/*
 * Created on Apr 5, 2005
 *
 * $Id: ChatRoom.java,v 1.2 2005/06/30 08:09:41 krichter Exp $
 */
package databay.chatserver;

import org.apache.log4j.Logger;

/**
 * @author krichter
 *
 */
public class ChatRoom
{
    
    private Logger logger = Logger.getLogger(this.getClass());
    private RingBuffer buffer=null;
    private String stylesheetURL=null;
    private String name;
    private String charset;
    private long expirationTime=3600;
    
    public ChatRoom(String name,int bufferLength)
    {
        this.name=name;
        this.buffer = new RingBuffer(bufferLength);
    }
    
    public RingBuffer getBuffer()
    {
        return buffer;
    }
    public void setBuffer(RingBuffer buffer)
    {
        this.buffer = buffer;
    }
    public String getName()
    {
        return name;
    }
    public void setName(String name)
    {
        this.name = name;
    }
    public String getStylesheetURL()
    {
        return stylesheetURL;
    }
    public void setStylesheetURL(String stylesheetURL)
    {
        logger.debug("ChatRoom: "+getName()+" sets stylesheet "+stylesheetURL);
        this.stylesheetURL = stylesheetURL;
    }

    /**
     * @param entry
     */
    public void addLine(LineEntry entry)
    {
        getBuffer().addLine(entry);
    }

    /**
     * @return
     */
    public String getCharacterEncoding()
    {
        return charset;
    }
    
    public void setCharacterEncoding(String encoding)
    {
        logger.debug("ChatRoom: "+getName()+" sets encoding "+encoding);
        this.charset=encoding;
    }

    /**
     * 
     */
    public long getExpirationTime()
    {
        return expirationTime;
    }
    
    public void setExpirationTime(long expirationTime)
    {
        this.expirationTime = expirationTime;
    }
}
