/*
 * $Id: HttpHeader.java,v 1.6 2005/06/30 08:12:34 krichter Exp $
 */
package databay.chatserver;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;
import org.apache.log4j.Logger;

public class HttpHeader
{
		private String header;
		private Logger logger = Logger.getLogger(this.getClass().getName());

		private static String status;
		private static String server = "Server: Databay Chatserver/"+ChatServer.version+"\r\n";
		private static String connection = "Connection: close\r\n";
		private static String cache = "Cache-control: private\r\n";
		private static String content = "Content-Type: text/html\r\n";
		private static String footer = "\r\n";


		public HttpHeader()
		{
			setStatus(0);
			buildHeader();
		}

		public void setStatus(int st)
		{
			switch(st)
			{
				case 403:
					status = "HTTP/1.1 Status: 403 Forbidden\r\n";
					break;

				default:
					status = "HTTP/1.1 200 OK\r\n";
					break;
			}
			return;
		}
					
		public String getHeader()
		{
			return header;
		}
		private void setHeader(String s)
		{
			header = s;
		}

		private void buildHeader()
		{
			setHeader(status + getGMTString() + "\r\n" + server + connection + cache + content + footer);
		}
		private String getGMTString()
		{
			SimpleDateFormat formatter = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss z",Locale.US);

			formatter.setTimeZone(TimeZone.getTimeZone("GMT"));

			logger.debug("Date: " + new Date());

			return "Date: " + formatter.format(new Date());
		}
}
