/*
 * $Id: RingBuffer.java,v 1.4 2005/06/30 08:13:15 krichter Exp $
 * 
 */
package databay.chatserver;

/*
 * Buffer fuer die Aufnahme der Nachrichten.
 * die Groesse des Buffers wird im Konstruktor festgelegt, nachrichten werden dann zyklisch hinzugefuegt 
 */


public class RingBuffer extends Object
{
    private LineEntry[] myEntries;
    private int capacity_;
    private int ring_position;
    private int wraps=0;

    /**
     * @param int Kapazitaet des Buffers
     */
    public RingBuffer(int capacity)
    {
    	myEntries= new LineEntry[capacity];
    	capacity_ = capacity;
    	ring_position=0;
    }

    /**
     * fuegt einen LineEntry hinzu
     * @param LineEntry newEntry
     */
    public void addLine(LineEntry newEntry)
    {
    	myEntries[ring_position]=newEntry;
    	ring_position = (ring_position+1) % capacity_;
    	if (ring_position == 0) wraps=1;
    }
    
    /**
     * gibt die Zeile mit der Nummer index zurueck
     * @param index Zeilennummer
     */
    public LineEntry getLine(int index)
    {
        if (index < capacity_)
            return myEntries[index];
        else 
            return null;
    }
    /**
     * gibt den Index der neuesten Nachricht zurueck
     *
     */
    public int getMaxIndex()
    {
	return ring_position-1;
    }

    /**
     * gibt den Index der aeltesten Nachricht zurueck
     */
    public int getMinIndex()
    {
	if (wraps==0) return 0;
	else return ring_position;
    }
    /*
     * gibt die Kapazitaet dieses Buffers aus
     */
    public int getCapacity()
    {
	return capacity_;
    }
    
    public void clear()
    {
        myEntries= new LineEntry[capacity_];
        ring_position=0;
    }
}
