/*
 * $Id: ServerCon.java,v 1.16 2006/10/13 08:53:01 smeyer Exp $
 */
package databay.chatserver;

import java.net.Socket;
import java.net.InetAddress;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.io.OutputStreamWriter;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Enumeration;
import java.util.Vector;
import org.apache.log4j.Logger;

/**
 * Klasse fuer die Kommunikation mit dem Chatserver (posten von Zeilen und Administration)
 */
class ServerCon implements Runnable 
{
		private Logger logger = Logger.getLogger(ServerCon.class);
		private Socket socket;
		private BufferedReader in;
		private PrintWriter out;
        private String nickname = "";
		private ChatAuth ca;
		private HttpHeader httpHeader = new HttpHeader();

		public ChatSpeicher cs = null;
		ConnectionData cd = new ConnectionData();

		public ServerCon (Socket s,ChatSpeicher cspeicher,ChatAuth cauth) 
		{
			cs = cspeicher;
			ca = cauth;
			socket = s;

			//logger.setLevel(ChatServer.logLevel);
		}

		

		/**
		 * run methode fuer die ServerCon  (MultiThreading)
		 */
		public void run() {
			String thisLine;
			Vector outLines = null;
			String gruppe = "";
   
			try 
			{
				out = new PrintWriter 
					(new BufferedWriter 
					 (new OutputStreamWriter 
					  (socket.getOutputStream() ) ) );
				in = new BufferedReader 
					(new InputStreamReader 
					 (socket.getInputStream() ) );
	    
				// SEND HTTP HEADER
				out.println(httpHeader.getHeader());
				logger.debug(httpHeader.getHeader());

				thisLine = in.readLine();
				logger.info(thisLine);
				//	    logger.debug("Socket Timeout: "+socket.getSoTimeout());
	    
	    
				if (thisLine.length() >12 &&
					thisLine.startsWith("GET /moderate")
					)
				{
					String tok=null;
					StringTokenizer stk = new StringTokenizer(thisLine, "? & ");
		
					// ignorieren der naechsten Token		
					if (stk.hasMoreTokens())
					{
						tok = stk.nextToken();
						logger.debug("First Token: " + tok);
					}
					if (stk.hasMoreTokens())
					{
						tok = stk.nextToken();
						logger.debug("Second Token: " + tok);
					}
					// passwd Token
					if (stk.hasMoreTokens())
					{
						tok=stk.nextToken();
						logger.debug("Password: " + tok);
					}

					/*
					 * stimmt das Moderator Passwort? 
					 */
					if (tok.compareTo(cs.getModeratorPasswd()) == 0)
					{
		    
						String command="";
						if  (stk.hasMoreTokens())
						{
							command = stk.nextToken();
							logger.debug("Command: " + command);
						}
                        
						if(command.equalsIgnoreCase("delete"))
						{
							tok = stk.nextToken();
							String chat_room = tok;
							cs.deleteChatRoom(tok);
							logger.info("Deleted chat room: " + tok);
						}
                        else if(command.equalsIgnoreCase("clear"))
                        {
                            tok = stk.nextToken();
                            String chat_room = tok;
                            cs.clearChatRoom(tok);
                            logger.info("Cleared chat room: " + tok);
                        }
						else if (command.equalsIgnoreCase("kick") )
						{
							if ( stk.countTokens() >=2 )
							{
								tok = stk.nextToken();
								String userHash = tok;
								tok = stk.nextToken();
								String group = tok;
                                
                                String message="";
                                while (stk.hasMoreTokens())
                                {
                                    tok=stk.nextToken();
                                    if (tok.startsWith("HTTP"))
                                        continue;
                                    message+=" "+tok;
                                }
                               
								logger.debug("Kicking user "+ userHash +" in group "+group);
                                ca.checkWriteAccess(socket);

                                if (message.length()>0)
                                {
                                    logger.debug(" with message "+message);
                                    cs.writeSpeicher("/KICK "+userHash+" "+message,userHash,"",group);
                                }
                                else
                                {
                                    cs.writeSpeicher("/KICK "+userHash,userHash,"",group);
                                }
                                
								out.flush();
							}
							else 
							{
								logger.error("Invalid parameter count.\n");
								out.println("Invalid parameter count.\n");
                                out.flush();
							}
			
						}		
						else 
						{
							logger.error("Invalid command: "+command);
							out.println("Invalid command: "+command);
							out.flush();
						}
					}
					else 
					{
						logger.error("Invalid Moderator Password");
						printModeratorError("Invalid moderator password");
						out.flush();
					}
				}
				else if (thisLine.length() >9 && 
						 thisLine.substring(0,10).equals("GET /admin")
					)
				{
					String tok=null;
					StringTokenizer stk = new StringTokenizer(thisLine, "? & ");

					// ignorieren der naechsten Token		
					if (stk.hasMoreTokens()) tok = stk.nextToken();
					if (stk.hasMoreTokens()) tok = stk.nextToken();

					// passwd Token
					if (stk.hasMoreTokens()) tok=stk.nextToken();

					/*
					 * stimmt das Admin Passwort? 
					 */
		
					if (tok.compareTo(cs.getAdminPasswd()) == 0)
					{
		    
						String command="";
						if  (stk.hasMoreTokens())
						{
							command = stk.nextToken();
						}
		    
						if (command.compareTo("") != 0)
						{
							if (command.equalsIgnoreCase("info") )
							{
								out.println("User: "+ChatSpeicher.getCount()+"<BR>");
								int chatRoomCount=0;
								out.println("ChatRooms:<BR>");
								for (Enumeration e=cs.getAllRoomNames();e.hasMoreElements();)
								{
									String name = (String) e.nextElement();
									out.println ("&nbsp;&nbsp;"+name+"<BR>");
									chatRoomCount++;
								}
								out.println("Gesamt: "+chatRoomCount+" ChatRooms<BR>");
							}
							else if (command.equalsIgnoreCase("reload") )
							{
								printAdminInfo("Reloading header and footer files...");
                                cs.readHTMLFiles();
							}
                            else if (command.equalsIgnoreCase("create"))
                            {
                                String room="";
                                String style="";
                                String charset="";
                                
                                if ( stk.hasMoreTokens())
                                {
                                    room = stk.nextToken();
                                }
                                
                                if (stk.hasMoreTokens())
                                {
                                    style = stk.nextToken();
                                }
                                
                                if (stk.hasMoreTokens())
                                {
                                    charset = stk.nextToken();
                                }
                                ChatRoom cr=null;
                                if ( ! cs.existsChatRoom(room))
                                {
                                    logger.debug("Creating room "+room+ " with style "+style+" and charset "+charset);
                                    cr = cs.addChatRoom(room);
                                    if (! style.equals(""))
                                    {
                                        cr.setStylesheetURL(style);
                                    }
                                    
                                    if (! charset.equals(""))
                                    {
                                        cr.setCharacterEncoding(charset);
                                    }
                                }
                                else 
                                {
                                    printAdminError("Chatroom already exists: "+room);
                                    
                                }
                                
                                
                            }
		
							else 
							{
								printAdminError("Invalid command "+command);
							}
							out.flush();
						}
						else 
						{
						}
					} 
					else 
					{
						printAdminError("Invalid admin password");
						out.flush();
					}
		
				} 
				else if (thisLine.length() >=12 && thisLine.substring(0,12).equalsIgnoreCase("GET /version"))
				{
					out.println("Databay AG Chatserver Version "+ChatServer.version);
					out.flush();
				}
				// Nachricht an alle in einem Chatroom mit "><from>Message
				else if (thisLine.length() != 0 && thisLine.substring(0,1).equals(">") ) 
				{
					String M = thisLine.substring(1);
					String G = M.substring(0,20);
					M = M.substring(20);

					ca.checkWriteAccess(socket);
					cs.writeSpeicher(M,"","",G);
		
				} 
				// Private nachricht in einen Chatroom schreiben mit "|<from><to><group>Message"
				else if (thisLine.length() != 0  && thisLine.substring(0,1).equals("|") ) 
				{
					String M = thisLine.substring(1);
					String toHash = M.substring(0,32);
					M = M.substring(32);
					String fromHash = M.substring(0,32);
					M = M.substring(32);
					String G = M.substring(0,20);
					M = M.substring(20);

					ca.checkWriteAccess(socket);
					cs.writeSpeicher(M,toHash,fromHash,G);
				}
				else if(thisLine.length() != 0  && thisLine.substring(0,1).equals("!"))
				{
					String uname = thisLine.substring(1,33);
					String ip = thisLine.substring(33);

					logger.debug("Remote Ip: "+thisLine);
					ca.checkWriteAccess(socket);
					ca.addUser(uname,InetAddress.getByName(ip));
				}
				else if(thisLine.length() != 0  && thisLine.substring(0,1).equals("-"))
				{
					String uname = thisLine.substring(1,33);

					logger.debug("Logout user: "+uname);
					ca.checkWriteAccess(socket);
					ca.deleteUser(uname);
				}
				// nur anzeigen des Chatrooms, kein Befehl uebergeben
				else 
				{
					ChatSpeicher.incrementCount();
					if (thisLine.length() != 0  && thisLine.substring(0,5).equals("GET /")) 
                    {
						nickname = thisLine.substring(5);
                        String style="";
                        String charset="";
                        if (nickname.length()>32) 
						{
                            StringTokenizer stk = new StringTokenizer(nickname,"&");
                            
                            if (stk.hasMoreTokens())
                            {
                                nickname=stk.nextToken();
                            }
                            else
                            {
                                nickname="";
                            }

                            if (stk.hasMoreTokens())
                            {
                                style = stk.nextToken();
                            }
                            else
                            {
                                style="";
                            }
                            
                            if ( stk.hasMoreTokens())
                            {
                                charset = stk.nextToken();
                            }
                            else
                            {
                                charset="";
                            }
                            
							// check access
                            nickname = nickname.substring(0,32);
							ca.checkReadAccess(nickname,socket);
							//logger.debug("Nickname "+Nickname);
							gruppe = thisLine.substring(37,57);

							if (!cs.existsChatRoom(gruppe) && gruppe.length()>0)
                            {
                                ChatRoom cr = cs.addChatRoom(gruppe);
                                if (!style.equals(""))
                                {
                                    cr.setStylesheetURL(style);    
                                }
                                if ( !charset.equals(""))
                                {
                                    cr.setCharacterEncoding(charset);
                                }
                            }
							//				logger.debug(Gruppe);
			
						}
                        else // nick len != 32 => invalid
                        {
                            ChatSpeicher.decrementCount();
                        }
					}
                    
                    
					/*
					 * OUTPUT HEADER...
					 */
					ChatRoom cr = cs.getChatRoom(gruppe);
                    if ( cr!=null)
                    {
    					cs.printHeaders(out,cr);
    					out.flush();
    		
    					for (int i=0;i<(2400-100);i++) 
    					//for(int i = 0;i < 100;++i)
    					{
    						outLines = cs.readSpeicher(cd,nickname,gruppe);
    
    						if (outLines.size()!=0 ) 
    						{
    							for (Enumeration e= outLines.elements();e.hasMoreElements();)
    							{
    								String outLine = (String) e.nextElement();

                                    logger.debug("NICKNAME: "+nickname);
                                    if ( outLine.startsWith("/"))
                                    {
                                        if (outLine.startsWith("/KICK "+nickname))
                                        {
                                                /*
                                                 * OUTPUT FOOTER
                                                 */
                                        logger.debug("KICK line for nickname "+nickname);
                                        if (outLine.length()> 7+nickname.length())
                                        {
                                            logger.debug("KICK line special message");
                                            out.println(outLine.substring(6+nickname.length()));
                                        }
                                        else
                                        {
                                            logger.debug("KICK defaultmessage");
                                            out.println("You have been kicked.<BR>");
                                        }
    									//			    cs.printFooters(out);
    									out.flush();
    									in.close();
    									out.close();
    									socket.close();
    									ChatSpeicher.decrementCount();
    									return;
                                        }
    								}
                                    else
                                    {
                                        logger.debug ("Normal line: "+outLine);
                                        out.println(outLine);
                                    }
    							}
    							out.flush();
    						}

    						try 
    						{
    							Thread.sleep(100);
    							// if ((i%10) ==0)
    							// logger.debug(socket);
    						}
    						catch (InterruptedException e) 
    						{
    							ChatSpeicher.decrementCount();
    							logger.error("Interrupted ServerThread " + e);
    						}
                        }
                        ChatSpeicher.decrementCount();
					}


					/*
					 * OUTPUT FOOTER
					 */
					cs.printFooters(out);
					out.flush();
		
		
				}
				logger.debug("end");
				in.close();
				out.close();
				socket.close();
	    
			}
			catch (NoWriteAccessException e1)
			{
				logger.warn("No write access: "+e1.getMessage());
                ChatSpeicher.decrementCount();
			}
			catch (NoReadAccessException e2)
			{
				logger.warn("No read access: "+e2.getMessage());
                ChatSpeicher.decrementCount();
			}
			catch (Exception e) 
			{
				logger.error("ServerCon exception: " + (String) e.getMessage());
				ChatSpeicher.decrementCount();
			}
		}



        /**
         * @param string
         */
        private void printAdminInfo(String message)
        {
            logger.info("ADMIN INFO: "+message);
            out.println("<SPAN CLASS=\"admininfo\">"+message+"</SPAN><BR>");
        }



        /**
         * @param string
         */
        private void printModeratorError(String message)
        {
            logger.info("MODERATOR ERROR: "+message);
            out.println("<SPAN CLASS=\"moderatorerror\">"+message+"</SPAN><BR>");
        }



        /**
         * @param message
         * @param string
         */
        private void printAdminError(String message)
        {
            logger.info("ADMIN ERROR: "+message);
            out.println("<SPAN CLASS=\"adminerror\">"+message+"</SPAN><BR>");
        }
}
