-- MySQL dump 9.11
--
-- Host: localhost    Database: ilias37x
-- ------------------------------------------------------
-- Server version	4.0.27

--
-- Table structure for table `addressbook`
--

CREATE TABLE `addressbook` (
  `addr_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `login` varchar(40) default NULL,
  `firstname` varchar(40) default NULL,
  `lastname` varchar(40) default NULL,
  `email` varchar(40) default NULL,
  PRIMARY KEY  (`addr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `addressbook`
--


--
-- Table structure for table `aicc_course`
--

CREATE TABLE `aicc_course` (
  `obj_id` int(11) NOT NULL default '0',
  `course_creator` varchar(255) default NULL,
  `course_id` varchar(50) default NULL,
  `course_system` varchar(50) default NULL,
  `course_title` varchar(255) default NULL,
  `level` varchar(5) default NULL,
  `max_fields_cst` smallint(6) default NULL,
  `max_fields_ort` smallint(6) default NULL,
  `total_aus` smallint(6) default NULL,
  `total_blocks` smallint(6) default NULL,
  `total_complex_obj` smallint(6) default NULL,
  `total_objectives` smallint(6) default NULL,
  `version` varchar(10) default NULL,
  `max_normal` tinyint(4) default NULL,
  `description` text,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_course`
--


--
-- Table structure for table `aicc_object`
--

CREATE TABLE `aicc_object` (
  `obj_id` int(11) NOT NULL auto_increment,
  `slm_id` int(11) NOT NULL default '0',
  `system_id` varchar(50) NOT NULL default '',
  `title` text NOT NULL,
  `description` text,
  `developer_id` varchar(50) default NULL,
  `type` char(3) NOT NULL default '',
  PRIMARY KEY  (`obj_id`),
  KEY `alm_id` (`slm_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_object`
--


--
-- Table structure for table `aicc_units`
--

CREATE TABLE `aicc_units` (
  `obj_id` int(11) NOT NULL auto_increment,
  `type` varchar(50) default NULL,
  `command_line` varchar(255) default NULL,
  `max_time_allowed` time default NULL,
  `time_limit_action` varchar(50) default NULL,
  `max_score` decimal(10,0) default NULL,
  `core_vendor` text,
  `system_vendor` text,
  `file_name` varchar(255) default NULL,
  `mastery_score` smallint(6) default NULL,
  `web_launch` varchar(255) default NULL,
  `au_password` varchar(50) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_units`
--


--
-- Table structure for table `ass_log`
--

CREATE TABLE `ass_log` (
  `ass_log_id` int(11) NOT NULL auto_increment,
  `user_fi` int(11) NOT NULL default '0',
  `obj_fi` int(11) NOT NULL default '0',
  `logtext` text NOT NULL,
  `question_fi` int(11) default NULL,
  `original_fi` int(11) default NULL,
  `ref_id` int(11) default NULL,
  `test_only` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`ass_log_id`),
  KEY `user_fi` (`user_fi`,`obj_fi`)
) TYPE=MyISAM COMMENT='Logging of Test&Assessment object changes';

--
-- Dumping data for table `ass_log`
--


--
-- Table structure for table `benchmark`
--

CREATE TABLE `benchmark` (
  `cdate` datetime default NULL,
  `module` varchar(150) default NULL,
  `benchmark` varchar(150) default NULL,
  `duration` double(14,5) default NULL,
  KEY `module` (`module`,`benchmark`)
) TYPE=MyISAM;

--
-- Dumping data for table `benchmark`
--


--
-- Table structure for table `bookmark_data`
--

CREATE TABLE `bookmark_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `target` varchar(200) NOT NULL default '',
  `type` varchar(4) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `bookmark_data`
--

INSERT INTO `bookmark_data` VALUES (1,0,'dummy_folder','','','bmf');

--
-- Table structure for table `bookmark_tree`
--

CREATE TABLE `bookmark_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `bookmark_tree`
--

INSERT INTO `bookmark_tree` VALUES (6,1,0,1,2,1);

--
-- Table structure for table `chat_blocked`
--

CREATE TABLE `chat_blocked` (
  `chat_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `chat_blocked`
--


--
-- Table structure for table `chat_invitations`
--

CREATE TABLE `chat_invitations` (
  `room_id` int(11) NOT NULL default '0',
  `guest_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`room_id`,`guest_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_invitations`
--


--
-- Table structure for table `chat_record_data`
--

CREATE TABLE `chat_record_data` (
  `record_data_id` int(11) NOT NULL auto_increment,
  `record_id` int(11) NOT NULL default '0',
  `message` mediumtext NOT NULL,
  `msg_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`record_data_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_record_data`
--


--
-- Table structure for table `chat_records`
--

CREATE TABLE `chat_records` (
  `record_id` int(11) NOT NULL auto_increment,
  `moderator_id` int(11) NOT NULL default '0',
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `start_time` int(11) NOT NULL default '0',
  `end_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`record_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_records`
--


--
-- Table structure for table `chat_room_messages`
--

CREATE TABLE `chat_room_messages` (
  `entry_id` int(11) NOT NULL auto_increment,
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `message` text,
  `commit_timestamp` timestamp(14) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_room_messages`
--


--
-- Table structure for table `chat_rooms`
--

CREATE TABLE `chat_rooms` (
  `room_id` int(11) NOT NULL auto_increment,
  `chat_id` int(11) NOT NULL default '0',
  `title` varchar(64) default NULL,
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`room_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_rooms`
--


--
-- Table structure for table `chat_user`
--

CREATE TABLE `chat_user` (
  `usr_id` int(11) NOT NULL default '0',
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `last_conn_timestamp` int(14) default NULL,
  `kicked` tinyint(4) default '0',
  PRIMARY KEY  (`usr_id`,`chat_id`,`room_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_user`
--


--
-- Table structure for table `conditions`
--

CREATE TABLE `conditions` (
  `id` int(11) NOT NULL auto_increment,
  `target_ref_id` int(11) NOT NULL default '0',
  `target_obj_id` int(11) NOT NULL default '0',
  `target_type` varchar(8) NOT NULL default '',
  `trigger_ref_id` int(11) NOT NULL default '0',
  `trigger_obj_id` int(11) NOT NULL default '0',
  `trigger_type` varchar(8) NOT NULL default '',
  `operator` varchar(64) default NULL,
  `value` varchar(64) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `conditions`
--


--
-- Table structure for table `container_settings`
--

CREATE TABLE `container_settings` (
  `id` int(11) NOT NULL default '0',
  `keyword` char(40) NOT NULL default '',
  `value` char(50) default NULL,
  PRIMARY KEY  (`id`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `container_settings`
--


--
-- Table structure for table `content_object`
--

CREATE TABLE `content_object` (
  `id` int(11) NOT NULL default '0',
  `default_layout` varchar(100) NOT NULL default 'toc2win',
  `stylesheet` int(11) NOT NULL default '0',
  `page_header` enum('st_title','pg_title','none') default 'st_title',
  `online` enum('y','n') default 'n',
  `toc_active` enum('y','n') default 'y',
  `lm_menu_active` enum('y','n') default 'y',
  `toc_mode` enum('chapters','pages') default 'chapters',
  `clean_frames` enum('y','n') NOT NULL default 'n',
  `print_view_active` enum('y','n') default 'y',
  `numbering` enum('y','n') default 'n',
  `hist_user_comments` enum('y','n') default 'n',
  `public_access_mode` enum('complete','selected') NOT NULL default 'complete',
  `public_html_file` varchar(50) NOT NULL default '',
  `public_xml_file` varchar(50) NOT NULL default '',
  `downloads_active` enum('y','n') default 'n',
  `downloads_public_active` enum('y','n') NOT NULL default 'y',
  `pub_notes` enum('y','n') NOT NULL default 'n',
  `header_page` int(11) NOT NULL default '0',
  `footer_page` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `content_object`
--


--
-- Table structure for table `crs_archives`
--

CREATE TABLE `crs_archives` (
  `archive_id` int(11) NOT NULL auto_increment,
  `course_id` int(11) NOT NULL default '0',
  `archive_name` varchar(255) NOT NULL default '',
  `archive_type` tinyint(2) NOT NULL default '0',
  `archive_date` int(11) default NULL,
  `archive_size` int(11) default NULL,
  `archive_lang` varchar(16) default NULL,
  PRIMARY KEY  (`archive_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_archives`
--


--
-- Table structure for table `crs_file`
--

CREATE TABLE `crs_file` (
  `file_id` int(11) NOT NULL auto_increment,
  `course_id` int(11) NOT NULL default '0',
  `file_name` char(64) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `file_size` int(11) NOT NULL default '0',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_file`
--


--
-- Table structure for table `crs_groupings`
--

CREATE TABLE `crs_groupings` (
  `crs_grp_id` int(11) NOT NULL default '0',
  `crs_ref_id` int(11) NOT NULL default '0',
  `crs_id` int(11) NOT NULL default '0',
  `unique_field` char(32) NOT NULL default '',
  PRIMARY KEY  (`crs_grp_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_groupings`
--


--
-- Table structure for table `crs_items`
--

CREATE TABLE `crs_items` (
  `parent_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `timing_type` tinyint(2) default NULL,
  `timing_start` int(8) default NULL,
  `timing_end` int(8) default NULL,
  `suggestion_start` int(11) NOT NULL default '0',
  `suggestion_end` int(11) NOT NULL default '0',
  `changeable` tinyint(1) NOT NULL default '0',
  `earliest_start` int(11) NOT NULL default '0',
  `latest_end` int(11) NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '0',
  `position` int(11) default NULL,
  PRIMARY KEY  (`parent_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_items`
--


--
-- Table structure for table `crs_lm_history`
--

CREATE TABLE `crs_lm_history` (
  `usr_id` int(11) NOT NULL default '0',
  `crs_ref_id` int(11) NOT NULL default '0',
  `lm_ref_id` int(11) NOT NULL default '0',
  `lm_page_id` int(11) NOT NULL default '0',
  `last_access` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`crs_ref_id`,`lm_ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_lm_history`
--


--
-- Table structure for table `crs_members`
--

CREATE TABLE `crs_members` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `status` tinyint(2) NOT NULL default '0',
  `role` tinyint(2) NOT NULL default '0',
  `passed` tinyint(1) default NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_members`
--


--
-- Table structure for table `crs_objective_lm`
--

CREATE TABLE `crs_objective_lm` (
  `lm_ass_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `type` char(6) NOT NULL default '',
  PRIMARY KEY  (`lm_ass_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_lm`
--


--
-- Table structure for table `crs_objective_qst`
--

CREATE TABLE `crs_objective_qst` (
  `qst_ass_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `question_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`qst_ass_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_qst`
--


--
-- Table structure for table `crs_objective_results`
--

CREATE TABLE `crs_objective_results` (
  `res_id` int(11) NOT NULL auto_increment,
  `usr_id` int(11) NOT NULL default '0',
  `question_id` int(11) NOT NULL default '0',
  `points` int(11) NOT NULL default '0',
  PRIMARY KEY  (`res_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_results`
--


--
-- Table structure for table `crs_objective_status`
--

CREATE TABLE `crs_objective_status` (
  `objective_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_status`
--


--
-- Table structure for table `crs_objective_status_pretest`
--

CREATE TABLE `crs_objective_status_pretest` (
  `objective_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_status_pretest`
--


--
-- Table structure for table `crs_objective_tst`
--

CREATE TABLE `crs_objective_tst` (
  `test_objective_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `tst_status` tinyint(2) default NULL,
  `tst_limit` tinyint(3) default NULL,
  PRIMARY KEY  (`test_objective_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_tst`
--


--
-- Table structure for table `crs_objectives`
--

CREATE TABLE `crs_objectives` (
  `crs_id` int(11) NOT NULL default '0',
  `objective_id` int(11) NOT NULL auto_increment,
  `title` varchar(70) NOT NULL default '',
  `description` varchar(128) NOT NULL default '',
  `position` int(3) NOT NULL default '0',
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objectives`
--


--
-- Table structure for table `crs_settings`
--

CREATE TABLE `crs_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `syllabus` text,
  `contact_name` varchar(255) default NULL,
  `contact_responsibility` varchar(255) default NULL,
  `contact_phone` varchar(255) default NULL,
  `contact_email` varchar(255) default NULL,
  `contact_consultation` text,
  `activation_type` tinyint(1) NOT NULL default '0',
  `activation_start` int(11) default NULL,
  `activation_end` int(11) default NULL,
  `subscription_limitation_type` tinyint(1) NOT NULL default '0',
  `subscription_start` int(11) default NULL,
  `subscription_end` int(11) default NULL,
  `subscription_type` int(2) default NULL,
  `subscription_password` varchar(32) default NULL,
  `subscription_max_members` int(4) default NULL,
  `subscription_notify` int(2) default NULL,
  `view_mode` tinyint(1) NOT NULL default '0',
  `sortorder` int(2) default NULL,
  `archive_start` int(11) default NULL,
  `archive_end` int(11) default NULL,
  `archive_type` int(2) default NULL,
  `abo` tinyint(2) default '1',
  `waiting_list` tinyint(1) NOT NULL default '1',
  `important` text NOT NULL,
  `show_members` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_settings`
--


--
-- Table structure for table `crs_start`
--

CREATE TABLE `crs_start` (
  `crs_start_id` int(11) NOT NULL auto_increment,
  `crs_id` int(11) NOT NULL default '0',
  `item_ref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`crs_start_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_start`
--


--
-- Table structure for table `crs_subscribers`
--

CREATE TABLE `crs_subscribers` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `sub_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_subscribers`
--


--
-- Table structure for table `crs_timings_planed`
--

CREATE TABLE `crs_timings_planed` (
  `item_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `planed_start` int(11) NOT NULL default '0',
  `planed_end` int(11) NOT NULL default '0',
  PRIMARY KEY  (`item_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_timings_planed`
--


--
-- Table structure for table `crs_timings_usr_accept`
--

CREATE TABLE `crs_timings_usr_accept` (
  `crs_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `accept` tinyint(1) NOT NULL default '0',
  `remark` text NOT NULL,
  `visible` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`crs_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_timings_usr_accept`
--


--
-- Table structure for table `crs_waiting_list`
--

CREATE TABLE `crs_waiting_list` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `sub_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_waiting_list`
--


--
-- Table structure for table `ctrl_calls`
--

CREATE TABLE `ctrl_calls` (
  `parent` varchar(100) NOT NULL default '',
  `child` varchar(100) default NULL,
  KEY `jmp_parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_calls`
--

INSERT INTO `ctrl_calls` VALUES ('ilfeedbackgui','');
INSERT INTO `ctrl_calls` VALUES ('ilstartupgui','ilregistrationgui');
INSERT INTO `ctrl_calls` VALUES ('ilstartupgui','ilpasswordassistancegui');
INSERT INTO `ctrl_calls` VALUES ('ilregistrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilregistrationsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsearchsettingsgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','ilsearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','iladvancedsearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','ilsearchresultgui');
INSERT INTO `ctrl_calls` VALUES ('iluserfiltergui','');
INSERT INTO `ctrl_calls` VALUES ('illpfiltergui','');
INSERT INTO `ctrl_calls` VALUES ('illpgui','');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','illpfiltergui');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','iluserfiltergui');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','ilpdfpresentation');
INSERT INTO `ctrl_calls` VALUES ('illplistofprogressgui','illpfiltergui');
INSERT INTO `ctrl_calls` VALUES ('illplistofprogressgui','ilpdfpresentation');
INSERT INTO `ctrl_calls` VALUES ('illplistofsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofobjectsgui');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofsettingsgui');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofprogressgui');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illmstatisticsgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjusertrackinggui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjusertrackinggui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilpdfpresentation','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assmultiplechoicegui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assclozetestgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assmatchingquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assorderingquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assimagemapquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assjavaappletgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assnumericgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asstextsubsetgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asssinglechoicegui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asstextquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilobjcoursegui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestoutputgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestevaluationgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatservergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjgroupgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfilegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcoursegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilcourseobjectivesgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsahslearningmodulegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjchatgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjforumgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlearningmodulegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjdlbookgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjglossarygui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjquestionpoolgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsurveyquestionpoolgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjtestgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsurveygui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjexercisegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmediapoolgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfilebasedlmgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcategorygui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrolegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjuserfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjilinccoursegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjilincclassroomgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlinkresourcegui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjroletemplategui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjstylesheetgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrootfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsystemfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrolefoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjauthsettingsgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjchatservergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlanguagefoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmailgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjobjectfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjpaymentsettingsgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrecoveryfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsearchsettingsgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjstylesettingsgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjtaxonomyfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjassessmentfoldergui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjexternaltoolssettingsgui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjusertrackinggui');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjadvancededitinggui');
INSERT INTO `ctrl_calls` VALUES ('ilcontainerlinklistgui','');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilnotegui');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilfeedbackgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjadvancededitinggui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjassessmentfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','ilregistrationsettingsgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilcontainerlinklistgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilobjuserfoldergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilrepositorysearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjexternaltoolssettingsgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilcoursecontentgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilregistergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilrepositorysearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilobjcoursegroupinggui');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilcoursecontentgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlanguagefoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmailgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjobjectfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjrecoveryfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjrolefoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjrolegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjroletemplategui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilcontainerlinklistgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjstylesettingsgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjstylesheetgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsysusertrackinggui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsystemfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjuserfoldergui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjusergui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjusergui','ilobjilincusergui');
INSERT INTO `ctrl_calls` VALUES ('ilpdnotesgui','ilnotegui');
INSERT INTO `ctrl_calls` VALUES ('ilpdnotesgui','ilfeedbackgui');
INSERT INTO `ctrl_calls` VALUES ('ilpermissiongui','ilobjrolegui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpersonalprofilegui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilbookmarkadministrationgui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpdnotesgui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilfeedbackgui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpaymentgui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpaymentadmingui');
INSERT INTO `ctrl_calls` VALUES ('ilpersonalprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjgroupgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfoldergui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfilegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcoursegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilcourseobjectivesgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsahslearningmodulegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjchatgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjforumgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjlearningmodulegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjdlbookgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjglossarygui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjquestionpoolgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsurveyquestionpoolgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjtestgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsurveygui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjexercisegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjmediapoolgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfilebasedlmgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcategorygui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjrolegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjilinccoursegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjilincclassroomgui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjlinkresourcegui');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjrootfoldergui');
INSERT INTO `ctrl_calls` VALUES ('ileditclipboardgui','ilobjmediaobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilglossaryeditorgui','ilobjglossarygui');
INSERT INTO `ctrl_calls` VALUES ('ilglossarypresentationgui','ilnotegui');
INSERT INTO `ctrl_calls` VALUES ('ilglossarypresentationgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilglossarytermgui','iltermdefinitioneditorgui');
INSERT INTO `ctrl_calls` VALUES ('illmeditorgui','ilobjdlbookgui');
INSERT INTO `ctrl_calls` VALUES ('illmeditorgui','ilmetadatagui');
INSERT INTO `ctrl_calls` VALUES ('illmeditorgui','ilobjlearningmodulegui');
INSERT INTO `ctrl_calls` VALUES ('illmpageobjectgui','ilpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('illmpageobjectgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilnotegui');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilpaymentpurchasegui');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilfilesystemgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','illmpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilstructureobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilobjstylesheetgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilfilesystemgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilglossarytermgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilfilesystemgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','illmpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilstructureobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilobjstylesheetgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilobjmediaobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilobjfoldergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ileditclipboardgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilfilesystemgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilfilesystemgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilscormpresentationgui');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilaiccpresentationgui');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilhacppresentationgui');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilstructureobjectgui','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilstructureobjectgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('iltermdefinitioneditorgui','ilpageobjectgui');
INSERT INTO `ctrl_calls` VALUES ('iltermdefinitioneditorgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediaobjectgui','ilinternallinkgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediaobjectgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcparagraphgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpctablegui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpctabledatagui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcmediaobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpclistgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpclistitemgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcfilelistgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcfileitemgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilobjmediaobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcsourcecodegui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilinternallinkgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ilpageeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ileditclipboardgui');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ilmediapooltargetselector');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcoursearchivesgui');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcourseobjectivepresentationgui');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcourseitemadministrationgui');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ileventadministrationgui');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentinterface','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentinterface','ilcourseitemadministrationgui');
INSERT INTO `ctrl_calls` VALUES ('ilcourseitemadministrationgui','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseregistergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilpaymentpurchasegui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseobjectivesgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilobjcoursegroupinggui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','illearningprogressgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilrepositorysearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcoursecontentinterface');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilconditionhandlerinterface');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcoursecontentgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjilincclassroomgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilobjilincclassroomgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilrepositorysearchgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilobjusergui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjpaymentsettingsgui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymenttrusteegui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentstatisticgui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentobjectgui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentbilladmingui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentgui','ilpaymentshoppingcartgui');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentgui','ilpaymentbuyedobjectsgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilsurveyevaluationgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilsurveyexecutiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilpermissiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilinfoscreengui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveynominalquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveymetricquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveyordinalquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveytextquestiongui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','ilmdeditorgui');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','ilpermissiongui');

--
-- Table structure for table `ctrl_classfile`
--

CREATE TABLE `ctrl_classfile` (
  `class` varchar(100) NOT NULL default '',
  `file` varchar(250) default NULL,
  PRIMARY KEY  (`class`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_classfile`
--

INSERT INTO `ctrl_classfile` VALUES ('ilfeedbackgui','Services/Feedback/classes/class.ilFeedbackGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilstartupgui','Services/Init/classes/class.ilStartUpGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilregistrationgui','Services/Registration/classes/class.ilRegistrationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilregistrationsettingsgui','Services/Registration/classes/class.ilRegistrationSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsearchsettingsgui','Services/Search/classes/class.ilObjSearchSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilsearchcontroller','Services/Search/classes/class.ilSearchController.php');
INSERT INTO `ctrl_classfile` VALUES ('iluserfiltergui','Services/Search/classes/class.ilUserFilterGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illpfiltergui','Services/Tracking/classes/class.ilLPFilterGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illpgui','Services/Tracking/classes/class.ilLPGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illplistofobjectsgui','Services/Tracking/classes/class.ilLPListOfObjectsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illplistofprogressgui','Services/Tracking/classes/class.ilLPListOfProgressGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illplistofsettingsgui','Services/Tracking/classes/class.ilLPListOfSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illearningprogressgui','Services/Tracking/classes/class.ilLearningProgressGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjusertrackinggui','Services/Tracking/classes/class.ilObjUserTrackingGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpdfpresentation','Services/Tracking/classes/class.ilPDFPresentation.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjquestionpoolgui','assessment/classes/class.ilObjQuestionPoolGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjtestgui','assessment/classes/class.ilObjTestGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjchatgui','chat/classes/class.ilObjChatGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjchatservergui','chat/classes/class.ilObjChatServerGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('iladministrationgui','classes/class.ilAdministrationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilcontainerlinklistgui','classes/class.ilContainerLinkListGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilinfoscreengui','classes/class.ilInfoScreenGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjadvancededitinggui','classes/class.ilObjAdvancedEditingGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjassessmentfoldergui','classes/class.ilObjAssessmentFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjauthsettingsgui','classes/class.ilObjAuthSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcategorygui','classes/class.ilObjCategoryGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjexercisegui','classes/class.ilObjExerciseGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjexternaltoolssettingsgui','classes/class.ilObjExternalToolsSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfilegui','classes/class.ilObjFileGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfoldergui','classes/class.ilObjFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjforumgui','classes/class.ilObjForumGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjgroupgui','classes/class.ilObjGroupGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlanguagefoldergui','classes/class.ilObjLanguageFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmailgui','classes/class.ilObjMailGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjobjectfoldergui','classes/class.ilObjObjectFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrecoveryfoldergui','classes/class.ilObjRecoveryFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrolefoldergui','classes/class.ilObjRoleFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrolegui','classes/class.ilObjRoleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjroletemplategui','classes/class.ilObjRoleTemplateGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrootfoldergui','classes/class.ilObjRootFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjstylesettingsgui','classes/class.ilObjStyleSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjstylesheetgui','classes/class.ilObjStyleSheetGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsysusertrackinggui','classes/class.ilObjSysUserTrackingGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsystemfoldergui','classes/class.ilObjSystemFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjuserfoldergui','classes/class.ilObjUserFolderGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjusergui','classes/class.ilObjUserGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpdnotesgui','classes/class.ilPDNotesGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpermissiongui','classes/class.ilPermissionGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpersonaldesktopgui','classes/class.ilPersonalDesktopGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpersonalprofilegui','classes/class.ilPersonalProfileGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilrepositorygui','classes/class.ilRepositoryGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ileditclipboardgui','content/classes/class.ilEditClipboardGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilglossaryeditorgui','content/classes/class.ilGlossaryEditorGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilglossarypresentationgui','content/classes/class.ilGlossaryPresentationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilglossarytermgui','content/classes/class.ilGlossaryTermGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illmeditorgui','content/classes/class.ilLMEditorGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illmpageobjectgui','content/classes/class.ilLMPageObjectGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('illmpresentationgui','content/classes/class.ilLMPresentationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjaicclearningmodulegui','content/classes/class.ilObjAICCLearningModuleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjdlbookgui','content/classes/class.ilObjDlBookGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfilebasedlmgui','content/classes/class.ilObjFileBasedLMGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjglossarygui','content/classes/class.ilObjGlossaryGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjhacplearningmodulegui','content/classes/class.ilObjHACPLearningModuleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlearningmodulegui','content/classes/class.ilObjLearningModuleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediapoolgui','content/classes/class.ilObjMediaPoolGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsahslearningmodulegui','content/classes/class.ilObjSAHSLearningModuleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjscormlearningmodulegui','content/classes/class.ilObjSCORMLearningModuleGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilsahspresentationgui','content/classes/class.ilSAHSPresentationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilstructureobjectgui','content/classes/class.ilStructureObjectGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('iltermdefinitioneditorgui','content/classes/class.ilTermDefinitionEditorGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediaobjectgui','content/classes/Media/class.ilObjMediaObjectGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpageeditorgui','content/classes/Pages/class.ilPageEditorGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpageobjectgui','content/classes/Pages/class.ilPageObjectGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilcoursecontentgui','course/classes/class.ilCourseContentGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilcoursecontentinterface','course/classes/class.ilCourseContentInterface.php');
INSERT INTO `ctrl_classfile` VALUES ('ilcourseitemadministrationgui','course/classes/class.ilCourseItemAdministrationGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcoursegui','course/classes/class.ilObjCourseGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjilincclassroomgui','ilinc/classes/class.ilObjiLincClassroomGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjilinccoursegui','ilinc/classes/class.ilObjiLincCourseGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlinkresourcegui','link/classes/class.ilObjLinkResourceGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjpaymentsettingsgui','payment/classes/class.ilObjPaymentSettingsGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpaymentadmingui','payment/classes/class.ilPaymentAdminGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilpaymentgui','payment/classes/class.ilPaymentGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsurveygui','survey/classes/class.ilObjSurveyGUI.php');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsurveyquestionpoolgui','survey/classes/class.ilObjSurveyQuestionPoolGUI.php');

--
-- Table structure for table `ctrl_structure`
--

CREATE TABLE `ctrl_structure` (
  `root_class` varchar(40) NOT NULL default '',
  `call_node` mediumtext,
  `forward` mediumtext,
  `parent` mediumtext,
  PRIMARY KEY  (`root_class`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_structure`
--

INSERT INTO `ctrl_structure` VALUES ('ilrepositorygui','a:640:{i:1;a:2:{s:5:\"class\";s:15:\"ilrepositorygui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:16:\"ilobjcategorygui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:3;}i:7;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:6;}i:8;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:3;}i:11;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:10;}i:12;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:11;}i:14;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:13;}i:15;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:13;}i:17;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:16;}i:18;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:13;}i:19;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:18;}i:20;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:11;}i:21;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:20;}i:24;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:23;}i:25;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:11;}i:26;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:10;}i:28;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:3;}i:29;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:29;}i:31;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:30;}i:33;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:28;}i:34;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:28;}i:35;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:34;}i:36;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:34;}i:37;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:36;}i:38;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:36;}i:39;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:34;}i:40;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:34;}i:41;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:34;}i:42;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:34;}i:43;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:34;}i:44;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:34;}i:45;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:34;}i:46;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:34;}i:47;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:34;}i:48;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:34;}i:49;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:3;}i:50;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:49;}i:51;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:50;}i:52;a:2:{s:5:\"class\";s:12:\"ilobjchatgui\";s:6:\"parent\";i:1;}i:53;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:52;}i:54;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:53;}i:55;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:54;}i:56;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:1;}i:57;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:56;}i:59;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:58;}i:60;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:58;}i:61;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:60;}i:62;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:58;}i:63;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:58;}i:64;a:2:{s:5:\"class\";s:24:\"ilcoursecontentinterface\";s:6:\"parent\";i:56;}i:65;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:64;}i:66;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:64;}i:67;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:66;}i:68;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:56;}i:69;a:2:{s:5:\"class\";s:19:\"ilcourseregistergui\";s:6:\"parent\";i:56;}i:70;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:56;}i:71;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:70;}i:72;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:70;}i:74;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:56;}i:75;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:74;}i:76;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:74;}i:77;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:76;}i:78;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:77;}i:79;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:76;}i:80;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:79;}i:81;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:76;}i:82;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:81;}i:83;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:74;}i:84;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:83;}i:85;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:84;}i:86;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:83;}i:87;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:86;}i:88;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:74;}i:89;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:88;}i:90;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:56;}i:91;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:56;}i:92;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:56;}i:93;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:92;}i:94;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:93;}i:95;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:93;}i:96;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:95;}i:97;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:96;}i:98;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:95;}i:99;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:98;}i:100;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:95;}i:101;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:100;}i:102;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:93;}i:103;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:102;}i:104;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:103;}i:105;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:102;}i:106;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:105;}i:107;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:93;}i:108;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:107;}i:109;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:92;}i:110;a:2:{s:5:\"class\";s:20:\"ilpaymentpurchasegui\";s:6:\"parent\";i:56;}i:111;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:56;}i:112;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:111;}i:113;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:112;}i:114;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:56;}i:115;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:116;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:115;}i:117;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:116;}i:118;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:116;}i:119;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:118;}i:120;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:119;}i:121;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:118;}i:122;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:121;}i:123;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:118;}i:124;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:123;}i:125;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:116;}i:126;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:125;}i:127;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:126;}i:128;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:125;}i:129;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:128;}i:130;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:116;}i:131;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:130;}i:132;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:115;}i:133;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:132;}i:134;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:132;}i:135;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:134;}i:136;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:135;}i:137;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:136;}i:138;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:136;}i:139;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:134;}i:140;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:134;}i:141;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:140;}i:142;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:140;}i:143;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:142;}i:144;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:142;}i:145;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:140;}i:146;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:140;}i:147;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:140;}i:148;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:140;}i:149;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:140;}i:150;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:140;}i:151;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:140;}i:152;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:140;}i:153;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:140;}i:154;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:140;}i:155;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:115;}i:156;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:115;}i:157;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:156;}i:158;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:115;}i:159;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:158;}i:160;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:159;}i:161;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:115;}i:162;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:161;}i:163;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:161;}i:164;a:2:{s:5:\"class\";s:16:\"ilobjexercisegui\";s:6:\"parent\";i:1;}i:165;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:164;}i:166;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:165;}i:167;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:166;}i:168;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:165;}i:169;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:164;}i:170;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:169;}i:171;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:169;}i:172;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:171;}i:173;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:172;}i:174;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:171;}i:175;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:174;}i:176;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:171;}i:177;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:176;}i:178;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:169;}i:179;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:178;}i:180;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:179;}i:181;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:178;}i:182;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:181;}i:183;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:169;}i:184;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:183;}i:185;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:164;}i:186;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:185;}i:187;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:186;}i:188;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:164;}i:189;a:2:{s:5:\"class\";s:19:\"ilobjfilebasedlmgui\";s:6:\"parent\";i:1;}i:190;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:189;}i:191;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:189;}i:192;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:191;}i:193;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:192;}i:194;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:191;}i:195;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:189;}i:196;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:195;}i:197;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:195;}i:198;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:197;}i:199;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:198;}i:200;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:197;}i:201;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:200;}i:202;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:197;}i:203;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:202;}i:204;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:195;}i:205;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:204;}i:206;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:205;}i:207;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:204;}i:208;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:207;}i:209;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:195;}i:210;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:209;}i:211;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:189;}i:212;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:189;}i:213;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:212;}i:214;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:213;}i:215;a:2:{s:5:\"class\";s:12:\"ilobjfilegui\";s:6:\"parent\";i:1;}i:216;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:215;}i:217;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:216;}i:218;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:217;}i:219;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:216;}i:220;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:215;}i:221;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:215;}i:222;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:221;}i:223;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:222;}i:224;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1;}i:225;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:224;}i:226;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:224;}i:227;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:226;}i:228;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:226;}i:229;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:228;}i:230;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:226;}i:231;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:226;}i:232;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:224;}i:233;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:232;}i:234;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:232;}i:235;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:234;}i:236;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:235;}i:237;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:234;}i:238;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:237;}i:239;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:234;}i:240;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:239;}i:241;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:232;}i:242;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:241;}i:243;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:242;}i:244;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:241;}i:245;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:244;}i:246;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:232;}i:247;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:246;}i:248;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:224;}i:249;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:248;}i:250;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:249;}i:251;a:2:{s:5:\"class\";s:13:\"ilobjforumgui\";s:6:\"parent\";i:1;}i:252;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:251;}i:253;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:252;}i:254;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:253;}i:255;a:2:{s:5:\"class\";s:16:\"ilobjglossarygui\";s:6:\"parent\";i:1;}i:256;a:2:{s:5:\"class\";s:17:\"ilglossarytermgui\";s:6:\"parent\";i:255;}i:257;a:2:{s:5:\"class\";s:25:\"iltermdefinitioneditorgui\";s:6:\"parent\";i:256;}i:258;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:257;}i:259;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:257;}i:260;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:259;}i:261;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:260;}i:262;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:261;}i:263;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:261;}i:264;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:259;}i:265;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:259;}i:266;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:265;}i:267;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:265;}i:268;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:267;}i:269;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:267;}i:270;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:265;}i:271;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:265;}i:272;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:265;}i:273;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:265;}i:274;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:265;}i:275;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:265;}i:276;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:265;}i:277;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:265;}i:278;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:265;}i:279;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:265;}i:280;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:255;}i:281;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:255;}i:282;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:281;}i:283;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:282;}i:284;a:2:{s:5:\"class\";s:13:\"ilobjgroupgui\";s:6:\"parent\";i:1;}i:285;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:284;}i:286;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:284;}i:287;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:284;}i:288;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:287;}i:289;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:287;}i:290;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:289;}i:291;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:287;}i:292;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:287;}i:293;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:284;}i:294;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:293;}i:295;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:294;}i:296;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:293;}i:297;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:284;}i:298;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:297;}i:299;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:297;}i:300;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:299;}i:301;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:300;}i:302;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:299;}i:303;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:302;}i:304;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:299;}i:305;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:304;}i:306;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:297;}i:307;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:306;}i:308;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:307;}i:309;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:306;}i:310;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:309;}i:311;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:297;}i:312;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:311;}i:313;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:284;}i:314;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:284;}i:315;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:314;}i:316;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:315;}i:317;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:315;}i:318;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:317;}i:319;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:318;}i:320;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:317;}i:321;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:320;}i:322;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:317;}i:323;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:322;}i:324;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:315;}i:325;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:324;}i:326;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:325;}i:327;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:324;}i:328;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:327;}i:329;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:315;}i:330;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:329;}i:331;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:314;}i:332;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:284;}i:333;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:332;}i:334;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:333;}i:335;a:2:{s:5:\"class\";s:13:\"ilregistergui\";s:6:\"parent\";i:284;}i:336;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:284;}i:337;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1;}i:338;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:337;}i:339;a:2:{s:5:\"class\";s:19:\"ilobjilinccoursegui\";s:6:\"parent\";i:1;}i:340;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:339;}i:341;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:340;}i:342;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:341;}i:343;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:340;}i:344;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:339;}i:345;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:344;}i:346;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:339;}i:347;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:346;}i:348;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:347;}i:349;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:347;}i:350;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:349;}i:351;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:350;}i:352;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:349;}i:353;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:352;}i:354;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:349;}i:355;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:354;}i:356;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:347;}i:357;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:356;}i:358;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:357;}i:359;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:356;}i:360;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:359;}i:361;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:347;}i:362;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:361;}i:363;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:346;}i:364;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:339;}i:365;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:364;}i:366;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:365;}i:367;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:339;}i:368;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:369;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:368;}i:370;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:369;}i:371;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:369;}i:372;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:371;}i:373;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:372;}i:374;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:371;}i:375;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:374;}i:376;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:371;}i:377;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:376;}i:378;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:369;}i:379;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:378;}i:380;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:379;}i:381;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:378;}i:382;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:381;}i:383;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:369;}i:384;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:383;}i:385;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:368;}i:386;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:385;}i:387;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:385;}i:388;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:387;}i:389;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:388;}i:390;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:389;}i:391;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:389;}i:392;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:387;}i:393;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:387;}i:394;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:393;}i:395;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:393;}i:396;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:395;}i:397;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:395;}i:398;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:393;}i:399;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:393;}i:400;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:393;}i:401;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:393;}i:402;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:393;}i:403;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:393;}i:404;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:393;}i:405;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:393;}i:406;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:393;}i:407;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:393;}i:408;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:368;}i:409;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:368;}i:410;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:409;}i:411;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:368;}i:412;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:411;}i:413;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:412;}i:414;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:368;}i:415;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:414;}i:416;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:414;}i:417;a:2:{s:5:\"class\";s:20:\"ilobjlinkresourcegui\";s:6:\"parent\";i:1;}i:418;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:417;}i:419;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:418;}i:420;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:419;}i:421;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:418;}i:422;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:417;}i:423;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:417;}i:424;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:423;}i:425;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:424;}i:426;a:2:{s:5:\"class\";s:17:\"ilobjmediapoolgui\";s:6:\"parent\";i:1;}i:427;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:426;}i:428;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:427;}i:429;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:428;}i:430;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:428;}i:431;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:426;}i:432;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:431;}i:433;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:431;}i:434;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:433;}i:435;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:433;}i:436;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:435;}i:437;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:433;}i:438;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:433;}i:439;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:431;}i:440;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:439;}i:441;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:439;}i:442;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:441;}i:443;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:442;}i:444;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:441;}i:445;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:444;}i:446;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:441;}i:447;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:446;}i:448;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:439;}i:449;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:448;}i:450;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:449;}i:451;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:448;}i:452;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:451;}i:453;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:439;}i:454;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:453;}i:455;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:431;}i:456;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:455;}i:457;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:456;}i:458;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:426;}i:459;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:458;}i:460;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:458;}i:461;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:426;}i:462;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:461;}i:463;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:462;}i:464;a:2:{s:5:\"class\";s:20:\"ilobjquestionpoolgui\";s:6:\"parent\";i:1;}i:465;a:2:{s:5:\"class\";s:15:\"assclozetestgui\";s:6:\"parent\";i:464;}i:466;a:2:{s:5:\"class\";s:22:\"assimagemapquestiongui\";s:6:\"parent\";i:464;}i:467;a:2:{s:5:\"class\";s:16:\"assjavaappletgui\";s:6:\"parent\";i:464;}i:468;a:2:{s:5:\"class\";s:22:\"assmatchingquestiongui\";s:6:\"parent\";i:464;}i:469;a:2:{s:5:\"class\";s:20:\"assmultiplechoicegui\";s:6:\"parent\";i:464;}i:470;a:2:{s:5:\"class\";s:13:\"assnumericgui\";s:6:\"parent\";i:464;}i:471;a:2:{s:5:\"class\";s:22:\"assorderingquestiongui\";s:6:\"parent\";i:464;}i:472;a:2:{s:5:\"class\";s:18:\"asssinglechoicegui\";s:6:\"parent\";i:464;}i:473;a:2:{s:5:\"class\";s:18:\"asstextquestiongui\";s:6:\"parent\";i:464;}i:474;a:2:{s:5:\"class\";s:16:\"asstextsubsetgui\";s:6:\"parent\";i:464;}i:475;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:464;}i:476;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:464;}i:477;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:476;}i:478;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:477;}i:479;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:478;}i:480;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:478;}i:481;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:476;}i:482;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:476;}i:483;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:482;}i:484;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:482;}i:485;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:484;}i:486;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:484;}i:487;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:482;}i:488;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:482;}i:489;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:482;}i:490;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:482;}i:491;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:482;}i:492;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:482;}i:493;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:482;}i:494;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:482;}i:495;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:482;}i:496;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:482;}i:497;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:464;}i:498;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:497;}i:499;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:498;}i:500;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1;}i:501;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:500;}i:502;a:2:{s:5:\"class\";s:18:\"ilobjrootfoldergui\";s:6:\"parent\";i:1;}i:503;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:502;}i:504;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:503;}i:505;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:502;}i:506;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:505;}i:507;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:506;}i:508;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:507;}i:509;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:507;}i:510;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:505;}i:511;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:505;}i:512;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:511;}i:513;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:511;}i:514;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:513;}i:515;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:513;}i:516;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:511;}i:517;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:511;}i:518;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:511;}i:519;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:511;}i:520;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:511;}i:521;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:511;}i:522;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:511;}i:523;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:511;}i:524;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:511;}i:525;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:511;}i:526;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:502;}i:527;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:526;}i:528;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:527;}i:529;a:2:{s:5:\"class\";s:26:\"ilobjsahslearningmodulegui\";s:6:\"parent\";i:1;}i:530;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:529;}i:531;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:529;}i:532;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:529;}i:533;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:532;}i:534;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:533;}i:535;a:2:{s:5:\"class\";s:14:\"ilobjsurveygui\";s:6:\"parent\";i:1;}i:536;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:535;}i:537;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:536;}i:538;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:537;}i:539;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:536;}i:540;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:535;}i:541;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:535;}i:542;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:541;}i:543;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:542;}i:544;a:2:{s:5:\"class\";s:21:\"ilsurveyevaluationgui\";s:6:\"parent\";i:535;}i:545;a:2:{s:5:\"class\";s:20:\"ilsurveyexecutiongui\";s:6:\"parent\";i:535;}i:546;a:2:{s:5:\"class\";s:26:\"ilobjsurveyquestionpoolgui\";s:6:\"parent\";i:1;}i:547;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:546;}i:548;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:546;}i:549;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:548;}i:550;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:549;}i:551;a:2:{s:5:\"class\";s:23:\"surveymetricquestiongui\";s:6:\"parent\";i:546;}i:552;a:2:{s:5:\"class\";s:24:\"surveynominalquestiongui\";s:6:\"parent\";i:546;}i:553;a:2:{s:5:\"class\";s:24:\"surveyordinalquestiongui\";s:6:\"parent\";i:546;}i:554;a:2:{s:5:\"class\";s:21:\"surveytextquestiongui\";s:6:\"parent\";i:546;}i:555;a:2:{s:5:\"class\";s:12:\"ilobjtestgui\";s:6:\"parent\";i:1;}i:556;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:555;}i:557;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:556;}i:558;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:557;}i:559;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:556;}i:560;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:555;}i:561;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:560;}i:562;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:560;}i:563;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:562;}i:564;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:563;}i:565;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:562;}i:566;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:565;}i:567;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:562;}i:568;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:567;}i:569;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:560;}i:570;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:569;}i:571;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:570;}i:572;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:569;}i:573;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:572;}i:574;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:560;}i:575;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:574;}i:576;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:555;}i:577;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:555;}i:578;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:577;}i:579;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:577;}i:580;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:579;}i:581;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:579;}i:582;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:581;}i:583;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:579;}i:584;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:579;}i:585;a:2:{s:5:\"class\";s:24:\"ilcoursecontentinterface\";s:6:\"parent\";i:577;}i:586;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:585;}i:587;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:585;}i:588;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:587;}i:589;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:577;}i:590;a:2:{s:5:\"class\";s:19:\"ilcourseregistergui\";s:6:\"parent\";i:577;}i:591;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:577;}i:592;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:591;}i:593;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:592;}i:594;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:591;}i:595;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:577;}i:596;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:595;}i:597;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:595;}i:598;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:597;}i:599;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:598;}i:600;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:597;}i:601;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:600;}i:602;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:597;}i:603;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:602;}i:604;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:595;}i:605;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:604;}i:606;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:605;}i:607;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:604;}i:608;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:607;}i:609;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:595;}i:610;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:609;}i:611;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:577;}i:612;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:577;}i:613;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:577;}i:614;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:613;}i:615;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:614;}i:616;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:614;}i:617;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:616;}i:618;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:617;}i:619;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:616;}i:620;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:619;}i:621;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:616;}i:622;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:621;}i:623;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:614;}i:624;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:623;}i:625;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:624;}i:626;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:623;}i:627;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:626;}i:628;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:614;}i:629;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:628;}i:630;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:613;}i:631;a:2:{s:5:\"class\";s:20:\"ilpaymentpurchasegui\";s:6:\"parent\";i:577;}i:632;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:577;}i:633;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:632;}i:634;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:633;}i:635;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:577;}i:636;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:555;}i:637;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:636;}i:638;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:637;}i:639;a:2:{s:5:\"class\";s:19:\"iltestevaluationgui\";s:6:\"parent\";i:555;}i:640;a:2:{s:5:\"class\";s:15:\"iltestoutputgui\";s:6:\"parent\";i:555;}}','a:50:{s:0:\"\";a:347:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:0:\"\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:0:\"\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:0:\"\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:0:\"\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:0:\"\";i:187;s:0:\"\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:0:\"\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:0:\"\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:0:\"\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:0:\"\";i:277;s:0:\"\";i:278;s:0:\"\";i:279;s:0:\"\";i:280;s:0:\"\";i:281;s:0:\"\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:0:\"\";i:285;s:0:\"\";i:286;s:0:\"\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:12:\"ilobjrolegui\";a:25:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";}s:15:\"ilpermissiongui\";a:24:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";i:2;s:12:\"ilobjrolegui\";i:3;s:12:\"ilobjrolegui\";i:4;s:12:\"ilobjrolegui\";i:5;s:12:\"ilobjrolegui\";i:6;s:12:\"ilobjrolegui\";i:7;s:12:\"ilobjrolegui\";i:8;s:12:\"ilobjrolegui\";i:9;s:12:\"ilobjrolegui\";i:10;s:12:\"ilobjrolegui\";i:11;s:12:\"ilobjrolegui\";i:12;s:12:\"ilobjrolegui\";i:13;s:12:\"ilobjrolegui\";i:14;s:12:\"ilobjrolegui\";i:15;s:12:\"ilobjrolegui\";i:16;s:12:\"ilobjrolegui\";i:17;s:12:\"ilobjrolegui\";i:18;s:12:\"ilobjrolegui\";i:19;s:12:\"ilobjrolegui\";i:20;s:12:\"ilobjrolegui\";i:21;s:12:\"ilobjrolegui\";i:22;s:12:\"ilobjrolegui\";i:23;s:12:\"ilobjrolegui\";}s:18:\"ilobjuserfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:13:\"illpfiltergui\";a:30:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";}s:17:\"ilpdfpresentation\";a:30:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";}s:15:\"iluserfiltergui\";a:15:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:45:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:15:\"iluserfiltergui\";i:9;s:13:\"illpfiltergui\";i:10;s:17:\"ilpdfpresentation\";i:11;s:15:\"iluserfiltergui\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:15:\"iluserfiltergui\";i:15;s:13:\"illpfiltergui\";i:16;s:17:\"ilpdfpresentation\";i:17;s:15:\"iluserfiltergui\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:15:\"iluserfiltergui\";i:21;s:13:\"illpfiltergui\";i:22;s:17:\"ilpdfpresentation\";i:23;s:15:\"iluserfiltergui\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:15:\"iluserfiltergui\";i:27;s:13:\"illpfiltergui\";i:28;s:17:\"ilpdfpresentation\";i:29;s:15:\"iluserfiltergui\";i:30;s:13:\"illpfiltergui\";i:31;s:17:\"ilpdfpresentation\";i:32;s:15:\"iluserfiltergui\";i:33;s:13:\"illpfiltergui\";i:34;s:17:\"ilpdfpresentation\";i:35;s:15:\"iluserfiltergui\";i:36;s:13:\"illpfiltergui\";i:37;s:17:\"ilpdfpresentation\";i:38;s:15:\"iluserfiltergui\";i:39;s:13:\"illpfiltergui\";i:40;s:17:\"ilpdfpresentation\";i:41;s:15:\"iluserfiltergui\";i:42;s:13:\"illpfiltergui\";i:43;s:17:\"ilpdfpresentation\";i:44;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:30:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";i:4;s:13:\"illpfiltergui\";i:5;s:17:\"ilpdfpresentation\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:13:\"illpfiltergui\";i:9;s:17:\"ilpdfpresentation\";i:10;s:13:\"illpfiltergui\";i:11;s:17:\"ilpdfpresentation\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:13:\"illpfiltergui\";i:15;s:17:\"ilpdfpresentation\";i:16;s:13:\"illpfiltergui\";i:17;s:17:\"ilpdfpresentation\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:13:\"illpfiltergui\";i:21;s:17:\"ilpdfpresentation\";i:22;s:13:\"illpfiltergui\";i:23;s:17:\"ilpdfpresentation\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:13:\"illpfiltergui\";i:27;s:17:\"ilpdfpresentation\";i:28;s:13:\"illpfiltergui\";i:29;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:15:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";}s:21:\"illearningprogressgui\";a:60:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";i:8;s:17:\"illmstatisticsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:21:\"illplistofprogressgui\";i:11;s:21:\"illplistofsettingsgui\";i:12;s:17:\"illmstatisticsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:21:\"illplistofprogressgui\";i:15;s:21:\"illplistofsettingsgui\";i:16;s:17:\"illmstatisticsgui\";i:17;s:20:\"illplistofobjectsgui\";i:18;s:21:\"illplistofprogressgui\";i:19;s:21:\"illplistofsettingsgui\";i:20;s:17:\"illmstatisticsgui\";i:21;s:20:\"illplistofobjectsgui\";i:22;s:21:\"illplistofprogressgui\";i:23;s:21:\"illplistofsettingsgui\";i:24;s:17:\"illmstatisticsgui\";i:25;s:20:\"illplistofobjectsgui\";i:26;s:21:\"illplistofprogressgui\";i:27;s:21:\"illplistofsettingsgui\";i:28;s:17:\"illmstatisticsgui\";i:29;s:20:\"illplistofobjectsgui\";i:30;s:21:\"illplistofprogressgui\";i:31;s:21:\"illplistofsettingsgui\";i:32;s:17:\"illmstatisticsgui\";i:33;s:20:\"illplistofobjectsgui\";i:34;s:21:\"illplistofprogressgui\";i:35;s:21:\"illplistofsettingsgui\";i:36;s:17:\"illmstatisticsgui\";i:37;s:20:\"illplistofobjectsgui\";i:38;s:21:\"illplistofprogressgui\";i:39;s:21:\"illplistofsettingsgui\";i:40;s:17:\"illmstatisticsgui\";i:41;s:20:\"illplistofobjectsgui\";i:42;s:21:\"illplistofprogressgui\";i:43;s:21:\"illplistofsettingsgui\";i:44;s:17:\"illmstatisticsgui\";i:45;s:20:\"illplistofobjectsgui\";i:46;s:21:\"illplistofprogressgui\";i:47;s:21:\"illplistofsettingsgui\";i:48;s:17:\"illmstatisticsgui\";i:49;s:20:\"illplistofobjectsgui\";i:50;s:21:\"illplistofprogressgui\";i:51;s:21:\"illplistofsettingsgui\";i:52;s:17:\"illmstatisticsgui\";i:53;s:20:\"illplistofobjectsgui\";i:54;s:21:\"illplistofprogressgui\";i:55;s:21:\"illplistofsettingsgui\";i:56;s:17:\"illmstatisticsgui\";i:57;s:20:\"illplistofobjectsgui\";i:58;s:21:\"illplistofprogressgui\";i:59;s:21:\"illplistofsettingsgui\";}s:12:\"ilobjusergui\";a:10:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";i:2;s:21:\"illearningprogressgui\";i:3;s:17:\"ilobjilincusergui\";i:4;s:21:\"illearningprogressgui\";i:5;s:17:\"ilobjilincusergui\";i:6;s:21:\"illearningprogressgui\";i:7;s:17:\"ilobjilincusergui\";i:8;s:21:\"illearningprogressgui\";i:9;s:17:\"ilobjilincusergui\";}s:19:\"ilobjmediaobjectgui\";a:28:{i:0;s:17:\"ilinternallinkgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:13:\"ilmdeditorgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:13:\"ilmdeditorgui\";i:20;s:17:\"ilinternallinkgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:17:\"ilinternallinkgui\";i:23;s:13:\"ilmdeditorgui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:17:\"ilinternallinkgui\";i:27;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:7:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";}s:15:\"ilpageeditorgui\";a:72:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpcfileitemgui\";i:3;s:15:\"ilpcfilelistgui\";i:4;s:11:\"ilpclistgui\";i:5;s:15:\"ilpclistitemgui\";i:6;s:18:\"ilpcmediaobjectgui\";i:7;s:16:\"ilpcparagraphgui\";i:8;s:15:\"ilpcquestiongui\";i:9;s:17:\"ilpcsourcecodegui\";i:10;s:16:\"ilpctabledatagui\";i:11;s:12:\"ilpctablegui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:15:\"ilpcfileitemgui\";i:15;s:15:\"ilpcfilelistgui\";i:16;s:11:\"ilpclistgui\";i:17;s:15:\"ilpclistitemgui\";i:18;s:18:\"ilpcmediaobjectgui\";i:19;s:16:\"ilpcparagraphgui\";i:20;s:15:\"ilpcquestiongui\";i:21;s:17:\"ilpcsourcecodegui\";i:22;s:16:\"ilpctabledatagui\";i:23;s:12:\"ilpctablegui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:15:\"ilpcfileitemgui\";i:27;s:15:\"ilpcfilelistgui\";i:28;s:11:\"ilpclistgui\";i:29;s:15:\"ilpclistitemgui\";i:30;s:18:\"ilpcmediaobjectgui\";i:31;s:16:\"ilpcparagraphgui\";i:32;s:15:\"ilpcquestiongui\";i:33;s:17:\"ilpcsourcecodegui\";i:34;s:16:\"ilpctabledatagui\";i:35;s:12:\"ilpctablegui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:15:\"ilpcfileitemgui\";i:39;s:15:\"ilpcfilelistgui\";i:40;s:11:\"ilpclistgui\";i:41;s:15:\"ilpclistitemgui\";i:42;s:18:\"ilpcmediaobjectgui\";i:43;s:16:\"ilpcparagraphgui\";i:44;s:15:\"ilpcquestiongui\";i:45;s:17:\"ilpcsourcecodegui\";i:46;s:16:\"ilpctabledatagui\";i:47;s:12:\"ilpctablegui\";i:48;s:17:\"ilinternallinkgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:15:\"ilpcfileitemgui\";i:51;s:15:\"ilpcfilelistgui\";i:52;s:11:\"ilpclistgui\";i:53;s:15:\"ilpclistitemgui\";i:54;s:18:\"ilpcmediaobjectgui\";i:55;s:16:\"ilpcparagraphgui\";i:56;s:15:\"ilpcquestiongui\";i:57;s:17:\"ilpcsourcecodegui\";i:58;s:16:\"ilpctabledatagui\";i:59;s:12:\"ilpctablegui\";i:60;s:17:\"ilinternallinkgui\";i:61;s:19:\"ilobjmediaobjectgui\";i:62;s:15:\"ilpcfileitemgui\";i:63;s:15:\"ilpcfilelistgui\";i:64;s:11:\"ilpclistgui\";i:65;s:15:\"ilpclistitemgui\";i:66;s:18:\"ilpcmediaobjectgui\";i:67;s:16:\"ilpcparagraphgui\";i:68;s:15:\"ilpcquestiongui\";i:69;s:17:\"ilpcsourcecodegui\";i:70;s:16:\"ilpctabledatagui\";i:71;s:12:\"ilpctablegui\";}s:15:\"ilpageobjectgui\";a:18:{i:0;s:18:\"ileditclipboardgui\";i:1;s:25:\"ilmediapooltargetselector\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:25:\"ilmediapooltargetselector\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:25:\"ilmediapooltargetselector\";i:8;s:15:\"ilpageeditorgui\";i:9;s:18:\"ileditclipboardgui\";i:10;s:25:\"ilmediapooltargetselector\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:25:\"ilmediapooltargetselector\";i:14;s:15:\"ilpageeditorgui\";i:15;s:18:\"ileditclipboardgui\";i:16;s:25:\"ilmediapooltargetselector\";i:17;s:15:\"ilpageeditorgui\";}s:16:\"ilobjcategorygui\";a:5:{i:0;s:22:\"ilcontainerlinklistgui\";i:1;s:18:\"ilobjuserfoldergui\";i:2;s:12:\"ilobjusergui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpermissiongui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:29:\"ilcourseitemadministrationgui\";a:7:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:27:\"ilconditionhandlerinterface\";i:4;s:27:\"ilconditionhandlerinterface\";i:5;s:27:\"ilconditionhandlerinterface\";i:6;s:27:\"ilconditionhandlerinterface\";}s:18:\"ilcoursecontentgui\";a:20:{i:0;s:19:\"ilcoursearchivesgui\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:32:\"ilcourseobjectivepresentationgui\";i:3;s:24:\"ileventadministrationgui\";i:4;s:19:\"ilcoursearchivesgui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:32:\"ilcourseobjectivepresentationgui\";i:7;s:24:\"ileventadministrationgui\";i:8;s:19:\"ilcoursearchivesgui\";i:9;s:29:\"ilcourseitemadministrationgui\";i:10;s:32:\"ilcourseobjectivepresentationgui\";i:11;s:24:\"ileventadministrationgui\";i:12;s:19:\"ilcoursearchivesgui\";i:13;s:29:\"ilcourseitemadministrationgui\";i:14;s:32:\"ilcourseobjectivepresentationgui\";i:15;s:24:\"ileventadministrationgui\";i:16;s:19:\"ilcoursearchivesgui\";i:17;s:29:\"ilcourseitemadministrationgui\";i:18;s:32:\"ilcourseobjectivepresentationgui\";i:19;s:24:\"ileventadministrationgui\";}s:24:\"ilcoursecontentinterface\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:29:\"ilcourseitemadministrationgui\";}s:13:\"ilfeedbackgui\";a:10:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";}s:15:\"ilinfoscreengui\";a:20:{i:0;s:13:\"ilfeedbackgui\";i:1;s:9:\"ilnotegui\";i:2;s:13:\"ilfeedbackgui\";i:3;s:9:\"ilnotegui\";i:4;s:13:\"ilfeedbackgui\";i:5;s:9:\"ilnotegui\";i:6;s:13:\"ilfeedbackgui\";i:7;s:9:\"ilnotegui\";i:8;s:13:\"ilfeedbackgui\";i:9;s:9:\"ilnotegui\";i:10;s:13:\"ilfeedbackgui\";i:11;s:9:\"ilnotegui\";i:12;s:13:\"ilfeedbackgui\";i:13;s:9:\"ilnotegui\";i:14;s:13:\"ilfeedbackgui\";i:15;s:9:\"ilnotegui\";i:16;s:13:\"ilfeedbackgui\";i:17;s:9:\"ilnotegui\";i:18;s:13:\"ilfeedbackgui\";i:19;s:9:\"ilnotegui\";}s:14:\"ilobjcoursegui\";a:26:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:24:\"ilcoursecontentinterface\";i:3;s:21:\"ilcourseobjectivesgui\";i:4;s:19:\"ilcourseregistergui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:21:\"illearningprogressgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:22:\"ilobjcoursegroupinggui\";i:9;s:12:\"ilobjusergui\";i:10;s:20:\"ilpaymentpurchasegui\";i:11;s:15:\"ilpermissiongui\";i:12;s:21:\"ilrepositorysearchgui\";i:13;s:27:\"ilconditionhandlerinterface\";i:14;s:18:\"ilcoursecontentgui\";i:15;s:24:\"ilcoursecontentinterface\";i:16;s:21:\"ilcourseobjectivesgui\";i:17;s:19:\"ilcourseregistergui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:21:\"illearningprogressgui\";i:20;s:13:\"ilmdeditorgui\";i:21;s:22:\"ilobjcoursegroupinggui\";i:22;s:12:\"ilobjusergui\";i:23;s:20:\"ilpaymentpurchasegui\";i:24;s:15:\"ilpermissiongui\";i:25;s:21:\"ilrepositorysearchgui\";}s:17:\"illmpageobjectgui\";a:4:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:16:\"ilobjexercisegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilrepositorysearchgui\";}s:19:\"ilobjfilebasedlmgui\";a:5:{i:0;s:15:\"ilfilesystemgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:21:\"illearningprogressgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:15:\"ilpermissiongui\";}s:12:\"ilobjfilegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:14:\"ilobjfoldergui\";a:8:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:15:\"ilpermissiongui\";i:4;s:27:\"ilconditionhandlerinterface\";i:5;s:18:\"ilcoursecontentgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:15:\"ilpermissiongui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:25:\"iltermdefinitioneditorgui\";a:2:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:25:\"iltermdefinitioneditorgui\";}s:16:\"ilobjglossarygui\";a:3:{i:0;s:17:\"ilglossarytermgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:13:\"ilobjgroupgui\";a:10:{i:0;s:0:\"\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:21:\"illearningprogressgui\";i:5;s:22:\"ilobjcoursegroupinggui\";i:6;s:12:\"ilobjusergui\";i:7;s:15:\"ilpermissiongui\";i:8;s:13:\"ilregistergui\";i:9;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:19:\"ilobjilinccoursegui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:22:\"ilobjilincclassroomgui\";i:2;s:12:\"ilobjusergui\";i:3;s:15:\"ilpermissiongui\";i:4;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjlearningmodulegui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:20:\"ilobjlinkresourcegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediapoolgui\";a:4:{i:0;s:18:\"ileditclipboardgui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpermissiongui\";}s:20:\"ilobjquestionpoolgui\";a:13:{i:0;s:15:\"assclozetestgui\";i:1;s:22:\"assimagemapquestiongui\";i:2;s:16:\"assjavaappletgui\";i:3;s:22:\"assmatchingquestiongui\";i:4;s:20:\"assmultiplechoicegui\";i:5;s:13:\"assnumericgui\";i:6;s:22:\"assorderingquestiongui\";i:7;s:18:\"asssinglechoicegui\";i:8;s:18:\"asstextquestiongui\";i:9;s:16:\"asstextsubsetgui\";i:10;s:13:\"ilmdeditorgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:15:\"ilpermissiongui\";}s:18:\"ilobjrootfoldergui\";a:3:{i:0;s:22:\"ilcontainerlinklistgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpermissiongui\";}s:26:\"ilobjsahslearningmodulegui\";a:3:{i:0;s:15:\"ilfilesystemgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:14:\"ilobjsurveygui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilsurveyevaluationgui\";i:4;s:20:\"ilsurveyexecutiongui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:6:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:23:\"surveymetricquestiongui\";i:3;s:24:\"surveynominalquestiongui\";i:4;s:24:\"surveyordinalquestiongui\";i:5;s:21:\"surveytextquestiongui\";}s:12:\"ilobjtestgui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:15:\"ilpermissiongui\";i:5;s:19:\"iltestevaluationgui\";i:6;s:15:\"iltestoutputgui\";}s:15:\"ilrepositorygui\";a:24:{i:0;s:21:\"ilcourseobjectivesgui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:12:\"ilobjchatgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:14:\"ilobjdlbookgui\";i:5;s:16:\"ilobjexercisegui\";i:6;s:19:\"ilobjfilebasedlmgui\";i:7;s:12:\"ilobjfilegui\";i:8;s:14:\"ilobjfoldergui\";i:9;s:13:\"ilobjforumgui\";i:10;s:16:\"ilobjglossarygui\";i:11;s:13:\"ilobjgroupgui\";i:12;s:22:\"ilobjilincclassroomgui\";i:13;s:19:\"ilobjilinccoursegui\";i:14;s:22:\"ilobjlearningmodulegui\";i:15;s:20:\"ilobjlinkresourcegui\";i:16;s:17:\"ilobjmediapoolgui\";i:17;s:20:\"ilobjquestionpoolgui\";i:18;s:12:\"ilobjrolegui\";i:19;s:18:\"ilobjrootfoldergui\";i:20;s:26:\"ilobjsahslearningmodulegui\";i:21;s:14:\"ilobjsurveygui\";i:22;s:26:\"ilobjsurveyquestionpoolgui\";i:23;s:12:\"ilobjtestgui\";}}','a:94:{s:0:\"\";a:479:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:22:\"ilcontainerlinklistgui\";i:3;s:0:\"\";i:4;s:12:\"ilobjrolegui\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:13:\"illpfiltergui\";i:8;s:0:\"\";i:9;s:17:\"ilpdfpresentation\";i:10;s:0:\"\";i:11;s:15:\"iluserfiltergui\";i:12;s:0:\"\";i:13;s:13:\"illpfiltergui\";i:14;s:0:\"\";i:15;s:17:\"ilpdfpresentation\";i:16;s:0:\"\";i:17;s:21:\"illplistofsettingsgui\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:12:\"ilobjrolegui\";i:37;s:0:\"\";i:38;s:12:\"ilobjrolegui\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:13:\"ilfeedbackgui\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:13:\"illpfiltergui\";i:54;s:0:\"\";i:55;s:17:\"ilpdfpresentation\";i:56;s:0:\"\";i:57;s:15:\"iluserfiltergui\";i:58;s:0:\"\";i:59;s:13:\"illpfiltergui\";i:60;s:0:\"\";i:61;s:17:\"ilpdfpresentation\";i:62;s:0:\"\";i:63;s:21:\"illplistofsettingsgui\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:13:\"illpfiltergui\";i:69;s:0:\"\";i:70;s:17:\"ilpdfpresentation\";i:71;s:0:\"\";i:72;s:15:\"iluserfiltergui\";i:73;s:0:\"\";i:74;s:13:\"illpfiltergui\";i:75;s:0:\"\";i:76;s:17:\"ilpdfpresentation\";i:77;s:0:\"\";i:78;s:21:\"illplistofsettingsgui\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:12:\"ilobjrolegui\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:13:\"illpfiltergui\";i:87;s:0:\"\";i:88;s:17:\"ilpdfpresentation\";i:89;s:0:\"\";i:90;s:15:\"iluserfiltergui\";i:91;s:0:\"\";i:92;s:13:\"illpfiltergui\";i:93;s:0:\"\";i:94;s:17:\"ilpdfpresentation\";i:95;s:0:\"\";i:96;s:21:\"illplistofsettingsgui\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:18:\"ilobjstylesheetgui\";i:117;s:0:\"\";i:118;s:12:\"ilobjrolegui\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:13:\"ilfeedbackgui\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:13:\"illpfiltergui\";i:127;s:0:\"\";i:128;s:17:\"ilpdfpresentation\";i:129;s:0:\"\";i:130;s:15:\"iluserfiltergui\";i:131;s:0:\"\";i:132;s:13:\"illpfiltergui\";i:133;s:0:\"\";i:134;s:17:\"ilpdfpresentation\";i:135;s:0:\"\";i:136;s:21:\"illplistofsettingsgui\";i:137;s:0:\"\";i:138;s:12:\"ilobjrolegui\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:13:\"ilfeedbackgui\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:13:\"illpfiltergui\";i:147;s:0:\"\";i:148;s:17:\"ilpdfpresentation\";i:149;s:0:\"\";i:150;s:15:\"iluserfiltergui\";i:151;s:0:\"\";i:152;s:13:\"illpfiltergui\";i:153;s:0:\"\";i:154;s:17:\"ilpdfpresentation\";i:155;s:0:\"\";i:156;s:21:\"illplistofsettingsgui\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:12:\"ilobjrolegui\";i:160;s:0:\"\";i:161;s:13:\"ilfeedbackgui\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:12:\"ilobjrolegui\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:13:\"illpfiltergui\";i:174;s:0:\"\";i:175;s:17:\"ilpdfpresentation\";i:176;s:0:\"\";i:177;s:15:\"iluserfiltergui\";i:178;s:0:\"\";i:179;s:13:\"illpfiltergui\";i:180;s:0:\"\";i:181;s:17:\"ilpdfpresentation\";i:182;s:0:\"\";i:183;s:21:\"illplistofsettingsgui\";i:184;s:0:\"\";i:185;s:12:\"ilobjrolegui\";i:186;s:0:\"\";i:187;s:12:\"ilobjrolegui\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:12:\"ilobjrolegui\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:13:\"ilfeedbackgui\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:13:\"illpfiltergui\";i:220;s:0:\"\";i:221;s:17:\"ilpdfpresentation\";i:222;s:0:\"\";i:223;s:15:\"iluserfiltergui\";i:224;s:0:\"\";i:225;s:13:\"illpfiltergui\";i:226;s:0:\"\";i:227;s:17:\"ilpdfpresentation\";i:228;s:0:\"\";i:229;s:21:\"illplistofsettingsgui\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:13:\"illpfiltergui\";i:234;s:0:\"\";i:235;s:17:\"ilpdfpresentation\";i:236;s:0:\"\";i:237;s:15:\"iluserfiltergui\";i:238;s:0:\"\";i:239;s:13:\"illpfiltergui\";i:240;s:0:\"\";i:241;s:17:\"ilpdfpresentation\";i:242;s:0:\"\";i:243;s:21:\"illplistofsettingsgui\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:12:\"ilobjrolegui\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:13:\"ilobjgroupgui\";i:250;s:0:\"\";i:251;s:22:\"ilobjilincclassroomgui\";i:252;s:0:\"\";i:253;s:13:\"ilfeedbackgui\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:22:\"ilobjilincclassroomgui\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:13:\"illpfiltergui\";i:260;s:0:\"\";i:261;s:17:\"ilpdfpresentation\";i:262;s:0:\"\";i:263;s:15:\"iluserfiltergui\";i:264;s:0:\"\";i:265;s:13:\"illpfiltergui\";i:266;s:0:\"\";i:267;s:17:\"ilpdfpresentation\";i:268;s:0:\"\";i:269;s:21:\"illplistofsettingsgui\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:12:\"ilobjrolegui\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:13:\"illpfiltergui\";i:277;s:0:\"\";i:278;s:17:\"ilpdfpresentation\";i:279;s:0:\"\";i:280;s:15:\"iluserfiltergui\";i:281;s:0:\"\";i:282;s:13:\"illpfiltergui\";i:283;s:0:\"\";i:284;s:17:\"ilpdfpresentation\";i:285;s:0:\"\";i:286;s:21:\"illplistofsettingsgui\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:18:\"ilobjstylesheetgui\";i:307;s:0:\"\";i:308;s:12:\"ilobjrolegui\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:13:\"ilfeedbackgui\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:12:\"ilobjrolegui\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:13:\"illpfiltergui\";i:327;s:0:\"\";i:328;s:17:\"ilpdfpresentation\";i:329;s:0:\"\";i:330;s:15:\"iluserfiltergui\";i:331;s:0:\"\";i:332;s:13:\"illpfiltergui\";i:333;s:0:\"\";i:334;s:17:\"ilpdfpresentation\";i:335;s:0:\"\";i:336;s:21:\"illplistofsettingsgui\";i:337;s:0:\"\";i:338;s:12:\"ilobjrolegui\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:12:\"ilobjrolegui\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:12:\"ilobjrolegui\";i:372;s:0:\"\";i:373;s:12:\"ilobjrolegui\";i:374;s:0:\"\";i:375;s:22:\"ilcontainerlinklistgui\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:0:\"\";i:389;s:0:\"\";i:390;s:0:\"\";i:391;s:0:\"\";i:392;s:0:\"\";i:393;s:12:\"ilobjrolegui\";i:394;s:0:\"\";i:395;s:0:\"\";i:396;s:0:\"\";i:397;s:12:\"ilobjrolegui\";i:398;s:0:\"\";i:399;s:13:\"ilfeedbackgui\";i:400;s:0:\"\";i:401;s:0:\"\";i:402;s:0:\"\";i:403;s:12:\"ilobjrolegui\";i:404;s:0:\"\";i:405;s:0:\"\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:12:\"ilobjrolegui\";i:409;s:0:\"\";i:410;s:0:\"\";i:411;s:0:\"\";i:412;s:0:\"\";i:413;s:0:\"\";i:414;s:13:\"ilfeedbackgui\";i:415;s:0:\"\";i:416;s:0:\"\";i:417;s:0:\"\";i:418;s:13:\"illpfiltergui\";i:419;s:0:\"\";i:420;s:17:\"ilpdfpresentation\";i:421;s:0:\"\";i:422;s:15:\"iluserfiltergui\";i:423;s:0:\"\";i:424;s:13:\"illpfiltergui\";i:425;s:0:\"\";i:426;s:17:\"ilpdfpresentation\";i:427;s:0:\"\";i:428;s:21:\"illplistofsettingsgui\";i:429;s:0:\"\";i:430;s:0:\"\";i:431;s:0:\"\";i:432;s:0:\"\";i:433;s:0:\"\";i:434;s:0:\"\";i:435;s:0:\"\";i:436;s:0:\"\";i:437;s:0:\"\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:13:\"ilfeedbackgui\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:13:\"illpfiltergui\";i:445;s:0:\"\";i:446;s:17:\"ilpdfpresentation\";i:447;s:0:\"\";i:448;s:15:\"iluserfiltergui\";i:449;s:0:\"\";i:450;s:13:\"illpfiltergui\";i:451;s:0:\"\";i:452;s:17:\"ilpdfpresentation\";i:453;s:0:\"\";i:454;s:21:\"illplistofsettingsgui\";i:455;s:0:\"\";i:456;s:0:\"\";i:457;s:0:\"\";i:458;s:0:\"\";i:459;s:13:\"illpfiltergui\";i:460;s:0:\"\";i:461;s:17:\"ilpdfpresentation\";i:462;s:0:\"\";i:463;s:15:\"iluserfiltergui\";i:464;s:0:\"\";i:465;s:13:\"illpfiltergui\";i:466;s:0:\"\";i:467;s:17:\"ilpdfpresentation\";i:468;s:0:\"\";i:469;s:21:\"illplistofsettingsgui\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:12:\"ilobjrolegui\";i:474;s:0:\"\";i:475;s:0:\"\";i:476;s:12:\"ilobjrolegui\";i:477;s:0:\"\";i:478;s:0:\"\";}s:12:\"ilobjrolegui\";a:25:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";i:2;s:15:\"ilpermissiongui\";i:3;s:15:\"ilpermissiongui\";i:4;s:15:\"ilpermissiongui\";i:5;s:15:\"ilpermissiongui\";i:6;s:15:\"ilpermissiongui\";i:7;s:15:\"ilpermissiongui\";i:8;s:15:\"ilpermissiongui\";i:9;s:15:\"ilpermissiongui\";i:10;s:15:\"ilpermissiongui\";i:11;s:15:\"ilpermissiongui\";i:12;s:15:\"ilpermissiongui\";i:13;s:15:\"ilpermissiongui\";i:14;s:15:\"ilpermissiongui\";i:15;s:15:\"ilpermissiongui\";i:16;s:15:\"ilpermissiongui\";i:17;s:15:\"ilpermissiongui\";i:18;s:15:\"ilpermissiongui\";i:19;s:15:\"ilpermissiongui\";i:20;s:15:\"ilpermissiongui\";i:21;s:15:\"ilpermissiongui\";i:22;s:15:\"ilpermissiongui\";i:23;s:15:\"ilpermissiongui\";i:24;s:15:\"ilrepositorygui\";}s:15:\"ilpermissiongui\";a:24:{i:0;s:18:\"ilobjuserfoldergui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:12:\"ilobjchatgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:14:\"ilobjdlbookgui\";i:5;s:16:\"ilobjexercisegui\";i:6;s:19:\"ilobjfilebasedlmgui\";i:7;s:12:\"ilobjfilegui\";i:8;s:14:\"ilobjfoldergui\";i:9;s:13:\"ilobjforumgui\";i:10;s:16:\"ilobjglossarygui\";i:11;s:13:\"ilobjgroupgui\";i:12;s:19:\"ilobjilinccoursegui\";i:13;s:22:\"ilobjlearningmodulegui\";i:14;s:20:\"ilobjlinkresourcegui\";i:15;s:14:\"ilobjfoldergui\";i:16;s:17:\"ilobjmediapoolgui\";i:17;s:20:\"ilobjquestionpoolgui\";i:18;s:18:\"ilobjrootfoldergui\";i:19;s:26:\"ilobjsahslearningmodulegui\";i:20;s:14:\"ilobjsurveygui\";i:21;s:26:\"ilobjsurveyquestionpoolgui\";i:22;s:14:\"ilobjcoursegui\";i:23;s:12:\"ilobjtestgui\";}s:13:\"illpfiltergui\";a:30:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:30:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:15:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:20:\"illplistofobjectsgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:20:\"illplistofobjectsgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:20:\"illplistofobjectsgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:15:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:14:\"ilobjdlbookgui\";i:4;s:16:\"ilobjexercisegui\";i:5;s:19:\"ilobjfilebasedlmgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:12:\"ilobjusergui\";i:8;s:13:\"ilobjgroupgui\";i:9;s:12:\"ilobjusergui\";i:10;s:22:\"ilobjlearningmodulegui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:12:\"ilobjusergui\";i:13;s:14:\"ilobjcoursegui\";i:14;s:12:\"ilobjtestgui\";}s:17:\"ilobjilincusergui\";a:5:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:12:\"ilobjusergui\";i:3;s:12:\"ilobjusergui\";i:4;s:12:\"ilobjusergui\";}s:17:\"ilinternallinkgui\";a:20:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:15:\"ilpageeditorgui\";}s:13:\"ilmdeditorgui\";a:32:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:17:\"illmpageobjectgui\";i:6;s:20:\"ilstructureobjectgui\";i:7;s:14:\"ilobjdlbookgui\";i:8;s:19:\"ilobjfilebasedlmgui\";i:9;s:12:\"ilobjfilegui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:25:\"iltermdefinitioneditorgui\";i:13;s:16:\"ilobjglossarygui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:17:\"illmpageobjectgui\";i:17;s:20:\"ilstructureobjectgui\";i:18;s:22:\"ilobjlearningmodulegui\";i:19;s:20:\"ilobjlinkresourcegui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:19:\"ilobjmediaobjectgui\";i:24;s:20:\"ilobjquestionpoolgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:26:\"ilobjsahslearningmodulegui\";i:28;s:14:\"ilobjsurveygui\";i:29;s:26:\"ilobjsurveyquestionpoolgui\";i:30;s:14:\"ilobjcoursegui\";i:31;s:12:\"ilobjtestgui\";}s:19:\"ilobjmediaobjectgui\";a:14:{i:0;s:18:\"ileditclipboardgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:18:\"ileditclipboardgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:18:\"ileditclipboardgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:18:\"ileditclipboardgui\";i:9;s:17:\"ilobjmediapoolgui\";i:10;s:18:\"ileditclipboardgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:7:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:17:\"ilobjmediapoolgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";}s:25:\"ilmediapooltargetselector\";a:6:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";}s:15:\"ilpageeditorgui\";a:6:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:18:\"ilobjrootfoldergui\";}s:18:\"ilobjuserfoldergui\";a:1:{i:0;s:16:\"ilobjcategorygui\";}s:12:\"ilobjusergui\";a:5:{i:0;s:16:\"ilobjcategorygui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";}s:15:\"ilpageobjectgui\";a:6:{i:0;s:16:\"ilobjcategorygui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:25:\"iltermdefinitioneditorgui\";i:3;s:17:\"illmpageobjectgui\";i:4;s:20:\"ilobjquestionpoolgui\";i:5;s:18:\"ilobjrootfoldergui\";}s:27:\"ilconditionhandlerinterface\";a:16:{i:0;s:29:\"ilcourseitemadministrationgui\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:24:\"ilcoursecontentinterface\";i:3;s:14:\"ilobjcoursegui\";i:4;s:20:\"ilstructureobjectgui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:29:\"ilcourseitemadministrationgui\";i:8;s:13:\"ilobjgroupgui\";i:9;s:20:\"ilstructureobjectgui\";i:10;s:29:\"ilcourseitemadministrationgui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:29:\"ilcourseitemadministrationgui\";i:13;s:29:\"ilcourseitemadministrationgui\";i:14;s:24:\"ilcoursecontentinterface\";i:15;s:14:\"ilobjcoursegui\";}s:19:\"ilcoursearchivesgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:29:\"ilcourseitemadministrationgui\";a:7:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:24:\"ilcoursecontentinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";i:5;s:18:\"ilcoursecontentgui\";i:6;s:24:\"ilcoursecontentinterface\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:24:\"ileventadministrationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:13:\"ilfeedbackgui\";a:10:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:10:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";}s:18:\"ilcoursecontentgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:24:\"ilcoursecontentinterface\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseobjectivesgui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:15:\"ilrepositorygui\";}s:19:\"ilcourseregistergui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:15:\"ilinfoscreengui\";a:10:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:19:\"ilobjfilebasedlmgui\";i:3;s:12:\"ilobjfilegui\";i:4;s:13:\"ilobjgroupgui\";i:5;s:19:\"ilobjilinccoursegui\";i:6;s:20:\"ilobjlinkresourcegui\";i:7;s:14:\"ilobjsurveygui\";i:8;s:14:\"ilobjcoursegui\";i:9;s:12:\"ilobjtestgui\";}s:22:\"ilobjcoursegroupinggui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:13:\"ilobjgroupgui\";i:2;s:14:\"ilobjcoursegui\";}s:20:\"ilpaymentpurchasegui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilrepositorysearchgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:15:\"ilfilesystemgui\";a:2:{i:0;s:19:\"ilobjfilebasedlmgui\";i:1;s:26:\"ilobjsahslearningmodulegui\";}s:25:\"iltermdefinitioneditorgui\";a:1:{i:0;s:17:\"ilglossarytermgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:16:\"ilobjglossarygui\";}s:13:\"ilregistergui\";a:1:{i:0;s:13:\"ilobjgroupgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:19:\"ilobjilinccoursegui\";i:1;s:15:\"ilrepositorygui\";}s:14:\"ilobjfoldergui\";a:2:{i:0;s:17:\"ilobjmediapoolgui\";i:1;s:15:\"ilrepositorygui\";}s:15:\"assclozetestgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assimagemapquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"assjavaappletgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assmatchingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:20:\"assmultiplechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:13:\"assnumericgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assorderingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asssinglechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asstextquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"asstextsubsetgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:21:\"ilsurveyevaluationgui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:20:\"ilsurveyexecutiongui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:23:\"surveymetricquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveynominalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveyordinalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:21:\"surveytextquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:14:\"ilobjcoursegui\";a:2:{i:0;s:12:\"ilobjtestgui\";i:1;s:15:\"ilrepositorygui\";}s:19:\"iltestevaluationgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:15:\"iltestoutputgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:16:\"ilobjcategorygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:16:\"ilobjexercisegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:19:\"ilobjfilebasedlmgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjfilegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:16:\"ilobjglossarygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:13:\"ilobjgroupgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:19:\"ilobjilinccoursegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjlinkresourcegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:17:\"ilobjmediapoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjquestionpoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:18:\"ilobjrootfoldergui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:26:\"ilobjsahslearningmodulegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:14:\"ilobjsurveygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjtestgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}}');
INSERT INTO `ctrl_structure` VALUES ('ilpersonaldesktopgui','a:52:{i:1;a:2:{s:5:\"class\";s:20:\"ilpersonaldesktopgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:27:\"ilbookmarkadministrationgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1;}i:6;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:5;}i:7;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:5;}i:8;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:7;}i:11;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:10;}i:12;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:7;}i:13;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:12;}i:14;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:5;}i:15;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:15;}i:17;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:14;}i:18;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:17;}i:19;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:5;}i:20;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:19;}i:21;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:1;}i:22;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:22;}i:25;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:24;}i:28;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:27;}i:29;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:24;}i:30;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:29;}i:31;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:22;}i:32;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:31;}i:33;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:32;}i:34;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:31;}i:35;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:34;}i:36;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:22;}i:37;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:36;}i:38;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:21;}i:39;a:2:{s:5:\"class\";s:17:\"ilpaymentadmingui\";s:6:\"parent\";i:1;}i:40;a:2:{s:5:\"class\";s:21:\"ilpaymentbilladmingui\";s:6:\"parent\";i:39;}i:41;a:2:{s:5:\"class\";s:18:\"ilpaymentobjectgui\";s:6:\"parent\";i:39;}i:42;a:2:{s:5:\"class\";s:21:\"ilpaymentstatisticgui\";s:6:\"parent\";i:39;}i:43;a:2:{s:5:\"class\";s:19:\"ilpaymenttrusteegui\";s:6:\"parent\";i:39;}i:44;a:2:{s:5:\"class\";s:12:\"ilpaymentgui\";s:6:\"parent\";i:1;}i:45;a:2:{s:5:\"class\";s:24:\"ilpaymentbuyedobjectsgui\";s:6:\"parent\";i:44;}i:46;a:2:{s:5:\"class\";s:24:\"ilpaymentshoppingcartgui\";s:6:\"parent\";i:44;}i:47;a:2:{s:5:\"class\";s:12:\"ilpdnotesgui\";s:6:\"parent\";i:1;}i:48;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:47;}i:49;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:48;}i:50;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:47;}i:51;a:2:{s:5:\"class\";s:20:\"ilpersonalprofilegui\";s:6:\"parent\";i:1;}i:52;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:51;}}','a:15:{s:0:\"\";a:26:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:13:\"illpfiltergui\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:6:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:4:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:21:\"illearningprogressgui\";a:8:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";}s:12:\"ilobjusergui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";}s:17:\"ilpaymentadmingui\";a:4:{i:0;s:21:\"ilpaymentbilladmingui\";i:1;s:18:\"ilpaymentobjectgui\";i:2;s:21:\"ilpaymentstatisticgui\";i:3;s:19:\"ilpaymenttrusteegui\";}s:12:\"ilpaymentgui\";a:2:{i:0;s:24:\"ilpaymentbuyedobjectsgui\";i:1;s:24:\"ilpaymentshoppingcartgui\";}s:12:\"ilpdnotesgui\";a:2:{i:0;s:13:\"ilfeedbackgui\";i:1;s:9:\"ilnotegui\";}s:20:\"ilpersonalprofilegui\";a:1:{i:0;s:0:\"\";}s:20:\"ilpersonaldesktopgui\";a:8:{i:0;s:27:\"ilbookmarkadministrationgui\";i:1;s:13:\"ilfeedbackgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:12:\"ilobjusergui\";i:4;s:17:\"ilpaymentadmingui\";i:5;s:12:\"ilpaymentgui\";i:6;s:12:\"ilpdnotesgui\";i:7;s:20:\"ilpersonalprofilegui\";}}','a:24:{s:0:\"\";a:41:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:13:\"ilfeedbackgui\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:13:\"illpfiltergui\";i:6;s:0:\"\";i:7;s:17:\"ilpdfpresentation\";i:8;s:0:\"\";i:9;s:15:\"iluserfiltergui\";i:10;s:0:\"\";i:11;s:13:\"illpfiltergui\";i:12;s:0:\"\";i:13;s:17:\"ilpdfpresentation\";i:14;s:0:\"\";i:15;s:21:\"illplistofsettingsgui\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:13:\"illpfiltergui\";i:19;s:0:\"\";i:20;s:17:\"ilpdfpresentation\";i:21;s:0:\"\";i:22;s:15:\"iluserfiltergui\";i:23;s:0:\"\";i:24;s:13:\"illpfiltergui\";i:25;s:0:\"\";i:26;s:17:\"ilpdfpresentation\";i:27;s:0:\"\";i:28;s:21:\"illplistofsettingsgui\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:13:\"ilfeedbackgui\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:20:\"ilpersonalprofilegui\";}s:13:\"illpfiltergui\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:2:{i:0;s:12:\"ilobjusergui\";i:1;s:20:\"ilpersonaldesktopgui\";}s:17:\"ilobjilincusergui\";a:1:{i:0;s:12:\"ilobjusergui\";}s:21:\"ilpaymentbilladmingui\";a:1:{i:0;s:17:\"ilpaymentadmingui\";}s:18:\"ilpaymentobjectgui\";a:1:{i:0;s:17:\"ilpaymentadmingui\";}s:21:\"ilpaymentstatisticgui\";a:1:{i:0;s:17:\"ilpaymentadmingui\";}s:19:\"ilpaymenttrusteegui\";a:1:{i:0;s:17:\"ilpaymentadmingui\";}s:24:\"ilpaymentbuyedobjectsgui\";a:1:{i:0;s:12:\"ilpaymentgui\";}s:24:\"ilpaymentshoppingcartgui\";a:1:{i:0;s:12:\"ilpaymentgui\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:12:\"ilpdnotesgui\";i:1;s:20:\"ilpersonaldesktopgui\";}s:9:\"ilnotegui\";a:1:{i:0;s:12:\"ilpdnotesgui\";}s:27:\"ilbookmarkadministrationgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:12:\"ilobjusergui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:17:\"ilpaymentadmingui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:12:\"ilpaymentgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:12:\"ilpdnotesgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:20:\"ilpersonalprofilegui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('illmpresentationgui','a:7:{i:1;a:2:{s:5:\"class\";s:19:\"illmpresentationgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2;}i:4;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2;}i:6;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1;}i:7;a:2:{s:5:\"class\";s:20:\"ilpaymentpurchasegui\";s:6:\"parent\";i:1;}}','a:4:{s:0:\"\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:13:\"ilfeedbackgui\";a:1:{i:0;s:0:\"\";}s:15:\"ilinfoscreengui\";a:2:{i:0;s:13:\"ilfeedbackgui\";i:1;s:9:\"ilnotegui\";}s:19:\"illmpresentationgui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:9:\"ilnotegui\";i:2;s:20:\"ilpaymentpurchasegui\";}}','a:5:{s:0:\"\";a:5:{i:0;s:0:\"\";i:1;s:13:\"ilfeedbackgui\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";}s:13:\"ilfeedbackgui\";a:1:{i:0;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:19:\"illmpresentationgui\";}s:15:\"ilinfoscreengui\";a:1:{i:0;s:19:\"illmpresentationgui\";}s:20:\"ilpaymentpurchasegui\";a:1:{i:0;s:19:\"illmpresentationgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('illmeditorgui','a:100:{i:1;a:2:{s:5:\"class\";s:13:\"illmeditorgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:13:\"ilmetadatagui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:4;}i:7;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:6;}i:8;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:6;}i:10;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:9;}i:11;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:6;}i:12;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:4;}i:14;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:13;}i:15;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:13;}i:17;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:16;}i:18;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:4;}i:19;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:18;}i:20;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:3;}i:21;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:20;}i:23;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:23;}i:25;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:24;}i:27;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:22;}i:28;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:22;}i:29;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:28;}i:31;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:30;}i:33;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:28;}i:34;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:28;}i:35;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:28;}i:36;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:28;}i:37;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:28;}i:38;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:28;}i:39;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:28;}i:40;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:28;}i:41;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:28;}i:42;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:28;}i:43;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:3;}i:44;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:3;}i:45;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:44;}i:46;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:3;}i:47;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:46;}i:48;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:47;}i:49;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:3;}i:50;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:49;}i:51;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:49;}i:52;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:53;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:52;}i:54;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:53;}i:55;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:53;}i:56;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:55;}i:57;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:55;}i:59;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:58;}i:60;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:55;}i:61;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:60;}i:62;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:53;}i:63;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:62;}i:64;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:62;}i:66;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:65;}i:67;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:53;}i:68;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:67;}i:69;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:52;}i:70;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:69;}i:71;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:69;}i:72;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:72;}i:74;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:73;}i:75;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:73;}i:76;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:71;}i:77;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:71;}i:78;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:77;}i:79;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:77;}i:80;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:79;}i:81;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:79;}i:82;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:77;}i:83;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:77;}i:84;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:77;}i:85;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:77;}i:86;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:77;}i:87;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:77;}i:88;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:77;}i:89;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:77;}i:90;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:77;}i:91;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:77;}i:92;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:52;}i:93;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:52;}i:94;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:93;}i:95;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:52;}i:96;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:95;}i:97;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:96;}i:98;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:52;}i:99;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:98;}i:100;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:98;}}','a:20:{s:0:\"\";a:59:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";}s:13:\"illpfiltergui\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:6:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:4:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:21:\"illearningprogressgui\";a:8:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";}s:19:\"ilobjmediaobjectgui\";a:8:{i:0;s:17:\"ilinternallinkgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:2:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";}s:15:\"ilpageeditorgui\";a:24:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpcfileitemgui\";i:3;s:15:\"ilpcfilelistgui\";i:4;s:11:\"ilpclistgui\";i:5;s:15:\"ilpclistitemgui\";i:6;s:18:\"ilpcmediaobjectgui\";i:7;s:16:\"ilpcparagraphgui\";i:8;s:15:\"ilpcquestiongui\";i:9;s:17:\"ilpcsourcecodegui\";i:10;s:16:\"ilpctabledatagui\";i:11;s:12:\"ilpctablegui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:15:\"ilpcfileitemgui\";i:15;s:15:\"ilpcfilelistgui\";i:16;s:11:\"ilpclistgui\";i:17;s:15:\"ilpclistitemgui\";i:18;s:18:\"ilpcmediaobjectgui\";i:19;s:16:\"ilpcparagraphgui\";i:20;s:15:\"ilpcquestiongui\";i:21;s:17:\"ilpcsourcecodegui\";i:22;s:16:\"ilpctabledatagui\";i:23;s:12:\"ilpctablegui\";}s:15:\"ilpageobjectgui\";a:6:{i:0;s:18:\"ileditclipboardgui\";i:1;s:25:\"ilmediapooltargetselector\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:25:\"ilmediapooltargetselector\";i:5;s:15:\"ilpageeditorgui\";}s:17:\"illmpageobjectgui\";a:4:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:12:\"ilobjrolegui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:15:\"ilpermissiongui\";a:2:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:22:\"ilobjlearningmodulegui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:13:\"illmeditorgui\";a:3:{i:0;s:13:\"ilmetadatagui\";i:1;s:14:\"ilobjdlbookgui\";i:2;s:22:\"ilobjlearningmodulegui\";}}','a:35:{s:0:\"\";a:75:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:13:\"illpfiltergui\";i:4;s:0:\"\";i:5;s:17:\"ilpdfpresentation\";i:6;s:0:\"\";i:7;s:15:\"iluserfiltergui\";i:8;s:0:\"\";i:9;s:13:\"illpfiltergui\";i:10;s:0:\"\";i:11;s:17:\"ilpdfpresentation\";i:12;s:0:\"\";i:13;s:21:\"illplistofsettingsgui\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:18:\"ilobjstylesheetgui\";i:34;s:0:\"\";i:35;s:12:\"ilobjrolegui\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:13:\"illpfiltergui\";i:41;s:0:\"\";i:42;s:17:\"ilpdfpresentation\";i:43;s:0:\"\";i:44;s:15:\"iluserfiltergui\";i:45;s:0:\"\";i:46;s:13:\"illpfiltergui\";i:47;s:0:\"\";i:48;s:17:\"ilpdfpresentation\";i:49;s:0:\"\";i:50;s:21:\"illplistofsettingsgui\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:18:\"ilobjstylesheetgui\";i:71;s:0:\"\";i:72;s:12:\"ilobjrolegui\";i:73;s:0:\"\";i:74;s:0:\"\";}s:13:\"illpfiltergui\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:17:\"ilinternallinkgui\";a:6:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";}s:13:\"ilmdeditorgui\";a:10:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:20:\"ilstructureobjectgui\";i:4;s:14:\"ilobjdlbookgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:17:\"illmpageobjectgui\";i:8;s:20:\"ilstructureobjectgui\";i:9;s:22:\"ilobjlearningmodulegui\";}s:19:\"ilobjmediaobjectgui\";a:4:{i:0;s:18:\"ileditclipboardgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:18:\"ileditclipboardgui\";i:3;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:25:\"ilmediapooltargetselector\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:15:\"ilpageeditorgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:15:\"ilpageobjectgui\";a:2:{i:0;s:17:\"illmpageobjectgui\";i:1;s:17:\"illmpageobjectgui\";}s:12:\"ilobjrolegui\";a:2:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";}s:27:\"ilconditionhandlerinterface\";a:2:{i:0;s:20:\"ilstructureobjectgui\";i:1;s:20:\"ilstructureobjectgui\";}s:21:\"illearningprogressgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:15:\"ilpermissiongui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:13:\"ilmetadatagui\";a:1:{i:0;s:13:\"illmeditorgui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:13:\"illmeditorgui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:13:\"illmeditorgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('iladministrationgui','a:745:{i:1;a:2:{s:5:\"class\";s:19:\"iladministrationgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:23:\"ilobjadvancededitinggui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:5;}i:7;a:2:{s:5:\"class\";s:24:\"ilobjassessmentfoldergui\";s:6:\"parent\";i:1;}i:8;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:9;}i:11;a:2:{s:5:\"class\";s:20:\"ilobjauthsettingsgui\";s:6:\"parent\";i:1;}i:12;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:12;}i:14;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:13;}i:15;a:2:{s:5:\"class\";s:25:\"ilregistrationsettingsgui\";s:6:\"parent\";i:11;}i:16;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:15;}i:17;a:2:{s:5:\"class\";s:16:\"ilobjcategorygui\";s:6:\"parent\";i:1;}i:18;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:17;}i:19;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:18;}i:20;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:17;}i:21;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:17;}i:25;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:25;}i:28;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:27;}i:29;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:27;}i:31;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:27;}i:33;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:32;}i:34;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:25;}i:35;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:34;}i:36;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:35;}i:37;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:34;}i:38;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:37;}i:39;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:25;}i:40;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:39;}i:41;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:24;}i:42;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:17;}i:43;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:42;}i:44;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:43;}i:45;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:44;}i:46;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:44;}i:47;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:42;}i:48;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:42;}i:49;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:48;}i:50;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:48;}i:51;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:50;}i:52;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:50;}i:53;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:48;}i:54;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:48;}i:55;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:48;}i:56;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:48;}i:57;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:48;}i:58;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:48;}i:59;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:48;}i:60;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:48;}i:61;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:48;}i:62;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:48;}i:63;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:17;}i:64;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:64;}i:66;a:2:{s:5:\"class\";s:12:\"ilobjchatgui\";s:6:\"parent\";i:1;}i:67;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:66;}i:68;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:67;}i:69;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:68;}i:70;a:2:{s:5:\"class\";s:18:\"ilobjchatservergui\";s:6:\"parent\";i:1;}i:71;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:70;}i:72;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:72;}i:74;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:1;}i:75;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:74;}i:76;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:74;}i:77;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:76;}i:78;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:76;}i:79;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:78;}i:80;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:76;}i:81;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:76;}i:82;a:2:{s:5:\"class\";s:24:\"ilcoursecontentinterface\";s:6:\"parent\";i:74;}i:83;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:82;}i:84;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:82;}i:85;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:84;}i:86;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:74;}i:87;a:2:{s:5:\"class\";s:19:\"ilcourseregistergui\";s:6:\"parent\";i:74;}i:88;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:74;}i:89;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:88;}i:90;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:89;}i:91;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:88;}i:92;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:74;}i:93;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:92;}i:94;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:92;}i:95;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:94;}i:96;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:95;}i:97;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:94;}i:98;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:97;}i:99;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:94;}i:100;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:99;}i:101;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:92;}i:102;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:101;}i:103;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:102;}i:104;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:101;}i:105;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:104;}i:106;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:92;}i:107;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:106;}i:108;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:74;}i:109;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:74;}i:110;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:74;}i:111;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:110;}i:112;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:111;}i:113;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:111;}i:114;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:113;}i:115;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:114;}i:116;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:113;}i:117;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:116;}i:118;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:113;}i:119;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:118;}i:120;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:111;}i:121;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:120;}i:122;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:121;}i:123;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:120;}i:124;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:123;}i:125;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:111;}i:126;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:125;}i:127;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:110;}i:128;a:2:{s:5:\"class\";s:20:\"ilpaymentpurchasegui\";s:6:\"parent\";i:74;}i:129;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:74;}i:130;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:129;}i:131;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:130;}i:132;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:74;}i:133;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:134;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:133;}i:135;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:134;}i:136;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:134;}i:137;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:136;}i:138;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:137;}i:139;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:136;}i:140;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:139;}i:141;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:136;}i:142;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:141;}i:143;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:134;}i:144;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:143;}i:145;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:144;}i:146;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:143;}i:147;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:146;}i:148;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:134;}i:149;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:148;}i:150;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:133;}i:151;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:150;}i:152;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:150;}i:153;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:152;}i:154;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:153;}i:155;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:154;}i:156;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:154;}i:157;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:152;}i:158;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:152;}i:159;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:158;}i:160;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:158;}i:161;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:160;}i:162;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:160;}i:163;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:158;}i:164;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:158;}i:165;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:158;}i:166;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:158;}i:167;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:158;}i:168;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:158;}i:169;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:158;}i:170;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:158;}i:171;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:158;}i:172;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:158;}i:173;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:133;}i:174;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:133;}i:175;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:174;}i:176;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:133;}i:177;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:176;}i:178;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:177;}i:179;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:133;}i:180;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:179;}i:181;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:179;}i:182;a:2:{s:5:\"class\";s:16:\"ilobjexercisegui\";s:6:\"parent\";i:1;}i:183;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:182;}i:184;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:183;}i:185;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:184;}i:186;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:183;}i:187;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:182;}i:188;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:187;}i:189;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:187;}i:190;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:189;}i:191;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:190;}i:192;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:189;}i:193;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:192;}i:194;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:189;}i:195;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:194;}i:196;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:187;}i:197;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:196;}i:198;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:197;}i:199;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:196;}i:200;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:199;}i:201;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:187;}i:202;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:201;}i:203;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:182;}i:204;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:203;}i:205;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:204;}i:206;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:182;}i:207;a:2:{s:5:\"class\";s:29:\"ilobjexternaltoolssettingsgui\";s:6:\"parent\";i:1;}i:208;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:207;}i:209;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:208;}i:210;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:209;}i:211;a:2:{s:5:\"class\";s:19:\"ilobjfilebasedlmgui\";s:6:\"parent\";i:1;}i:212;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:211;}i:213;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:211;}i:214;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:213;}i:215;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:214;}i:216;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:213;}i:217;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:211;}i:218;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:217;}i:219;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:217;}i:220;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:219;}i:221;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:220;}i:222;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:219;}i:223;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:222;}i:224;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:219;}i:225;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:224;}i:226;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:217;}i:227;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:226;}i:228;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:227;}i:229;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:226;}i:230;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:229;}i:231;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:217;}i:232;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:231;}i:233;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:211;}i:234;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:211;}i:235;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:234;}i:236;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:235;}i:237;a:2:{s:5:\"class\";s:12:\"ilobjfilegui\";s:6:\"parent\";i:1;}i:238;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:237;}i:239;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:238;}i:240;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:239;}i:241;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:238;}i:242;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:237;}i:243;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:237;}i:244;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:243;}i:245;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:244;}i:246;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1;}i:247;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:246;}i:248;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:246;}i:249;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:248;}i:250;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:248;}i:251;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:250;}i:252;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:248;}i:253;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:248;}i:254;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:246;}i:255;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:254;}i:256;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:254;}i:257;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:256;}i:258;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:257;}i:259;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:256;}i:260;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:259;}i:261;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:256;}i:262;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:261;}i:263;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:254;}i:264;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:263;}i:265;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:264;}i:266;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:263;}i:267;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:266;}i:268;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:254;}i:269;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:268;}i:270;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:246;}i:271;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:270;}i:272;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:271;}i:273;a:2:{s:5:\"class\";s:13:\"ilobjforumgui\";s:6:\"parent\";i:1;}i:274;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:273;}i:275;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:274;}i:276;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:275;}i:277;a:2:{s:5:\"class\";s:16:\"ilobjglossarygui\";s:6:\"parent\";i:1;}i:278;a:2:{s:5:\"class\";s:17:\"ilglossarytermgui\";s:6:\"parent\";i:277;}i:279;a:2:{s:5:\"class\";s:25:\"iltermdefinitioneditorgui\";s:6:\"parent\";i:278;}i:280;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:279;}i:281;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:279;}i:282;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:281;}i:283;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:282;}i:284;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:283;}i:285;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:283;}i:286;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:281;}i:287;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:281;}i:288;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:287;}i:289;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:287;}i:290;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:289;}i:291;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:289;}i:292;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:287;}i:293;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:287;}i:294;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:287;}i:295;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:287;}i:296;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:287;}i:297;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:287;}i:298;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:287;}i:299;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:287;}i:300;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:287;}i:301;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:287;}i:302;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:277;}i:303;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:277;}i:304;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:303;}i:305;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:304;}i:306;a:2:{s:5:\"class\";s:13:\"ilobjgroupgui\";s:6:\"parent\";i:1;}i:307;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:306;}i:308;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:306;}i:309;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:306;}i:310;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:309;}i:311;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:309;}i:312;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:311;}i:313;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:309;}i:314;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:309;}i:315;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:306;}i:316;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:315;}i:317;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:316;}i:318;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:315;}i:319;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:306;}i:320;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:319;}i:321;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:319;}i:322;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:321;}i:323;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:322;}i:324;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:321;}i:325;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:324;}i:326;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:321;}i:327;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:326;}i:328;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:319;}i:329;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:328;}i:330;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:329;}i:331;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:328;}i:332;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:331;}i:333;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:319;}i:334;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:333;}i:335;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:306;}i:336;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:306;}i:337;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:336;}i:338;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:337;}i:339;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:337;}i:340;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:339;}i:341;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:340;}i:342;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:339;}i:343;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:342;}i:344;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:339;}i:345;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:344;}i:346;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:337;}i:347;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:346;}i:348;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:347;}i:349;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:346;}i:350;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:349;}i:351;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:337;}i:352;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:351;}i:353;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:336;}i:354;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:306;}i:355;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:354;}i:356;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:355;}i:357;a:2:{s:5:\"class\";s:13:\"ilregistergui\";s:6:\"parent\";i:306;}i:358;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:306;}i:359;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1;}i:360;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:359;}i:361;a:2:{s:5:\"class\";s:19:\"ilobjilinccoursegui\";s:6:\"parent\";i:1;}i:362;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:361;}i:363;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:362;}i:364;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:363;}i:365;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:362;}i:366;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:361;}i:367;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:366;}i:368;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:361;}i:369;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:368;}i:370;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:369;}i:371;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:369;}i:372;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:371;}i:373;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:372;}i:374;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:371;}i:375;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:374;}i:376;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:371;}i:377;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:376;}i:378;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:369;}i:379;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:378;}i:380;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:379;}i:381;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:378;}i:382;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:381;}i:383;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:369;}i:384;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:383;}i:385;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:368;}i:386;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:361;}i:387;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:386;}i:388;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:387;}i:389;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:361;}i:390;a:2:{s:5:\"class\";s:22:\"ilobjlanguagefoldergui\";s:6:\"parent\";i:1;}i:391;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:390;}i:392;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:391;}i:393;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:392;}i:394;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:395;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:394;}i:396;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:395;}i:397;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:395;}i:398;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:397;}i:399;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:398;}i:400;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:397;}i:401;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:400;}i:402;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:397;}i:403;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:402;}i:404;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:395;}i:405;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:404;}i:406;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:405;}i:407;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:404;}i:408;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:407;}i:409;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:395;}i:410;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:409;}i:411;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:394;}i:412;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:411;}i:413;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:411;}i:414;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:413;}i:415;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:414;}i:416;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:415;}i:417;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:415;}i:418;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:413;}i:419;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:413;}i:420;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:419;}i:421;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:419;}i:422;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:421;}i:423;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:421;}i:424;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:419;}i:425;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:419;}i:426;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:419;}i:427;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:419;}i:428;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:419;}i:429;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:419;}i:430;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:419;}i:431;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:419;}i:432;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:419;}i:433;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:419;}i:434;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:394;}i:435;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:394;}i:436;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:435;}i:437;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:394;}i:438;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:437;}i:439;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:438;}i:440;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:394;}i:441;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:440;}i:442;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:440;}i:443;a:2:{s:5:\"class\";s:20:\"ilobjlinkresourcegui\";s:6:\"parent\";i:1;}i:444;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:443;}i:445;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:444;}i:446;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:445;}i:447;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:444;}i:448;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:443;}i:449;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:443;}i:450;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:449;}i:451;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:450;}i:452;a:2:{s:5:\"class\";s:12:\"ilobjmailgui\";s:6:\"parent\";i:1;}i:453;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:452;}i:454;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:453;}i:455;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:454;}i:456;a:2:{s:5:\"class\";s:17:\"ilobjmediapoolgui\";s:6:\"parent\";i:1;}i:457;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:456;}i:458;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:457;}i:459;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:458;}i:460;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:458;}i:461;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:456;}i:462;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:461;}i:463;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:461;}i:464;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:463;}i:465;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:463;}i:466;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:465;}i:467;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:463;}i:468;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:463;}i:469;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:461;}i:470;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:469;}i:471;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:469;}i:472;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:471;}i:473;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:472;}i:474;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:471;}i:475;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:474;}i:476;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:471;}i:477;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:476;}i:478;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:469;}i:479;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:478;}i:480;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:479;}i:481;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:478;}i:482;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:481;}i:483;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:469;}i:484;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:483;}i:485;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:461;}i:486;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:485;}i:487;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:486;}i:488;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:456;}i:489;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:488;}i:490;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:488;}i:491;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:456;}i:492;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:491;}i:493;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:492;}i:494;a:2:{s:5:\"class\";s:20:\"ilobjobjectfoldergui\";s:6:\"parent\";i:1;}i:495;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:494;}i:496;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:495;}i:497;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:496;}i:498;a:2:{s:5:\"class\";s:23:\"ilobjpaymentsettingsgui\";s:6:\"parent\";i:1;}i:499;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:498;}i:500;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:499;}i:501;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:500;}i:502;a:2:{s:5:\"class\";s:20:\"ilobjquestionpoolgui\";s:6:\"parent\";i:1;}i:503;a:2:{s:5:\"class\";s:15:\"assclozetestgui\";s:6:\"parent\";i:502;}i:504;a:2:{s:5:\"class\";s:22:\"assimagemapquestiongui\";s:6:\"parent\";i:502;}i:505;a:2:{s:5:\"class\";s:16:\"assjavaappletgui\";s:6:\"parent\";i:502;}i:506;a:2:{s:5:\"class\";s:22:\"assmatchingquestiongui\";s:6:\"parent\";i:502;}i:507;a:2:{s:5:\"class\";s:20:\"assmultiplechoicegui\";s:6:\"parent\";i:502;}i:508;a:2:{s:5:\"class\";s:13:\"assnumericgui\";s:6:\"parent\";i:502;}i:509;a:2:{s:5:\"class\";s:22:\"assorderingquestiongui\";s:6:\"parent\";i:502;}i:510;a:2:{s:5:\"class\";s:18:\"asssinglechoicegui\";s:6:\"parent\";i:502;}i:511;a:2:{s:5:\"class\";s:18:\"asstextquestiongui\";s:6:\"parent\";i:502;}i:512;a:2:{s:5:\"class\";s:16:\"asstextsubsetgui\";s:6:\"parent\";i:502;}i:513;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:502;}i:514;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:502;}i:515;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:514;}i:516;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:515;}i:517;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:516;}i:518;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:516;}i:519;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:514;}i:520;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:514;}i:521;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:520;}i:522;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:520;}i:523;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:522;}i:524;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:522;}i:525;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:520;}i:526;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:520;}i:527;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:520;}i:528;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:520;}i:529;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:520;}i:530;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:520;}i:531;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:520;}i:532;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:520;}i:533;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:520;}i:534;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:520;}i:535;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:502;}i:536;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:535;}i:537;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:536;}i:538;a:2:{s:5:\"class\";s:22:\"ilobjrecoveryfoldergui\";s:6:\"parent\";i:1;}i:539;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:538;}i:540;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:539;}i:541;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:540;}i:542;a:2:{s:5:\"class\";s:18:\"ilobjrolefoldergui\";s:6:\"parent\";i:1;}i:543;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:542;}i:544;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:543;}i:545;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:544;}i:546;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1;}i:547;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:546;}i:548;a:2:{s:5:\"class\";s:20:\"ilobjroletemplategui\";s:6:\"parent\";i:1;}i:549;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:548;}i:550;a:2:{s:5:\"class\";s:18:\"ilobjrootfoldergui\";s:6:\"parent\";i:1;}i:551;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:550;}i:552;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:551;}i:553;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:550;}i:554;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:553;}i:555;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:554;}i:556;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:555;}i:557;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:555;}i:558;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:553;}i:559;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:553;}i:560;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:559;}i:561;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:559;}i:562;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:561;}i:563;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:561;}i:564;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:559;}i:565;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:559;}i:566;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:559;}i:567;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:559;}i:568;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:559;}i:569;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:559;}i:570;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:559;}i:571;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:559;}i:572;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:559;}i:573;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:559;}i:574;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:550;}i:575;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:574;}i:576;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:575;}i:577;a:2:{s:5:\"class\";s:26:\"ilobjsahslearningmodulegui\";s:6:\"parent\";i:1;}i:578;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:577;}i:579;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:577;}i:580;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:577;}i:581;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:580;}i:582;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:581;}i:583;a:2:{s:5:\"class\";s:22:\"ilobjsearchsettingsgui\";s:6:\"parent\";i:1;}i:584;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:583;}i:585;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:584;}i:586;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:585;}i:587;a:2:{s:5:\"class\";s:21:\"ilobjstylesettingsgui\";s:6:\"parent\";i:1;}i:588;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:587;}i:589;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:588;}i:590;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:589;}i:591;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:1;}i:592;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:591;}i:593;a:2:{s:5:\"class\";s:14:\"ilobjsurveygui\";s:6:\"parent\";i:1;}i:594;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:593;}i:595;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:594;}i:596;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:595;}i:597;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:594;}i:598;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:593;}i:599;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:593;}i:600;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:599;}i:601;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:600;}i:602;a:2:{s:5:\"class\";s:21:\"ilsurveyevaluationgui\";s:6:\"parent\";i:593;}i:603;a:2:{s:5:\"class\";s:20:\"ilsurveyexecutiongui\";s:6:\"parent\";i:593;}i:604;a:2:{s:5:\"class\";s:26:\"ilobjsurveyquestionpoolgui\";s:6:\"parent\";i:1;}i:605;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:604;}i:606;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:604;}i:607;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:606;}i:608;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:607;}i:609;a:2:{s:5:\"class\";s:23:\"surveymetricquestiongui\";s:6:\"parent\";i:604;}i:610;a:2:{s:5:\"class\";s:24:\"surveynominalquestiongui\";s:6:\"parent\";i:604;}i:611;a:2:{s:5:\"class\";s:24:\"surveyordinalquestiongui\";s:6:\"parent\";i:604;}i:612;a:2:{s:5:\"class\";s:21:\"surveytextquestiongui\";s:6:\"parent\";i:604;}i:613;a:2:{s:5:\"class\";s:20:\"ilobjsystemfoldergui\";s:6:\"parent\";i:1;}i:614;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:613;}i:615;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:614;}i:616;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:615;}i:617;a:2:{s:5:\"class\";s:22:\"ilobjtaxonomyfoldergui\";s:6:\"parent\";i:1;}i:618;a:2:{s:5:\"class\";s:12:\"ilobjtestgui\";s:6:\"parent\";i:1;}i:619;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:618;}i:620;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:619;}i:621;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:620;}i:622;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:619;}i:623;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:618;}i:624;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:623;}i:625;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:623;}i:626;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:625;}i:627;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:626;}i:628;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:625;}i:629;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:628;}i:630;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:625;}i:631;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:630;}i:632;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:623;}i:633;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:632;}i:634;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:633;}i:635;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:632;}i:636;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:635;}i:637;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:623;}i:638;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:637;}i:639;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:618;}i:640;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:618;}i:641;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:640;}i:642;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:640;}i:643;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:642;}i:644;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:642;}i:645;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:644;}i:646;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:642;}i:647;a:2:{s:5:\"class\";s:24:\"ileventadministrationgui\";s:6:\"parent\";i:642;}i:648;a:2:{s:5:\"class\";s:24:\"ilcoursecontentinterface\";s:6:\"parent\";i:640;}i:649;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:648;}i:650;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:648;}i:651;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:650;}i:652;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:640;}i:653;a:2:{s:5:\"class\";s:19:\"ilcourseregistergui\";s:6:\"parent\";i:640;}i:654;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:640;}i:655;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:654;}i:656;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:655;}i:657;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:654;}i:658;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:640;}i:659;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:658;}i:660;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:658;}i:661;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:660;}i:662;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:661;}i:663;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:660;}i:664;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:663;}i:665;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:660;}i:666;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:665;}i:667;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:658;}i:668;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:667;}i:669;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:668;}i:670;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:667;}i:671;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:670;}i:672;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:658;}i:673;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:672;}i:674;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:640;}i:675;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:640;}i:676;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:640;}i:677;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:676;}i:678;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:677;}i:679;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:677;}i:680;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:679;}i:681;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:680;}i:682;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:679;}i:683;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:682;}i:684;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:679;}i:685;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:684;}i:686;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:677;}i:687;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:686;}i:688;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:687;}i:689;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:686;}i:690;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:689;}i:691;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:677;}i:692;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:691;}i:693;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:676;}i:694;a:2:{s:5:\"class\";s:20:\"ilpaymentpurchasegui\";s:6:\"parent\";i:640;}i:695;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:640;}i:696;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:695;}i:697;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:696;}i:698;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:640;}i:699;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:618;}i:700;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:699;}i:701;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:700;}i:702;a:2:{s:5:\"class\";s:19:\"iltestevaluationgui\";s:6:\"parent\";i:618;}i:703;a:2:{s:5:\"class\";s:15:\"iltestoutputgui\";s:6:\"parent\";i:618;}i:704;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:1;}i:705;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:704;}i:706;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:705;}i:707;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:706;}i:708;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:1;}i:709;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:708;}i:710;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:709;}i:711;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:709;}i:712;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:711;}i:713;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:712;}i:714;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:711;}i:715;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:714;}i:716;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:711;}i:717;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:716;}i:718;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:709;}i:719;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:718;}i:720;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:719;}i:721;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:718;}i:722;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:721;}i:723;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:709;}i:724;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:723;}i:725;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:708;}i:726;a:2:{s:5:\"class\";s:20:\"ilobjusertrackinggui\";s:6:\"parent\";i:1;}i:727;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:726;}i:728;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:727;}i:729;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:727;}i:730;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:729;}i:731;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:730;}i:732;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:729;}i:733;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:732;}i:734;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:729;}i:735;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:734;}i:736;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:727;}i:737;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:736;}i:738;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:737;}i:739;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:736;}i:740;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:739;}i:741;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:727;}i:742;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:741;}i:743;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:726;}i:744;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:743;}i:745;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:744;}}','a:67:{s:0:\"\";a:382:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:0:\"\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:0:\"\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:0:\"\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:0:\"\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:0:\"\";i:187;s:0:\"\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:0:\"\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:0:\"\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:0:\"\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:0:\"\";i:277;s:0:\"\";i:278;s:0:\"\";i:279;s:0:\"\";i:280;s:0:\"\";i:281;s:0:\"\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:0:\"\";i:285;s:0:\"\";i:286;s:0:\"\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:0:\"\";i:372;s:0:\"\";i:373;s:0:\"\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";}s:12:\"ilobjrolegui\";a:41:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";}s:15:\"ilpermissiongui\";a:40:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";i:2;s:12:\"ilobjrolegui\";i:3;s:12:\"ilobjrolegui\";i:4;s:12:\"ilobjrolegui\";i:5;s:12:\"ilobjrolegui\";i:6;s:12:\"ilobjrolegui\";i:7;s:12:\"ilobjrolegui\";i:8;s:12:\"ilobjrolegui\";i:9;s:12:\"ilobjrolegui\";i:10;s:12:\"ilobjrolegui\";i:11;s:12:\"ilobjrolegui\";i:12;s:12:\"ilobjrolegui\";i:13;s:12:\"ilobjrolegui\";i:14;s:12:\"ilobjrolegui\";i:15;s:12:\"ilobjrolegui\";i:16;s:12:\"ilobjrolegui\";i:17;s:12:\"ilobjrolegui\";i:18;s:12:\"ilobjrolegui\";i:19;s:12:\"ilobjrolegui\";i:20;s:12:\"ilobjrolegui\";i:21;s:12:\"ilobjrolegui\";i:22;s:12:\"ilobjrolegui\";i:23;s:12:\"ilobjrolegui\";i:24;s:12:\"ilobjrolegui\";i:25;s:12:\"ilobjrolegui\";i:26;s:12:\"ilobjrolegui\";i:27;s:12:\"ilobjrolegui\";i:28;s:12:\"ilobjrolegui\";i:29;s:12:\"ilobjrolegui\";i:30;s:12:\"ilobjrolegui\";i:31;s:12:\"ilobjrolegui\";i:32;s:12:\"ilobjrolegui\";i:33;s:12:\"ilobjrolegui\";i:34;s:12:\"ilobjrolegui\";i:35;s:12:\"ilobjrolegui\";i:36;s:12:\"ilobjrolegui\";i:37;s:12:\"ilobjrolegui\";i:38;s:12:\"ilobjrolegui\";i:39;s:12:\"ilobjrolegui\";}s:23:\"ilobjadvancededitinggui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:24:\"ilobjassessmentfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:25:\"ilregistrationsettingsgui\";a:1:{i:0;s:0:\"\";}s:20:\"ilobjauthsettingsgui\";a:2:{i:0;s:15:\"ilpermissiongui\";i:1;s:25:\"ilregistrationsettingsgui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:18:\"ilobjuserfoldergui\";a:2:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";}s:13:\"illpfiltergui\";a:34:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";}s:17:\"ilpdfpresentation\";a:34:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";}s:15:\"iluserfiltergui\";a:17:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:51:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:15:\"iluserfiltergui\";i:9;s:13:\"illpfiltergui\";i:10;s:17:\"ilpdfpresentation\";i:11;s:15:\"iluserfiltergui\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:15:\"iluserfiltergui\";i:15;s:13:\"illpfiltergui\";i:16;s:17:\"ilpdfpresentation\";i:17;s:15:\"iluserfiltergui\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:15:\"iluserfiltergui\";i:21;s:13:\"illpfiltergui\";i:22;s:17:\"ilpdfpresentation\";i:23;s:15:\"iluserfiltergui\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:15:\"iluserfiltergui\";i:27;s:13:\"illpfiltergui\";i:28;s:17:\"ilpdfpresentation\";i:29;s:15:\"iluserfiltergui\";i:30;s:13:\"illpfiltergui\";i:31;s:17:\"ilpdfpresentation\";i:32;s:15:\"iluserfiltergui\";i:33;s:13:\"illpfiltergui\";i:34;s:17:\"ilpdfpresentation\";i:35;s:15:\"iluserfiltergui\";i:36;s:13:\"illpfiltergui\";i:37;s:17:\"ilpdfpresentation\";i:38;s:15:\"iluserfiltergui\";i:39;s:13:\"illpfiltergui\";i:40;s:17:\"ilpdfpresentation\";i:41;s:15:\"iluserfiltergui\";i:42;s:13:\"illpfiltergui\";i:43;s:17:\"ilpdfpresentation\";i:44;s:15:\"iluserfiltergui\";i:45;s:13:\"illpfiltergui\";i:46;s:17:\"ilpdfpresentation\";i:47;s:15:\"iluserfiltergui\";i:48;s:13:\"illpfiltergui\";i:49;s:17:\"ilpdfpresentation\";i:50;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:34:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";i:4;s:13:\"illpfiltergui\";i:5;s:17:\"ilpdfpresentation\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:13:\"illpfiltergui\";i:9;s:17:\"ilpdfpresentation\";i:10;s:13:\"illpfiltergui\";i:11;s:17:\"ilpdfpresentation\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:13:\"illpfiltergui\";i:15;s:17:\"ilpdfpresentation\";i:16;s:13:\"illpfiltergui\";i:17;s:17:\"ilpdfpresentation\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:13:\"illpfiltergui\";i:21;s:17:\"ilpdfpresentation\";i:22;s:13:\"illpfiltergui\";i:23;s:17:\"ilpdfpresentation\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:13:\"illpfiltergui\";i:27;s:17:\"ilpdfpresentation\";i:28;s:13:\"illpfiltergui\";i:29;s:17:\"ilpdfpresentation\";i:30;s:13:\"illpfiltergui\";i:31;s:17:\"ilpdfpresentation\";i:32;s:13:\"illpfiltergui\";i:33;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:17:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";}s:21:\"illearningprogressgui\";a:68:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";i:8;s:17:\"illmstatisticsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:21:\"illplistofprogressgui\";i:11;s:21:\"illplistofsettingsgui\";i:12;s:17:\"illmstatisticsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:21:\"illplistofprogressgui\";i:15;s:21:\"illplistofsettingsgui\";i:16;s:17:\"illmstatisticsgui\";i:17;s:20:\"illplistofobjectsgui\";i:18;s:21:\"illplistofprogressgui\";i:19;s:21:\"illplistofsettingsgui\";i:20;s:17:\"illmstatisticsgui\";i:21;s:20:\"illplistofobjectsgui\";i:22;s:21:\"illplistofprogressgui\";i:23;s:21:\"illplistofsettingsgui\";i:24;s:17:\"illmstatisticsgui\";i:25;s:20:\"illplistofobjectsgui\";i:26;s:21:\"illplistofprogressgui\";i:27;s:21:\"illplistofsettingsgui\";i:28;s:17:\"illmstatisticsgui\";i:29;s:20:\"illplistofobjectsgui\";i:30;s:21:\"illplistofprogressgui\";i:31;s:21:\"illplistofsettingsgui\";i:32;s:17:\"illmstatisticsgui\";i:33;s:20:\"illplistofobjectsgui\";i:34;s:21:\"illplistofprogressgui\";i:35;s:21:\"illplistofsettingsgui\";i:36;s:17:\"illmstatisticsgui\";i:37;s:20:\"illplistofobjectsgui\";i:38;s:21:\"illplistofprogressgui\";i:39;s:21:\"illplistofsettingsgui\";i:40;s:17:\"illmstatisticsgui\";i:41;s:20:\"illplistofobjectsgui\";i:42;s:21:\"illplistofprogressgui\";i:43;s:21:\"illplistofsettingsgui\";i:44;s:17:\"illmstatisticsgui\";i:45;s:20:\"illplistofobjectsgui\";i:46;s:21:\"illplistofprogressgui\";i:47;s:21:\"illplistofsettingsgui\";i:48;s:17:\"illmstatisticsgui\";i:49;s:20:\"illplistofobjectsgui\";i:50;s:21:\"illplistofprogressgui\";i:51;s:21:\"illplistofsettingsgui\";i:52;s:17:\"illmstatisticsgui\";i:53;s:20:\"illplistofobjectsgui\";i:54;s:21:\"illplistofprogressgui\";i:55;s:21:\"illplistofsettingsgui\";i:56;s:17:\"illmstatisticsgui\";i:57;s:20:\"illplistofobjectsgui\";i:58;s:21:\"illplistofprogressgui\";i:59;s:21:\"illplistofsettingsgui\";i:60;s:17:\"illmstatisticsgui\";i:61;s:20:\"illplistofobjectsgui\";i:62;s:21:\"illplistofprogressgui\";i:63;s:21:\"illplistofsettingsgui\";i:64;s:17:\"illmstatisticsgui\";i:65;s:20:\"illplistofobjectsgui\";i:66;s:21:\"illplistofprogressgui\";i:67;s:21:\"illplistofsettingsgui\";}s:12:\"ilobjusergui\";a:12:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";i:2;s:21:\"illearningprogressgui\";i:3;s:17:\"ilobjilincusergui\";i:4;s:21:\"illearningprogressgui\";i:5;s:17:\"ilobjilincusergui\";i:6;s:21:\"illearningprogressgui\";i:7;s:17:\"ilobjilincusergui\";i:8;s:21:\"illearningprogressgui\";i:9;s:17:\"ilobjilincusergui\";i:10;s:21:\"illearningprogressgui\";i:11;s:17:\"ilobjilincusergui\";}s:19:\"ilobjmediaobjectgui\";a:28:{i:0;s:17:\"ilinternallinkgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:13:\"ilmdeditorgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:13:\"ilmdeditorgui\";i:20;s:17:\"ilinternallinkgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:17:\"ilinternallinkgui\";i:23;s:13:\"ilmdeditorgui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:17:\"ilinternallinkgui\";i:27;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:7:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";}s:15:\"ilpageeditorgui\";a:72:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpcfileitemgui\";i:3;s:15:\"ilpcfilelistgui\";i:4;s:11:\"ilpclistgui\";i:5;s:15:\"ilpclistitemgui\";i:6;s:18:\"ilpcmediaobjectgui\";i:7;s:16:\"ilpcparagraphgui\";i:8;s:15:\"ilpcquestiongui\";i:9;s:17:\"ilpcsourcecodegui\";i:10;s:16:\"ilpctabledatagui\";i:11;s:12:\"ilpctablegui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:15:\"ilpcfileitemgui\";i:15;s:15:\"ilpcfilelistgui\";i:16;s:11:\"ilpclistgui\";i:17;s:15:\"ilpclistitemgui\";i:18;s:18:\"ilpcmediaobjectgui\";i:19;s:16:\"ilpcparagraphgui\";i:20;s:15:\"ilpcquestiongui\";i:21;s:17:\"ilpcsourcecodegui\";i:22;s:16:\"ilpctabledatagui\";i:23;s:12:\"ilpctablegui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:15:\"ilpcfileitemgui\";i:27;s:15:\"ilpcfilelistgui\";i:28;s:11:\"ilpclistgui\";i:29;s:15:\"ilpclistitemgui\";i:30;s:18:\"ilpcmediaobjectgui\";i:31;s:16:\"ilpcparagraphgui\";i:32;s:15:\"ilpcquestiongui\";i:33;s:17:\"ilpcsourcecodegui\";i:34;s:16:\"ilpctabledatagui\";i:35;s:12:\"ilpctablegui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:15:\"ilpcfileitemgui\";i:39;s:15:\"ilpcfilelistgui\";i:40;s:11:\"ilpclistgui\";i:41;s:15:\"ilpclistitemgui\";i:42;s:18:\"ilpcmediaobjectgui\";i:43;s:16:\"ilpcparagraphgui\";i:44;s:15:\"ilpcquestiongui\";i:45;s:17:\"ilpcsourcecodegui\";i:46;s:16:\"ilpctabledatagui\";i:47;s:12:\"ilpctablegui\";i:48;s:17:\"ilinternallinkgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:15:\"ilpcfileitemgui\";i:51;s:15:\"ilpcfilelistgui\";i:52;s:11:\"ilpclistgui\";i:53;s:15:\"ilpclistitemgui\";i:54;s:18:\"ilpcmediaobjectgui\";i:55;s:16:\"ilpcparagraphgui\";i:56;s:15:\"ilpcquestiongui\";i:57;s:17:\"ilpcsourcecodegui\";i:58;s:16:\"ilpctabledatagui\";i:59;s:12:\"ilpctablegui\";i:60;s:17:\"ilinternallinkgui\";i:61;s:19:\"ilobjmediaobjectgui\";i:62;s:15:\"ilpcfileitemgui\";i:63;s:15:\"ilpcfilelistgui\";i:64;s:11:\"ilpclistgui\";i:65;s:15:\"ilpclistitemgui\";i:66;s:18:\"ilpcmediaobjectgui\";i:67;s:16:\"ilpcparagraphgui\";i:68;s:15:\"ilpcquestiongui\";i:69;s:17:\"ilpcsourcecodegui\";i:70;s:16:\"ilpctabledatagui\";i:71;s:12:\"ilpctablegui\";}s:15:\"ilpageobjectgui\";a:18:{i:0;s:18:\"ileditclipboardgui\";i:1;s:25:\"ilmediapooltargetselector\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:25:\"ilmediapooltargetselector\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:25:\"ilmediapooltargetselector\";i:8;s:15:\"ilpageeditorgui\";i:9;s:18:\"ileditclipboardgui\";i:10;s:25:\"ilmediapooltargetselector\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:25:\"ilmediapooltargetselector\";i:14;s:15:\"ilpageeditorgui\";i:15;s:18:\"ileditclipboardgui\";i:16;s:25:\"ilmediapooltargetselector\";i:17;s:15:\"ilpageeditorgui\";}s:16:\"ilobjcategorygui\";a:5:{i:0;s:22:\"ilcontainerlinklistgui\";i:1;s:18:\"ilobjuserfoldergui\";i:2;s:12:\"ilobjusergui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpermissiongui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:18:\"ilobjchatservergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:29:\"ilcourseitemadministrationgui\";a:7:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:27:\"ilconditionhandlerinterface\";i:4;s:27:\"ilconditionhandlerinterface\";i:5;s:27:\"ilconditionhandlerinterface\";i:6;s:27:\"ilconditionhandlerinterface\";}s:18:\"ilcoursecontentgui\";a:20:{i:0;s:19:\"ilcoursearchivesgui\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:32:\"ilcourseobjectivepresentationgui\";i:3;s:24:\"ileventadministrationgui\";i:4;s:19:\"ilcoursearchivesgui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:32:\"ilcourseobjectivepresentationgui\";i:7;s:24:\"ileventadministrationgui\";i:8;s:19:\"ilcoursearchivesgui\";i:9;s:29:\"ilcourseitemadministrationgui\";i:10;s:32:\"ilcourseobjectivepresentationgui\";i:11;s:24:\"ileventadministrationgui\";i:12;s:19:\"ilcoursearchivesgui\";i:13;s:29:\"ilcourseitemadministrationgui\";i:14;s:32:\"ilcourseobjectivepresentationgui\";i:15;s:24:\"ileventadministrationgui\";i:16;s:19:\"ilcoursearchivesgui\";i:17;s:29:\"ilcourseitemadministrationgui\";i:18;s:32:\"ilcourseobjectivepresentationgui\";i:19;s:24:\"ileventadministrationgui\";}s:24:\"ilcoursecontentinterface\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:29:\"ilcourseitemadministrationgui\";}s:13:\"ilfeedbackgui\";a:10:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";}s:15:\"ilinfoscreengui\";a:20:{i:0;s:13:\"ilfeedbackgui\";i:1;s:9:\"ilnotegui\";i:2;s:13:\"ilfeedbackgui\";i:3;s:9:\"ilnotegui\";i:4;s:13:\"ilfeedbackgui\";i:5;s:9:\"ilnotegui\";i:6;s:13:\"ilfeedbackgui\";i:7;s:9:\"ilnotegui\";i:8;s:13:\"ilfeedbackgui\";i:9;s:9:\"ilnotegui\";i:10;s:13:\"ilfeedbackgui\";i:11;s:9:\"ilnotegui\";i:12;s:13:\"ilfeedbackgui\";i:13;s:9:\"ilnotegui\";i:14;s:13:\"ilfeedbackgui\";i:15;s:9:\"ilnotegui\";i:16;s:13:\"ilfeedbackgui\";i:17;s:9:\"ilnotegui\";i:18;s:13:\"ilfeedbackgui\";i:19;s:9:\"ilnotegui\";}s:14:\"ilobjcoursegui\";a:26:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:24:\"ilcoursecontentinterface\";i:3;s:21:\"ilcourseobjectivesgui\";i:4;s:19:\"ilcourseregistergui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:21:\"illearningprogressgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:22:\"ilobjcoursegroupinggui\";i:9;s:12:\"ilobjusergui\";i:10;s:20:\"ilpaymentpurchasegui\";i:11;s:15:\"ilpermissiongui\";i:12;s:21:\"ilrepositorysearchgui\";i:13;s:27:\"ilconditionhandlerinterface\";i:14;s:18:\"ilcoursecontentgui\";i:15;s:24:\"ilcoursecontentinterface\";i:16;s:21:\"ilcourseobjectivesgui\";i:17;s:19:\"ilcourseregistergui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:21:\"illearningprogressgui\";i:20;s:13:\"ilmdeditorgui\";i:21;s:22:\"ilobjcoursegroupinggui\";i:22;s:12:\"ilobjusergui\";i:23;s:20:\"ilpaymentpurchasegui\";i:24;s:15:\"ilpermissiongui\";i:25;s:21:\"ilrepositorysearchgui\";}s:17:\"illmpageobjectgui\";a:4:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:16:\"ilobjexercisegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilrepositorysearchgui\";}s:29:\"ilobjexternaltoolssettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:19:\"ilobjfilebasedlmgui\";a:5:{i:0;s:15:\"ilfilesystemgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:21:\"illearningprogressgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:15:\"ilpermissiongui\";}s:12:\"ilobjfilegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:14:\"ilobjfoldergui\";a:8:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:15:\"ilpermissiongui\";i:4;s:27:\"ilconditionhandlerinterface\";i:5;s:18:\"ilcoursecontentgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:15:\"ilpermissiongui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:25:\"iltermdefinitioneditorgui\";a:2:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:25:\"iltermdefinitioneditorgui\";}s:16:\"ilobjglossarygui\";a:3:{i:0;s:17:\"ilglossarytermgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:13:\"ilobjgroupgui\";a:10:{i:0;s:0:\"\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:21:\"illearningprogressgui\";i:5;s:22:\"ilobjcoursegroupinggui\";i:6;s:12:\"ilobjusergui\";i:7;s:15:\"ilpermissiongui\";i:8;s:13:\"ilregistergui\";i:9;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:19:\"ilobjilinccoursegui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:22:\"ilobjilincclassroomgui\";i:2;s:12:\"ilobjusergui\";i:3;s:15:\"ilpermissiongui\";i:4;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjlanguagefoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:22:\"ilobjlearningmodulegui\";a:6:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:18:\"ilobjstylesheetgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:20:\"ilstructureobjectgui\";}s:20:\"ilobjlinkresourcegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:12:\"ilobjmailgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediapoolgui\";a:4:{i:0;s:18:\"ileditclipboardgui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpermissiongui\";}s:20:\"ilobjobjectfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:23:\"ilobjpaymentsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilobjquestionpoolgui\";a:13:{i:0;s:15:\"assclozetestgui\";i:1;s:22:\"assimagemapquestiongui\";i:2;s:16:\"assjavaappletgui\";i:3;s:22:\"assmatchingquestiongui\";i:4;s:20:\"assmultiplechoicegui\";i:5;s:13:\"assnumericgui\";i:6;s:22:\"assorderingquestiongui\";i:7;s:18:\"asssinglechoicegui\";i:8;s:18:\"asstextquestiongui\";i:9;s:16:\"asstextsubsetgui\";i:10;s:13:\"ilmdeditorgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:15:\"ilpermissiongui\";}s:22:\"ilobjrecoveryfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:18:\"ilobjrolefoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilobjroletemplategui\";a:1:{i:0;s:0:\"\";}s:18:\"ilobjrootfoldergui\";a:3:{i:0;s:22:\"ilcontainerlinklistgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpermissiongui\";}s:26:\"ilobjsahslearningmodulegui\";a:3:{i:0;s:15:\"ilfilesystemgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:22:\"ilobjsearchsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:21:\"ilobjstylesettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:14:\"ilobjsurveygui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilsurveyevaluationgui\";i:4;s:20:\"ilsurveyexecutiongui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:6:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:23:\"surveymetricquestiongui\";i:3;s:24:\"surveynominalquestiongui\";i:4;s:24:\"surveyordinalquestiongui\";i:5;s:21:\"surveytextquestiongui\";}s:20:\"ilobjsystemfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:12:\"ilobjtestgui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:15:\"ilpermissiongui\";i:5;s:19:\"iltestevaluationgui\";i:6;s:15:\"iltestoutputgui\";}s:20:\"ilobjusertrackinggui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:15:\"ilpermissiongui\";}s:19:\"iladministrationgui\";a:44:{i:0;s:21:\"ilcourseobjectivesgui\";i:1;s:23:\"ilobjadvancededitinggui\";i:2;s:24:\"ilobjassessmentfoldergui\";i:3;s:20:\"ilobjauthsettingsgui\";i:4;s:16:\"ilobjcategorygui\";i:5;s:12:\"ilobjchatgui\";i:6;s:18:\"ilobjchatservergui\";i:7;s:14:\"ilobjcoursegui\";i:8;s:14:\"ilobjdlbookgui\";i:9;s:16:\"ilobjexercisegui\";i:10;s:29:\"ilobjexternaltoolssettingsgui\";i:11;s:19:\"ilobjfilebasedlmgui\";i:12;s:12:\"ilobjfilegui\";i:13;s:14:\"ilobjfoldergui\";i:14;s:13:\"ilobjforumgui\";i:15;s:16:\"ilobjglossarygui\";i:16;s:13:\"ilobjgroupgui\";i:17;s:22:\"ilobjilincclassroomgui\";i:18;s:19:\"ilobjilinccoursegui\";i:19;s:22:\"ilobjlanguagefoldergui\";i:20;s:22:\"ilobjlearningmodulegui\";i:21;s:20:\"ilobjlinkresourcegui\";i:22;s:12:\"ilobjmailgui\";i:23;s:17:\"ilobjmediapoolgui\";i:24;s:20:\"ilobjobjectfoldergui\";i:25;s:23:\"ilobjpaymentsettingsgui\";i:26;s:20:\"ilobjquestionpoolgui\";i:27;s:22:\"ilobjrecoveryfoldergui\";i:28;s:18:\"ilobjrolefoldergui\";i:29;s:12:\"ilobjrolegui\";i:30;s:20:\"ilobjroletemplategui\";i:31;s:18:\"ilobjrootfoldergui\";i:32;s:26:\"ilobjsahslearningmodulegui\";i:33;s:22:\"ilobjsearchsettingsgui\";i:34;s:21:\"ilobjstylesettingsgui\";i:35;s:18:\"ilobjstylesheetgui\";i:36;s:14:\"ilobjsurveygui\";i:37;s:26:\"ilobjsurveyquestionpoolgui\";i:38;s:20:\"ilobjsystemfoldergui\";i:39;s:22:\"ilobjtaxonomyfoldergui\";i:40;s:12:\"ilobjtestgui\";i:41;s:18:\"ilobjuserfoldergui\";i:42;s:12:\"ilobjusergui\";i:43;s:20:\"ilobjusertrackinggui\";}}','a:112:{s:0:\"\";a:545:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:12:\"ilobjrolegui\";i:3;s:0:\"\";i:4;s:12:\"ilobjrolegui\";i:5;s:0:\"\";i:6;s:12:\"ilobjrolegui\";i:7;s:0:\"\";i:8;s:25:\"ilregistrationsettingsgui\";i:9;s:0:\"\";i:10;s:22:\"ilcontainerlinklistgui\";i:11;s:0:\"\";i:12;s:12:\"ilobjrolegui\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:13:\"illpfiltergui\";i:16;s:0:\"\";i:17;s:17:\"ilpdfpresentation\";i:18;s:0:\"\";i:19;s:15:\"iluserfiltergui\";i:20;s:0:\"\";i:21;s:13:\"illpfiltergui\";i:22;s:0:\"\";i:23;s:17:\"ilpdfpresentation\";i:24;s:0:\"\";i:25;s:21:\"illplistofsettingsgui\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:12:\"ilobjrolegui\";i:45;s:0:\"\";i:46;s:12:\"ilobjrolegui\";i:47;s:0:\"\";i:48;s:12:\"ilobjrolegui\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:13:\"ilfeedbackgui\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:13:\"illpfiltergui\";i:64;s:0:\"\";i:65;s:17:\"ilpdfpresentation\";i:66;s:0:\"\";i:67;s:15:\"iluserfiltergui\";i:68;s:0:\"\";i:69;s:13:\"illpfiltergui\";i:70;s:0:\"\";i:71;s:17:\"ilpdfpresentation\";i:72;s:0:\"\";i:73;s:21:\"illplistofsettingsgui\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:13:\"illpfiltergui\";i:79;s:0:\"\";i:80;s:17:\"ilpdfpresentation\";i:81;s:0:\"\";i:82;s:15:\"iluserfiltergui\";i:83;s:0:\"\";i:84;s:13:\"illpfiltergui\";i:85;s:0:\"\";i:86;s:17:\"ilpdfpresentation\";i:87;s:0:\"\";i:88;s:21:\"illplistofsettingsgui\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:12:\"ilobjrolegui\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:13:\"illpfiltergui\";i:97;s:0:\"\";i:98;s:17:\"ilpdfpresentation\";i:99;s:0:\"\";i:100;s:15:\"iluserfiltergui\";i:101;s:0:\"\";i:102;s:13:\"illpfiltergui\";i:103;s:0:\"\";i:104;s:17:\"ilpdfpresentation\";i:105;s:0:\"\";i:106;s:21:\"illplistofsettingsgui\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:18:\"ilobjstylesheetgui\";i:127;s:0:\"\";i:128;s:12:\"ilobjrolegui\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:13:\"ilfeedbackgui\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:13:\"illpfiltergui\";i:137;s:0:\"\";i:138;s:17:\"ilpdfpresentation\";i:139;s:0:\"\";i:140;s:15:\"iluserfiltergui\";i:141;s:0:\"\";i:142;s:13:\"illpfiltergui\";i:143;s:0:\"\";i:144;s:17:\"ilpdfpresentation\";i:145;s:0:\"\";i:146;s:21:\"illplistofsettingsgui\";i:147;s:0:\"\";i:148;s:12:\"ilobjrolegui\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:12:\"ilobjrolegui\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:13:\"ilfeedbackgui\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:13:\"illpfiltergui\";i:159;s:0:\"\";i:160;s:17:\"ilpdfpresentation\";i:161;s:0:\"\";i:162;s:15:\"iluserfiltergui\";i:163;s:0:\"\";i:164;s:13:\"illpfiltergui\";i:165;s:0:\"\";i:166;s:17:\"ilpdfpresentation\";i:167;s:0:\"\";i:168;s:21:\"illplistofsettingsgui\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:12:\"ilobjrolegui\";i:172;s:0:\"\";i:173;s:13:\"ilfeedbackgui\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:12:\"ilobjrolegui\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:13:\"illpfiltergui\";i:186;s:0:\"\";i:187;s:17:\"ilpdfpresentation\";i:188;s:0:\"\";i:189;s:15:\"iluserfiltergui\";i:190;s:0:\"\";i:191;s:13:\"illpfiltergui\";i:192;s:0:\"\";i:193;s:17:\"ilpdfpresentation\";i:194;s:0:\"\";i:195;s:21:\"illplistofsettingsgui\";i:196;s:0:\"\";i:197;s:12:\"ilobjrolegui\";i:198;s:0:\"\";i:199;s:12:\"ilobjrolegui\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:12:\"ilobjrolegui\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:13:\"ilfeedbackgui\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:13:\"illpfiltergui\";i:232;s:0:\"\";i:233;s:17:\"ilpdfpresentation\";i:234;s:0:\"\";i:235;s:15:\"iluserfiltergui\";i:236;s:0:\"\";i:237;s:13:\"illpfiltergui\";i:238;s:0:\"\";i:239;s:17:\"ilpdfpresentation\";i:240;s:0:\"\";i:241;s:21:\"illplistofsettingsgui\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:13:\"illpfiltergui\";i:246;s:0:\"\";i:247;s:17:\"ilpdfpresentation\";i:248;s:0:\"\";i:249;s:15:\"iluserfiltergui\";i:250;s:0:\"\";i:251;s:13:\"illpfiltergui\";i:252;s:0:\"\";i:253;s:17:\"ilpdfpresentation\";i:254;s:0:\"\";i:255;s:21:\"illplistofsettingsgui\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:12:\"ilobjrolegui\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:13:\"ilobjgroupgui\";i:262;s:0:\"\";i:263;s:22:\"ilobjilincclassroomgui\";i:264;s:0:\"\";i:265;s:13:\"ilfeedbackgui\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:22:\"ilobjilincclassroomgui\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:13:\"illpfiltergui\";i:272;s:0:\"\";i:273;s:17:\"ilpdfpresentation\";i:274;s:0:\"\";i:275;s:15:\"iluserfiltergui\";i:276;s:0:\"\";i:277;s:13:\"illpfiltergui\";i:278;s:0:\"\";i:279;s:17:\"ilpdfpresentation\";i:280;s:0:\"\";i:281;s:21:\"illplistofsettingsgui\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:12:\"ilobjrolegui\";i:285;s:0:\"\";i:286;s:0:\"\";i:287;s:12:\"ilobjrolegui\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:13:\"illpfiltergui\";i:291;s:0:\"\";i:292;s:17:\"ilpdfpresentation\";i:293;s:0:\"\";i:294;s:15:\"iluserfiltergui\";i:295;s:0:\"\";i:296;s:13:\"illpfiltergui\";i:297;s:0:\"\";i:298;s:17:\"ilpdfpresentation\";i:299;s:0:\"\";i:300;s:21:\"illplistofsettingsgui\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:18:\"ilobjstylesheetgui\";i:321;s:0:\"\";i:322;s:12:\"ilobjrolegui\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:13:\"ilfeedbackgui\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:12:\"ilobjrolegui\";i:331;s:0:\"\";i:332;s:12:\"ilobjrolegui\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:13:\"illpfiltergui\";i:343;s:0:\"\";i:344;s:17:\"ilpdfpresentation\";i:345;s:0:\"\";i:346;s:15:\"iluserfiltergui\";i:347;s:0:\"\";i:348;s:13:\"illpfiltergui\";i:349;s:0:\"\";i:350;s:17:\"ilpdfpresentation\";i:351;s:0:\"\";i:352;s:21:\"illplistofsettingsgui\";i:353;s:0:\"\";i:354;s:12:\"ilobjrolegui\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:12:\"ilobjrolegui\";i:359;s:0:\"\";i:360;s:12:\"ilobjrolegui\";i:361;s:0:\"\";i:362;s:12:\"ilobjrolegui\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:0:\"\";i:372;s:0:\"\";i:373;s:0:\"\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:0:\"\";i:389;s:0:\"\";i:390;s:0:\"\";i:391;s:12:\"ilobjrolegui\";i:392;s:0:\"\";i:393;s:12:\"ilobjrolegui\";i:394;s:0:\"\";i:395;s:12:\"ilobjrolegui\";i:396;s:0:\"\";i:397;s:12:\"ilobjrolegui\";i:398;s:0:\"\";i:399;s:20:\"ilobjroletemplategui\";i:400;s:0:\"\";i:401;s:22:\"ilcontainerlinklistgui\";i:402;s:0:\"\";i:403;s:0:\"\";i:404;s:0:\"\";i:405;s:0:\"\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:0:\"\";i:409;s:0:\"\";i:410;s:0:\"\";i:411;s:0:\"\";i:412;s:0:\"\";i:413;s:0:\"\";i:414;s:0:\"\";i:415;s:0:\"\";i:416;s:0:\"\";i:417;s:0:\"\";i:418;s:0:\"\";i:419;s:12:\"ilobjrolegui\";i:420;s:0:\"\";i:421;s:0:\"\";i:422;s:0:\"\";i:423;s:12:\"ilobjrolegui\";i:424;s:0:\"\";i:425;s:12:\"ilobjrolegui\";i:426;s:0:\"\";i:427;s:12:\"ilobjrolegui\";i:428;s:0:\"\";i:429;s:18:\"ilobjstylesheetgui\";i:430;s:0:\"\";i:431;s:13:\"ilfeedbackgui\";i:432;s:0:\"\";i:433;s:0:\"\";i:434;s:0:\"\";i:435;s:12:\"ilobjrolegui\";i:436;s:0:\"\";i:437;s:0:\"\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:12:\"ilobjrolegui\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:0:\"\";i:445;s:0:\"\";i:446;s:12:\"ilobjrolegui\";i:447;s:0:\"\";i:448;s:0:\"\";i:449;s:13:\"ilfeedbackgui\";i:450;s:0:\"\";i:451;s:0:\"\";i:452;s:0:\"\";i:453;s:13:\"illpfiltergui\";i:454;s:0:\"\";i:455;s:17:\"ilpdfpresentation\";i:456;s:0:\"\";i:457;s:15:\"iluserfiltergui\";i:458;s:0:\"\";i:459;s:13:\"illpfiltergui\";i:460;s:0:\"\";i:461;s:17:\"ilpdfpresentation\";i:462;s:0:\"\";i:463;s:21:\"illplistofsettingsgui\";i:464;s:0:\"\";i:465;s:0:\"\";i:466;s:0:\"\";i:467;s:0:\"\";i:468;s:0:\"\";i:469;s:0:\"\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:0:\"\";i:474;s:0:\"\";i:475;s:13:\"ilfeedbackgui\";i:476;s:0:\"\";i:477;s:0:\"\";i:478;s:0:\"\";i:479;s:13:\"illpfiltergui\";i:480;s:0:\"\";i:481;s:17:\"ilpdfpresentation\";i:482;s:0:\"\";i:483;s:15:\"iluserfiltergui\";i:484;s:0:\"\";i:485;s:13:\"illpfiltergui\";i:486;s:0:\"\";i:487;s:17:\"ilpdfpresentation\";i:488;s:0:\"\";i:489;s:21:\"illplistofsettingsgui\";i:490;s:0:\"\";i:491;s:0:\"\";i:492;s:0:\"\";i:493;s:0:\"\";i:494;s:13:\"illpfiltergui\";i:495;s:0:\"\";i:496;s:17:\"ilpdfpresentation\";i:497;s:0:\"\";i:498;s:15:\"iluserfiltergui\";i:499;s:0:\"\";i:500;s:13:\"illpfiltergui\";i:501;s:0:\"\";i:502;s:17:\"ilpdfpresentation\";i:503;s:0:\"\";i:504;s:21:\"illplistofsettingsgui\";i:505;s:0:\"\";i:506;s:0:\"\";i:507;s:0:\"\";i:508;s:12:\"ilobjrolegui\";i:509;s:0:\"\";i:510;s:0:\"\";i:511;s:12:\"ilobjrolegui\";i:512;s:0:\"\";i:513;s:0:\"\";i:514;s:0:\"\";i:515;s:12:\"ilobjrolegui\";i:516;s:0:\"\";i:517;s:0:\"\";i:518;s:13:\"illpfiltergui\";i:519;s:0:\"\";i:520;s:17:\"ilpdfpresentation\";i:521;s:0:\"\";i:522;s:15:\"iluserfiltergui\";i:523;s:0:\"\";i:524;s:13:\"illpfiltergui\";i:525;s:0:\"\";i:526;s:17:\"ilpdfpresentation\";i:527;s:0:\"\";i:528;s:21:\"illplistofsettingsgui\";i:529;s:0:\"\";i:530;s:0:\"\";i:531;s:0:\"\";i:532;s:13:\"illpfiltergui\";i:533;s:0:\"\";i:534;s:17:\"ilpdfpresentation\";i:535;s:0:\"\";i:536;s:15:\"iluserfiltergui\";i:537;s:0:\"\";i:538;s:13:\"illpfiltergui\";i:539;s:0:\"\";i:540;s:17:\"ilpdfpresentation\";i:541;s:0:\"\";i:542;s:21:\"illplistofsettingsgui\";i:543;s:0:\"\";i:544;s:12:\"ilobjrolegui\";}s:12:\"ilobjrolegui\";a:41:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";i:2;s:15:\"ilpermissiongui\";i:3;s:15:\"ilpermissiongui\";i:4;s:15:\"ilpermissiongui\";i:5;s:15:\"ilpermissiongui\";i:6;s:15:\"ilpermissiongui\";i:7;s:15:\"ilpermissiongui\";i:8;s:15:\"ilpermissiongui\";i:9;s:15:\"ilpermissiongui\";i:10;s:15:\"ilpermissiongui\";i:11;s:15:\"ilpermissiongui\";i:12;s:15:\"ilpermissiongui\";i:13;s:15:\"ilpermissiongui\";i:14;s:15:\"ilpermissiongui\";i:15;s:15:\"ilpermissiongui\";i:16;s:15:\"ilpermissiongui\";i:17;s:15:\"ilpermissiongui\";i:18;s:15:\"ilpermissiongui\";i:19;s:15:\"ilpermissiongui\";i:20;s:15:\"ilpermissiongui\";i:21;s:15:\"ilpermissiongui\";i:22;s:15:\"ilpermissiongui\";i:23;s:15:\"ilpermissiongui\";i:24;s:15:\"ilpermissiongui\";i:25;s:15:\"ilpermissiongui\";i:26;s:15:\"ilpermissiongui\";i:27;s:15:\"ilpermissiongui\";i:28;s:15:\"ilpermissiongui\";i:29;s:15:\"ilpermissiongui\";i:30;s:15:\"ilpermissiongui\";i:31;s:15:\"ilpermissiongui\";i:32;s:15:\"ilpermissiongui\";i:33;s:15:\"ilpermissiongui\";i:34;s:15:\"ilpermissiongui\";i:35;s:15:\"ilpermissiongui\";i:36;s:15:\"ilpermissiongui\";i:37;s:15:\"ilpermissiongui\";i:38;s:15:\"ilpermissiongui\";i:39;s:15:\"ilpermissiongui\";i:40;s:19:\"iladministrationgui\";}s:15:\"ilpermissiongui\";a:40:{i:0;s:23:\"ilobjadvancededitinggui\";i:1;s:24:\"ilobjassessmentfoldergui\";i:2;s:20:\"ilobjauthsettingsgui\";i:3;s:18:\"ilobjuserfoldergui\";i:4;s:16:\"ilobjcategorygui\";i:5;s:12:\"ilobjchatgui\";i:6;s:18:\"ilobjchatservergui\";i:7;s:14:\"ilobjcoursegui\";i:8;s:14:\"ilobjdlbookgui\";i:9;s:16:\"ilobjexercisegui\";i:10;s:29:\"ilobjexternaltoolssettingsgui\";i:11;s:19:\"ilobjfilebasedlmgui\";i:12;s:12:\"ilobjfilegui\";i:13;s:14:\"ilobjfoldergui\";i:14;s:13:\"ilobjforumgui\";i:15;s:16:\"ilobjglossarygui\";i:16;s:13:\"ilobjgroupgui\";i:17;s:19:\"ilobjilinccoursegui\";i:18;s:22:\"ilobjlanguagefoldergui\";i:19;s:22:\"ilobjlearningmodulegui\";i:20;s:20:\"ilobjlinkresourcegui\";i:21;s:12:\"ilobjmailgui\";i:22;s:14:\"ilobjfoldergui\";i:23;s:17:\"ilobjmediapoolgui\";i:24;s:20:\"ilobjobjectfoldergui\";i:25;s:23:\"ilobjpaymentsettingsgui\";i:26;s:20:\"ilobjquestionpoolgui\";i:27;s:22:\"ilobjrecoveryfoldergui\";i:28;s:18:\"ilobjrolefoldergui\";i:29;s:18:\"ilobjrootfoldergui\";i:30;s:26:\"ilobjsahslearningmodulegui\";i:31;s:22:\"ilobjsearchsettingsgui\";i:32;s:21:\"ilobjstylesettingsgui\";i:33;s:14:\"ilobjsurveygui\";i:34;s:26:\"ilobjsurveyquestionpoolgui\";i:35;s:20:\"ilobjsystemfoldergui\";i:36;s:14:\"ilobjcoursegui\";i:37;s:12:\"ilobjtestgui\";i:38;s:18:\"ilobjuserfoldergui\";i:39;s:20:\"ilobjusertrackinggui\";}s:25:\"ilregistrationsettingsgui\";a:1:{i:0;s:20:\"ilobjauthsettingsgui\";}s:13:\"illpfiltergui\";a:34:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";i:30;s:20:\"illplistofobjectsgui\";i:31;s:21:\"illplistofprogressgui\";i:32;s:20:\"illplistofobjectsgui\";i:33;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:34:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";i:30;s:20:\"illplistofobjectsgui\";i:31;s:21:\"illplistofprogressgui\";i:32;s:20:\"illplistofobjectsgui\";i:33;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:17:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:20:\"illplistofobjectsgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:20:\"illplistofobjectsgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:20:\"illplistofobjectsgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:20:\"illplistofobjectsgui\";i:16;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:17:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";i:15;s:21:\"illearningprogressgui\";i:16;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:17:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";i:15;s:21:\"illearningprogressgui\";i:16;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:17:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";i:15;s:21:\"illearningprogressgui\";i:16;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:17:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";i:15;s:21:\"illearningprogressgui\";i:16;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:17:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:14:\"ilobjdlbookgui\";i:4;s:16:\"ilobjexercisegui\";i:5;s:19:\"ilobjfilebasedlmgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:12:\"ilobjusergui\";i:8;s:13:\"ilobjgroupgui\";i:9;s:12:\"ilobjusergui\";i:10;s:22:\"ilobjlearningmodulegui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:12:\"ilobjusergui\";i:13;s:14:\"ilobjcoursegui\";i:14;s:12:\"ilobjtestgui\";i:15;s:12:\"ilobjusergui\";i:16;s:20:\"ilobjusertrackinggui\";}s:17:\"ilobjilincusergui\";a:6:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:12:\"ilobjusergui\";i:3;s:12:\"ilobjusergui\";i:4;s:12:\"ilobjusergui\";i:5;s:12:\"ilobjusergui\";}s:17:\"ilinternallinkgui\";a:20:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:15:\"ilpageeditorgui\";}s:13:\"ilmdeditorgui\";a:32:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:17:\"illmpageobjectgui\";i:6;s:20:\"ilstructureobjectgui\";i:7;s:14:\"ilobjdlbookgui\";i:8;s:19:\"ilobjfilebasedlmgui\";i:9;s:12:\"ilobjfilegui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:25:\"iltermdefinitioneditorgui\";i:13;s:16:\"ilobjglossarygui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:17:\"illmpageobjectgui\";i:17;s:20:\"ilstructureobjectgui\";i:18;s:22:\"ilobjlearningmodulegui\";i:19;s:20:\"ilobjlinkresourcegui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:19:\"ilobjmediaobjectgui\";i:24;s:20:\"ilobjquestionpoolgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:26:\"ilobjsahslearningmodulegui\";i:28;s:14:\"ilobjsurveygui\";i:29;s:26:\"ilobjsurveyquestionpoolgui\";i:30;s:14:\"ilobjcoursegui\";i:31;s:12:\"ilobjtestgui\";}s:19:\"ilobjmediaobjectgui\";a:14:{i:0;s:18:\"ileditclipboardgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:18:\"ileditclipboardgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:18:\"ileditclipboardgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:18:\"ileditclipboardgui\";i:9;s:17:\"ilobjmediapoolgui\";i:10;s:18:\"ileditclipboardgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:6:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:7:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:17:\"ilobjmediapoolgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";}s:25:\"ilmediapooltargetselector\";a:6:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";}s:15:\"ilpageeditorgui\";a:6:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:18:\"ilobjrootfoldergui\";}s:18:\"ilobjuserfoldergui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:19:\"iladministrationgui\";}s:12:\"ilobjusergui\";a:6:{i:0;s:16:\"ilobjcategorygui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";i:5;s:19:\"iladministrationgui\";}s:15:\"ilpageobjectgui\";a:6:{i:0;s:16:\"ilobjcategorygui\";i:1;s:17:\"illmpageobjectgui\";i:2;s:25:\"iltermdefinitioneditorgui\";i:3;s:17:\"illmpageobjectgui\";i:4;s:20:\"ilobjquestionpoolgui\";i:5;s:18:\"ilobjrootfoldergui\";}s:27:\"ilconditionhandlerinterface\";a:16:{i:0;s:29:\"ilcourseitemadministrationgui\";i:1;s:29:\"ilcourseitemadministrationgui\";i:2;s:24:\"ilcoursecontentinterface\";i:3;s:14:\"ilobjcoursegui\";i:4;s:20:\"ilstructureobjectgui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:29:\"ilcourseitemadministrationgui\";i:8;s:13:\"ilobjgroupgui\";i:9;s:20:\"ilstructureobjectgui\";i:10;s:29:\"ilcourseitemadministrationgui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:29:\"ilcourseitemadministrationgui\";i:13;s:29:\"ilcourseitemadministrationgui\";i:14;s:24:\"ilcoursecontentinterface\";i:15;s:14:\"ilobjcoursegui\";}s:19:\"ilcoursearchivesgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:29:\"ilcourseitemadministrationgui\";a:7:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:24:\"ilcoursecontentinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";i:5;s:18:\"ilcoursecontentgui\";i:6;s:24:\"ilcoursecontentinterface\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:24:\"ileventadministrationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:13:\"ilfeedbackgui\";a:10:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:10:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";}s:18:\"ilcoursecontentgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:24:\"ilcoursecontentinterface\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseobjectivesgui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:19:\"iladministrationgui\";}s:19:\"ilcourseregistergui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:15:\"ilinfoscreengui\";a:10:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:19:\"ilobjfilebasedlmgui\";i:3;s:12:\"ilobjfilegui\";i:4;s:13:\"ilobjgroupgui\";i:5;s:19:\"ilobjilinccoursegui\";i:6;s:20:\"ilobjlinkresourcegui\";i:7;s:14:\"ilobjsurveygui\";i:8;s:14:\"ilobjcoursegui\";i:9;s:12:\"ilobjtestgui\";}s:22:\"ilobjcoursegroupinggui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:13:\"ilobjgroupgui\";i:2;s:14:\"ilobjcoursegui\";}s:20:\"ilpaymentpurchasegui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilrepositorysearchgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:3:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";i:2;s:19:\"iladministrationgui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:15:\"ilfilesystemgui\";a:2:{i:0;s:19:\"ilobjfilebasedlmgui\";i:1;s:26:\"ilobjsahslearningmodulegui\";}s:25:\"iltermdefinitioneditorgui\";a:1:{i:0;s:17:\"ilglossarytermgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:16:\"ilobjglossarygui\";}s:13:\"ilregistergui\";a:1:{i:0;s:13:\"ilobjgroupgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:19:\"ilobjilinccoursegui\";i:1;s:19:\"iladministrationgui\";}s:14:\"ilobjfoldergui\";a:2:{i:0;s:17:\"ilobjmediapoolgui\";i:1;s:19:\"iladministrationgui\";}s:15:\"assclozetestgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assimagemapquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"assjavaappletgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assmatchingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:20:\"assmultiplechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:13:\"assnumericgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assorderingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asssinglechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asstextquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"asstextsubsetgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:21:\"ilsurveyevaluationgui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:20:\"ilsurveyexecutiongui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:23:\"surveymetricquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveynominalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveyordinalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:21:\"surveytextquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:14:\"ilobjcoursegui\";a:2:{i:0;s:12:\"ilobjtestgui\";i:1;s:19:\"iladministrationgui\";}s:19:\"iltestevaluationgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:15:\"iltestoutputgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:23:\"ilobjadvancededitinggui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:24:\"ilobjassessmentfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjauthsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjcategorygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjchatservergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjexercisegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:29:\"ilobjexternaltoolssettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:19:\"ilobjfilebasedlmgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjfilegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjglossarygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:13:\"ilobjgroupgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:19:\"ilobjilinccoursegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjlanguagefoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjlinkresourcegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjmailgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:17:\"ilobjmediapoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjobjectfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:23:\"ilobjpaymentsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjquestionpoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjrecoveryfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjrolefoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjroletemplategui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjrootfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:26:\"ilobjsahslearningmodulegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjsearchsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:21:\"ilobjstylesettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:14:\"ilobjsurveygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjsystemfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjtaxonomyfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjtestgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjusertrackinggui\";a:1:{i:0;s:19:\"iladministrationgui\";}}');

--
-- Table structure for table `dbk_translations`
--

CREATE TABLE `dbk_translations` (
  `id` int(11) NOT NULL default '0',
  `tr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`tr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `dbk_translations`
--


--
-- Table structure for table `desktop_item`
--

CREATE TABLE `desktop_item` (
  `user_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `type` varchar(4) NOT NULL default '',
  `parameters` varchar(200) default NULL,
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `desktop_item`
--


--
-- Table structure for table `dp_changed_dates`
--

CREATE TABLE `dp_changed_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `date_ID` int(15) NOT NULL default '0',
  `status` int(15) NOT NULL default '0',
  `timestamp` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r Anzeige von Ge?nderten Termindaten';

--
-- Dumping data for table `dp_changed_dates`
--


--
-- Table structure for table `dp_dates`
--

CREATE TABLE `dp_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `begin` int(10) NOT NULL default '0',
  `end` int(10) NOT NULL default '0',
  `group_ID` int(15) NOT NULL default '0',
  `user_ID` int(15) NOT NULL default '0',
  `created` int(10) NOT NULL default '0',
  `changed` int(10) NOT NULL default '0',
  `rotation` int(15) NOT NULL default '0',
  `shorttext` varchar(50) NOT NULL default '',
  `text` text,
  `end_rotation` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Termin Tabelle';

--
-- Dumping data for table `dp_dates`
--


--
-- Table structure for table `dp_keyword`
--

CREATE TABLE `dp_keyword` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `keyword` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r Schlagw?rter';

--
-- Dumping data for table `dp_keyword`
--


--
-- Table structure for table `dp_keywords`
--

CREATE TABLE `dp_keywords` (
  `ID` int(15) NOT NULL auto_increment,
  `date_ID` int(15) NOT NULL default '0',
  `keyword_ID` int(15) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r die Zuordnung der Schlagw?rter';

--
-- Dumping data for table `dp_keywords`
--


--
-- Table structure for table `dp_neg_dates`
--

CREATE TABLE `dp_neg_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `date_ID` int(15) NOT NULL default '0',
  `user_ID` int(15) NOT NULL default '0',
  `timestamp` int(14) default NULL,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r die negativen Termine';

--
-- Dumping data for table `dp_neg_dates`
--


--
-- Table structure for table `dp_properties`
--

CREATE TABLE `dp_properties` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `dv_starttime` time NOT NULL default '00:00:00',
  `dv_endtime` time NOT NULL default '00:00:00',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r UserEinstellungen';

--
-- Dumping data for table `dp_properties`
--


--
-- Table structure for table `event`
--

CREATE TABLE `event` (
  `event_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `title` varchar(70) NOT NULL default '',
  `description` text NOT NULL,
  `location` text NOT NULL,
  `tutor_name` text NOT NULL,
  `tutor_email` varchar(127) NOT NULL default '',
  `tutor_phone` varchar(127) NOT NULL default '',
  `details` text NOT NULL,
  `registration` tinyint(1) NOT NULL default '0',
  `participation` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`event_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event`
--


--
-- Table structure for table `event_appointment`
--

CREATE TABLE `event_appointment` (
  `appointment_id` int(11) NOT NULL auto_increment,
  `event_id` int(11) NOT NULL default '0',
  `starting_time` int(11) NOT NULL default '0',
  `ending_time` int(11) NOT NULL default '0',
  `fulltime` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`appointment_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_appointment`
--


--
-- Table structure for table `event_file`
--

CREATE TABLE `event_file` (
  `file_id` int(11) NOT NULL auto_increment,
  `event_id` int(11) NOT NULL default '0',
  `file_name` char(64) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `file_size` int(11) NOT NULL default '0',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_file`
--


--
-- Table structure for table `event_items`
--

CREATE TABLE `event_items` (
  `event_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`event_id`,`item_id`),
  KEY `event_id` (`event_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_items`
--


--
-- Table structure for table `event_participants`
--

CREATE TABLE `event_participants` (
  `event_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `registered` tinyint(1) NOT NULL default '0',
  `participated` tinyint(1) NOT NULL default '0',
  `mark` text NOT NULL,
  `comment` text NOT NULL,
  PRIMARY KEY  (`event_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_participants`
--


--
-- Table structure for table `exc_data`
--

CREATE TABLE `exc_data` (
  `obj_id` int(11) NOT NULL default '0',
  `instruction` text,
  `time_stamp` int(10) default NULL,
  PRIMARY KEY  (`obj_id`),
  FULLTEXT KEY `instruction` (`instruction`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_data`
--


--
-- Table structure for table `exc_members`
--

CREATE TABLE `exc_members` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `notice` text,
  `returned` tinyint(1) NOT NULL default '0',
  `solved` tinyint(1) default NULL,
  `status_time` timestamp(14) NOT NULL,
  `sent` tinyint(1) default NULL,
  `sent_time` timestamp(14) NOT NULL default '00000000000000',
  `feedback_time` timestamp(14) NOT NULL default '00000000000000',
  `feedback` tinyint(1) NOT NULL default '0',
  `status` enum('notgraded','failed','passed') NOT NULL default 'notgraded',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_members`
--


--
-- Table structure for table `exc_returned`
--

CREATE TABLE `exc_returned` (
  `returned_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `filename` mediumtext NOT NULL,
  `filetitle` mediumtext NOT NULL,
  `mimetype` varchar(40) NOT NULL default '',
  `timestamp` timestamp(14) NOT NULL,
  PRIMARY KEY  (`returned_id`),
  KEY `obj_id` (`obj_id`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_returned`
--


--
-- Table structure for table `exc_usr_tutor`
--

CREATE TABLE `exc_usr_tutor` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `tutor_id` int(11) NOT NULL default '0',
  `download_time` timestamp(14) NOT NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`,`tutor_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_usr_tutor`
--


--
-- Table structure for table `feedback_items`
--

CREATE TABLE `feedback_items` (
  `fb_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `description` text,
  `anonymous` tinyint(1) NOT NULL default '1',
  `required` tinyint(1) default '0',
  `show_on` varchar(6) default NULL,
  `text_answer` tinyint(1) default '0',
  `votes` text,
  `starttime` int(11) default '0',
  `endtime` int(11) default '0',
  `repeat_interval` int(11) default NULL,
  `interval_unit` tinyint(4) default NULL,
  `first_vote_best` tinyint(1) default '0',
  `obj_id` int(11) default '0',
  `ref_id` int(11) default '0',
  PRIMARY KEY  (`fb_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `feedback_items`
--


--
-- Table structure for table `feedback_results`
--

CREATE TABLE `feedback_results` (
  `fb_id` int(11) NOT NULL default '0',
  `user_id` int(11) default NULL,
  `vote` int(11) NOT NULL default '0',
  `note` text NOT NULL,
  `votetime` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `feedback_results`
--


--
-- Table structure for table `file_based_lm`
--

CREATE TABLE `file_based_lm` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `startfile` varchar(200) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_based_lm`
--


--
-- Table structure for table `file_data`
--

CREATE TABLE `file_data` (
  `file_id` int(11) NOT NULL default '0',
  `file_name` char(128) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `version` int(11) default NULL,
  `mode` char(8) default 'object',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_data`
--


--
-- Table structure for table `file_usage`
--

CREATE TABLE `file_usage` (
  `id` int(11) NOT NULL default '0',
  `usage_type` varchar(10) NOT NULL default '',
  `usage_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`usage_type`,`usage_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_usage`
--


--
-- Table structure for table `frm_data`
--

CREATE TABLE `frm_data` (
  `top_pk` bigint(20) NOT NULL auto_increment,
  `top_frm_fk` bigint(20) NOT NULL default '0',
  `top_name` varchar(255) NOT NULL default '',
  `top_description` varchar(255) NOT NULL default '',
  `top_num_posts` int(11) NOT NULL default '0',
  `top_num_threads` int(11) NOT NULL default '0',
  `top_last_post` varchar(50) NOT NULL default '',
  `top_mods` int(11) NOT NULL default '0',
  `top_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `visits` int(11) NOT NULL default '0',
  `top_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `update_user` int(11) NOT NULL default '0',
  `top_usr_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`top_pk`),
  KEY `top_frm_fk` (`top_frm_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_data`
--


--
-- Table structure for table `frm_notification`
--

CREATE TABLE `frm_notification` (
  `notification_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `frm_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`notification_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_notification`
--


--
-- Table structure for table `frm_posts`
--

CREATE TABLE `frm_posts` (
  `pos_pk` bigint(20) NOT NULL auto_increment,
  `pos_top_fk` bigint(20) NOT NULL default '0',
  `pos_thr_fk` bigint(20) NOT NULL default '0',
  `pos_usr_id` bigint(20) NOT NULL default '0',
  `pos_message` text NOT NULL,
  `pos_subject` text NOT NULL,
  `pos_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `pos_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `update_user` int(11) NOT NULL default '0',
  `pos_cens` tinyint(4) NOT NULL default '0',
  `pos_cens_com` text NOT NULL,
  `notify` tinyint(1) NOT NULL default '0',
  `import_name` text,
  PRIMARY KEY  (`pos_pk`),
  KEY `pos_thr_fk` (`pos_thr_fk`),
  KEY `pos_top_fk` (`pos_top_fk`),
  KEY `pos_date` (`pos_date`),
  FULLTEXT KEY `message_subject` (`pos_message`,`pos_subject`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_posts`
--


--
-- Table structure for table `frm_posts_tree`
--

CREATE TABLE `frm_posts_tree` (
  `fpt_pk` bigint(20) NOT NULL auto_increment,
  `thr_fk` bigint(20) NOT NULL default '0',
  `pos_fk` bigint(20) NOT NULL default '0',
  `parent_pos` bigint(20) NOT NULL default '0',
  `lft` int(11) NOT NULL default '0',
  `rgt` int(11) NOT NULL default '0',
  `depth` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`fpt_pk`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_posts_tree`
--


--
-- Table structure for table `frm_settings`
--

CREATE TABLE `frm_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `default_view` int(2) NOT NULL default '0',
  `anonymized` tinyint(1) NOT NULL default '0',
  `statistics_enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_settings`
--


--
-- Table structure for table `frm_thread_access`
--

CREATE TABLE `frm_thread_access` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  `access_old` int(11) NOT NULL default '0',
  `access_last` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`,`thread_id`),
  KEY `usr_thread` (`thread_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_thread_access`
--


--
-- Table structure for table `frm_threads`
--

CREATE TABLE `frm_threads` (
  `thr_pk` bigint(20) NOT NULL auto_increment,
  `thr_top_fk` bigint(20) NOT NULL default '0',
  `thr_subject` varchar(255) NOT NULL default '',
  `thr_usr_id` bigint(20) NOT NULL default '0',
  `thr_num_posts` int(11) NOT NULL default '0',
  `thr_last_post` varchar(50) NOT NULL default '',
  `thr_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `thr_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `visits` int(11) NOT NULL default '0',
  `import_name` text,
  PRIMARY KEY  (`thr_pk`),
  FULLTEXT KEY `thr_subject` (`thr_subject`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_threads`
--


--
-- Table structure for table `frm_user_read`
--

CREATE TABLE `frm_user_read` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  `post_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`,`thread_id`,`post_id`),
  KEY `obj_usr` (`obj_id`,`usr_id`),
  KEY `post_usr` (`post_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_user_read`
--


--
-- Table structure for table `glossary`
--

CREATE TABLE `glossary` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `virtual` enum('none','fixed','level','subtree') NOT NULL default 'none',
  `public_html_file` varchar(50) NOT NULL default '',
  `public_xml_file` varchar(50) NOT NULL default '',
  `glo_menu_active` enum('y','n') default 'y',
  `downloads_active` enum('y','n') default 'n',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary`
--


--
-- Table structure for table `glossary_definition`
--

CREATE TABLE `glossary_definition` (
  `id` int(11) NOT NULL auto_increment,
  `term_id` int(11) NOT NULL default '0',
  `short_text` varchar(200) NOT NULL default '',
  `nr` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary_definition`
--


--
-- Table structure for table `glossary_term`
--

CREATE TABLE `glossary_term` (
  `id` int(11) NOT NULL auto_increment,
  `glo_id` int(11) NOT NULL default '0',
  `term` varchar(200) default NULL,
  `language` char(2) default NULL,
  `import_id` varchar(50) NOT NULL default '',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `glo_id` (`glo_id`),
  FULLTEXT KEY `term` (`term`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary_term`
--


--
-- Table structure for table `grp_data`
--

CREATE TABLE `grp_data` (
  `grp_id` int(11) NOT NULL default '0',
  `register` int(11) default '1',
  `password` varchar(255) default NULL,
  `expiration` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`grp_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `grp_data`
--


--
-- Table structure for table `grp_registration`
--

CREATE TABLE `grp_registration` (
  `grp_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `application_date` datetime NOT NULL default '0000-00-00 00:00:00'
) TYPE=MyISAM;

--
-- Dumping data for table `grp_registration`
--


--
-- Table structure for table `history`
--

CREATE TABLE `history` (
  `id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` varchar(8) NOT NULL default '',
  `action` varchar(20) NOT NULL default '',
  `hdate` datetime default NULL,
  `usr_id` int(11) NOT NULL default '0',
  `info_params` text NOT NULL,
  `user_comment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_type` (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `history`
--


--
-- Table structure for table `il_meta_annotation`
--

CREATE TABLE `il_meta_annotation` (
  `meta_annotation_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `entity` text,
  `date` text,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_annotation_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_annotation`
--


--
-- Table structure for table `il_meta_classification`
--

CREATE TABLE `il_meta_classification` (
  `meta_classification_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `purpose` varchar(32) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_classification_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_classification`
--


--
-- Table structure for table `il_meta_contribute`
--

CREATE TABLE `il_meta_contribute` (
  `meta_contribute_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `role` varchar(32) default NULL,
  `date` text,
  PRIMARY KEY  (`meta_contribute_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_contribute`
--


--
-- Table structure for table `il_meta_description`
--

CREATE TABLE `il_meta_description` (
  `meta_description_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_description_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `description` (`description`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_description`
--


--
-- Table structure for table `il_meta_educational`
--

CREATE TABLE `il_meta_educational` (
  `meta_educational_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `interactivity_type` varchar(16) default NULL,
  `learning_resource_type` varchar(32) default NULL,
  `interactivity_level` varchar(16) default NULL,
  `semantic_density` varchar(16) default NULL,
  `intended_end_user_role` varchar(16) default NULL,
  `context` varchar(16) default NULL,
  `difficulty` varchar(16) default NULL,
  `typical_learning_time` text,
  PRIMARY KEY  (`meta_educational_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_educational`
--


--
-- Table structure for table `il_meta_entity`
--

CREATE TABLE `il_meta_entity` (
  `meta_entity_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `entity` text,
  PRIMARY KEY  (`meta_entity_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `entity` (`entity`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_entity`
--


--
-- Table structure for table `il_meta_format`
--

CREATE TABLE `il_meta_format` (
  `meta_format_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `format` text,
  PRIMARY KEY  (`meta_format_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_format`
--


--
-- Table structure for table `il_meta_general`
--

CREATE TABLE `il_meta_general` (
  `meta_general_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `general_structure` varchar(16) default NULL,
  `title` text,
  `title_language` char(2) default NULL,
  `coverage` text,
  `coverage_language` char(2) default NULL,
  PRIMARY KEY  (`meta_general_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `title_coverage` (`title`,`coverage`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_general`
--


--
-- Table structure for table `il_meta_identifier`
--

CREATE TABLE `il_meta_identifier` (
  `meta_identifier_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `catalog` text,
  `entry` text,
  PRIMARY KEY  (`meta_identifier_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_identifier`
--


--
-- Table structure for table `il_meta_identifier_`
--

CREATE TABLE `il_meta_identifier_` (
  `meta_identifier__id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `catalog` text,
  `entry` text,
  PRIMARY KEY  (`meta_identifier__id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_identifier_`
--


--
-- Table structure for table `il_meta_keyword`
--

CREATE TABLE `il_meta_keyword` (
  `meta_keyword_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `keyword` text,
  `keyword_language` char(2) default NULL,
  PRIMARY KEY  (`meta_keyword_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `keyword` (`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_keyword`
--


--
-- Table structure for table `il_meta_language`
--

CREATE TABLE `il_meta_language` (
  `meta_language_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `parent_type` char(16) default NULL,
  `parent_id` int(11) default NULL,
  `language` char(2) default NULL,
  PRIMARY KEY  (`meta_language_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_language`
--


--
-- Table structure for table `il_meta_lifecycle`
--

CREATE TABLE `il_meta_lifecycle` (
  `meta_lifecycle_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `lifecycle_status` varchar(16) default NULL,
  `meta_version` text,
  `version_language` char(2) binary default NULL,
  PRIMARY KEY  (`meta_lifecycle_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_lifecycle`
--


--
-- Table structure for table `il_meta_location`
--

CREATE TABLE `il_meta_location` (
  `meta_location_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `location` text,
  `location_type` varchar(16) default NULL,
  PRIMARY KEY  (`meta_location_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_location`
--


--
-- Table structure for table `il_meta_meta_data`
--

CREATE TABLE `il_meta_meta_data` (
  `meta_meta_data_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `meta_data_scheme` char(16) default NULL,
  `language` char(2) default NULL,
  PRIMARY KEY  (`meta_meta_data_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_meta_data`
--


--
-- Table structure for table `il_meta_relation`
--

CREATE TABLE `il_meta_relation` (
  `meta_relation_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `kind` char(16) default NULL,
  PRIMARY KEY  (`meta_relation_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_relation`
--


--
-- Table structure for table `il_meta_requirement`
--

CREATE TABLE `il_meta_requirement` (
  `meta_requirement_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `operating_system_name` varchar(16) default NULL,
  `operating_system_minimum_version` text,
  `operating_system_maximum_version` text,
  `browser_name` varchar(32) default NULL,
  `browser_minimum_version` text,
  `browser_maximum_version` text,
  `or_composite_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`meta_requirement_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_requirement`
--


--
-- Table structure for table `il_meta_rights`
--

CREATE TABLE `il_meta_rights` (
  `meta_rights_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `costs` char(3) default NULL,
  `copyright_and_other_restrictions` char(3) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_rights_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_rights`
--


--
-- Table structure for table `il_meta_taxon`
--

CREATE TABLE `il_meta_taxon` (
  `meta_taxon_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `taxon` text,
  `taxon_language` char(2) default NULL,
  `taxon_id` text,
  PRIMARY KEY  (`meta_taxon_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_taxon`
--


--
-- Table structure for table `il_meta_taxon_path`
--

CREATE TABLE `il_meta_taxon_path` (
  `meta_taxon_path_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `source` text,
  `source_language` char(2) default NULL,
  PRIMARY KEY  (`meta_taxon_path_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_taxon_path`
--


--
-- Table structure for table `il_meta_technical`
--

CREATE TABLE `il_meta_technical` (
  `meta_technical_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `size` text,
  `installation_remarks` text,
  `installation_remarks_language` char(2) default NULL,
  `other_platform_requirements` text,
  `other_platform_requirements_language` char(2) default NULL,
  `duration` text,
  PRIMARY KEY  (`meta_technical_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_technical`
--


--
-- Table structure for table `il_meta_typical_age_range`
--

CREATE TABLE `il_meta_typical_age_range` (
  `meta_typical_age_range_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `typical_age_range` text,
  `typical_age_range_language` char(2) default NULL,
  `typical_age_range_min` tinyint(3) NOT NULL default '-1',
  `typical_age_range_max` tinyint(3) NOT NULL default '-1',
  PRIMARY KEY  (`meta_typical_age_range_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_typical_age_range`
--


--
-- Table structure for table `ilinc_data`
--

CREATE TABLE `ilinc_data` (
  `obj_id` int(11) unsigned NOT NULL default '0',
  `type` varchar(5) NOT NULL default '',
  `course_id` int(11) unsigned NOT NULL default '0',
  `contact_name` varchar(255) default NULL,
  `contact_responsibility` varchar(255) default NULL,
  `contact_phone` varchar(255) default NULL,
  `contact_email` varchar(255) default NULL,
  `activation_unlimited` tinyint(2) default NULL,
  `activation_start` int(11) default NULL,
  `activation_end` int(11) default NULL,
  `activation_offline` enum('y','n') default NULL,
  `subscription_unlimited` tinyint(2) default NULL,
  `subscription_start` int(11) default NULL,
  `subscription_end` int(11) default NULL,
  `subscription_type` tinyint(2) default NULL,
  `subscription_password` varchar(32) default NULL,
  `akclassvalue1` varchar(40) default NULL,
  `akclassvalue2` varchar(40) default NULL,
  KEY `obj_id` (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ilinc_data`
--


--
-- Table structure for table `ilinc_registration`
--

CREATE TABLE `ilinc_registration` (
  `obj_id` int(10) unsigned NOT NULL default '0',
  `usr_id` int(10) unsigned NOT NULL default '0',
  `usr_text` varchar(255) default NULL,
  `application_date` datetime default NULL,
  PRIMARY KEY  (`obj_id`),
  KEY `usr_id` (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ilinc_registration`
--


--
-- Table structure for table `int_link`
--

CREATE TABLE `int_link` (
  `source_type` varchar(10) NOT NULL default '',
  `source_id` int(11) NOT NULL default '0',
  `target_type` varchar(4) NOT NULL default '',
  `target_id` int(11) NOT NULL default '0',
  `target_inst` int(11) NOT NULL default '0',
  PRIMARY KEY  (`source_type`,`source_id`,`target_type`,`target_id`,`target_inst`)
) TYPE=MyISAM;

--
-- Dumping data for table `int_link`
--


--
-- Table structure for table `link_check`
--

CREATE TABLE `link_check` (
  `obj_id` int(11) NOT NULL default '0',
  `page_id` int(11) NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  `parent_type` varchar(8) NOT NULL default '',
  `http_status_code` int(4) NOT NULL default '0',
  `last_check` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `link_check`
--


--
-- Table structure for table `link_check_report`
--

CREATE TABLE `link_check_report` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `link_check_report`
--


--
-- Table structure for table `lm_data`
--

CREATE TABLE `lm_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `title` varchar(200) NOT NULL default '',
  `type` char(2) NOT NULL default '',
  `lm_id` int(11) NOT NULL default '0',
  `import_id` varchar(50) NOT NULL default '',
  `public_access` enum('y','n') NOT NULL default 'n',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `active` enum('y','n') default 'y',
  PRIMARY KEY  (`obj_id`),
  KEY `lm_id` (`lm_id`),
  KEY `type` (`type`)
) TYPE=MyISAM;

--
-- Dumping data for table `lm_data`
--

INSERT INTO `lm_data` VALUES (1,'dummy','du',0,'','n','0000-00-00 00:00:00','0000-00-00 00:00:00','y');

--
-- Table structure for table `lm_menu`
--

CREATE TABLE `lm_menu` (
  `id` int(11) NOT NULL auto_increment,
  `lm_id` int(11) NOT NULL default '0',
  `link_type` enum('extern','intern') default NULL,
  `title` varchar(200) default NULL,
  `target` varchar(200) default NULL,
  `link_ref_id` int(11) default NULL,
  `active` enum('y','n') NOT NULL default 'n',
  PRIMARY KEY  (`id`),
  KEY `link_type` (`link_type`),
  KEY `lm_id` (`lm_id`),
  KEY `active` (`active`)
) TYPE=MyISAM;

--
-- Dumping data for table `lm_menu`
--


--
-- Table structure for table `lm_tree`
--

CREATE TABLE `lm_tree` (
  `lm_id` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_lm` (`lm_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `lm_tree`
--


--
-- Table structure for table `lng_data`
--

CREATE TABLE `lng_data` (
  `module` varchar(30) NOT NULL default '',
  `identifier` varchar(50) binary NOT NULL default '',
  `lang_key` char(2) NOT NULL default '',
  `value` blob NOT NULL,
  PRIMARY KEY  (`module`,`identifier`,`lang_key`),
  KEY `module` (`module`),
  KEY `lang_key` (`lang_key`)
) TYPE=MyISAM;

--
-- Dumping data for table `lng_data`
--

INSERT INTO `lng_data` VALUES ('administration','analysis_options','en','Analysis options');
INSERT INTO `lng_data` VALUES ('administration','analyze_data','en','Analyze and repair data integrity');
INSERT INTO `lng_data` VALUES ('administration','analyzing','en','Analyzing...');
INSERT INTO `lng_data` VALUES ('administration','analyzing_tree_structure','en','Analyzing tree structure...');
INSERT INTO `lng_data` VALUES ('administration','check_tree','en','Check tree structure');
INSERT INTO `lng_data` VALUES ('administration','check_tree_desc','en','Check consistence of entire tree structure. Depending on tree size this may take a while!');
INSERT INTO `lng_data` VALUES ('administration','clean','en','Clean up');
INSERT INTO `lng_data` VALUES ('administration','clean_desc','en','Remove invalid references & tree entries. Initialize gaps in tree structure.');
INSERT INTO `lng_data` VALUES ('administration','cleaning','en','Cleaning...');
INSERT INTO `lng_data` VALUES ('administration','cleaning_final','en','Final cleaning...');
INSERT INTO `lng_data` VALUES ('administration','disabled','en','Disabled');
INSERT INTO `lng_data` VALUES ('administration','done','en','Done');
INSERT INTO `lng_data` VALUES ('administration','dump_tree','en','Dump tree');
INSERT INTO `lng_data` VALUES ('administration','dump_tree_desc','en','Perform an analysis of the tree and print all tree nodes along with analysis data.');
INSERT INTO `lng_data` VALUES ('administration','dumping_tree','en','Dumping tree...');
INSERT INTO `lng_data` VALUES ('administration','found','en','found.');
INSERT INTO `lng_data` VALUES ('administration','found_none','en','none found.');
INSERT INTO `lng_data` VALUES ('administration','initializing_gaps','en','Initializing gaps in tree...');
INSERT INTO `lng_data` VALUES ('administration','log_scan','en','Log scan results');
INSERT INTO `lng_data` VALUES ('administration','log_scan_desc','en','Write scan results to \'scanlog.log\' in client data directory.');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_purge','en','Nothing to purge...');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_remove','en','Nothing to remove...');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_restore','en','Nothing to restore...');
INSERT INTO `lng_data` VALUES ('administration','options','en','Options');
INSERT INTO `lng_data` VALUES ('administration','output_options','en','Output options');
INSERT INTO `lng_data` VALUES ('administration','passwd_auto_generate','en','Password Forwarding/Generation');
INSERT INTO `lng_data` VALUES ('administration','purge_missing','en','Purge missing objects');
INSERT INTO `lng_data` VALUES ('administration','purge_missing_desc','en','Remove all missing and unbound objects found from system.');
INSERT INTO `lng_data` VALUES ('administration','purge_trash','en','Purge deleted objects');
INSERT INTO `lng_data` VALUES ('administration','purge_trash_desc','en','Remove all objects in trash bin from system.');
INSERT INTO `lng_data` VALUES ('administration','purging','en','Purging...');
INSERT INTO `lng_data` VALUES ('administration','purging_missing_objs','en','Purging missing objects...');
INSERT INTO `lng_data` VALUES ('administration','purging_trash','en','Purging trash...');
INSERT INTO `lng_data` VALUES ('administration','purging_unbound_objs','en','Purging unbound objects...');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_childs','en','Removing invalid tree entries...');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_refs','en','Removing invalid references...');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_rolfs','en','Removing invalid rolefolders...');
INSERT INTO `lng_data` VALUES ('administration','repair_options','en','Repair options');
INSERT INTO `lng_data` VALUES ('administration','restore_missing','en','Restore missing objects');
INSERT INTO `lng_data` VALUES ('administration','restore_missing_desc','en','Restore missing and unbound objects to RecoveryFolder.');
INSERT INTO `lng_data` VALUES ('administration','restore_trash','en','Restore deleted objects');
INSERT INTO `lng_data` VALUES ('administration','restore_trash_desc','en','Restore all objects in trash bin to RecoveryFolder.');
INSERT INTO `lng_data` VALUES ('administration','restoring','en','Restoring...');
INSERT INTO `lng_data` VALUES ('administration','restoring_missing_objs','en','Restoring missing objects...');
INSERT INTO `lng_data` VALUES ('administration','restoring_trash','en','Restoring trash...');
INSERT INTO `lng_data` VALUES ('administration','restoring_unbound_objs','en','Restoring unbound objects & subobjects...');
INSERT INTO `lng_data` VALUES ('administration','scan','en','Scan');
INSERT INTO `lng_data` VALUES ('administration','scan_completed','en','Scan completed');
INSERT INTO `lng_data` VALUES ('administration','scan_desc','en','Scan system for corrupted/invalid/missing/unbound objects.');
INSERT INTO `lng_data` VALUES ('administration','scan_details','en','Scan details');
INSERT INTO `lng_data` VALUES ('administration','scan_modes','en','Scan modes used');
INSERT INTO `lng_data` VALUES ('administration','scanning_system','en','Scanning system...');
INSERT INTO `lng_data` VALUES ('administration','searching_deleted_objs','en','Searching for deleted objects...');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_childs','en','Searching for invalid tree entries...');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_refs','en','Searching for invalid references...');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_rolfs','en','Searching for invalid rolefolders...');
INSERT INTO `lng_data` VALUES ('administration','searching_missing_objs','en','Searching for missing objects...');
INSERT INTO `lng_data` VALUES ('administration','searching_unbound_objs','en','Searching for unbound objects...');
INSERT INTO `lng_data` VALUES ('administration','skipped','en','skipped');
INSERT INTO `lng_data` VALUES ('administration','start_scan','en','Start!');
INSERT INTO `lng_data` VALUES ('administration','stop_scan','en','Stop!');
INSERT INTO `lng_data` VALUES ('administration','systemcheck','en','System check');
INSERT INTO `lng_data` VALUES ('administration','tree_corrupt','en','Tree is corrupted! See scan log for details.');
INSERT INTO `lng_data` VALUES ('administration','view_last_log','en','View last Scan log');
INSERT INTO `lng_data` VALUES ('administration','view_log','en','View details');
INSERT INTO `lng_data` VALUES ('assessment','0_unlimited','en','(0=unlimited)');
INSERT INTO `lng_data` VALUES ('assessment','action','en','Action');
INSERT INTO `lng_data` VALUES ('assessment','add_answer','en','Add answer');
INSERT INTO `lng_data` VALUES ('assessment','add_answer_tf','en','true/false answers');
INSERT INTO `lng_data` VALUES ('assessment','add_answer_yn','en','yes/no answers');
INSERT INTO `lng_data` VALUES ('assessment','add_applet_parameter','en','Add applet parameter');
INSERT INTO `lng_data` VALUES ('assessment','add_area','en','Add area');
INSERT INTO `lng_data` VALUES ('assessment','add_gap','en','Add Gap Text');
INSERT INTO `lng_data` VALUES ('assessment','add_imagemap','en','Import image map');
INSERT INTO `lng_data` VALUES ('assessment','add_matching_pair','en','Add matching pair');
INSERT INTO `lng_data` VALUES ('assessment','add_questionpool','en','Add question pool');
INSERT INTO `lng_data` VALUES ('assessment','add_solution','en','Add suggested solution');
INSERT INTO `lng_data` VALUES ('assessment','all_available_question_pools','en','All available question pools');
INSERT INTO `lng_data` VALUES ('assessment','answer','en','Answer');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_not_correct_but_positive','en','You\'ve got points for your solution but it\'s not the best solution');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_right','en','Your solution is correct');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_wrong','en','Your solution is wrong');
INSERT INTO `lng_data` VALUES ('assessment','answer_picture','en','Answer picture');
INSERT INTO `lng_data` VALUES ('assessment','answer_text','en','Answer text');
INSERT INTO `lng_data` VALUES ('assessment','applet_attributes','en','Applet attributes');
INSERT INTO `lng_data` VALUES ('assessment','applet_new_parameter','en','New parameter');
INSERT INTO `lng_data` VALUES ('assessment','applet_parameter','en','Parameter');
INSERT INTO `lng_data` VALUES ('assessment','applet_parameters','en','Applet parameters');
INSERT INTO `lng_data` VALUES ('assessment','apply','en','Apply');
INSERT INTO `lng_data` VALUES ('assessment','assClozeTest','en','Cloze Question');
INSERT INTO `lng_data` VALUES ('assessment','assImagemapQuestion','en','Image Map Question');
INSERT INTO `lng_data` VALUES ('assessment','assJavaApplet','en','Java Applet Question');
INSERT INTO `lng_data` VALUES ('assessment','assMatchingQuestion','en','Matching Question');
INSERT INTO `lng_data` VALUES ('assessment','assMultipleChoice','en','Multiple Choice Question (multiple response)');
INSERT INTO `lng_data` VALUES ('assessment','assNumeric','en','Numeric question');
INSERT INTO `lng_data` VALUES ('assessment','assOrderingQuestion','en','Ordering Question');
INSERT INTO `lng_data` VALUES ('assessment','assQuestions','en','Questions');
INSERT INTO `lng_data` VALUES ('assessment','assSingleChoice','en','Multiple Choice Question (single response)');
INSERT INTO `lng_data` VALUES ('assessment','assTextQuestion','en','Essay Question');
INSERT INTO `lng_data` VALUES ('assessment','assTextSubset','en','Text subset question');
INSERT INTO `lng_data` VALUES ('assessment','ass_create_export_file','en','Create export file');
INSERT INTO `lng_data` VALUES ('assessment','ass_create_export_test_results','en','Export test results');
INSERT INTO `lng_data` VALUES ('assessment','ass_export_files','en','Export files');
INSERT INTO `lng_data` VALUES ('assessment','ass_file','en','File');
INSERT INTO `lng_data` VALUES ('assessment','ass_question','en','Question');
INSERT INTO `lng_data` VALUES ('assessment','ass_size','en','Size');
INSERT INTO `lng_data` VALUES ('assessment','available_points','en','Available points');
INSERT INTO `lng_data` VALUES ('assessment','average_reached_points','en','Average reached points');
INSERT INTO `lng_data` VALUES ('assessment','backtocallingtest','en','Back to the calling test');
INSERT INTO `lng_data` VALUES ('assessment','by','en','by');
INSERT INTO `lng_data` VALUES ('assessment','cancel_test','en','Suspend the test');
INSERT INTO `lng_data` VALUES ('assessment','cannot_edit_marks','en','There are already learners who ran the test. You can only change the marks if a score reporting date is enabled and the reporting date is not yet reached.');
INSERT INTO `lng_data` VALUES ('assessment','cannot_edit_test','en','You do not possess sufficient permissions to edit the test!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_execute_test','en','You do not possess sufficient permissions to run the test!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_export_qpl','en','You do not possess sufficient permissions to export the question pool!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_export_test','en','You do not possess sufficient permissions to export the test!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_maintain_test','en','You do not possess sufficient permissions to maintain the test!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_read_questionpool','en','You do not possess sufficient permissions to read the question pool data!');
INSERT INTO `lng_data` VALUES ('assessment','cannot_save_metaobject','en','You do not possess sufficient permissions to save the meta data!');
INSERT INTO `lng_data` VALUES ('assessment','change_properties_from_random_to_standard','en','You are about to change your test properties from a random test to a non random test. The information on the question pools you already added to the random test will be removed from test. Do you really want to change the test properties?');
INSERT INTO `lng_data` VALUES ('assessment','change_properties_from_standard_to_random','en','You are about to change your test properties from a non random test to a random test. The questions you already added to the test will be removed, because you have to select question pools for a random test. Do you really want to change the test properties?');
INSERT INTO `lng_data` VALUES ('assessment','change_solution','en','Change suggested solution');
INSERT INTO `lng_data` VALUES ('assessment','changelog_description','en','The following table contains all changes of authors which have been made to this test.');
INSERT INTO `lng_data` VALUES ('assessment','changelog_heading','en','Changelog');
INSERT INTO `lng_data` VALUES ('assessment','checkbox_checked','en','Checked');
INSERT INTO `lng_data` VALUES ('assessment','checkbox_unchecked','en','Unchecked');
INSERT INTO `lng_data` VALUES ('assessment','circle','en','Circle');
INSERT INTO `lng_data` VALUES ('assessment','circle_click_center','en','Please click on center of the desired area.');
INSERT INTO `lng_data` VALUES ('assessment','circle_click_circle','en','Please click on a circle point of the desired area.');
INSERT INTO `lng_data` VALUES ('assessment','clientip','en','Client IP');
INSERT INTO `lng_data` VALUES ('assessment','close_text_hint','en','You can define a gap by entering [gap][/gap] at the text position of your choice. Press the \'Create gaps\' button to add an editable form for every gap.');
INSERT INTO `lng_data` VALUES ('assessment','cloze_text','en','Cloze text');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_case_insensitive','en','Case insensitive');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_case_sensitive','en','Case sensitive');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_levenshtein_of','en','Levenshtein distance of %s');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_rating','en','Text gap rating');
INSERT INTO `lng_data` VALUES ('assessment','code','en','Code');
INSERT INTO `lng_data` VALUES ('assessment','codebase','en','Codebase');
INSERT INTO `lng_data` VALUES ('assessment','concatenation','en','Concatenation');
INSERT INTO `lng_data` VALUES ('assessment','confirm_delete_all_user_data','en','Are you sure you want to delete all user data of the test?');
INSERT INTO `lng_data` VALUES ('assessment','confirm_delete_single_user_data','en','Are you sure you want to delete the test data of the selected users?');
INSERT INTO `lng_data` VALUES ('assessment','confirm_sync_questions','en','The question you changed is a copy which has been created for use with the active test. Do you want to change the original of the question too?');
INSERT INTO `lng_data` VALUES ('assessment','coordinates','en','Coordinates');
INSERT INTO `lng_data` VALUES ('assessment','correct_solution_is','en','The correct solution is');
INSERT INTO `lng_data` VALUES ('assessment','counter','en','Counter');
INSERT INTO `lng_data` VALUES ('assessment','create_date','en','Created');
INSERT INTO `lng_data` VALUES ('assessment','create_gaps','en','Create gaps');
INSERT INTO `lng_data` VALUES ('assessment','create_imagemap','en','Create an Image map');
INSERT INTO `lng_data` VALUES ('assessment','create_new','en','Create new');
INSERT INTO `lng_data` VALUES ('assessment','definition','en','Definition');
INSERT INTO `lng_data` VALUES ('assessment','delete_area','en','Delete area');
INSERT INTO `lng_data` VALUES ('assessment','delete_image','en','Delete image');
INSERT INTO `lng_data` VALUES ('assessment','delete_user_data','en','Delete test data of the selected users');
INSERT INTO `lng_data` VALUES ('assessment','description_maxchars','en','If nothing entered the maximum number of characters for this text answer is unlimited.');
INSERT INTO `lng_data` VALUES ('assessment','detail_ending_time_reached','en','You have reached the ending time of the test. The test isn\'t available since %s');
INSERT INTO `lng_data` VALUES ('assessment','detail_max_processing_time_reached','en','You have reached the maximum allowed processing time of the test!');
INSERT INTO `lng_data` VALUES ('assessment','detail_starting_time_not_reached','en','You have not reached the starting time of the test. The test will be available on %s');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output','en','Detailed output');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output_printview','en','Detailed output with question printviews');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output_solutions','en','Detailed output with question solutions');
INSERT INTO `lng_data` VALUES ('assessment','direct_feedback','en','Verify your solution');
INSERT INTO `lng_data` VALUES ('assessment','duplicate','en','Duplicate');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_matching_values_selected','en','You have selected duplicate matching values!');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_order_values_entered','en','You have entered duplicate order values!');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_qpl','en','Duplicate question pool for test');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_tst','en','Duplicate test');
INSERT INTO `lng_data` VALUES ('assessment','ects_allow_ects_grades','en','Show ECTS grade additional to received mark');
INSERT INTO `lng_data` VALUES ('assessment','ects_fill_out_all_values','en','Please enter a value for every ECTS grade!');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade','en','ECTS grade');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_a','en','outstanding performance with only minor errors');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_a_short','en','EXCELLENT');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_b','en','above the average standard but with some errors');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_b_short','en','VERY GOOD');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_c','en','generally sound work with a number of notable errors');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_c_short','en','GOOD');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_d','en','fair but with significant shortcomings');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_d_short','en','SATISFACTORY');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_e','en','performance meets the minimum criteria');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_e_short','en','SUFFICIENT');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_f','en','considerable further work is required');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_f_short','en','FAIL');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_fx','en','some more work required before the credit can be awarded');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_fx_short','en','FAIL');
INSERT INTO `lng_data` VALUES ('assessment','ects_output_of_ects_grades','en','Output of ECTS grades');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_a','en','Please enter a value between 0 and 100 for ECTS grade A!');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_b','en','Please enter a value between 0 and 100 for ECTS grade B!');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_c','en','Please enter a value between 0 and 100 for ECTS grade C!');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_d','en','Please enter a value between 0 and 100 for ECTS grade D!');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_e','en','Please enter a value between 0 and 100 for ECTS grade E!');
INSERT INTO `lng_data` VALUES ('assessment','ects_use_fx_grade','en','Use the \'FX\' grade, if failed participants reached at least');
INSERT INTO `lng_data` VALUES ('assessment','ects_use_fx_grade_part2','en','percent of the total points.');
INSERT INTO `lng_data` VALUES ('assessment','edit_content','en','Edit content');
INSERT INTO `lng_data` VALUES ('assessment','edit_properties','en','Edit properties');
INSERT INTO `lng_data` VALUES ('assessment','end_tag','en','End tag');
INSERT INTO `lng_data` VALUES ('assessment','ending_time_reached','en','You have reached the ending time');
INSERT INTO `lng_data` VALUES ('assessment','enlarge','en','enlarge');
INSERT INTO `lng_data` VALUES ('assessment','enter_anonymous_code','en','Enter anonymous access code');
INSERT INTO `lng_data` VALUES ('assessment','enter_enough_positive_points','en','The maxium available points for the question must be greater than 0! Please enter sufficient non negative points for your answers.');
INSERT INTO `lng_data` VALUES ('assessment','error_image_upload_copy_file','en','There was an error moving the uploaded image file to its destination folder!');
INSERT INTO `lng_data` VALUES ('assessment','error_image_upload_wrong_format','en','Please upload a valid image file! Supported image formats are gif, jpeg and png.');
INSERT INTO `lng_data` VALUES ('assessment','error_importing_question','en','There was an error importing the question(s) from the file you have selected!');
INSERT INTO `lng_data` VALUES ('assessment','error_open_image_file','en','Error opening an image file!');
INSERT INTO `lng_data` VALUES ('assessment','error_open_java_file','en','Error opening an java applet!');
INSERT INTO `lng_data` VALUES ('assessment','error_save_image_file','en','Error saving an image file!');
INSERT INTO `lng_data` VALUES ('assessment','eval_all_users','en','Evaluation for all users');
INSERT INTO `lng_data` VALUES ('assessment','eval_choice_result','en','The choice with the value %s is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_cloze_result','en','Gap number %s with the value %s is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_concatenation','en','Concatenation');
INSERT INTO `lng_data` VALUES ('assessment','eval_data','en','Evaluation Data');
INSERT INTO `lng_data` VALUES ('assessment','eval_found_selected_groups','en','Selected groups');
INSERT INTO `lng_data` VALUES ('assessment','eval_found_selected_users','en','Selected users');
INSERT INTO `lng_data` VALUES ('assessment','eval_imagemap_result','en','The image map selection is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_java_result','en','The answer for the value %s is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_legend_link','en','Please refer to the legend for the meaning of the column header symbols.');
INSERT INTO `lng_data` VALUES ('assessment','eval_matching_result','en','The matching pair %s - %s is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_order_result','en','The order for the value %s is %s. You received %s points.');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_groups','en','Groups');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_roles','en','Roles');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_term','en','Search term');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_users','en','Users');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_userselection','en','Search the users you want to add to the statistical evaluation');
INSERT INTO `lng_data` VALUES ('assessment','eval_selected_users','en','Evaluation for selected users');
INSERT INTO `lng_data` VALUES ('assessment','exp_eval_data','en','Export evaluation data as');
INSERT INTO `lng_data` VALUES ('assessment','exp_type_excel','en','Microsoft Excel');
INSERT INTO `lng_data` VALUES ('assessment','exp_type_spss','en','Comma separated value (CSV)');
INSERT INTO `lng_data` VALUES ('assessment','export','en','Export');
INSERT INTO `lng_data` VALUES ('assessment','failed_official','en','failed');
INSERT INTO `lng_data` VALUES ('assessment','failed_short','en','failed');
INSERT INTO `lng_data` VALUES ('assessment','false','en','False');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_answer_fields','en','Please fill out all answer text fields before you add a new one!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_matching_pairs','en','Please fill out all matching pairs before you add a new one!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_add_answer','en','Please fill out all required fields before you add answers!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_add_matching','en','Please fill out all required fields before you add a matching pair!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_create_gaps','en','Please fill out all required fields before you create gaps!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_image','en','Please fill out all required fields before you upload images!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_imagemap','en','Please fill out all required fields before you upload image maps!');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_material','en','Please fill out all required fields before you upload materials!');
INSERT INTO `lng_data` VALUES ('assessment','filter','en','Filter');
INSERT INTO `lng_data` VALUES ('assessment','filter_all_question_types','en','All question types');
INSERT INTO `lng_data` VALUES ('assessment','filter_all_questionpools','en','All question pools');
INSERT INTO `lng_data` VALUES ('assessment','filter_show_question_types','en','Show question types');
INSERT INTO `lng_data` VALUES ('assessment','filter_show_questionpools','en','Show question pools');
INSERT INTO `lng_data` VALUES ('assessment','filter_users','en','Filter users');
INSERT INTO `lng_data` VALUES ('assessment','gap','en','Gap');
INSERT INTO `lng_data` VALUES ('assessment','gap_definition','en','Gap definition');
INSERT INTO `lng_data` VALUES ('assessment','gap_selection','en','Gap selection');
INSERT INTO `lng_data` VALUES ('assessment','glossary_term','en','Glossary term');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers','en','Graphical answer support');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers_hide','en','Hide graphical answer support');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers_show','en','Show graphical answer support');
INSERT INTO `lng_data` VALUES ('assessment','height','en','Height');
INSERT INTO `lng_data` VALUES ('assessment','imagemap','en','Image map');
INSERT INTO `lng_data` VALUES ('assessment','imagemap_file','en','Image map file');
INSERT INTO `lng_data` VALUES ('assessment','imagemap_source','en','Image map source');
INSERT INTO `lng_data` VALUES ('assessment','import_errors_qti','en','The were errors parsing the QTI file. The import was cancelled.');
INSERT INTO `lng_data` VALUES ('assessment','import_question','en','Import question(s)');
INSERT INTO `lng_data` VALUES ('assessment','insert_after','en','Insert after');
INSERT INTO `lng_data` VALUES ('assessment','insert_before','en','Insert before');
INSERT INTO `lng_data` VALUES ('assessment','internal_links','en','Internal Links');
INSERT INTO `lng_data` VALUES ('assessment','internal_links_update','en','Update');
INSERT INTO `lng_data` VALUES ('assessment','javaapplet','en','Java Applet');
INSERT INTO `lng_data` VALUES ('assessment','javaapplet_successful_saved','en','Your results have been saved successful!');
INSERT INTO `lng_data` VALUES ('assessment','javaapplet_unsuccessful_saved','en','There was an error saving the question results!');
INSERT INTO `lng_data` VALUES ('assessment','keywords_hint','en','Enter a list of keywords, separated by spaces or newlines to add an automatic scoring option for the essay question. If any of the keywords will be found in the answertext of the learner, the default score will be set to the maximum available points instead of 0 points.');
INSERT INTO `lng_data` VALUES ('assessment','last_update','en','Last update');
INSERT INTO `lng_data` VALUES ('assessment','legend','en','Legend');
INSERT INTO `lng_data` VALUES ('assessment','locked','en','locked');
INSERT INTO `lng_data` VALUES ('assessment','log_could_not_enter_test_due_to_simultaneous_users','en','The user could not enter the test because the maximum number of simultaneous users has been reached');
INSERT INTO `lng_data` VALUES ('assessment','log_create_new_test','en','Created new test');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_added','en','Mark added');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_changed','en','Mark changed');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_removed','en','Mark removed');
INSERT INTO `lng_data` VALUES ('assessment','log_modified_test','en','The test was modified');
INSERT INTO `lng_data` VALUES ('assessment','log_no_test_fields_changed','en','Saved, but nothing changed');
INSERT INTO `lng_data` VALUES ('assessment','log_question_added','en','Question added at position');
INSERT INTO `lng_data` VALUES ('assessment','log_question_position_changed','en','Question position changed');
INSERT INTO `lng_data` VALUES ('assessment','log_question_removed','en','Question removed');
INSERT INTO `lng_data` VALUES ('assessment','log_random_question_pool_added','en','Added the question pool \'%s\' with %s questions for the random test');
INSERT INTO `lng_data` VALUES ('assessment','log_random_question_pool_deleted','en','Removed all random question pools for the test');
INSERT INTO `lng_data` VALUES ('assessment','log_selected_user_data_removed','en','Removed test data of user %s');
INSERT INTO `lng_data` VALUES ('assessment','log_total_amount_of_questions','en','Set the total amount of questions for the random test to %s');
INSERT INTO `lng_data` VALUES ('assessment','log_user_answered_question','en','User answered a question and received %s points');
INSERT INTO `lng_data` VALUES ('assessment','log_user_data_removed','en','Removed all user data');
INSERT INTO `lng_data` VALUES ('assessment','log_user_entered_values','en','User entered values');
INSERT INTO `lng_data` VALUES ('assessment','log_user_not_entered_values','en','User did not enter values');
INSERT INTO `lng_data` VALUES ('assessment','maintenance','en','Maintenance');
INSERT INTO `lng_data` VALUES ('assessment','mark_schema','en','Mark schema');
INSERT INTO `lng_data` VALUES ('assessment','match_terms_and_definitions','en','Match terms and definitions');
INSERT INTO `lng_data` VALUES ('assessment','match_terms_and_pictures','en','Match terms and pictures');
INSERT INTO `lng_data` VALUES ('assessment','matches','en','matches');
INSERT INTO `lng_data` VALUES ('assessment','matching_pair','en','Matching pair');
INSERT INTO `lng_data` VALUES ('assessment','matching_question_javascript_hint','en','Please drag a definition/picture on the right side over a term on the left side and drop the definition/picture to match the term with the definition/picture.');
INSERT INTO `lng_data` VALUES ('assessment','material','en','Material');
INSERT INTO `lng_data` VALUES ('assessment','material_download','en','Material to download');
INSERT INTO `lng_data` VALUES ('assessment','material_file','en','Material file');
INSERT INTO `lng_data` VALUES ('assessment','maxchars','en','Maximum number of characters');
INSERT INTO `lng_data` VALUES ('assessment','maximum_nr_of_tries_reached','en','You have reached the maximum number of passes for this test. The test cannot be entered!');
INSERT INTO `lng_data` VALUES ('assessment','maximum_points','en','Maxium available points');
INSERT INTO `lng_data` VALUES ('assessment','meaning','en','Meaning');
INSERT INTO `lng_data` VALUES ('assessment','min_percentage_ne_0','en','You must define a minimum percentage of 0 percent! The mark schema wasn\'t saved.');
INSERT INTO `lng_data` VALUES ('assessment','multiline_answers_hide','en','Use single-line answers');
INSERT INTO `lng_data` VALUES ('assessment','multiline_answers_show','en','Use multi-line answers');
INSERT INTO `lng_data` VALUES ('assessment','multiline_terms_hide','en','Use single-line terms');
INSERT INTO `lng_data` VALUES ('assessment','multiline_terms_show','en','Use multi-line terms');
INSERT INTO `lng_data` VALUES ('assessment','negative_points_not_allowed','en','You are not allowed to enter negative points!');
INSERT INTO `lng_data` VALUES ('assessment','next_question_rows','en','Questions %d - %d of %d >>');
INSERT INTO `lng_data` VALUES ('assessment','no_passed_mark','en','You must set at least one mark to PASSED! The mark schema wasn\'t saved.');
INSERT INTO `lng_data` VALUES ('assessment','no_question_selected_for_move','en','Please check at least one question to move it!');
INSERT INTO `lng_data` VALUES ('assessment','no_questions_available','en','There are no questions available!');
INSERT INTO `lng_data` VALUES ('assessment','no_target_selected_for_move','en','You must select a target position!');
INSERT INTO `lng_data` VALUES ('assessment','no_user_or_group_selected','en','Please check an option what are you searching for (users, groups, roles)!');
INSERT INTO `lng_data` VALUES ('assessment','not_worked_through','en','Not answered');
INSERT INTO `lng_data` VALUES ('assessment','nr_of_correct_answers','en','Number of requested answers');
INSERT INTO `lng_data` VALUES ('assessment','online_exam_show_answer_print_sheet','en','You have finished your online exam. To call the answers printview to print out your test results please press the &quot;Answers printview&quot; button.');
INSERT INTO `lng_data` VALUES ('assessment','online_exam_show_finish_test','en','You still have to call the final submission of your online exam. Please press the &quot;Finish the test&quot; button to call the final submission.');
INSERT INTO `lng_data` VALUES ('assessment','optional_keywords','en','Optional input of keywords');
INSERT INTO `lng_data` VALUES ('assessment','or','en','or');
INSERT INTO `lng_data` VALUES ('assessment','order_pictures','en','Order pictures');
INSERT INTO `lng_data` VALUES ('assessment','order_terms','en','Order terms');
INSERT INTO `lng_data` VALUES ('assessment','ordering_question_javascript_hint','en','Please drag a definition/picture over the definition/picture where you want to put it and drop it. The underlying definition/picture and all following definitions/pictures will move downwards.');
INSERT INTO `lng_data` VALUES ('assessment','output_mode','en','Output mode');
INSERT INTO `lng_data` VALUES ('assessment','participants','en','Participants');
INSERT INTO `lng_data` VALUES ('assessment','pass','en','Pass');
INSERT INTO `lng_data` VALUES ('assessment','passed_official','en','passed');
INSERT INTO `lng_data` VALUES ('assessment','passed_only','en','Passed tests only');
INSERT INTO `lng_data` VALUES ('assessment','passed_short','en','passed');
INSERT INTO `lng_data` VALUES ('assessment','percentage_solved','en','You have solved %.2f percent of this question!');
INSERT INTO `lng_data` VALUES ('assessment','percentile','en','Percentile');
INSERT INTO `lng_data` VALUES ('assessment','picture','en','Picture');
INSERT INTO `lng_data` VALUES ('assessment','please_select','en','-- please select --');
INSERT INTO `lng_data` VALUES ('assessment','point','en','Point');
INSERT INTO `lng_data` VALUES ('assessment','points','en','Points');
INSERT INTO `lng_data` VALUES ('assessment','points_checked','en','Points when checked');
INSERT INTO `lng_data` VALUES ('assessment','points_short','en','Pt.');
INSERT INTO `lng_data` VALUES ('assessment','points_unchecked','en','Points when unchecked');
INSERT INTO `lng_data` VALUES ('assessment','polygon','en','Polygon');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_next_or_save','en','Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_next_point','en','Please click on the next point of the polygon.');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_starting_point','en','Please click on the starting point of the polygon.');
INSERT INTO `lng_data` VALUES ('assessment','postpone','en','Postpone question');
INSERT INTO `lng_data` VALUES ('assessment','postponed','en','postponed');
INSERT INTO `lng_data` VALUES ('assessment','preview','en','Preview');
INSERT INTO `lng_data` VALUES ('assessment','previous_question_rows','en','<< Questions %d - %d of %d');
INSERT INTO `lng_data` VALUES ('assessment','print_answers','en','Print Answers');
INSERT INTO `lng_data` VALUES ('assessment','print_view','en','Print view');
INSERT INTO `lng_data` VALUES ('assessment','qpl_answertext_fields_not_filled','en','The question could only be saved, if you fill out all answer text fields!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_no_assessment_of_questions','en','There is no assessment of questions available for the selected question. The question was never used in a test.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_of_questions','en','Assessment of questions');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_total_of_answers','en','Total of answers');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_total_of_right_answers','en','Total percentage of right answers (percentage of maximum points)');
INSERT INTO `lng_data` VALUES ('assessment','qpl_confirm_delete_questions','en','Are you sure you want to delete the following question(s)?');
INSERT INTO `lng_data` VALUES ('assessment','qpl_copy_insert_clipboard','en','The selected question(s) are copied to the clipboard');
INSERT INTO `lng_data` VALUES ('assessment','qpl_copy_select_none','en','Please check at least one question to copy it to the clipboard');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_describe_undeleteable_questions','en','The following questions are in use in random tests. You cannot delete these questions:');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_no_deleteable_questions','en','All questions you tried to delete are in use in a random test');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_rbac_error','en','You have no rights to delete this question!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_select_none','en','Please check at least one question to delete it');
INSERT INTO `lng_data` VALUES ('assessment','qpl_display_fullsize_image','en','Click here to display the original image!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_duplicate_select_none','en','Please check at least one question to duplicate it');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_rbac_error','en','You have no rights to edit this question!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_select_multiple','en','Please check only one question for editing');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_select_none','en','Please check one question for editing');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_excel','en','Microsoft Excel file');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_select_none','en','Please check at least one question to export it');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_xml','en','QTI XML file');
INSERT INTO `lng_data` VALUES ('assessment','qpl_general_properties','en','General properties');
INSERT INTO `lng_data` VALUES ('assessment','qpl_imagemap_preview_missing','en','ILIAS could not create the temporary preview file containing the imagemap areas. The original image is shown instead. This means that either the webserver\'s ImageMagick tool isn\'t configured correctly or there are no write permissions in the temporary directory! Please contact your system administrator.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_create_new_qpl','en','Import the questions in a new question pool');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_no_items','en','Error: The import file contains no questions!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_non_ilias_files','en','Error: The import file contains QTI files which are not created by an ILIAS system. Please contact the ILIAS team to get in import filter for your QTI file format.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_verify_found_questions','en','ILIAS found the following questions in the import file. Please select the questions you want to import.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_move_insert_clipboard','en','The selected question(s) are marked for moving');
INSERT INTO `lng_data` VALUES ('assessment','qpl_move_select_none','en','Please check at least one question to select it for moving');
INSERT INTO `lng_data` VALUES ('assessment','qpl_online_property','en','Online');
INSERT INTO `lng_data` VALUES ('assessment','qpl_online_property_description','en','Only online question pools could be used in tests.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_paste_no_objects','en','There are no questions in the clipboard. Please copy or move a question into the clipboard.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_paste_success','en','The question(s) have been pasted into the question pool');
INSERT INTO `lng_data` VALUES ('assessment','qpl_question_is_in_use','en','The question you are about to edit exists in %s test(s). If you change this question, you will NOT change the question(s) in the test(s), because the system creates a copy of a question when it is inserted in a test!');
INSERT INTO `lng_data` VALUES ('assessment','qpl_questions_deleted','en','Question(s) deleted.');
INSERT INTO `lng_data` VALUES ('assessment','qpl_select_file_for_import','en','You must select a file for import!');
INSERT INTO `lng_data` VALUES ('assessment','qt_multiple_choice','en','Multiple Choice Question');
INSERT INTO `lng_data` VALUES ('assessment','question_saved_for_upload','en','The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!');
INSERT INTO `lng_data` VALUES ('assessment','question_short','en','Q');
INSERT INTO `lng_data` VALUES ('assessment','question_summary','en','Question Summary');
INSERT INTO `lng_data` VALUES ('assessment','question_title','en','Question title');
INSERT INTO `lng_data` VALUES ('assessment','question_type','en','Question Type');
INSERT INTO `lng_data` VALUES ('assessment','questionpool_not_entered','en','Please enter a name for a question pool!');
INSERT INTO `lng_data` VALUES ('assessment','questions_from','en','questions from');
INSERT INTO `lng_data` VALUES ('assessment','radio_set','en','Set');
INSERT INTO `lng_data` VALUES ('assessment','radio_unset','en','Unset');
INSERT INTO `lng_data` VALUES ('assessment','random_accept_sample','en','Accept sample');
INSERT INTO `lng_data` VALUES ('assessment','random_another_sample','en','Get another sample');
INSERT INTO `lng_data` VALUES ('assessment','random_selection','en','Random selection');
INSERT INTO `lng_data` VALUES ('assessment','range','en','Range');
INSERT INTO `lng_data` VALUES ('assessment','range_lower_limit','en','Lower limit');
INSERT INTO `lng_data` VALUES ('assessment','range_upper_limit','en','Upper limit');
INSERT INTO `lng_data` VALUES ('assessment','rectangle','en','Rectangle');
INSERT INTO `lng_data` VALUES ('assessment','rectangle_click_br_corner','en','Please click on the bottom right corner of the desired area.');
INSERT INTO `lng_data` VALUES ('assessment','rectangle_click_tl_corner','en','Please click on the top left corner of the desired area.');
INSERT INTO `lng_data` VALUES ('assessment','region','en','Region');
INSERT INTO `lng_data` VALUES ('assessment','remove_question','en','Remove');
INSERT INTO `lng_data` VALUES ('assessment','remove_solution','en','Remove suggested solution');
INSERT INTO `lng_data` VALUES ('assessment','report_date_not_reached','en','You have not reached the reporting date. You will be able to view the test results at %s');
INSERT INTO `lng_data` VALUES ('assessment','reset_definitions','en','Reset definition positions');
INSERT INTO `lng_data` VALUES ('assessment','reset_filter','en','Reset filter');
INSERT INTO `lng_data` VALUES ('assessment','reset_pictures','en','Reset picture positions');
INSERT INTO `lng_data` VALUES ('assessment','result','en','Result');
INSERT INTO `lng_data` VALUES ('assessment','save_before_upload_imagemap','en','You must apply your changes before you can upload an image map!');
INSERT INTO `lng_data` VALUES ('assessment','save_before_upload_javaapplet','en','You must apply your changes before you can upload a Java applet!');
INSERT INTO `lng_data` VALUES ('assessment','save_edit','en','Save and edit content');
INSERT INTO `lng_data` VALUES ('assessment','save_finish','en','Finish the test');
INSERT INTO `lng_data` VALUES ('assessment','save_introduction','en','Go to introduction');
INSERT INTO `lng_data` VALUES ('assessment','save_next','en','Next');
INSERT INTO `lng_data` VALUES ('assessment','save_previous','en','Previous');
INSERT INTO `lng_data` VALUES ('assessment','save_text_answer_points','en','Save essay points');
INSERT INTO `lng_data` VALUES ('assessment','scored_pass','en','Scored pass');
INSERT INTO `lng_data` VALUES ('assessment','search_found_groups','en','Found groups');
INSERT INTO `lng_data` VALUES ('assessment','search_found_users','en','Found users');
INSERT INTO `lng_data` VALUES ('assessment','search_groups','en','Search Groups');
INSERT INTO `lng_data` VALUES ('assessment','search_roles','en','Search Roles');
INSERT INTO `lng_data` VALUES ('assessment','search_term','en','Search Term');
INSERT INTO `lng_data` VALUES ('assessment','search_users','en','Search Users');
INSERT INTO `lng_data` VALUES ('assessment','see_details_for_further_information','en','See details for suggested solutions');
INSERT INTO `lng_data` VALUES ('assessment','select_an_answer','en','--- Please select an answer ---');
INSERT INTO `lng_data` VALUES ('assessment','select_gap','en','Select gap');
INSERT INTO `lng_data` VALUES ('assessment','select_max_one_item','en','Please select one item only');
INSERT INTO `lng_data` VALUES ('assessment','select_one_submitted_test','en','Please select at least one user who finished the test');
INSERT INTO `lng_data` VALUES ('assessment','select_one_user','en','Please select at least one user');
INSERT INTO `lng_data` VALUES ('assessment','select_qpl_option','en','--- Please select a question pool ---');
INSERT INTO `lng_data` VALUES ('assessment','select_target_position_for_move_question','en','Please select a target position to move the question(s) and press one of the insert buttons!');
INSERT INTO `lng_data` VALUES ('assessment','select_tst_option','en','--- Please select a test ---');
INSERT INTO `lng_data` VALUES ('assessment','selected_image','en','Selected image');
INSERT INTO `lng_data` VALUES ('assessment','set_edit_mode','en','Set edit mode');
INSERT INTO `lng_data` VALUES ('assessment','set_filter','en','Set filter');
INSERT INTO `lng_data` VALUES ('assessment','shape','en','Shape');
INSERT INTO `lng_data` VALUES ('assessment','shuffle_answers','en','Shuffle answers');
INSERT INTO `lng_data` VALUES ('assessment','solution_comment_count_system','en','Questions which are answered partially correct will be scored with 0 points');
INSERT INTO `lng_data` VALUES ('assessment','solution_comment_mc_scoring','en','Multiple choice questions with no checked answer will be scored with 0 points');
INSERT INTO `lng_data` VALUES ('assessment','solution_comment_score_cutting','en','If the question result is negative, the points have been cut to zero points');
INSERT INTO `lng_data` VALUES ('assessment','solution_hint','en','Suggested solution');
INSERT INTO `lng_data` VALUES ('assessment','solution_may_contain_keywords','en','The solution may contain one of the following keywords');
INSERT INTO `lng_data` VALUES ('assessment','solution_order','en','Solution order');
INSERT INTO `lng_data` VALUES ('assessment','start_tag','en','Start tag');
INSERT INTO `lng_data` VALUES ('assessment','starting_time_not_reached','en','You have not reached the starting time');
INSERT INTO `lng_data` VALUES ('assessment','statistical_data','en','Statistical data');
INSERT INTO `lng_data` VALUES ('assessment','statistics','en','Statistics');
INSERT INTO `lng_data` VALUES ('assessment','suggested_solution_added_successfully','en','You successfully set a suggested solution!');
INSERT INTO `lng_data` VALUES ('assessment','symbol','en','Symbol');
INSERT INTO `lng_data` VALUES ('assessment','term','en','Term');
INSERT INTO `lng_data` VALUES ('assessment','test_cancelled','en','The test was cancelled');
INSERT INTO `lng_data` VALUES ('assessment','test_reference','en','Test reference');
INSERT INTO `lng_data` VALUES ('assessment','text_answers_saved','en','Essay points modified!');
INSERT INTO `lng_data` VALUES ('assessment','text_gap','en','Text gap');
INSERT INTO `lng_data` VALUES ('assessment','text_maximum_chars_allowed','en','Please do not enter more than a maximum of %s characters. Any characters above will be cut.');
INSERT INTO `lng_data` VALUES ('assessment','text_rating','en','Text matching method');
INSERT INTO `lng_data` VALUES ('assessment','time_format','en','HH MM SS');
INSERT INTO `lng_data` VALUES ('assessment','too_many_empty_parameters','en','Please fill out your empty applet parameters before you add a new parameter!');
INSERT INTO `lng_data` VALUES ('assessment','true','en','True');
INSERT INTO `lng_data` VALUES ('assessment','tst_access_code_created','en','To provide you with permanent access to your test results and to offer you a possibility to resume this test, a unique test access code was created. Please write down this code use it for further actions.');
INSERT INTO `lng_data` VALUES ('assessment','tst_all_user_data_deleted','en','All user data of this test has been deleted!');
INSERT INTO `lng_data` VALUES ('assessment','tst_allow_instant_verification','en','Allow instant verification of answers');
INSERT INTO `lng_data` VALUES ('assessment','tst_allowed_users','en','Maximum number of users running the test simultaneously');
INSERT INTO `lng_data` VALUES ('assessment','tst_allowed_users_time_gap','en','Idle time for active users');
INSERT INTO `lng_data` VALUES ('assessment','tst_already_submitted','en','Test has already been finish and submitted.');
INSERT INTO `lng_data` VALUES ('assessment','tst_already_taken','en','Tests already taken');
INSERT INTO `lng_data` VALUES ('assessment','tst_answer_sheet','en','Test Answer Sheet');
INSERT INTO `lng_data` VALUES ('assessment','tst_answered_questions','en','Answered questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_best_solution_is','en','The best solution is');
INSERT INTO `lng_data` VALUES ('assessment','tst_browse_for_questions','en','Browse for questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_delete_results','en','You are about to delete all your previous entered question results of this test. This will reset all questions to its default values. Please note, that you cannot reset the number of passes, you already needed for this test. Do you really want to reset all your previous entered results?');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_delete_results_info','en','Your previous entered question results were deleted. You have successfully reset the test!');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_print','en','Press button to print all questions with points and solution. The question always appears at the end of a page.');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_submit_answers','en','Please confirm your submission of your solution. You won\'t be able to revert your answers after pressing the submit button.');
INSERT INTO `lng_data` VALUES ('assessment','tst_count_correct_solutions','en','Count only complete solutions');
INSERT INTO `lng_data` VALUES ('assessment','tst_count_partial_solutions','en','Count partial solutions');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_all_user_data','en','Delete all user data');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_missing_mark','en','Please select at least one mark step to delete it');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_results','en','Reset test');
INSERT INTO `lng_data` VALUES ('assessment','tst_ending_time','en','Ending time');
INSERT INTO `lng_data` VALUES ('assessment','tst_enter_questionpool','en','Please enter a question pool name where the new question will be stored');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_no_anonymous_aggregation','en','No one has entered the test yet. There are no anonymous aggregated test results available.');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_results_by_pass','en','Detailed question results');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_show_answer','en','Show answer');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_finished','en','Total finished tests (users who submitted the test with the finish test button)');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_finished_average_time','en','Average test processing time');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed','en','Total passed tests');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed_average_points','en','Average points of passed tests');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed_average_time','en','Average processing time of all passed tests');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_persons','en','Total number of persons who started the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_user_answer','en','User answer');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirm_button','en','Yes, I want to finish the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirm_cancel_button','en','No, go back to the previous question');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirmation_question','en','You are going to finish this test and reach the maximum number of allowed test passes. You won\'t be able to enter this test again to change your answers. Do you really want to finish the test?');
INSERT INTO `lng_data` VALUES ('assessment','tst_finished','en','Finished');
INSERT INTO `lng_data` VALUES ('assessment','tst_general_properties','en','General properties');
INSERT INTO `lng_data` VALUES ('assessment','tst_generate_xls','en','Generate Excel');
INSERT INTO `lng_data` VALUES ('assessment','tst_heading_scoring','en','Scoring');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results','en','Hide previous results');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_description','en','If checked, the previous results of a learner will not be used as default values in future test passes');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_hide','en','Hide my results from a previous test pass');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_introduction','en','If you\'re processing more than one pass of this test, your previous entered results will not be used as default values');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_title_points','en','Question title points');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_title_points_description','en','Hide the output of the maximum points in the question title');
INSERT INTO `lng_data` VALUES ('assessment','tst_import_no_items','en','Error: The import file contains no questions!');
INSERT INTO `lng_data` VALUES ('assessment','tst_import_verify_found_questions','en','ILIAS found the following questions in the test import file. Please select the questions you want to import with this test.');
INSERT INTO `lng_data` VALUES ('assessment','tst_in_use_edit_questions_disabled','en','The test is in use by %d user(s). You are not allowed to edit or move the questions in this test!');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_missing_question','en','Please select at least one question to insert it into the test!');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_questions','en','Are you sure you want to insert the following question(s) to the test?');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_questions_and_results','en','This test was already executed by %s user(s). Inserting questions to this test will remove all test results of these users. Are you sure you want to insert the following question(s) to the test?');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_verification','en','Instant verification');
INSERT INTO `lng_data` VALUES ('assessment','tst_introduction','en','Introduction');
INSERT INTO `lng_data` VALUES ('assessment','tst_maintenance_information_no_results','en','There are no existing user datasets for the test. You need at least one user dataset to maintain the data.');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark','en','Mark');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_create_new_mark_step','en','Create new mark step');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_create_simple_mark_schema','en','Create simple mark schema');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_minimum_level','en','Minimum level (in %)');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_official_form','en','Official form');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_short_form','en','Short form');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users','en','Participants restriction');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users_heading','en','The maximum number of simultaneous users in this test has been reached');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users_message','en','The maximum number of simultaneous active users in the test has been reached. Please try again later to start or resume the test. If one of the active users is inactive for more than %s seconds, you may be able to enter this test. Thank you for your understanding.');
INSERT INTO `lng_data` VALUES ('assessment','tst_maximum_points','en','Maximum points');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_author','en','You have not entered the authors name in the test properties! Please add an authors name.');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_marks','en','You do not have a mark schema in the test! Please add at least a simple mark schema to the test.');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_questions','en','You do not have any questions in the test! Please add at least one question into the test.');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_title','en','You have not entered a test title! Please go to the metadata section and enter a title.');
INSERT INTO `lng_data` VALUES ('assessment','tst_must_be_online_exam','en','This option is only available for online exams!');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_marks_defined','en','There are no marks defined, please create at least a simple mark schema!');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_more_available_questionpools','en','There are no more question pools available');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_question_selected_for_removal','en','Please check at least one question to remove it!');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questionpools_for_random_test','en','You have not added a question pool for this random test! Please select at least one question pool.');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questions_available','en','There are no questions available! You need to create new questions or browse for questions.');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questions_for_random_test','en','You have taken no questions from the questionspools for this random test! Please take at least one question by setting the amount of questions for an added question pool.');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_solution_available','en','Short answer questions don\'t have a specified solution.');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_taken_tests','en','There are no taken tests!');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_tries','en','none');
INSERT INTO `lng_data` VALUES ('assessment','tst_nr_of_tries','en','Max. number of passes');
INSERT INTO `lng_data` VALUES ('assessment','tst_nr_of_tries_of_user','en','Passes already completed');
INSERT INTO `lng_data` VALUES ('assessment','tst_participating_users','en','Participating Users');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_best_pass','en','Score the best pass of a user');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_details','en','Show details');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_last_pass','en','Score the last pass of a user');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_scoring','en','Multiple pass scoring');
INSERT INTO `lng_data` VALUES ('assessment','tst_password','en','Test password');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_details','en','If you define a test password, all users with test access must enter this password to start the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_entered_wrong_password','en','You cannot start the test because you entered the wrong test password!');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_introduction','en','This test can only be accessed with a test password. Please enter the test password to start the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_percent_solved','en','Percent solved');
INSERT INTO `lng_data` VALUES ('assessment','tst_position','en','Question %s of %s');
INSERT INTO `lng_data` VALUES ('assessment','tst_print','en','Test & Assessment Print View');
INSERT INTO `lng_data` VALUES ('assessment','tst_print_date','en','Date of Print');
INSERT INTO `lng_data` VALUES ('assessment','tst_processing_time','en','Max. processing time');
INSERT INTO `lng_data` VALUES ('assessment','tst_properties','en','Test properties');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_order','en','Order');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_resetsolved','en','Set unsolved');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_result_sheet','en','Show result sheet');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_setsolved','en','Set solved');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_summary_text','en','Here you can see all questions. Use the bulbs to mark a question as solved.');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_no','en','Order');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_offer','en','Do you accept this sample or do you want another one?');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection','en','Question selection');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection_description','en','If you only use question pools which contain questions with an equal maximum number of available points, the test will have an equal number of maximum points for all participating users and thus the test results will be better comparable. It is recommended to choose this selection mode.');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection_equal','en','Use question pools with equal maximum points');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_solved_state','en','Solved');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_title','en','Title');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_type','en','Question type');
INSERT INTO `lng_data` VALUES ('assessment','tst_questions_inserted','en','Question(s) inserted!');
INSERT INTO `lng_data` VALUES ('assessment','tst_questions_removed','en','Question(s) removed!');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_nr_of_questions','en','How many questions?');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_qpl_unselected','en','There is at least one unselected question pool! You don\'t need to add a new question pool.');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_questionpools','en','Source question pools');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_select_questionpool','en','Select the question pool to choose the questions from');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_selection_question_count_too_high','en','The question count you entered was higher than the maximum number of available questions. The question count has been reduced automatically.');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_selection_question_total_count_too_high','en','The question count you entered was higher than the maximum number of available questions for all selected question pools. The question count has been reduced automatically.');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_test','en','Random test');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_test_description','en','If checked, the questions of the test will be generated by a random generator');
INSERT INTO `lng_data` VALUES ('assessment','tst_reached_points','en','Reached points');
INSERT INTO `lng_data` VALUES ('assessment','tst_remove_questions','en','Are you sure you want to remove the following question(s) from the test?');
INSERT INTO `lng_data` VALUES ('assessment','tst_remove_questions_and_results','en','This test was already executed by %s user(s). Removing questions from this test will remove all test results of these users. Are you sure you want to remove the following question(s) from the test?');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_first_question','en','Offer test results when the test has been started');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_question','en','Allow instant verification of answers');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_test','en','Offer test results when the test is finished');
INSERT INTO `lng_data` VALUES ('assessment','tst_result_congratulations','en','Congratulations! You passed the test.');
INSERT INTO `lng_data` VALUES ('assessment','tst_result_sorry','en','Sorry, you failed the test.');
INSERT INTO `lng_data` VALUES ('assessment','tst_result_user_name','en','Test results for %s');
INSERT INTO `lng_data` VALUES ('assessment','tst_results','en','Test results');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_aggregated','en','Aggregated test results');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_evaluation','en','Back to evaluation overview');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_introduction','en','Back to introduction');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_overview','en','Back to results overview');
INSERT INTO `lng_data` VALUES ('assessment','tst_resume_test','en','Resume the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cut_question','en','Cut negative points for every question');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cut_test','en','Cut negative points for the sum of all question results');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cutting','en','Cut negative points');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_questions','en','Multiple choice questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_use_scoring_system','en','Set the defined score, even when no answer was checked');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_zero_points_when_unanswered','en','Score 0 points when no answer was checked');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_reporting','en','Score reporting');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_reporting_date','en','Score reporting date');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_type','en','Score reporting type');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_file_for_import','en','You must select a file for import!');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_qpls','en','Please select a question pool for duplication');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_questionpool','en','Please select a question pool to store the created question');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_questionpools','en','Please select a question pool to store the imported questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_random_questions','en','Select the question pool(s) and the amount of questions for the random test');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_tsts','en','Please select a test for duplication');
INSERT INTO `lng_data` VALUES ('assessment','tst_selected_user_data_deleted','en','The test data of the selected user(s) was deleted successfully');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence','en','Sequence');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_fixed','en','The sequence of questions is fixed');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_postpone','en','The learner may postpone a question to the end of the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_properties','en','Sequence properties');
INSERT INTO `lng_data` VALUES ('assessment','tst_session_settings','en','Session settings');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_answer_print_sheet','en','Answers Printview');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_answer_sheet','en','Show answers');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_results','en','Show test results');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_details','en','Score details');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_details_description','en','Learners may see all solution details of their answered questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_printview','en','Solution printview');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_printview_description','en','Learners may see their complete test results for printing');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_summary','en','Show question summary');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_summary_description','en','Offers a summary page with all test questions available for the test participants during the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_shuffle_questions','en','Shuffle questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_shuffle_questions_description','en','Shuffle the sequence of questions for every user on test start');
INSERT INTO `lng_data` VALUES ('assessment','tst_signature','en','Signature');
INSERT INTO `lng_data` VALUES ('assessment','tst_start_test','en','Start the test');
INSERT INTO `lng_data` VALUES ('assessment','tst_started','en','Test Started');
INSERT INTO `lng_data` VALUES ('assessment','tst_starting_time','en','Starting time');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_all_users','en','All participants');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_choose_users','en','(select one or more users from the user list)');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_atimeofwork','en','Average time of work');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancemean','en','Distance to arithmetic mean');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancemedian','en','Distance to median');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancequintile','en','Distance to arithmetic quintile');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_firstvisit','en','First visit');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_lastvisit','en','Last visit');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_mark_median','en','Mark of median');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_median','en','Median of test result in points');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_pworkedthrough','en','Percent of total workload already worked through');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_qworkedthrough','en','Questions already worked through');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_rank_median','en','Rank of median');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_rank_participant','en','Rank of participant');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_resultsmarks','en','Test results in marks');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_resultspoints','en','Test results in points');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_specification','en','Specification of evaluation data');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_timeofwork','en','Time of work');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_total_participants','en','Total number of participants');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_selected_users','en','Selected participants');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_users_intro','en','Show statistical evaluation for');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_completed','en','completed');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_completed_more_tries_possible','en','Completed');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_missing','en','There are required elements missing in this test!');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_missing_elements','en','The following elements are missing:');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_not_entered','en','Not started');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_ok','en','The status of the test is OK. There are no missing elements.');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_progress','en','In progress');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_answers','en','Yes, I want to submit my answers');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_answers_txt','en','You now may finish the test by submitting your answers.');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_results','en','Yes, I do confirm the submission.');
INSERT INTO `lng_data` VALUES ('assessment','tst_test_output','en','Test output');
INSERT INTO `lng_data` VALUES ('assessment','tst_text_count_system','en','Scoring system');
INSERT INTO `lng_data` VALUES ('assessment','tst_time_already_spent','en','You started the test at %s. Your maximum processing time is %s.');
INSERT INTO `lng_data` VALUES ('assessment','tst_time_already_spent_left','en','You have %s left.');
INSERT INTO `lng_data` VALUES ('assessment','tst_total_questions','en','Total amount of questions');
INSERT INTO `lng_data` VALUES ('assessment','tst_total_questions_description','en','If you set this value, the amount of questions entered with the question pools are ignored. If you don\'t set this value, you need to enter an amount with every selected question pool!');
INSERT INTO `lng_data` VALUES ('assessment','tst_tst_date','en','Date of Test');
INSERT INTO `lng_data` VALUES ('assessment','tst_type','en','Test type');
INSERT INTO `lng_data` VALUES ('assessment','tst_type_changed','en','You have changed the test type. All previous processed tests have been deleted!');
INSERT INTO `lng_data` VALUES ('assessment','tst_type_comment','en','Warning: Changing the test type of a running test will delete all previous processed tests!');
INSERT INTO `lng_data` VALUES ('assessment','tst_types','en','Test types');
INSERT INTO `lng_data` VALUES ('assessment','tst_use_javascript','en','Use Javascript for drag and drop actions');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_answer_was','en','Your answer was');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_answers','en','These are your answers given to the following questions.');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_ects_mark_is','en','Your ECTS grade is');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_mark_is','en','Your mark is');
INSERT INTO `lng_data` VALUES ('assessment','tt_assessment','en','Assessment test');
INSERT INTO `lng_data` VALUES ('assessment','tt_online_exam','en','Online Exam');
INSERT INTO `lng_data` VALUES ('assessment','tt_self_assessment','en','Self assessment test');
INSERT INTO `lng_data` VALUES ('assessment','tt_varying_randomtest','en','Varying random test');
INSERT INTO `lng_data` VALUES ('assessment','unlimited','en','unlimited');
INSERT INTO `lng_data` VALUES ('assessment','unlock','en','Unlock');
INSERT INTO `lng_data` VALUES ('assessment','unlock_question','en','This question is in use of at least one test and there are %s submitted results. If you choose to unlock the question the complete test results of the affected users will be deleted after saving this question. If you want to use a changed version of this question but you do not want to delete the users test results, you can duplicate the question in the question pool and change that version.');
INSERT INTO `lng_data` VALUES ('assessment','upload_image','en','Upload image');
INSERT INTO `lng_data` VALUES ('assessment','upload_imagemap','en','Upload an Image map');
INSERT INTO `lng_data` VALUES ('assessment','uploaded_material','en','Uploaded Material');
INSERT INTO `lng_data` VALUES ('assessment','user_not_invited','en','You are not supposed to take this exam.');
INSERT INTO `lng_data` VALUES ('assessment','user_wrong_clientip','en','You don\'t have the right ip using this test.');
INSERT INTO `lng_data` VALUES ('assessment','value_between_x_and_y','en','The value should be between %s and %s');
INSERT INTO `lng_data` VALUES ('assessment','warning_question_not_complete','en','The question is not complete!');
INSERT INTO `lng_data` VALUES ('assessment','warning_test_not_complete','en','The test is not complete!');
INSERT INTO `lng_data` VALUES ('assessment','when','en','when');
INSERT INTO `lng_data` VALUES ('assessment','width','en','Width');
INSERT INTO `lng_data` VALUES ('assessment','with_order','en','with order');
INSERT INTO `lng_data` VALUES ('assessment','worked_through','en','Answered');
INSERT INTO `lng_data` VALUES ('assessment','working_time','en','Working Time');
INSERT INTO `lng_data` VALUES ('assessment','you_received_a_of_b_points','en','You received %d of %d possible points');
INSERT INTO `lng_data` VALUES ('barometer','anonymous','en','Anonymous');
INSERT INTO `lng_data` VALUES ('barometer','barometer_title','en','Feedback');
INSERT INTO `lng_data` VALUES ('barometer','best','en','Best');
INSERT INTO `lng_data` VALUES ('barometer','change_course','en','Change Course');
INSERT INTO `lng_data` VALUES ('barometer','chart_type','en','Chart type');
INSERT INTO `lng_data` VALUES ('barometer','chart_users','en','Chart user');
INSERT INTO `lng_data` VALUES ('barometer','chart_votes','en','Chart votes');
INSERT INTO `lng_data` VALUES ('barometer','create','en','Create New Feedback');
INSERT INTO `lng_data` VALUES ('barometer','day','en','Day');
INSERT INTO `lng_data` VALUES ('barometer','days','en','Days');
INSERT INTO `lng_data` VALUES ('barometer','delete','en','Delete');
INSERT INTO `lng_data` VALUES ('barometer','duration','en','Duration');
INSERT INTO `lng_data` VALUES ('barometer','edit','en','Edit');
INSERT INTO `lng_data` VALUES ('barometer','edit_barometer','en','Edit feedback');
INSERT INTO `lng_data` VALUES ('barometer','every','en','every');
INSERT INTO `lng_data` VALUES ('barometer','feedb_edit_feedback','en','Edit Feedback');
INSERT INTO `lng_data` VALUES ('barometer','feedb_feedback_list','en','Feedback List');
INSERT INTO `lng_data` VALUES ('barometer','feedb_feedback_settings','en','Feedback Settings');
INSERT INTO `lng_data` VALUES ('barometer','feedb_time','en','Time');
INSERT INTO `lng_data` VALUES ('barometer','first_vote','en','1. Vote is the');
INSERT INTO `lng_data` VALUES ('barometer','from','en','From');
INSERT INTO `lng_data` VALUES ('barometer','hours','en','Hours');
INSERT INTO `lng_data` VALUES ('barometer','lines','en','Lines');
INSERT INTO `lng_data` VALUES ('barometer','login','en','Login');
INSERT INTO `lng_data` VALUES ('barometer','missing_fields','en','Please fill in all required information');
INSERT INTO `lng_data` VALUES ('barometer','month','en','Month');
INSERT INTO `lng_data` VALUES ('barometer','months','en','Months');
INSERT INTO `lng_data` VALUES ('barometer','new_vote','en','New vote');
INSERT INTO `lng_data` VALUES ('barometer','note','en','Comment');
INSERT INTO `lng_data` VALUES ('barometer','optional','en','Optional');
INSERT INTO `lng_data` VALUES ('barometer','options','en','Options');
INSERT INTO `lng_data` VALUES ('barometer','pie','en','Pie');
INSERT INTO `lng_data` VALUES ('barometer','repeat','en','Repeat Every');
INSERT INTO `lng_data` VALUES ('barometer','required','en','Required');
INSERT INTO `lng_data` VALUES ('barometer','save','en','Save');
INSERT INTO `lng_data` VALUES ('barometer','save_vote','en','Submit vote');
INSERT INTO `lng_data` VALUES ('barometer','skip','en','Skip');
INSERT INTO `lng_data` VALUES ('barometer','statistics','en','Statistics');
INSERT INTO `lng_data` VALUES ('barometer','status','en','Status');
INSERT INTO `lng_data` VALUES ('barometer','table','en','Table');
INSERT INTO `lng_data` VALUES ('barometer','text','en','Text');
INSERT INTO `lng_data` VALUES ('barometer','text_answer','en','Text answer');
INSERT INTO `lng_data` VALUES ('barometer','time','en','Running');
INSERT INTO `lng_data` VALUES ('barometer','title','en','Title');
INSERT INTO `lng_data` VALUES ('barometer','type','en','Type');
INSERT INTO `lng_data` VALUES ('barometer','until','en','Until');
INSERT INTO `lng_data` VALUES ('barometer','user','en','User');
INSERT INTO `lng_data` VALUES ('barometer','vote','en','Vote');
INSERT INTO `lng_data` VALUES ('barometer','votes','en','Votes');
INSERT INTO `lng_data` VALUES ('barometer','weeks','en','Weeks');
INSERT INTO `lng_data` VALUES ('barometer','worst','en','Worst');
INSERT INTO `lng_data` VALUES ('barometer','year','en','Year');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_add','en','Add');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_author','en','Author');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_av','en','AV');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_bibitem','en','Bibliographical information');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_book','en','Book');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_booktitle','en','Book title');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_catalog','en','Catalog');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_choose_index','en','Please select a bibliographical information:');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_cross_reference','en','Cross reference');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_delete','en','Delete');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_dissertation','en','Dissertation');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_edition','en','Edition');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_editor','en','Editor');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_entry','en','Entry');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_first_name','en','First name');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_grey_literature','en','Grey literature');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_how_published','en','How published');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_identifier','en','Identifier');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_inbook','en','In book');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_inproceedings','en','In proceedings');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_institution','en','Institution');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_internet','en','Internet');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_isbn','en','ISBN');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_issn','en','ISSN');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_journal','en','Journal');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_journal_article','en','Journal article');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_keyword','en','Keyword');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_label','en','Label');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_language','en','Language');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_last_name','en','Last name');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_manual','en','Manual');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_master_thesis','en','Master thesis');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_middle_name','en','Middle name');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_month','en','Month');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_new_element','en','New element');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_newspaper_article','en','Newspaper article');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_not_found','en','No bibliographical information available.');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_note','en','Note');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_number','en','Number');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_organization','en','Organization');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_pages','en','Pages');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_phd_thesis','en','PhD thesis');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_please_select','en','Please select');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_print','en','Print');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_proceedings','en','Proceedings');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_publisher','en','Publisher');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_save','en','Save');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_school','en','School');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series','en','Series');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_editor','en','Editor');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_title','en','Series title');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_volume','en','Volume');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_technical_report','en','Technical report');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_type','en','Type');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_unpublished','en','Unpublished');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_url','en','URL');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_where_published','en','Where published');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_year','en','Year');
INSERT INTO `lng_data` VALUES ('chat','cancel_talk','en','Cancel address');
INSERT INTO `lng_data` VALUES ('chat','cancel_whisper','en','Cancel whisper');
INSERT INTO `lng_data` VALUES ('chat','chat_access_blocked','en','You are excluded from these chatrooms');
INSERT INTO `lng_data` VALUES ('chat','chat_active','en','Active');
INSERT INTO `lng_data` VALUES ('chat','chat_active_users','en','Further users (present)');
INSERT INTO `lng_data` VALUES ('chat','chat_add_allowed_hosts','en','Please add the address of the host(s) which are allowed to access the chat server.');
INSERT INTO `lng_data` VALUES ('chat','chat_add_external_ip','en','Please add the server\'s external IP.');
INSERT INTO `lng_data` VALUES ('chat','chat_add_internal_ip','en','Please add the server\'s internal IP.');
INSERT INTO `lng_data` VALUES ('chat','chat_add_moderator_password','en','Please add a moderator password.');
INSERT INTO `lng_data` VALUES ('chat','chat_add_port','en','Please add the server port.');
INSERT INTO `lng_data` VALUES ('chat','chat_add_private_chatroom','en','Add private chatroom');
INSERT INTO `lng_data` VALUES ('chat','chat_address','en','Address');
INSERT INTO `lng_data` VALUES ('chat','chat_address_user','en','Address');
INSERT INTO `lng_data` VALUES ('chat','chat_aqua','en','aqua');
INSERT INTO `lng_data` VALUES ('chat','chat_arial','en','Arial');
INSERT INTO `lng_data` VALUES ('chat','chat_black','en','black');
INSERT INTO `lng_data` VALUES ('chat','chat_block_user','en','Block');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked','en','Restricted access');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked_unlocked','en','Unlock');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked_users','en','Blocked users');
INSERT INTO `lng_data` VALUES ('chat','chat_blue','en','blue');
INSERT INTO `lng_data` VALUES ('chat','chat_bold','en','Bold');
INSERT INTO `lng_data` VALUES ('chat','chat_chatroom_body','en','Chat room:');
INSERT INTO `lng_data` VALUES ('chat','chat_chatroom_rename','en','Edit chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_chatrooms','en','Chat Rooms');
INSERT INTO `lng_data` VALUES ('chat','chat_color','en','Font color');
INSERT INTO `lng_data` VALUES ('chat','chat_delete_sure','en','Are you sure, you want to delete this chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_drop_user','en','User kicked');
INSERT INTO `lng_data` VALUES ('chat','chat_edit','en','Edit chat');
INSERT INTO `lng_data` VALUES ('chat','chat_empty','en','Empty');
INSERT INTO `lng_data` VALUES ('chat','chat_enter_valid_username','en','Please enter a valid username.');
INSERT INTO `lng_data` VALUES ('chat','chat_face','en','Font type');
INSERT INTO `lng_data` VALUES ('chat','chat_fuchsia','en','fuchsia');
INSERT INTO `lng_data` VALUES ('chat','chat_gray','en','gray');
INSERT INTO `lng_data` VALUES ('chat','chat_green','en','green');
INSERT INTO `lng_data` VALUES ('chat','chat_hide_details','en','Hide details');
INSERT INTO `lng_data` VALUES ('chat','chat_html_export','en','HTML export');
INSERT INTO `lng_data` VALUES ('chat','chat_ilias','en','ILIAS Chat module');
INSERT INTO `lng_data` VALUES ('chat','chat_inactive','en','Inactive');
INSERT INTO `lng_data` VALUES ('chat','chat_input','en','Input');
INSERT INTO `lng_data` VALUES ('chat','chat_insert_message','en','Please insert a message');
INSERT INTO `lng_data` VALUES ('chat','chat_invitation_body','en','Invitation to chat from:');
INSERT INTO `lng_data` VALUES ('chat','chat_invitation_subject','en','Chat invitation');
INSERT INTO `lng_data` VALUES ('chat','chat_invite_user','en','Invite user');
INSERT INTO `lng_data` VALUES ('chat','chat_invited_by','en','Invited by');
INSERT INTO `lng_data` VALUES ('chat','chat_italic','en','Italic');
INSERT INTO `lng_data` VALUES ('chat','chat_kick_user_session','en','Kick user');
INSERT INTO `lng_data` VALUES ('chat','chat_kicked_from_room','en','You have been kicked from this chatroom, you cannot write messages.');
INSERT INTO `lng_data` VALUES ('chat','chat_level_all','en','All');
INSERT INTO `lng_data` VALUES ('chat','chat_level_debug','en','Debug');
INSERT INTO `lng_data` VALUES ('chat','chat_level_error','en','Error');
INSERT INTO `lng_data` VALUES ('chat','chat_level_fatal','en','Fatal');
INSERT INTO `lng_data` VALUES ('chat','chat_level_info','en','Info');
INSERT INTO `lng_data` VALUES ('chat','chat_lime','en','lime');
INSERT INTO `lng_data` VALUES ('chat','chat_maroon','en','maroon');
INSERT INTO `lng_data` VALUES ('chat','chat_messages_deleted','en','Messages have been deleted.');
INSERT INTO `lng_data` VALUES ('chat','chat_moderator_password','en','Moderator password');
INSERT INTO `lng_data` VALUES ('chat','chat_navy','en','navy');
INSERT INTO `lng_data` VALUES ('chat','chat_new_message','en','New message');
INSERT INTO `lng_data` VALUES ('chat','chat_no_active_users','en','No further users present.');
INSERT INTO `lng_data` VALUES ('chat','chat_no_blocked','en','No blocked users available');
INSERT INTO `lng_data` VALUES ('chat','chat_no_connection','en','Cannot contact chat server.');
INSERT INTO `lng_data` VALUES ('chat','chat_no_delete_public','en','The public chat room cannot be deleted');
INSERT INTO `lng_data` VALUES ('chat','chat_no_recordings_available','en','No recordings are available at the moment.');
INSERT INTO `lng_data` VALUES ('chat','chat_no_refresh_public','en','The public chat room cannot be refreshed.');
INSERT INTO `lng_data` VALUES ('chat','chat_no_rename_public','en','The public room cannot be renamed');
INSERT INTO `lng_data` VALUES ('chat','chat_no_users_selected','en','You have to select one user.');
INSERT INTO `lng_data` VALUES ('chat','chat_no_write_perm','en','No permission to write');
INSERT INTO `lng_data` VALUES ('chat','chat_olive','en','olive');
INSERT INTO `lng_data` VALUES ('chat','chat_online_users','en','Further users (online)');
INSERT INTO `lng_data` VALUES ('chat','chat_private_message','en','Private Message');
INSERT INTO `lng_data` VALUES ('chat','chat_profile','en','Profile');
INSERT INTO `lng_data` VALUES ('chat','chat_public_room','en','Public chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_purple','en','purple');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_action','en','Action');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_description','en','Description');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_moderator','en','Moderator');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_not_found','en','Could not find recording.');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_running','en','Recording running');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_started','en','Recording started');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_stopped','en','Recording stopped');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_time_frame','en','Time frame');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_title','en','Title of recording');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings','en','Recordings');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_delete_sure','en','Deleting records - are you sure?');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_deleted','en','Recordings were deleted.');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_select_one','en','Please choose recordings you would like to delete.');
INSERT INTO `lng_data` VALUES ('chat','chat_red','en','red');
INSERT INTO `lng_data` VALUES ('chat','chat_refresh','en','Refresh');
INSERT INTO `lng_data` VALUES ('chat','chat_refreshed','en','Deleted all messages of the selected chatrooms.');
INSERT INTO `lng_data` VALUES ('chat','chat_room_added','en','Added new chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_room_name','en','Name of chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_room_renamed','en','Chat room renamed.');
INSERT INTO `lng_data` VALUES ('chat','chat_room_select','en','Private chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_rooms','en','Chat Rooms');
INSERT INTO `lng_data` VALUES ('chat','chat_rooms_deleted','en','Chat room(s) deleted.');
INSERT INTO `lng_data` VALUES ('chat','chat_select_one_room','en','Please select one chat room');
INSERT INTO `lng_data` VALUES ('chat','chat_server_allowed','en','Allowed hosts');
INSERT INTO `lng_data` VALUES ('chat','chat_server_allowed_b','en','(e.g. 192.168.1.1,192.168.1.2)');
INSERT INTO `lng_data` VALUES ('chat','chat_server_external_ip','en','Server external IP');
INSERT INTO `lng_data` VALUES ('chat','chat_server_internal_ip','en','Server internal IP');
INSERT INTO `lng_data` VALUES ('chat','chat_server_logfile','en','Log file path');
INSERT INTO `lng_data` VALUES ('chat','chat_server_loglevel','en','Log level');
INSERT INTO `lng_data` VALUES ('chat','chat_server_not_active','en','The chat server is not active');
INSERT INTO `lng_data` VALUES ('chat','chat_server_port','en','Server Port');
INSERT INTO `lng_data` VALUES ('chat','chat_server_settings','en','Chat server settings');
INSERT INTO `lng_data` VALUES ('chat','chat_settings_saved','en','Settings saved');
INSERT INTO `lng_data` VALUES ('chat','chat_show_details','en','Show details');
INSERT INTO `lng_data` VALUES ('chat','chat_silver','en','silver');
INSERT INTO `lng_data` VALUES ('chat','chat_start_recording','en','Start recording');
INSERT INTO `lng_data` VALUES ('chat','chat_status','en','Status');
INSERT INTO `lng_data` VALUES ('chat','chat_status_saved','en','The status has been changed');
INSERT INTO `lng_data` VALUES ('chat','chat_stop_recording','en','Stop recording');
INSERT INTO `lng_data` VALUES ('chat','chat_tahoma','en','Tahoma');
INSERT INTO `lng_data` VALUES ('chat','chat_teal','en','teal');
INSERT INTO `lng_data` VALUES ('chat','chat_times','en','Times');
INSERT INTO `lng_data` VALUES ('chat','chat_title_missing','en','Please insert a name.');
INSERT INTO `lng_data` VALUES ('chat','chat_to_chat_body','en','To the chat');
INSERT INTO `lng_data` VALUES ('chat','chat_type','en','Font face');
INSERT INTO `lng_data` VALUES ('chat','chat_unblocked_user','en','The selected user have been unlocked.');
INSERT INTO `lng_data` VALUES ('chat','chat_underlined','en','Underlined');
INSERT INTO `lng_data` VALUES ('chat','chat_unkick_user_session','en','Unkick user');
INSERT INTO `lng_data` VALUES ('chat','chat_user_already_blocked','en','The access for the selected user is already blocked.');
INSERT INTO `lng_data` VALUES ('chat','chat_user_blocked','en','Blocked access for the selected user.');
INSERT INTO `lng_data` VALUES ('chat','chat_user_dropped','en','User kicked');
INSERT INTO `lng_data` VALUES ('chat','chat_user_invited','en','Invited user to chat.');
INSERT INTO `lng_data` VALUES ('chat','chat_user_name','en','Username');
INSERT INTO `lng_data` VALUES ('chat','chat_whisper','en','Whisper');
INSERT INTO `lng_data` VALUES ('chat','chat_yellow','en','yellow');
INSERT INTO `lng_data` VALUES ('chat','chats','en','Chats');
INSERT INTO `lng_data` VALUES ('chat','my_chats','en','My Chats');
INSERT INTO `lng_data` VALUES ('common','3rd_party_software','en','3rd party software');
INSERT INTO `lng_data` VALUES ('common','DD.MM.YYYY','en','DD.MM.YYYY');
INSERT INTO `lng_data` VALUES ('common','HH','en','HH:MM');
INSERT INTO `lng_data` VALUES ('common','absolute_path','en','Absolute Path');
INSERT INTO `lng_data` VALUES ('common','accept_usr_agreement','en','Accept user agreement?');
INSERT INTO `lng_data` VALUES ('common','access','en','Access');
INSERT INTO `lng_data` VALUES ('common','account_expires_body','en','Your account is limited, it will expire at:');
INSERT INTO `lng_data` VALUES ('common','account_expires_subject','en','[ILIAS 3] Your account expires');
INSERT INTO `lng_data` VALUES ('common','action','en','Action');
INSERT INTO `lng_data` VALUES ('common','action_aborted','en','Action aborted');
INSERT INTO `lng_data` VALUES ('common','actions','en','Actions');
INSERT INTO `lng_data` VALUES ('common','activate_assessment_logging','en','Activate Test&Assessment logging');
INSERT INTO `lng_data` VALUES ('common','activate_https','en','HTTPS handling by ILIAS<br>(Payment, Login)');
INSERT INTO `lng_data` VALUES ('common','activate_tracking','en','Activation');
INSERT INTO `lng_data` VALUES ('common','activation','en','Edit Timings');
INSERT INTO `lng_data` VALUES ('common','active','en','Active');
INSERT INTO `lng_data` VALUES ('common','active_roles','en','Active Roles');
INSERT INTO `lng_data` VALUES ('common','add','en','Add');
INSERT INTO `lng_data` VALUES ('common','add_author','en','Add Author');
INSERT INTO `lng_data` VALUES ('common','add_comments','en','Edit comments');
INSERT INTO `lng_data` VALUES ('common','add_condition','en','Create new association');
INSERT INTO `lng_data` VALUES ('common','add_member','en','Add Member');
INSERT INTO `lng_data` VALUES ('common','add_members','en','Add Members');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_field','en','Add New User-defined Field');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_select_field','en','Add New Select Box');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_text_field','en','Add New Text Field');
INSERT INTO `lng_data` VALUES ('common','add_note','en','Add Note');
INSERT INTO `lng_data` VALUES ('common','add_translation','en','Add translation');
INSERT INTO `lng_data` VALUES ('common','add_user','en','Add local user');
INSERT INTO `lng_data` VALUES ('common','add_user_defined_field','en','Add New Field');
INSERT INTO `lng_data` VALUES ('common','added_new_condition','en','Created new condition.');
INSERT INTO `lng_data` VALUES ('common','additional_info','en','Additional Information');
INSERT INTO `lng_data` VALUES ('common','adm_create_tax','en','Create taxonomy');
INSERT INTO `lng_data` VALUES ('common','adm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','adm_read','en','Read access to System settings');
INSERT INTO `lng_data` VALUES ('common','adm_visible','en','System settings are visible');
INSERT INTO `lng_data` VALUES ('common','adm_write','en','Edit Basic system settings');
INSERT INTO `lng_data` VALUES ('common','admin_panel','en','Administration Panel');
INSERT INTO `lng_data` VALUES ('common','admin_panel_disable','en','Switch Administration Commands Off');
INSERT INTO `lng_data` VALUES ('common','admin_panel_enable','en','Switch Administration Commands On');
INSERT INTO `lng_data` VALUES ('common','administrate','en','Administrate');
INSERT INTO `lng_data` VALUES ('common','administrate_users','en','Local user administration');
INSERT INTO `lng_data` VALUES ('common','administration','en','Administration');
INSERT INTO `lng_data` VALUES ('common','administrator','en','Administrator');
INSERT INTO `lng_data` VALUES ('common','adopt','en','Adopt');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_allow_html_tags','en','Allow the selected HTML tags for text editing');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_allow_javascript_editor','en','Enable a Rich Text Editor');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_assessment_settings','en','Allowed HTML Tags for the ILIAS Test&Assessment tool');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_cat_page_editing','en','Enable Content Editing for Category Pages');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_cat_page_editing_desc','en','This enables the content editing of category pages. When deactivated, the categories are just displayed as a set of item lists.');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_js_editing','en','Enable HTMLArea for Content Editing');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_js_editing_desc','en','Enables HTMLArea and JavaScript support for page editing in learning modules and glossaries.');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_settings','en','Learning Module and Glossary Settings');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_no_rte','en','Do not use rich text editing');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_settings','en','Advanced Editing Settings');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_survey_settings','en','Allowed HTML Tags for the ILIAS survey tool');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_tinymce','en','TinyMCE Editor');
INSERT INTO `lng_data` VALUES ('common','adve_assessment_settings','en','Test & Assessment Settings');
INSERT INTO `lng_data` VALUES ('common','adve_cat_settings','en','Category Settings');
INSERT INTO `lng_data` VALUES ('common','adve_edit_permission','en','Change Permission Settings');
INSERT INTO `lng_data` VALUES ('common','adve_general_settings','en','General Settings');
INSERT INTO `lng_data` VALUES ('common','adve_lm_settings','en','LM / Glossary Settings');
INSERT INTO `lng_data` VALUES ('common','adve_read','en','Access Advanced Editing Administration');
INSERT INTO `lng_data` VALUES ('common','adve_survey_settings','en','Survey Settings');
INSERT INTO `lng_data` VALUES ('common','adve_visible','en','Advanced Editing Administration is Visible');
INSERT INTO `lng_data` VALUES ('common','adve_write','en','Advanced Editing Administration');
INSERT INTO `lng_data` VALUES ('common','agree_date','en','Agreed on');
INSERT INTO `lng_data` VALUES ('common','all_authors','en','All authors');
INSERT INTO `lng_data` VALUES ('common','all_global_roles','en','Global roles');
INSERT INTO `lng_data` VALUES ('common','all_lms','en','All learning modules');
INSERT INTO `lng_data` VALUES ('common','all_local_roles','en','Local roles (all)');
INSERT INTO `lng_data` VALUES ('common','all_objects','en','All Objects');
INSERT INTO `lng_data` VALUES ('common','all_roles','en','All Roles');
INSERT INTO `lng_data` VALUES ('common','all_topics','en','All Topics');
INSERT INTO `lng_data` VALUES ('common','all_tsts','en','All tests');
INSERT INTO `lng_data` VALUES ('common','all_users','en','All users');
INSERT INTO `lng_data` VALUES ('common','allow_assign_users','en','Allow user assignment for local administrators.');
INSERT INTO `lng_data` VALUES ('common','allow_register','en','Available in registration form for new users');
INSERT INTO `lng_data` VALUES ('common','alm','en','Learning Module AICC');
INSERT INTO `lng_data` VALUES ('common','alm_added','en','AICC Learning Module added');
INSERT INTO `lng_data` VALUES ('common','alm_create','en','Create AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','alm_delete','en','Delete AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','alm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','alm_join','en','Subscribe to AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','alm_leave','en','Unsubscribe from AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','alm_read','en','Read access to AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','alm_visible','en','AICC Learning Module is visible');
INSERT INTO `lng_data` VALUES ('common','alm_write','en','Edit AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','already_delivered_files','en','Submitted Files');
INSERT INTO `lng_data` VALUES ('common','and','en','and');
INSERT INTO `lng_data` VALUES ('common','announce','en','Announce');
INSERT INTO `lng_data` VALUES ('common','announce_changes','en','Announce Changes');
INSERT INTO `lng_data` VALUES ('common','anonymous','en','Anonymous');
INSERT INTO `lng_data` VALUES ('common','answers','en','Answers');
INSERT INTO `lng_data` VALUES ('common','any_language','en','Any language');
INSERT INTO `lng_data` VALUES ('common','append_search','en','Append search results');
INSERT INTO `lng_data` VALUES ('common','application_completed','en','Application is complete');
INSERT INTO `lng_data` VALUES ('common','application_date','en','Application date');
INSERT INTO `lng_data` VALUES ('common','applied_users','en','Applied users');
INSERT INTO `lng_data` VALUES ('common','apply','en','Apply');
INSERT INTO `lng_data` VALUES ('common','apply_filter','en','Apply filter');
INSERT INTO `lng_data` VALUES ('common','appointment','en','Appointment');
INSERT INTO `lng_data` VALUES ('common','appointment_list','en','Appointment List');
INSERT INTO `lng_data` VALUES ('common','approve_date','en','Approved on');
INSERT INTO `lng_data` VALUES ('common','approve_recipient','en','Login ID of Approver');
INSERT INTO `lng_data` VALUES ('common','archive','en','Archive');
INSERT INTO `lng_data` VALUES ('common','are_you_sure','en','Are you sure?');
INSERT INTO `lng_data` VALUES ('common','arrow_downright','en','Arrow from top to down right');
INSERT INTO `lng_data` VALUES ('common','articels_unread','en','Unread articels');
INSERT INTO `lng_data` VALUES ('common','as_of','en','as of');
INSERT INTO `lng_data` VALUES ('common','ascending_order','en','Ascending order');
INSERT INTO `lng_data` VALUES ('common','assessment_log','en','Create an Test&Assessment log for a specific time period');
INSERT INTO `lng_data` VALUES ('common','assessment_log_datetime','en','Date/Time');
INSERT INTO `lng_data` VALUES ('common','assessment_log_for_test','en','For test');
INSERT INTO `lng_data` VALUES ('common','assessment_log_log_entries','en','log entries');
INSERT INTO `lng_data` VALUES ('common','assessment_log_no_log','en','It is no log data available for the selected test and the selected time period!');
INSERT INTO `lng_data` VALUES ('common','assessment_log_open_calendar','en','Click here to open a calendar for date selection (JavaScript required!)');
INSERT INTO `lng_data` VALUES ('common','assessment_log_question','en','Question');
INSERT INTO `lng_data` VALUES ('common','assessment_log_select_test','en','--- Please select a test ---');
INSERT INTO `lng_data` VALUES ('common','assessment_log_text','en','Log message');
INSERT INTO `lng_data` VALUES ('common','assessment_log_user_answer','en','User answered a question');
INSERT INTO `lng_data` VALUES ('common','assessment_log_user_answers','en','Show user actions');
INSERT INTO `lng_data` VALUES ('common','assessment_settings','en','Test&Assessment Administration Settings');
INSERT INTO `lng_data` VALUES ('common','assessment_settings_reporting_language','en','Reporting language');
INSERT INTO `lng_data` VALUES ('common','assf_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','assf_read','en','Access Test&Assessment Administration');
INSERT INTO `lng_data` VALUES ('common','assf_visible','en','Test&Assessment administration is visible');
INSERT INTO `lng_data` VALUES ('common','assf_write','en','Edit Test&Assessment administration');
INSERT INTO `lng_data` VALUES ('common','assign','en','Assign');
INSERT INTO `lng_data` VALUES ('common','assign_global_role','en','Assign to Global Role');
INSERT INTO `lng_data` VALUES ('common','assign_lo_forum','en','Assign LO Forum');
INSERT INTO `lng_data` VALUES ('common','assign_local_role','en','Assign to Local Role');
INSERT INTO `lng_data` VALUES ('common','assign_user_to_role','en','Assign User to Role');
INSERT INTO `lng_data` VALUES ('common','assigned_roles','en','Assigned Roles');
INSERT INTO `lng_data` VALUES ('common','assigned_users','en','Assigned Users');
INSERT INTO `lng_data` VALUES ('common','associated_user','en','associated User');
INSERT INTO `lng_data` VALUES ('common','associated_users','en','associated Users');
INSERT INTO `lng_data` VALUES ('common','at_least_one_style','en','At least one style must remain activated.');
INSERT INTO `lng_data` VALUES ('common','at_location','en','at location');
INSERT INTO `lng_data` VALUES ('common','attachment','en','Attachment');
INSERT INTO `lng_data` VALUES ('common','attachments','en','Attachments');
INSERT INTO `lng_data` VALUES ('common','attend','en','Attend');
INSERT INTO `lng_data` VALUES ('common','auth_active_roles','en','Global roles available on registration form');
INSERT INTO `lng_data` VALUES ('common','auth_allow_local','en','Allow Local Authentication');
INSERT INTO `lng_data` VALUES ('common','auth_cas','en','CAS');
INSERT INTO `lng_data` VALUES ('common','auth_cas_allow_local_desc','en','This allows CAS users to authenticate with their local ILIAS username and a local password.');
INSERT INTO `lng_data` VALUES ('common','auth_cas_auth','en','Configure CAS Authentication');
INSERT INTO `lng_data` VALUES ('common','auth_cas_auth_desc','en','CAS requires PHP 4.3.1 or higher with CURL support (7.5 or higher)');
INSERT INTO `lng_data` VALUES ('common','auth_cas_create_users_desc','en','Creates automatically an ILIAS user account, for users that successfully authenticated against CAS, without having an ILIAS account yet.');
INSERT INTO `lng_data` VALUES ('common','auth_cas_port_desc','en','E.g. 443 if the full CAS server URI is https://auth.yourserver.com:443/cas/');
INSERT INTO `lng_data` VALUES ('common','auth_cas_server_desc','en','E.g. auth.yourserver.com if the full CAS server URI is https://auth.yourserver.com:443/cas/');
INSERT INTO `lng_data` VALUES ('common','auth_cas_settings_saved','en','CAS settings saved');
INSERT INTO `lng_data` VALUES ('common','auth_cas_uri_desc','en','Local URI, e.g. cas if the full CAS server URI is https://auth.yourserver.com:443/cas/');
INSERT INTO `lng_data` VALUES ('common','auth_cas_user_default_role_desc','en','This role is assigned to automatically created CAS users.');
INSERT INTO `lng_data` VALUES ('common','auth_configure','en','configure...');
INSERT INTO `lng_data` VALUES ('common','auth_create_users','en','Create non-existing users automatically');
INSERT INTO `lng_data` VALUES ('common','auth_default','en','Default setting');
INSERT INTO `lng_data` VALUES ('common','auth_default_mode_changed_to','en','Default authentication mode changed to');
INSERT INTO `lng_data` VALUES ('common','auth_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','auth_ldap','en','LDAP');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_desc','en','Authenticate users via LDAP server');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_enable','en','Enable LDAP support');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_not_configured','en','LDAP is not configured yet');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_settings_saved','en','LDAP settings saved');
INSERT INTO `lng_data` VALUES ('common','auth_local','en','ILIAS database');
INSERT INTO `lng_data` VALUES ('common','auth_local_desc','en','Authenticate users via local ILIAS database (default)');
INSERT INTO `lng_data` VALUES ('common','auth_login_instructions','en','Instructions shown on login page');
INSERT INTO `lng_data` VALUES ('common','auth_mode','en','Authentication mode');
INSERT INTO `lng_data` VALUES ('common','auth_mode_not_changed','en','(Nothing changed)');
INSERT INTO `lng_data` VALUES ('common','auth_mode_roles_changed','en','Changed authentication mode for this Role');
INSERT INTO `lng_data` VALUES ('common','auth_new_account_mail_desc','en','Send new account mail to user, if user is generated automatically. A password will only be generated, if \"Allow Local Authentication\" is also activated.');
INSERT INTO `lng_data` VALUES ('common','auth_per_default','en','Per Default');
INSERT INTO `lng_data` VALUES ('common','auth_radius','en','RADIUS');
INSERT INTO `lng_data` VALUES ('common','auth_radius_configure','en','Configure RADIUS-Authentication');
INSERT INTO `lng_data` VALUES ('common','auth_radius_desc','en','Authenticate users via RADIUS server');
INSERT INTO `lng_data` VALUES ('common','auth_radius_enable','en','Enable RADIUS support');
INSERT INTO `lng_data` VALUES ('common','auth_radius_not_configured','en','RADIUS is not configured yet');
INSERT INTO `lng_data` VALUES ('common','auth_radius_port','en','Port');
INSERT INTO `lng_data` VALUES ('common','auth_radius_server','en','Servers');
INSERT INTO `lng_data` VALUES ('common','auth_radius_server_desc','en','You may add multiple servers with commas separated. Servers are rotated in Round robin fashion when queried.');
INSERT INTO `lng_data` VALUES ('common','auth_radius_settings_saved','en','RADIUS settings saved');
INSERT INTO `lng_data` VALUES ('common','auth_radius_shared_secret','en','Shared secret');
INSERT INTO `lng_data` VALUES ('common','auth_read','en','Access authentication settings');
INSERT INTO `lng_data` VALUES ('common','auth_remark_non_local_auth','en','When selecting another authentication mode than ILIAS database, you may not change user\'s login name and password anymore.');
INSERT INTO `lng_data` VALUES ('common','auth_role_auth_mode','en','Authentication mode');
INSERT INTO `lng_data` VALUES ('common','auth_script','en','Custom');
INSERT INTO `lng_data` VALUES ('common','auth_script_desc','en','Authenticate users via external script');
INSERT INTO `lng_data` VALUES ('common','auth_select','en','Select authentication mode');
INSERT INTO `lng_data` VALUES ('common','auth_shib','en','Shibboleth');
INSERT INTO `lng_data` VALUES ('common','auth_shib_desc','en','Authenticate users via Shibboleth, can be used as second authentication method');
INSERT INTO `lng_data` VALUES ('common','auth_shib_not_configured','en','Shibboleth is not configured yet');
INSERT INTO `lng_data` VALUES ('common','auth_shibboleth','en','Shibboleth');
INSERT INTO `lng_data` VALUES ('common','auth_soap','en','SOAP');
INSERT INTO `lng_data` VALUES ('common','auth_soap_allow_local_desc','en','This allows SOAP users to authenticate with their local ILIAS username and a local password.');
INSERT INTO `lng_data` VALUES ('common','auth_soap_auth','en','Configure SOAP Authentication');
INSERT INTO `lng_data` VALUES ('common','auth_soap_auth_desc','en','This settings deal only with SOAP based user authentication, not with the ILIAS SOAP interface.');
INSERT INTO `lng_data` VALUES ('common','auth_soap_create_users_desc','en','Creates automatically an ILIAS user account, for users that successfully authenticated against SOAP, without having an ILIAS account yet.');
INSERT INTO `lng_data` VALUES ('common','auth_soap_namespace','en','Namespace');
INSERT INTO `lng_data` VALUES ('common','auth_soap_namespace_desc','en','As defined in WSDL. Must be specified, if .NET SOAP style is used.');
INSERT INTO `lng_data` VALUES ('common','auth_soap_port_desc','en','E.g. 8080 if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php');
INSERT INTO `lng_data` VALUES ('common','auth_soap_server_desc','en','E.g. auth.yourserver.com if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php');
INSERT INTO `lng_data` VALUES ('common','auth_soap_settings_saved','en','SOAP authentication settings saved');
INSERT INTO `lng_data` VALUES ('common','auth_soap_uri_desc','en','Local URI, e.g. dir/server.php if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php');
INSERT INTO `lng_data` VALUES ('common','auth_soap_use_dotnet','en','Use .NET SOAP Style');
INSERT INTO `lng_data` VALUES ('common','auth_soap_use_https','en','Use HTTPS');
INSERT INTO `lng_data` VALUES ('common','auth_soap_user_default_role','en','Default role assigned to SOAP authenticated users');
INSERT INTO `lng_data` VALUES ('common','auth_soap_user_default_role_desc','en','This role is assigned to automatically created SOAP users.');
INSERT INTO `lng_data` VALUES ('common','auth_user_default_role','en','Default Role');
INSERT INTO `lng_data` VALUES ('common','auth_visible','en','Authentication settings are visible');
INSERT INTO `lng_data` VALUES ('common','auth_write','en','Edit authentication settings');
INSERT INTO `lng_data` VALUES ('common','authentication_settings','en','Authentication');
INSERT INTO `lng_data` VALUES ('common','author','en','Author');
INSERT INTO `lng_data` VALUES ('common','authors','en','Authors');
INSERT INTO `lng_data` VALUES ('common','auto_registration','en','Automatically approve registration');
INSERT INTO `lng_data` VALUES ('common','available','en','Available');
INSERT INTO `lng_data` VALUES ('common','available_languages','en','Available Languages');
INSERT INTO `lng_data` VALUES ('common','average_time','en','Average time');
INSERT INTO `lng_data` VALUES ('common','back','en','Back');
INSERT INTO `lng_data` VALUES ('common','back_to_crs_content','en','Back to Course Content');
INSERT INTO `lng_data` VALUES ('common','back_to_fold_content','en','Back to Folder Content');
INSERT INTO `lng_data` VALUES ('common','back_to_grp_content','en','Back to Group Content');
INSERT INTO `lng_data` VALUES ('common','basedn','en','BaseDN');
INSERT INTO `lng_data` VALUES ('common','basic_data','en','Basic Data');
INSERT INTO `lng_data` VALUES ('common','basic_settings','en','Basic Settings');
INSERT INTO `lng_data` VALUES ('common','benchmark','en','Benchmark');
INSERT INTO `lng_data` VALUES ('common','benchmark_settings','en','Benchmark Settings');
INSERT INTO `lng_data` VALUES ('common','benchmarks','en','Benchmarks');
INSERT INTO `lng_data` VALUES ('common','bib_data','en','Bibliographical Data');
INSERT INTO `lng_data` VALUES ('common','big_icon','en','Big Icon');
INSERT INTO `lng_data` VALUES ('common','bkm_import','en','Import bookmarks');
INSERT INTO `lng_data` VALUES ('common','bkm_import_ok','en','Successfully imported %d bookmarks and %d bookmark folders.');
INSERT INTO `lng_data` VALUES ('common','bkm_sendmail','en','Send as attachment');
INSERT INTO `lng_data` VALUES ('common','bm','en','Bookmark');
INSERT INTO `lng_data` VALUES ('common','bmf','en','Bookmark Folder');
INSERT INTO `lng_data` VALUES ('common','bookmark_edit','en','Edit Bookmark');
INSERT INTO `lng_data` VALUES ('common','bookmark_folder_edit','en','Edit Bookmark Folder');
INSERT INTO `lng_data` VALUES ('common','bookmark_folder_new','en','New Bookmark Folder');
INSERT INTO `lng_data` VALUES ('common','bookmark_new','en','New Bookmark');
INSERT INTO `lng_data` VALUES ('common','bookmark_target','en','Target');
INSERT INTO `lng_data` VALUES ('common','bookmarks','en','Bookmarks');
INSERT INTO `lng_data` VALUES ('common','bookmarks_of','en','Bookmarks of');
INSERT INTO `lng_data` VALUES ('common','bottom_frame','en','Main Content');
INSERT INTO `lng_data` VALUES ('common','btn_add','en','Add');
INSERT INTO `lng_data` VALUES ('common','btn_new_value','en','New value');
INSERT INTO `lng_data` VALUES ('common','btn_next','en','Continue');
INSERT INTO `lng_data` VALUES ('common','btn_previous','en','Back');
INSERT INTO `lng_data` VALUES ('common','btn_remove_system','en','Remove from System');
INSERT INTO `lng_data` VALUES ('common','btn_undelete','en','Undelete');
INSERT INTO `lng_data` VALUES ('common','by','en','By');
INSERT INTO `lng_data` VALUES ('common','by_location','en','Order by location');
INSERT INTO `lng_data` VALUES ('common','by_type','en','Order by type');
INSERT INTO `lng_data` VALUES ('common','bytes','en','Bytes');
INSERT INTO `lng_data` VALUES ('common','calendar','en','Calendar');
INSERT INTO `lng_data` VALUES ('common','cancel','en','Cancel');
INSERT INTO `lng_data` VALUES ('common','cannot_find_xml','en','Cannot find any XML-file.');
INSERT INTO `lng_data` VALUES ('common','cannot_uninstall_language_in_use','en','You cannot uninstall the language currently in use!');
INSERT INTO `lng_data` VALUES ('common','cannot_uninstall_systemlanguage','en','You cannot uninstall the system language!');
INSERT INTO `lng_data` VALUES ('common','cannot_unzip_file','en','Cannot unpack file.');
INSERT INTO `lng_data` VALUES ('common','cant_deactivate_if_users_assigned','en','You cannot deactivate a style if there are still users assigned to it.');
INSERT INTO `lng_data` VALUES ('common','cat','en','Category');
INSERT INTO `lng_data` VALUES ('common','cat_a','en','a Category');
INSERT INTO `lng_data` VALUES ('common','cat_add','en','Add Category');
INSERT INTO `lng_data` VALUES ('common','cat_added','en','Category added');
INSERT INTO `lng_data` VALUES ('common','cat_cat_administrate_users','en','Administrate local user accounts');
INSERT INTO `lng_data` VALUES ('common','cat_clear_page','en','Clear Page');
INSERT INTO `lng_data` VALUES ('common','cat_create','en','Create Category');
INSERT INTO `lng_data` VALUES ('common','cat_create_alm','en','Create AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','cat_create_cat','en','Create Category');
INSERT INTO `lng_data` VALUES ('common','cat_create_chat','en','Create Chat');
INSERT INTO `lng_data` VALUES ('common','cat_create_crs','en','Create Course');
INSERT INTO `lng_data` VALUES ('common','cat_create_dbk','en','Create Digilib Book');
INSERT INTO `lng_data` VALUES ('common','cat_create_exc','en','Create Exercise');
INSERT INTO `lng_data` VALUES ('common','cat_create_file','en','Upload File');
INSERT INTO `lng_data` VALUES ('common','cat_create_frm','en','Create Forum');
INSERT INTO `lng_data` VALUES ('common','cat_create_glo','en','Create Glossary');
INSERT INTO `lng_data` VALUES ('common','cat_create_grp','en','Create Group');
INSERT INTO `lng_data` VALUES ('common','cat_create_hlm','en','Create HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','cat_create_htlm','en','Create HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','cat_create_icrs','en','Create LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','cat_create_lm','en','Create ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','cat_create_mep','en','Create Media Pool');
INSERT INTO `lng_data` VALUES ('common','cat_create_qpl','en','Create Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','cat_create_sahs','en','Create SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','cat_create_spl','en','Create Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','cat_create_svy','en','Create Survey');
INSERT INTO `lng_data` VALUES ('common','cat_create_tst','en','Create Test');
INSERT INTO `lng_data` VALUES ('common','cat_create_url','en','Create URL');
INSERT INTO `lng_data` VALUES ('common','cat_create_webr','en','Create Web Resource');
INSERT INTO `lng_data` VALUES ('common','cat_delete','en','Delete Category');
INSERT INTO `lng_data` VALUES ('common','cat_edit','en','Edit Category');
INSERT INTO `lng_data` VALUES ('common','cat_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','cat_new','en','New Category');
INSERT INTO `lng_data` VALUES ('common','cat_pages','en','Category Pages');
INSERT INTO `lng_data` VALUES ('common','cat_pages_clear','en','Category page cleared.');
INSERT INTO `lng_data` VALUES ('common','cat_pages_not_created','en','Category page not createded yet.');
INSERT INTO `lng_data` VALUES ('common','cat_pages_undone','en','Last changes for cagegory page undone.');
INSERT INTO `lng_data` VALUES ('common','cat_read','en','Read access to Category');
INSERT INTO `lng_data` VALUES ('common','cat_read_users','en','Read access to local user accounts');
INSERT INTO `lng_data` VALUES ('common','cat_undo_last_page_changes','en','Undo Last Page Changes');
INSERT INTO `lng_data` VALUES ('common','cat_visible','en','Category is visible');
INSERT INTO `lng_data` VALUES ('common','cat_write','en','Edit Category');
INSERT INTO `lng_data` VALUES ('common','categories','en','Categories');
INSERT INTO `lng_data` VALUES ('common','categories_imported','en','Category import complete.');
INSERT INTO `lng_data` VALUES ('common','cc','en','CC');
INSERT INTO `lng_data` VALUES ('common','cen','en','Centra Event');
INSERT INTO `lng_data` VALUES ('common','cen_add','en','Add Centra Event');
INSERT INTO `lng_data` VALUES ('common','cen_added','en','Centra Event added');
INSERT INTO `lng_data` VALUES ('common','cen_delete','en','Delete Centra Event');
INSERT INTO `lng_data` VALUES ('common','cen_edit','en','Edit Centra Event');
INSERT INTO `lng_data` VALUES ('common','cen_new','en','New Centra Event');
INSERT INTO `lng_data` VALUES ('common','cen_save','en','Save Centra Event');
INSERT INTO `lng_data` VALUES ('common','censorship','en','Censorship');
INSERT INTO `lng_data` VALUES ('common','centra_account','en','Centra Admin Account');
INSERT INTO `lng_data` VALUES ('common','centra_rooms','en','Centra Rooms');
INSERT INTO `lng_data` VALUES ('common','centra_server','en','Centra Server');
INSERT INTO `lng_data` VALUES ('common','chac_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','chac_read','en','Read access to chat settings');
INSERT INTO `lng_data` VALUES ('common','chac_visible','en','Chat settings are visible');
INSERT INTO `lng_data` VALUES ('common','chac_write','en','Edit chat settings');
INSERT INTO `lng_data` VALUES ('common','change','en','Change');
INSERT INTO `lng_data` VALUES ('common','change_active_assignment','en','Change active assignment');
INSERT INTO `lng_data` VALUES ('common','change_assignment','en','Change assignment');
INSERT INTO `lng_data` VALUES ('common','change_existing_objects','en','Change existing Objects');
INSERT INTO `lng_data` VALUES ('common','change_header_title','en','Edit Header Title');
INSERT INTO `lng_data` VALUES ('common','change_lo_info','en','Change LO Info');
INSERT INTO `lng_data` VALUES ('common','change_metadata','en','Change Metadata');
INSERT INTO `lng_data` VALUES ('common','change_owner','en','Change owner');
INSERT INTO `lng_data` VALUES ('common','change_sort_direction','en','Change sort direction');
INSERT INTO `lng_data` VALUES ('common','changeable','en','Changeable');
INSERT INTO `lng_data` VALUES ('common','changed_to','en','changed to');
INSERT INTO `lng_data` VALUES ('common','chapter','en','Chapter');
INSERT INTO `lng_data` VALUES ('common','chapter_number','en','Chapter Number');
INSERT INTO `lng_data` VALUES ('common','chapter_title','en','Chapter Title');
INSERT INTO `lng_data` VALUES ('common','characters','en','characters');
INSERT INTO `lng_data` VALUES ('common','chat','en','Chat');
INSERT INTO `lng_data` VALUES ('common','chat_active_in','en','Active in chat:');
INSERT INTO `lng_data` VALUES ('common','chat_add','en','Add Chat');
INSERT INTO `lng_data` VALUES ('common','chat_delete','en','Delete chat');
INSERT INTO `lng_data` VALUES ('common','chat_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','chat_invite','en','Chat');
INSERT INTO `lng_data` VALUES ('common','chat_moderate','en','Moderate chat');
INSERT INTO `lng_data` VALUES ('common','chat_new','en','New Chat');
INSERT INTO `lng_data` VALUES ('common','chat_read','en','Read/Write access to chat');
INSERT INTO `lng_data` VALUES ('common','chat_users_active','en','Active users');
INSERT INTO `lng_data` VALUES ('common','chat_visible','en','Chat is visible');
INSERT INTO `lng_data` VALUES ('common','chat_write','en','Edit chat');
INSERT INTO `lng_data` VALUES ('common','check','en','Check');
INSERT INTO `lng_data` VALUES ('common','check_all','en','Check all');
INSERT INTO `lng_data` VALUES ('common','check_langfile','en','Please check your language file');
INSERT INTO `lng_data` VALUES ('common','check_languages','en','Check Languages');
INSERT INTO `lng_data` VALUES ('common','check_link','en','Link check');
INSERT INTO `lng_data` VALUES ('common','check_link_desc','en','If enabled all external links in ILIAS learning modules will be checked if they are active.');
INSERT INTO `lng_data` VALUES ('common','check_max_allowed_packet_size','en','The page content size is too large.');
INSERT INTO `lng_data` VALUES ('common','check_user_accounts','en','Check user accounts');
INSERT INTO `lng_data` VALUES ('common','check_user_accounts_desc','en','If cron jobs are activated and this option is enabled, all users whose account expires will be informed by email.');
INSERT INTO `lng_data` VALUES ('common','check_web_resources','en','Check Web Resources');
INSERT INTO `lng_data` VALUES ('common','check_web_resources_desc','en','If enabled all Web Resources will be checked if they are active.');
INSERT INTO `lng_data` VALUES ('common','checked_files','en','Importable files');
INSERT INTO `lng_data` VALUES ('common','chg_language','en','Change Language');
INSERT INTO `lng_data` VALUES ('common','chg_password','en','Change Password');
INSERT INTO `lng_data` VALUES ('common','choose_language','en','Choose Your Language');
INSERT INTO `lng_data` VALUES ('common','choose_location','en','Choose Location');
INSERT INTO `lng_data` VALUES ('common','choose_only_one_language','en','Please choose only one language');
INSERT INTO `lng_data` VALUES ('common','chown_warning','en','Attention, you may loose access permissions on this object after changing the owner.');
INSERT INTO `lng_data` VALUES ('common','city','en','City, State');
INSERT INTO `lng_data` VALUES ('common','cleaned_file','en','File has been cleaned.');
INSERT INTO `lng_data` VALUES ('common','cleaning_failed','en','Cleaning failed.');
INSERT INTO `lng_data` VALUES ('common','clear','en','Clear');
INSERT INTO `lng_data` VALUES ('common','clear_clipboard','en','Empty Clipboard');
INSERT INTO `lng_data` VALUES ('common','client','en','Client');
INSERT INTO `lng_data` VALUES ('common','client_id','en','Client ID');
INSERT INTO `lng_data` VALUES ('common','client_ip','en','Client IP');
INSERT INTO `lng_data` VALUES ('common','clipboard','en','Clipboard');
INSERT INTO `lng_data` VALUES ('common','close','en','Close');
INSERT INTO `lng_data` VALUES ('common','close_window','en','Close window');
INSERT INTO `lng_data` VALUES ('common','cnt_new','en','(%s New)');
INSERT INTO `lng_data` VALUES ('common','collapse','en','Collapse');
INSERT INTO `lng_data` VALUES ('common','comma_separated','en','Comma Separated');
INSERT INTO `lng_data` VALUES ('common','comment','en','Comment');
INSERT INTO `lng_data` VALUES ('common','compose','en','Compose');
INSERT INTO `lng_data` VALUES ('common','condition','en','Condition');
INSERT INTO `lng_data` VALUES ('common','condition_already_assigned','en','Object already assigned.');
INSERT INTO `lng_data` VALUES ('common','condition_circle_created','en','This association is not possible, since the objects would interdepend.');
INSERT INTO `lng_data` VALUES ('common','condition_deleted','en','Condition deleted.');
INSERT INTO `lng_data` VALUES ('common','condition_finished','en','Finished');
INSERT INTO `lng_data` VALUES ('common','condition_not_finished','en','Not finished');
INSERT INTO `lng_data` VALUES ('common','condition_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('common','condition_precondition','en','Preconditions:');
INSERT INTO `lng_data` VALUES ('common','condition_select_object','en','Please select one object.');
INSERT INTO `lng_data` VALUES ('common','condition_select_one','en','-Please select one condition-');
INSERT INTO `lng_data` VALUES ('common','condition_update','en','Save');
INSERT INTO `lng_data` VALUES ('common','conditions_updated','en','Conditions saved');
INSERT INTO `lng_data` VALUES ('common','confirm','en','Confirm');
INSERT INTO `lng_data` VALUES ('common','confirmation','en','Confirmation');
INSERT INTO `lng_data` VALUES ('common','conflict_handling','en','Conflict handling');
INSERT INTO `lng_data` VALUES ('common','cont_object','en','Object');
INSERT INTO `lng_data` VALUES ('common','contact_data','en','Contact Information');
INSERT INTO `lng_data` VALUES ('common','container','en','Container');
INSERT INTO `lng_data` VALUES ('common','content','en','Content');
INSERT INTO `lng_data` VALUES ('common','content_styles','en','Content Styles');
INSERT INTO `lng_data` VALUES ('common','context','en','Context');
INSERT INTO `lng_data` VALUES ('common','continue_work','en','Continue');
INSERT INTO `lng_data` VALUES ('common','contra','en','Contra');
INSERT INTO `lng_data` VALUES ('common','cookies_howto','en','How to enable cookies');
INSERT INTO `lng_data` VALUES ('common','copied_object','en','Copied object');
INSERT INTO `lng_data` VALUES ('common','copy','en','Copy');
INSERT INTO `lng_data` VALUES ('common','copyChapter','en','Copy');
INSERT INTO `lng_data` VALUES ('common','copyPage','en','Copy');
INSERT INTO `lng_data` VALUES ('common','copy_of','en','Copy of');
INSERT INTO `lng_data` VALUES ('common','copy_to','en','to');
INSERT INTO `lng_data` VALUES ('common','could_not_verify_account','en','Sorry, we could not verify your account. Please contact the system administrator.');
INSERT INTO `lng_data` VALUES ('common','count','en','Count');
INSERT INTO `lng_data` VALUES ('common','country','en','Country');
INSERT INTO `lng_data` VALUES ('common','course','en','Course');
INSERT INTO `lng_data` VALUES ('common','courses','en','Courses');
INSERT INTO `lng_data` VALUES ('common','create','en','Create');
INSERT INTO `lng_data` VALUES ('common','create_date','en','Created on');
INSERT INTO `lng_data` VALUES ('common','create_export_file','en','Create export file');
INSERT INTO `lng_data` VALUES ('common','create_in','en','Create in');
INSERT INTO `lng_data` VALUES ('common','create_stylesheet','en','Create Style');
INSERT INTO `lng_data` VALUES ('common','created','en','Create date');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification','en','Send forum notifications');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_cron','en','regularly per cron job');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_desc','en','If enabled, all users, who want to be informed about new posts in specified forum topics, will get notifications by e-mail.');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_directly','en','directly on new entries');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_never','en','never');
INSERT INTO `lng_data` VALUES ('common','cron_jobs','en','Cron jobs');
INSERT INTO `lng_data` VALUES ('common','cron_jobs_desc','en','A cron job is an automated process that operates at predefined time intervals. You will find informations about the setup in the \'INSTALL Documentation.');
INSERT INTO `lng_data` VALUES ('common','cron_lucene_index','en','Update Lucene search index');
INSERT INTO `lng_data` VALUES ('common','cron_lucene_index_info','en','If enabled, the lucene search index will be updated. Please configure the lucene server at \'Administration -> Search\'.');
INSERT INTO `lng_data` VALUES ('common','crs','en','Course');
INSERT INTO `lng_data` VALUES ('common','crs_a','en','a Course');
INSERT INTO `lng_data` VALUES ('common','crs_activation_start_invalid','en','The start and the end time is not valid.');
INSERT INTO `lng_data` VALUES ('common','crs_add','en','Add Course');
INSERT INTO `lng_data` VALUES ('common','crs_added','en','Course added');
INSERT INTO `lng_data` VALUES ('common','crs_all_questions_answered_successfully','en','You have successfully answered every question.');
INSERT INTO `lng_data` VALUES ('common','crs_archives','en','Archives');
INSERT INTO `lng_data` VALUES ('common','crs_at_least_one_admin','en','There has to be at least one course administrator.');
INSERT INTO `lng_data` VALUES ('common','crs_available','en','Available Courses');
INSERT INTO `lng_data` VALUES ('common','crs_container_link_not_allowed','en','It is not possible to link container objects');
INSERT INTO `lng_data` VALUES ('common','crs_create','en','Create Course');
INSERT INTO `lng_data` VALUES ('common','crs_create_alm','en','Create AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','crs_create_chat','en','Create Chat');
INSERT INTO `lng_data` VALUES ('common','crs_create_dbk','en','Create Digilib Book');
INSERT INTO `lng_data` VALUES ('common','crs_create_exc','en','Create Exercise');
INSERT INTO `lng_data` VALUES ('common','crs_create_file','en','Upload File');
INSERT INTO `lng_data` VALUES ('common','crs_create_fold','en','Create Folder');
INSERT INTO `lng_data` VALUES ('common','crs_create_frm','en','Create Forum');
INSERT INTO `lng_data` VALUES ('common','crs_create_glo','en','Create Glossary');
INSERT INTO `lng_data` VALUES ('common','crs_create_grp','en','Create Group');
INSERT INTO `lng_data` VALUES ('common','crs_create_hlm','en','Create HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','crs_create_htlm','en','Create HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','crs_create_icrs','en','Create LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','crs_create_lm','en','Create ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','crs_create_mep','en','Create Media Pool');
INSERT INTO `lng_data` VALUES ('common','crs_create_qpl','en','Create Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','crs_create_sahs','en','Create SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','crs_create_spl','en','Create Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','crs_create_svy','en','Create Survey');
INSERT INTO `lng_data` VALUES ('common','crs_create_tst','en','Create Test');
INSERT INTO `lng_data` VALUES ('common','crs_create_webr','en','Create Web Resource');
INSERT INTO `lng_data` VALUES ('common','crs_delete','en','Delete Course');
INSERT INTO `lng_data` VALUES ('common','crs_edit','en','Edit Course');
INSERT INTO `lng_data` VALUES ('common','crs_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','crs_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','crs_info','en','Info');
INSERT INTO `lng_data` VALUES ('common','crs_join','en','Join Course');
INSERT INTO `lng_data` VALUES ('common','crs_leave','en','Leave Course');
INSERT INTO `lng_data` VALUES ('common','crs_management_system','en','Course Management System');
INSERT INTO `lng_data` VALUES ('common','crs_member_not_passed','en','Not passed');
INSERT INTO `lng_data` VALUES ('common','crs_member_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('common','crs_members_gallery','en','Course Members Gallery');
INSERT INTO `lng_data` VALUES ('common','crs_new','en','New Course');
INSERT INTO `lng_data` VALUES ('common','crs_no_content','en','Without content');
INSERT INTO `lng_data` VALUES ('common','crs_read','en','Read access to Course');
INSERT INTO `lng_data` VALUES ('common','crs_status_blocked','en','[Access refused]');
INSERT INTO `lng_data` VALUES ('common','crs_status_pending','en','[Waiting for registration]');
INSERT INTO `lng_data` VALUES ('common','crs_subscribers_assigned','en','Assigned new user(s)');
INSERT INTO `lng_data` VALUES ('common','crs_visible','en','Course is visible');
INSERT INTO `lng_data` VALUES ('common','crs_write','en','Edit Course');
INSERT INTO `lng_data` VALUES ('common','cumulative_time','en','Cumulative time');
INSERT INTO `lng_data` VALUES ('common','cur_number_rec','en','Current number of records');
INSERT INTO `lng_data` VALUES ('common','current_ip','en','Current IP:');
INSERT INTO `lng_data` VALUES ('common','current_ip_alert','en','Notice: if you enter a wrong ip you won\'t be able to access the system with this profile anymore.');
INSERT INTO `lng_data` VALUES ('common','current_password','en','Current Password');
INSERT INTO `lng_data` VALUES ('common','custom_icon_size_big','en','Custom icon size (big)');
INSERT INTO `lng_data` VALUES ('common','custom_icon_size_small','en','Custom icon size (small)');
INSERT INTO `lng_data` VALUES ('common','cut','en','Cut');
INSERT INTO `lng_data` VALUES ('common','cutPage','en','Cut');
INSERT INTO `lng_data` VALUES ('common','daily','en','daily');
INSERT INTO `lng_data` VALUES ('common','data_privacy','en','Data Privacy Settings');
INSERT INTO `lng_data` VALUES ('common','database','en','Database');
INSERT INTO `lng_data` VALUES ('common','database_version','en','Current Database Version');
INSERT INTO `lng_data` VALUES ('common','dataset','en','Item');
INSERT INTO `lng_data` VALUES ('common','date','en','Date');
INSERT INTO `lng_data` VALUES ('common','dateplaner','en','Calendar');
INSERT INTO `lng_data` VALUES ('common','day','en','Day');
INSERT INTO `lng_data` VALUES ('common','days','en','Days');
INSERT INTO `lng_data` VALUES ('common','days_of_period','en','Days of period');
INSERT INTO `lng_data` VALUES ('common','db_host','en','Database Host');
INSERT INTO `lng_data` VALUES ('common','db_name','en','Database Name');
INSERT INTO `lng_data` VALUES ('common','db_need_update','en','Database needs an update!');
INSERT INTO `lng_data` VALUES ('common','db_pass','en','Database Password');
INSERT INTO `lng_data` VALUES ('common','db_type','en','Database Type');
INSERT INTO `lng_data` VALUES ('common','db_user','en','Database User');
INSERT INTO `lng_data` VALUES ('common','db_version','en','Database Version');
INSERT INTO `lng_data` VALUES ('common','dbk','en','Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_a','en','a Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_add','en','Add Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_added','en','Digilib Book added');
INSERT INTO `lng_data` VALUES ('common','dbk_create','en','Create Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_delete','en','Delete Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','dbk_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','dbk_new','en','New Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_read','en','Read access to Digilib Book');
INSERT INTO `lng_data` VALUES ('common','dbk_visible','en','Digilib Book is visible');
INSERT INTO `lng_data` VALUES ('common','dbk_write','en','Edit Digilib Book');
INSERT INTO `lng_data` VALUES ('common','def_repository_view','en','Default repository view');
INSERT INTO `lng_data` VALUES ('common','default','en','Default');
INSERT INTO `lng_data` VALUES ('common','default_language','en','Default Language');
INSERT INTO `lng_data` VALUES ('common','default_perm_settings','en','Default permissions');
INSERT INTO `lng_data` VALUES ('common','default_role','en','Default Role');
INSERT INTO `lng_data` VALUES ('common','default_roles','en','Default Roles');
INSERT INTO `lng_data` VALUES ('common','default_skin','en','Default Skin');
INSERT INTO `lng_data` VALUES ('common','default_skin_style','en','Default Skin / Style');
INSERT INTO `lng_data` VALUES ('common','default_style','en','Default Style');
INSERT INTO `lng_data` VALUES ('common','default_value','en','Default Value');
INSERT INTO `lng_data` VALUES ('common','delete','en','Delete');
INSERT INTO `lng_data` VALUES ('common','delete_all','en','Delete All');
INSERT INTO `lng_data` VALUES ('common','delete_all_rec','en','Delete all records');
INSERT INTO `lng_data` VALUES ('common','delete_object','en','Delete Object(s)');
INSERT INTO `lng_data` VALUES ('common','delete_selected','en','Delete Selected');
INSERT INTO `lng_data` VALUES ('common','delete_selected_items','en','Delete selected items');
INSERT INTO `lng_data` VALUES ('common','delete_tr_data','en','Delete tracking data');
INSERT INTO `lng_data` VALUES ('common','deleted','en','Deleted');
INSERT INTO `lng_data` VALUES ('common','deleted_user','en','The user has been deleted');
INSERT INTO `lng_data` VALUES ('common','deleted_users','en','Deleted users');
INSERT INTO `lng_data` VALUES ('common','deliver','en','Deliver');
INSERT INTO `lng_data` VALUES ('common','department','en','Department');
INSERT INTO `lng_data` VALUES ('common','desc','en','Description');
INSERT INTO `lng_data` VALUES ('common','descending_order','en','Descending order');
INSERT INTO `lng_data` VALUES ('common','description','en','Description');
INSERT INTO `lng_data` VALUES ('common','desired_password','en','Desired Password');
INSERT INTO `lng_data` VALUES ('common','desktop_items','en','Personal desktop items');
INSERT INTO `lng_data` VALUES ('common','details','en','Details');
INSERT INTO `lng_data` VALUES ('common','disable','en','disable');
INSERT INTO `lng_data` VALUES ('common','disable_check','en','Disable check');
INSERT INTO `lng_data` VALUES ('common','disabled','en','Disabled');
INSERT INTO `lng_data` VALUES ('common','domain','en','Domain');
INSERT INTO `lng_data` VALUES ('common','down','en','Down');
INSERT INTO `lng_data` VALUES ('common','download','en','Download');
INSERT INTO `lng_data` VALUES ('common','download_all_returned_files','en','Download all returned files');
INSERT INTO `lng_data` VALUES ('common','drafts','en','Drafts');
INSERT INTO `lng_data` VALUES ('common','drop','en','Drop');
INSERT INTO `lng_data` VALUES ('common','edit','en','Edit');
INSERT INTO `lng_data` VALUES ('common','edit_comments','en','Edit comments for the selected user');
INSERT INTO `lng_data` VALUES ('common','edit_content','en','Edit content');
INSERT INTO `lng_data` VALUES ('common','edit_data','en','edit data');
INSERT INTO `lng_data` VALUES ('common','edit_operations','en','Edit Operations');
INSERT INTO `lng_data` VALUES ('common','edit_page','en','Edit Page');
INSERT INTO `lng_data` VALUES ('common','edit_page_content','en','Edit Page Content');
INSERT INTO `lng_data` VALUES ('common','edit_perm_ruleset','en','Edit default permission rules');
INSERT INTO `lng_data` VALUES ('common','edit_properties','en','Edit Properties');
INSERT INTO `lng_data` VALUES ('common','edit_roleassignment','en','Edit role assignment');
INSERT INTO `lng_data` VALUES ('common','edit_stylesheet','en','Edit Style');
INSERT INTO `lng_data` VALUES ('common','edited_at','en','Edited at');
INSERT INTO `lng_data` VALUES ('common','editor','en','Editor');
INSERT INTO `lng_data` VALUES ('common','email','en','Mail');
INSERT INTO `lng_data` VALUES ('common','email_feedback','en','Mail feedback');
INSERT INTO `lng_data` VALUES ('common','email_footer','en','<br />powered by ILIAS');
INSERT INTO `lng_data` VALUES ('common','email_not_valid','en','The email address you entered is not valid!');
INSERT INTO `lng_data` VALUES ('common','enable','en','Enable');
INSERT INTO `lng_data` VALUES ('common','enable_calendar','en','Enable Calendar');
INSERT INTO `lng_data` VALUES ('common','enable_custom_icons','en','Enable custom icons');
INSERT INTO `lng_data` VALUES ('common','enable_custom_icons_info','en','This allows to define custom icons for single categories, courses and groups. The properties section of categories, courses and groups will provide an image upload dialog.');
INSERT INTO `lng_data` VALUES ('common','enable_fora_statistics','en','Enable Statistics in Forum');
INSERT INTO `lng_data` VALUES ('common','enable_fora_statistics_desc','en','If disabled, nobody is able to access the forum statistics.');
INSERT INTO `lng_data` VALUES ('common','enable_hist_user_comments','en','Enable user comments in history');
INSERT INTO `lng_data` VALUES ('common','enable_hist_user_comments_desc','en','Give authors the opportunity to add comments to the history log of pages.');
INSERT INTO `lng_data` VALUES ('common','enable_js_edit','en','Enable JavaScript Editing');
INSERT INTO `lng_data` VALUES ('common','enable_js_edit_info','en','This option enables JavaScript editing for all content objects (ILIAS Learning Modules, Glossaries, Assessment Questions, Digilib Books)');
INSERT INTO `lng_data` VALUES ('common','enable_password_assistance','en','Enable password assistance');
INSERT INTO `lng_data` VALUES ('common','enable_registration','en','Enable new user registration');
INSERT INTO `lng_data` VALUES ('common','enable_trash','en','Enable Trash');
INSERT INTO `lng_data` VALUES ('common','enable_trash_info','en','If enabled, deleted Objects are moved into Trash and may be recovered later. When deactivating this option deleted Objects are removed irreversibly from the System!');
INSERT INTO `lng_data` VALUES ('common','enabled','en','Enabled');
INSERT INTO `lng_data` VALUES ('common','enter_filename_deliver','en','Enter file to be delivered');
INSERT INTO `lng_data` VALUES ('common','enumerate','en','Enumerate');
INSERT INTO `lng_data` VALUES ('common','err_1_param','en','Only 1 parameter!');
INSERT INTO `lng_data` VALUES ('common','err_2_param','en','Only 2 parameter!');
INSERT INTO `lng_data` VALUES ('common','err_auth_cas_no_ilias_user','en','Login failed. CAS authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.');
INSERT INTO `lng_data` VALUES ('common','err_auth_ext_user_exists','en','External account \'%s\' for authentication mode \'%s\' is already existing. (User \'%s\')');
INSERT INTO `lng_data` VALUES ('common','err_auth_soap_no_ilias_user','en','Login failed. SOAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.');
INSERT INTO `lng_data` VALUES ('common','err_count_param','en','Reason: Wrong parameter count');
INSERT INTO `lng_data` VALUES ('common','err_enter_current_passwd','en','Please enter your current password');
INSERT INTO `lng_data` VALUES ('common','err_in_line','en','Error in line');
INSERT INTO `lng_data` VALUES ('common','err_inactive','en','This account has not been activated. Please contact the system administrator for access.');
INSERT INTO `lng_data` VALUES ('common','err_invalid_port','en','Invalid port number');
INSERT INTO `lng_data` VALUES ('common','err_ldap_auth_failed','en','User not authenticated on LDAP server! Please ensure that you have the same password in ILIAS and LDAP');
INSERT INTO `lng_data` VALUES ('common','err_ldap_connect_failed','en','Connection to LDAP server failed! Please check your settings');
INSERT INTO `lng_data` VALUES ('common','err_ldap_search_failed','en','Connection to LDAP server failed! PLease check BaseDN and Search base');
INSERT INTO `lng_data` VALUES ('common','err_ldap_user_not_found','en','User not found on LDAP server! Please check attribute for login name and Objectclass');
INSERT INTO `lng_data` VALUES ('common','err_no_cookies','en','Please enable session cookies in your browser!');
INSERT INTO `lng_data` VALUES ('common','err_no_langfile_found','en','No language file found!');
INSERT INTO `lng_data` VALUES ('common','err_no_param','en','No parameter!');
INSERT INTO `lng_data` VALUES ('common','err_over_3_param','en','More than 3 parameters!');
INSERT INTO `lng_data` VALUES ('common','err_role_not_assignable','en','You cannot assign users to this role at this location');
INSERT INTO `lng_data` VALUES ('common','err_session_expired','en','Your session is expired!');
INSERT INTO `lng_data` VALUES ('common','err_unknown_error','en','Unknown Error');
INSERT INTO `lng_data` VALUES ('common','err_wrong_header','en','Reason: Wrong header.');
INSERT INTO `lng_data` VALUES ('common','err_wrong_login','en','Wrong Login or Password');
INSERT INTO `lng_data` VALUES ('common','err_wrong_password','en','Wrong Password');
INSERT INTO `lng_data` VALUES ('common','error','en','Error');
INSERT INTO `lng_data` VALUES ('common','error_parser','en','Error starting the parser.');
INSERT INTO `lng_data` VALUES ('common','error_recipient','en','Error Recipient');
INSERT INTO `lng_data` VALUES ('common','exc','en','Exercise');
INSERT INTO `lng_data` VALUES ('common','exc_add','en','Add Exercise');
INSERT INTO `lng_data` VALUES ('common','exc_added','en','Exercise added');
INSERT INTO `lng_data` VALUES ('common','exc_ask_delete','en','Delete file?');
INSERT INTO `lng_data` VALUES ('common','exc_assign_usr','en','Assign User');
INSERT INTO `lng_data` VALUES ('common','exc_create','en','Create exercise');
INSERT INTO `lng_data` VALUES ('common','exc_date_not_valid','en','The date is not valid');
INSERT INTO `lng_data` VALUES ('common','exc_deassign_members','en','Delete member(s)');
INSERT INTO `lng_data` VALUES ('common','exc_delete','en','Delete exercise');
INSERT INTO `lng_data` VALUES ('common','exc_details','en','Exercise details');
INSERT INTO `lng_data` VALUES ('common','exc_download_all','en','Download All');
INSERT INTO `lng_data` VALUES ('common','exc_download_files','en','Download Files');
INSERT INTO `lng_data` VALUES ('common','exc_download_new','en','Download New');
INSERT INTO `lng_data` VALUES ('common','exc_edit','en','New exercise created');
INSERT INTO `lng_data` VALUES ('common','exc_edit_exercise','en','Edit exercise');
INSERT INTO `lng_data` VALUES ('common','exc_edit_learning_progress','en','Edit Learning Progress');
INSERT INTO `lng_data` VALUES ('common','exc_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','exc_edit_until','en','Edit Until');
INSERT INTO `lng_data` VALUES ('common','exc_exercise_sent','en','Exercise Sent');
INSERT INTO `lng_data` VALUES ('common','exc_feedback_sent','en','Feedback Sent');
INSERT INTO `lng_data` VALUES ('common','exc_files','en','Files');
INSERT INTO `lng_data` VALUES ('common','exc_files_returned','en','Submitted Files');
INSERT INTO `lng_data` VALUES ('common','exc_groups','en','Groups');
INSERT INTO `lng_data` VALUES ('common','exc_header_members','en','Exercise (members)');
INSERT INTO `lng_data` VALUES ('common','exc_instruction','en','Work Instructions');
INSERT INTO `lng_data` VALUES ('common','exc_last_submission','en','Last Submission');
INSERT INTO `lng_data` VALUES ('common','exc_mail_users','en','Send mail to user(s)');
INSERT INTO `lng_data` VALUES ('common','exc_members_already_assigned','en','These user are already assigned to this exercise');
INSERT INTO `lng_data` VALUES ('common','exc_members_assigned','en','Members assigned');
INSERT INTO `lng_data` VALUES ('common','exc_members_comments_saved','en','The exercise comments for the selected user have been saved');
INSERT INTO `lng_data` VALUES ('common','exc_new','en','New exercise');
INSERT INTO `lng_data` VALUES ('common','exc_no_members_assigned','en','No members assigned');
INSERT INTO `lng_data` VALUES ('common','exc_notices','en','Notices');
INSERT INTO `lng_data` VALUES ('common','exc_obj','en','Exercise');
INSERT INTO `lng_data` VALUES ('common','exc_read','en','Access exercise');
INSERT INTO `lng_data` VALUES ('common','exc_resubmitted_advice','en','This symbol will be displayed in case that a new file has been submitted after the \"solved\" field has been checked');
INSERT INTO `lng_data` VALUES ('common','exc_roles','en','Roles');
INSERT INTO `lng_data` VALUES ('common','exc_save_changes','en','Save');
INSERT INTO `lng_data` VALUES ('common','exc_schedule','en','Schedule');
INSERT INTO `lng_data` VALUES ('common','exc_search_for','en','Search for');
INSERT INTO `lng_data` VALUES ('common','exc_select_one_file','en','Please select exactly one file.');
INSERT INTO `lng_data` VALUES ('common','exc_send_exercise','en','Send exercise by mail');
INSERT INTO `lng_data` VALUES ('common','exc_sent','en','The exercise has been sent to the selected users');
INSERT INTO `lng_data` VALUES ('common','exc_sent_at','en','Sent at <br />%s');
INSERT INTO `lng_data` VALUES ('common','exc_status','en','Status');
INSERT INTO `lng_data` VALUES ('common','exc_status_resubmitted','en','Resubmitted');
INSERT INTO `lng_data` VALUES ('common','exc_status_saved','en','Exercise updated');
INSERT INTO `lng_data` VALUES ('common','exc_status_sent','en','Delivered');
INSERT INTO `lng_data` VALUES ('common','exc_status_solved','en','Solved');
INSERT INTO `lng_data` VALUES ('common','exc_status_submitted','en','Submitted');
INSERT INTO `lng_data` VALUES ('common','exc_submission','en','Submission');
INSERT INTO `lng_data` VALUES ('common','exc_time_over_short','en','Time is over.');
INSERT INTO `lng_data` VALUES ('common','exc_time_to_send','en','Remaining Working Time');
INSERT INTO `lng_data` VALUES ('common','exc_upload_error','en','Error uploading file');
INSERT INTO `lng_data` VALUES ('common','exc_users','en','Users');
INSERT INTO `lng_data` VALUES ('common','exc_visible','en','Exercise is visible');
INSERT INTO `lng_data` VALUES ('common','exc_write','en','Edit exercise');
INSERT INTO `lng_data` VALUES ('common','excs','en','Exercises');
INSERT INTO `lng_data` VALUES ('common','execute','en','Execute');
INSERT INTO `lng_data` VALUES ('common','exercise_time_over','en','You have reached the end time of the exercise. You cannot longer deliver files!');
INSERT INTO `lng_data` VALUES ('common','exp_html','en','Export HTML');
INSERT INTO `lng_data` VALUES ('common','expand','en','Expand');
INSERT INTO `lng_data` VALUES ('common','explorer_frame','en','Explorer Tree');
INSERT INTO `lng_data` VALUES ('common','export','en','Export');
INSERT INTO `lng_data` VALUES ('common','export_group_members','en','Export group members (to Microsoft Excel)');
INSERT INTO `lng_data` VALUES ('common','export_html','en','export as HTML file');
INSERT INTO `lng_data` VALUES ('common','export_xml','en','export as XML file');
INSERT INTO `lng_data` VALUES ('common','extt_configure','en','configure...');
INSERT INTO `lng_data` VALUES ('common','extt_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc','en','netucate LearnLinc');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_additional_options','en','Additional Options');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_active','en','Enable cost centers');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_active_info','en','With this option enabled you may use iLinc cost centers for Learnlinc-Seminars and Classrooms');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_required','en','Cost center required');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_required_info','en','Specifying at least one Cost center for a LearnLinc Seminar is required');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_configure','en','Configure netucate LearnLinc');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_connection_data','en','Connection data');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_customer_id','en','Customer ID');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_desc','en','Provides virtual classrooms. Commercial service. For an account and further information please contact netucate at www.netucate.com');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_enable','en','Enable LearnLinc support');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_protocol_port','en','Protocol & Port');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_registrar_login','en','Login ID');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_registrar_passwd','en','Password');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_server','en','Server');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_settings_saved','en','LearnLinc settings saved');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_timeout','en','Max time waiting for server response');
INSERT INTO `lng_data` VALUES ('common','extt_name','en','Software/Service');
INSERT INTO `lng_data` VALUES ('common','extt_read','en','Access third party software settings');
INSERT INTO `lng_data` VALUES ('common','extt_remark','en','All software and services listed above are not part of ILIAS and do not fall under the ILIAS open source licence agreement.');
INSERT INTO `lng_data` VALUES ('common','extt_title_configure','en','Configure external software');
INSERT INTO `lng_data` VALUES ('common','extt_visible','en','Third party software settings are visible');
INSERT INTO `lng_data` VALUES ('common','extt_write','en','Configure third party software');
INSERT INTO `lng_data` VALUES ('common','faq_exercise','en','FAQ Exercise');
INSERT INTO `lng_data` VALUES ('common','fax','en','Fax');
INSERT INTO `lng_data` VALUES ('common','feedback','en','Feedback');
INSERT INTO `lng_data` VALUES ('common','feedback_recipient','en','Feedback Recipient');
INSERT INTO `lng_data` VALUES ('common','field_name','en','Field Name');
INSERT INTO `lng_data` VALUES ('common','field_type','en','Field Type');
INSERT INTO `lng_data` VALUES ('common','file','en','File');
INSERT INTO `lng_data` VALUES ('common','file_a','en','a File');
INSERT INTO `lng_data` VALUES ('common','file_add','en','Upload File');
INSERT INTO `lng_data` VALUES ('common','file_add_and_metadata','en','Upload File and Edit Metadata');
INSERT INTO `lng_data` VALUES ('common','file_added','en','File uploaded');
INSERT INTO `lng_data` VALUES ('common','file_delete','en','Delete File');
INSERT INTO `lng_data` VALUES ('common','file_edit','en','Edit File');
INSERT INTO `lng_data` VALUES ('common','file_edit_permission','en','Change Permission settings');
INSERT INTO `lng_data` VALUES ('common','file_icon','en','File icon');
INSERT INTO `lng_data` VALUES ('common','file_info','en','File Information');
INSERT INTO `lng_data` VALUES ('common','file_is_infected','en','The file is infected by a virus.');
INSERT INTO `lng_data` VALUES ('common','file_new','en','New File');
INSERT INTO `lng_data` VALUES ('common','file_not_found','en','File Not Found');
INSERT INTO `lng_data` VALUES ('common','file_not_valid','en','File not valid!');
INSERT INTO `lng_data` VALUES ('common','file_notice','en','Please take note of the maximum file size of');
INSERT INTO `lng_data` VALUES ('common','file_read','en','Download File');
INSERT INTO `lng_data` VALUES ('common','file_suffix_repl','en','File Upload Suffix Replacement');
INSERT INTO `lng_data` VALUES ('common','file_suffix_repl_info','en','Files ending with these suffixes (separated by comma) will be renamed with a suffix \".sec\" if uploaded into the webspace. This is done per default for the suffixes:');
INSERT INTO `lng_data` VALUES ('common','file_valid','en','File is valid!');
INSERT INTO `lng_data` VALUES ('common','file_version','en','Version Provided in File');
INSERT INTO `lng_data` VALUES ('common','file_visible','en','File is visible');
INSERT INTO `lng_data` VALUES ('common','file_write','en','Edit File');
INSERT INTO `lng_data` VALUES ('common','filename','en','Filename');
INSERT INTO `lng_data` VALUES ('common','files','en','Files');
INSERT INTO `lng_data` VALUES ('common','files_location','en','Files Location');
INSERT INTO `lng_data` VALUES ('common','fill_out_all_required_fields','en','Please fill out all required fields');
INSERT INTO `lng_data` VALUES ('common','filter','en','Filter:');
INSERT INTO `lng_data` VALUES ('common','firstname','en','First name');
INSERT INTO `lng_data` VALUES ('common','flatview','en','Flat View');
INSERT INTO `lng_data` VALUES ('common','fold','en','Folder');
INSERT INTO `lng_data` VALUES ('common','fold_a','en','a Folder');
INSERT INTO `lng_data` VALUES ('common','fold_add','en','Add Folder');
INSERT INTO `lng_data` VALUES ('common','fold_added','en','Folder added');
INSERT INTO `lng_data` VALUES ('common','fold_create_alm','en','Create AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','fold_create_chat','en','Create Chat');
INSERT INTO `lng_data` VALUES ('common','fold_create_dbk','en','Create Digilib Book');
INSERT INTO `lng_data` VALUES ('common','fold_create_exc','en','Create Exercise');
INSERT INTO `lng_data` VALUES ('common','fold_create_file','en','Upload File');
INSERT INTO `lng_data` VALUES ('common','fold_create_fold','en','Create Folder');
INSERT INTO `lng_data` VALUES ('common','fold_create_frm','en','Create Forum');
INSERT INTO `lng_data` VALUES ('common','fold_create_glo','en','Create Glossary');
INSERT INTO `lng_data` VALUES ('common','fold_create_hlm','en','Create HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','fold_create_htlm','en','Create HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','fold_create_icrs','en','Create LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','fold_create_lm','en','Create ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','fold_create_mep','en','Create Media Pool');
INSERT INTO `lng_data` VALUES ('common','fold_create_qpl','en','Create Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','fold_create_sahs','en','Create SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','fold_create_spl','en','Create Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','fold_create_svy','en','Create Survey');
INSERT INTO `lng_data` VALUES ('common','fold_create_tst','en','Create Test');
INSERT INTO `lng_data` VALUES ('common','fold_create_webr','en','Create Web Resource');
INSERT INTO `lng_data` VALUES ('common','fold_delete','en','Delete Folder');
INSERT INTO `lng_data` VALUES ('common','fold_edit','en','Edit Folder');
INSERT INTO `lng_data` VALUES ('common','fold_edit_learning_progress','en','Edit Learning Progress');
INSERT INTO `lng_data` VALUES ('common','fold_edit_permission','en','Change Permission settings');
INSERT INTO `lng_data` VALUES ('common','fold_new','en','New Folder');
INSERT INTO `lng_data` VALUES ('common','fold_read','en','Read access to Folder');
INSERT INTO `lng_data` VALUES ('common','fold_visible','en','Folder is visible');
INSERT INTO `lng_data` VALUES ('common','fold_write','en','Edit Folder');
INSERT INTO `lng_data` VALUES ('common','folder','en','Folder');
INSERT INTO `lng_data` VALUES ('common','folders','en','Folders');
INSERT INTO `lng_data` VALUES ('common','force_accept_usr_agreement','en','You must accept the user agreement!');
INSERT INTO `lng_data` VALUES ('common','forename','en','Forename');
INSERT INTO `lng_data` VALUES ('common','forgot_password','en','Forgot password?');
INSERT INTO `lng_data` VALUES ('common','forgot_username','en','Forgot username?');
INSERT INTO `lng_data` VALUES ('common','form_empty_fields','en','Please complete these fields:');
INSERT INTO `lng_data` VALUES ('common','forum','en','Forum');
INSERT INTO `lng_data` VALUES ('common','forum_direct_notification','en','Dir. Notification');
INSERT INTO `lng_data` VALUES ('common','forum_general_notification','en','Gen. Notification');
INSERT INTO `lng_data` VALUES ('common','forum_import','en','Forum import');
INSERT INTO `lng_data` VALUES ('common','forum_import_file','en','Import file');
INSERT INTO `lng_data` VALUES ('common','forum_notification','en','Notification');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me','en','Notify me when a reply is posted');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me_directly','en','Please inform me about direct answers to my contribution.');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me_generally','en','Please inform me about any new contributions to my topic.');
INSERT INTO `lng_data` VALUES ('common','forum_post_replied','en','Your forum entry has been replied.');
INSERT INTO `lng_data` VALUES ('common','forums','en','Forums');
INSERT INTO `lng_data` VALUES ('common','forums_articles','en','Articles');
INSERT INTO `lng_data` VALUES ('common','forums_last_post','en','Last Article');
INSERT INTO `lng_data` VALUES ('common','forums_moderators','en','Moderators');
INSERT INTO `lng_data` VALUES ('common','forums_new_articles','en','New articles');
INSERT INTO `lng_data` VALUES ('common','forums_overview','en','Forums Overview');
INSERT INTO `lng_data` VALUES ('common','forums_threads','en','Topics');
INSERT INTO `lng_data` VALUES ('common','frm','en','Forum');
INSERT INTO `lng_data` VALUES ('common','frm_a','en','a Forum');
INSERT INTO `lng_data` VALUES ('common','frm_add','en','Add Forum');
INSERT INTO `lng_data` VALUES ('common','frm_added','en','Forum added');
INSERT INTO `lng_data` VALUES ('common','frm_article','en','article');
INSERT INTO `lng_data` VALUES ('common','frm_create','en','Create Forum');
INSERT INTO `lng_data` VALUES ('common','frm_delete','en','Delete Forum');
INSERT INTO `lng_data` VALUES ('common','frm_delete_post','en','Delete a post, censorship');
INSERT INTO `lng_data` VALUES ('common','frm_edit','en','Edit Forum');
INSERT INTO `lng_data` VALUES ('common','frm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','frm_edit_post','en','Add new thread, posting');
INSERT INTO `lng_data` VALUES ('common','frm_new','en','New Forum');
INSERT INTO `lng_data` VALUES ('common','frm_read','en','Read access to Forum');
INSERT INTO `lng_data` VALUES ('common','frm_statistics_ranking','en','Ranking');
INSERT INTO `lng_data` VALUES ('common','frm_status_new','en','Status \'New\'');
INSERT INTO `lng_data` VALUES ('common','frm_status_new_desc','en','Please select a duration how long the status \'New\' is kept for forum entries.');
INSERT INTO `lng_data` VALUES ('common','frm_visible','en','Forum is visible');
INSERT INTO `lng_data` VALUES ('common','frm_write','en','Edit forum');
INSERT INTO `lng_data` VALUES ('common','from','en','From');
INSERT INTO `lng_data` VALUES ('common','fullname','en','Full name');
INSERT INTO `lng_data` VALUES ('common','functions','en','Functions');
INSERT INTO `lng_data` VALUES ('common','gdf_add','en','Add Definition');
INSERT INTO `lng_data` VALUES ('common','gdf_new','en','New Definition');
INSERT INTO `lng_data` VALUES ('common','gender','en','Gender');
INSERT INTO `lng_data` VALUES ('common','gender_f','en','Female');
INSERT INTO `lng_data` VALUES ('common','gender_m','en','Male');
INSERT INTO `lng_data` VALUES ('common','general_settings','en','General settings');
INSERT INTO `lng_data` VALUES ('common','generate','en','Generate');
INSERT INTO `lng_data` VALUES ('common','glo','en','Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_a','en','a Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_add','en','Add Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_added','en','Glossary added');
INSERT INTO `lng_data` VALUES ('common','glo_create','en','Create Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_delete','en','Delete Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','glo_join','en','Subscribe to Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_leave','en','Unsubscribe from Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_mode','en','Mode');
INSERT INTO `lng_data` VALUES ('common','glo_mode_desc','en','A virtual glossary works like a normal glossary. Additionally it contains the terms from all glossaries that are located on the same level in the repository like the virtual glossary (level) respectively from all glossaries that are located downwards in the repository from the position of the virtual glossary (subtree).');
INSERT INTO `lng_data` VALUES ('common','glo_mode_level','en','virtual (this level only)');
INSERT INTO `lng_data` VALUES ('common','glo_mode_normal','en','normal');
INSERT INTO `lng_data` VALUES ('common','glo_mode_subtree','en','virtual (entire subtree)');
INSERT INTO `lng_data` VALUES ('common','glo_new','en','New Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_read','en','Read access to Glossary');
INSERT INTO `lng_data` VALUES ('common','glo_upload_file','en','File');
INSERT INTO `lng_data` VALUES ('common','glo_visible','en','Glossary is visible');
INSERT INTO `lng_data` VALUES ('common','glo_write','en','Edit Glossary');
INSERT INTO `lng_data` VALUES ('common','global','en','Global');
INSERT INTO `lng_data` VALUES ('common','global_default','en','Global Default');
INSERT INTO `lng_data` VALUES ('common','global_fixed','en','Global Fixed');
INSERT INTO `lng_data` VALUES ('common','global_settings','en','Global settings');
INSERT INTO `lng_data` VALUES ('common','global_user','en','Global users');
INSERT INTO `lng_data` VALUES ('common','glossaries','en','Glossaries');
INSERT INTO `lng_data` VALUES ('common','glossary','en','Glossary');
INSERT INTO `lng_data` VALUES ('common','glossary_added','en','Glossary added');
INSERT INTO `lng_data` VALUES ('common','group_access_denied','en','Access Denied');
INSERT INTO `lng_data` VALUES ('common','group_any_objects','en','No subobjects available');
INSERT INTO `lng_data` VALUES ('common','group_create_chat','en','Create chat');
INSERT INTO `lng_data` VALUES ('common','group_desc','en','Group Description');
INSERT INTO `lng_data` VALUES ('common','group_details','en','Group Details');
INSERT INTO `lng_data` VALUES ('common','group_filesharing','en','Group File Sharing');
INSERT INTO `lng_data` VALUES ('common','group_import','en','Group import');
INSERT INTO `lng_data` VALUES ('common','group_import_file','en','Import file');
INSERT INTO `lng_data` VALUES ('common','group_info_reg','en','Admission procedure');
INSERT INTO `lng_data` VALUES ('common','group_members','en','Group Members');
INSERT INTO `lng_data` VALUES ('common','group_memstat','en','Member Status');
INSERT INTO `lng_data` VALUES ('common','group_memstat_admin','en','Administrator');
INSERT INTO `lng_data` VALUES ('common','group_memstat_member','en','Member');
INSERT INTO `lng_data` VALUES ('common','group_name','en','Group name');
INSERT INTO `lng_data` VALUES ('common','group_new_registrations','en','Join requests');
INSERT INTO `lng_data` VALUES ('common','group_no_registration','en','Join group');
INSERT INTO `lng_data` VALUES ('common','group_no_registration_msg','en','You can join this group directly.');
INSERT INTO `lng_data` VALUES ('common','group_not_available','en','No group available');
INSERT INTO `lng_data` VALUES ('common','group_objects','en','Group Objects');
INSERT INTO `lng_data` VALUES ('common','group_password_registration_msg','en','If you know the group password, you can join this group. Please contact a group administrator, if you don\'t know the password.');
INSERT INTO `lng_data` VALUES ('common','group_registration','en','Registration');
INSERT INTO `lng_data` VALUES ('common','group_registration_expiration_date','en','Expiration Date');
INSERT INTO `lng_data` VALUES ('common','group_registration_expiration_time','en','Expiration Time');
INSERT INTO `lng_data` VALUES ('common','group_registration_expired','en','The time period for joining this group has expired');
INSERT INTO `lng_data` VALUES ('common','group_registration_expired_msg','en','The time period for joining this group has expired. Please contact a group administrator, if you want to join this group.');
INSERT INTO `lng_data` VALUES ('common','group_registration_mode','en','Registration procedure');
INSERT INTO `lng_data` VALUES ('common','group_registration_time','en','Registration period');
INSERT INTO `lng_data` VALUES ('common','group_req_direct','en','Join directly');
INSERT INTO `lng_data` VALUES ('common','group_req_password','en','Join with group password');
INSERT INTO `lng_data` VALUES ('common','group_req_registration','en','Request membership');
INSERT INTO `lng_data` VALUES ('common','group_req_registration_msg','en','You can request membership for this group. You will receive a message when a group administrator has accepted or declined your request.');
INSERT INTO `lng_data` VALUES ('common','group_reset','en','Reset Group Permissions');
INSERT INTO `lng_data` VALUES ('common','group_status','en','Group is');
INSERT INTO `lng_data` VALUES ('common','group_status_closed','en','Closed');
INSERT INTO `lng_data` VALUES ('common','group_status_desc','en','Determines the initial status of the group by using the permission settings from the role templates \'il_grp_status_closed\' or \'il_grp_status_open\'<br />Public: Group is visible; User may subscribe.<br />Closed: Group is not visible for non-members; User has to be invited by a member to join.');
INSERT INTO `lng_data` VALUES ('common','group_status_public','en','Public');
INSERT INTO `lng_data` VALUES ('common','groupings','en','Membership Limitations');
INSERT INTO `lng_data` VALUES ('common','groupings_assigned_obj_crs','en','Assigned Courses');
INSERT INTO `lng_data` VALUES ('common','groupings_assigned_obj_grp','en','Assigned Groups');
INSERT INTO `lng_data` VALUES ('common','groups','en','Groups');
INSERT INTO `lng_data` VALUES ('common','groups_overview','en','Groups Overview');
INSERT INTO `lng_data` VALUES ('common','grp','en','Group');
INSERT INTO `lng_data` VALUES ('common','grp_a','en','a Group');
INSERT INTO `lng_data` VALUES ('common','grp_add','en','Add Group');
INSERT INTO `lng_data` VALUES ('common','grp_add_member','en','Add Member(s)');
INSERT INTO `lng_data` VALUES ('common','grp_added','en','Group added');
INSERT INTO `lng_data` VALUES ('common','grp_already_applied','en','You have already applied to this group! Please wait for confirmation');
INSERT INTO `lng_data` VALUES ('common','grp_app_send_mail','en','Send applicant a message');
INSERT INTO `lng_data` VALUES ('common','grp_back','en','Back');
INSERT INTO `lng_data` VALUES ('common','grp_count_members','en','Number of members');
INSERT INTO `lng_data` VALUES ('common','grp_create','en','Create Group');
INSERT INTO `lng_data` VALUES ('common','grp_create_alm','en','Create AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','grp_create_chat','en','Create Chat');
INSERT INTO `lng_data` VALUES ('common','grp_create_dbk','en','Create Digilib Book');
INSERT INTO `lng_data` VALUES ('common','grp_create_exc','en','Create Exercise');
INSERT INTO `lng_data` VALUES ('common','grp_create_file','en','Upload File');
INSERT INTO `lng_data` VALUES ('common','grp_create_fold','en','Create Folder');
INSERT INTO `lng_data` VALUES ('common','grp_create_frm','en','Create Forum');
INSERT INTO `lng_data` VALUES ('common','grp_create_glo','en','Create Glossary');
INSERT INTO `lng_data` VALUES ('common','grp_create_grp','en','Create Group');
INSERT INTO `lng_data` VALUES ('common','grp_create_hlm','en','Create HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','grp_create_htlm','en','Create HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','grp_create_icrs','en','Create LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','grp_create_lm','en','Create ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','grp_create_mep','en','Create Media Pool');
INSERT INTO `lng_data` VALUES ('common','grp_create_qpl','en','Create Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','grp_create_sahs','en','Create SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','grp_create_spl','en','Create Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','grp_create_svy','en','Create Survey');
INSERT INTO `lng_data` VALUES ('common','grp_create_tst','en','Create Test');
INSERT INTO `lng_data` VALUES ('common','grp_create_webr','en','Create Web Resource');
INSERT INTO `lng_data` VALUES ('common','grp_delete','en','Delete Group');
INSERT INTO `lng_data` VALUES ('common','grp_deleted_export_files','en','Deleted selected files.');
INSERT INTO `lng_data` VALUES ('common','grp_dismiss_member','en','Are you sure you want to dismiss the following member(s) from the group?');
INSERT INTO `lng_data` VALUES ('common','grp_dismiss_myself','en','Are you sure you want to leave the group?');
INSERT INTO `lng_data` VALUES ('common','grp_edit','en','Edit Group');
INSERT INTO `lng_data` VALUES ('common','grp_edit_learning_progress','en','Edit Learning Progress');
INSERT INTO `lng_data` VALUES ('common','grp_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','grp_err_administrator_required','en','Member could not be removed, at least one administrator per group is required !');
INSERT INTO `lng_data` VALUES ('common','grp_err_at_least_one_groupadministrator_is_needed','en','Each group needs at least one group administrator');
INSERT INTO `lng_data` VALUES ('common','grp_err_error','en','An error occurred');
INSERT INTO `lng_data` VALUES ('common','grp_err_last_member','en','Last member could not be removed, please delete group instead.');
INSERT INTO `lng_data` VALUES ('common','grp_err_member_could_not_be_removed','en','Member could not be removed. Please verify all dependencies of this user.');
INSERT INTO `lng_data` VALUES ('common','grp_err_no_permission','en','You do not possess the permissions for this operation.');
INSERT INTO `lng_data` VALUES ('common','grp_err_registration_data','en','Please enter a password, the expiration date and time for a valid joining period !');
INSERT INTO `lng_data` VALUES ('common','grp_header_edit_members','en','Edit members');
INSERT INTO `lng_data` VALUES ('common','grp_join','en','User may join Group');
INSERT INTO `lng_data` VALUES ('common','grp_leave','en','User may leave Group');
INSERT INTO `lng_data` VALUES ('common','grp_list_users','en','List users');
INSERT INTO `lng_data` VALUES ('common','grp_mail_body_new_subscription','en','You have been subscribed to this group.');
INSERT INTO `lng_data` VALUES ('common','grp_mail_body_subscription_cancelled','en','Your membership has been cancelled.');
INSERT INTO `lng_data` VALUES ('common','grp_mail_subj_new_subscription','en','New subscription');
INSERT INTO `lng_data` VALUES ('common','grp_mail_subj_subscription_cancelled','en','Subscription cancelled');
INSERT INTO `lng_data` VALUES ('common','grp_mem_change_status','en','Change member status');
INSERT INTO `lng_data` VALUES ('common','grp_mem_leave','en','Dismiss member from group');
INSERT INTO `lng_data` VALUES ('common','grp_mem_send_mail','en','Send member a message');
INSERT INTO `lng_data` VALUES ('common','grp_members_gallery','en','Group Members Gallery');
INSERT INTO `lng_data` VALUES ('common','grp_msg_applicants_assigned','en','Applicant(s) assigned as group member(s)');
INSERT INTO `lng_data` VALUES ('common','grp_msg_applicants_removed','en','Applicant(s) removed from list.');
INSERT INTO `lng_data` VALUES ('common','grp_msg_member_assigned','en','User(s) assigned as group member(s)');
INSERT INTO `lng_data` VALUES ('common','grp_msg_membership_annulled','en','You left the group');
INSERT INTO `lng_data` VALUES ('common','grp_name_exists','en','There is already a group with this name! Please choose another name.');
INSERT INTO `lng_data` VALUES ('common','grp_new','en','New Group');
INSERT INTO `lng_data` VALUES ('common','grp_new_search','en','New search');
INSERT INTO `lng_data` VALUES ('common','grp_no_groups_selected','en','Please select a group');
INSERT INTO `lng_data` VALUES ('common','grp_no_results_found','en','No results found');
INSERT INTO `lng_data` VALUES ('common','grp_no_roles_selected','en','Please select a role');
INSERT INTO `lng_data` VALUES ('common','grp_options','en','Options');
INSERT INTO `lng_data` VALUES ('common','grp_read','en','Read access to Group');
INSERT INTO `lng_data` VALUES ('common','grp_register','en','Join');
INSERT INTO `lng_data` VALUES ('common','grp_registration','en','Join group');
INSERT INTO `lng_data` VALUES ('common','grp_registration_completed','en','You have joined the group');
INSERT INTO `lng_data` VALUES ('common','grp_search_enter_search_string','en','Please enter a search string');
INSERT INTO `lng_data` VALUES ('common','grp_search_members','en','User search');
INSERT INTO `lng_data` VALUES ('common','grp_select_one_file','en','Please select one file.');
INSERT INTO `lng_data` VALUES ('common','grp_select_one_file_only','en','Please select exactly one file.');
INSERT INTO `lng_data` VALUES ('common','grp_visible','en','Group is visible');
INSERT INTO `lng_data` VALUES ('common','grp_write','en','Edit Group');
INSERT INTO `lng_data` VALUES ('common','guest','en','Guest');
INSERT INTO `lng_data` VALUES ('common','guests','en','Guests');
INSERT INTO `lng_data` VALUES ('common','header_searchable','en','Searchable');
INSERT INTO `lng_data` VALUES ('common','header_title','en','Header Title');
INSERT INTO `lng_data` VALUES ('common','help','en','Help');
INSERT INTO `lng_data` VALUES ('common','hide','en','hide');
INSERT INTO `lng_data` VALUES ('common','hide_details','en','Hide Details');
INSERT INTO `lng_data` VALUES ('common','hide_private_notes','en','Hide private notes');
INSERT INTO `lng_data` VALUES ('common','hide_public_notes','en','Hide public notes');
INSERT INTO `lng_data` VALUES ('common','hide_structure','en','Disable Structured-View');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_delete_pg','en','Page \"%1\" [%2] has been deleted.');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_delete_st','en','Chapter \"%1\" [%2] has been deleted.');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_create','en','Page created.');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_cut','en','Page cut out of chapter \"%1\" [%2].');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_paste','en','Page pasted into chapter \"%1\" [%2].');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_update','en','Page changed.');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_st_cut_page','en','Page \"%1\" [%2] cut out of chapter.');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_st_paste_page','en','Page \"%1\" [%2] pasted into chapter.');
INSERT INTO `lng_data` VALUES ('common','hist_file_create','en','File created, file name is \"%1\". ');
INSERT INTO `lng_data` VALUES ('common','hist_file_replace','en','File replaced, new file name is \"%1\", new version is %2. ');
INSERT INTO `lng_data` VALUES ('common','hist_lm_delete_pg','en','Page \"%1\" [%2] has been deleted.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_delete_st','en','Chapter \"%1\" [%2] has been deleted.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_create','en','Page created.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_cut','en','Page cut out of chapter \"%1\" [%2].');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_paste','en','Page pasted into chapter \"%1\" [%2].');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_update','en','Page changed.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_create','en','Chapter created.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_cut_page','en','Page \"%1\" [%2] cut out of chapter.');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_paste_page','en','Page \"%1\" [%2] pasted into chapter.');
INSERT INTO `lng_data` VALUES ('common','hist_no_entries','en','No entries in history.');
INSERT INTO `lng_data` VALUES ('common','hist_webr_add','en','Added new Web Resource with title: \"%1\"');
INSERT INTO `lng_data` VALUES ('common','hist_webr_delete','en','Deleted Web Resource. Title: \"%1\"');
INSERT INTO `lng_data` VALUES ('common','hist_webr_update','en','Update Web Resource. Title: \"%1\"');
INSERT INTO `lng_data` VALUES ('common','history','en','History');
INSERT INTO `lng_data` VALUES ('common','hits_per_page','en','Hits/Page');
INSERT INTO `lng_data` VALUES ('common','hlm','en','Learning Module HACP');
INSERT INTO `lng_data` VALUES ('common','hlm_added','en','HACP Learning Module added');
INSERT INTO `lng_data` VALUES ('common','hlm_create','en','Create HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hlm_delete','en','Delete HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hlm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','hlm_join','en','Subscribe to HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hlm_leave','en','Unsubscribe from HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hlm_read','en','Read access to HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hlm_visible','en','HACP Learning Module is visible');
INSERT INTO `lng_data` VALUES ('common','hlm_write','en','Edit HACP Learning Module');
INSERT INTO `lng_data` VALUES ('common','hobby','en','Interests/Hobbies');
INSERT INTO `lng_data` VALUES ('common','home','en','Public Area');
INSERT INTO `lng_data` VALUES ('common','host','en','Host');
INSERT INTO `lng_data` VALUES ('common','hour','en','Hour');
INSERT INTO `lng_data` VALUES ('common','hours','en','Hour(s)');
INSERT INTO `lng_data` VALUES ('common','hours_of_day','en','Hours of day');
INSERT INTO `lng_data` VALUES ('common','htlm','en','Learning Module HTML');
INSERT INTO `lng_data` VALUES ('common','htlm_add','en','Add HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','htlm_delete','en','Delete HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','htlm_edit','en','Edit HTML Learning Module Properties');
INSERT INTO `lng_data` VALUES ('common','htlm_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','htlm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','htlm_new','en','New HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','htlm_read','en','Read HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','htlm_visible','en','HTML Learning Module is visible');
INSERT INTO `lng_data` VALUES ('common','htlm_write','en','Edit HTML Learning Module');
INSERT INTO `lng_data` VALUES ('common','http','en','HTTP');
INSERT INTO `lng_data` VALUES ('common','http_not_possible','en','This server is not supporting http requests.');
INSERT INTO `lng_data` VALUES ('common','http_path','en','Http Path');
INSERT INTO `lng_data` VALUES ('common','https_not_possible','en','This server is not supporting HTTPS connnections.');
INSERT INTO `lng_data` VALUES ('common','i2passwd','en','ILIAS 2 password');
INSERT INTO `lng_data` VALUES ('common','icla','en','LearnLinc Classroom');
INSERT INTO `lng_data` VALUES ('common','icla_add','en','Add LearnLinc Classroom');
INSERT INTO `lng_data` VALUES ('common','icla_deleted','en','LearnLinc classroom(s) deleted');
INSERT INTO `lng_data` VALUES ('common','icla_edit','en','Edit LearnLinc Classroom');
INSERT INTO `lng_data` VALUES ('common','icla_new','en','New LearnLinc Classroom');
INSERT INTO `lng_data` VALUES ('common','icon_settings','en','Icon Settings');
INSERT INTO `lng_data` VALUES ('common','icons_in_header','en','Header row');
INSERT INTO `lng_data` VALUES ('common','icons_in_item_rows','en','Item rows');
INSERT INTO `lng_data` VALUES ('common','icons_in_typed_lists','en','Icon position in item lists');
INSERT INTO `lng_data` VALUES ('common','icons_in_typed_lists_info','en','Determines where to display icons in item lists that are ordered by type within the repository and on the personal desktop.');
INSERT INTO `lng_data` VALUES ('common','icrs','en','LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_add','en','Add LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_added','en','LearnLinc Seminar added');
INSERT INTO `lng_data` VALUES ('common','icrs_create_icla','en','Create LearnLinc Classrooms');
INSERT INTO `lng_data` VALUES ('common','icrs_delete','en','Delete LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_edit','en','Edit LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_edit_permission','en','Edit permission settings');
INSERT INTO `lng_data` VALUES ('common','icrs_join','en','User may join LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_leave','en','User may leave LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_members_gallery','en','Seminar members gallery');
INSERT INTO `lng_data` VALUES ('common','icrs_new','en','New LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_read','en','Read access to LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','icrs_visible','en','LearnLinc Seminar is visible');
INSERT INTO `lng_data` VALUES ('common','icrs_write','en','Edit LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','id','en','ID');
INSERT INTO `lng_data` VALUES ('common','identifier','en','identifier');
INSERT INTO `lng_data` VALUES ('common','if_no_title_then_filename','en','Leave blank to display the file name');
INSERT INTO `lng_data` VALUES ('common','if_no_title_then_url','en','Leave blank to display the URL');
INSERT INTO `lng_data` VALUES ('common','ignore_on_conflict','en','Ignore on conflict');
INSERT INTO `lng_data` VALUES ('common','il_chat_moderator','en','Chat moderator');
INSERT INTO `lng_data` VALUES ('common','il_crs_admin','en','Course administrator');
INSERT INTO `lng_data` VALUES ('common','il_crs_member','en','Course member');
INSERT INTO `lng_data` VALUES ('common','il_crs_tutor','en','Course tutor');
INSERT INTO `lng_data` VALUES ('common','il_frm_moderator','en','Forum moderator');
INSERT INTO `lng_data` VALUES ('common','il_grp_admin','en','Group administrator');
INSERT INTO `lng_data` VALUES ('common','il_grp_member','en','Group member');
INSERT INTO `lng_data` VALUES ('common','il_icrs_admin','en','LearnLinc Seminar administrator');
INSERT INTO `lng_data` VALUES ('common','il_icrs_member','en','LearnLinc Seminar member');
INSERT INTO `lng_data` VALUES ('common','ilias_version','en','ILIAS version');
INSERT INTO `lng_data` VALUES ('common','ilinc_add_user','en','Add user(s)');
INSERT INTO `lng_data` VALUES ('common','ilinc_akclassvalue','en','Cost center');
INSERT INTO `lng_data` VALUES ('common','ilinc_akclassvalues','en','Cost centers');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_always_open','en','Classroom is always open');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_closed','en','Classroom is closed');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_open','en','Classroom is open');
INSERT INTO `lng_data` VALUES ('common','ilinc_classrooms','en','LearnLinc Classrooms');
INSERT INTO `lng_data` VALUES ('common','ilinc_coursemember_status','en','Attending as');
INSERT INTO `lng_data` VALUES ('common','ilinc_courses','en','LearnLinc Seminars');
INSERT INTO `lng_data` VALUES ('common','ilinc_dismiss_member','en','Are you sure you want to dismiss the following user(s) from the LearnLinc Seminar?');
INSERT INTO `lng_data` VALUES ('common','ilinc_dismiss_myself','en','Are you sure you want to dismiss yourself from the LearnLinc Seminar?');
INSERT INTO `lng_data` VALUES ('common','ilinc_docent','en','Instructor');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_administrator_required','en','Member could not be removed, at least one administrator per LearnLinc Seminar is required !');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_at_least_one_groupadministrator_is_neede','en','Each LearnLinc Seminar needs at least one administrator');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_last_member','en','Last member could not be removed, please delete LearnLinc Seminar instead.');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_member_could_not_be_removed','en','User could not be removed. Please verify all dependencies of that user.');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_no_permission','en','You do not possess the permissions for this operation.');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_registration_data','en','Please enter a password, the expiration date and time for a valid registration period !');
INSERT INTO `lng_data` VALUES ('common','ilinc_header_edit_users','en','Edit list of involved users');
INSERT INTO `lng_data` VALUES ('common','ilinc_id','en','iLinc ID');
INSERT INTO `lng_data` VALUES ('common','ilinc_involved_users','en','Involved Users');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_body_new_subscription','en','You have been subscribed to this LearnLinc Seminar.');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_body_subscription_cancelled','en','Your membership has been cancelled.');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_subj_new_subscription','en','New subscription');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_subj_subscription_cancelled','en','Subscription cancelled');
INSERT INTO `lng_data` VALUES ('common','ilinc_manage_course_documents','en','Materials');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_change_status','en','Change user\'s status');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_leave','en','Dismiss user from LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_send_mail','en','Send user a message');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_joined','en','You joined the LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_member_assigned','en','User(s) assigned');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_membership_annulled','en','Subscription cancelled');
INSERT INTO `lng_data` VALUES ('common','ilinc_no_akclassvalues','en','none');
INSERT INTO `lng_data` VALUES ('common','ilinc_no_docent_assigned','en','Not assigned');
INSERT INTO `lng_data` VALUES ('common','ilinc_notset','en','Not set');
INSERT INTO `lng_data` VALUES ('common','ilinc_remark','en','Remark');
INSERT INTO `lng_data` VALUES ('common','ilinc_server_not_active','en','iLinc Server not activated');
INSERT INTO `lng_data` VALUES ('common','ilinc_student','en','Participant');
INSERT INTO `lng_data` VALUES ('common','ilinc_upload_pic_linktext','en','Upload');
INSERT INTO `lng_data` VALUES ('common','ilinc_upload_pic_text','en','To display your picture in LearnLinc Seminars please use this link:');
INSERT INTO `lng_data` VALUES ('common','image','en','Image');
INSERT INTO `lng_data` VALUES ('common','image_gen_unsucc','en','Image generation unsuccessful. Contact your system administrator and verify the convert path.');
INSERT INTO `lng_data` VALUES ('common','import','en','Import');
INSERT INTO `lng_data` VALUES ('common','import_alm','en','Import AICC Package');
INSERT INTO `lng_data` VALUES ('common','import_cat_localrol','en','Create local role for every new category');
INSERT INTO `lng_data` VALUES ('common','import_cat_table','en','The following table is only meaningful if the checkbox is set');
INSERT INTO `lng_data` VALUES ('common','import_categories','en','Import Categories');
INSERT INTO `lng_data` VALUES ('common','import_dbk','en','Import Digilib Book');
INSERT INTO `lng_data` VALUES ('common','import_failure_log','en','Import failure log');
INSERT INTO `lng_data` VALUES ('common','import_file','en','Import File');
INSERT INTO `lng_data` VALUES ('common','import_file_not_valid','en','The import file is not valid.');
INSERT INTO `lng_data` VALUES ('common','import_finished','en','Number of imported messages.');
INSERT INTO `lng_data` VALUES ('common','import_forum_finished','en','The forum has been imported.');
INSERT INTO `lng_data` VALUES ('common','import_glossary','en','Import Glossary');
INSERT INTO `lng_data` VALUES ('common','import_grp','en','Import group');
INSERT INTO `lng_data` VALUES ('common','import_grp_finished','en','Imported group without any error');
INSERT INTO `lng_data` VALUES ('common','import_hlm','en','Import HACP Package');
INSERT INTO `lng_data` VALUES ('common','import_lm','en','Import ILIAS Learning module');
INSERT INTO `lng_data` VALUES ('common','import_qpl','en','Import Question pool Test');
INSERT INTO `lng_data` VALUES ('common','import_questions_into_qpl','en','Import question(s) into question pool');
INSERT INTO `lng_data` VALUES ('common','import_root_user','en','Import Root User');
INSERT INTO `lng_data` VALUES ('common','import_sahs','en','Import SCORM/AICC Package');
INSERT INTO `lng_data` VALUES ('common','import_spl','en','Import Question pool Survey');
INSERT INTO `lng_data` VALUES ('common','import_svy','en','Import Survey');
INSERT INTO `lng_data` VALUES ('common','import_tst','en','Import Test');
INSERT INTO `lng_data` VALUES ('common','import_users','en','Import Users');
INSERT INTO `lng_data` VALUES ('common','import_warning_log','en','Import warning log');
INSERT INTO `lng_data` VALUES ('common','important','en','Important');
INSERT INTO `lng_data` VALUES ('common','imported','en','imported');
INSERT INTO `lng_data` VALUES ('common','in','en','in');
INSERT INTO `lng_data` VALUES ('common','in_use','en','User Language');
INSERT INTO `lng_data` VALUES ('common','inactive','en','Inactive');
INSERT INTO `lng_data` VALUES ('common','inbox','en','Inbox');
INSERT INTO `lng_data` VALUES ('common','include_local','en','include local');
INSERT INTO `lng_data` VALUES ('common','info','en','Information');
INSERT INTO `lng_data` VALUES ('common','info_access_and_status_info','en','Access- and Statusinformation');
INSERT INTO `lng_data` VALUES ('common','info_access_permissions','en','Access permissions');
INSERT INTO `lng_data` VALUES ('common','info_assign_sure','en','Are you sure you want to assign the following user(s)?');
INSERT INTO `lng_data` VALUES ('common','info_assigned','en','assigned');
INSERT INTO `lng_data` VALUES ('common','info_available_roles','en','Available roles');
INSERT INTO `lng_data` VALUES ('common','info_change_user_view','en','Change User');
INSERT INTO `lng_data` VALUES ('common','info_delete_sure','en','Are you sure that you want to delete the following item(s)?');
INSERT INTO `lng_data` VALUES ('common','info_delete_warning_no_trash','en','(WARNING: Selected Objects will be removed irreversibly from System and may not be recovered anymore!)');
INSERT INTO `lng_data` VALUES ('common','info_deleted','en','Object(s) Deleted');
INSERT INTO `lng_data` VALUES ('common','info_enter_login_or_id','en','<i>(Enter login name or user ID)</i>');
INSERT INTO `lng_data` VALUES ('common','info_err_user_not_exist','en','User with that login name or user_id does not exists');
INSERT INTO `lng_data` VALUES ('common','info_from_role','en','Granted by Role / Ownership');
INSERT INTO `lng_data` VALUES ('common','info_is_member','en','User is member');
INSERT INTO `lng_data` VALUES ('common','info_is_not_member','en','User is not a member');
INSERT INTO `lng_data` VALUES ('common','info_not_assigned','en','not assigned');
INSERT INTO `lng_data` VALUES ('common','info_owner_of_object','en','Owner of object');
INSERT INTO `lng_data` VALUES ('common','info_permission_origin','en','Original Position');
INSERT INTO `lng_data` VALUES ('common','info_permission_source','en','Effective From*');
INSERT INTO `lng_data` VALUES ('common','info_remark_interrupted','en','Role is interrupted at this position. The role\'s default permission settings in effect are located in that position.');
INSERT INTO `lng_data` VALUES ('common','info_short','en','Info');
INSERT INTO `lng_data` VALUES ('common','info_status_info','en','Permissions of User');
INSERT INTO `lng_data` VALUES ('common','info_trash','en','Deleted Objects');
INSERT INTO `lng_data` VALUES ('common','info_view_of_user','en','User');
INSERT INTO `lng_data` VALUES ('common','inform_user_mail','en','Send email to inform user about changes');
INSERT INTO `lng_data` VALUES ('common','information_abbr','en','Info');
INSERT INTO `lng_data` VALUES ('common','ingmedia_all_offers','en','All LE');
INSERT INTO `lng_data` VALUES ('common','ingmedia_back_to_le','en','Back to LE');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_afternoon','en','Good afternoon');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_evening','en','Good evening');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_morning','en','Good morning');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_night','en','Good night');
INSERT INTO `lng_data` VALUES ('common','ingmedia_hello','en','Hello');
INSERT INTO `lng_data` VALUES ('common','ingmedia_info_about_work1','en','On');
INSERT INTO `lng_data` VALUES ('common','ingmedia_info_about_work2','en',', you worked here for the last time. You can continue there by clicking here:');
INSERT INTO `lng_data` VALUES ('common','ingmedia_level_zero','en','Level up');
INSERT INTO `lng_data` VALUES ('common','ingmedia_pers_dates','en','Personal data');
INSERT INTO `lng_data` VALUES ('common','ingmedia_reg_fo','en','Registered forums');
INSERT INTO `lng_data` VALUES ('common','ingmedia_reg_le','en','Registered LE');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info1','en','Here you can change your personal data. Except for the INGMEDIA username and password, you do not have to fill out other fields. Remember that lost passwords can only be returned by email (!).');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info2','en','It is not allowed to use special characters (like , ; . = - * + #) in your INGMEDIA username and password. To be allowed to use the INGMEDIA platform, you must accept the user agreement.');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info3','en','Please select one of the links in the side bar.');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_title','en','Change user data.');
INSERT INTO `lng_data` VALUES ('common','ingmedia_user_agree','en','Agreement');
INSERT INTO `lng_data` VALUES ('common','ingmedia_vis_le','en','Visited LE');
INSERT INTO `lng_data` VALUES ('common','ingmedia_visited_le','en','All LE you have visited so far.');
INSERT INTO `lng_data` VALUES ('common','ingmedia_welcome','en',', welcome to your personal desktop!!');
INSERT INTO `lng_data` VALUES ('common','inifile','en','Ini-File');
INSERT INTO `lng_data` VALUES ('common','input_error','en','Input error');
INSERT INTO `lng_data` VALUES ('common','insert','en','Insert');
INSERT INTO `lng_data` VALUES ('common','insert_object_here','en','Insert object here');
INSERT INTO `lng_data` VALUES ('common','inst_id','en','Installation ID');
INSERT INTO `lng_data` VALUES ('common','inst_info','en','Installation Info');
INSERT INTO `lng_data` VALUES ('common','inst_name','en','Installation Name');
INSERT INTO `lng_data` VALUES ('common','install','en','Install');
INSERT INTO `lng_data` VALUES ('common','install_local','en','Install With Local');
INSERT INTO `lng_data` VALUES ('common','installed','en','Installed');
INSERT INTO `lng_data` VALUES ('common','installed_local','en','Installed With Local');
INSERT INTO `lng_data` VALUES ('common','institution','en','Institution');
INSERT INTO `lng_data` VALUES ('common','internal_local_roles_only','en','Local roles (only autogenerated)');
INSERT INTO `lng_data` VALUES ('common','internal_system','en','Internal system');
INSERT INTO `lng_data` VALUES ('common','ip_address','en','IP Address');
INSERT INTO `lng_data` VALUES ('common','is_already_your','en','is already your');
INSERT INTO `lng_data` VALUES ('common','item','en','Item');
INSERT INTO `lng_data` VALUES ('common','java_server','en','Java-Server');
INSERT INTO `lng_data` VALUES ('common','java_server_host','en','Host');
INSERT INTO `lng_data` VALUES ('common','java_server_info','en','If activated, it is possible to search in PDF, HTML files and HTML-Learning modules');
INSERT INTO `lng_data` VALUES ('common','java_server_no_connection','en','Attention: Cannot connect to Java server.');
INSERT INTO `lng_data` VALUES ('common','java_server_port','en','Port');
INSERT INTO `lng_data` VALUES ('common','java_server_readme','en','Setup informations');
INSERT INTO `lng_data` VALUES ('common','join','en','Join');
INSERT INTO `lng_data` VALUES ('common','kb','en','KByte');
INSERT INTO `lng_data` VALUES ('common','keywords','en','Keywords');
INSERT INTO `lng_data` VALUES ('common','lang_cs','en','Czech');
INSERT INTO `lng_data` VALUES ('common','lang_da','en','Danish');
INSERT INTO `lng_data` VALUES ('common','lang_dateformat','en','Y-m-d');
INSERT INTO `lng_data` VALUES ('common','lang_de','en','German');
INSERT INTO `lng_data` VALUES ('common','lang_el','en','Greek');
INSERT INTO `lng_data` VALUES ('common','lang_en','en','English');
INSERT INTO `lng_data` VALUES ('common','lang_es','en','Spanish');
INSERT INTO `lng_data` VALUES ('common','lang_fi','en','Finnish');
INSERT INTO `lng_data` VALUES ('common','lang_fr','en','French');
INSERT INTO `lng_data` VALUES ('common','lang_ge','en','Georgian');
INSERT INTO `lng_data` VALUES ('common','lang_hu','en','Hungarian');
INSERT INTO `lng_data` VALUES ('common','lang_id','en','Indonesian');
INSERT INTO `lng_data` VALUES ('common','lang_it','en','Italian');
INSERT INTO `lng_data` VALUES ('common','lang_ja','en','Japanese');
INSERT INTO `lng_data` VALUES ('common','lang_lt','en','Lithuanian');
INSERT INTO `lng_data` VALUES ('common','lang_nl','en','Dutch');
INSERT INTO `lng_data` VALUES ('common','lang_no','en','Norwegian');
INSERT INTO `lng_data` VALUES ('common','lang_path','en','Language Path');
INSERT INTO `lng_data` VALUES ('common','lang_pl','en','Polish');
INSERT INTO `lng_data` VALUES ('common','lang_pt','en','Portuguese');
INSERT INTO `lng_data` VALUES ('common','lang_ro','en','Romanian');
INSERT INTO `lng_data` VALUES ('common','lang_sep_decimal','en','.');
INSERT INTO `lng_data` VALUES ('common','lang_sep_thousand','en',',');
INSERT INTO `lng_data` VALUES ('common','lang_sq','en','Albanian');
INSERT INTO `lng_data` VALUES ('common','lang_sr','en','Serbian');
INSERT INTO `lng_data` VALUES ('common','lang_sv','en','Swedish');
INSERT INTO `lng_data` VALUES ('common','lang_timeformat','en','H:i:s');
INSERT INTO `lng_data` VALUES ('common','lang_timeformat_no_sec','en','H:i');
INSERT INTO `lng_data` VALUES ('common','lang_uk','en','Ukrainian');
INSERT INTO `lng_data` VALUES ('common','lang_version','en','1');
INSERT INTO `lng_data` VALUES ('common','lang_vi','en','Vietnamese');
INSERT INTO `lng_data` VALUES ('common','lang_xx','en','Custom');
INSERT INTO `lng_data` VALUES ('common','lang_zh','en','Simplified Chinese');
INSERT INTO `lng_data` VALUES ('common','langfile_found','en','Language file found');
INSERT INTO `lng_data` VALUES ('common','language','en','Language');
INSERT INTO `lng_data` VALUES ('common','language_not_installed','en','is not installed. Please install that language first');
INSERT INTO `lng_data` VALUES ('common','languages','en','Languages');
INSERT INTO `lng_data` VALUES ('common','languages_already_installed','en','Selected language(s) are already installed');
INSERT INTO `lng_data` VALUES ('common','languages_already_uninstalled','en','Selected language(s) are already uninstalled');
INSERT INTO `lng_data` VALUES ('common','languages_updated','en','All installed languages have been updated');
INSERT INTO `lng_data` VALUES ('common','last_access','en','Last access');
INSERT INTO `lng_data` VALUES ('common','last_change','en','Last Change');
INSERT INTO `lng_data` VALUES ('common','last_edited_on','en','Last edited on');
INSERT INTO `lng_data` VALUES ('common','last_login','en','Last login');
INSERT INTO `lng_data` VALUES ('common','last_update','en','Last Update');
INSERT INTO `lng_data` VALUES ('common','last_visit','en','Last Visit');
INSERT INTO `lng_data` VALUES ('common','lastname','en','Last name');
INSERT INTO `lng_data` VALUES ('common','launch','en','Launch');
INSERT INTO `lng_data` VALUES ('common','ldap','en','LDAP');
INSERT INTO `lng_data` VALUES ('common','ldap_basedn','en','LDAP BaseDN');
INSERT INTO `lng_data` VALUES ('common','ldap_configure','en','Configure LDAP Authentication');
INSERT INTO `lng_data` VALUES ('common','ldap_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','ldap_login_key','en','Attribute for login name');
INSERT INTO `lng_data` VALUES ('common','ldap_objectclass','en','ObjectClass of user accounts');
INSERT INTO `lng_data` VALUES ('common','ldap_passwd','en','Your current password');
INSERT INTO `lng_data` VALUES ('common','ldap_port','en','LDAP Port');
INSERT INTO `lng_data` VALUES ('common','ldap_read','en','Read access to LDAP settings');
INSERT INTO `lng_data` VALUES ('common','ldap_search_base','en','LDAP Search base');
INSERT INTO `lng_data` VALUES ('common','ldap_server','en','LDAP Server URL');
INSERT INTO `lng_data` VALUES ('common','ldap_tls','en','Use LDAP TLS');
INSERT INTO `lng_data` VALUES ('common','ldap_v2','en','LDAPv2');
INSERT INTO `lng_data` VALUES ('common','ldap_v3','en','LDAPv3');
INSERT INTO `lng_data` VALUES ('common','ldap_version','en','LDAP protokoll version');
INSERT INTO `lng_data` VALUES ('common','ldap_visible','en','LDAP settings are visible');
INSERT INTO `lng_data` VALUES ('common','ldap_write','en','Edit LDAP settings');
INSERT INTO `lng_data` VALUES ('common','learning module','en','Learning Module');
INSERT INTO `lng_data` VALUES ('common','learning_objects','en','Learning Objects');
INSERT INTO `lng_data` VALUES ('common','learning_progress','en','Learning Progress');
INSERT INTO `lng_data` VALUES ('common','learning_resourc','en','Learning Resource');
INSERT INTO `lng_data` VALUES ('common','learning_resource','en','Learning Resource');
INSERT INTO `lng_data` VALUES ('common','learning_resources','en','Learning Resources');
INSERT INTO `lng_data` VALUES ('common','level','en','Level');
INSERT INTO `lng_data` VALUES ('common','link','en','Link');
INSERT INTO `lng_data` VALUES ('common','link_check','en','Link check');
INSERT INTO `lng_data` VALUES ('common','link_check_body_top','en','You receive this mail because you want to be informed about invalid links of the following learning modules:');
INSERT INTO `lng_data` VALUES ('common','link_check_message_b','en','If enabled, you will be informed about invalid links by email.');
INSERT INTO `lng_data` VALUES ('common','link_check_message_disabled','en','Messages diabled');
INSERT INTO `lng_data` VALUES ('common','link_check_message_enabled','en','Messages enabled');
INSERT INTO `lng_data` VALUES ('common','link_check_subject','en','[ILIAS 3] Link check');
INSERT INTO `lng_data` VALUES ('common','link_checker_refreshed','en','Refreshed view');
INSERT INTO `lng_data` VALUES ('common','link_dynamic_info','en','You can add dynamic parameters like the ILIAS user id.');
INSERT INTO `lng_data` VALUES ('common','link_selected_items','en','Link selected items');
INSERT INTO `lng_data` VALUES ('common','linked_object','en','The object has been linked');
INSERT INTO `lng_data` VALUES ('common','linked_pages','en','Linked Pages');
INSERT INTO `lng_data` VALUES ('common','links_add_param','en','Add parameter:');
INSERT INTO `lng_data` VALUES ('common','links_dyn_parameter','en','Dynamic parameters');
INSERT INTO `lng_data` VALUES ('common','links_dynamic','en','Dynamic Web Links parameters');
INSERT INTO `lng_data` VALUES ('common','links_dynamic_info','en','If enabled, it is possible to append dynamic parameters to Web Links. E.g. the ILIAS user id or the username.');
INSERT INTO `lng_data` VALUES ('common','links_existing_params','en','Existing parameters:');
INSERT INTO `lng_data` VALUES ('common','links_name','en','Parameter name');
INSERT INTO `lng_data` VALUES ('common','links_no_name_given','en','Please choose a parameter name.');
INSERT INTO `lng_data` VALUES ('common','links_no_value_given','en','Please choose a parameter value.');
INSERT INTO `lng_data` VALUES ('common','links_not_available','en','Not available');
INSERT INTO `lng_data` VALUES ('common','links_parameter_deleted','en','Parameter deleted.');
INSERT INTO `lng_data` VALUES ('common','links_select_one','en','- Select one -');
INSERT INTO `lng_data` VALUES ('common','links_session_id','en','ILIAS session id');
INSERT INTO `lng_data` VALUES ('common','links_user_id','en','ILIAS user id');
INSERT INTO `lng_data` VALUES ('common','links_user_name','en','ILIAS username');
INSERT INTO `lng_data` VALUES ('common','links_value','en','Parameter value');
INSERT INTO `lng_data` VALUES ('common','list_of_pages','en','Pages List');
INSERT INTO `lng_data` VALUES ('common','list_of_questions','en','Question List');
INSERT INTO `lng_data` VALUES ('common','literature','en','Literature');
INSERT INTO `lng_data` VALUES ('common','literature_bookmarks','en','Literature Bookmarks');
INSERT INTO `lng_data` VALUES ('common','lm','en','Learning Module ILIAS');
INSERT INTO `lng_data` VALUES ('common','lm_a','en','an ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_add','en','Add ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_added','en','ILIAS Learning Module added');
INSERT INTO `lng_data` VALUES ('common','lm_create','en','Create ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_delete','en','Delete ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','lm_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','lm_join','en','Subscribe to ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_leave','en','Unsubscribe from ILIASLearning Module');
INSERT INTO `lng_data` VALUES ('common','lm_new','en','New ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_read','en','Read access to ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lm_type_aicc','en','AICC');
INSERT INTO `lng_data` VALUES ('common','lm_type_hacp','en','HACP');
INSERT INTO `lng_data` VALUES ('common','lm_type_scorm','en','SCORM');
INSERT INTO `lng_data` VALUES ('common','lm_visible','en','ILIAS Learning Module is visible');
INSERT INTO `lng_data` VALUES ('common','lm_write','en','Edit ILIAS Learning Module');
INSERT INTO `lng_data` VALUES ('common','lng','en','Language');
INSERT INTO `lng_data` VALUES ('common','lngf','en','Languages');
INSERT INTO `lng_data` VALUES ('common','lngf_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','lngf_read','en','Read access to Language settings');
INSERT INTO `lng_data` VALUES ('common','lngf_visible','en','Language settings are visible');
INSERT INTO `lng_data` VALUES ('common','lo','en','Learning Object');
INSERT INTO `lng_data` VALUES ('common','lo_available','en','Overview Learning Modules & Courses');
INSERT INTO `lng_data` VALUES ('common','lo_categories','en','LO Categories');
INSERT INTO `lng_data` VALUES ('common','lo_edit','en','Edit Learning Object');
INSERT INTO `lng_data` VALUES ('common','lo_new','en','New Learning Object');
INSERT INTO `lng_data` VALUES ('common','lo_no_content','en','No Learning Resources Available');
INSERT INTO `lng_data` VALUES ('common','lo_other_langs','en','LOs in Other Languages');
INSERT INTO `lng_data` VALUES ('common','lo_overview','en','LO Overview');
INSERT INTO `lng_data` VALUES ('common','local','en','Local');
INSERT INTO `lng_data` VALUES ('common','local_language_file','en','local language file');
INSERT INTO `lng_data` VALUES ('common','local_language_files','en','local language files');
INSERT INTO `lng_data` VALUES ('common','local_languages_already_installed','en','Selected local language file(s) are already installed');
INSERT INTO `lng_data` VALUES ('common','locator','en','Location:');
INSERT INTO `lng_data` VALUES ('common','log_in','en','Login');
INSERT INTO `lng_data` VALUES ('common','logic_and','en','and');
INSERT INTO `lng_data` VALUES ('common','logic_or','en','or');
INSERT INTO `lng_data` VALUES ('common','login','en','Login');
INSERT INTO `lng_data` VALUES ('common','login_as','en','Logged in as');
INSERT INTO `lng_data` VALUES ('common','login_data','en','Login data');
INSERT INTO `lng_data` VALUES ('common','login_exists','en','There is already a user with this login name! Please choose another one.');
INSERT INTO `lng_data` VALUES ('common','login_invalid','en','The chosen login is invalid! Only the following characters are allowed (minimum 4 characters): A-Z a-z 0-9 _.-+*@!$%~');
INSERT INTO `lng_data` VALUES ('common','login_time','en','Time online');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias','en','Login to ILIAS');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias_via_cas','en','Login to ILIAS via Central Authentication Service');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias_via_shibboleth','en','Login to ILIAS via');
INSERT INTO `lng_data` VALUES ('common','logout','en','Logout');
INSERT INTO `lng_data` VALUES ('common','logout_text','en','You logged off from ILIAS. Your session has been closed.');
INSERT INTO `lng_data` VALUES ('common','logs','en','Log data');
INSERT INTO `lng_data` VALUES ('common','los','en','Learning Objects');
INSERT INTO `lng_data` VALUES ('common','los_last_visited','en','Last Visited Learning Objects');
INSERT INTO `lng_data` VALUES ('common','lres','en','Learning Resources');
INSERT INTO `lng_data` VALUES ('common','mail','en','Mail');
INSERT INTO `lng_data` VALUES ('common','mail_a_root','en','Mailbox');
INSERT INTO `lng_data` VALUES ('common','mail_addressbook','en','Address book');
INSERT INTO `lng_data` VALUES ('common','mail_allow_smtp','en','Allow SMTP');
INSERT INTO `lng_data` VALUES ('common','mail_b_inbox','en','Inbox');
INSERT INTO `lng_data` VALUES ('common','mail_c_trash','en','Trash');
INSERT INTO `lng_data` VALUES ('common','mail_d_drafts','en','Drafts');
INSERT INTO `lng_data` VALUES ('common','mail_delete_error','en','Error while deleting');
INSERT INTO `lng_data` VALUES ('common','mail_delete_error_file','en','Error deleting file');
INSERT INTO `lng_data` VALUES ('common','mail_e_sent','en','Sent');
INSERT INTO `lng_data` VALUES ('common','mail_edit_permission','en','Change Permission Settings');
INSERT INTO `lng_data` VALUES ('common','mail_feedback','en','Mail Feedback');
INSERT INTO `lng_data` VALUES ('common','mail_folders','en','Mail Folders');
INSERT INTO `lng_data` VALUES ('common','mail_import','en','Import');
INSERT INTO `lng_data` VALUES ('common','mail_import_file','en','Export file');
INSERT INTO `lng_data` VALUES ('common','mail_intern_enable','en','Enable');
INSERT INTO `lng_data` VALUES ('common','mail_mail_visible','en','User may use mail system');
INSERT INTO `lng_data` VALUES ('common','mail_mails_of','en','Mail');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_attach','en','Max. attachment size');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_box','en','Max. mailbox size');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_mail','en','Max. mail size');
INSERT INTO `lng_data` VALUES ('common','mail_maxtime_attach','en','Max. days to keep attachments');
INSERT INTO `lng_data` VALUES ('common','mail_maxtime_mail','en','Max. days to keep mail');
INSERT INTO `lng_data` VALUES ('common','mail_members','en','Mail to Members');
INSERT INTO `lng_data` VALUES ('common','mail_not_sent','en','Mail not sent!');
INSERT INTO `lng_data` VALUES ('common','mail_read','en','Read access to Mail settings');
INSERT INTO `lng_data` VALUES ('common','mail_search_no','en','No entries found.');
INSERT INTO `lng_data` VALUES ('common','mail_search_word','en','Search word');
INSERT INTO `lng_data` VALUES ('common','mail_select_one','en','You must select one mail');
INSERT INTO `lng_data` VALUES ('common','mail_send_error','en','Error sending mail');
INSERT INTO `lng_data` VALUES ('common','mail_sent','en','Mail sent!');
INSERT INTO `lng_data` VALUES ('common','mail_smtp_mail','en','User may send mail via SMTP');
INSERT INTO `lng_data` VALUES ('common','mail_system','en','System Message');
INSERT INTO `lng_data` VALUES ('common','mail_system_message','en','User may send internal system messages');
INSERT INTO `lng_data` VALUES ('common','mail_visible','en','Mail settings are visible');
INSERT INTO `lng_data` VALUES ('common','mail_write','en','Edit Mail settings');
INSERT INTO `lng_data` VALUES ('common','mail_z_local','en','User Folders');
INSERT INTO `lng_data` VALUES ('common','mails','en','Mail');
INSERT INTO `lng_data` VALUES ('common','main_menu_frame','en','Top Level Menu');
INSERT INTO `lng_data` VALUES ('common','manage_tracking_data','en','Manage Tracking Data');
INSERT INTO `lng_data` VALUES ('common','mark_all_read','en','Mark All as Read');
INSERT INTO `lng_data` VALUES ('common','mark_all_unread','en','Mark All as Unread');
INSERT INTO `lng_data` VALUES ('common','matriculation','en','Matriculation number');
INSERT INTO `lng_data` VALUES ('common','max_number_rec','en','Maximum number of records');
INSERT INTO `lng_data` VALUES ('common','max_time','en','Maximum time');
INSERT INTO `lng_data` VALUES ('common','member','en','Member');
INSERT INTO `lng_data` VALUES ('common','member_status','en','Member Status');
INSERT INTO `lng_data` VALUES ('common','members','en','Members');
INSERT INTO `lng_data` VALUES ('common','membership_annulled','en','Your membership has been cancelled');
INSERT INTO `lng_data` VALUES ('common','mep','en','Media Pool');
INSERT INTO `lng_data` VALUES ('common','mep_add','en','Add Media Pool');
INSERT INTO `lng_data` VALUES ('common','mep_added','en','Added Media Pool');
INSERT INTO `lng_data` VALUES ('common','mep_delete','en','Delete Media Pool');
INSERT INTO `lng_data` VALUES ('common','mep_edit','en','Edit Media Pool Properties');
INSERT INTO `lng_data` VALUES ('common','mep_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','mep_new','en','New Media Pool');
INSERT INTO `lng_data` VALUES ('common','mep_not_insert_already_exist','en','The following items have not been inserted because they are already in the media pool:');
INSERT INTO `lng_data` VALUES ('common','mep_read','en','Read Media Pool Content');
INSERT INTO `lng_data` VALUES ('common','mep_visible','en','Media Pool is visible');
INSERT INTO `lng_data` VALUES ('common','mep_write','en','Edit Media Pool Content');
INSERT INTO `lng_data` VALUES ('common','message','en','Message');
INSERT INTO `lng_data` VALUES ('common','message_content','en','Message Content');
INSERT INTO `lng_data` VALUES ('common','message_no_delivered_files','en','You do not have submitted any files.');
INSERT INTO `lng_data` VALUES ('common','message_to','en','Message to:');
INSERT INTO `lng_data` VALUES ('common','meta_data','en','Metadata');
INSERT INTO `lng_data` VALUES ('common','migrate','en','Migrate');
INSERT INTO `lng_data` VALUES ('common','min_time','en','Minimum time');
INSERT INTO `lng_data` VALUES ('common','minute','en','Minute');
INSERT INTO `lng_data` VALUES ('common','minutes','en','Minutes');
INSERT INTO `lng_data` VALUES ('common','missing','en','Missing');
INSERT INTO `lng_data` VALUES ('common','mob','en','Media Object');
INSERT INTO `lng_data` VALUES ('common','module','en','module');
INSERT INTO `lng_data` VALUES ('common','modules','en','Modules');
INSERT INTO `lng_data` VALUES ('common','month','en','Month');
INSERT INTO `lng_data` VALUES ('common','month_01_long','en','January');
INSERT INTO `lng_data` VALUES ('common','month_01_short','en','Jan');
INSERT INTO `lng_data` VALUES ('common','month_02_long','en','February');
INSERT INTO `lng_data` VALUES ('common','month_02_short','en','Feb');
INSERT INTO `lng_data` VALUES ('common','month_03_long','en','March');
INSERT INTO `lng_data` VALUES ('common','month_03_short','en','Mar');
INSERT INTO `lng_data` VALUES ('common','month_04_long','en','April');
INSERT INTO `lng_data` VALUES ('common','month_04_short','en','Apr');
INSERT INTO `lng_data` VALUES ('common','month_05_long','en','May');
INSERT INTO `lng_data` VALUES ('common','month_05_short','en','May');
INSERT INTO `lng_data` VALUES ('common','month_06_long','en','June');
INSERT INTO `lng_data` VALUES ('common','month_06_short','en','Jun');
INSERT INTO `lng_data` VALUES ('common','month_07_long','en','July');
INSERT INTO `lng_data` VALUES ('common','month_07_short','en','Jul');
INSERT INTO `lng_data` VALUES ('common','month_08_long','en','August');
INSERT INTO `lng_data` VALUES ('common','month_08_short','en','Aug');
INSERT INTO `lng_data` VALUES ('common','month_09_long','en','September');
INSERT INTO `lng_data` VALUES ('common','month_09_short','en','Sep');
INSERT INTO `lng_data` VALUES ('common','month_10_long','en','October');
INSERT INTO `lng_data` VALUES ('common','month_10_short','en','Oct');
INSERT INTO `lng_data` VALUES ('common','month_11_long','en','November');
INSERT INTO `lng_data` VALUES ('common','month_11_short','en','Nov');
INSERT INTO `lng_data` VALUES ('common','month_12_long','en','December');
INSERT INTO `lng_data` VALUES ('common','month_12_short','en','Dec');
INSERT INTO `lng_data` VALUES ('common','monthly','en','monthly');
INSERT INTO `lng_data` VALUES ('common','months','en','Months');
INSERT INTO `lng_data` VALUES ('common','move','en','Move');
INSERT INTO `lng_data` VALUES ('common','moveChapter','en','Move');
INSERT INTO `lng_data` VALUES ('common','movePage','en','Move');
INSERT INTO `lng_data` VALUES ('common','move_selected_items','en','Move selected items');
INSERT INTO `lng_data` VALUES ('common','move_to','en','Move to');
INSERT INTO `lng_data` VALUES ('common','move_users_to_style','en','Move Users to Style');
INSERT INTO `lng_data` VALUES ('common','msg_cancel','en','Action cancelled');
INSERT INTO `lng_data` VALUES ('common','msg_changes_ok','en','The changes were OK');
INSERT INTO `lng_data` VALUES ('common','msg_clear_clipboard','en','Clipboard cleared');
INSERT INTO `lng_data` VALUES ('common','msg_cloned','en','Selected object(s) copied');
INSERT INTO `lng_data` VALUES ('common','msg_copy_clipboard','en','Selected object(s) stored in clipboard (Action: copy)');
INSERT INTO `lng_data` VALUES ('common','msg_cut_clipboard','en','Selected object(s) stored in clipboard (Action: cut)');
INSERT INTO `lng_data` VALUES ('common','msg_cut_copied','en','Selected object(s) moved.');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_role','en','Role deleted');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_roles','en','Roles deleted');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_roles_rolts','en','Roles & Role Templates deleted');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_rolt','en','Role Template deleted');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_rolts','en','Role Template deleted');
INSERT INTO `lng_data` VALUES ('common','msg_error_copy','en','Copy Error');
INSERT INTO `lng_data` VALUES ('common','msg_failed','en','Sorry, action failed');
INSERT INTO `lng_data` VALUES ('common','msg_invalid_filetype','en','Invalid file type');
INSERT INTO `lng_data` VALUES ('common','msg_is_last_role','en','You removed the last global role from the following users');
INSERT INTO `lng_data` VALUES ('common','msg_last_role_for_registration','en','At least one role must be available in the registration form for new users. This role is currently the only one available.');
INSERT INTO `lng_data` VALUES ('common','msg_link_clipboard','en','Selected object(s) stored in clipboard (Action: link)');
INSERT INTO `lng_data` VALUES ('common','msg_linked','en','Selected object(s) linked.');
INSERT INTO `lng_data` VALUES ('common','msg_may_not_contain','en','This object may not contain objects of type:');
INSERT INTO `lng_data` VALUES ('common','msg_min_one_active_role','en','Each user must have at least one active global role!');
INSERT INTO `lng_data` VALUES ('common','msg_min_one_role','en','Each user must have at least one global role!');
INSERT INTO `lng_data` VALUES ('common','msg_multi_language_selected','en','You selected the same language for different translations!');
INSERT INTO `lng_data` VALUES ('common','msg_no_default_language','en','No default language specified! You must define one translation as default translation.');
INSERT INTO `lng_data` VALUES ('common','msg_no_delete_yourself','en','You cannot delete your own user account.');
INSERT INTO `lng_data` VALUES ('common','msg_no_file','en','You didn\'t choose a file');
INSERT INTO `lng_data` VALUES ('common','msg_no_language_selected','en','No translation language specified! You must define a language for each translation');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_assign_role_to_user','en','You have no permission to change user\'s role assignment');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_assign_user_to_role','en','You have no permission to change the user assignment');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_copy','en','You have no permission to create a copy of the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create','en','You have no permission to create the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_object1','en','You have no permission to create');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_object2','en','at this location!');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_role','en','You have no permission to add roles');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_rolf','en','You have no permission to create a Role Folder. Therefore you may not stop inheritance of roles or add local roles here.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_rolt','en','You have no permission to add role templates');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_user','en','You have no permission to add users');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_cut','en','You have no permission to cut the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_delete','en','You have no permission to delete the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_delete_track','en','You have no permission to delete tracking data.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_link','en','You have no permission to create a link from the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_role','en','You have no permission to modify roles');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_rolt','en','You have no permission to modify role templates');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_user','en','You have no permission to modify user data');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_paste','en','You have no permission to paste the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_perm','en','You have no permission to edit permission settings');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read','en','You have no permission to access this item.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_item','en','You have no permission to access item \'%s\'.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_lm','en','You have no permission to read this learning module.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_track','en','You have no permission to access the user tracking.');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_undelete','en','You have no permission to undelete the following object(s):');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_write','en','You have no permission to write');
INSERT INTO `lng_data` VALUES ('common','msg_no_rolf_allowed1','en','The object');
INSERT INTO `lng_data` VALUES ('common','msg_no_rolf_allowed2','en','is not allowed to contain a Role Folder');
INSERT INTO `lng_data` VALUES ('common','msg_no_scan_log','en','Scan log not implemented yet');
INSERT INTO `lng_data` VALUES ('common','msg_no_search_result','en','No entries found');
INSERT INTO `lng_data` VALUES ('common','msg_no_search_string','en','Please enter your query');
INSERT INTO `lng_data` VALUES ('common','msg_no_sysadmin_sysrole_not_assignable','en','Only a System Administrator may assign users to the System Administrator Role');
INSERT INTO `lng_data` VALUES ('common','msg_no_title','en','Please enter a title.');
INSERT INTO `lng_data` VALUES ('common','msg_no_type_accessible','en','Sorry. You do not have the permissions to access any [type] of this list.');
INSERT INTO `lng_data` VALUES ('common','msg_no_type_available','en','Sorry. There is no [type] available at the moment.');
INSERT INTO `lng_data` VALUES ('common','msg_no_url','en','You didn\'t enter a URL');
INSERT INTO `lng_data` VALUES ('common','msg_not_available_for_anon','en','The page you have chosen is only accessible for registered users');
INSERT INTO `lng_data` VALUES ('common','msg_not_in_itself','en','It\'s not possible to paste the object in itself');
INSERT INTO `lng_data` VALUES ('common','msg_nothing_found','en','msg_nothing_found');
INSERT INTO `lng_data` VALUES ('common','msg_obj_created','en','Object created.');
INSERT INTO `lng_data` VALUES ('common','msg_obj_exists','en','This object already exists in this folder');
INSERT INTO `lng_data` VALUES ('common','msg_obj_modified','en','Modifications saved.');
INSERT INTO `lng_data` VALUES ('common','msg_obj_no_link','en','are not allowed to be linked');
INSERT INTO `lng_data` VALUES ('common','msg_obj_not_deletable_sold','en','Payment is activated for the following objects. They can no be deleted.');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from1','en','Permission settings adopted from');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from2','en','(Settings have been saved!)');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from_itself','en','You cannot adopt permission settings from the current role/role template itself.');
INSERT INTO `lng_data` VALUES ('common','msg_removed','en','Object(s) removed from system.');
INSERT INTO `lng_data` VALUES ('common','msg_role_exists1','en','A role/role template with the name');
INSERT INTO `lng_data` VALUES ('common','msg_role_exists2','en','already exists! Please choose another name');
INSERT INTO `lng_data` VALUES ('common','msg_role_reserved_prefix','en','The prefix \'il_\' is reserved for automatically generated roles. Please choose another name');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_active_changed','en','Active role assignment changed');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_active_changed_comment','en','This setting is not saved to the user\'s profile! If the user logs in again, all active role assignments reset to their saved values.');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_changed','en','Role assignment changed');
INSERT INTO `lng_data` VALUES ('common','msg_sysrole_not_deletable','en','The system role cannot be deleted');
INSERT INTO `lng_data` VALUES ('common','msg_sysrole_not_editable','en','The permission settings of the system role may not be changed. The system role grants all assigned users unlimited access to all objects & functions.');
INSERT INTO `lng_data` VALUES ('common','msg_trash_empty','en','There are no deleted objects');
INSERT INTO `lng_data` VALUES ('common','msg_undeleted','en','Object(s) undeleted.');
INSERT INTO `lng_data` VALUES ('common','msg_user_last_role1','en','The following users are assigned to this role only:');
INSERT INTO `lng_data` VALUES ('common','msg_user_last_role2','en','Please delete the users or assign them to another role in order to delete this role.');
INSERT INTO `lng_data` VALUES ('common','msg_userassignment_changed','en','User assignment changed');
INSERT INTO `lng_data` VALUES ('common','multimedia','en','Multimedia');
INSERT INTO `lng_data` VALUES ('common','my_bms','en','My Bookmarks');
INSERT INTO `lng_data` VALUES ('common','my_frms','en','My Forums');
INSERT INTO `lng_data` VALUES ('common','my_grps','en','My Groups');
INSERT INTO `lng_data` VALUES ('common','my_los','en','My Learning Objects');
INSERT INTO `lng_data` VALUES ('common','my_tsts','en','My Tests');
INSERT INTO `lng_data` VALUES ('common','name','en','Name');
INSERT INTO `lng_data` VALUES ('common','never','en','never');
INSERT INTO `lng_data` VALUES ('common','new','en','New');
INSERT INTO `lng_data` VALUES ('common','new_appointment','en','New Appointment');
INSERT INTO `lng_data` VALUES ('common','new_folder','en','New Folder');
INSERT INTO `lng_data` VALUES ('common','new_group','en','New Group');
INSERT INTO `lng_data` VALUES ('common','new_language','en','New Language');
INSERT INTO `lng_data` VALUES ('common','new_list_password','en','New suggestions');
INSERT INTO `lng_data` VALUES ('common','new_lowercase','en','new');
INSERT INTO `lng_data` VALUES ('common','new_mail','en','New mail!');
INSERT INTO `lng_data` VALUES ('common','news','en','News');
INSERT INTO `lng_data` VALUES ('common','next','en','next');
INSERT INTO `lng_data` VALUES ('common','nickname','en','Nickname');
INSERT INTO `lng_data` VALUES ('common','no','en','No');
INSERT INTO `lng_data` VALUES ('common','no_access_item','en','You have no permission to access this item.');
INSERT INTO `lng_data` VALUES ('common','no_access_item_public','en','This item cannot be accessed in the public area.');
INSERT INTO `lng_data` VALUES ('common','no_access_link_object','en','You are not allowed to link this object');
INSERT INTO `lng_data` VALUES ('common','no_bm_in_personal_list','en','No bookmarks defined.');
INSERT INTO `lng_data` VALUES ('common','no_chat_in_personal_list','en','No chats in personal list');
INSERT INTO `lng_data` VALUES ('common','no_checkbox','en','No checkbox checked!');
INSERT INTO `lng_data` VALUES ('common','no_condition_selected','en','Please select one precondition.');
INSERT INTO `lng_data` VALUES ('common','no_conditions_found','en','No preconditions created.');
INSERT INTO `lng_data` VALUES ('common','no_datasets','en','The table is empty');
INSERT INTO `lng_data` VALUES ('common','no_date','en','No date');
INSERT INTO `lng_data` VALUES ('common','no_description','en','No description');
INSERT INTO `lng_data` VALUES ('common','no_frm_in_personal_list','en','No forums in personal list.');
INSERT INTO `lng_data` VALUES ('common','no_global_role_left','en','Every user has to be assigned to one role.');
INSERT INTO `lng_data` VALUES ('common','no_grp_in_personal_list','en','No groups in personal list.');
INSERT INTO `lng_data` VALUES ('common','no_import_available','en','Import not available for type');
INSERT INTO `lng_data` VALUES ('common','no_import_file_found','en','No import file found');
INSERT INTO `lng_data` VALUES ('common','no_invalid_links','en','No invalid links found.');
INSERT INTO `lng_data` VALUES ('common','no_limit','en','No limit');
INSERT INTO `lng_data` VALUES ('common','no_lo_in_personal_list','en','No learning objects in personal list.');
INSERT INTO `lng_data` VALUES ('common','no_local_users','en','There are no local user');
INSERT INTO `lng_data` VALUES ('common','no_objects','en','No objects');
INSERT INTO `lng_data` VALUES ('common','no_parent_access','en','No access to a superordinated object!');
INSERT INTO `lng_data` VALUES ('common','no_permission','en','You do not have the necessary permission.');
INSERT INTO `lng_data` VALUES ('common','no_permission_to_join','en','You are not allowed to join this group!');
INSERT INTO `lng_data` VALUES ('common','no_roles_user_can_be_assigned_to','en','There are no global roles the user can be assigned to. Therefore you are not allowed to add users.');
INSERT INTO `lng_data` VALUES ('common','no_submission_made','en','---');
INSERT INTO `lng_data` VALUES ('common','no_title','en','No Title');
INSERT INTO `lng_data` VALUES ('common','no_tst_in_personal_list','en','No tests in personal list.');
INSERT INTO `lng_data` VALUES ('common','no_user_defined_fields_defined','en','No user-defined fields available.');
INSERT INTO `lng_data` VALUES ('common','no_users_applied','en','Please select a user.');
INSERT INTO `lng_data` VALUES ('common','no_users_selected','en','Please select one user.');
INSERT INTO `lng_data` VALUES ('common','no_xml_file_found_in_zip','en','XML file within zip file not found:');
INSERT INTO `lng_data` VALUES ('common','no_zip_file','en','No zip file found.');
INSERT INTO `lng_data` VALUES ('common','non_internal_local_roles_only','en','Local roles (only userdefined)');
INSERT INTO `lng_data` VALUES ('common','none','en','None');
INSERT INTO `lng_data` VALUES ('common','normal','en','Normal');
INSERT INTO `lng_data` VALUES ('common','not_accessed','en','Not accessed');
INSERT INTO `lng_data` VALUES ('common','not_accessed_yet','en','Not accessed yet');
INSERT INTO `lng_data` VALUES ('common','not_available','en','Not Available');
INSERT INTO `lng_data` VALUES ('common','not_implemented_yet','en','Not implemented yet');
INSERT INTO `lng_data` VALUES ('common','not_installed','en','Not Installed');
INSERT INTO `lng_data` VALUES ('common','not_logged_in','en','You are not logged in');
INSERT INTO `lng_data` VALUES ('common','note','en','Note');
INSERT INTO `lng_data` VALUES ('common','note_all_pub_notes','en','All notes');
INSERT INTO `lng_data` VALUES ('common','note_my_pub_notes','en','My notes only');
INSERT INTO `lng_data` VALUES ('common','notes','en','Notes');
INSERT INTO `lng_data` VALUES ('common','num_users','en','Number of Users');
INSERT INTO `lng_data` VALUES ('common','number_of_accesses','en','Number of accesses');
INSERT INTO `lng_data` VALUES ('common','number_of_records','en','Number of records');
INSERT INTO `lng_data` VALUES ('common','obj','en','Object');
INSERT INTO `lng_data` VALUES ('common','obj_adm','en','Administration');
INSERT INTO `lng_data` VALUES ('common','obj_adm_desc','en','Main system settings folder containing all panels to administrate your ILIAS installation.');
INSERT INTO `lng_data` VALUES ('common','obj_adve','en','Advanced Editing');
INSERT INTO `lng_data` VALUES ('common','obj_adve_desc','en','Administration settings for advanced editing like JavaScript based Rich Text Editors, LaTeX support etc..');
INSERT INTO `lng_data` VALUES ('common','obj_alm','en','Learning Module AICC');
INSERT INTO `lng_data` VALUES ('common','obj_assf','en','Test and Assessment');
INSERT INTO `lng_data` VALUES ('common','obj_assf_desc','en','Test&Assessment log settings.');
INSERT INTO `lng_data` VALUES ('common','obj_auth','en','Authentication and Registration');
INSERT INTO `lng_data` VALUES ('common','obj_auth_desc','en','Configure your authentication mode (local, LDAP, ...) and new account registration settings here.');
INSERT INTO `lng_data` VALUES ('common','obj_cat','en','Category');
INSERT INTO `lng_data` VALUES ('common','obj_cen','en','Centra Event');
INSERT INTO `lng_data` VALUES ('common','obj_chac','en','Chat Settings');
INSERT INTO `lng_data` VALUES ('common','obj_chac_desc','en','Configure your chat server here. Enable/disable chats.');
INSERT INTO `lng_data` VALUES ('common','obj_chat','en','Chat');
INSERT INTO `lng_data` VALUES ('common','obj_crs','en','Course');
INSERT INTO `lng_data` VALUES ('common','obj_dbk','en','Digilib Book');
INSERT INTO `lng_data` VALUES ('common','obj_exc','en','Exercise');
INSERT INTO `lng_data` VALUES ('common','obj_extt','en','Third Party Software');
INSERT INTO `lng_data` VALUES ('common','obj_extt_desc','en','Configure external software or services that are supported by ILIAS');
INSERT INTO `lng_data` VALUES ('common','obj_file','en','File');
INSERT INTO `lng_data` VALUES ('common','obj_fold','en','Folder');
INSERT INTO `lng_data` VALUES ('common','obj_frm','en','Forum');
INSERT INTO `lng_data` VALUES ('common','obj_glo','en','Glossary');
INSERT INTO `lng_data` VALUES ('common','obj_grp','en','Group');
INSERT INTO `lng_data` VALUES ('common','obj_hlm','en','Learning Module HACP');
INSERT INTO `lng_data` VALUES ('common','obj_htlm','en','Learning Module HTML');
INSERT INTO `lng_data` VALUES ('common','obj_icla','en','LearnLinc Classroom');
INSERT INTO `lng_data` VALUES ('common','obj_icrs','en','LearnLinc Seminar');
INSERT INTO `lng_data` VALUES ('common','obj_ldap','en','LDAP Settings');
INSERT INTO `lng_data` VALUES ('common','obj_ldap_desc','en','Configure global LDAP Settings here.');
INSERT INTO `lng_data` VALUES ('common','obj_lm','en','Learning Module ILIAS');
INSERT INTO `lng_data` VALUES ('common','obj_lng','en','Language');
INSERT INTO `lng_data` VALUES ('common','obj_lngf','en','Languages');
INSERT INTO `lng_data` VALUES ('common','obj_lngf_desc','en','Manage your system languages here.');
INSERT INTO `lng_data` VALUES ('common','obj_lo','en','LearningObject');
INSERT INTO `lng_data` VALUES ('common','obj_mail','en','Mail Settings');
INSERT INTO `lng_data` VALUES ('common','obj_mail_desc','en','Configure global mail settings here.');
INSERT INTO `lng_data` VALUES ('common','obj_mep','en','Media Pool');
INSERT INTO `lng_data` VALUES ('common','obj_mob','en','Media Object');
INSERT INTO `lng_data` VALUES ('common','obj_not_found','en','Object Not Found');
INSERT INTO `lng_data` VALUES ('common','obj_note','en','Note');
INSERT INTO `lng_data` VALUES ('common','obj_notf','en','Note Administration');
INSERT INTO `lng_data` VALUES ('common','obj_objf','en','Object Definitions');
INSERT INTO `lng_data` VALUES ('common','obj_objf_desc','en','Manage ILIAS object types and object permissions. (only for experts!)');
INSERT INTO `lng_data` VALUES ('common','obj_owner','en','This Object is owned by');
INSERT INTO `lng_data` VALUES ('common','obj_pays','en','Payment Settings');
INSERT INTO `lng_data` VALUES ('common','obj_pays_desc','en','Configure payment settings and vendors');
INSERT INTO `lng_data` VALUES ('common','obj_pg','en','Page');
INSERT INTO `lng_data` VALUES ('common','obj_qpl','en','Question Pool Test');
INSERT INTO `lng_data` VALUES ('common','obj_recf','en','Restored Objects');
INSERT INTO `lng_data` VALUES ('common','obj_recf_desc','en','Contains restored Objects from System Check.');
INSERT INTO `lng_data` VALUES ('common','obj_role','en','Role');
INSERT INTO `lng_data` VALUES ('common','obj_rolf','en','Roles');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_desc','en','Manage your roles here.');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_local','en','Local Roles');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_local_desc','en','Contains local roles of object no.');
INSERT INTO `lng_data` VALUES ('common','obj_rolt','en','Role Template');
INSERT INTO `lng_data` VALUES ('common','obj_root','en','ILIAS root node');
INSERT INTO `lng_data` VALUES ('common','obj_sahs','en','Learning Module SCORM/AICC');
INSERT INTO `lng_data` VALUES ('common','obj_seas','en','Search');
INSERT INTO `lng_data` VALUES ('common','obj_seas_desc','en','Manage the search settings here.');
INSERT INTO `lng_data` VALUES ('common','obj_spl','en','Question Pool Survey');
INSERT INTO `lng_data` VALUES ('common','obj_st','en','Chapter');
INSERT INTO `lng_data` VALUES ('common','obj_stys','en','Style and Layout');
INSERT INTO `lng_data` VALUES ('common','obj_stys_desc','en','Manage system skin and style settings here');
INSERT INTO `lng_data` VALUES ('common','obj_svy','en','Survey');
INSERT INTO `lng_data` VALUES ('common','obj_tax','en','Taxonomy');
INSERT INTO `lng_data` VALUES ('common','obj_taxf','en','Taxonomies');
INSERT INTO `lng_data` VALUES ('common','obj_taxf_desc','en','Folder for taxonomies');
INSERT INTO `lng_data` VALUES ('common','obj_trac','en','Tracking and Learning Progress');
INSERT INTO `lng_data` VALUES ('common','obj_trac_desc','en','User access tracking data');
INSERT INTO `lng_data` VALUES ('common','obj_tst','en','Test');
INSERT INTO `lng_data` VALUES ('common','obj_typ','en','Object Type Definition');
INSERT INTO `lng_data` VALUES ('common','obj_type','en','Object Type');
INSERT INTO `lng_data` VALUES ('common','obj_url','en','URL');
INSERT INTO `lng_data` VALUES ('common','obj_uset','en','User Settings');
INSERT INTO `lng_data` VALUES ('common','obj_usr','en','User');
INSERT INTO `lng_data` VALUES ('common','obj_usrf','en','User Accounts');
INSERT INTO `lng_data` VALUES ('common','obj_usrf_desc','en','Manage user accounts here.');
INSERT INTO `lng_data` VALUES ('common','obj_webr','en','Web Resource');
INSERT INTO `lng_data` VALUES ('common','object','en','Object');
INSERT INTO `lng_data` VALUES ('common','object_added','en','Object added');
INSERT INTO `lng_data` VALUES ('common','object_duplicated','en','Object duplicated');
INSERT INTO `lng_data` VALUES ('common','object_imported','en','Object imported');
INSERT INTO `lng_data` VALUES ('common','objects','en','Objects');
INSERT INTO `lng_data` VALUES ('common','objf','en','Object definitions');
INSERT INTO `lng_data` VALUES ('common','objf_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','objf_read','en','Read access to Object definitions');
INSERT INTO `lng_data` VALUES ('common','objf_visible','en','Object definitions are visible');
INSERT INTO `lng_data` VALUES ('common','objf_write','en','Edit Object definitions');
INSERT INTO `lng_data` VALUES ('common','objs_alm','en','AICC Learning Modules');
INSERT INTO `lng_data` VALUES ('common','objs_cat','en','Categories');
INSERT INTO `lng_data` VALUES ('common','objs_chat','en','Chats');
INSERT INTO `lng_data` VALUES ('common','objs_confirm','en','Confirm Action');
INSERT INTO `lng_data` VALUES ('common','objs_crs','en','Courses');
INSERT INTO `lng_data` VALUES ('common','objs_dbk','en','Digilib Books');
INSERT INTO `lng_data` VALUES ('common','objs_delete','en','Delete objects');
INSERT INTO `lng_data` VALUES ('common','objs_exc','en','Exercises');
INSERT INTO `lng_data` VALUES ('common','objs_file','en','Files');
INSERT INTO `lng_data` VALUES ('common','objs_fold','en','Folders');
INSERT INTO `lng_data` VALUES ('common','objs_frm','en','Forums');
INSERT INTO `lng_data` VALUES ('common','objs_glo','en','Glossaries');
INSERT INTO `lng_data` VALUES ('common','objs_grp','en','Groups');
INSERT INTO `lng_data` VALUES ('common','objs_hlm','en','HACP Learning Modules');
INSERT INTO `lng_data` VALUES ('common','objs_htlm','en','HTML Learning Modules');
INSERT INTO `lng_data` VALUES ('common','objs_icla','en','LearnLinc Classrooms');
INSERT INTO `lng_data` VALUES ('common','objs_icrs','en','LearnLinc Seminars');
INSERT INTO `lng_data` VALUES ('common','objs_lm','en','ILIAS Learning Modules');
INSERT INTO `lng_data` VALUES ('common','objs_lng','en','Languages');
INSERT INTO `lng_data` VALUES ('common','objs_lo','en','Learning Objects');
INSERT INTO `lng_data` VALUES ('common','objs_mep','en','Media Pools');
INSERT INTO `lng_data` VALUES ('common','objs_mob','en','Media Objects');
INSERT INTO `lng_data` VALUES ('common','objs_note','en','Notes');
INSERT INTO `lng_data` VALUES ('common','objs_pg','en','Pages');
INSERT INTO `lng_data` VALUES ('common','objs_qpl','en','Question Pools Test');
INSERT INTO `lng_data` VALUES ('common','objs_role','en','Roles');
INSERT INTO `lng_data` VALUES ('common','objs_rolt','en','Role Templates');
INSERT INTO `lng_data` VALUES ('common','objs_sahs','en','SCORM/AICC Learning Modules');
INSERT INTO `lng_data` VALUES ('common','objs_spl','en','Question Pools Survey');
INSERT INTO `lng_data` VALUES ('common','objs_st','en','Chapters');
INSERT INTO `lng_data` VALUES ('common','objs_svy','en','Surveys');
INSERT INTO `lng_data` VALUES ('common','objs_tst','en','Tests');
INSERT INTO `lng_data` VALUES ('common','objs_type','en','Object Types');
INSERT INTO `lng_data` VALUES ('common','objs_url','en','URLs');
INSERT INTO `lng_data` VALUES ('common','objs_usr','en','Users');
INSERT INTO `lng_data` VALUES ('common','objs_webr','en','Web Resources');
INSERT INTO `lng_data` VALUES ('common','of','en','Of');
INSERT INTO `lng_data` VALUES ('common','offline','en','offline');
INSERT INTO `lng_data` VALUES ('common','offline_version','en','Offline Version');
INSERT INTO `lng_data` VALUES ('common','ok','en','OK');
INSERT INTO `lng_data` VALUES ('common','old','en','Old');
INSERT INTO `lng_data` VALUES ('common','online','en','Online');
INSERT INTO `lng_data` VALUES ('common','online_chapter','en','Online Chapter');
INSERT INTO `lng_data` VALUES ('common','online_time','en','Time online (DD:HH:MM:SS)');
INSERT INTO `lng_data` VALUES ('common','online_version','en','Online Version');
INSERT INTO `lng_data` VALUES ('common','open_views_inside_frameset','en','Open views inside frameset');
INSERT INTO `lng_data` VALUES ('common','operation','en','Operation');
INSERT INTO `lng_data` VALUES ('common','optimize','en','Optimize');
INSERT INTO `lng_data` VALUES ('common','options','en','Options');
INSERT INTO `lng_data` VALUES ('common','options_for_subobjects','en','Options for subobjects');
INSERT INTO `lng_data` VALUES ('common','order_by','en','Order by');
INSERT INTO `lng_data` VALUES ('common','order_by_answers','en','Order by Answers');
INSERT INTO `lng_data` VALUES ('common','order_by_date','en','Order by Date');
INSERT INTO `lng_data` VALUES ('common','other','en','Other');
INSERT INTO `lng_data` VALUES ('common','overview','en','Overview');
INSERT INTO `lng_data` VALUES ('common','overwrite','en','Overwrite');
INSERT INTO `lng_data` VALUES ('common','owner','en','Owner');
INSERT INTO `lng_data` VALUES ('common','owner_updated','en','Owner updated.');
INSERT INTO `lng_data` VALUES ('common','page','en','Page');
INSERT INTO `lng_data` VALUES ('common','page_edit','en','Edit Page');
INSERT INTO `lng_data` VALUES ('common','pages','en','Pages');
INSERT INTO `lng_data` VALUES ('common','parameter','en','Parameter');
INSERT INTO `lng_data` VALUES ('common','parse','en','Parse');
INSERT INTO `lng_data` VALUES ('common','passed','en','Passed');
INSERT INTO `lng_data` VALUES ('common','passwd','en','Password');
INSERT INTO `lng_data` VALUES ('common','passwd_generation','en','Password Generation');
INSERT INTO `lng_data` VALUES ('common','passwd_generation_info','en','If enabled, passwords can only be selected from a pretended list.');
INSERT INTO `lng_data` VALUES ('common','passwd_invalid','en','The new password is invalid! Only the following characters are allowed (minimum 6 characters): A-Z a-z 0-9 _.-+?#*@!$%~');
INSERT INTO `lng_data` VALUES ('common','passwd_not_match','en','Your entries for the new password don\'t match! Please re-enter your new password. ');
INSERT INTO `lng_data` VALUES ('common','passwd_wrong','en','The password you entered is wrong!');
INSERT INTO `lng_data` VALUES ('common','password','en','Password');
INSERT INTO `lng_data` VALUES ('common','password_assistance_disabled','en','Password assistance is only then available, when user authentication is done via local ILIAS database.');
INSERT INTO `lng_data` VALUES ('common','password_assistance_info','en','If password assistance is enabled, a link with the text \"Forgot Password?\" is shown on the login page of ILIAS. Users can use this link to assign a new password to their user account, without needing assistance from a system administrator.');
INSERT INTO `lng_data` VALUES ('common','paste','en','Paste');
INSERT INTO `lng_data` VALUES ('common','pasteChapter','en','Paste');
INSERT INTO `lng_data` VALUES ('common','pastePage','en','Paste');
INSERT INTO `lng_data` VALUES ('common','paste_clipboard_items','en','Paste items from clipboard');
INSERT INTO `lng_data` VALUES ('common','path','en','Path');
INSERT INTO `lng_data` VALUES ('common','path_not_set','en','Path not set');
INSERT INTO `lng_data` VALUES ('common','path_to_babylon','en','Path to Babylon');
INSERT INTO `lng_data` VALUES ('common','path_to_convert','en','Path to Convert');
INSERT INTO `lng_data` VALUES ('common','path_to_htmldoc','en','Path to HTMLdoc');
INSERT INTO `lng_data` VALUES ('common','path_to_java','en','Path to Java');
INSERT INTO `lng_data` VALUES ('common','path_to_unzip','en','Path to Unzip');
INSERT INTO `lng_data` VALUES ('common','path_to_zip','en','Path to Zip');
INSERT INTO `lng_data` VALUES ('common','pathes','en','Paths');
INSERT INTO `lng_data` VALUES ('common','pay_methods','en','Pay methods');
INSERT INTO `lng_data` VALUES ('common','payment_buyable','en','Buyable');
INSERT INTO `lng_data` VALUES ('common','payment_in_sc','en','Already in shopping cart');
INSERT INTO `lng_data` VALUES ('common','payment_payed_access','en','Payed/Access');
INSERT INTO `lng_data` VALUES ('common','payment_system','en','Payment System');
INSERT INTO `lng_data` VALUES ('common','pays_edit','en','Edit payment settings');
INSERT INTO `lng_data` VALUES ('common','pays_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','pays_read','en','Access payment settings');
INSERT INTO `lng_data` VALUES ('common','pays_visible','en','Payment settings are visible');
INSERT INTO `lng_data` VALUES ('common','pays_write','en','Edit payment settings');
INSERT INTO `lng_data` VALUES ('common','pdf_export','en','PDF Export');
INSERT INTO `lng_data` VALUES ('common','per_object','en','Access per object');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_1','en','This form determines the permissions of role \'%s\' for newly created objects under the object \'%s\'.');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_2','en','If you want to change the permissions of role \'%s\' for all already existing objects underneath \'%s\' you must check the option \'Change Existing Objects\' at the bottom of the screen.');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_glob_1','en','This form determines the permissions of role \'%s\' for newly created objects in the repository.');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_glob_2','en','If you want to change the permissions of role \'%s\' for all existing objects in the repository you must check the option \'Change Existing Objects\' at the bottom of the screen.');
INSERT INTO `lng_data` VALUES ('common','perm_settings','en','Permissions');
INSERT INTO `lng_data` VALUES ('common','perma_link','en','Permanent Link');
INSERT INTO `lng_data` VALUES ('common','permission','en','Permission');
INSERT INTO `lng_data` VALUES ('common','permission_denied','en','Permission Denied');
INSERT INTO `lng_data` VALUES ('common','permission_settings','en','Object Permission Settings');
INSERT INTO `lng_data` VALUES ('common','permission_settings_info','en','This form determines which role is allowed to do what with the current object \'%s\'.');
INSERT INTO `lng_data` VALUES ('common','person_title','en','Title');
INSERT INTO `lng_data` VALUES ('common','personal_data','en','Personal information');
INSERT INTO `lng_data` VALUES ('common','personal_desktop','en','Personal Desktop');
INSERT INTO `lng_data` VALUES ('common','personal_picture','en','Personal Picture');
INSERT INTO `lng_data` VALUES ('common','personal_profile','en','Personal Profile');
INSERT INTO `lng_data` VALUES ('common','persons','en','Persons');
INSERT INTO `lng_data` VALUES ('common','pg_a','en','a page');
INSERT INTO `lng_data` VALUES ('common','pg_add','en','Add page');
INSERT INTO `lng_data` VALUES ('common','pg_added','en','Page added');
INSERT INTO `lng_data` VALUES ('common','pg_edit','en','Edit page');
INSERT INTO `lng_data` VALUES ('common','pg_new','en','New page');
INSERT INTO `lng_data` VALUES ('common','phone','en','Phone');
INSERT INTO `lng_data` VALUES ('common','phone_home','en','Phone, Home');
INSERT INTO `lng_data` VALUES ('common','phone_mobile','en','Phone, Mobile');
INSERT INTO `lng_data` VALUES ('common','phone_office','en','Phone, Office');
INSERT INTO `lng_data` VALUES ('common','phrase','en','Phrase');
INSERT INTO `lng_data` VALUES ('common','please_choose','en','-- Select --');
INSERT INTO `lng_data` VALUES ('common','please_enter_target','en','Please enter a target');
INSERT INTO `lng_data` VALUES ('common','please_enter_title','en','Please enter a title');
INSERT INTO `lng_data` VALUES ('common','please_select','en','-- Please Select --');
INSERT INTO `lng_data` VALUES ('common','please_select_a_delivered_file_to_delete','en','You must select at least one delivered file to delete it!');
INSERT INTO `lng_data` VALUES ('common','please_select_a_delivered_file_to_download','en','You must select at least one delivered file to download it!');
INSERT INTO `lng_data` VALUES ('common','please_wait','en','Please wait...');
INSERT INTO `lng_data` VALUES ('common','port','en','Port');
INSERT INTO `lng_data` VALUES ('common','position','en','Position');
INSERT INTO `lng_data` VALUES ('common','precondition_not_accessible','en','You do not have sufficient permission to view the precondition(s) of this item.');
INSERT INTO `lng_data` VALUES ('common','preconditions','en','Preconditions');
INSERT INTO `lng_data` VALUES ('common','predefined_template','en','Predefined role template');
INSERT INTO `lng_data` VALUES ('common','presentation_options','en','Presentation Options');
INSERT INTO `lng_data` VALUES ('common','previous','en','previous');
INSERT INTO `lng_data` VALUES ('common','print','en','Print');
INSERT INTO `lng_data` VALUES ('common','print_view','en','Print View');
INSERT INTO `lng_data` VALUES ('common','private_notes','en','Private Notes');
INSERT INTO `lng_data` VALUES ('common','pro','en','Pro');
INSERT INTO `lng_data` VALUES ('common','profile','en','Profile');
INSERT INTO `lng_data` VALUES ('common','profile_changed','en','ILIAS eLearning - Your profile has changed');
INSERT INTO `lng_data` VALUES ('common','profile_incomplete','en','Your profile is incomplete. Please fill in all required data.');
INSERT INTO `lng_data` VALUES ('common','profile_of','en','Profile of');
INSERT INTO `lng_data` VALUES ('common','properties','en','Properties');
INSERT INTO `lng_data` VALUES ('common','pub_section','en','Public Area');
INSERT INTO `lng_data` VALUES ('common','public','en','public');
INSERT INTO `lng_data` VALUES ('common','public_notes','en','Public Notes');
INSERT INTO `lng_data` VALUES ('common','public_profile','en','Public Profile');
INSERT INTO `lng_data` VALUES ('common','public_profile_not_visible','en','The User Profile is not public');
INSERT INTO `lng_data` VALUES ('common','publication','en','Publication');
INSERT INTO `lng_data` VALUES ('common','publication_date','en','Publication Date');
INSERT INTO `lng_data` VALUES ('common','published','en','Published');
INSERT INTO `lng_data` VALUES ('common','publishing_organisation','en','Publishing Organization');
INSERT INTO `lng_data` VALUES ('common','purpose','en','Purpose');
INSERT INTO `lng_data` VALUES ('common','qpl','en','Question Pool Test');
INSERT INTO `lng_data` VALUES ('common','qpl_add','en','Add question pool for test');
INSERT INTO `lng_data` VALUES ('common','qpl_delete','en','Delete Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','qpl_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','qpl_new','en','New question pool for test');
INSERT INTO `lng_data` VALUES ('common','qpl_read','en','Read access to Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','qpl_upload_file','en','Upload file');
INSERT INTO `lng_data` VALUES ('common','qpl_visible','en','Question Pool for Test is visible');
INSERT INTO `lng_data` VALUES ('common','qpl_write','en','Edit Question Pool for Test');
INSERT INTO `lng_data` VALUES ('common','quarterly','en','quarterly');
INSERT INTO `lng_data` VALUES ('common','query_data','en','Query data');
INSERT INTO `lng_data` VALUES ('common','question','en','Question');
INSERT INTO `lng_data` VALUES ('common','question_pools','en','Question pools');
INSERT INTO `lng_data` VALUES ('common','quit','en','Quit');
INSERT INTO `lng_data` VALUES ('common','quote','en','Quote');
INSERT INTO `lng_data` VALUES ('common','read','en','Read');
INSERT INTO `lng_data` VALUES ('common','recf_edit','en','Edit RecoveryFolder');
INSERT INTO `lng_data` VALUES ('common','recipient','en','Recipient');
INSERT INTO `lng_data` VALUES ('common','referral_comment','en','How did you hear about ILIAS?');
INSERT INTO `lng_data` VALUES ('common','refresh','en','Refresh');
INSERT INTO `lng_data` VALUES ('common','refresh_languages','en','Refresh Languages');
INSERT INTO `lng_data` VALUES ('common','refresh_list','en','Refresh List');
INSERT INTO `lng_data` VALUES ('common','refuse','en','Refuse');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_salutation','en','Hello');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text1','en','Welcome to ILIAS eLearning!');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text2','en','To access ILIAS use the following data:');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text3','en','Further personal information:');
INSERT INTO `lng_data` VALUES ('common','reg_mail_subject','en','ILIAS eLearning - Your access data');
INSERT INTO `lng_data` VALUES ('common','reg_passwd_via_mail','en','Your password will be sent to your email address given below.');
INSERT INTO `lng_data` VALUES ('common','register','en','Register');
INSERT INTO `lng_data` VALUES ('common','register_info','en','Please fill out the form to register (Fields marked with an asterisk are required information).');
INSERT INTO `lng_data` VALUES ('common','registered_since','en','Registered since');
INSERT INTO `lng_data` VALUES ('common','registered_user','en','registered User');
INSERT INTO `lng_data` VALUES ('common','registered_users','en','registered Users');
INSERT INTO `lng_data` VALUES ('common','registration','en','New account registration');
INSERT INTO `lng_data` VALUES ('common','registration_disabled','en','Only available when using local authentication');
INSERT INTO `lng_data` VALUES ('common','registration_expired','en','Registration period expired...');
INSERT INTO `lng_data` VALUES ('common','related_to','en','Related to');
INSERT INTO `lng_data` VALUES ('common','remove','en','Remove');
INSERT INTO `lng_data` VALUES ('common','remove_personal_picture','en','Remove');
INSERT INTO `lng_data` VALUES ('common','remove_translation','en','Remove translation');
INSERT INTO `lng_data` VALUES ('common','rename','en','Rename');
INSERT INTO `lng_data` VALUES ('common','rename_file','en','Rename File');
INSERT INTO `lng_data` VALUES ('common','repeat_scan','en','Repeating virus scan...');
INSERT INTO `lng_data` VALUES ('common','repeat_scan_failed','en','Repeat scan failed.');
INSERT INTO `lng_data` VALUES ('common','repeat_scan_succeded','en','Repeat scan succeded.');
INSERT INTO `lng_data` VALUES ('common','replace_file','en','Replace File');
INSERT INTO `lng_data` VALUES ('common','reply','en','Reply');
INSERT INTO `lng_data` VALUES ('common','repository','en','Repository');
INSERT INTO `lng_data` VALUES ('common','repository_admin','en','Repository Trash and Permissions');
INSERT INTO `lng_data` VALUES ('common','repository_admin_desc','en','Set permissions for repository items, restore or remove objects from system trash');
INSERT INTO `lng_data` VALUES ('common','repository_frame','en','Repository Content');
INSERT INTO `lng_data` VALUES ('common','request_membership','en','Request membership');
INSERT INTO `lng_data` VALUES ('common','require_city','en','Require city');
INSERT INTO `lng_data` VALUES ('common','require_country','en','Require country');
INSERT INTO `lng_data` VALUES ('common','require_default_role','en','Require role');
INSERT INTO `lng_data` VALUES ('common','require_department','en','Require department');
INSERT INTO `lng_data` VALUES ('common','require_email','en','Require email');
INSERT INTO `lng_data` VALUES ('common','require_fax','en','Require fax');
INSERT INTO `lng_data` VALUES ('common','require_firstname','en','Require first name');
INSERT INTO `lng_data` VALUES ('common','require_gender','en','Require gender');
INSERT INTO `lng_data` VALUES ('common','require_hobby','en','Require hobby');
INSERT INTO `lng_data` VALUES ('common','require_institution','en','Require institution');
INSERT INTO `lng_data` VALUES ('common','require_lastname','en','Require last name');
INSERT INTO `lng_data` VALUES ('common','require_login','en','Require login');
INSERT INTO `lng_data` VALUES ('common','require_mandatory','en','mandatory');
INSERT INTO `lng_data` VALUES ('common','require_matriculation','en','Require matriculation number');
INSERT INTO `lng_data` VALUES ('common','require_passwd','en','Require password');
INSERT INTO `lng_data` VALUES ('common','require_passwd2','en','Require retype password');
INSERT INTO `lng_data` VALUES ('common','require_phone_home','en','Require home phone');
INSERT INTO `lng_data` VALUES ('common','require_phone_mobile','en','Require mobile phone');
INSERT INTO `lng_data` VALUES ('common','require_phone_office','en','Require office phone');
INSERT INTO `lng_data` VALUES ('common','require_referral_comment','en','Require referral comment');
INSERT INTO `lng_data` VALUES ('common','require_street','en','Require street');
INSERT INTO `lng_data` VALUES ('common','require_zipcode','en','Require zip code');
INSERT INTO `lng_data` VALUES ('common','required_field','en','Required');
INSERT INTO `lng_data` VALUES ('common','reset','en','Reset');
INSERT INTO `lng_data` VALUES ('common','resources','en','Resources');
INSERT INTO `lng_data` VALUES ('common','retype_password','en','Retype Password');
INSERT INTO `lng_data` VALUES ('common','right','en','Right');
INSERT INTO `lng_data` VALUES ('common','rights','en','Rights');
INSERT INTO `lng_data` VALUES ('common','role','en','Role');
INSERT INTO `lng_data` VALUES ('common','role_a','en','a Role');
INSERT INTO `lng_data` VALUES ('common','role_add','en','Add Role');
INSERT INTO `lng_data` VALUES ('common','role_add_local','en','Add local Role');
INSERT INTO `lng_data` VALUES ('common','role_add_user','en','Add User(s) to role');
INSERT INTO `lng_data` VALUES ('common','role_added','en','Role added');
INSERT INTO `lng_data` VALUES ('common','role_assigned_desk_items','en','Assigned desktop items');
INSERT INTO `lng_data` VALUES ('common','role_assigned_desktop_item','en','Created new assignment.');
INSERT INTO `lng_data` VALUES ('common','role_assignment','en','Role Assignment');
INSERT INTO `lng_data` VALUES ('common','role_assignment_updated','en','Role assignment has been updated.');
INSERT INTO `lng_data` VALUES ('common','role_count_users','en','Number of users');
INSERT INTO `lng_data` VALUES ('common','role_deleted','en','Role deleted');
INSERT INTO `lng_data` VALUES ('common','role_deleted_desktop_items','en','Deleted assignment.');
INSERT INTO `lng_data` VALUES ('common','role_desk_add','en','Assign desktop item');
INSERT INTO `lng_data` VALUES ('common','role_desk_none_created','en','No desktop items assigned to this role.');
INSERT INTO `lng_data` VALUES ('common','role_edit','en','Edit Role');
INSERT INTO `lng_data` VALUES ('common','role_header_edit_users','en','Change User Assignment');
INSERT INTO `lng_data` VALUES ('common','role_list_users','en','List users');
INSERT INTO `lng_data` VALUES ('common','role_mailto','en','Mail to all assigned Users');
INSERT INTO `lng_data` VALUES ('common','role_new','en','New Role');
INSERT INTO `lng_data` VALUES ('common','role_new_search','en','New search');
INSERT INTO `lng_data` VALUES ('common','role_no_groups_selected','en','Please select a group');
INSERT INTO `lng_data` VALUES ('common','role_no_results_found','en','No results found');
INSERT INTO `lng_data` VALUES ('common','role_no_roles_selected','en','Please select a role');
INSERT INTO `lng_data` VALUES ('common','role_no_users_no_desk_items','en','It is not possible to assign personal desktop items, since you cannot assign users to this role.');
INSERT INTO `lng_data` VALUES ('common','role_protect_permissions','en','Protect permissions');
INSERT INTO `lng_data` VALUES ('common','role_search_enter_search_string','en','Please enter a search string');
INSERT INTO `lng_data` VALUES ('common','role_search_users','en','User search');
INSERT INTO `lng_data` VALUES ('common','role_select_desktop_item','en','Please select one object that will be assigned to this role.');
INSERT INTO `lng_data` VALUES ('common','role_select_one_item','en','Please select one object.');
INSERT INTO `lng_data` VALUES ('common','role_sure_delete_desk_items','en','Are you sure you want to delete the following assignments?');
INSERT INTO `lng_data` VALUES ('common','role_templates_only','en','Role templates only');
INSERT INTO `lng_data` VALUES ('common','role_user_deassign','en','Deassign user from role');
INSERT INTO `lng_data` VALUES ('common','role_user_edit','en','Edit account data');
INSERT INTO `lng_data` VALUES ('common','role_user_send_mail','en','Send user a message');
INSERT INTO `lng_data` VALUES ('common','roles','en','Roles');
INSERT INTO `lng_data` VALUES ('common','roles_of_import_global','en','Global roles of import file');
INSERT INTO `lng_data` VALUES ('common','roles_of_import_local','en','Local roles of import file');
INSERT INTO `lng_data` VALUES ('common','rolf','en','Roles');
INSERT INTO `lng_data` VALUES ('common','rolf_added','en','Role Folder added');
INSERT INTO `lng_data` VALUES ('common','rolf_create_role','en','Create new Role definition');
INSERT INTO `lng_data` VALUES ('common','rolf_create_rolt','en','Create new Role definition template');
INSERT INTO `lng_data` VALUES ('common','rolf_delete','en','Delete Roles/Role templates');
INSERT INTO `lng_data` VALUES ('common','rolf_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','rolf_edit_userassignment','en','Change user assignment of Roles');
INSERT INTO `lng_data` VALUES ('common','rolf_read','en','Read access to Roles/Role templates');
INSERT INTO `lng_data` VALUES ('common','rolf_visible','en','Roles/Role templates are visible');
INSERT INTO `lng_data` VALUES ('common','rolf_write','en','Edit default permission settings of Roles/Role templates');
INSERT INTO `lng_data` VALUES ('common','rolt','en','Role Template');
INSERT INTO `lng_data` VALUES ('common','rolt_a','en','a Role Template');
INSERT INTO `lng_data` VALUES ('common','rolt_add','en','Add Role Template');
INSERT INTO `lng_data` VALUES ('common','rolt_added','en','Role template added');
INSERT INTO `lng_data` VALUES ('common','rolt_edit','en','Edit Role Template');
INSERT INTO `lng_data` VALUES ('common','rolt_new','en','New Role Template');
INSERT INTO `lng_data` VALUES ('common','root_create_cat','en','User may create Categories');
INSERT INTO `lng_data` VALUES ('common','root_edit','en','Edit system root node');
INSERT INTO `lng_data` VALUES ('common','root_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','root_read','en','Read access to ILIAS system');
INSERT INTO `lng_data` VALUES ('common','root_visible','en','ILIAS system is visible');
INSERT INTO `lng_data` VALUES ('common','root_write','en','Edit metadata of system root node');
INSERT INTO `lng_data` VALUES ('common','sahs','en','Learning Module SCORM/AICC');
INSERT INTO `lng_data` VALUES ('common','sahs_added','en','SCORM/AICC Learning Module added');
INSERT INTO `lng_data` VALUES ('common','sahs_create','en','Create SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','sahs_delete','en','Delete SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','sahs_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','sahs_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','sahs_join','en','Subscribe to SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','sahs_leave','en','Unsubscribe from SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','sahs_read','en','Read access to SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','sahs_visible','en','SCORM/AICC Learning Module is visible');
INSERT INTO `lng_data` VALUES ('common','sahs_write','en','Edit SCORM/AICC Learning Module');
INSERT INTO `lng_data` VALUES ('common','salutation','en','Salutation');
INSERT INTO `lng_data` VALUES ('common','salutation_f','en','Ms./Mrs.');
INSERT INTO `lng_data` VALUES ('common','salutation_m','en','Mr.');
INSERT INTO `lng_data` VALUES ('common','save','en','Save');
INSERT INTO `lng_data` VALUES ('common','save_and_back','en','Save And Back');
INSERT INTO `lng_data` VALUES ('common','save_message','en','Save Message');
INSERT INTO `lng_data` VALUES ('common','save_refresh','en','Save and Refresh');
INSERT INTO `lng_data` VALUES ('common','save_return','en','Save and Return');
INSERT INTO `lng_data` VALUES ('common','save_settings','en','Save Settings');
INSERT INTO `lng_data` VALUES ('common','save_user_related_data','en','Save user related access data');
INSERT INTO `lng_data` VALUES ('common','saved','en','Saved');
INSERT INTO `lng_data` VALUES ('common','saved_successfully','en','Saved Successfully');
INSERT INTO `lng_data` VALUES ('common','search','en','Search');
INSERT INTO `lng_data` VALUES ('common','search_active','en','Include active users');
INSERT INTO `lng_data` VALUES ('common','search_for','en','Search For');
INSERT INTO `lng_data` VALUES ('common','search_in','en','Search in');
INSERT INTO `lng_data` VALUES ('common','search_inactive','en','Include inactive users');
INSERT INTO `lng_data` VALUES ('common','search_minimum_characters','en','The minimum word length is:');
INSERT INTO `lng_data` VALUES ('common','search_new','en','New Search');
INSERT INTO `lng_data` VALUES ('common','search_note','en','If &quot;search in&quot; is left blank, all users will be searched. This allows you to find all active or all inactive users.');
INSERT INTO `lng_data` VALUES ('common','search_recipient','en','Search Recipient');
INSERT INTO `lng_data` VALUES ('common','search_result','en','Search result');
INSERT INTO `lng_data` VALUES ('common','search_to_short','en','Your query is to short.');
INSERT INTO `lng_data` VALUES ('common','search_user','en','Search User');
INSERT INTO `lng_data` VALUES ('common','seas_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','seas_max_hits','en','Max hits');
INSERT INTO `lng_data` VALUES ('common','seas_max_hits_info','en','Please enter a number for the maximum number of search results.');
INSERT INTO `lng_data` VALUES ('common','seas_read','en','Read search settings');
INSERT INTO `lng_data` VALUES ('common','seas_search','en','Allow to use the search');
INSERT INTO `lng_data` VALUES ('common','seas_settings','en','Search settings');
INSERT INTO `lng_data` VALUES ('common','seas_visible','en','Search settings are visible');
INSERT INTO `lng_data` VALUES ('common','seas_write','en','Edit search settings');
INSERT INTO `lng_data` VALUES ('common','second','en','Second');
INSERT INTO `lng_data` VALUES ('common','seconds','en','Seconds');
INSERT INTO `lng_data` VALUES ('common','sections','en','Sections');
INSERT INTO `lng_data` VALUES ('common','select','en','Select');
INSERT INTO `lng_data` VALUES ('common','select_all','en','Select All');
INSERT INTO `lng_data` VALUES ('common','select_file','en','Select file');
INSERT INTO `lng_data` VALUES ('common','select_max_one_item','en','Please select one item only');
INSERT INTO `lng_data` VALUES ('common','select_mode','en','Select mode');
INSERT INTO `lng_data` VALUES ('common','select_object_to_copy','en','Please select the object you want to copy');
INSERT INTO `lng_data` VALUES ('common','select_object_to_link','en','Please select the object which you want to link');
INSERT INTO `lng_data` VALUES ('common','select_password','en','Select a new password');
INSERT INTO `lng_data` VALUES ('common','select_questionpool','en','Question pool for Test');
INSERT INTO `lng_data` VALUES ('common','select_questionpool_option','en','--- Please select a question pool ---');
INSERT INTO `lng_data` VALUES ('common','selected','en','Selected');
INSERT INTO `lng_data` VALUES ('common','selected_items','en','Personal Items');
INSERT INTO `lng_data` VALUES ('common','send','en','Send');
INSERT INTO `lng_data` VALUES ('common','send_mail_admins','en','Mail to administrators');
INSERT INTO `lng_data` VALUES ('common','send_mail_members','en','Mail to members');
INSERT INTO `lng_data` VALUES ('common','send_mail_tutors','en','Mail to tutors');
INSERT INTO `lng_data` VALUES ('common','sender','en','Sender');
INSERT INTO `lng_data` VALUES ('common','sent','en','Sent');
INSERT INTO `lng_data` VALUES ('common','sequence','en','Sequence');
INSERT INTO `lng_data` VALUES ('common','sequences','en','Sequences');
INSERT INTO `lng_data` VALUES ('common','server','en','Server');
INSERT INTO `lng_data` VALUES ('common','server_data','en','Server data');
INSERT INTO `lng_data` VALUES ('common','server_software','en','Server Software');
INSERT INTO `lng_data` VALUES ('common','set','en','Set');
INSERT INTO `lng_data` VALUES ('common','setSystemLanguage','en','Set System Language');
INSERT INTO `lng_data` VALUES ('common','setUserLanguage','en','Set User Language');
INSERT INTO `lng_data` VALUES ('common','set_offline','en','Set Offline');
INSERT INTO `lng_data` VALUES ('common','set_online','en','Set Online');
INSERT INTO `lng_data` VALUES ('common','settings','en','Settings');
INSERT INTO `lng_data` VALUES ('common','settings_saved','en','Saved settings');
INSERT INTO `lng_data` VALUES ('common','shib','en','Shibboleth');
INSERT INTO `lng_data` VALUES ('common','shib_active','en','Enable Shibboleth support');
INSERT INTO `lng_data` VALUES ('common','shib_city','en','Attribute for city');
INSERT INTO `lng_data` VALUES ('common','shib_configure','en','Configure Shibboleh Authentication');
INSERT INTO `lng_data` VALUES ('common','shib_country','en','Attribute for country');
INSERT INTO `lng_data` VALUES ('common','shib_data_conv','en','Absolute path to data manipulation API');
INSERT INTO `lng_data` VALUES ('common','shib_data_conv_warning','en','The data manipulation API file you specified cannot be read');
INSERT INTO `lng_data` VALUES ('common','shib_department','en','Attribute for department');
INSERT INTO `lng_data` VALUES ('common','shib_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','shib_email','en','Attribute for email address');
INSERT INTO `lng_data` VALUES ('common','shib_federation_name','en','Name of your Shibboleth federation');
INSERT INTO `lng_data` VALUES ('common','shib_firstname','en','Attribute for firstname');
INSERT INTO `lng_data` VALUES ('common','shib_gender','en','Attribute for gender (must be \'m\' or \'f\')');
INSERT INTO `lng_data` VALUES ('common','shib_general_login_instructions','en','To log in via %s, please click on the login button and choose your organization of the following page.<br>If you have questions concerning this, please ask the');
INSERT INTO `lng_data` VALUES ('common','shib_general_wayf_login_instructions','en','In case you are not associated with the given organizations and you need access to a course on this server, please contact the');
INSERT INTO `lng_data` VALUES ('common','shib_idp_list','en','Provide a list of Identity Providers to let the user choose from on the ILIAS login page.<br>On each line there must be a comma-separated tuple for <strong>providerID of IdP</strong> (see the Shibboleth metadata file) and <strong>Name of IdP</strong> as it shall be displayed in the drow-down list.<br>As an optional third parameter you can add the <strong>location of a Shibboleth session initiator</strong> that shall be used in case your ILIAS installation is part of a multi federation setup.');
INSERT INTO `lng_data` VALUES ('common','shib_institution','en','Attribute for institution');
INSERT INTO `lng_data` VALUES ('common','shib_instructions','en','Be sure to read the <a href=\"README.SHIBBOLETH.txt\" target=\"_blank\">README</a> for instructions on how to configure Shibboleth support for ILIAS. ');
INSERT INTO `lng_data` VALUES ('common','shib_invalid_home_organization','en','Please choose a valid organization!');
INSERT INTO `lng_data` VALUES ('common','shib_language','en','Attribute for language');
INSERT INTO `lng_data` VALUES ('common','shib_lastname','en','Attribute for lastname');
INSERT INTO `lng_data` VALUES ('common','shib_login','en','Unique Shibboleth attribute');
INSERT INTO `lng_data` VALUES ('common','shib_login_button','en','Path to the image of a Shibboleth login button that is used to redirect users to the WAYF specified in the Shibboleth configuration');
INSERT INTO `lng_data` VALUES ('common','shib_login_external_wayf','en','Use external WAYF service');
INSERT INTO `lng_data` VALUES ('common','shib_login_internal_wayf','en','Use ILIAS WAYF service');
INSERT INTO `lng_data` VALUES ('common','shib_login_type','en','Organization selection');
INSERT INTO `lng_data` VALUES ('common','shib_member_of','en','I\'m a member of ...');
INSERT INTO `lng_data` VALUES ('common','shib_phone_home','en','Attribute for home phone number');
INSERT INTO `lng_data` VALUES ('common','shib_phone_mobile','en','Attribute for mobile phone number');
INSERT INTO `lng_data` VALUES ('common','shib_phone_office','en','Attribute for office phone number');
INSERT INTO `lng_data` VALUES ('common','shib_read','en','Read access to Shibboleth settings');
INSERT INTO `lng_data` VALUES ('common','shib_select_home_organization','en','For authentication via %s, please select your organization from the drop down list.');
INSERT INTO `lng_data` VALUES ('common','shib_settings_saved','en','The Shibboleth settings were saved');
INSERT INTO `lng_data` VALUES ('common','shib_street','en','Attribute for street');
INSERT INTO `lng_data` VALUES ('common','shib_title','en','Attribute for title');
INSERT INTO `lng_data` VALUES ('common','shib_update','en','Update this field on login');
INSERT INTO `lng_data` VALUES ('common','shib_user_default_role','en','Default role assigned to Shibboleth users');
INSERT INTO `lng_data` VALUES ('common','shib_visible','en','Shibboleth settings are visible');
INSERT INTO `lng_data` VALUES ('common','shib_write','en','Edit Shibboleth settings');
INSERT INTO `lng_data` VALUES ('common','shib_zipcode','en','Attribute for zipcode');
INSERT INTO `lng_data` VALUES ('common','show','en','Show');
INSERT INTO `lng_data` VALUES ('common','show_details','en','Show Details');
INSERT INTO `lng_data` VALUES ('common','show_list','en','Show List');
INSERT INTO `lng_data` VALUES ('common','show_members','en','Display Members');
INSERT INTO `lng_data` VALUES ('common','show_notes_on_pd','en','Show notes on personal desktop');
INSERT INTO `lng_data` VALUES ('common','show_owner','en','Show Owner');
INSERT INTO `lng_data` VALUES ('common','show_private_notes','en','Show private notes');
INSERT INTO `lng_data` VALUES ('common','show_public_notes','en','Show public notes');
INSERT INTO `lng_data` VALUES ('common','show_structure','en','Enable Structured-View');
INSERT INTO `lng_data` VALUES ('common','show_users_online','en','Show active users');
INSERT INTO `lng_data` VALUES ('common','signature','en','Signature');
INSERT INTO `lng_data` VALUES ('common','size','en','Size');
INSERT INTO `lng_data` VALUES ('common','skin_style','en','Default Skin / Style');
INSERT INTO `lng_data` VALUES ('common','small_icon','en','Small Icon');
INSERT INTO `lng_data` VALUES ('common','smtp','en','SMTP');
INSERT INTO `lng_data` VALUES ('common','soap_user_administration','en','External user administration (SOAP)');
INSERT INTO `lng_data` VALUES ('common','soap_user_administration_desc','en','If enabled, all user accounts can be administrated by an external SOAP-Client.');
INSERT INTO `lng_data` VALUES ('common','sort_by_this_column','en','Sort by this column');
INSERT INTO `lng_data` VALUES ('common','spacer','en','Spacer');
INSERT INTO `lng_data` VALUES ('common','spl','en','Question Pool Survey');
INSERT INTO `lng_data` VALUES ('common','spl_add','en','Add question pool for survey');
INSERT INTO `lng_data` VALUES ('common','spl_delete','en','Delete Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','spl_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','spl_new','en','New question pool for survey');
INSERT INTO `lng_data` VALUES ('common','spl_read','en','Read access to Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','spl_upload_file','en','Upload file');
INSERT INTO `lng_data` VALUES ('common','spl_visible','en','Question Pool for Survey is visible');
INSERT INTO `lng_data` VALUES ('common','spl_write','en','Edit Question Pool for Survey');
INSERT INTO `lng_data` VALUES ('common','ssl','en','SSL (HTTPS)');
INSERT INTO `lng_data` VALUES ('common','st_a','en','a chapter');
INSERT INTO `lng_data` VALUES ('common','st_add','en','Add chapter');
INSERT INTO `lng_data` VALUES ('common','st_added','en','Chapter added');
INSERT INTO `lng_data` VALUES ('common','st_edit','en','Edit chapter');
INSERT INTO `lng_data` VALUES ('common','st_new','en','New chapter');
INSERT INTO `lng_data` VALUES ('common','standard_fields','en','Standard Fields');
INSERT INTO `lng_data` VALUES ('common','startpage','en','Start page');
INSERT INTO `lng_data` VALUES ('common','statistic','en','Statistic');
INSERT INTO `lng_data` VALUES ('common','status','en','Status');
INSERT INTO `lng_data` VALUES ('common','step','en','Step');
INSERT INTO `lng_data` VALUES ('common','stop_inheritance','en','Stop inheritance');
INSERT INTO `lng_data` VALUES ('common','street','en','Street');
INSERT INTO `lng_data` VALUES ('common','structure','en','Structure');
INSERT INTO `lng_data` VALUES ('common','sty','en','Style');
INSERT INTO `lng_data` VALUES ('common','style_activation','en','Style Activation');
INSERT INTO `lng_data` VALUES ('common','stys_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','stys_read','en','Read access to style settings');
INSERT INTO `lng_data` VALUES ('common','stys_visible','en','Style settings are visible');
INSERT INTO `lng_data` VALUES ('common','stys_write','en','Edit style settings');
INSERT INTO `lng_data` VALUES ('common','subcat_name','en','Subcategory Name');
INSERT INTO `lng_data` VALUES ('common','subchapter_new','en','New Subchapter');
INSERT INTO `lng_data` VALUES ('common','subject','en','Subject');
INSERT INTO `lng_data` VALUES ('common','subject_module','en','Subject Module');
INSERT INTO `lng_data` VALUES ('common','submit','en','Submit');
INSERT INTO `lng_data` VALUES ('common','subobjects','en','Subobjects');
INSERT INTO `lng_data` VALUES ('common','subscription','en','Subscription');
INSERT INTO `lng_data` VALUES ('common','summary','en','Summary');
INSERT INTO `lng_data` VALUES ('common','sure_delete_selected_users','en','Are you sure you want to delete the selected user(s)');
INSERT INTO `lng_data` VALUES ('common','svy','en','Survey');
INSERT INTO `lng_data` VALUES ('common','svy_add','en','Add survey');
INSERT INTO `lng_data` VALUES ('common','svy_delete','en','Delete survey');
INSERT INTO `lng_data` VALUES ('common','svy_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','svy_evaluation','en','Evaluation');
INSERT INTO `lng_data` VALUES ('common','svy_finished','en','finished');
INSERT INTO `lng_data` VALUES ('common','svy_invite','en','Invite users to a survey');
INSERT INTO `lng_data` VALUES ('common','svy_new','en','New survey');
INSERT INTO `lng_data` VALUES ('common','svy_no_content','en','No surveys available');
INSERT INTO `lng_data` VALUES ('common','svy_not_finished','en','not finished');
INSERT INTO `lng_data` VALUES ('common','svy_not_started','en','not started');
INSERT INTO `lng_data` VALUES ('common','svy_participate','en','Participate in a survey');
INSERT INTO `lng_data` VALUES ('common','svy_read','en','Read access to survey');
INSERT INTO `lng_data` VALUES ('common','svy_run','en','Run');
INSERT INTO `lng_data` VALUES ('common','svy_upload_file','en','Upload file');
INSERT INTO `lng_data` VALUES ('common','svy_visible','en','Survey is visible');
INSERT INTO `lng_data` VALUES ('common','svy_warning_survey_not_complete','en','The survey is not finished!');
INSERT INTO `lng_data` VALUES ('common','svy_write','en','Edit survey');
INSERT INTO `lng_data` VALUES ('common','system','en','System');
INSERT INTO `lng_data` VALUES ('common','system_check','en','System Check');
INSERT INTO `lng_data` VALUES ('common','system_choose_language','en','System Choose Language');
INSERT INTO `lng_data` VALUES ('common','system_groups','en','System Groups');
INSERT INTO `lng_data` VALUES ('common','system_grp','en','System Group');
INSERT INTO `lng_data` VALUES ('common','system_information','en','System Information');
INSERT INTO `lng_data` VALUES ('common','system_language','en','System Language');
INSERT INTO `lng_data` VALUES ('common','system_message','en','System Message');
INSERT INTO `lng_data` VALUES ('common','system_style_settings','en','System Style Settings');
INSERT INTO `lng_data` VALUES ('common','system_styles','en','System Styles');
INSERT INTO `lng_data` VALUES ('common','table_mail_import','en','Mail import');
INSERT INTO `lng_data` VALUES ('common','target','en','Target');
INSERT INTO `lng_data` VALUES ('common','tax','en','Taxonomy');
INSERT INTO `lng_data` VALUES ('common','tax_add','en','Add Taxonomy');
INSERT INTO `lng_data` VALUES ('common','tax_delete','en','Delete taxonomies');
INSERT INTO `lng_data` VALUES ('common','tax_edit','en','Edit Taxonomy');
INSERT INTO `lng_data` VALUES ('common','tax_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','tax_new','en','New Taxonomy');
INSERT INTO `lng_data` VALUES ('common','tax_read','en','Read access to taxonomies');
INSERT INTO `lng_data` VALUES ('common','tax_visible','en','Taxonomy is visible');
INSERT INTO `lng_data` VALUES ('common','tax_write','en','Write access to taxonomies');
INSERT INTO `lng_data` VALUES ('common','taxf_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','taxf_read','en','Read access to taxonomy folder');
INSERT INTO `lng_data` VALUES ('common','taxf_visible','en','Taxonomy folder is visible');
INSERT INTO `lng_data` VALUES ('common','taxf_write','en','Write access to taxonomy folder');
INSERT INTO `lng_data` VALUES ('common','term','en','Term');
INSERT INTO `lng_data` VALUES ('common','test','en','Test');
INSERT INTO `lng_data` VALUES ('common','test_intern','en','Test Intern');
INSERT INTO `lng_data` VALUES ('common','test_module','en','Test Module');
INSERT INTO `lng_data` VALUES ('common','tests','en','Tests');
INSERT INTO `lng_data` VALUES ('common','thread','en','Thread');
INSERT INTO `lng_data` VALUES ('common','thumbnail','en','Thumbnail');
INSERT INTO `lng_data` VALUES ('common','time','en','Time');
INSERT INTO `lng_data` VALUES ('common','time_d','en','Day');
INSERT INTO `lng_data` VALUES ('common','time_h','en','Hour');
INSERT INTO `lng_data` VALUES ('common','time_limit','en','Access');
INSERT INTO `lng_data` VALUES ('common','time_limit_add_time_limit_for_selected','en','Please enter a time period for the selected users.');
INSERT INTO `lng_data` VALUES ('common','time_limit_applied_users','en','Applied users');
INSERT INTO `lng_data` VALUES ('common','time_limit_from','en','From (time limit)');
INSERT INTO `lng_data` VALUES ('common','time_limit_message','en','Message (time limit)');
INSERT INTO `lng_data` VALUES ('common','time_limit_no_users_selected','en','Please select a user.');
INSERT INTO `lng_data` VALUES ('common','time_limit_not_valid','en','The period is not valid.');
INSERT INTO `lng_data` VALUES ('common','time_limit_not_within_owners','en','Your access is limited. The period is outside of your limit.');
INSERT INTO `lng_data` VALUES ('common','time_limit_owner','en','Owner (time limit)');
INSERT INTO `lng_data` VALUES ('common','time_limit_reached','en','Your access period is expired.');
INSERT INTO `lng_data` VALUES ('common','time_limit_unlimited','en','Unlimited (time limit)');
INSERT INTO `lng_data` VALUES ('common','time_limit_until','en','Until (time limit)');
INSERT INTO `lng_data` VALUES ('common','time_limit_users_updated','en','User data updated');
INSERT INTO `lng_data` VALUES ('common','time_limits','en','Access');
INSERT INTO `lng_data` VALUES ('common','time_segment','en','Period of time');
INSERT INTO `lng_data` VALUES ('common','title','en','Title');
INSERT INTO `lng_data` VALUES ('common','to','en','To');
INSERT INTO `lng_data` VALUES ('common','to_client_list','en','Client Selection');
INSERT INTO `lng_data` VALUES ('common','to_desktop','en','Add to desktop');
INSERT INTO `lng_data` VALUES ('common','today','en','Today');
INSERT INTO `lng_data` VALUES ('common','toggleGlobalDefault','en','Toggle Global Default');
INSERT INTO `lng_data` VALUES ('common','toggleGlobalFixed','en','Toggle Global Fixed');
INSERT INTO `lng_data` VALUES ('common','total','en','Total');
INSERT INTO `lng_data` VALUES ('common','tpl_path','en','Template Path');
INSERT INTO `lng_data` VALUES ('common','trac_delete','en','Delete Tracking Data');
INSERT INTO `lng_data` VALUES ('common','trac_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','trac_read','en','Read Tracking Data');
INSERT INTO `lng_data` VALUES ('common','trac_visible','en','User tracking is visible');
INSERT INTO `lng_data` VALUES ('common','tracked_objects','en','Tracked objects');
INSERT INTO `lng_data` VALUES ('common','tracking_data','en','Tracking Data');
INSERT INTO `lng_data` VALUES ('common','tracking_data_del_confirm','en','Do you really want to delete all tracking data of the specified month and before?');
INSERT INTO `lng_data` VALUES ('common','tracking_data_deleted','en','Tracking data deleted');
INSERT INTO `lng_data` VALUES ('common','tracking_settings','en','Tracking Settings');
INSERT INTO `lng_data` VALUES ('common','translation','en','Translation');
INSERT INTO `lng_data` VALUES ('common','trash','en','Trash');
INSERT INTO `lng_data` VALUES ('common','tree_frame','en','Tree Frame');
INSERT INTO `lng_data` VALUES ('common','tree_frame_info','en','Defines whether the tree frame (e.g. repository tree) should appear on the left or on the right.');
INSERT INTO `lng_data` VALUES ('common','tree_left','en','Left');
INSERT INTO `lng_data` VALUES ('common','tree_right','en','Right');
INSERT INTO `lng_data` VALUES ('common','treeview','en','Tree View');
INSERT INTO `lng_data` VALUES ('common','tst','en','Test');
INSERT INTO `lng_data` VALUES ('common','tst_add','en','Add test');
INSERT INTO `lng_data` VALUES ('common','tst_anon_eval','en','Results');
INSERT INTO `lng_data` VALUES ('common','tst_delete','en','Delete Test');
INSERT INTO `lng_data` VALUES ('common','tst_edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('common','tst_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','tst_new','en','New test');
INSERT INTO `lng_data` VALUES ('common','tst_no_content','en','No tests available');
INSERT INTO `lng_data` VALUES ('common','tst_read','en','Read access to Test');
INSERT INTO `lng_data` VALUES ('common','tst_run','en','Run');
INSERT INTO `lng_data` VALUES ('common','tst_statistical_evaluation','en','Statistics');
INSERT INTO `lng_data` VALUES ('common','tst_upload_file','en','Upload file');
INSERT INTO `lng_data` VALUES ('common','tst_user_not_invited','en','You are not supposed to take this exam.');
INSERT INTO `lng_data` VALUES ('common','tst_user_wrong_clientip','en','You don\'t have the right ip using this test');
INSERT INTO `lng_data` VALUES ('common','tst_visible','en','Test is visible');
INSERT INTO `lng_data` VALUES ('common','tst_warning_test_not_complete','en','The test is not complete!');
INSERT INTO `lng_data` VALUES ('common','tst_write','en','Edit Test');
INSERT INTO `lng_data` VALUES ('common','txt_add_object_instruction1','en','Browse to the location where you want to add');
INSERT INTO `lng_data` VALUES ('common','txt_add_object_instruction2','en','.');
INSERT INTO `lng_data` VALUES ('common','txt_registered','en','You successfully registered to ILIAS. Please click on the button below to login to ILIAS with your user account.');
INSERT INTO `lng_data` VALUES ('common','txt_submitted','en','You successfully submitted an account request to ILIAS. Your account request will be reviewed by the system administrators, and should be activated within 48 hours. You will not be able to log in until your account is activated.');
INSERT INTO `lng_data` VALUES ('common','typ','en','Object Type Definition');
INSERT INTO `lng_data` VALUES ('common','type','en','Type');
INSERT INTO `lng_data` VALUES ('common','type_your_message_here','en','Type Your Message Here');
INSERT INTO `lng_data` VALUES ('common','udf_add_field','en','Add Field');
INSERT INTO `lng_data` VALUES ('common','udf_added_field','en','Added new field.');
INSERT INTO `lng_data` VALUES ('common','udf_delete_header','en','Delete Field');
INSERT INTO `lng_data` VALUES ('common','udf_delete_sure','en','Are you sure you want to delete this field and all assigned user data ?');
INSERT INTO `lng_data` VALUES ('common','udf_duplicate_entries','en','The values have to be unique.');
INSERT INTO `lng_data` VALUES ('common','udf_field_deleted','en','Deleted field.');
INSERT INTO `lng_data` VALUES ('common','udf_name_already_exists','en','This field name already exists. Please choose a different name.');
INSERT INTO `lng_data` VALUES ('common','udf_no_entries','en','Please enter minimum one value.');
INSERT INTO `lng_data` VALUES ('common','udf_no_name_given','en','Please enter a field name.');
INSERT INTO `lng_data` VALUES ('common','udf_type_select','en','Select Box (fixed values)');
INSERT INTO `lng_data` VALUES ('common','udf_type_text','en','Text Field (optional values)');
INSERT INTO `lng_data` VALUES ('common','udf_update_select_field','en','Edit Select Box');
INSERT INTO `lng_data` VALUES ('common','udf_update_success','en','Saved modifications.');
INSERT INTO `lng_data` VALUES ('common','udf_update_text_field','en','Edit Text Field');
INSERT INTO `lng_data` VALUES ('common','udf_value','en','Value');
INSERT INTO `lng_data` VALUES ('common','udf_value_deleted','en','The value has been deleted.');
INSERT INTO `lng_data` VALUES ('common','uid','en','UID');
INSERT INTO `lng_data` VALUES ('common','ums_create_new_account','en','Create New Account');
INSERT INTO `lng_data` VALUES ('common','ums_explanation','en','Your external account could not be mapped to an ILIAS account. But ILIAS has found an account with your e-mail address. If this is your account, please login with your ILIAS password.');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_2','en','If this is not your account, please hit \'Create New Account\'.');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_3','en','Your external account could not be mapped to an ILIAS account. But ILIAS has found multiple accounts with your e-mail address. If one of those is your account, please login with your ILIAS password.');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_4','en','If none of them is your account, please hit \'Create New Account\'.');
INSERT INTO `lng_data` VALUES ('common','ums_login_account','en','Login Account');
INSERT INTO `lng_data` VALUES ('common','unambiguousness','en','Unambiguousness');
INSERT INTO `lng_data` VALUES ('common','uncheck_all','en','Uncheck all');
INSERT INTO `lng_data` VALUES ('common','uninstall','en','Uninstall');
INSERT INTO `lng_data` VALUES ('common','uninstalled','en','uninstalled.');
INSERT INTO `lng_data` VALUES ('common','unknown','en','UNKNOWN');
INSERT INTO `lng_data` VALUES ('common','unlabeled','en','Unlabeled');
INSERT INTO `lng_data` VALUES ('common','unread','en','Unread');
INSERT INTO `lng_data` VALUES ('common','unread_lowercase','en','unread');
INSERT INTO `lng_data` VALUES ('common','unselected','en','Unselected');
INSERT INTO `lng_data` VALUES ('common','unsubscribe','en','Remove from desktop');
INSERT INTO `lng_data` VALUES ('common','unzip','en','Unzip');
INSERT INTO `lng_data` VALUES ('common','up','en','Up');
INSERT INTO `lng_data` VALUES ('common','update','en','Edit');
INSERT INTO `lng_data` VALUES ('common','update_applied','en','Update Applied');
INSERT INTO `lng_data` VALUES ('common','update_language','en','Update Language');
INSERT INTO `lng_data` VALUES ('common','update_on_conflict','en','Update on conflict');
INSERT INTO `lng_data` VALUES ('common','upload','en','Upload');
INSERT INTO `lng_data` VALUES ('common','upload_error_file_not_found','en','Upload error: File not found.');
INSERT INTO `lng_data` VALUES ('common','uploaded_and_checked','en','The file has been uploaded and checked, you can now start to import it.');
INSERT INTO `lng_data` VALUES ('common','uri','en','URI');
INSERT INTO `lng_data` VALUES ('common','url','en','URL');
INSERT INTO `lng_data` VALUES ('common','url_a','en','a URL');
INSERT INTO `lng_data` VALUES ('common','url_add','en','Add URL');
INSERT INTO `lng_data` VALUES ('common','url_added','en','URL added');
INSERT INTO `lng_data` VALUES ('common','url_create_url','en','Create URL');
INSERT INTO `lng_data` VALUES ('common','url_delete','en','Delete URL');
INSERT INTO `lng_data` VALUES ('common','url_description','en','URL Description');
INSERT INTO `lng_data` VALUES ('common','url_edit','en','Edit URL');
INSERT INTO `lng_data` VALUES ('common','url_edit_permission','en','Change Permission settings');
INSERT INTO `lng_data` VALUES ('common','url_new','en','New URL');
INSERT INTO `lng_data` VALUES ('common','url_not_found','en','File Not Found');
INSERT INTO `lng_data` VALUES ('common','url_read','en','Open URL');
INSERT INTO `lng_data` VALUES ('common','url_to_latex','en','URL to LaTeX CGI script');
INSERT INTO `lng_data` VALUES ('common','url_visible','en','URL is visible');
INSERT INTO `lng_data` VALUES ('common','url_write','en','Edit URL');
INSERT INTO `lng_data` VALUES ('common','user','en','User');
INSERT INTO `lng_data` VALUES ('common','user_access','en','Access per user');
INSERT INTO `lng_data` VALUES ('common','user_added','en','User added');
INSERT INTO `lng_data` VALUES ('common','user_assignment','en','User Assignment');
INSERT INTO `lng_data` VALUES ('common','user_cant_receive_mail','en','user is not allowed to use the mail system');
INSERT INTO `lng_data` VALUES ('common','user_comment','en','User comment');
INSERT INTO `lng_data` VALUES ('common','user_defined_fields','en','User-defined Fields');
INSERT INTO `lng_data` VALUES ('common','user_defined_list','en','Overview User-defined Fields');
INSERT INTO `lng_data` VALUES ('common','user_deleted','en','User deleted');
INSERT INTO `lng_data` VALUES ('common','user_detail','en','Detail Data');
INSERT INTO `lng_data` VALUES ('common','user_ext_account','en','External Account');
INSERT INTO `lng_data` VALUES ('common','user_ext_account_desc','en','Account used for external authentication. (CAS or SOAP authentication)');
INSERT INTO `lng_data` VALUES ('common','user_import_failed','en','User import failed.');
INSERT INTO `lng_data` VALUES ('common','user_imported','en','User import complete.');
INSERT INTO `lng_data` VALUES ('common','user_imported_with_warnings','en','User import complete with warnings.');
INSERT INTO `lng_data` VALUES ('common','user_language','en','User Language');
INSERT INTO `lng_data` VALUES ('common','user_new_account_mail','en','New Account Mail');
INSERT INTO `lng_data` VALUES ('common','user_new_account_mail_desc','en','This mail can be sent when an ILIAS user is created by other means then self-registration.');
INSERT INTO `lng_data` VALUES ('common','user_not_chosen','en','You did not choose a group-member!');
INSERT INTO `lng_data` VALUES ('common','user_not_known','en','Please insert a valid username.');
INSERT INTO `lng_data` VALUES ('common','user_profile_other','en','Other Information');
INSERT INTO `lng_data` VALUES ('common','user_send_new_account_mail','en','Send new account mail');
INSERT INTO `lng_data` VALUES ('common','user_statistics','en','Statistical Data');
INSERT INTO `lng_data` VALUES ('common','userdata','en','User data');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_csv','en','Comma Separated Values');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_excel_x86','en','Microsoft Excel');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_file','en','File');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_file_size','en','File size');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_files','en','Files');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_xml','en','XML');
INSERT INTO `lng_data` VALUES ('common','username','en','User name');
INSERT INTO `lng_data` VALUES ('common','users','en','Users');
INSERT INTO `lng_data` VALUES ('common','users_not_imported','en','The following users do not exist, their messages cannot become imported');
INSERT INTO `lng_data` VALUES ('common','users_online','en','Active users');
INSERT INTO `lng_data` VALUES ('common','users_online_show_associated','en','Show members of my courses and groups only');
INSERT INTO `lng_data` VALUES ('common','users_online_show_n','en','Don\'t show active users');
INSERT INTO `lng_data` VALUES ('common','users_online_show_y','en','Show all active users');
INSERT INTO `lng_data` VALUES ('common','usertracking','en','User Tracking');
INSERT INTO `lng_data` VALUES ('common','usr','en','User');
INSERT INTO `lng_data` VALUES ('common','usr_a','en','a User');
INSERT INTO `lng_data` VALUES ('common','usr_active_only','en','Active Users only');
INSERT INTO `lng_data` VALUES ('common','usr_add','en','Add User');
INSERT INTO `lng_data` VALUES ('common','usr_added','en','User added');
INSERT INTO `lng_data` VALUES ('common','usr_agreement','en','User Agreement');
INSERT INTO `lng_data` VALUES ('common','usr_agreement_empty','en','The agreement contains no text');
INSERT INTO `lng_data` VALUES ('common','usr_edit','en','Edit User');
INSERT INTO `lng_data` VALUES ('common','usr_hits_per_page','en','Hits/page in tables');
INSERT INTO `lng_data` VALUES ('common','usr_inactive_only','en','Inactive Users only');
INSERT INTO `lng_data` VALUES ('common','usr_new','en','New User');
INSERT INTO `lng_data` VALUES ('common','usr_settings_explanation_profile','en','Check \'Visible\' to show fields in the registration form and personal user profile on the personal desktop. Check \'Changeable\' to allow the user to change the value in the personal profile. Please note that visible fields can always be entered in the registration form. Required fields are required in the registration form and the personal user profile. All data can be changed in the user administration independent on these settings.');
INSERT INTO `lng_data` VALUES ('common','usr_settings_header_profile','en','User profile settings');
INSERT INTO `lng_data` VALUES ('common','usr_settings_header_profile_profile','en','Personal profile setting');
INSERT INTO `lng_data` VALUES ('common','usr_settings_saved','en','Global user settings saved successfully!');
INSERT INTO `lng_data` VALUES ('common','usr_skin_style','en','Skin / Style');
INSERT INTO `lng_data` VALUES ('common','usr_style','en','User Style');
INSERT INTO `lng_data` VALUES ('common','usrf','en','User accounts');
INSERT INTO `lng_data` VALUES ('common','usrf_create_user','en','Create new user account');
INSERT INTO `lng_data` VALUES ('common','usrf_delete','en','Delete user accounts');
INSERT INTO `lng_data` VALUES ('common','usrf_edit_permission','en','Change access to user accounts');
INSERT INTO `lng_data` VALUES ('common','usrf_edit_roleassignment','en','Change role assignment of user accounts');
INSERT INTO `lng_data` VALUES ('common','usrf_push_desktop_items','en','Allow to push items on the personal desktop.');
INSERT INTO `lng_data` VALUES ('common','usrf_read','en','Read access to user accounts');
INSERT INTO `lng_data` VALUES ('common','usrf_read_users','en','Role assignment for local administrators');
INSERT INTO `lng_data` VALUES ('common','usrf_visible','en','User accounts are visible');
INSERT INTO `lng_data` VALUES ('common','usrf_write','en','Edit user accounts');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_failed','en','Action %1$s failed.');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_ignored','en','Ignored action %1$s.');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_replaced','en','Replaced action %1$s by %2$s.');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_delete','en','Can\'t perform \"Delete\" action. No such user in database. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_insert','en','Can\'t perform \"Insert\" action. User is already in database. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_update','en','Can\'t perform \"Update\" action. No such user in database. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_conflict_handling_info','en','When \"Ignore on conflict\" is selected, ILIAS ignores an action, if it can not be performed (e. g. an \"Insert\" action is not done, if there is already a user with the same login in the database.)\\nWhen \"Update on conflict\" is selected, ILIAS updates the database if an action can not be performed. (e. g. an \"Insert\" action is replaced by an \"Update\" action, if a user with the same login exists in the database). ');
INSERT INTO `lng_data` VALUES ('common','usrimport_global_role_for_action_required','en','At least one global role must be specified for \"%1$s\" action. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_ignore_role','en','Ignore role');
INSERT INTO `lng_data` VALUES ('common','usrimport_login_is_not_unique','en','Login is not unique.');
INSERT INTO `lng_data` VALUES ('common','usrimport_with_specified_role_not_permitted','en','Import with specified role not permitted.');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_missing','en','Attribute \"%2$s\" in element \"%1$s\" is missing. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_value_illegal','en','Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is illegal. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_value_inapplicable','en','Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is inapplicable for \"%4$s\" action. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_content_illegal','en','Content \"%2$s\" of element \"%1$s\" is illegal. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_for_action_required','en','Element \"%1$s\" must be specified for \"%2$s\" action. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_inapplicable','en','Element \"%1$s\" is inapplicable for \"%2$s\" action. ');
INSERT INTO `lng_data` VALUES ('common','usrimport_no_insert_ext_account_exists','en','Can\'t perform \"Insert\" action. External account already exists.');
INSERT INTO `lng_data` VALUES ('common','usrimport_no_update_ext_account_exists','en','Can\'t perform \"Update\" action. External account already exists.');
INSERT INTO `lng_data` VALUES ('common','valid','en','Valid');
INSERT INTO `lng_data` VALUES ('common','validate','en','Validate');
INSERT INTO `lng_data` VALUES ('common','value','en','Value');
INSERT INTO `lng_data` VALUES ('common','vcard','en','Visiting card');
INSERT INTO `lng_data` VALUES ('common','vcard_download','en','Download visiting card');
INSERT INTO `lng_data` VALUES ('common','vendors','en','Vendors');
INSERT INTO `lng_data` VALUES ('common','verification_failed','en','Verification failed');
INSERT INTO `lng_data` VALUES ('common','verification_failure_log','en','Verification failure log');
INSERT INTO `lng_data` VALUES ('common','verification_log','en','Verification log');
INSERT INTO `lng_data` VALUES ('common','verification_warning_log','en','Verification warning log');
INSERT INTO `lng_data` VALUES ('common','version','en','Version');
INSERT INTO `lng_data` VALUES ('common','versions','en','Versions');
INSERT INTO `lng_data` VALUES ('common','view','en','View');
INSERT INTO `lng_data` VALUES ('common','view_content','en','View Content');
INSERT INTO `lng_data` VALUES ('common','visible','en','Visible');
INSERT INTO `lng_data` VALUES ('common','visible_layers','en','Visible Layers');
INSERT INTO `lng_data` VALUES ('common','visitor','en','Visitor');
INSERT INTO `lng_data` VALUES ('common','visitors','en','Visitors');
INSERT INTO `lng_data` VALUES ('common','visits','en','Visits');
INSERT INTO `lng_data` VALUES ('common','web_resources','en','Web Resources');
INSERT INTO `lng_data` VALUES ('common','webr','en','Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_active','en','Active');
INSERT INTO `lng_data` VALUES ('common','webr_add','en','Add Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_add_item','en','Add Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_delete','en','Delete Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_delete_items','en','Delete Web Resource(s)');
INSERT INTO `lng_data` VALUES ('common','webr_deleted_items','en','Deleted Web Resource(s).');
INSERT INTO `lng_data` VALUES ('common','webr_disable_check','en','Disable check');
INSERT INTO `lng_data` VALUES ('common','webr_edit','en','Edit Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_edit_item','en','Edit Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_edit_permission','en','Change permission settings');
INSERT INTO `lng_data` VALUES ('common','webr_fillout_all','en','Please fill out all required fields.');
INSERT INTO `lng_data` VALUES ('common','webr_item_updated','en','Saved modifications');
INSERT INTO `lng_data` VALUES ('common','webr_join','en','Subscribe Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_last_check','en','Last check');
INSERT INTO `lng_data` VALUES ('common','webr_last_check_table','en','Last check:');
INSERT INTO `lng_data` VALUES ('common','webr_leave','en','Unsubscribe Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_modified_items','en','Saved modifications.');
INSERT INTO `lng_data` VALUES ('common','webr_never_checked','en','Never checked');
INSERT INTO `lng_data` VALUES ('common','webr_new','en','Add new Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_no_items_created','en','No Web Resources created');
INSERT INTO `lng_data` VALUES ('common','webr_read','en','Read access to Web Resource');
INSERT INTO `lng_data` VALUES ('common','webr_sure_delete_items','en','Do you really want to delete the following Web Resource(s)?');
INSERT INTO `lng_data` VALUES ('common','webr_visible','en','Web Resource is visible');
INSERT INTO `lng_data` VALUES ('common','webr_write','en','Edit Web Resource');
INSERT INTO `lng_data` VALUES ('common','webservices','en','Webservices');
INSERT INTO `lng_data` VALUES ('common','week','en','Week');
INSERT INTO `lng_data` VALUES ('common','weekly','en','weekly');
INSERT INTO `lng_data` VALUES ('common','weeks','en','Weeks');
INSERT INTO `lng_data` VALUES ('common','welcome','en','Welcome');
INSERT INTO `lng_data` VALUES ('common','who_is_online','en','Who is online?');
INSERT INTO `lng_data` VALUES ('common','width_x_height','en','Width x Height');
INSERT INTO `lng_data` VALUES ('common','with','en','with');
INSERT INTO `lng_data` VALUES ('common','write','en','Write');
INSERT INTO `lng_data` VALUES ('common','wrong_ip_detected','en','Your access is denied because of a wrong client ip.<br>Please contact the system administrator.');
INSERT INTO `lng_data` VALUES ('common','year','en','Year');
INSERT INTO `lng_data` VALUES ('common','years','en','Years');
INSERT INTO `lng_data` VALUES ('common','yes','en','Yes');
INSERT INTO `lng_data` VALUES ('common','you_may_add_local_roles','en','You May Add Local Roles');
INSERT INTO `lng_data` VALUES ('common','your_message','en','Your Message');
INSERT INTO `lng_data` VALUES ('common','zip','en','Zip Code');
INSERT INTO `lng_data` VALUES ('common','zipcode','en','Zip Code');
INSERT INTO `lng_data` VALUES ('content','HTML export','en','HTML Export');
INSERT INTO `lng_data` VALUES ('content','PDF export','en','PDF Export');
INSERT INTO `lng_data` VALUES ('content','Pages','en','Pages');
INSERT INTO `lng_data` VALUES ('content','add_menu_entry','en','Add menu entry >>');
INSERT INTO `lng_data` VALUES ('content','all','en','All');
INSERT INTO `lng_data` VALUES ('content','all_pages','en','the entire Learning module');
INSERT INTO `lng_data` VALUES ('content','choose_public_mode','en','Unregistered users may access');
INSERT INTO `lng_data` VALUES ('content','choose_public_pages','en','Choose public accessible pages');
INSERT INTO `lng_data` VALUES ('content','citate','en','Citate');
INSERT INTO `lng_data` VALUES ('content','citate_from','en','Citate From ...');
INSERT INTO `lng_data` VALUES ('content','citate_page','en','Citate this Page');
INSERT INTO `lng_data` VALUES ('content','citate_to','en','Citate To ...');
INSERT INTO `lng_data` VALUES ('content','cont_Additional','en','Additional');
INSERT INTO `lng_data` VALUES ('content','cont_Alphabetic','en','Alphabetic a, b, ...  ');
INSERT INTO `lng_data` VALUES ('content','cont_Circle','en','Circle');
INSERT INTO `lng_data` VALUES ('content','cont_Citation','en','Citation');
INSERT INTO `lng_data` VALUES ('content','cont_Code','en','Code');
INSERT INTO `lng_data` VALUES ('content','cont_Example','en','e.g.  ');
INSERT INTO `lng_data` VALUES ('content','cont_Headline1','en','Headline 1');
INSERT INTO `lng_data` VALUES ('content','cont_Headline2','en','Headline 2');
INSERT INTO `lng_data` VALUES ('content','cont_Headline3','en','Headline 3');
INSERT INTO `lng_data` VALUES ('content','cont_List','en','List');
INSERT INTO `lng_data` VALUES ('content','cont_LocalFile','en','Local File');
INSERT INTO `lng_data` VALUES ('content','cont_Mnemonic','en','Mnemonic');
INSERT INTO `lng_data` VALUES ('content','cont_Number','en','Number');
INSERT INTO `lng_data` VALUES ('content','cont_Poly','en','Polygon');
INSERT INTO `lng_data` VALUES ('content','cont_Rect','en','Rectangle');
INSERT INTO `lng_data` VALUES ('content','cont_Reference','en','Reference');
INSERT INTO `lng_data` VALUES ('content','cont_Remark','en','Remark');
INSERT INTO `lng_data` VALUES ('content','cont_Roman','en','Roman i, ii, ...  ');
INSERT INTO `lng_data` VALUES ('content','cont_TableContent','en','Table Content');
INSERT INTO `lng_data` VALUES ('content','cont_Unordered','en','Unordered');
INSERT INTO `lng_data` VALUES ('content','cont_act_number','en','Chapter Numeration');
INSERT INTO `lng_data` VALUES ('content','cont_activate_page','en','Activate Page');
INSERT INTO `lng_data` VALUES ('content','cont_active','en','Enable Menu');
INSERT INTO `lng_data` VALUES ('content','cont_add_area','en','Add Area');
INSERT INTO `lng_data` VALUES ('content','cont_add_change_comment','en','Add change comment');
INSERT INTO `lng_data` VALUES ('content','cont_add_definition','en','Add Definition');
INSERT INTO `lng_data` VALUES ('content','cont_add_fullscreen','en','Add Full Screen');
INSERT INTO `lng_data` VALUES ('content','cont_added_comment','en','Comment has been added to history.');
INSERT INTO `lng_data` VALUES ('content','cont_added_term','en','Term added');
INSERT INTO `lng_data` VALUES ('content','cont_all_definitions','en','All Definitions');
INSERT INTO `lng_data` VALUES ('content','cont_all_pages','en','All Pages');
INSERT INTO `lng_data` VALUES ('content','cont_annex','en','Annex');
INSERT INTO `lng_data` VALUES ('content','cont_api_adapter','en','API Adapter Name');
INSERT INTO `lng_data` VALUES ('content','cont_api_func_prefix','en','API Functions Prefix');
INSERT INTO `lng_data` VALUES ('content','cont_areas_deleted','en','Map areas deleted.');
INSERT INTO `lng_data` VALUES ('content','cont_assign_full','en','Assign Full Screen');
INSERT INTO `lng_data` VALUES ('content','cont_assign_std','en','Assign Standard');
INSERT INTO `lng_data` VALUES ('content','cont_assign_translation','en','Assign translation');
INSERT INTO `lng_data` VALUES ('content','cont_assignments_deleted','en','The assignments have been deleted');
INSERT INTO `lng_data` VALUES ('content','cont_autoindent','en','Auto Indent');
INSERT INTO `lng_data` VALUES ('content','cont_back','en','Back');
INSERT INTO `lng_data` VALUES ('content','cont_booktitle','en','Book title');
INSERT INTO `lng_data` VALUES ('content','cont_bottom','en','Bottom');
INSERT INTO `lng_data` VALUES ('content','cont_browser_not_js_capable','en','JavaScript enabled editing is not supported for your browser.');
INSERT INTO `lng_data` VALUES ('content','cont_cant_copy_folders','en','Folders cannot be copied to clipboard.');
INSERT INTO `lng_data` VALUES ('content','cont_cant_del_full','en','Deletion of full screen file not possible.');
INSERT INTO `lng_data` VALUES ('content','cont_cant_del_std','en','Deletion of standard view file not possible.');
INSERT INTO `lng_data` VALUES ('content','cont_caption','en','Caption');
INSERT INTO `lng_data` VALUES ('content','cont_change_type','en','Change Type');
INSERT INTO `lng_data` VALUES ('content','cont_chap_and_pages','en','Chapters and Pages');
INSERT INTO `lng_data` VALUES ('content','cont_chap_copy_select_target_now','en','Chapter marked for copying. Select target now.');
INSERT INTO `lng_data` VALUES ('content','cont_chap_select_target_now','en','Chapter marked for moving. Select target now.');
INSERT INTO `lng_data` VALUES ('content','cont_chapters','en','Chapters');
INSERT INTO `lng_data` VALUES ('content','cont_chapters_and_pages','en','Chapters and Pages');
INSERT INTO `lng_data` VALUES ('content','cont_chapters_only','en','Chapters only');
INSERT INTO `lng_data` VALUES ('content','cont_characteristic','en','Characteristic');
INSERT INTO `lng_data` VALUES ('content','cont_choose_cont_obj','en','Choose Content Object');
INSERT INTO `lng_data` VALUES ('content','cont_choose_glossary','en','Choose Glossary');
INSERT INTO `lng_data` VALUES ('content','cont_choose_media_source','en','Choose Media Source');
INSERT INTO `lng_data` VALUES ('content','cont_citation_err_one','en','You must select exactly one edition');
INSERT INTO `lng_data` VALUES ('content','cont_citation_selection_not_valid','en','You\'re selection is not valid');
INSERT INTO `lng_data` VALUES ('content','cont_citations','en','Citations');
INSERT INTO `lng_data` VALUES ('content','cont_click_br_corner','en','Please click on the bottom right corner of the desired area.');
INSERT INTO `lng_data` VALUES ('content','cont_click_center','en','Please click on center of the desired area.');
INSERT INTO `lng_data` VALUES ('content','cont_click_circle','en','Please click on a circle point of the desired area.');
INSERT INTO `lng_data` VALUES ('content','cont_click_next_or_save','en','Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)');
INSERT INTO `lng_data` VALUES ('content','cont_click_next_point','en','Please click on the next point of the polygon.');
INSERT INTO `lng_data` VALUES ('content','cont_click_starting_point','en','Please click on the starting point of the polygon.');
INSERT INTO `lng_data` VALUES ('content','cont_click_tl_corner','en','Please click on the top left corner of the desired area.');
INSERT INTO `lng_data` VALUES ('content','cont_confirm_delete','en','really delete ?');
INSERT INTO `lng_data` VALUES ('content','cont_content','en','Content');
INSERT INTO `lng_data` VALUES ('content','cont_content_obj','en','Content Object');
INSERT INTO `lng_data` VALUES ('content','cont_contents','en','Contents');
INSERT INTO `lng_data` VALUES ('content','cont_coords','en','Coordinates');
INSERT INTO `lng_data` VALUES ('content','cont_copy_object','en','copy object');
INSERT INTO `lng_data` VALUES ('content','cont_copy_to_clipboard','en','Copy to clipboard');
INSERT INTO `lng_data` VALUES ('content','cont_copy_to_media_pool','en','Copy to media pool');
INSERT INTO `lng_data` VALUES ('content','cont_create_dir','en','Create Directory');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file','en','Create Export File');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_html','en','Create Export File (HTML)');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_scorm','en','Create Export File (SCORM)');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_xml','en','Create Export File (XML)');
INSERT INTO `lng_data` VALUES ('content','cont_create_folder','en','Create Folder');
INSERT INTO `lng_data` VALUES ('content','cont_create_html_version','en','Create HTML Package');
INSERT INTO `lng_data` VALUES ('content','cont_create_mob','en','Create Media Object');
INSERT INTO `lng_data` VALUES ('content','cont_credit_mode','en','Credit mode (for lesson mode \'normal\')');
INSERT INTO `lng_data` VALUES ('content','cont_credit_off','en','No Credit');
INSERT INTO `lng_data` VALUES ('content','cont_credit_on','en','Credit');
INSERT INTO `lng_data` VALUES ('content','cont_credits','en','Credits');
INSERT INTO `lng_data` VALUES ('content','cont_cross_reference','en','Cross reference');
INSERT INTO `lng_data` VALUES ('content','cont_data_from_lms','en','adlcp:datafromlms');
INSERT INTO `lng_data` VALUES ('content','cont_de_activate','en','(De-)Activate');
INSERT INTO `lng_data` VALUES ('content','cont_deactivate_page','en','Deactivate Page');
INSERT INTO `lng_data` VALUES ('content','cont_def_layout','en','Default Layout');
INSERT INTO `lng_data` VALUES ('content','cont_def_lesson_mode','en','Default lesson mode');
INSERT INTO `lng_data` VALUES ('content','cont_def_organization','en','default');
INSERT INTO `lng_data` VALUES ('content','cont_definition','en','Definition');
INSERT INTO `lng_data` VALUES ('content','cont_definitions','en','Definitions');
INSERT INTO `lng_data` VALUES ('content','cont_del_assignment','en','Delete assignment');
INSERT INTO `lng_data` VALUES ('content','cont_delete_selected','en','Delete');
INSERT INTO `lng_data` VALUES ('content','cont_dependencies','en','Dependencies');
INSERT INTO `lng_data` VALUES ('content','cont_derive_from_obj','en','Derive from Object');
INSERT INTO `lng_data` VALUES ('content','cont_details','en','Details');
INSERT INTO `lng_data` VALUES ('content','cont_dir_file','en','Directory/File');
INSERT INTO `lng_data` VALUES ('content','cont_disable_js','en','JavaScript inactive');
INSERT INTO `lng_data` VALUES ('content','cont_disable_media','en','Media inactive');
INSERT INTO `lng_data` VALUES ('content','cont_disable_html','en','HTML inactive');
INSERT INTO `lng_data` VALUES ('content','cont_enable_html','en','HTML active');
INSERT INTO `lng_data` VALUES ('content','cont_download_title','en','Download Title');
INSERT INTO `lng_data` VALUES ('content','cont_downloads','en','Downloads');
INSERT INTO `lng_data` VALUES ('content','cont_downloads_desc','en','Enable download of all public export files.');
INSERT INTO `lng_data` VALUES ('content','cont_downloads_public_desc','en','Allow download even for anonymous users (in public area)');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_center','en','Align: Center');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_left','en','Align: Left');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_left_float','en','Align: Left Float');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_right','en','Align: Right');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_right_float','en','Align: Right Float');
INSERT INTO `lng_data` VALUES ('content','cont_ed_class','en','Style');
INSERT INTO `lng_data` VALUES ('content','cont_ed_col_left','en','Move Column Left');
INSERT INTO `lng_data` VALUES ('content','cont_ed_col_right','en','Move Column Right');
INSERT INTO `lng_data` VALUES ('content','cont_ed_copy_clip','en','Copy to Clipboard');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete','en','Delete');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_col','en','Delete Column');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_item','en','Delete Item');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_row','en','Delete Row');
INSERT INTO `lng_data` VALUES ('content','cont_ed_edit','en','Edit');
INSERT INTO `lng_data` VALUES ('content','cont_ed_edit_prop','en','Edit Properties');
INSERT INTO `lng_data` VALUES ('content','cont_ed_enable','en','(De-)Activate Elements');
INSERT INTO `lng_data` VALUES ('content','cont_ed_go','en','Go');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_code','en','Insert Code');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_filelist','en','Insert File List');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_list','en','Insert List');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_media','en','Insert Media');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_par','en','Insert Paragr.');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_table','en','Insert Table');
INSERT INTO `lng_data` VALUES ('content','cont_ed_item_down','en','Move Item Down');
INSERT INTO `lng_data` VALUES ('content','cont_ed_item_up','en','Move Item Up');
INSERT INTO `lng_data` VALUES ('content','cont_ed_moveafter','en','Move After');
INSERT INTO `lng_data` VALUES ('content','cont_ed_movebefore','en','Move Before');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_col_after','en','New Column After');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_col_before','en','New Column Before');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_item_after','en','New Item After');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_item_before','en','New Item Before');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_row_after','en','New Row After');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_row_before','en','New Row Before');
INSERT INTO `lng_data` VALUES ('content','cont_ed_paste_clip','en','Paste From Clipboard');
INSERT INTO `lng_data` VALUES ('content','cont_ed_row_down','en','Move Row Down');
INSERT INTO `lng_data` VALUES ('content','cont_ed_row_up','en','Move Row Up');
INSERT INTO `lng_data` VALUES ('content','cont_ed_split_page','en','Split to New Page');
INSERT INTO `lng_data` VALUES ('content','cont_ed_split_page_next','en','Split to Next Page');
INSERT INTO `lng_data` VALUES ('content','cont_ed_width','en','Width');
INSERT INTO `lng_data` VALUES ('content','cont_edit_area','en','Edit Area');
INSERT INTO `lng_data` VALUES ('content','cont_edit_file_list_properties','en','Edit File List Properties');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob','en','Edit Media Object');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_alias_prop','en','Edit Media Object Instance Properties');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_files','en','Object Files');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_properties','en','Edit Media Object Properties');
INSERT INTO `lng_data` VALUES ('content','cont_edit_par','en','Edit Paragraph');
INSERT INTO `lng_data` VALUES ('content','cont_edit_src','en','Edit source code');
INSERT INTO `lng_data` VALUES ('content','cont_edit_tab_properties','en','Table Properties');
INSERT INTO `lng_data` VALUES ('content','cont_edit_term','en','Edit Term');
INSERT INTO `lng_data` VALUES ('content','cont_edition','en','Edition');
INSERT INTO `lng_data` VALUES ('content','cont_empty_mep_folder','en','There are no media objects in this folder.');
INSERT INTO `lng_data` VALUES ('content','cont_enable_js','en','JavaScript active');
INSERT INTO `lng_data` VALUES ('content','cont_enable_media','en','Media active');
INSERT INTO `lng_data` VALUES ('content','cont_export_files','en','Export Files');
INSERT INTO `lng_data` VALUES ('content','cont_external','en','external');
INSERT INTO `lng_data` VALUES ('content','cont_external_url','en','external url');
INSERT INTO `lng_data` VALUES ('content','cont_file','en','File');
INSERT INTO `lng_data` VALUES ('content','cont_files','en','Files');
INSERT INTO `lng_data` VALUES ('content','cont_fix_tree','en','Fix structure');
INSERT INTO `lng_data` VALUES ('content','cont_fix_tree_confirm','en','Please execute this command only if the tree structure of this learning module is corrupted, e.g. if blank items occur in the explorer view.');
INSERT INTO `lng_data` VALUES ('content','cont_footer','en','Footer');
INSERT INTO `lng_data` VALUES ('content','cont_format','en','Format');
INSERT INTO `lng_data` VALUES ('content','cont_format_error','en','This operation is not allowed here!');
INSERT INTO `lng_data` VALUES ('content','cont_frame_botright','en','Content Details (Glossary)');
INSERT INTO `lng_data` VALUES ('content','cont_frame_maincontent','en','Learning Resource Main Content');
INSERT INTO `lng_data` VALUES ('content','cont_frame_right','en','Content Details');
INSERT INTO `lng_data` VALUES ('content','cont_frame_toc','en','Table of Contents');
INSERT INTO `lng_data` VALUES ('content','cont_frame_topright','en','Content Details (FAQ and Media)');
INSERT INTO `lng_data` VALUES ('content','cont_free_pages','en','Free Pages');
INSERT INTO `lng_data` VALUES ('content','cont_full_is_in_dir','en','Deletion not possible. Full screen file is in directory.');
INSERT INTO `lng_data` VALUES ('content','cont_fullscreen','en','Full Screen');
INSERT INTO `lng_data` VALUES ('content','cont_get_link','en','get link');
INSERT INTO `lng_data` VALUES ('content','cont_get_orig_size','en','Set original size');
INSERT INTO `lng_data` VALUES ('content','cont_glo_menu','en','Menu');
INSERT INTO `lng_data` VALUES ('content','cont_glo_properties','en','Glossary Properties');
INSERT INTO `lng_data` VALUES ('content','cont_header','en','Header');
INSERT INTO `lng_data` VALUES ('content','cont_height','en','Height');
INSERT INTO `lng_data` VALUES ('content','cont_how_published','en','How published');
INSERT INTO `lng_data` VALUES ('content','cont_href','en','href');
INSERT INTO `lng_data` VALUES ('content','cont_id_ref','en','identifierref');
INSERT INTO `lng_data` VALUES ('content','cont_imagemap','en','Image Map');
INSERT INTO `lng_data` VALUES ('content','cont_import_id','en','identifier');
INSERT INTO `lng_data` VALUES ('content','cont_insert_file_item','en','Insert File Item');
INSERT INTO `lng_data` VALUES ('content','cont_insert_file_list','en','Insert File List');
INSERT INTO `lng_data` VALUES ('content','cont_insert_list','en','Insert List');
INSERT INTO `lng_data` VALUES ('content','cont_insert_mob','en','Insert Media Object');
INSERT INTO `lng_data` VALUES ('content','cont_insert_new_footnote','en','insert new footnote');
INSERT INTO `lng_data` VALUES ('content','cont_insert_par','en','Insert Paragraph');
INSERT INTO `lng_data` VALUES ('content','cont_insert_search','en','Please insert a search term');
INSERT INTO `lng_data` VALUES ('content','cont_insert_src','en','Insert source code');
INSERT INTO `lng_data` VALUES ('content','cont_insert_table','en','Insert Table');
INSERT INTO `lng_data` VALUES ('content','cont_internal','en','internal');
INSERT INTO `lng_data` VALUES ('content','cont_internal_link','en','internal link');
INSERT INTO `lng_data` VALUES ('content','cont_is_visible','en','isvisible');
INSERT INTO `lng_data` VALUES ('content','cont_isbn','en','ISBN');
INSERT INTO `lng_data` VALUES ('content','cont_issn','en','ISSN');
INSERT INTO `lng_data` VALUES ('content','cont_item','en','Item');
INSERT INTO `lng_data` VALUES ('content','cont_journal','en','Journal');
INSERT INTO `lng_data` VALUES ('content','cont_keyword','en','Keyword');
INSERT INTO `lng_data` VALUES ('content','cont_link','en','Link');
INSERT INTO `lng_data` VALUES ('content','cont_link_area','en','Link Area');
INSERT INTO `lng_data` VALUES ('content','cont_link_ext','en','Link (external)');
INSERT INTO `lng_data` VALUES ('content','cont_link_int','en','Link (internal)');
INSERT INTO `lng_data` VALUES ('content','cont_link_select','en','Internal Link');
INSERT INTO `lng_data` VALUES ('content','cont_link_type','en','Link Type');
INSERT INTO `lng_data` VALUES ('content','cont_linked_mobs','en','Linked media objects');
INSERT INTO `lng_data` VALUES ('content','cont_list_files','en','List Files');
INSERT INTO `lng_data` VALUES ('content','cont_list_properties','en','List Properties');
INSERT INTO `lng_data` VALUES ('content','cont_lk_chapter','en','Chapter');
INSERT INTO `lng_data` VALUES ('content','cont_lk_chapter_new','en','Chapter (New Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_faq','en','Media (FAQ Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_inline','en','Media (Inline)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_media','en','Media (Media Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_new','en','Media (New Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page','en','Page');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page_faq','en','Page (FAQ Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page_new','en','Page (New Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lk_survey','en','Survey');
INSERT INTO `lng_data` VALUES ('content','cont_lk_term','en','Glossary Term');
INSERT INTO `lng_data` VALUES ('content','cont_lk_term_new','en','Glossary Term (New Frame)');
INSERT INTO `lng_data` VALUES ('content','cont_lm_menu','en','Menu');
INSERT INTO `lng_data` VALUES ('content','cont_lm_properties','en','Learning Module Properties');
INSERT INTO `lng_data` VALUES ('content','cont_lvalue','en','Data element');
INSERT INTO `lng_data` VALUES ('content','cont_manifest','en','Manifest');
INSERT INTO `lng_data` VALUES ('content','cont_map_areas','en','Link Areas');
INSERT INTO `lng_data` VALUES ('content','cont_mastery_score','en','adlcp:masteryscore');
INSERT INTO `lng_data` VALUES ('content','cont_max_time_allowed','en','adlcp:maxtimeallowed');
INSERT INTO `lng_data` VALUES ('content','cont_media_source','en','Media Source');
INSERT INTO `lng_data` VALUES ('content','cont_mep_structure','en','Media Pool Structure');
INSERT INTO `lng_data` VALUES ('content','cont_missing_preconditions','en','You need to fulfill the following preconditions to access the chapter \"%s\". ');
INSERT INTO `lng_data` VALUES ('content','cont_mob_files','en','Object Files');
INSERT INTO `lng_data` VALUES ('content','cont_mob_inst_prop','en','Instance Properties');
INSERT INTO `lng_data` VALUES ('content','cont_mob_prop','en','Object Properties');
INSERT INTO `lng_data` VALUES ('content','cont_mob_usages','en','Usage');
INSERT INTO `lng_data` VALUES ('content','cont_month','en','Month');
INSERT INTO `lng_data` VALUES ('content','cont_move_object','en','move object');
INSERT INTO `lng_data` VALUES ('content','cont_msg_multiple_editions','en','It\'s not possible to show details of multiple editions');
INSERT INTO `lng_data` VALUES ('content','cont_name','en','Name');
INSERT INTO `lng_data` VALUES ('content','cont_new_area','en','New Link Area');
INSERT INTO `lng_data` VALUES ('content','cont_new_assignment','en','New assignment');
INSERT INTO `lng_data` VALUES ('content','cont_new_dir','en','New Directory');
INSERT INTO `lng_data` VALUES ('content','cont_new_file','en','New File');
INSERT INTO `lng_data` VALUES ('content','cont_new_media_obj','en','New Media Object');
INSERT INTO `lng_data` VALUES ('content','cont_new_term','en','New Term');
INSERT INTO `lng_data` VALUES ('content','cont_no_access','en','No Access');
INSERT INTO `lng_data` VALUES ('content','cont_no_assign_itself','en','The object cannot be assigned to itself');
INSERT INTO `lng_data` VALUES ('content','cont_no_manifest','en','No imsmanifest.xml file found in main directory.');
INSERT INTO `lng_data` VALUES ('content','cont_no_object_found','en','Could not find any object with this title');
INSERT INTO `lng_data` VALUES ('content','cont_no_page','en','No Page found.');
INSERT INTO `lng_data` VALUES ('content','cont_no_subdir_in_zip','en','Zip command failed or import file invalid.<br>It does not contain a subfolder \'%s\'.');
INSERT INTO `lng_data` VALUES ('content','cont_no_zip_file','en','Import file is not a zip file.');
INSERT INTO `lng_data` VALUES ('content','cont_none','en','None');
INSERT INTO `lng_data` VALUES ('content','cont_nr_cols','en','Number of Columns');
INSERT INTO `lng_data` VALUES ('content','cont_nr_items','en','Number of Items');
INSERT INTO `lng_data` VALUES ('content','cont_nr_rows','en','Number of Rows');
INSERT INTO `lng_data` VALUES ('content','cont_obj_removed','en','Objects removed.');
INSERT INTO `lng_data` VALUES ('content','cont_offline','en','Offline Versions');
INSERT INTO `lng_data` VALUES ('content','cont_offline_files','en','Offline versions');
INSERT INTO `lng_data` VALUES ('content','cont_offline_versions','en','Offline Versions');
INSERT INTO `lng_data` VALUES ('content','cont_online','en','Online');
INSERT INTO `lng_data` VALUES ('content','cont_or','en','or');
INSERT INTO `lng_data` VALUES ('content','cont_order','en','Order Type');
INSERT INTO `lng_data` VALUES ('content','cont_organization','en','Organization');
INSERT INTO `lng_data` VALUES ('content','cont_organizations','en','Organizations');
INSERT INTO `lng_data` VALUES ('content','cont_orig_size','en','Original Size');
INSERT INTO `lng_data` VALUES ('content','cont_page_deactivated','en','Page is deactivated.');
INSERT INTO `lng_data` VALUES ('content','cont_page_deactivated_elements','en','Page contains deactivated elements.');
INSERT INTO `lng_data` VALUES ('content','cont_page_header','en','Page Header');
INSERT INTO `lng_data` VALUES ('content','cont_page_link','en','Page Link');
INSERT INTO `lng_data` VALUES ('content','cont_page_select_target_now','en','Page marked for moving. Select target now.');
INSERT INTO `lng_data` VALUES ('content','cont_pages','en','Pages');
INSERT INTO `lng_data` VALUES ('content','cont_parameter','en','Parameter');
INSERT INTO `lng_data` VALUES ('content','cont_parameters','en','parameters');
INSERT INTO `lng_data` VALUES ('content','cont_paste_from_clipboard','en','Paste from clipboard');
INSERT INTO `lng_data` VALUES ('content','cont_personal_clipboard','en','Personal Clipboard');
INSERT INTO `lng_data` VALUES ('content','cont_pg_content','en','Page Content');
INSERT INTO `lng_data` VALUES ('content','cont_pg_title','en','Page Title');
INSERT INTO `lng_data` VALUES ('content','cont_please_select','en','please select');
INSERT INTO `lng_data` VALUES ('content','cont_prereq_type','en','adlcp:prerequisites.type');
INSERT INTO `lng_data` VALUES ('content','cont_prerequisites','en','adlcp:prerequisites');
INSERT INTO `lng_data` VALUES ('content','cont_preview','en','Preview');
INSERT INTO `lng_data` VALUES ('content','cont_print_view','en','Print View');
INSERT INTO `lng_data` VALUES ('content','cont_public_access','en','Public access');
INSERT INTO `lng_data` VALUES ('content','cont_public_notes','en','Public Notes');
INSERT INTO `lng_data` VALUES ('content','cont_public_notes_desc','en','Allow users to share notes on every page of the learning module.');
INSERT INTO `lng_data` VALUES ('content','cont_publisher','en','Publisher');
INSERT INTO `lng_data` VALUES ('content','cont_purpose','en','Purpose');
INSERT INTO `lng_data` VALUES ('content','cont_ref_helptext','en','(e.g. http://www.server.org/myimage.jpg)');
INSERT INTO `lng_data` VALUES ('content','cont_ref_images','en','Referenced Images');
INSERT INTO `lng_data` VALUES ('content','cont_reference','en','Reference');
INSERT INTO `lng_data` VALUES ('content','cont_remove_fullscreen','en','Remove Full Screen');
INSERT INTO `lng_data` VALUES ('content','cont_removeiln','en','really remove internal link ?');
INSERT INTO `lng_data` VALUES ('content','cont_repository_item','en','Repository Item');
INSERT INTO `lng_data` VALUES ('content','cont_repository_item_links','en','Repository Item Links');
INSERT INTO `lng_data` VALUES ('content','cont_resize_explanation','en','If this option is activated uploaded image files are automatically resized to the specified width and height.');
INSERT INTO `lng_data` VALUES ('content','cont_resize_explanation2','en','This function resizes local image files to the specified width and height.');
INSERT INTO `lng_data` VALUES ('content','cont_resize_image','en','Resize images');
INSERT INTO `lng_data` VALUES ('content','cont_resource','en','Resource');
INSERT INTO `lng_data` VALUES ('content','cont_resource_type','en','type');
INSERT INTO `lng_data` VALUES ('content','cont_resources','en','Resources');
INSERT INTO `lng_data` VALUES ('content','cont_rvalue','en','Value');
INSERT INTO `lng_data` VALUES ('content','cont_saved_map_area','en','Saved map area');
INSERT INTO `lng_data` VALUES ('content','cont_saved_map_data','en','Saved map data');
INSERT INTO `lng_data` VALUES ('content','cont_sc_auto_review','en','Set lesson mode \'review\' if student completed SCO');
INSERT INTO `lng_data` VALUES ('content','cont_sc_less_mode_browse','en','Browse');
INSERT INTO `lng_data` VALUES ('content','cont_sc_less_mode_normal','en','Normal');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_browsed','en','Browsed');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_completed','en','Completed');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_failed','en','Failed');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_incomplete','en','Incomplete');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_not_attempted','en','Not attempted');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_running','en','Running');
INSERT INTO `lng_data` VALUES ('content','cont_sc_title','en','title');
INSERT INTO `lng_data` VALUES ('content','cont_school','en','School');
INSERT INTO `lng_data` VALUES ('content','cont_score','en','Score');
INSERT INTO `lng_data` VALUES ('content','cont_scorm_type','en','adlcp:scormtype');
INSERT INTO `lng_data` VALUES ('content','cont_select_item','en','Select at least one item.');
INSERT INTO `lng_data` VALUES ('content','cont_select_max_one_item','en','Please select one item only');
INSERT INTO `lng_data` VALUES ('content','cont_select_max_one_term','en','Select one term only');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_edition','en','Please select at least one edition.');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_translation','en','Please select one translation');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_translation_warning','en','It is not possible to show more than one translation.');
INSERT INTO `lng_data` VALUES ('content','cont_select_term','en','Select a term');
INSERT INTO `lng_data` VALUES ('content','cont_select_translation','en','Please select the assignment from the list above');
INSERT INTO `lng_data` VALUES ('content','cont_series','en','Series');
INSERT INTO `lng_data` VALUES ('content','cont_series_editor','en','Series editor');
INSERT INTO `lng_data` VALUES ('content','cont_series_title','en','Series title');
INSERT INTO `lng_data` VALUES ('content','cont_series_volume','en','Series volume');
INSERT INTO `lng_data` VALUES ('content','cont_set_after','en','insert after');
INSERT INTO `lng_data` VALUES ('content','cont_set_before','en','insert before');
INSERT INTO `lng_data` VALUES ('content','cont_set_cancel','en','cancel');
INSERT INTO `lng_data` VALUES ('content','cont_set_class','en','Set Class');
INSERT INTO `lng_data` VALUES ('content','cont_set_edit_mode','en','Set Edit Mode');
INSERT INTO `lng_data` VALUES ('content','cont_set_into','en','insert into');
INSERT INTO `lng_data` VALUES ('content','cont_set_link','en','Edit Link');
INSERT INTO `lng_data` VALUES ('content','cont_set_shape','en','Edit Shape');
INSERT INTO `lng_data` VALUES ('content','cont_set_start_file','en','Set Start File');
INSERT INTO `lng_data` VALUES ('content','cont_set_width','en','Set Width');
INSERT INTO `lng_data` VALUES ('content','cont_shape','en','Shape');
INSERT INTO `lng_data` VALUES ('content','cont_show','en','Show');
INSERT INTO `lng_data` VALUES ('content','cont_show_citation','en','Show with citation');
INSERT INTO `lng_data` VALUES ('content','cont_show_line_numbers','en','Show line numbers');
INSERT INTO `lng_data` VALUES ('content','cont_show_print_view','en','Show Print View');
INSERT INTO `lng_data` VALUES ('content','cont_size','en','Size (Bytes)');
INSERT INTO `lng_data` VALUES ('content','cont_skip_chapter','en','Skip this chapter');
INSERT INTO `lng_data` VALUES ('content','cont_source','en','Source');
INSERT INTO `lng_data` VALUES ('content','cont_src','en','Source code');
INSERT INTO `lng_data` VALUES ('content','cont_src_other','en','other');
INSERT INTO `lng_data` VALUES ('content','cont_st_on_pg','en','this function is not allowed.');
INSERT INTO `lng_data` VALUES ('content','cont_st_title','en','Chapter Title');
INSERT INTO `lng_data` VALUES ('content','cont_startfile','en','Start File');
INSERT INTO `lng_data` VALUES ('content','cont_status','en','Status');
INSERT INTO `lng_data` VALUES ('content','cont_std_is_in_dir','en','Deletion not possible. Standard view file is in directory.');
INSERT INTO `lng_data` VALUES ('content','cont_std_view','en','Standard View');
INSERT INTO `lng_data` VALUES ('content','cont_structure','en','structure');
INSERT INTO `lng_data` VALUES ('content','cont_style','en','Style');
INSERT INTO `lng_data` VALUES ('content','cont_subchapters','en','Subchapters');
INSERT INTO `lng_data` VALUES ('content','cont_synchronize_frames','en','Synchronise frames');
INSERT INTO `lng_data` VALUES ('content','cont_synchronize_frames_desc','en','This option synchronises the table of contents frame with the content frame and clears additional frames in 3 window view. But it also decreases performance.');
INSERT INTO `lng_data` VALUES ('content','cont_table','en','Table');
INSERT INTO `lng_data` VALUES ('content','cont_table_border','en','Table Border');
INSERT INTO `lng_data` VALUES ('content','cont_table_cellpadding','en','Table Cell Padding');
INSERT INTO `lng_data` VALUES ('content','cont_table_cellspacing','en','Table Cell Spacing');
INSERT INTO `lng_data` VALUES ('content','cont_table_html_import','en','Import HTML Table');
INSERT INTO `lng_data` VALUES ('content','cont_table_html_import_info','en','Import only works with XHTML conform tables. Table must be root tag!');
INSERT INTO `lng_data` VALUES ('content','cont_table_spreadsheet_import','en','Spreadsheet Import');
INSERT INTO `lng_data` VALUES ('content','cont_table_spreadsheet_import_info','en','Paste table from spreadsheet application via clipboard into the textarea.');
INSERT INTO `lng_data` VALUES ('content','cont_table_width','en','Table Width');
INSERT INTO `lng_data` VALUES ('content','cont_target_within_source','en','Target must not be within source object.');
INSERT INTO `lng_data` VALUES ('content','cont_term','en','Term');
INSERT INTO `lng_data` VALUES ('content','cont_terms','en','Terms');
INSERT INTO `lng_data` VALUES ('content','cont_text_code','en','Code:');
INSERT INTO `lng_data` VALUES ('content','cont_text_com','en','Comment:');
INSERT INTO `lng_data` VALUES ('content','cont_text_emp','en','Emphatic Text:');
INSERT INTO `lng_data` VALUES ('content','cont_text_fn','en','Footnote:');
INSERT INTO `lng_data` VALUES ('content','cont_text_iln','en','Internal Link, e.g.:');
INSERT INTO `lng_data` VALUES ('content','cont_text_quot','en','Quotation:');
INSERT INTO `lng_data` VALUES ('content','cont_text_str','en','Strong Text:');
INSERT INTO `lng_data` VALUES ('content','cont_text_tex','en','LaTeX Code:');
INSERT INTO `lng_data` VALUES ('content','cont_text_xln','en','External Link:');
INSERT INTO `lng_data` VALUES ('content','cont_time','en','Time');
INSERT INTO `lng_data` VALUES ('content','cont_time_limit_action','en','adlcp:timelimitaction');
INSERT INTO `lng_data` VALUES ('content','cont_title','en','title');
INSERT INTO `lng_data` VALUES ('content','cont_title_footnotes','en','Footnotes');
INSERT INTO `lng_data` VALUES ('content','cont_toc','en','Table of Contents');
INSERT INTO `lng_data` VALUES ('content','cont_toc_mode','en','Table of Contents shows');
INSERT INTO `lng_data` VALUES ('content','cont_top','en','Top');
INSERT INTO `lng_data` VALUES ('content','cont_total_time','en','Total Time');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_data','en','Tracking Data');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_items','en','Tracking Items');
INSERT INTO `lng_data` VALUES ('content','cont_translations','en','Translation(s)');
INSERT INTO `lng_data` VALUES ('content','cont_translations_assigned','en','The translation(s) have been assigned');
INSERT INTO `lng_data` VALUES ('content','cont_tree_fixed','en','Tree structure has been fixed.');
INSERT INTO `lng_data` VALUES ('content','cont_update','en','Update');
INSERT INTO `lng_data` VALUES ('content','cont_update_names','en','Update Names');
INSERT INTO `lng_data` VALUES ('content','cont_upload_file','en','Upload File');
INSERT INTO `lng_data` VALUES ('content','cont_url','en','URL');
INSERT INTO `lng_data` VALUES ('content','cont_usage','en','Usage');
INSERT INTO `lng_data` VALUES ('content','cont_users_have_mob_in_clip1','en','This media object is in the clipboard of');
INSERT INTO `lng_data` VALUES ('content','cont_users_have_mob_in_clip2','en','user(s).');
INSERT INTO `lng_data` VALUES ('content','cont_validate_file','en','Validate File');
INSERT INTO `lng_data` VALUES ('content','cont_version','en','version');
INSERT INTO `lng_data` VALUES ('content','cont_view_last_export_log','en','Last Export Log');
INSERT INTO `lng_data` VALUES ('content','cont_where_published','en','Where published');
INSERT INTO `lng_data` VALUES ('content','cont_width','en','Width');
INSERT INTO `lng_data` VALUES ('content','cont_wysiwyg','en','Content WYSIWYG');
INSERT INTO `lng_data` VALUES ('content','cont_xml_base','en','xml:base');
INSERT INTO `lng_data` VALUES ('content','cont_year','en','Year');
INSERT INTO `lng_data` VALUES ('content','cont_zip_file_invalid','en','File is not a valid import file.<br>It does not contain a file \'%s\'.');
INSERT INTO `lng_data` VALUES ('content','copied_to_clipboard','en','Copied object(s) to clipboard.');
INSERT INTO `lng_data` VALUES ('content','dgl_pagebreak','en','Pagebreak');
INSERT INTO `lng_data` VALUES ('content','glo_definition_abbr','en','Def.');
INSERT INTO `lng_data` VALUES ('content','glo_term_used_in','en','The following resources linking to that term');
INSERT INTO `lng_data` VALUES ('content','lm_menu_edit_entry','en','Edit menu entry');
INSERT INTO `lng_data` VALUES ('content','lm_menu_entry_target','en','Target');
INSERT INTO `lng_data` VALUES ('content','lm_menu_entry_title','en','Title');
INSERT INTO `lng_data` VALUES ('content','lm_menu_new_entry','en','Create a new menu entry');
INSERT INTO `lng_data` VALUES ('content','lm_menu_select_internal_object','en','Select internal object >>');
INSERT INTO `lng_data` VALUES ('content','lm_menu_select_object_to_add','en','Please select the object you want to add to the menu');
INSERT INTO `lng_data` VALUES ('content','msg_entry_added','en','Menu entry added');
INSERT INTO `lng_data` VALUES ('content','msg_entry_removed','en','Menu entry removed');
INSERT INTO `lng_data` VALUES ('content','msg_entry_updated','en','Menu entry updated');
INSERT INTO `lng_data` VALUES ('content','msg_page_no_public_access','en','The page you called is not available in the public area. Only registered users may view this page. Please login first to access this page.');
INSERT INTO `lng_data` VALUES ('content','msg_page_not_public','en','Page is not public');
INSERT INTO `lng_data` VALUES ('content','pages from','en','Pages From');
INSERT INTO `lng_data` VALUES ('content','par','en','Paragraph');
INSERT INTO `lng_data` VALUES ('content','pg','en','Page');
INSERT INTO `lng_data` VALUES ('content','public_section','en','Public Area');
INSERT INTO `lng_data` VALUES ('content','read offline','en','Read Offline');
INSERT INTO `lng_data` VALUES ('content','selectFooter','en','Select As Footer');
INSERT INTO `lng_data` VALUES ('content','selectHeader','en','Select As Header');
INSERT INTO `lng_data` VALUES ('content','select_a_file','en','Please select a file.');
INSERT INTO `lng_data` VALUES ('content','selected_pages_only','en','only that pages selected below');
INSERT INTO `lng_data` VALUES ('content','set_public_mode','en','Set public access mode');
INSERT INTO `lng_data` VALUES ('content','st','en','Chapter');
INSERT INTO `lng_data` VALUES ('content','start export','en','Start Export');
INSERT INTO `lng_data` VALUES ('crs','activation_times_not_valid','en','The availability period is not valid.');
INSERT INTO `lng_data` VALUES ('crs','add_event','en','Add Session');
INSERT INTO `lng_data` VALUES ('crs','assigned','en','Assigned');
INSERT INTO `lng_data` VALUES ('crs','contact_email_not_valid','en','the contact email is not valid.');
INSERT INTO `lng_data` VALUES ('crs','crs_accept_subscriber','en','Admission to course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_accept_subscriber_body','en','You have been admitted to course \"%s\". ');
INSERT INTO `lng_data` VALUES ('crs','crs_access_password','en','Password');
INSERT INTO `lng_data` VALUES ('crs','crs_activation','en','Activation');
INSERT INTO `lng_data` VALUES ('crs','crs_add_archive_html','en','Create a HTML Archive');
INSERT INTO `lng_data` VALUES ('crs','crs_add_archive_xml','en','Create a XML Archive');
INSERT INTO `lng_data` VALUES ('crs','crs_add_grouping','en','Add Membership Limitation');
INSERT INTO `lng_data` VALUES ('crs','crs_add_grp_assignment','en','Assign course(s)');
INSERT INTO `lng_data` VALUES ('crs','crs_add_html_archive','en','Add HTML archive');
INSERT INTO `lng_data` VALUES ('crs','crs_add_member','en','Add Member(s)');
INSERT INTO `lng_data` VALUES ('crs','crs_add_objective','en','Add objective');
INSERT INTO `lng_data` VALUES ('crs','crs_add_remove_from_desktop','en','Add/Remove from Desktop');
INSERT INTO `lng_data` VALUES ('crs','crs_add_remove_from_desktop_info','en','Allow the members to add course items to the personal desktop.');
INSERT INTO `lng_data` VALUES ('crs','crs_add_starter','en','Add Start Object');
INSERT INTO `lng_data` VALUES ('crs','crs_add_subscribers','en','Add subscriber');
INSERT INTO `lng_data` VALUES ('crs','crs_added','en','Added new course');
INSERT INTO `lng_data` VALUES ('crs','crs_added_member','en','Addmission to course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_added_member_body','en','You have been admitted to course \"%s\". ');
INSERT INTO `lng_data` VALUES ('crs','crs_added_new_archive','en','A new archive has been added');
INSERT INTO `lng_data` VALUES ('crs','crs_added_objective','en','A new learning objective has been created.');
INSERT INTO `lng_data` VALUES ('crs','crs_added_starters','en','Assigned start object(s).');
INSERT INTO `lng_data` VALUES ('crs','crs_added_to_list','en','You have been assigned to the waiting list. You are assigned to position %s on the waiting list.');
INSERT INTO `lng_data` VALUES ('crs','crs_admin','en','Administrator');
INSERT INTO `lng_data` VALUES ('crs','crs_admin_no_notify','en','Administrator (no notification)');
INSERT INTO `lng_data` VALUES ('crs','crs_admin_notify','en','Administrator (notification)');
INSERT INTO `lng_data` VALUES ('crs','crs_administrators','en','Administrators');
INSERT INTO `lng_data` VALUES ('crs','crs_allow_abo','en','Allow subscription of course items');
INSERT INTO `lng_data` VALUES ('crs','crs_already_assigned_to_list','en','You are already assigned to the waiting list.');
INSERT INTO `lng_data` VALUES ('crs','crs_archive','en','Archives');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_disabled','en','Deactivated');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_download','en','Allow the Download of Course Archives');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_info','en','If enabled, all course content will we suppressed. Only HTML archives of this course will be available to course members.');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_lang','en','Language');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_read','en','Read access');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_select_type','en','Archive view');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_type','en','Archive type');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_type_disabled','en','Not available');
INSERT INTO `lng_data` VALUES ('crs','crs_archives_deleted','en','The archive(s) have been deleted');
INSERT INTO `lng_data` VALUES ('crs','crs_auto_fill','en','Auto fill');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_limitless_info','en','Choose this mode for making the course available and accessible to users (depending on the registration settings below).');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_until_info','en','Choose this mode for making the course available and accessible to users for a fixed period of time (depending on the registration settings below).');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_unvisible_info','en','Choose this mode for preparing the course. Only course administators and tutors can see and edit the course.');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked','en','Access refused');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked_member','en','Membership status in course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked_member_body','en','Your membership for course \"%s\" has been blocked. ');
INSERT INTO `lng_data` VALUES ('crs','crs_cancel_subscription','en','Resigned from course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_cancel_subscription_body','en','A member has resigned from course \"%s\". ');
INSERT INTO `lng_data` VALUES ('crs','crs_change_status','en','Changes status of objective:');
INSERT INTO `lng_data` VALUES ('crs','crs_chapter_already_assigned','en','These chapters are already assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_contact','en','Contact');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_consultation','en','Consultation');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_email','en','Mail');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_name','en','Name');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_phone','en','Telephone');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_responsibility','en','Responsibility');
INSERT INTO `lng_data` VALUES ('crs','crs_content','en','Course Content');
INSERT INTO `lng_data` VALUES ('crs','crs_copy_cat_not_allowed','en','It is not possible to copy categories');
INSERT INTO `lng_data` VALUES ('crs','crs_count_members','en','Number of members');
INSERT INTO `lng_data` VALUES ('crs','crs_count_questions','en','Number of questions');
INSERT INTO `lng_data` VALUES ('crs','crs_create_date','en','Create date');
INSERT INTO `lng_data` VALUES ('crs','crs_crs_structure','en','Course structure');
INSERT INTO `lng_data` VALUES ('crs','crs_dates','en','Dates');
INSERT INTO `lng_data` VALUES ('crs','crs_deassign_lm_sure','en','Are you sure you want to delete this assignment?');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_file','en','Delete File?');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_from_list_sure','en','Are you sure, you want to deassign the following users from the list?');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_from_waiting_list','en','Remove from waiting list');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_member','en','Deassign member(s)');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_members_sure','en','Do you want to delete the following members from this course');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_objectve_sure','en','Are you sure, you want to delete the selected objectives?');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_subscribers','en','Delete subscriber');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_subscribers_sure','en','Do you want to delete the following users');
INSERT INTO `lng_data` VALUES ('crs','crs_details','en','Course Details');
INSERT INTO `lng_data` VALUES ('crs','crs_dismiss_member','en','Terminated membership for course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_dismiss_member_body','en','You membership for course \"%s\" has been terminated ');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_archive','en','Edit Archives');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_content','en','Edit items');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_start_objects','en','Edit Start Objects');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_timings','en','Edit Timings');
INSERT INTO `lng_data` VALUES ('crs','crs_end','en','End');
INSERT INTO `lng_data` VALUES ('crs','crs_existing_files','en','Existing Files:');
INSERT INTO `lng_data` VALUES ('crs','crs_export','en','Course export');
INSERT INTO `lng_data` VALUES ('crs','crs_file','en','File');
INSERT INTO `lng_data` VALUES ('crs','crs_file_download','en','Files for Download');
INSERT INTO `lng_data` VALUES ('crs','crs_file_name','en','File name');
INSERT INTO `lng_data` VALUES ('crs','crs_file_size_info','en','Filesize');
INSERT INTO `lng_data` VALUES ('crs','crs_filename','en','Filename');
INSERT INTO `lng_data` VALUES ('crs','crs_free_places','en','Available places');
INSERT INTO `lng_data` VALUES ('crs','crs_from','en','From:');
INSERT INTO `lng_data` VALUES ('crs','crs_further_settings','en','Further Settings');
INSERT INTO `lng_data` VALUES ('crs','crs_general_info','en','General Informations');
INSERT INTO `lng_data` VALUES ('crs','crs_general_informations','en','General Informations');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping','en','Course grouping');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_assign','en','Change assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_delete_sure','en','Do you really want to delete the following membership limitations?');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_deleted','en','Deleted membership limitation.');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_modified_assignment','en','Changed assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_select_one','en','Please select a membership limitation.');
INSERT INTO `lng_data` VALUES ('crs','crs_groupings','en','Course membership limitations');
INSERT INTO `lng_data` VALUES ('crs','crs_groupings_ask_delete','en','Delete Membership Limitation');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_already_assigned','en','You are already member of this course grouping.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assign_crs','en','Assign course');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assigned_courses','en','Assigned courses.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assigned_courses_info','en','Assigned courses:');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_courses_already_assigned','en','The selected courses were already assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_crs_assignment','en','Course assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_deassigned_courses','en','Delete assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_enter_title','en','Please enter a title.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_info_reg','en','You can only register to one of this courses:');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_matriculation_required','en','This membership limitation requires an unique matriculation number. <br />Please insert this value in your settings on the personal desktop.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_modified_grouping','en','Saved modifications.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_no_course_selected','en','Please select one course.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_no_courses_assigned','en','No assigned courses.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_table_assigned_courses','en','Assigned Courses');
INSERT INTO `lng_data` VALUES ('crs','crs_header_archives','en','Course archives');
INSERT INTO `lng_data` VALUES ('crs','crs_header_delete_members','en','Delete members');
INSERT INTO `lng_data` VALUES ('crs','crs_header_delete_subscribers','en','Delete subscribers');
INSERT INTO `lng_data` VALUES ('crs','crs_header_edit_members','en','Edit members');
INSERT INTO `lng_data` VALUES ('crs','crs_header_members','en','Course members');
INSERT INTO `lng_data` VALUES ('crs','crs_header_remove_from_waiting_list','en','Waiting list: deassign users');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_lms','en','Hide learning materials');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_objectives','en','Hide objectives');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_or','en','Hide other resources');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_tst','en','Hide tests');
INSERT INTO `lng_data` VALUES ('crs','crs_html','en','HTML');
INSERT INTO `lng_data` VALUES ('crs','crs_important_info','en','Important Informations');
INSERT INTO `lng_data` VALUES ('crs','crs_info_download','en','Files for Download');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg','en','Admittance');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_confirmation','en','You can request membership for this course. You will get a message from a course administrator when your request has been admitted or declined.');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_deactivated','en','Course admittance is closed.');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_direct','en','You can join this course directly.');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_password','en','If a course administrator has given you the course password, you can join this course.');
INSERT INTO `lng_data` VALUES ('crs','crs_info_settings','en','Course Informations');
INSERT INTO `lng_data` VALUES ('crs','crs_info_start','en','Please work through all of the course items stated below.<br />After you have processed all red marked objects new course items will be activated.');
INSERT INTO `lng_data` VALUES ('crs','crs_item_availability_info','en','Choose this option for making the item available for a fixed period of time. If \'Visiblity\' is checked the item will remain visble but not accessible for the learners.');
INSERT INTO `lng_data` VALUES ('crs','crs_item_presetting_info','en','Choose this option to offer the learners suggested editing times.');
INSERT INTO `lng_data` VALUES ('crs','crs_learning_materials','en','Learning materials');
INSERT INTO `lng_data` VALUES ('crs','crs_list_users','en','List users');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_assignment','en','Learning material assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_assignment_deleted','en','Deleted assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_deassign','en','Delete assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_no_assignments_selected','en','Please select one assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_lms_already_assigned','en','These learning materials were already assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_materials','en','Course Materials');
INSERT INTO `lng_data` VALUES ('crs','crs_max_members_reached','en','The maximum number of members has been reached');
INSERT INTO `lng_data` VALUES ('crs','crs_mem_change_status','en','Change status');
INSERT INTO `lng_data` VALUES ('crs','crs_mem_send_mail','en','Send mail');
INSERT INTO `lng_data` VALUES ('crs','crs_member','en','Member');
INSERT INTO `lng_data` VALUES ('crs','crs_member_administration','en','Edit Participants');
INSERT INTO `lng_data` VALUES ('crs','crs_member_blocked','en','Member (blocked)');
INSERT INTO `lng_data` VALUES ('crs','crs_member_of','en','Member of course:');
INSERT INTO `lng_data` VALUES ('crs','crs_member_unblocked','en','Member (unblocked)');
INSERT INTO `lng_data` VALUES ('crs','crs_member_updated','en','The member has been updated');
INSERT INTO `lng_data` VALUES ('crs','crs_members','en','Members');
INSERT INTO `lng_data` VALUES ('crs','crs_members_deleted','en','Deleted members');
INSERT INTO `lng_data` VALUES ('crs','crs_members_footer','en','course member(s)');
INSERT INTO `lng_data` VALUES ('crs','crs_members_footer_passed','en','passed');
INSERT INTO `lng_data` VALUES ('crs','crs_members_print_title','en','Course members');
INSERT INTO `lng_data` VALUES ('crs','crs_members_table','en','Course Participants');
INSERT INTO `lng_data` VALUES ('crs','crs_members_title','en','Course members');
INSERT INTO `lng_data` VALUES ('crs','crs_move_down','en','Move down');
INSERT INTO `lng_data` VALUES ('crs','crs_move_up','en','Move up');
INSERT INTO `lng_data` VALUES ('crs','crs_moved_item','en','Moved course item');
INSERT INTO `lng_data` VALUES ('crs','crs_moved_objective','en','Moved learning objective.');
INSERT INTO `lng_data` VALUES ('crs','crs_new_search','en','New search');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription','en','User joined course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_body','en','A user has joined course \"%s\". ');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request','en','Request to join course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request_body','en','A user has requested to join course \"%s\". ');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request_body2','en','You have to call the member administration of that course for accepting or refusing the membership request.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archive_selected','en','No archives selected');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archives_available','en','There are no archives available');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archives_selected','en','Please select an archive');
INSERT INTO `lng_data` VALUES ('crs','crs_no_chapter_selected','en','Please select a chapter.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_groupings_assigned','en','No groupings assigned to this course.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_groups_selected','en','Please select a group');
INSERT INTO `lng_data` VALUES ('crs','crs_no_items_found','en','No items');
INSERT INTO `lng_data` VALUES ('crs','crs_no_language','en','No language');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lm_selected','en','Please select one learning material.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_assigned','en','There are no learning materials assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_inside_course','en','No learning materials found inside this course.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_inside_crs','en','No learning materials inside this course, which can be assigned to this learning objective.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_member_selected','en','Please select one member');
INSERT INTO `lng_data` VALUES ('crs','crs_no_members_assigned','en','There are no members assigned to this course');
INSERT INTO `lng_data` VALUES ('crs','crs_no_notify','en','No notify for new registrations');
INSERT INTO `lng_data` VALUES ('crs','crs_no_objective_selected','en','Please select one objective.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_objectives_created','en','There are no objectives assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_question_selected','en','Please select one question.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_questions_assigned','en','There are no questions assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_results_found','en','No results found');
INSERT INTO `lng_data` VALUES ('crs','crs_no_roles_selected','en','Please select a role');
INSERT INTO `lng_data` VALUES ('crs','crs_no_starter_created','en','No start objects assigned to this course.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_subscribers_selected','en','Please select a user');
INSERT INTO `lng_data` VALUES ('crs','crs_no_tests_inside_crs','en','No tests inside this course, which can be assigned to this learning objective.');
INSERT INTO `lng_data` VALUES ('crs','crs_no_users_added','en','No members added');
INSERT INTO `lng_data` VALUES ('crs','crs_no_users_selected','en','You did not select any user');
INSERT INTO `lng_data` VALUES ('crs','crs_no_valid_member_id_given','en','No valid member Id');
INSERT INTO `lng_data` VALUES ('crs','crs_not_available','en','-Not available-');
INSERT INTO `lng_data` VALUES ('crs','crs_notification','en','Notification');
INSERT INTO `lng_data` VALUES ('crs','crs_notify','en','Notify for new registrations');
INSERT INTO `lng_data` VALUES ('crs','crs_nr','en','Nr.');
INSERT INTO `lng_data` VALUES ('crs','crs_number_users_added','en','The following number of users has been assigned to the course:');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_accomplished','en','Accomplished');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_chapter','en','Assign chapters');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_lm','en','Assign learning material');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_question','en','Assign question');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_deassign_question','en','Delete assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_delete_lm_assignment','en','Delete assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_insert_percent','en','Please enter only numbers between 0 and 100.');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_modified','en','Updated learning objective.');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_no_title_given','en','Please enter a title.');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_not_accomplished','en','Not accomplished');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_overview_objectives','en','Overview objectives');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_overview_question_assignment','en','Overview question assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_pretest','en','Self assessment');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_question_assignment','en','Question assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_result','en','After test');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_updated_test','en','Updated modifications.');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_view','en','Objective oriented view');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives','en','Learning Objectives');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assign_chapter','en','Assign Chapter');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_lm','en','The selected learning materials have been assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_lms','en','Assigned learning materials');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_new_questions','en','Added new assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_questions','en','Assigned questions');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_chapter_assignment','en','Chapter assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_deassign_question_sure','en','Are you sure, you want to delete the following questions?');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_deleted','en','Delete learning objectives');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_edit_question_assignments','en','Edit question assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_final','en','You did not accomplish all course objectives in the previous exam. <br />Please select all red marked objectives one after another and review the related lerning materials. <br />After you have reviewed all red marked objectives, you can take the exam again.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_finished','en','Congratulations, you have accomplished all objectives of this course!');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_none','en','The following is a list of the course objectives.<br /> Please select the objectives one after another and work through the related learning materials.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_pretest','en','The following are the results of your self assessment. <br />Please select the red marked objectives one after another and work through their related learning material. <br />After you have processed all red marked objectives, you can take the final exam of this course, which is located in the test section of this page.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_pretest_non_suggest','en','The following are the results of your self assessment. <br />According to this you have fullfilled any learning objective. You can now take the final exam of this course, which is located in the test section of this page.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_lm_assignment','en','Learning material assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_max_points','en','Maximum points');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_no_question_selected','en','Please select one question.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_nr_questions','en','Number of questions');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_qst_deassigned','en','The question assignment has been deleted.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_reset_sure','en','You want to delete all results of this course. <br />All test results will be deleted.');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_reseted','en','Reseted results.');
INSERT INTO `lng_data` VALUES ('crs','crs_offline','en','Offline');
INSERT INTO `lng_data` VALUES ('crs','crs_options','en','Options');
INSERT INTO `lng_data` VALUES ('crs','crs_other_groupings','en','Groupings of other courses');
INSERT INTO `lng_data` VALUES ('crs','crs_other_resources','en','Other resources');
INSERT INTO `lng_data` VALUES ('crs','crs_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('crs','crs_password_not_valid','en','Your password is not valid');
INSERT INTO `lng_data` VALUES ('crs','crs_password_required','en','This registration procedure requires a password.');
INSERT INTO `lng_data` VALUES ('crs','crs_pdf','en','PDF');
INSERT INTO `lng_data` VALUES ('crs','crs_persons_on_waiting_list','en','Persons on the waiting list');
INSERT INTO `lng_data` VALUES ('crs','crs_print_list','en','Print list');
INSERT INTO `lng_data` VALUES ('crs','crs_question_assignment','en','Question assignment');
INSERT INTO `lng_data` VALUES ('crs','crs_reg','en','Registration');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_deactivated','en','Disabled');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_lim_info','en','Registrations are only possible during a fixed period of time.');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_max_info','en','Define the maximum number of users that can be assigned to this course. \'0\' means unlimited.');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_notify_info','en','If enabled all course administrators/tutors with status \'Notify\' will be informed by email about new registrations.');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_deactivated','en','Registration is disabled');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_end_earlier','en','The registration time is expired');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_max_members_reached','en','The maximum number of users is exceeded.');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_start_later','en','The registration time starts later');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_unlim_info','en','If enabled, there is no time limit for registrations. Please choose one of the registration procedures below.');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_until','en','Registration period');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_already_assigned','en','You are already assigned to this course');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_already_subscribed','en','You have already requested membership for this course');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_blocked','en','You are blocked from this course');
INSERT INTO `lng_data` VALUES ('crs','crs_registration','en','Course registration');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_deactivated','en','Choose this option for disabling course registration. No user can join this course.');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_limited','en','Limited Registration Period');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_type','en','Registration Procedure');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_unlimited','en','Unlimited Registration Period');
INSERT INTO `lng_data` VALUES ('crs','crs_reject_subscriber','en','Declined for course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_reject_subscriber_body','en','Your request to join course \"%s\" has been declined. ');
INSERT INTO `lng_data` VALUES ('crs','crs_reset_results','en','Reset results');
INSERT INTO `lng_data` VALUES ('crs','crs_role','en','Role');
INSERT INTO `lng_data` VALUES ('crs','crs_role_status','en','Role / Status');
INSERT INTO `lng_data` VALUES ('crs','crs_search_enter_search_string','en','Please enter a search string');
INSERT INTO `lng_data` VALUES ('crs','crs_search_for','en','Search for');
INSERT INTO `lng_data` VALUES ('crs','crs_search_members','en','User search');
INSERT INTO `lng_data` VALUES ('crs','crs_search_str','en','Search term');
INSERT INTO `lng_data` VALUES ('crs','crs_select_archive_language','en','Please select a language for the archive');
INSERT INTO `lng_data` VALUES ('crs','crs_select_exactly_one_lm','en','Please select exactly one learning module.');
INSERT INTO `lng_data` VALUES ('crs','crs_select_exactly_one_tst','en','Please select exactly one test.');
INSERT INTO `lng_data` VALUES ('crs','crs_select_native_lm','en','Single chapters can only be assigned to native ILIAS learning modules.');
INSERT INTO `lng_data` VALUES ('crs','crs_select_one_archive','en','Please select one archive');
INSERT INTO `lng_data` VALUES ('crs','crs_select_one_object','en','Please select one course item.');
INSERT INTO `lng_data` VALUES ('crs','crs_select_registration_type','en','Please select an admittance procedure.');
INSERT INTO `lng_data` VALUES ('crs','crs_select_starter','en','Select Start Object');
INSERT INTO `lng_data` VALUES ('crs','crs_set_on_waiting_list','en','You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.');
INSERT INTO `lng_data` VALUES ('crs','crs_settings','en','Course Settings');
INSERT INTO `lng_data` VALUES ('crs','crs_settings_saved','en','Settings saved');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_lms','en','Show learning materials');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_objectives','en','Show objectives');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_or','en','Show other resources');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_tst','en','Show tests');
INSERT INTO `lng_data` VALUES ('crs','crs_show_members','en','Show Members');
INSERT INTO `lng_data` VALUES ('crs','crs_show_members_info','en','If activated, course members can access the members gallery and the send mail to members feature.');
INSERT INTO `lng_data` VALUES ('crs','crs_show_objectives_view','en','Objective view');
INSERT INTO `lng_data` VALUES ('crs','crs_size','en','File size');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_activation','en','Sort by Activation');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_manual','en','Sort Manually');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_manual_info','en','This mode offers you the possibility to sort course items manually.');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_timing_info','en','Sort course items be their activation time or timing presettings.');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_title','en','Sort by Title');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_title_info','en','Choose this mode to sort course items automatically by title.');
INSERT INTO `lng_data` VALUES ('crs','crs_sortorder','en','Sort');
INSERT INTO `lng_data` VALUES ('crs','crs_sortorder_abo','en','Content Item Sorting');
INSERT INTO `lng_data` VALUES ('crs','crs_start','en','Start');
INSERT INTO `lng_data` VALUES ('crs','crs_start_objects','en','Start Objects');
INSERT INTO `lng_data` VALUES ('crs','crs_starter_deleted','en','Removed assignment.');
INSERT INTO `lng_data` VALUES ('crs','crs_starters_already_assigned','en','This object was already assigned.');
INSERT INTO `lng_data` VALUES ('crs','crs_status','en','Status');
INSERT INTO `lng_data` VALUES ('crs','crs_status_changed','en','Status in course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_status_changed_body','en','Your status in course \"%s\" has been changed. ');
INSERT INTO `lng_data` VALUES ('crs','crs_structure','en','Course structure');
INSERT INTO `lng_data` VALUES ('crs','crs_subscribers','en','Subscribers');
INSERT INTO `lng_data` VALUES ('crs','crs_subscribers_deleted','en','Deleted subscriber(s)');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription','en','Subscription');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_max_members','en','Maximum of Users');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_notify','en','Notify for subscriptions');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_confirmation','en','Request Membership');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_deactivated','en','Deactivated');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_direct','en','Join Directly');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_password','en','Join with Course Password');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_requested','en','You have requested membership for the course.');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_successful','en','You have joined the course');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_type','en','Subscription type');
INSERT INTO `lng_data` VALUES ('crs','crs_suggest_lm','en','Suggest learning materials if:');
INSERT INTO `lng_data` VALUES ('crs','crs_suggestion_end','en','Suggested End');
INSERT INTO `lng_data` VALUES ('crs','crs_sure_delete_selected_archives','en','Are you sure to delete the selected archives');
INSERT INTO `lng_data` VALUES ('crs','crs_syllabus','en','Syllabus');
INSERT INTO `lng_data` VALUES ('crs','crs_table_start_objects','en','Start Objects');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_complete','en','Complete');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_not_complete','en','Not complete');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_random','en','Random test');
INSERT INTO `lng_data` VALUES ('crs','crs_time','en','Subscription time');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_availability_enabled','en','Temporarily Available');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_availability_tbl','en','Availability');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_changeable','en','Time Target Changeable');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_changed','en','Timings Modified');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_disabled','en','Timings Disabled');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_disabled_info','en','Choose this option to disable any timings.');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_duration','en','Duration');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_early_begin','en','Earliest Start');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_end','en','Ending Time');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_from_until','en','(From/Until)');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_in_days','en','(In Days)');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_info_active','en','(Active)');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_late_end','en','Latest End');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_not_changed','en','Timings not Modified');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_planed_info','en','Planed Editing Time');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_planed_start','en','Planed');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_presetting','en','Time Target Enabled');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_presetting_tbl','en','Time Target');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_active','en','Enabled');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_changeable','en','Changeable');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_limit_start_end','en','Changeable');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_start_end','en','Suggestion');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_start','en','Starting Time');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_start_end_info','en','(Start/End)');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_sug_begin','en','Suggested Start');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_sug_end','en','Suggested End');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_suggested_info','en','Suggested Editing Time');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_time_frame','en','Time Frame');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_update_error','en','Your settings are not valid, please verify the timings for the following course materials:');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_visibility','en','Visibility');
INSERT INTO `lng_data` VALUES ('crs','crs_to','en','Until:');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor','en','Tutor');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor_no_notify','en','Tutor (no notification)');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor_notify','en','Tutor (notification)');
INSERT INTO `lng_data` VALUES ('crs','crs_tutors','en','Tutors');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked','en','Free entrance');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked_member','en','Status in course \"%s\" ');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked_member_body','en','Your membership in course \"%s\" has been restored ');
INSERT INTO `lng_data` VALUES ('crs','crs_unlimited','en','Unlimited');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribe','en','Unsubscribe');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribe_sure','en','Do you want to unsubscribe from this course');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribed_from_crs','en','You have been unsubscribed from this course');
INSERT INTO `lng_data` VALUES ('crs','crs_update_objective','en','Edit learning objective');
INSERT INTO `lng_data` VALUES ('crs','crs_users_added','en','Added user to the course');
INSERT INTO `lng_data` VALUES ('crs','crs_users_already_assigned','en','The user is already assigned to this course');
INSERT INTO `lng_data` VALUES ('crs','crs_users_removed_from_list','en','The selected users have been removed from the waiting list');
INSERT INTO `lng_data` VALUES ('crs','crs_view_archive','en','Archive View');
INSERT INTO `lng_data` VALUES ('crs','crs_view_info_objective','en','This presentation mode is used for the presentation of learning objectives.');
INSERT INTO `lng_data` VALUES ('crs','crs_view_info_standard','en','This content presentation mode is similar to the presentation of the repository content.');
INSERT INTO `lng_data` VALUES ('crs','crs_view_info_timing','en','Presentation mode for timing presettings.');
INSERT INTO `lng_data` VALUES ('crs','crs_view_mode','en','Course Presentation');
INSERT INTO `lng_data` VALUES ('crs','crs_view_objective','en','Objective Oriented View');
INSERT INTO `lng_data` VALUES ('crs','crs_view_standard','en','Standard View');
INSERT INTO `lng_data` VALUES ('crs','crs_view_timing','en','Timings View');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility','en','Availability');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_limitless','en','Unlimited');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_until','en','Temporarily Available');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_unvisible','en','Not Available');
INSERT INTO `lng_data` VALUES ('crs','crs_wait_info','en','If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.');
INSERT INTO `lng_data` VALUES ('crs','crs_waiting_list','en','Waiting List');
INSERT INTO `lng_data` VALUES ('crs','crs_xml','en','XML');
INSERT INTO `lng_data` VALUES ('crs','crs_youre_position','en','Your position on the waiting list');
INSERT INTO `lng_data` VALUES ('crs','edit_content','en','Edit Content');
INSERT INTO `lng_data` VALUES ('crs','edit_timings_list','en','Edit Timings');
INSERT INTO `lng_data` VALUES ('crs','event','en','Session');
INSERT INTO `lng_data` VALUES ('crs','event_add_new_event','en','Added new session');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials','en','Assign Materials');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials_info','en','Assigned course materials will be displayed directly below the session.');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials_table','en','Assignment of Course Materials');
INSERT INTO `lng_data` VALUES ('crs','event_btn_add','en','Add Session');
INSERT INTO `lng_data` VALUES ('crs','event_date','en','Date of Session:');
INSERT INTO `lng_data` VALUES ('crs','event_date_time','en','Date & Time');
INSERT INTO `lng_data` VALUES ('crs','event_delete_file','en','Delete File?');
INSERT INTO `lng_data` VALUES ('crs','event_delete_sure','en','Do really want to delete this session?');
INSERT INTO `lng_data` VALUES ('crs','event_desc','en','Description');
INSERT INTO `lng_data` VALUES ('crs','event_details_workflow','en','Details/Workflow');
INSERT INTO `lng_data` VALUES ('crs','event_edit_members','en','Edit Participants');
INSERT INTO `lng_data` VALUES ('crs','event_end_date','en','End');
INSERT INTO `lng_data` VALUES ('crs','event_etime_smaller_stime','en','The ending time is earlier than the starting time. Please enter a valid time span.');
INSERT INTO `lng_data` VALUES ('crs','event_existing_files','en','Existing Files:');
INSERT INTO `lng_data` VALUES ('crs','event_file','en','File');
INSERT INTO `lng_data` VALUES ('crs','event_file_download','en','Files for Download');
INSERT INTO `lng_data` VALUES ('crs','event_file_name','en','Filename');
INSERT INTO `lng_data` VALUES ('crs','event_file_size_info','en','Filesize');
INSERT INTO `lng_data` VALUES ('crs','event_full_time_info','en','full-time');
INSERT INTO `lng_data` VALUES ('crs','event_fullday','en','Full-Time');
INSERT INTO `lng_data` VALUES ('crs','event_fulltime_info','en','No Time Specified');
INSERT INTO `lng_data` VALUES ('crs','event_further_informations','en','Further Informations');
INSERT INTO `lng_data` VALUES ('crs','event_general_infos','en','General Informations');
INSERT INTO `lng_data` VALUES ('crs','event_general_properties','en','General Informations');
INSERT INTO `lng_data` VALUES ('crs','event_lecturer','en','Name');
INSERT INTO `lng_data` VALUES ('crs','event_location','en','Location');
INSERT INTO `lng_data` VALUES ('crs','event_participation','en','Participation');
INSERT INTO `lng_data` VALUES ('crs','event_register','en','Register');
INSERT INTO `lng_data` VALUES ('crs','event_registered','en','You have been registered to this session.');
INSERT INTO `lng_data` VALUES ('crs','event_registration','en','Registration');
INSERT INTO `lng_data` VALUES ('crs','event_registration_info','en','Allow users to register to the session.');
INSERT INTO `lng_data` VALUES ('crs','event_registration_participance','en','Registration');
INSERT INTO `lng_data` VALUES ('crs','event_save_participants','en','Save Participance');
INSERT INTO `lng_data` VALUES ('crs','event_start_date','en','Start');
INSERT INTO `lng_data` VALUES ('crs','event_table_create','en','New Session');
INSERT INTO `lng_data` VALUES ('crs','event_table_update','en','Edit Session');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_participants','en','List of Participants');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_participated','en','Participated');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_registered','en','Registered');
INSERT INTO `lng_data` VALUES ('crs','event_time','en','Time');
INSERT INTO `lng_data` VALUES ('crs','event_title','en','Title');
INSERT INTO `lng_data` VALUES ('crs','event_tutor_data','en','Informations About the Lecturer');
INSERT INTO `lng_data` VALUES ('crs','event_unregister','en','Unregister');
INSERT INTO `lng_data` VALUES ('crs','event_unregistered','en','You have been unregistered.');
INSERT INTO `lng_data` VALUES ('crs','event_updated','en','Saved Settings');
INSERT INTO `lng_data` VALUES ('crs','events','en','Sessions');
INSERT INTO `lng_data` VALUES ('crs','events_deleted','en','Session deleted');
INSERT INTO `lng_data` VALUES ('crs','import_crs','en','Import Course');
INSERT INTO `lng_data` VALUES ('crs','learners_view','en','Learners view');
INSERT INTO `lng_data` VALUES ('crs','subscription_times_not_valid','en','The registration period is not valid.');
INSERT INTO `lng_data` VALUES ('crs','timing_accept_table','en','Timings: Remarks');
INSERT INTO `lng_data` VALUES ('crs','timing_accepted','en','Accepted');
INSERT INTO `lng_data` VALUES ('crs','timing_not_accepted','en','Not Accepted');
INSERT INTO `lng_data` VALUES ('crs','timing_remark','en','Remark');
INSERT INTO `lng_data` VALUES ('crs','timing_tutor_visible','en','Remark is visible for course tutors');
INSERT INTO `lng_data` VALUES ('crs','timing_user_accept','en','Accept Timings');
INSERT INTO `lng_data` VALUES ('crs','timing_user_accepted','en','Timings Accepted');
INSERT INTO `lng_data` VALUES ('crs','timings','en','Timings');
INSERT INTO `lng_data` VALUES ('crs','timings_edit','en','Edit Timings');
INSERT INTO `lng_data` VALUES ('crs','timings_of','en','Timings Off');
INSERT INTO `lng_data` VALUES ('crs','timings_timings','en','Timings');
INSERT INTO `lng_data` VALUES ('crs','timings_timings_off','en','Switch Timings Administration Off');
INSERT INTO `lng_data` VALUES ('crs','timings_timings_on','en','Switch Timings Administration On');
INSERT INTO `lng_data` VALUES ('crs','timings_usr_edit','en','Edit Timings');
INSERT INTO `lng_data` VALUES ('crs','tutor_email','en','Mail');
INSERT INTO `lng_data` VALUES ('crs','tutor_firstname','en','Firstname');
INSERT INTO `lng_data` VALUES ('crs','tutor_lastname','en','Lastname');
INSERT INTO `lng_data` VALUES ('crs','tutor_name','en','Name');
INSERT INTO `lng_data` VALUES ('crs','tutor_phone','en','Phone');
INSERT INTO `lng_data` VALUES ('crs','tutor_title','en','Title');
INSERT INTO `lng_data` VALUES ('dateplaner','DateText','en','Message');
INSERT INTO `lng_data` VALUES ('dateplaner','Day_long','en','Day View');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DATE_EXISTS','en','This event already exists.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DB','en','Database write error!');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DB_CONNECT','en','The database is disconnected.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DEL_MSG','en','This is a recurring event. Would you like to delete one event or the series');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ENDDATE','en','Wrong end date input. Format: dd/mm/yyyy');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ENDTIME','en','Wrong end time. Format: hh:mm');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_END_START','en','Wrong end date input. End date is before start date.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_FILE_CSV_MSG','en','Please take a valid CSV File.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_JAVASCRIPT','en','<B><CENTER>your browser doesn\'t accept JavaScript.<br />Please close this Window after insert manually.<br />Thank you</CENTER></B>');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ROTATIONEND','en','Wrong recurring end date input. Format: dd/mm/yyyy');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ROT_END_START','en','Wrong recurring end date input. Recurring end date is before start date.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_SHORTTEXT','en','Wrong short text input. Short text is required.');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_STARTDATE','en','Wrong start date input. Format: dd/mm/yyyy');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_STARTTIME','en','Wrong start time. Format: hh:mm');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_TS','en','Incorrect date format');
INSERT INTO `lng_data` VALUES ('dateplaner','Fr_long','en','Friday');
INSERT INTO `lng_data` VALUES ('dateplaner','Fr_short','en','Fr');
INSERT INTO `lng_data` VALUES ('dateplaner','Language_file','en','English');
INSERT INTO `lng_data` VALUES ('dateplaner','Listbox_long','en','List of Events');
INSERT INTO `lng_data` VALUES ('dateplaner','Mo_long','en','Monday');
INSERT INTO `lng_data` VALUES ('dateplaner','Mo_short','en','Mo');
INSERT INTO `lng_data` VALUES ('dateplaner','Month_long','en','Month View');
INSERT INTO `lng_data` VALUES ('dateplaner','Sa_long','en','Saturday');
INSERT INTO `lng_data` VALUES ('dateplaner','Sa_short','en','Sa');
INSERT INTO `lng_data` VALUES ('dateplaner','Su_long','en','Sunday');
INSERT INTO `lng_data` VALUES ('dateplaner','Su_short','en','Su');
INSERT INTO `lng_data` VALUES ('dateplaner','Text','en','Text');
INSERT INTO `lng_data` VALUES ('dateplaner','Th_long','en','Thursday');
INSERT INTO `lng_data` VALUES ('dateplaner','Th_short','en','Th');
INSERT INTO `lng_data` VALUES ('dateplaner','Tu_long','en','Tuesday');
INSERT INTO `lng_data` VALUES ('dateplaner','Tu_short','en','Tu');
INSERT INTO `lng_data` VALUES ('dateplaner','View','en','View:');
INSERT INTO `lng_data` VALUES ('dateplaner','We_long','en','Wednesday');
INSERT INTO `lng_data` VALUES ('dateplaner','We_short','en','We');
INSERT INTO `lng_data` VALUES ('dateplaner','Week_long','en','Week View');
INSERT INTO `lng_data` VALUES ('dateplaner','add_data','en','Additional Data');
INSERT INTO `lng_data` VALUES ('dateplaner','app_','en','Group Events Inbox');
INSERT INTO `lng_data` VALUES ('dateplaner','app_date','en','Create Event');
INSERT INTO `lng_data` VALUES ('dateplaner','app_day','en','Day View');
INSERT INTO `lng_data` VALUES ('dateplaner','app_freetime','en','Free time of other group members (catch a time)');
INSERT INTO `lng_data` VALUES ('dateplaner','app_inbox','en','Group Events Inbox');
INSERT INTO `lng_data` VALUES ('dateplaner','app_list','en','List of Events');
INSERT INTO `lng_data` VALUES ('dateplaner','app_month','en','Month View');
INSERT INTO `lng_data` VALUES ('dateplaner','app_properties','en','Properties');
INSERT INTO `lng_data` VALUES ('dateplaner','app_week','en','Week View');
INSERT INTO `lng_data` VALUES ('dateplaner','application','en','Calendar');
INSERT INTO `lng_data` VALUES ('dateplaner','apply','en','Apply');
INSERT INTO `lng_data` VALUES ('dateplaner','back','en','Back');
INSERT INTO `lng_data` VALUES ('dateplaner','begin_date','en','Begin Date');
INSERT INTO `lng_data` VALUES ('dateplaner','busytime','en','Busy time in group');
INSERT INTO `lng_data` VALUES ('dateplaner','c_date','en','Create Event');
INSERT INTO `lng_data` VALUES ('dateplaner','changeTo','en','Change to:');
INSERT INTO `lng_data` VALUES ('dateplaner','changedDates','en','Changed Events');
INSERT INTO `lng_data` VALUES ('dateplaner','checkforfreetime','en','Check for free time');
INSERT INTO `lng_data` VALUES ('dateplaner','created','en','Created');
INSERT INTO `lng_data` VALUES ('dateplaner','date','en','Date');
INSERT INTO `lng_data` VALUES ('dateplaner','date_format','en','m/d/Y H:i');
INSERT INTO `lng_data` VALUES ('dateplaner','date_format_middle','en','m/d/y');
INSERT INTO `lng_data` VALUES ('dateplaner','del_all','en','Delete all events');
INSERT INTO `lng_data` VALUES ('dateplaner','del_one','en','Delete one event');
INSERT INTO `lng_data` VALUES ('dateplaner','delete','en','Delete');
INSERT INTO `lng_data` VALUES ('dateplaner','deletedDates','en','Deleted Events');
INSERT INTO `lng_data` VALUES ('dateplaner','discard','en','Discard');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_Grouptime','en','Free time');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_cancel','en','Cancel');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_delete','en','Delete');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_insert','en','Insert');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_update','en','Update');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_begin','en','Start Date:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_end','en','End Date:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_hm','en','Hour:Minute');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_enddate','en','End date:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupselect','en','Group select:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupview','en','Group event:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupview_text','en','Group:<br />');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_keywords','en','Keywords:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_keywordselect','en','Keyword select:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_message','en','Message:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_noGroup','en','no Group');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_noKey','en','no Keyword');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_preview','en','<b>! Preview !</b>');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation','en','Recurrence:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation_date','en','Recurrence date:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation_end','en','Recurrence end:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_shorttext','en','Short text:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_startdate','en','Start date:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_text','en','Text:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_whole_day','en','Whole day:');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_whole_rotation','en','Would you like to delete the entire recurring series? (click the checkbox)');
INSERT INTO `lng_data` VALUES ('dateplaner','end_date','en','End Date');
INSERT INTO `lng_data` VALUES ('dateplaner','endtime_for_view','en','End time for view:');
INSERT INTO `lng_data` VALUES ('dateplaner','error_minical_img','en','Cannot create GD-picture-stream');
INSERT INTO `lng_data` VALUES ('dateplaner','execute','en','Execute choices');
INSERT INTO `lng_data` VALUES ('dateplaner','extra_dates','en','One Day Events');
INSERT INTO `lng_data` VALUES ('dateplaner','free','en','Free');
INSERT INTO `lng_data` VALUES ('dateplaner','freetime','en','Free Time in group');
INSERT INTO `lng_data` VALUES ('dateplaner','group','en','Group');
INSERT INTO `lng_data` VALUES ('dateplaner','help_day','en','Calendar Day View');
INSERT INTO `lng_data` VALUES ('dateplaner','help_day_l','en','In the day view all events of a chosen day are displayed.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_enddate','en','End date - syntax[dd/mm/yyyy]');
INSERT INTO `lng_data` VALUES ('dateplaner','help_enddate_l','en','Contains the end time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endrotation','en','End time syntax[dd/mm/yyyy]');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endrotation_l','en','At this day the repetition will end.<br />The symbol opens a small calendar for choosing the appropriate date');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endtime','en','End time - syntax[hh/mm] 24-hour format');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endtime_l','en','Contains the end time of the appointment using 24-hour format.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_filename','en','dp_help_en.html');
INSERT INTO `lng_data` VALUES ('dateplaner','help_fullday','en','Whole day event - syntax[on/off]');
INSERT INTO `lng_data` VALUES ('dateplaner','help_fullday_l','en','If the event stretches over a whole day, please choose this option.<br />This will hide the start time, end time, and end date.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_further','en','<br /><b>click here for further information.</b>');
INSERT INTO `lng_data` VALUES ('dateplaner','help_group','en','Group events selection');
INSERT INTO `lng_data` VALUES ('dateplaner','help_group_l','en','Contains the groups for which the logged-in user has administrator rights and for which a date can be created.<br />After choosing this it is possible to view the unscheduled time of the group.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_inbox','en','Calendar Inbox');
INSERT INTO `lng_data` VALUES ('dateplaner','help_inbox_l','en','Here all new, changed, and deleted group events are displayed.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keyword','en','Keyword selection');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keywordUse','en','Keyword selection');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keywordUse_l','en','Choose one or more keywords from the dialog box.<br />TIP: use the CTRL key for selecting several entries.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keyword_l','en','Contains the keywords which a user can associate to dates.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_list','en','Calendar event list');
INSERT INTO `lng_data` VALUES ('dateplaner','help_list_l','en','In the event list, all events of a given period of time are displayed.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_month','en','Calendar month view');
INSERT INTO `lng_data` VALUES ('dateplaner','help_month_l','en','In the month view all events of a given month are displayed.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_alt','en','Changes the keyword');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_alt_l','en','Choose a keyword from the dialog box.<br />Change the keyword in the text field. Important: max. 20 characters.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_del','en','Deletes the keyword');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_del_l','en','Choose a keyword from the dialog box. Click the button to delete the keyword.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_import','en','Import of Outlook-CSV-Files');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_import_l','en','Here a CSC-File can be selected, which contains Outlook-Events. These events will be imported into the calendar.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_new','en','Add a keyword, max. 20 characters');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_new_l','en','Add a new keyword to the field \\\"new\\\". Important: max. 20 characters. ');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_time','en','Display time for day view/week view');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_time_l','en','The standard display time for the day view and week view can be changed. If dates are outside of the display time for a given days or week, the display time will be changed for that time span. Standard is 8h -18h.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_rotation','en','Recurrence');
INSERT INTO `lng_data` VALUES ('dateplaner','help_rotation_l','en','Contains the type of the recurrence / repetition.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_shorttext','en','Short text, max. 50 characters');
INSERT INTO `lng_data` VALUES ('dateplaner','help_shorttext_l','en','Here one can enter the short text for a given date.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_startdate','en','Start date - syntax[dd/mm/yyyy]');
INSERT INTO `lng_data` VALUES ('dateplaner','help_startdate_l','en','Contains the starting time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_starttime','en','Start time - syntax[hh/mm] 24-hour format');
INSERT INTO `lng_data` VALUES ('dateplaner','help_starttime_l','en','Contains the starting time of the event using 24-hour format.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_text','en','Text');
INSERT INTO `lng_data` VALUES ('dateplaner','help_text_l','en','Here one can enter the text for a given event.');
INSERT INTO `lng_data` VALUES ('dateplaner','help_week','en','Calendar week view');
INSERT INTO `lng_data` VALUES ('dateplaner','help_week_l','en','In the week view all events of a given week are displayed.');
INSERT INTO `lng_data` VALUES ('dateplaner','hour','en','hour');
INSERT INTO `lng_data` VALUES ('dateplaner','importDates','en','Import of Outlook Events');
INSERT INTO `lng_data` VALUES ('dateplaner','inbox','en','Inbox');
INSERT INTO `lng_data` VALUES ('dateplaner','insertImportDates','en','These events were successfully registered:');
INSERT INTO `lng_data` VALUES ('dateplaner','k_alldates','en','All Events');
INSERT INTO `lng_data` VALUES ('dateplaner','keep','en','Keep');
INSERT INTO `lng_data` VALUES ('dateplaner','keyword','en','Keyword');
INSERT INTO `lng_data` VALUES ('dateplaner','keywords','en','Keywords');
INSERT INTO `lng_data` VALUES ('dateplaner','last_change','en','Last changed');
INSERT INTO `lng_data` VALUES ('dateplaner','long_01','en','January');
INSERT INTO `lng_data` VALUES ('dateplaner','long_02','en','February');
INSERT INTO `lng_data` VALUES ('dateplaner','long_03','en','March');
INSERT INTO `lng_data` VALUES ('dateplaner','long_04','en','April');
INSERT INTO `lng_data` VALUES ('dateplaner','long_05','en','May');
INSERT INTO `lng_data` VALUES ('dateplaner','long_06','en','June');
INSERT INTO `lng_data` VALUES ('dateplaner','long_07','en','July');
INSERT INTO `lng_data` VALUES ('dateplaner','long_08','en','August');
INSERT INTO `lng_data` VALUES ('dateplaner','long_09','en','September');
INSERT INTO `lng_data` VALUES ('dateplaner','long_10','en','October');
INSERT INTO `lng_data` VALUES ('dateplaner','long_11','en','November');
INSERT INTO `lng_data` VALUES ('dateplaner','long_12','en','December');
INSERT INTO `lng_data` VALUES ('dateplaner','main_dates','en','Main Events');
INSERT INTO `lng_data` VALUES ('dateplaner','menue','en','Menu');
INSERT INTO `lng_data` VALUES ('dateplaner','mmonth','en','Last Month');
INSERT INTO `lng_data` VALUES ('dateplaner','month','en','Month');
INSERT INTO `lng_data` VALUES ('dateplaner','more','en','More');
INSERT INTO `lng_data` VALUES ('dateplaner','mweek','en','Last Week');
INSERT INTO `lng_data` VALUES ('dateplaner','myeahr','en','Last Year');
INSERT INTO `lng_data` VALUES ('dateplaner','newDates','en','New Events');
INSERT INTO `lng_data` VALUES ('dateplaner','newKeyword','en','New:');
INSERT INTO `lng_data` VALUES ('dateplaner','new_doc','en','Create new event');
INSERT INTO `lng_data` VALUES ('dateplaner','no_entry','en','No events available');
INSERT INTO `lng_data` VALUES ('dateplaner','o_day_date','en','24-hour event');
INSERT INTO `lng_data` VALUES ('dateplaner','of','en','of');
INSERT INTO `lng_data` VALUES ('dateplaner','open_day','en','Day View');
INSERT INTO `lng_data` VALUES ('dateplaner','pmonth','en','Next Month');
INSERT INTO `lng_data` VALUES ('dateplaner','printlist','en','Print');
INSERT INTO `lng_data` VALUES ('dateplaner','properties','en','Properties');
INSERT INTO `lng_data` VALUES ('dateplaner','pweek','en','Next Week');
INSERT INTO `lng_data` VALUES ('dateplaner','pyear','en','Next Year');
INSERT INTO `lng_data` VALUES ('dateplaner','r_14','en','Every 14 days');
INSERT INTO `lng_data` VALUES ('dateplaner','r_4_weeks','en','Every 4 weeks');
INSERT INTO `lng_data` VALUES ('dateplaner','r_day','en','Every day');
INSERT INTO `lng_data` VALUES ('dateplaner','r_halfyear','en','Every half year');
INSERT INTO `lng_data` VALUES ('dateplaner','r_month','en','Every month');
INSERT INTO `lng_data` VALUES ('dateplaner','r_nonrecurring','en','Once');
INSERT INTO `lng_data` VALUES ('dateplaner','r_week','en','Every week');
INSERT INTO `lng_data` VALUES ('dateplaner','r_year','en','Every year');
INSERT INTO `lng_data` VALUES ('dateplaner','readimportfile','en','Insert');
INSERT INTO `lng_data` VALUES ('dateplaner','rotation','en','Recurrence');
INSERT INTO `lng_data` VALUES ('dateplaner','rotation_dates','en','Recurrence events');
INSERT INTO `lng_data` VALUES ('dateplaner','semester_name','en','Semester Name');
INSERT INTO `lng_data` VALUES ('dateplaner','short_01','en','Jan');
INSERT INTO `lng_data` VALUES ('dateplaner','short_02','en','Feb');
INSERT INTO `lng_data` VALUES ('dateplaner','short_03','en','Mar');
INSERT INTO `lng_data` VALUES ('dateplaner','short_04','en','Apr');
INSERT INTO `lng_data` VALUES ('dateplaner','short_05','en','May');
INSERT INTO `lng_data` VALUES ('dateplaner','short_06','en','Jun');
INSERT INTO `lng_data` VALUES ('dateplaner','short_07','en','Jul');
INSERT INTO `lng_data` VALUES ('dateplaner','short_08','en','Aug');
INSERT INTO `lng_data` VALUES ('dateplaner','short_09','en','Sep');
INSERT INTO `lng_data` VALUES ('dateplaner','short_10','en','Oct');
INSERT INTO `lng_data` VALUES ('dateplaner','short_11','en','Nov');
INSERT INTO `lng_data` VALUES ('dateplaner','short_12','en','Dec');
INSERT INTO `lng_data` VALUES ('dateplaner','shorttext','en','Short Text');
INSERT INTO `lng_data` VALUES ('dateplaner','singleDate','en','Single Event');
INSERT INTO `lng_data` VALUES ('dateplaner','starttime_for_view','en','Start time for view:');
INSERT INTO `lng_data` VALUES ('dateplaner','timedate','en','Time / Date');
INSERT INTO `lng_data` VALUES ('dateplaner','timeslice','en','Time:');
INSERT INTO `lng_data` VALUES ('dateplaner','title','en','ILIAS calendar');
INSERT INTO `lng_data` VALUES ('dateplaner','to','en','to');
INSERT INTO `lng_data` VALUES ('dateplaner','today','en','Today');
INSERT INTO `lng_data` VALUES ('dateplaner','viewlist','en','View');
INSERT INTO `lng_data` VALUES ('dateplaner','week','en','Week');
INSERT INTO `lng_data` VALUES ('dateplaner','wk_short','en','WK');
INSERT INTO `lng_data` VALUES ('dateplaner','year','en','Year');
INSERT INTO `lng_data` VALUES ('exercise','exc_comment','en','Comment');
INSERT INTO `lng_data` VALUES ('exercise','exc_comment_for_learner','en','Comment for Learner');
INSERT INTO `lng_data` VALUES ('exercise','exc_failed','en','Failed');
INSERT INTO `lng_data` VALUES ('exercise','exc_feedback_from_tutor','en','Feedback from Tutor');
INSERT INTO `lng_data` VALUES ('exercise','exc_grading','en','Grading');
INSERT INTO `lng_data` VALUES ('exercise','exc_mark','en','Mark');
INSERT INTO `lng_data` VALUES ('exercise','exc_notgraded','en','Not Graded');
INSERT INTO `lng_data` VALUES ('exercise','exc_passed','en','Passed');
INSERT INTO `lng_data` VALUES ('exercise','exc_send_mail','en','Send Mail');
INSERT INTO `lng_data` VALUES ('exercise','exc_your_submission','en','Your Submission');
INSERT INTO `lng_data` VALUES ('forum','forum_anonymize','en','Write anonymously');
INSERT INTO `lng_data` VALUES ('forum','forum_anonymize_desc','en','Write this message anonymously (your ILIAS user name won\'t be shown anywhere).');
INSERT INTO `lng_data` VALUES ('forum','forums','en','Forums');
INSERT INTO `lng_data` VALUES ('forum','forums_all_threads_marked_read','en','All threads have been marked as read');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments','en','Attachments');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments_add','en','Add attachment');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments_edit','en','Edit attachment');
INSERT INTO `lng_data` VALUES ('forum','forums_available','en','Available Forums');
INSERT INTO `lng_data` VALUES ('forum','forums_censor_comment','en','Comment of Censor');
INSERT INTO `lng_data` VALUES ('forum','forums_count','en','Number of Forums');
INSERT INTO `lng_data` VALUES ('forum','forums_count_art','en','Number of Articles');
INSERT INTO `lng_data` VALUES ('forum','forums_count_thr','en','Number of Threads');
INSERT INTO `lng_data` VALUES ('forum','forums_created_by','en','Created by');
INSERT INTO `lng_data` VALUES ('forum','forums_delete_file','en','Delete attachment');
INSERT INTO `lng_data` VALUES ('forum','forums_disable_notification','en','Disable notification');
INSERT INTO `lng_data` VALUES ('forum','forums_download_attachment','en','Download file');
INSERT INTO `lng_data` VALUES ('forum','forums_edit_post','en','Edit Article');
INSERT INTO `lng_data` VALUES ('forum','forums_enable_notification','en','Enable notification');
INSERT INTO `lng_data` VALUES ('forum','forums_info_censor2_post','en','Revoke Censorship?');
INSERT INTO `lng_data` VALUES ('forum','forums_info_censor_post','en','Are you sure you want to hide this article?');
INSERT INTO `lng_data` VALUES ('forum','forums_info_delete_post','en','Are you sure you want to delete this article including any responses?');
INSERT INTO `lng_data` VALUES ('forum','forums_mark_read','en','Mark all read');
INSERT INTO `lng_data` VALUES ('forum','forums_new_entries','en','New Forums Entries');
INSERT INTO `lng_data` VALUES ('forum','forums_new_thread','en','New Topic');
INSERT INTO `lng_data` VALUES ('forum','forums_not_available','en','Forums Not Available');
INSERT INTO `lng_data` VALUES ('forum','forums_notification','en','Notification');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_enabled','en','Notification enabled');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_intro','en','This e-mail was automatically sent to you by the ILIAS installation %s, %s');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_is_disabled','en','Your notification about new posts in this thread is not (yet) enabled.');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_is_enabled','en','At the moment your notification about new posts in this thread is already enabled.');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_show_post','en','Show post: %s');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_subject','en','New post in a forum topic');
INSERT INTO `lng_data` VALUES ('forum','forums_overview','en','Forums Overview');
INSERT INTO `lng_data` VALUES ('forum','forums_post_deleted','en','Article has been deleted');
INSERT INTO `lng_data` VALUES ('forum','forums_post_modified','en','Article has been modified');
INSERT INTO `lng_data` VALUES ('forum','forums_post_new_entry','en','New article has been created');
INSERT INTO `lng_data` VALUES ('forum','forums_posts','en','All articles');
INSERT INTO `lng_data` VALUES ('forum','forums_posts_not_available','en','Articles Not Available');
INSERT INTO `lng_data` VALUES ('forum','forums_print_thread','en','Print Thread');
INSERT INTO `lng_data` VALUES ('forum','forums_print_view','en','Print view');
INSERT INTO `lng_data` VALUES ('forum','forums_quote','en','Quote');
INSERT INTO `lng_data` VALUES ('forum','forums_respond','en','Post Reply');
INSERT INTO `lng_data` VALUES ('forum','forums_subject','en','Subject');
INSERT INTO `lng_data` VALUES ('forum','forums_the_post','en','Article');
INSERT INTO `lng_data` VALUES ('forum','forums_thread','en','Topic');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_articles','en','Articles of the topic');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_create_date','en','Created at');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_create_from','en','Created from');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_marked','en','The Thread has been marked as read.');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_new_entry','en','New topic has been created');
INSERT INTO `lng_data` VALUES ('forum','forums_threads_not_available','en','Topics Not Available');
INSERT INTO `lng_data` VALUES ('forum','forums_topics_overview','en','Topics Overview');
INSERT INTO `lng_data` VALUES ('forum','forums_your_reply','en','Your Reply');
INSERT INTO `lng_data` VALUES ('forum','frm_anonymous_posting','en','Anonymous posting');
INSERT INTO `lng_data` VALUES ('forum','frm_anonymous_posting_desc','en','If enabled, anonymous posting is allowed within this forum.');
INSERT INTO `lng_data` VALUES ('forum','frm_default_view','en','Default view');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_disabled_for_participants','en','Statistics are disabled for forum members.');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_enabled','en','Enable Statistics');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_enabled_desc','en','Enable Posting Statistics for all participants');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_ranking','en','Ranking');
INSERT INTO `lng_data` VALUES ('forum','frm_title_required','en','Please insert a title.');
INSERT INTO `lng_data` VALUES ('forum','is_read','en','mark read');
INSERT INTO `lng_data` VALUES ('forum','new_post','en','New post');
INSERT INTO `lng_data` VALUES ('forum','thread','en','Topic');
INSERT INTO `lng_data` VALUES ('grp','grp_registration_unlimited','en','Unlimited registration period');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalue1','en','Cost center 1');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalue2','en','Cost center 2');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalues','en','Cost centers');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalue1','en','Cost center 1');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalue2','en','Cost center 2');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues','en','Cost centers');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues_desc','en','Enter here the code of the cost center(s) for this user. These values will be stored at the iLinc server.');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues_refreshed','en','Cost centers updated');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_connection_error','en','Error: No connection to iLinc Server!');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_no_account_yet','en','No iLinc Account yet');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_added','en','User account created on iLinc server');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_id','en','iLinc UserID');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_settings','en','iLinc User settings');
INSERT INTO `lng_data` VALUES ('jscalendar','about_calendar','en','About the calendar');
INSERT INTO `lng_data` VALUES ('jscalendar','about_calendar_long','en','DHTML Date/Time Selector\\n(c) dynarch.com 2002-2003\\nFor latest version visit: http://dynarch.com/mishoo/calendar.epl\\nDistributed under GNU LGPL.  See http://gnu.org/licenses/lgpl.html for details.\\n\\nDate selection:\\n- Use the «, » buttons to select year\\n- Use the <, > buttons to select month\\n- Hold mouse button on any of the above buttons for faster selection. ');
INSERT INTO `lng_data` VALUES ('jscalendar','about_time','en','\\n\\nTime selection:\\n- Click on any of the time parts to increase it\\n- or Shift-click to decrease it\\n- or click and drag for faster selection. ');
INSERT INTO `lng_data` VALUES ('jscalendar','close','en','Close');
INSERT INTO `lng_data` VALUES ('jscalendar','day_first','en','Display %s first');
INSERT INTO `lng_data` VALUES ('jscalendar','def_date_format','en','%Y-%m-%d');
INSERT INTO `lng_data` VALUES ('jscalendar','drag_to_move','en','Drag to move');
INSERT INTO `lng_data` VALUES ('jscalendar','go_today','en','Go Today');
INSERT INTO `lng_data` VALUES ('jscalendar','l_01','en','January');
INSERT INTO `lng_data` VALUES ('jscalendar','l_02','en','Feburary');
INSERT INTO `lng_data` VALUES ('jscalendar','l_03','en','March');
INSERT INTO `lng_data` VALUES ('jscalendar','l_04','en','April');
INSERT INTO `lng_data` VALUES ('jscalendar','l_05','en','May');
INSERT INTO `lng_data` VALUES ('jscalendar','l_06','en','June');
INSERT INTO `lng_data` VALUES ('jscalendar','l_07','en','July');
INSERT INTO `lng_data` VALUES ('jscalendar','l_08','en','August');
INSERT INTO `lng_data` VALUES ('jscalendar','l_09','en','September');
INSERT INTO `lng_data` VALUES ('jscalendar','l_10','en','October');
INSERT INTO `lng_data` VALUES ('jscalendar','l_11','en','November');
INSERT INTO `lng_data` VALUES ('jscalendar','l_12','en','December');
INSERT INTO `lng_data` VALUES ('jscalendar','l_fr','en','Friday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_mo','en','Monday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_sa','en','Saturday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_su','en','Sunday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_th','en','Thursday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_tu','en','Tuesday');
INSERT INTO `lng_data` VALUES ('jscalendar','l_we','en','Wednesday');
INSERT INTO `lng_data` VALUES ('jscalendar','next_month','en','Next month (hold for menu)');
INSERT INTO `lng_data` VALUES ('jscalendar','next_year','en','Next year (hold for menu)');
INSERT INTO `lng_data` VALUES ('jscalendar','open_calendar','en','Click here to open a calendar for date selection (JavaScript required!)');
INSERT INTO `lng_data` VALUES ('jscalendar','part_today','en',' (today)');
INSERT INTO `lng_data` VALUES ('jscalendar','prev_month','en','Prev. month (hold for menu)');
INSERT INTO `lng_data` VALUES ('jscalendar','prev_year','en','Prev. year (hold for menu)');
INSERT INTO `lng_data` VALUES ('jscalendar','s_01','en','Jan');
INSERT INTO `lng_data` VALUES ('jscalendar','s_02','en','Feb');
INSERT INTO `lng_data` VALUES ('jscalendar','s_03','en','Mar');
INSERT INTO `lng_data` VALUES ('jscalendar','s_04','en','Apr');
INSERT INTO `lng_data` VALUES ('jscalendar','s_05','en','May');
INSERT INTO `lng_data` VALUES ('jscalendar','s_06','en','Jun');
INSERT INTO `lng_data` VALUES ('jscalendar','s_07','en','Jul');
INSERT INTO `lng_data` VALUES ('jscalendar','s_08','en','Aug');
INSERT INTO `lng_data` VALUES ('jscalendar','s_09','en','Sep');
INSERT INTO `lng_data` VALUES ('jscalendar','s_10','en','Oct');
INSERT INTO `lng_data` VALUES ('jscalendar','s_11','en','Nov');
INSERT INTO `lng_data` VALUES ('jscalendar','s_12','en','Dec');
INSERT INTO `lng_data` VALUES ('jscalendar','s_fr','en','Fr');
INSERT INTO `lng_data` VALUES ('jscalendar','s_mo','en','Mo');
INSERT INTO `lng_data` VALUES ('jscalendar','s_sa','en','Sa');
INSERT INTO `lng_data` VALUES ('jscalendar','s_su','en','Su');
INSERT INTO `lng_data` VALUES ('jscalendar','s_th','en','Th');
INSERT INTO `lng_data` VALUES ('jscalendar','s_tu','en','Tu');
INSERT INTO `lng_data` VALUES ('jscalendar','s_we','en','We');
INSERT INTO `lng_data` VALUES ('jscalendar','select_date','en','Select date');
INSERT INTO `lng_data` VALUES ('jscalendar','time','en','Time');
INSERT INTO `lng_data` VALUES ('jscalendar','time_part','en','(Shift-)Click or drag to change value');
INSERT INTO `lng_data` VALUES ('jscalendar','today','en','Today');
INSERT INTO `lng_data` VALUES ('jscalendar','tt_date_format','en','%a, %b %e');
INSERT INTO `lng_data` VALUES ('jscalendar','wk','en','wk');
INSERT INTO `lng_data` VALUES ('mail','also_as_email','en','Also as Email');
INSERT INTO `lng_data` VALUES ('mail','bc','en','BCC');
INSERT INTO `lng_data` VALUES ('mail','forward','en','Forward');
INSERT INTO `lng_data` VALUES ('mail','linebreak','en','Line break');
INSERT INTO `lng_data` VALUES ('mail','mail_account_mail','en','Account Mail');
INSERT INTO `lng_data` VALUES ('mail','mail_account_mail_check','en','Send Account Mail');
INSERT INTO `lng_data` VALUES ('mail','mail_add_recipient','en','Please enter a recipient');
INSERT INTO `lng_data` VALUES ('mail','mail_add_subfolder','en','Add Subfolder');
INSERT INTO `lng_data` VALUES ('mail','mail_add_subject','en','Please enter a subject');
INSERT INTO `lng_data` VALUES ('mail','mail_add_to_addressbook','en','Add to address book');
INSERT INTO `lng_data` VALUES ('mail','mail_add_type','en','Please add the type of mail you want to send');
INSERT INTO `lng_data` VALUES ('mail','mail_addr_entries','en','Entries');
INSERT INTO `lng_data` VALUES ('mail','mail_attachments','en','Attachments');
INSERT INTO `lng_data` VALUES ('mail','mail_bc_not_valid','en','The BCC recipient is not valid');
INSERT INTO `lng_data` VALUES ('mail','mail_bc_search','en','BCC search');
INSERT INTO `lng_data` VALUES ('mail','mail_byte','en','Byte');
INSERT INTO `lng_data` VALUES ('mail','mail_cc_not_valid','en','The CC recipient is not valid');
INSERT INTO `lng_data` VALUES ('mail','mail_cc_search','en','CC search');
INSERT INTO `lng_data` VALUES ('mail','mail_change_to_folder','en','Switch to folder:');
INSERT INTO `lng_data` VALUES ('mail','mail_check_your_email_addr','en','Your email address is not valid');
INSERT INTO `lng_data` VALUES ('mail','mail_compose','en','Compose Message');
INSERT INTO `lng_data` VALUES ('mail','mail_deleted','en','The mail is deleted');
INSERT INTO `lng_data` VALUES ('mail','mail_deleted_entry','en','The entries are deleted');
INSERT INTO `lng_data` VALUES ('mail','mail_email_forbidden','en','You are not allowed to send email');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_login_or_email_addr','en','Please enter a valid login name or e-mail address.');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_valid_email_addr','en','Please enter a valid e-mail address.');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_valid_login','en','Please enter a valid login name.');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_added','en','Added new Entry');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_changed','en','The entry is changed');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_exists','en','An entry with the given login name or e-mail address already exists.');
INSERT INTO `lng_data` VALUES ('mail','mail_file_name','en','File name');
INSERT INTO `lng_data` VALUES ('mail','mail_file_size','en','File size');
INSERT INTO `lng_data` VALUES ('mail','mail_files_deleted','en','The file(s) are deleted');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_created','en','A new folder has been created');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_deleted','en','The folder has been deleted');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_exists','en','A folder already exists with this name');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_name','en','Folder name');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_name_changed','en','The folder has been renamed');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_options','en','Folder Options');
INSERT INTO `lng_data` VALUES ('mail','mail_following_rcp_not_valid','en','The following recipients are not valid:');
INSERT INTO `lng_data` VALUES ('mail','mail_global_options','en','Global options');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming','en','Incoming mail');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_both','en','local and forwarding');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_local','en','only local');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_smtp','en','forward to email address');
INSERT INTO `lng_data` VALUES ('mail','mail_insert_folder_name','en','Please insert a folder name');
INSERT INTO `lng_data` VALUES ('mail','mail_insert_query','en','Please insert a query');
INSERT INTO `lng_data` VALUES ('mail','mail_intern','en','Internal');
INSERT INTO `lng_data` VALUES ('mail','mail_mark_read','en','Mark mail read');
INSERT INTO `lng_data` VALUES ('mail','mail_mark_unread','en','Mark mail unread');
INSERT INTO `lng_data` VALUES ('mail','mail_maxsize_attachment_error','en','The upload limit is:');
INSERT INTO `lng_data` VALUES ('mail','mail_message_send','en','Message sent');
INSERT INTO `lng_data` VALUES ('mail','mail_move_error','en','Error moving mail');
INSERT INTO `lng_data` VALUES ('mail','mail_move_to','en','Move to:');
INSERT INTO `lng_data` VALUES ('mail','mail_moved','en','The mail has been moved');
INSERT INTO `lng_data` VALUES ('mail','mail_moved_to_trash','en','Mail has been moved to trash');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_admin_mail','en','E-Mail address of Administrator.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_client_name','en','Client Name.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_ilias_url','en','URL of ILIAS system.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_login','en','Login Account.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_no_pw_block','en','This text block is only included, if the new user account has been created without a password.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_pw_block','en','This text block is only included, if the new user account has been created including a password.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_salutation','en','Salutation.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target','en','URL of target item, e.g. a linked course that is passed to ILIAS from outside.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_block','en','This text is only included, if a target item is provided.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_title','en','Title of target item, e.g. course title.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_type','en','Type of target item, e.g. \"Course\" for a course item.');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_use_placeholder','en','The following placeholders may be used');
INSERT INTO `lng_data` VALUES ('mail','mail_new_file','en','Add new file:');
INSERT INTO `lng_data` VALUES ('mail','mail_no_attach_allowed','en','System messages are not allowed to contain attachments');
INSERT INTO `lng_data` VALUES ('mail','mail_no_attachments_found','en','No attachments found');
INSERT INTO `lng_data` VALUES ('mail','mail_no_permissions_write_smtp','en','You have no permission to write external mail');
INSERT INTO `lng_data` VALUES ('mail','mail_options_of','en','Options');
INSERT INTO `lng_data` VALUES ('mail','mail_options_saved','en','Options saved');
INSERT INTO `lng_data` VALUES ('mail','mail_recipient_not_valid','en','The recipient is not valid');
INSERT INTO `lng_data` VALUES ('mail','mail_s','en','Mail');
INSERT INTO `lng_data` VALUES ('mail','mail_s_unread','en','Unread Mail');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_female','en','Salutation, female');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_general','en','Salutation, general');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_male','en','Salutation, male');
INSERT INTO `lng_data` VALUES ('mail','mail_saved','en','The message has been saved');
INSERT INTO `lng_data` VALUES ('mail','mail_search_addressbook','en','search in address book');
INSERT INTO `lng_data` VALUES ('mail','mail_search_system','en','search in system');
INSERT INTO `lng_data` VALUES ('mail','mail_select_one_entry','en','You must select one entry');
INSERT INTO `lng_data` VALUES ('mail','mail_select_one_file','en','You must select one file');
INSERT INTO `lng_data` VALUES ('mail','mail_send_with_system_address','en','Send With System Address');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete','en','Are sure you want to delete the marked mail');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_entry','en','Are sure you want to delete the following entries');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_file','en','The file will be removed permanently');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_folder','en','The folder and its contents will be removed permanently');
INSERT INTO `lng_data` VALUES ('mail','mail_to','en','To');
INSERT INTO `lng_data` VALUES ('mail','mail_to_search','en','To search');
INSERT INTO `lng_data` VALUES ('mail','mail_user_addr_n_valid','en','Following users have no valid email address');
INSERT INTO `lng_data` VALUES ('mail','search_bc_recipient','en','Search BCC Recipient');
INSERT INTO `lng_data` VALUES ('mail','search_cc_recipient','en','Search CC Recipient');
INSERT INTO `lng_data` VALUES ('meta','md_days','en','Days:');
INSERT INTO `lng_data` VALUES ('meta','md_months','en','Month:');
INSERT INTO `lng_data` VALUES ('meta','md_time','en','Time:');
INSERT INTO `lng_data` VALUES ('meta','meta_accessibility_restrictions','en','Accessibility Restrictions');
INSERT INTO `lng_data` VALUES ('meta','meta_active','en','Active');
INSERT INTO `lng_data` VALUES ('meta','meta_add','en','Add');
INSERT INTO `lng_data` VALUES ('meta','meta_annotation','en','Annotation');
INSERT INTO `lng_data` VALUES ('meta','meta_atomic','en','Atomic');
INSERT INTO `lng_data` VALUES ('meta','meta_author','en','Author');
INSERT INTO `lng_data` VALUES ('meta','meta_browser','en','Browser');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AD','en','Andorra');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AE','en','United Arab Emirates');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AF','en','Afghanistan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AG','en','Antigua And Barbuda');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AI','en','Anguilla');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AL','en','Albania');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AM','en','Armenia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AN','en','Netherlands Antilles');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AO','en','Angola');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AQ','en','Antarctica');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AR','en','Argentina');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AS','en','American Samoa');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AT','en','Austria');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AU','en','Australia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AW','en','Aruba');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AZ','en','Azerbaijan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BA','en','Bosnia And Herzegowina');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BB','en','Barbados');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BD','en','Bangladesh');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BE','en','Belgium');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BF','en','Burkina Faso');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BG','en','Bulgaria');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BH','en','Bahrain');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BI','en','Burundi');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BJ','en','Benin');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BM','en','Bermuda');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BN','en','Brunei Darussalam');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BO','en','Bolivia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BR','en','Brazil');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BS','en','Bahamas');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BT','en','Bhutan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BV','en','Bouvet Island');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BW','en','Botswana');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BY','en','Belarus');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BZ','en','Belize');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CA','en','Canada');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CC','en','Cocos (Keeling) Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CF','en','Central African Republic');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CG','en','Congo');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CH','en','Switzerland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CI','en','Cote D\' Ivoire');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CK','en','Cook Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CL','en','Chile');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CM','en','Cameroon');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CN','en','China');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CO','en','Colombia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CR','en','Costa Rica');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CU','en','Cuba');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CV','en','Cape Verde');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CX','en','Christmas Island');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CY','en','Cyprus');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CZ','en','Czech Republic');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DE','en','Germany');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DJ','en','Djibouti');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DK','en','Denmark');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DM','en','Dominica');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DO','en','Dominican Republic');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DZ','en','Algeria');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EC','en','Ecuador');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EE','en','Estonia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EG','en','Egypt');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EH','en','Western Sahara');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ER','en','Eritrea');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ES','en','Spain');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ET','en','Ethiopia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FI','en','Finland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FJ','en','Fiji');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FK','en','Falkland Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FM','en','Micronesia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FO','en','Faroe Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FR','en','France');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FX','en','France, Metropolitan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GA','en','Gabon');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GB','en','United Kingdom');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GD','en','Grenada');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GE','en','Giorgia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GF','en','French Guiana');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GH','en','Ghana');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GI','en','Gibraltar');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GL','en','Greenland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GM','en','Gambia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GN','en','Guinea');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GP','en','Guadeloupe');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GQ','en','Equatorial Guinea');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GR','en','Greece');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GS','en','South Georgia And The South Sandwich Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GT','en','Guatemala');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GU','en','Guam');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GW','en','Guinea-Bissau');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GY','en','Guyana');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HM','en','Heard And Nc Donald Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HN','en','Honduras');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HR','en','Croatia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HT','en','Haiti');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HU','en','Hungary');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ID','en','Indonesia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IE','en','Ireland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IL','en','Israel');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IN','en','India');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IO','en','British Indian Ocean Territory');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IQ','en','Iraq');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IR','en','Iran');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IS','en','Iceland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IT','en','Italy');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JM','en','Jamaica');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JO','en','Jordan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JP','en','Japan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KE','en','Kenya');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KG','en','Kyrgyzstan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KH','en','Cambodia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KI','en','Kiribati');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KM','en','Comoros');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KN','en','Saint Kitts And Nevis');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KP','en','North Korea (People\'s Republic Of Korea)');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KR','en','South Korea (Republic Of Korea)');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KW','en','Kuwait');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KY','en','Cayman Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KZ','en','Kazakhstan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LA','en','Lao People\'s Republic');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LB','en','Lebanon');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LC','en','Saint Lucia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LI','en','Liechtenstein');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LK','en','Sri Lanka');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LR','en','Liberia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LS','en','Lesotho');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LT','en','Lithunia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LU','en','Luxembourg');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LV','en','Latvia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LY','en','Libyan Arab Jamahiriya');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MA','en','Morocco');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MC','en','Monaco');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MD','en','Moldova');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MG','en','Madagascar');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MH','en','Marshall Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MK','en','Macedonia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ML','en','Mali');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MM','en','Myanmar');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MN','en','Mongolia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MO','en','Macau');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MP','en','Northern Mariana Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MQ','en','Martinique');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MR','en','Mauritania');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MS','en','Montserrat');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MT','en','Malta');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MU','en','Mauritius');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MV','en','Maldives');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MW','en','Malawi');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MX','en','Mexico');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MY','en','Malaysia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MZ','en','Mozambique');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NA','en','Namibia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NC','en','New Caledonia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NE','en','Niger');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NF','en','Norfolk Island');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NG','en','Nigeria');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NI','en','Nicaragua');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NL','en','Netherlands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NO','en','Norway');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NP','en','Nepal');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NR','en','Nauru');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NU','en','Niue');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NZ','en','New Zealand');
INSERT INTO `lng_data` VALUES ('meta','meta_c_OM','en','Oman');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PA','en','Panama');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PE','en','Peru');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PF','en','French Polynesia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PG','en','Papua New Guinea');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PH','en','Philippines');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PK','en','Pakistan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PL','en','Poland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PM','en','St. Pierre And Miquelon');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PN','en','Pitcairn');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PR','en','Puerto Rico');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PT','en','Portugal');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PW','en','Palau');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PY','en','Paraguay');
INSERT INTO `lng_data` VALUES ('meta','meta_c_QA','en','Qatar');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RE','en','Reunion');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RO','en','Romania');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RU','en','Ran Federation');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RW','en','Rwanda');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SA','en','Saudi Arabia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SB','en','Solomon Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SC','en','Seychelles');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SD','en','Sudan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SE','en','Sweden');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SG','en','Singapore');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SH','en','St. Helena');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SI','en','Slovenia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SJ','en','Svalbard And Jan Mayen Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SK','en','Slovakia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SL','en','Siearra Leone');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SM','en','San Marino');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SN','en','Senegal');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SO','en','Somalia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SR','en','Suriname');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ST','en','Sao Tome And Principe');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SV','en','El Salvador');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SY','en','Syrian Arab Republic');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SZ','en','Swaziland');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TC','en','Turks And Caicos Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TD','en','Chad');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TF','en','French Southern Territories');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TG','en','Togo');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TH','en','Thailand');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TJ','en','Tajikistan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TK','en','Tokelau');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TM','en','Turkmenistan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TN','en','Tunisia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TO','en','Tonga');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TP','en','East Timor');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TR','en','Turkey');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TT','en','Trinidad And Tobago');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TV','en','Tuvalu');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TW','en','Taiwan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TZ','en','Tanzania');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UA','en','Ukraine');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UG','en','Uganda');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UM','en','U.S. Minor Outlying Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_US','en','U.S.A');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UY','en','Uruguay');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UZ','en','Uzbekistan');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VA','en','Vatican City State');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VC','en','Saint Vincent And The Grenadines');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VE','en','Venezuela');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VG','en','Virgin Islands (British)');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VI','en','Virgin Islands (US)');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VN','en','Viet Nam');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VU','en','Vanuatu');
INSERT INTO `lng_data` VALUES ('meta','meta_c_WF','en','Wallis And Futuna Islands');
INSERT INTO `lng_data` VALUES ('meta','meta_c_WS','en','Samoa');
INSERT INTO `lng_data` VALUES ('meta','meta_c_YE','en','Yemen');
INSERT INTO `lng_data` VALUES ('meta','meta_c_YT','en','Mayotte');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZA','en','South Africa');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZM','en','Zambia');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZR','en','Zaire');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZW','en','Zimbabwe');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZZ','en','Other Country');
INSERT INTO `lng_data` VALUES ('meta','meta_catalog','en','Catalog');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_element','en','Please choose an element you want to add!');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_language','en','Please choose a language');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_section','en','Please choose a section');
INSERT INTO `lng_data` VALUES ('meta','meta_classification','en','Classification');
INSERT INTO `lng_data` VALUES ('meta','meta_collection','en','Collection');
INSERT INTO `lng_data` VALUES ('meta','meta_competency','en','Competency');
INSERT INTO `lng_data` VALUES ('meta','meta_contentprovider','en','Content provider');
INSERT INTO `lng_data` VALUES ('meta','meta_context','en','Context');
INSERT INTO `lng_data` VALUES ('meta','meta_contribute','en','Contribute');
INSERT INTO `lng_data` VALUES ('meta','meta_copyright','en','Copyright');
INSERT INTO `lng_data` VALUES ('meta','meta_copyright_and_other_restrictions','en','Copyright and Other Restrictions');
INSERT INTO `lng_data` VALUES ('meta','meta_cost','en','Cost');
INSERT INTO `lng_data` VALUES ('meta','meta_coverage','en','Coverage');
INSERT INTO `lng_data` VALUES ('meta','meta_creator','en','Creator');
INSERT INTO `lng_data` VALUES ('meta','meta_current_value','en','Current value');
INSERT INTO `lng_data` VALUES ('meta','meta_date','en','Date');
INSERT INTO `lng_data` VALUES ('meta','meta_delete','en','Delete');
INSERT INTO `lng_data` VALUES ('meta','meta_description','en','Description');
INSERT INTO `lng_data` VALUES ('meta','meta_diagramm','en','Diagram');
INSERT INTO `lng_data` VALUES ('meta','meta_difficult','en','Difficult');
INSERT INTO `lng_data` VALUES ('meta','meta_difficulty','en','Difficulty');
INSERT INTO `lng_data` VALUES ('meta','meta_draft','en','Draft');
INSERT INTO `lng_data` VALUES ('meta','meta_duration','en','Duration');
INSERT INTO `lng_data` VALUES ('meta','meta_easy','en','Easy');
INSERT INTO `lng_data` VALUES ('meta','meta_editor','en','Editor');
INSERT INTO `lng_data` VALUES ('meta','meta_education','en','Education');
INSERT INTO `lng_data` VALUES ('meta','meta_educational','en','Educational');
INSERT INTO `lng_data` VALUES ('meta','meta_educational_level','en','Educational Level');
INSERT INTO `lng_data` VALUES ('meta','meta_educational_objective','en','Educational Objective');
INSERT INTO `lng_data` VALUES ('meta','meta_educationalvalidator','en','Educational validator');
INSERT INTO `lng_data` VALUES ('meta','meta_entity','en','Entity');
INSERT INTO `lng_data` VALUES ('meta','meta_entry','en','Entry');
INSERT INTO `lng_data` VALUES ('meta','meta_exam','en','Exam');
INSERT INTO `lng_data` VALUES ('meta','meta_exercise','en','Exercise');
INSERT INTO `lng_data` VALUES ('meta','meta_experiment','en','Experiment');
INSERT INTO `lng_data` VALUES ('meta','meta_expositive','en','Expositive');
INSERT INTO `lng_data` VALUES ('meta','meta_figure','en','Figure');
INSERT INTO `lng_data` VALUES ('meta','meta_final','en','Final');
INSERT INTO `lng_data` VALUES ('meta','meta_format','en','Format');
INSERT INTO `lng_data` VALUES ('meta','meta_general','en','General');
INSERT INTO `lng_data` VALUES ('meta','meta_graph','en','Graph');
INSERT INTO `lng_data` VALUES ('meta','meta_graphicaldesigner','en','Graphical designer');
INSERT INTO `lng_data` VALUES ('meta','meta_has_format','en','Has Format');
INSERT INTO `lng_data` VALUES ('meta','meta_has_part','en','Has Part');
INSERT INTO `lng_data` VALUES ('meta','meta_has_version','en','Has Version');
INSERT INTO `lng_data` VALUES ('meta','meta_hierarchical','en','Hierarchical');
INSERT INTO `lng_data` VALUES ('meta','meta_high','en','High');
INSERT INTO `lng_data` VALUES ('meta','meta_higher_education','en','Higher Education');
INSERT INTO `lng_data` VALUES ('meta','meta_id','en','Id');
INSERT INTO `lng_data` VALUES ('meta','meta_idea','en','Idea');
INSERT INTO `lng_data` VALUES ('meta','meta_identifier','en','Identifier');
INSERT INTO `lng_data` VALUES ('meta','meta_index','en','Index');
INSERT INTO `lng_data` VALUES ('meta','meta_info_tlt_not_valid','en','The current value is not valid. Therefore it can not be used other sections, e.g for learning progress statistics. Please insert atypical learning time in hours and/or minutes.');
INSERT INTO `lng_data` VALUES ('meta','meta_initiator','en','Initiator');
INSERT INTO `lng_data` VALUES ('meta','meta_installation_remarks','en','Installation Remarks');
INSERT INTO `lng_data` VALUES ('meta','meta_instructional_designer','en','Instructional designer');
INSERT INTO `lng_data` VALUES ('meta','meta_instructionaldesigner','en','Instructional designer');
INSERT INTO `lng_data` VALUES ('meta','meta_intended_end_user_role','en','Intended End User Role');
INSERT INTO `lng_data` VALUES ('meta','meta_interactivity_level','en','Interactivity Level');
INSERT INTO `lng_data` VALUES ('meta','meta_interactivity_type','en','Interactivity Type');
INSERT INTO `lng_data` VALUES ('meta','meta_is_based_on','en','Is Based On');
INSERT INTO `lng_data` VALUES ('meta','meta_is_basis_for','en','Is Basis For');
INSERT INTO `lng_data` VALUES ('meta','meta_is_format_of','en','Is Format Of');
INSERT INTO `lng_data` VALUES ('meta','meta_is_part_of','en','Is Part Of');
INSERT INTO `lng_data` VALUES ('meta','meta_is_referenced_by','en','Is Referenced By');
INSERT INTO `lng_data` VALUES ('meta','meta_is_required_by','en','Is Required By');
INSERT INTO `lng_data` VALUES ('meta','meta_is_version_of','en','Is Version Of');
INSERT INTO `lng_data` VALUES ('meta','meta_keyword','en','Keyword');
INSERT INTO `lng_data` VALUES ('meta','meta_kind','en','Kind');
INSERT INTO `lng_data` VALUES ('meta','meta_l_aa','en','Afar');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ab','en','Abkhazian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_af','en','Afrikaans');
INSERT INTO `lng_data` VALUES ('meta','meta_l_am','en','Amharic');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ar','en','Arabic');
INSERT INTO `lng_data` VALUES ('meta','meta_l_as','en','Assamese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ay','en','Aymara');
INSERT INTO `lng_data` VALUES ('meta','meta_l_az','en','Azerbaijani');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ba','en','Bashkir');
INSERT INTO `lng_data` VALUES ('meta','meta_l_be','en','Byelorussian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bg','en','Bulgarian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bh','en','Bihari');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bi','en','Bislama');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bn','en','Bengali;bangla');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bo','en','Tibetan');
INSERT INTO `lng_data` VALUES ('meta','meta_l_br','en','Breton');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ca','en','Catalan');
INSERT INTO `lng_data` VALUES ('meta','meta_l_co','en','Corsican');
INSERT INTO `lng_data` VALUES ('meta','meta_l_cs','en','Czech');
INSERT INTO `lng_data` VALUES ('meta','meta_l_cy','en','Welsh');
INSERT INTO `lng_data` VALUES ('meta','meta_l_da','en','Danish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_de','en','German');
INSERT INTO `lng_data` VALUES ('meta','meta_l_dz','en','Bhutani');
INSERT INTO `lng_data` VALUES ('meta','meta_l_el','en','Greek');
INSERT INTO `lng_data` VALUES ('meta','meta_l_en','en','English');
INSERT INTO `lng_data` VALUES ('meta','meta_l_eo','en','Esperanto');
INSERT INTO `lng_data` VALUES ('meta','meta_l_es','en','Spanish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_et','en','Estonian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_eu','en','Basque');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fa','en','Persian (farsi)');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fi','en','Finnish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fj','en','Fiji');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fo','en','Faroese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fr','en','French');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fy','en','Frisian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ga','en','Irish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gd','en','Scots gaelic');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gl','en','Galician');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gn','en','Guarani');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gu','en','Gujarati');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ha','en','Hausa');
INSERT INTO `lng_data` VALUES ('meta','meta_l_he','en','Hebrew');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hi','en','Hindi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hr','en','Croatian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hu','en','Hungarian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hy','en','Armenian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ia','en','Interlingua');
INSERT INTO `lng_data` VALUES ('meta','meta_l_id','en','Indonesian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ie','en','Interlingue');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ik','en','Inupiak');
INSERT INTO `lng_data` VALUES ('meta','meta_l_is','en','Icelandic');
INSERT INTO `lng_data` VALUES ('meta','meta_l_it','en','Italian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_iu','en','Inuktitut');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ja','en','Japanese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_jv','en','Javanese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ka','en','Georgian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kk','en','Kazakh');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kl','en','Greenlandic');
INSERT INTO `lng_data` VALUES ('meta','meta_l_km','en','Cambodian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kn','en','Kannada');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ko','en','Korean');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ks','en','Kashmiri');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ku','en','Kurdish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ky','en','Kirghiz');
INSERT INTO `lng_data` VALUES ('meta','meta_l_la','en','Latin');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ln','en','Lingala');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lo','en','Laothian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lt','en','Lithuanian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lv','en','Latvian;lettish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mg','en','Malagasy');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mi','en','Maori');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mk','en','Macedonian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ml','en','Malayalam');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mn','en','Mongolian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mo','en','Moldavian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mr','en','Marathi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ms','en','Malay');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mt','en','Maltese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_my','en','Burmese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_na','en','Nauru');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ne','en','Nepali');
INSERT INTO `lng_data` VALUES ('meta','meta_l_nl','en','Dutch');
INSERT INTO `lng_data` VALUES ('meta','meta_l_no','en','Norwegian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_oc','en','Occitan');
INSERT INTO `lng_data` VALUES ('meta','meta_l_om','en','Afan (oromo)');
INSERT INTO `lng_data` VALUES ('meta','meta_l_or','en','Oriya');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pa','en','Punjabi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pl','en','Polish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ps','en','Pashto;pushto');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pt','en','Portuguese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_qu','en','Quechua');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rm','en','Rhaeto-romance');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rn','en','Kurundi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ro','en','Romanian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ru','en','Russian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rw','en','Kinyarwanda');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sa','en','Sanskrit');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sd','en','Sindhi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sg','en','Sangho');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sh','en','Serbo-croatian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_si','en','Singhalese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sk','en','Slovak');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sl','en','Slovenian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sm','en','Samoan');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sn','en','Shona');
INSERT INTO `lng_data` VALUES ('meta','meta_l_so','en','Somali');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sq','en','Albanian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sr','en','Serbian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ss','en','Siswati');
INSERT INTO `lng_data` VALUES ('meta','meta_l_st','en','Sesotho');
INSERT INTO `lng_data` VALUES ('meta','meta_l_su','en','Sundanese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sv','en','Swedish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sw','en','Swahili');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ta','en','Tamil');
INSERT INTO `lng_data` VALUES ('meta','meta_l_te','en','Telugu');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tg','en','Tajik');
INSERT INTO `lng_data` VALUES ('meta','meta_l_th','en','Thai');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ti','en','Tigrinya');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tk','en','Turkmen');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tl','en','Tagalog');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tn','en','Setswana');
INSERT INTO `lng_data` VALUES ('meta','meta_l_to','en','Tonga');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tr','en','Turkish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ts','en','Tsonga');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tt','en','Tatar');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tw','en','Twi');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ug','en','Uigur');
INSERT INTO `lng_data` VALUES ('meta','meta_l_uk','en','Ukrainian');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ur','en','Urdu');
INSERT INTO `lng_data` VALUES ('meta','meta_l_uz','en','Uzbek');
INSERT INTO `lng_data` VALUES ('meta','meta_l_vi','en','Vietnamese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_vo','en','Volapuk');
INSERT INTO `lng_data` VALUES ('meta','meta_l_wo','en','Wolof');
INSERT INTO `lng_data` VALUES ('meta','meta_l_xh','en','Xhosa');
INSERT INTO `lng_data` VALUES ('meta','meta_l_yi','en','Yiddish');
INSERT INTO `lng_data` VALUES ('meta','meta_l_yo','en','Yoruba');
INSERT INTO `lng_data` VALUES ('meta','meta_l_za','en','Zhuang');
INSERT INTO `lng_data` VALUES ('meta','meta_l_zh','en','Chinese');
INSERT INTO `lng_data` VALUES ('meta','meta_l_zu','en','Zulu');
INSERT INTO `lng_data` VALUES ('meta','meta_language','en','Language');
INSERT INTO `lng_data` VALUES ('meta','meta_learner','en','Learner');
INSERT INTO `lng_data` VALUES ('meta','meta_learning_resource_type','en','Learning Resource Type');
INSERT INTO `lng_data` VALUES ('meta','meta_lecture','en','Lecture');
INSERT INTO `lng_data` VALUES ('meta','meta_lifecycle','en','Lifecycle');
INSERT INTO `lng_data` VALUES ('meta','meta_linear','en','Linear');
INSERT INTO `lng_data` VALUES ('meta','meta_local_file','en','Local File');
INSERT INTO `lng_data` VALUES ('meta','meta_location','en','Location');
INSERT INTO `lng_data` VALUES ('meta','meta_low','en','Low');
INSERT INTO `lng_data` VALUES ('meta','meta_mac_os','en','MacOS');
INSERT INTO `lng_data` VALUES ('meta','meta_manager','en','Manager');
INSERT INTO `lng_data` VALUES ('meta','meta_maximum_version','en','Maximum Version');
INSERT INTO `lng_data` VALUES ('meta','meta_medium','en','Medium');
INSERT INTO `lng_data` VALUES ('meta','meta_meta_metadata','en','Meta-Metadata');
INSERT INTO `lng_data` VALUES ('meta','meta_metadatascheme','en','Metadata Scheme');
INSERT INTO `lng_data` VALUES ('meta','meta_minimum_version','en','Minimum Version');
INSERT INTO `lng_data` VALUES ('meta','meta_mixed','en','Mixed');
INSERT INTO `lng_data` VALUES ('meta','meta_ms_windows','en','MS-Windows');
INSERT INTO `lng_data` VALUES ('meta','meta_multi_os','en','Multi-OS');
INSERT INTO `lng_data` VALUES ('meta','meta_name','en','Name');
INSERT INTO `lng_data` VALUES ('meta','meta_narrative_text','en','Narrative Text');
INSERT INTO `lng_data` VALUES ('meta','meta_networked','en','Networked');
INSERT INTO `lng_data` VALUES ('meta','meta_new_element','en','New Element');
INSERT INTO `lng_data` VALUES ('meta','meta_no','en','No');
INSERT INTO `lng_data` VALUES ('meta','meta_no_annotation','en','No metadata available for the Annotation section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_classification','en','No metadata available for the Classification section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_educational','en','No metadata available for Educational section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_lifecycle','en','No metadata available for Lifecycle section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_meta_metadata','en','No metadata available for Meta-Metadata section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_relation','en','No metadata available for the Relation section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_rights','en','No metadata available for the Rights section.');
INSERT INTO `lng_data` VALUES ('meta','meta_no_technical','en','No metadata available for Technical section.');
INSERT INTO `lng_data` VALUES ('meta','meta_none','en','None');
INSERT INTO `lng_data` VALUES ('meta','meta_operating_system','en','Operating System');
INSERT INTO `lng_data` VALUES ('meta','meta_or_composite','en','Or Composite');
INSERT INTO `lng_data` VALUES ('meta','meta_other','en','Other');
INSERT INTO `lng_data` VALUES ('meta','meta_other_plattform_requirements','en','Other Platform Requirements');
INSERT INTO `lng_data` VALUES ('meta','meta_pc_dos','en','PC-DOS');
INSERT INTO `lng_data` VALUES ('meta','meta_please_select','en','Please select');
INSERT INTO `lng_data` VALUES ('meta','meta_prerequisite','en','Prerequisite');
INSERT INTO `lng_data` VALUES ('meta','meta_problem_statement','en','Problem Statement');
INSERT INTO `lng_data` VALUES ('meta','meta_publisher','en','Publisher');
INSERT INTO `lng_data` VALUES ('meta','meta_purpose','en','Purpose');
INSERT INTO `lng_data` VALUES ('meta','meta_questionnaire','en','Questionnaire');
INSERT INTO `lng_data` VALUES ('meta','meta_quickedit','en','Quick Edit');
INSERT INTO `lng_data` VALUES ('meta','meta_reference','en','Reference');
INSERT INTO `lng_data` VALUES ('meta','meta_references','en','References');
INSERT INTO `lng_data` VALUES ('meta','meta_relation','en','Relation');
INSERT INTO `lng_data` VALUES ('meta','meta_requirement','en','Requirement');
INSERT INTO `lng_data` VALUES ('meta','meta_requires','en','Requires');
INSERT INTO `lng_data` VALUES ('meta','meta_resource','en','Resource');
INSERT INTO `lng_data` VALUES ('meta','meta_revised','en','Revised');
INSERT INTO `lng_data` VALUES ('meta','meta_rights','en','Rights');
INSERT INTO `lng_data` VALUES ('meta','meta_role','en','Role');
INSERT INTO `lng_data` VALUES ('meta','meta_school','en','School');
INSERT INTO `lng_data` VALUES ('meta','meta_scriptwriter','en','Scriptwriter');
INSERT INTO `lng_data` VALUES ('meta','meta_security_level','en','Security Level');
INSERT INTO `lng_data` VALUES ('meta','meta_self_assessment','en','Self Assessment');
INSERT INTO `lng_data` VALUES ('meta','meta_semantic_density','en','Semantic Density');
INSERT INTO `lng_data` VALUES ('meta','meta_simulation','en','Simulation');
INSERT INTO `lng_data` VALUES ('meta','meta_size','en','Size');
INSERT INTO `lng_data` VALUES ('meta','meta_skill_level','en','Skill Level');
INSERT INTO `lng_data` VALUES ('meta','meta_slide','en','Slide');
INSERT INTO `lng_data` VALUES ('meta','meta_source','en','Source');
INSERT INTO `lng_data` VALUES ('meta','meta_status','en','Status');
INSERT INTO `lng_data` VALUES ('meta','meta_structure','en','Structure');
INSERT INTO `lng_data` VALUES ('meta','meta_subjectmatterexpert','en','Subject matter expert');
INSERT INTO `lng_data` VALUES ('meta','meta_table','en','Table');
INSERT INTO `lng_data` VALUES ('meta','meta_taxon','en','Taxon');
INSERT INTO `lng_data` VALUES ('meta','meta_taxon_path','en','Taxon Path');
INSERT INTO `lng_data` VALUES ('meta','meta_teacher','en','Teacher');
INSERT INTO `lng_data` VALUES ('meta','meta_technical','en','Technical');
INSERT INTO `lng_data` VALUES ('meta','meta_technicalimplementer','en','Technical implementer');
INSERT INTO `lng_data` VALUES ('meta','meta_technicalvalidator','en','Technical validator');
INSERT INTO `lng_data` VALUES ('meta','meta_terminator','en','Terminator');
INSERT INTO `lng_data` VALUES ('meta','meta_title','en','Title');
INSERT INTO `lng_data` VALUES ('meta','meta_training','en','Training');
INSERT INTO `lng_data` VALUES ('meta','meta_type','en','Type');
INSERT INTO `lng_data` VALUES ('meta','meta_typical_age_range','en','Typical Age Range');
INSERT INTO `lng_data` VALUES ('meta','meta_typical_learning_time','en','Typical Learning Time');
INSERT INTO `lng_data` VALUES ('meta','meta_unavailable','en','Unavailable');
INSERT INTO `lng_data` VALUES ('meta','meta_unix','en','Unix');
INSERT INTO `lng_data` VALUES ('meta','meta_unknown','en','Unknown');
INSERT INTO `lng_data` VALUES ('meta','meta_validator','en','Validator');
INSERT INTO `lng_data` VALUES ('meta','meta_value','en','Value');
INSERT INTO `lng_data` VALUES ('meta','meta_version','en','Version');
INSERT INTO `lng_data` VALUES ('meta','meta_very_difficult','en','Very Difficult');
INSERT INTO `lng_data` VALUES ('meta','meta_very_easy','en','Very Easy');
INSERT INTO `lng_data` VALUES ('meta','meta_very_high','en','Very High');
INSERT INTO `lng_data` VALUES ('meta','meta_very_low','en','Very Low');
INSERT INTO `lng_data` VALUES ('meta','meta_yes','en','Yes');
INSERT INTO `lng_data` VALUES ('payment','currency_cent','en','Cent');
INSERT INTO `lng_data` VALUES ('payment','currency_euro','en','Euro');
INSERT INTO `lng_data` VALUES ('payment','duration','en','Duration');
INSERT INTO `lng_data` VALUES ('payment','excel_export','en','Excel export');
INSERT INTO `lng_data` VALUES ('payment','info','en','Informations about the pay method');
INSERT INTO `lng_data` VALUES ('payment','pay_add_to_shopping_cart','en','Add to shopping cart');
INSERT INTO `lng_data` VALUES ('payment','pay_added_to_shopping_cart','en','Added item to shopping cart.');
INSERT INTO `lng_data` VALUES ('payment','pay_all','en','All');
INSERT INTO `lng_data` VALUES ('payment','pay_article','en','Article');
INSERT INTO `lng_data` VALUES ('payment','pay_bank_data','en','Bank data');
INSERT INTO `lng_data` VALUES ('payment','pay_bill_no','en','Incoice no.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_account_holder','en','Account holder');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_account_number','en','Account number');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_back','en','back');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_bank_code','en','Bank code');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_card_holder','en','Card holder');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_card_number','en','Card number');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_check_number','en','Check number');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_check_terms_conditions','en','Please confirm that you\'ve read the terms and conditions and accept it.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card','en','Credit card');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card_data','en','Credit card');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card_not_valid','en','The credit card data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly. ');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry','en','Debit entry (german bank accounts only)');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry_data','en','Debit entry');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry_not_valid','en','The debit entry data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly. ');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_credit_card','en','Please check out whether all articles you would like to order are in the shopping cart. By filling in your credit card data and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds. ');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_debit_entry','en','Please check out whether all articles you would like to order are in the shopping cart. By filling in your data for the debit entry and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds. ');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_payment_type','en','Please select how to pay.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_personal_data','en','Please fill out the following form completely.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_house_number','en','House number');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_optional','en','optional');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_or','en','or');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_password_not_valid','en','Your password wasn\'t valid.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_payment_type','en','Kind of paying');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_payment_type_not_valid','en','The kind of paying you\'ve choosen isn\'t valid. Please select another option.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_personal_data','en','Your personal data');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_personal_data_not_valid','en','Your personal data isn\'t valid. Please check out whether all fields are filled out correctly.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_please_select','en','Please select');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_po_box','en','PO Box');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_code','en','Payment server returns error code');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_communication','en','Error while communictaion with payment server.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_sysadmin','en','Please contact system administrator for further information.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_shopping_cart_empty','en','Your shopping card is empty.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_street_or_pobox','en','Please enter street and house number or po box.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions','en','General terms and conditions');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions_read','en','I\'ve read the general terms and conditions and accept it.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions_show','en','show');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_thanks','en','Thank you. Your order was submitted.');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_total_amount','en','Total amount');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_validity','en','valid until');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_vat_included','en','VAT included');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_your_order','en','Your order');
INSERT INTO `lng_data` VALUES ('payment','pay_change_price','en','Change price/duration combination');
INSERT INTO `lng_data` VALUES ('payment','pay_click_to_buy','en','Buy now');
INSERT INTO `lng_data` VALUES ('payment','pay_confirm_order','en','Please confirm your order by entering your password.');
INSERT INTO `lng_data` VALUES ('payment','pay_customer_no','en','Customer no.');
INSERT INTO `lng_data` VALUES ('payment','pay_deleted_booking','en','The entry has been deleted.');
INSERT INTO `lng_data` VALUES ('payment','pay_deleted_items','en','The selected items have been deleted.');
INSERT INTO `lng_data` VALUES ('payment','pay_ending','en','ends with');
INSERT INTO `lng_data` VALUES ('payment','pay_entitled_retrieve','en','Entitled to retrieve data for');
INSERT INTO `lng_data` VALUES ('payment','pay_expires_info','en','This object is disposable. The payment has been expired, you can not buy it.');
INSERT INTO `lng_data` VALUES ('payment','pay_filter','en','Filter');
INSERT INTO `lng_data` VALUES ('payment','pay_goto_buyed_objects','en','Goto your buyed objects');
INSERT INTO `lng_data` VALUES ('payment','pay_goto_shopping_cart','en','Goto the shopping cart');
INSERT INTO `lng_data` VALUES ('payment','pay_header','en','Payment');
INSERT INTO `lng_data` VALUES ('payment','pay_hint_paypal','en','Hint for PayPal');
INSERT INTO `lng_data` VALUES ('payment','pay_info','en','Access to the following material is not for free. If you want to gain access to a certain learning object please select a price. You can purchase one or several learning objects by using the button \"shopping cart\" on your personal desktop.  You are going to gain immediate access to a chosen object and period.');
INSERT INTO `lng_data` VALUES ('payment','pay_info_paypal','en','To pay for those objects that are in your shopping cart you\'ll leave ILIAS temporary and head for the PayPal website. Please follow the steps that are shown to you there. After paying successfully you\'ll be directed back to ILIAS automatically. Don\'t close the window of your browser at any time whilst the selling process. Otherwise the objects you\'ve bought can\'t be activated for you automatically.');
INSERT INTO `lng_data` VALUES ('payment','pay_item_already_in_sc','en','This object already exists in your shopping cart.');
INSERT INTO `lng_data` VALUES ('payment','pay_item_already_in_sc_choose_another','en','This object was already taken up in your shopping cart. Select if necessary a new price/duration combination.');
INSERT INTO `lng_data` VALUES ('payment','pay_locator','en','Payment');
INSERT INTO `lng_data` VALUES ('payment','pay_message_attachment','en','As a confirmation for your order we send you a bill (PDF format) as attachment.');
INSERT INTO `lng_data` VALUES ('payment','pay_message_hello','en','Dear');
INSERT INTO `lng_data` VALUES ('payment','pay_message_regards','en','Yours sincerely');
INSERT INTO `lng_data` VALUES ('payment','pay_message_subject','en','Your ILIAS order');
INSERT INTO `lng_data` VALUES ('payment','pay_message_thanks','en','Thank you for your ILIAS 3 order.');
INSERT INTO `lng_data` VALUES ('payment','pay_no_vendors_created','en','No vendors created');
INSERT INTO `lng_data` VALUES ('payment','pay_not_buyed_any_object','en','You have not bought any object.');
INSERT INTO `lng_data` VALUES ('payment','pay_order_date_from','en','Order date from');
INSERT INTO `lng_data` VALUES ('payment','pay_order_date_til','en','Order date til');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_credit_card','en','The order was paid by credit card.');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_debit_entry','en','The order was paid by debit entry.');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_paypal','en','The order was paid by PayPal.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_fails','en','PayPal reports errors that occured during the transaction.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_info','en','If necessary feel free to contact the system administrator of this ILIAS installation.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_not_completed','en','The transaction isn\'t totally completed yet.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_prev_trans_id','en','The transaction id given by PayPal was already used before.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_customer','en','Checking this transaction resulted in no match of the customer.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_items','en','Checking this transaction resulted in no match of the sold items.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_vendor','en','Checking this transaction resulted in no match of the vendor.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_failed','en','Your puchase of ILIAS objects using PayPal failed!');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_success','en','Thanks for your purchase of ILIAS objects using PayPal! You\'ll receive a written confirmation in PDF format by e-mail.');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_unreachable','en','The connection to the payment server of PayPal failed.');
INSERT INTO `lng_data` VALUES ('payment','pay_reset_filter','en','Reset filter');
INSERT INTO `lng_data` VALUES ('payment','pay_select_one_item','en','Please select one item.');
INSERT INTO `lng_data` VALUES ('payment','pay_select_price','en','Please select a price/duration combination.');
INSERT INTO `lng_data` VALUES ('payment','pay_send_order','en','Send order');
INSERT INTO `lng_data` VALUES ('payment','pay_shopping_cart_empty','en','Your shopping cart is empty.');
INSERT INTO `lng_data` VALUES ('payment','pay_starting','en','starts with');
INSERT INTO `lng_data` VALUES ('payment','pay_step1','en','Your order - Schritt 1/3: Enter your personal data');
INSERT INTO `lng_data` VALUES ('payment','pay_step2','en','Your order - Schritt 2/3: Choose kind of payment');
INSERT INTO `lng_data` VALUES ('payment','pay_step3_credit_card','en','Your order - Schritt 3/3: Enter your credit card data and send your order');
INSERT INTO `lng_data` VALUES ('payment','pay_step3_debit_entry','en','Your order - Schritt 3/3: Enter your bank data and send your order');
INSERT INTO `lng_data` VALUES ('payment','pay_update_view','en','Update view');
INSERT INTO `lng_data` VALUES ('payment','paya_access','en','Access');
INSERT INTO `lng_data` VALUES ('payment','paya_add_customer','en','Add Selling Process');
INSERT INTO `lng_data` VALUES ('payment','paya_add_price','en','Add new price');
INSERT INTO `lng_data` VALUES ('payment','paya_add_price_title','en','New price');
INSERT INTO `lng_data` VALUES ('payment','paya_added_new_object','en','Added new object. Please edit the pay method and the prices.');
INSERT INTO `lng_data` VALUES ('payment','paya_added_new_price','en','Created new price');
INSERT INTO `lng_data` VALUES ('payment','paya_added_trustee','en','Created new trustee.');
INSERT INTO `lng_data` VALUES ('payment','paya_bookings_available','en','This object has been sold. Please delete all statistic data first.');
INSERT INTO `lng_data` VALUES ('payment','paya_buyable','en','Buyable');
INSERT INTO `lng_data` VALUES ('payment','paya_buyed_objects','en','Bought Objects');
INSERT INTO `lng_data` VALUES ('payment','paya_count_purchaser','en','Number of purchasers');
INSERT INTO `lng_data` VALUES ('payment','paya_customer','en','Customer');
INSERT INTO `lng_data` VALUES ('payment','paya_customer_added_successfully','en','The selling process was added to the statistics sucessfully.');
INSERT INTO `lng_data` VALUES ('payment','paya_delete_price','en','Delete price');
INSERT INTO `lng_data` VALUES ('payment','paya_delete_trustee_msg','en','Deleted selected trustees.');
INSERT INTO `lng_data` VALUES ('payment','paya_deleted_last_price','en','The last price has been deleted.');
INSERT INTO `lng_data` VALUES ('payment','paya_deleted_object','en','Stoped payment for the selected object.');
INSERT INTO `lng_data` VALUES ('payment','paya_details_updated','en','Details updated.');
INSERT INTO `lng_data` VALUES ('payment','paya_disabled','en','Disabled');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_details','en','Edit details');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_pay_method','en','Edit pay method');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_prices','en','Edit prices');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_prices_first','en','Please edit the prices first.');
INSERT INTO `lng_data` VALUES ('payment','paya_enabled','en','Enabled');
INSERT INTO `lng_data` VALUES ('payment','paya_enter_login','en','Please enter an user name.');
INSERT INTO `lng_data` VALUES ('payment','paya_err_adding_object','en','Error adding object');
INSERT INTO `lng_data` VALUES ('payment','paya_error_adding_customer','en','An error occured while adding the selling process to the statistics.');
INSERT INTO `lng_data` VALUES ('payment','paya_error_mandatory_fields','en','Please fill in all mandatory fields (*).');
INSERT INTO `lng_data` VALUES ('payment','paya_error_no_object_id_given','en','Please choose an object.');
INSERT INTO `lng_data` VALUES ('payment','paya_error_update_booking','en','Error saving statistic data.');
INSERT INTO `lng_data` VALUES ('payment','paya_expires','en','Expire payment');
INSERT INTO `lng_data` VALUES ('payment','paya_filter_reseted','en','Filter reseted.');
INSERT INTO `lng_data` VALUES ('payment','paya_header','en','Payment administration');
INSERT INTO `lng_data` VALUES ('payment','paya_insert_only_numbers','en','Please insert only integers.');
INSERT INTO `lng_data` VALUES ('payment','paya_locator','en','Payment administration');
INSERT INTO `lng_data` VALUES ('payment','paya_months','en','Month(s)');
INSERT INTO `lng_data` VALUES ('payment','paya_no_booking_id_given','en','Error: no \'booking id\' given');
INSERT INTO `lng_data` VALUES ('payment','paya_no_bookings','en','No statistic available.');
INSERT INTO `lng_data` VALUES ('payment','paya_no_object_selected','en','Please select one object.');
INSERT INTO `lng_data` VALUES ('payment','paya_no_objects_assigned','en','There are no sellable objects.');
INSERT INTO `lng_data` VALUES ('payment','paya_no_price_available','en','No prices available');
INSERT INTO `lng_data` VALUES ('payment','paya_no_prices_selected','en','Please select one price');
INSERT INTO `lng_data` VALUES ('payment','paya_no_settings_necessary','en','There are no settings necessary for this pay method');
INSERT INTO `lng_data` VALUES ('payment','paya_no_trustees','en','No trustees created.');
INSERT INTO `lng_data` VALUES ('payment','paya_no_valid_login','en','This user name is not valid.');
INSERT INTO `lng_data` VALUES ('payment','paya_no_vendor_selected','en','You haven\'t selected a vendor.');
INSERT INTO `lng_data` VALUES ('payment','paya_not_assign_yourself','en','It is not possible to assign yourself.');
INSERT INTO `lng_data` VALUES ('payment','paya_not_buyable','en','Not buyable');
INSERT INTO `lng_data` VALUES ('payment','paya_object','en','Objekts');
INSERT INTO `lng_data` VALUES ('payment','paya_object_not_purchasable','en','It is not possible to sell this object.');
INSERT INTO `lng_data` VALUES ('payment','paya_order_date','en','Order date');
INSERT INTO `lng_data` VALUES ('payment','paya_pay_method','en','Pay method');
INSERT INTO `lng_data` VALUES ('payment','paya_pay_method_not_specified','en','Not specified');
INSERT INTO `lng_data` VALUES ('payment','paya_payed','en','Payed');
INSERT INTO `lng_data` VALUES ('payment','paya_payed_access','en','Payed/Access');
INSERT INTO `lng_data` VALUES ('payment','paya_perm_obj','en','Edit objects');
INSERT INTO `lng_data` VALUES ('payment','paya_perm_stat','en','Edit statistics');
INSERT INTO `lng_data` VALUES ('payment','paya_price_not_valid','en','This price is not valid. Please insert only numbers');
INSERT INTO `lng_data` VALUES ('payment','paya_select_object_to_sell','en','Please select the object which you want to sell.');
INSERT INTO `lng_data` VALUES ('payment','paya_select_pay_method_first','en','Please select one pay method first.');
INSERT INTO `lng_data` VALUES ('payment','paya_sell_object','en','Sell object');
INSERT INTO `lng_data` VALUES ('payment','paya_shopping_cart','en','Shopping cart');
INSERT INTO `lng_data` VALUES ('payment','paya_statistic','en','Statistic');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_object','en','Are you sure, you want to stop payment for this object? All assigned data will get lost.');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_selected_prices','en','Are you sure you want to delete the selected prices?');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_selected_trustees','en','Are you sure you want to delete the selected trustees?');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_stat','en','Are you sure, you want to delete this statistic?');
INSERT INTO `lng_data` VALUES ('payment','paya_transaction','en','Transaction');
INSERT INTO `lng_data` VALUES ('payment','paya_trustee_table','en','Trustees');
INSERT INTO `lng_data` VALUES ('payment','paya_trustees','en','Trustees');
INSERT INTO `lng_data` VALUES ('payment','paya_update_price','en','Update prices');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_booking','en','Updated statistic.');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_prices','en','Updated prices');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_trustees','en','Updated permissions.');
INSERT INTO `lng_data` VALUES ('payment','paya_user_already_assigned','en','User already assigned.');
INSERT INTO `lng_data` VALUES ('payment','paya_vendor','en','Vendor');
INSERT INTO `lng_data` VALUES ('payment','pays_active_bookings','en','There active bookings for the selected vendor(s). Please delete them first.');
INSERT INTO `lng_data` VALUES ('payment','pays_add_info','en','Additional information for bill (optional)');
INSERT INTO `lng_data` VALUES ('payment','pays_add_vendor','en','Add vendor');
INSERT INTO `lng_data` VALUES ('payment','pays_added_vendor','en','Added new vendor');
INSERT INTO `lng_data` VALUES ('payment','pays_address','en','Address for bill');
INSERT INTO `lng_data` VALUES ('payment','pays_already_assigned_vendors','en','The following number of users were already assigned:');
INSERT INTO `lng_data` VALUES ('payment','pays_assigned_vendors','en','The following number of users have been assigned to the vendor list:');
INSERT INTO `lng_data` VALUES ('payment','pays_auth_token','en','Unique token given by PayPal');
INSERT INTO `lng_data` VALUES ('payment','pays_bank_data','en','Bank data for bill');
INSERT INTO `lng_data` VALUES ('payment','pays_bill','en','Bill');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf','en','BMF');
INSERT INTO `lng_data` VALUES ('payment','pays_cost_center','en','Cost center');
INSERT INTO `lng_data` VALUES ('payment','pays_cost_center_not_valid','en','Please enter a valid cost center.');
INSERT INTO `lng_data` VALUES ('payment','pays_currency_subunit','en','Currency (1/100) (e.g. Cent)');
INSERT INTO `lng_data` VALUES ('payment','pays_currency_unit','en','Currency (e.g. EUR)');
INSERT INTO `lng_data` VALUES ('payment','pays_delete_vendor','en','Deassign user');
INSERT INTO `lng_data` VALUES ('payment','pays_deleted_number_vendors','en','The following number of vendors have been deleted:');
INSERT INTO `lng_data` VALUES ('payment','pays_edit_vendor','en','Edit user');
INSERT INTO `lng_data` VALUES ('payment','pays_email_vendor','en','E-Mail address of the vendor');
INSERT INTO `lng_data` VALUES ('payment','pays_general','en','General');
INSERT INTO `lng_data` VALUES ('payment','pays_general_settings','en','General settings');
INSERT INTO `lng_data` VALUES ('payment','pays_general_settings_not_valid','en','Your general settings aren\'t valid. Please check out whether all fields are filled out correctly.');
INSERT INTO `lng_data` VALUES ('payment','pays_header_select_vendor','en','Vendor selection');
INSERT INTO `lng_data` VALUES ('payment','pays_no_username_given','en','No username given');
INSERT INTO `lng_data` VALUES ('payment','pays_no_valid_username_given','en','No valid username given');
INSERT INTO `lng_data` VALUES ('payment','pays_no_vendor_selected','en','No vendor selected');
INSERT INTO `lng_data` VALUES ('payment','pays_number_bookings','en','Active bookings');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_bill_exist','en','Pay method \'bill\' is activated for some objects. Therefore it can not be deactivated.');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_bmf_exist','en','Pay method \'BMF\' is activated for some objects. Therefore it can not be deactivated.');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_paypal_exist','en','Pay method \'PayPal\' is activated for some objects. Therefore it can not be deactivated.');
INSERT INTO `lng_data` VALUES ('payment','pays_offline','en','Offline');
INSERT INTO `lng_data` VALUES ('payment','pays_online','en','Online');
INSERT INTO `lng_data` VALUES ('payment','pays_page_style','en','Page style');
INSERT INTO `lng_data` VALUES ('payment','pays_pay_methods','en','Pay methods');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal','en','PayPal');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal_settings','en','Settings for PayPal');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal_settings_not_valid','en','Your settings for PayPal aren\'t valid. Please check out whether all fields are filled out correctly.');
INSERT INTO `lng_data` VALUES ('payment','pays_pdf_path','en','Path for generating bill as PDF file');
INSERT INTO `lng_data` VALUES ('payment','pays_server_host','en','Server host (e.g. www.paypal.com)');
INSERT INTO `lng_data` VALUES ('payment','pays_server_path','en','Path to the scripts (e.g. /cgi-bin/webscr)');
INSERT INTO `lng_data` VALUES ('payment','pays_sure_delete_selected_vendors','en','Do you really want to delete the selected vendor(s)');
INSERT INTO `lng_data` VALUES ('payment','pays_too_many_vendors_selected','en','Please select only one customer to perform this action.');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_general_settings','en','Your general settings were updated.');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_pay_method','en','Changed pay method.');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_paypal_settings','en','Your settings for PayPal were updated.');
INSERT INTO `lng_data` VALUES ('payment','pays_user_already_assigned','en','This user is already assigned to the vendor list');
INSERT INTO `lng_data` VALUES ('payment','pays_vat_rate','en','VAT rate in % (optional)');
INSERT INTO `lng_data` VALUES ('payment','pays_vendor','en','Vendor');
INSERT INTO `lng_data` VALUES ('payment','price_a','en','Price');
INSERT INTO `lng_data` VALUES ('payment','prices','en','Prices');
INSERT INTO `lng_data` VALUES ('payment','update','en','Update');
INSERT INTO `lng_data` VALUES ('pwassist','password_assistance','en','Password Assistance');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_email','en','Please enter an email address and submit the form.\\nILIAS will send an email to that address. The email contains all usernames which have registered this email address.\\nChoose a suitable username and use the password service to retrieve a new password. If you do not retrieve any email by this service please contact your course admin or %1$s. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_username_and_email','en','Enter a user name and the associated email address in the fields shown below.\\nILIAS will send a message to that email address. The message contains an address for a web page, where you can enter a new password for the user account.\\nIn case your unable to assign a password to your user account using this form, contact your course administration or send an email to %1$s. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_username_and_new_password','en','Enter the user name and the new password in the fields below.');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_email','en','Please correct your email address.\\nThe given email address could not be found in the database. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_username_or_email','en','Please correct the text in the entry fields.\\nThe user name and email address you have entered do not match an entry in the database. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_auth_mode','en','The user won\'t be authenticated directly at ILIAS. Thus, sending a password is impossible.');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_login_not_match','en','Please enter another user name.\\nThe user name you have entered does not match the user name for which you had asked for password assistance. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_body','en','Register a new password for your user account:\\n\\t%1$s\\n\\nThis message has been generated automatically by the ILIAS server\\n\\t%2$s\\n\\nYou (or someone at %3$s) has asked for password assistance for the user account \"%4$s\".\\n\\nPlease check carefully the conditions listed below, and proceed accordingly:\\n\\n- If you have used the password assistance form on the ILIAS server by accident:\\nDelete this mail.\\n\\n- If you are certain, that you never asked for password assistance at this ILIAS server:\\nPlease contact %5$s.\\n\\n- If you asked for password assistance, please proceed as follows:\\n\\n1. Open your browser.\\n\\n2. Enter the following address in your browser:\\n\\t%1$s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. On the web page shown by your browser, enter a new password for your user account.\\n\\nPlease note, that for security reasons, you can perform you can perform the three steps abeove only exactly once and for a limited time only. Afterwards the address becomes invalid, and you have to use the password assistance page on the ILIAS server again. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_sent','en','A message has been sent to %1$s.\\nPlease check your mail box. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_subject','en','ILIAS Password Assistance');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_not_permitted','en','Please enter another user name.\\nPassword assistance is not permitted for the user name you have entered. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_password_assigned','en','The password has been successfully assigned to user \"%1$s\". ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_session_expired','en','Please fill in this form again.\\nYour password assistance session has expired. This may have happened, because you tried to use the link that has been emailed to you more than once, or because too much time has passed since the link has been sent to you. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_update_error','en','Please contact your system administrator.\\nThe password could not be assigned to the user account due to an error whe updating the data base. ');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_username_mail_body','en','These are the active username found for the given email address:\\n%s\\n\\nThis message has been created automatically by the following ILIAS Server:\\n\\t%s\\n\\nYou (or somebody with IP  %s) have requested support for forgotten usernames for the email address \'%s\'.\\n\\nPlease check the following and act as suggested::\\n\\n-You have requested this mail by accident:\\nDelete this email.\\n\\n-You are sure, that you never requested this email:\\nPlease contact %s.\\n\\n- If you requested this email, please proceed as follows::\\n\\n1. Start your internet browser.\\n\\n2. Enter the following url:\\n\\t%s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. Your Browser now shows the Password-Service. Use this page together with one of the usernames and the according email address to retrieve a new password. ');
INSERT INTO `lng_data` VALUES ('rbac','edit_learning_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('rbac','filter_all_roles','en','Show all roles of current context');
INSERT INTO `lng_data` VALUES ('rbac','filter_global_roles','en','Show only global roles');
INSERT INTO `lng_data` VALUES ('rbac','filter_local_roles','en','Show only local roles of current context');
INSERT INTO `lng_data` VALUES ('rbac','filter_local_roles_object','en','Show only local roles defined at this position');
INSERT INTO `lng_data` VALUES ('rbac','filter_roles_local_policy','en','Show only roles using a local policy at this position');
INSERT INTO `lng_data` VALUES ('rbac','info_user_view_changed','en','User view changed');
INSERT INTO `lng_data` VALUES ('rbac','leave','en','Leave');
INSERT INTO `lng_data` VALUES ('rbac','msg_no_roles_of_type','en','No Roles available with selected filter setting');
INSERT INTO `lng_data` VALUES ('rbac','perm_administrate','en','Administrate');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_create','en','Create new objects');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_create_desc','en','Determine which object types may be created under the current object.');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_general','en','General operations');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_general_desc','en','Common operations available for all objects. Hover the mousepointer over operation to get more information.');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_object','en','Special operations');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_object_desc','en','Object-specific operations, only available to certain object types.');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_rbac','en','Permission settings');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_rbac_desc','en','Access control to Permission settings (this menu) and local policy settings for automatic permission settings for new created objects.');
INSERT INTO `lng_data` VALUES ('rbac','perm_local_role','en','Local role');
INSERT INTO `lng_data` VALUES ('rbac','perm_local_role_desc','en','This role is locally defined at the current object and correspond to a local policy');
INSERT INTO `lng_data` VALUES ('rbac','perm_use_local_policy','en','Use local policy');
INSERT INTO `lng_data` VALUES ('rbac','perm_use_local_policy_desc','en','If local policy is activated, you may define different default permission settings for the current object.');
INSERT INTO `lng_data` VALUES ('registration','reg_add_assignment','en','New Assignment');
INSERT INTO `lng_data` VALUES ('registration','reg_added_assignment','en','Added new assignment.');
INSERT INTO `lng_data` VALUES ('registration','reg_approve','en','Registration with Approvement');
INSERT INTO `lng_data` VALUES ('registration','reg_approve_info','en','If checked any new user registration has to be approved by an administrator.');
INSERT INTO `lng_data` VALUES ('registration','reg_available_roles','en','Available Roles:');
INSERT INTO `lng_data` VALUES ('registration','reg_default','en','Default');
INSERT INTO `lng_data` VALUES ('registration','reg_deleted_assignment','en','Deleted assignment(s).');
INSERT INTO `lng_data` VALUES ('registration','reg_direct','en','Direct Registration');
INSERT INTO `lng_data` VALUES ('registration','reg_direct_info','en','If this is checked, any new user registration request is automatically approved.');
INSERT INTO `lng_data` VALUES ('registration','reg_disabled','en','No Registration Possible');
INSERT INTO `lng_data` VALUES ('registration','reg_domain','en','Domain');
INSERT INTO `lng_data` VALUES ('registration','reg_email','en','Automatic Role Assignment');
INSERT INTO `lng_data` VALUES ('registration','reg_email_role_assignment','en','Role Assignment By Domain');
INSERT INTO `lng_data` VALUES ('registration','reg_fixed','en','Selection From Specified List');
INSERT INTO `lng_data` VALUES ('registration','reg_info_pwd','en','If enabled passwords will be send automatically to the new users per E-mail.');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_approve','en','You already have registered to ILIAS eLearning and received a mail with your account data. Now your account has been activated by an administrator.');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_profile','en','Profile data:');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_profile_changed','en','your profile has changed !');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_pwd_generation','en','Your account request will be reviewed by an administrator, and should be activated within 48 hours. You will be informed about the approvement by email.');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_new_user_body','en','A new user has been registered.');
INSERT INTO `lng_data` VALUES ('registration','reg_missing_domain','en','Please fill out all fields.');
INSERT INTO `lng_data` VALUES ('registration','reg_missing_role','en','Please fill out all fields.');
INSERT INTO `lng_data` VALUES ('registration','reg_notification','en','Notifications');
INSERT INTO `lng_data` VALUES ('registration','reg_notification_info','en','Enter one or more Login-Ids of users (comma seperated) that will be informed about new user registrations per email.');
INSERT INTO `lng_data` VALUES ('registration','reg_role_assignment','en','Role Assignment');
INSERT INTO `lng_data` VALUES ('registration','reg_role_info','en','Assigned Roles');
INSERT INTO `lng_data` VALUES ('registration','reg_select_one','en','Please select one entry.');
INSERT INTO `lng_data` VALUES ('registration','reg_selectable_roles','en','Selectable Roles');
INSERT INTO `lng_data` VALUES ('registration','reg_settings_header','en','New Registration Settings');
INSERT INTO `lng_data` VALUES ('registration','reg_type','en','Registration Type');
INSERT INTO `lng_data` VALUES ('registration','reg_unknown_recipients','en','The following logins are not valid:');
INSERT INTO `lng_data` VALUES ('registration','registration_settings','en','New Registrations');
INSERT INTO `lng_data` VALUES ('search','add_members_header','en','Add members');
INSERT INTO `lng_data` VALUES ('search','append_results','en','Append results');
INSERT INTO `lng_data` VALUES ('search','search_active','en','Include active users');
INSERT INTO `lng_data` VALUES ('search','search_added_new_folder','en','Added new folder.');
INSERT INTO `lng_data` VALUES ('search','search_advanced','en','Advanced search');
INSERT INTO `lng_data` VALUES ('search','search_all_results','en','All results');
INSERT INTO `lng_data` VALUES ('search','search_all_words','en','All words');
INSERT INTO `lng_data` VALUES ('search','search_and','en','and');
INSERT INTO `lng_data` VALUES ('search','search_any','en','-- Any --');
INSERT INTO `lng_data` VALUES ('search','search_any_word','en','Any word');
INSERT INTO `lng_data` VALUES ('search','search_area','en','Search area');
INSERT INTO `lng_data` VALUES ('search','search_area_info','en','Please select an area where the search should start.');
INSERT INTO `lng_data` VALUES ('search','search_below','en','Beneath:');
INSERT INTO `lng_data` VALUES ('search','search_change','en','Change');
INSERT INTO `lng_data` VALUES ('search','search_choose_object_type','en','Please choose one object type.');
INSERT INTO `lng_data` VALUES ('search','search_concatenation','en','Concatenation');
INSERT INTO `lng_data` VALUES ('search','search_content','en','Page Content');
INSERT INTO `lng_data` VALUES ('search','search_dbk_content','en','Digital Library (content)');
INSERT INTO `lng_data` VALUES ('search','search_dbk_meta','en','Digital Library (metadata)');
INSERT INTO `lng_data` VALUES ('search','search_delete_sure','en','The object and its contents will be deleted permanently');
INSERT INTO `lng_data` VALUES ('search','search_details_info','en','Detail search. Please select one or more objects above.');
INSERT INTO `lng_data` VALUES ('search','search_direct','en','Direct search');
INSERT INTO `lng_data` VALUES ('search','search_fast_info','en','Search for titles, descriptions and keywords in all object types');
INSERT INTO `lng_data` VALUES ('search','search_for_grp_members','en','Search for group members');
INSERT INTO `lng_data` VALUES ('search','search_for_role_members','en','Search for role members');
INSERT INTO `lng_data` VALUES ('search','search_for_users','en','Search for users');
INSERT INTO `lng_data` VALUES ('search','search_full_info','en','Choose this option to search in a large amount of data.');
INSERT INTO `lng_data` VALUES ('search','search_group','en','Groups');
INSERT INTO `lng_data` VALUES ('search','search_grp_title','en','Group name');
INSERT INTO `lng_data` VALUES ('search','search_hits','en','Found in:');
INSERT INTO `lng_data` VALUES ('search','search_in_magazin','en','In the repository');
INSERT INTO `lng_data` VALUES ('search','search_in_result','en','Search within results');
INSERT INTO `lng_data` VALUES ('search','search_inactive','en','Include inactive users');
INSERT INTO `lng_data` VALUES ('search','search_index','en','Indexed search');
INSERT INTO `lng_data` VALUES ('search','search_like_info','en','Choose this option to get best results.');
INSERT INTO `lng_data` VALUES ('search','search_limit_reached','en','Your search produced more than %s hits. You can restrict the search terms to receive more detailed results.');
INSERT INTO `lng_data` VALUES ('search','search_lm_content','en','Learning materials (content)');
INSERT INTO `lng_data` VALUES ('search','search_lm_meta','en','Learning materials (metadata)');
INSERT INTO `lng_data` VALUES ('search','search_lucene','en','Lucene search');
INSERT INTO `lng_data` VALUES ('search','search_lucene_host','en','Lucene-Server');
INSERT INTO `lng_data` VALUES ('search','search_lucene_info','en','If activated, it is possible to search in PDF, HTML files and HTML-Learning modules');
INSERT INTO `lng_data` VALUES ('search','search_lucene_port','en','Lucene-Port');
INSERT INTO `lng_data` VALUES ('search','search_lucene_readme','en','Setup informations');
INSERT INTO `lng_data` VALUES ('search','search_meta','en','Metadata');
INSERT INTO `lng_data` VALUES ('search','search_minimum_three','en','Your search must be at least three characters long');
INSERT INTO `lng_data` VALUES ('search','search_move_folder_not_allowed','en','Folder cannot be moved.');
INSERT INTO `lng_data` VALUES ('search','search_move_to','en','Move to:');
INSERT INTO `lng_data` VALUES ('search','search_my_search_results','en','My search results');
INSERT INTO `lng_data` VALUES ('search','search_new_folder','en','New folder');
INSERT INTO `lng_data` VALUES ('search','search_no_category','en','You have not selected any search categories');
INSERT INTO `lng_data` VALUES ('search','search_no_connection_lucene','en','Cannot connect to Lucene server.');
INSERT INTO `lng_data` VALUES ('search','search_no_match','en','Your search did not match any results');
INSERT INTO `lng_data` VALUES ('search','search_no_results_saved','en','No results saved.');
INSERT INTO `lng_data` VALUES ('search','search_no_search_term','en','You have not selected any search terms');
INSERT INTO `lng_data` VALUES ('search','search_no_selection','en','You made no selection.');
INSERT INTO `lng_data` VALUES ('search','search_object_renamed','en','Object renamed.');
INSERT INTO `lng_data` VALUES ('search','search_objects_deleted','en','Object(s) deleted.');
INSERT INTO `lng_data` VALUES ('search','search_objects_moved','en','Objects moved.');
INSERT INTO `lng_data` VALUES ('search','search_one_action','en','Select one action.');
INSERT INTO `lng_data` VALUES ('search','search_or','en','or');
INSERT INTO `lng_data` VALUES ('search','search_rename_title','en','Rename title');
INSERT INTO `lng_data` VALUES ('search','search_results','en','Search results');
INSERT INTO `lng_data` VALUES ('search','search_results_saved','en','Search results saved');
INSERT INTO `lng_data` VALUES ('search','search_role_title','en','Role name');
INSERT INTO `lng_data` VALUES ('search','search_save_as_select','en','Save as:');
INSERT INTO `lng_data` VALUES ('search','search_search_for','en','Search for');
INSERT INTO `lng_data` VALUES ('search','search_search_no_results_saved','en','There are no search results saved');
INSERT INTO `lng_data` VALUES ('search','search_search_results','en','Search results');
INSERT INTO `lng_data` VALUES ('search','search_search_term','en','Search term');
INSERT INTO `lng_data` VALUES ('search','search_select_exactly_one_object','en','You must select exactly one object.');
INSERT INTO `lng_data` VALUES ('search','search_select_folder','en','Please select exactly one folder. It is not possible to rename search results.');
INSERT INTO `lng_data` VALUES ('search','search_select_one','en','Select one folder');
INSERT INTO `lng_data` VALUES ('search','search_select_one_action','en','--Select one action--');
INSERT INTO `lng_data` VALUES ('search','search_select_one_folder_select','en','--Select one folder--');
INSERT INTO `lng_data` VALUES ('search','search_select_one_result','en','Select at least one search result');
INSERT INTO `lng_data` VALUES ('search','search_select_one_select','en','--Select one folder--');
INSERT INTO `lng_data` VALUES ('search','search_show_result','en','Show');
INSERT INTO `lng_data` VALUES ('search','search_tst_svy','en','Tests/Surveys');
INSERT INTO `lng_data` VALUES ('search','search_type','en','Search type');
INSERT INTO `lng_data` VALUES ('search','search_user','en','Users');
INSERT INTO `lng_data` VALUES ('search','until','en','up to');
INSERT INTO `lng_data` VALUES ('style','sty_all','en','All');
INSERT INTO `lng_data` VALUES ('style','sty_background','en','Background');
INSERT INTO `lng_data` VALUES ('style','sty_background_attachment','en','Background Attachment');
INSERT INTO `lng_data` VALUES ('style','sty_background_color','en','Background Color');
INSERT INTO `lng_data` VALUES ('style','sty_background_image','en','Background Image');
INSERT INTO `lng_data` VALUES ('style','sty_background_position','en','Background Position');
INSERT INTO `lng_data` VALUES ('style','sty_background_repeat','en','Background Repeat');
INSERT INTO `lng_data` VALUES ('style','sty_border','en','Border');
INSERT INTO `lng_data` VALUES ('style','sty_border_color','en','Border Color');
INSERT INTO `lng_data` VALUES ('style','sty_border_style','en','Border Style');
INSERT INTO `lng_data` VALUES ('style','sty_border_width','en','Border Width');
INSERT INTO `lng_data` VALUES ('style','sty_bottom','en','Bottom');
INSERT INTO `lng_data` VALUES ('style','sty_clear','en','Clear');
INSERT INTO `lng_data` VALUES ('style','sty_color','en','Colour');
INSERT INTO `lng_data` VALUES ('style','sty_confirm_del_ind_styles','en','Confirm Deletion of Individual Content Styles');
INSERT INTO `lng_data` VALUES ('style','sty_confirm_del_ind_styles_desc','en','All learning modules with individual styles will be assigned to style \'%s\'. This will also delete all individual content styles. Are you sure to continue?');
INSERT INTO `lng_data` VALUES ('style','sty_copy_other_stylesheet','en','Copy Style from Local Source');
INSERT INTO `lng_data` VALUES ('style','sty_create_ind_style','en','Create Individual Style');
INSERT INTO `lng_data` VALUES ('style','sty_create_new_stylesheet','en','Create new Style');
INSERT INTO `lng_data` VALUES ('style','sty_cursor','en','Cursor');
INSERT INTO `lng_data` VALUES ('style','sty_default_style','en','Default Style');
INSERT INTO `lng_data` VALUES ('style','sty_font_family','en','Font Family');
INSERT INTO `lng_data` VALUES ('style','sty_font_size','en','Font Size');
INSERT INTO `lng_data` VALUES ('style','sty_font_stretch','en','Font Stretch');
INSERT INTO `lng_data` VALUES ('style','sty_font_style','en','Font Style');
INSERT INTO `lng_data` VALUES ('style','sty_font_variant','en','Font Variant');
INSERT INTO `lng_data` VALUES ('style','sty_font_weight','en','Font Weight');
INSERT INTO `lng_data` VALUES ('style','sty_import_stylesheet','en','Import Style');
INSERT INTO `lng_data` VALUES ('style','sty_individual_style','en','Individual Style');
INSERT INTO `lng_data` VALUES ('style','sty_individual_styles','en','Individual Styles');
INSERT INTO `lng_data` VALUES ('style','sty_left','en','Left');
INSERT INTO `lng_data` VALUES ('style','sty_letter_spacing','en','Letter Spacing');
INSERT INTO `lng_data` VALUES ('style','sty_line_height','en','Line Height');
INSERT INTO `lng_data` VALUES ('style','sty_margin','en','Margin');
INSERT INTO `lng_data` VALUES ('style','sty_margin_and_padding','en','Margin and Padding');
INSERT INTO `lng_data` VALUES ('style','sty_move_lm_styles','en','Change Style of Learning Modules');
INSERT INTO `lng_data` VALUES ('style','sty_move_style','en','Change Style');
INSERT INTO `lng_data` VALUES ('style','sty_nr_learning_modules','en','Number of Learning Modules');
INSERT INTO `lng_data` VALUES ('style','sty_padding','en','Padding');
INSERT INTO `lng_data` VALUES ('style','sty_right','en','Right');
INSERT INTO `lng_data` VALUES ('style','sty_save_active_styles','en','Save Active Styles');
INSERT INTO `lng_data` VALUES ('style','sty_save_standard_styles','en','Save Standard Styles');
INSERT INTO `lng_data` VALUES ('style','sty_scope','en','Scope');
INSERT INTO `lng_data` VALUES ('style','sty_set_scope','en','Set Scope');
INSERT INTO `lng_data` VALUES ('style','sty_source','en','Source');
INSERT INTO `lng_data` VALUES ('style','sty_special','en','Special');
INSERT INTO `lng_data` VALUES ('style','sty_standard_style','en','Standard Style');
INSERT INTO `lng_data` VALUES ('style','sty_text','en','Text');
INSERT INTO `lng_data` VALUES ('style','sty_text_align','en','Text Alignment');
INSERT INTO `lng_data` VALUES ('style','sty_text_decoration','en','Text Decoration');
INSERT INTO `lng_data` VALUES ('style','sty_text_indent','en','Text Indentation');
INSERT INTO `lng_data` VALUES ('style','sty_text_transform','en','Text Transform');
INSERT INTO `lng_data` VALUES ('style','sty_top','en','Top');
INSERT INTO `lng_data` VALUES ('style','sty_vertical_align','en','Vertical Alignment');
INSERT INTO `lng_data` VALUES ('style','sty_white_space','en','White Space');
INSERT INTO `lng_data` VALUES ('style','sty_word_spacing','en','Word Spacing');
INSERT INTO `lng_data` VALUES ('survey','SurveyMetricQuestion','en','Metric question');
INSERT INTO `lng_data` VALUES ('survey','SurveyNominalQuestion','en','Nominal question');
INSERT INTO `lng_data` VALUES ('survey','SurveyOrdinalQuestion','en','Ordinal question');
INSERT INTO `lng_data` VALUES ('survey','SurveyTextQuestion','en','Essay');
INSERT INTO `lng_data` VALUES ('survey','add_category','en','Add answer');
INSERT INTO `lng_data` VALUES ('survey','add_heading','en','Add heading');
INSERT INTO `lng_data` VALUES ('survey','add_limits_for_standard_numbers','en','Please enter a lower and upper limit for the standard numbers you want to add as answers.');
INSERT INTO `lng_data` VALUES ('survey','add_phrase','en','Add phrase');
INSERT INTO `lng_data` VALUES ('survey','add_phrase_introduction','en','Please select a phrase:');
INSERT INTO `lng_data` VALUES ('survey','add_standard_numbers','en','Add standard numbers');
INSERT INTO `lng_data` VALUES ('survey','already_completed_survey','en','You have already finished the survey! You are not able to enter the survey again.');
INSERT INTO `lng_data` VALUES ('survey','anonymization','en','Anonymization');
INSERT INTO `lng_data` VALUES ('survey','anonymize_anonymous_introduction','en','This survey anonymizes all user data. To grant you access to the survey, you must use a 5-character survey code which you can receive from the creator/maintainer of this survey<br />Please enter it in the text field below.');
INSERT INTO `lng_data` VALUES ('survey','anonymize_key_introduction','en','This survey anonymizes all user data. To grant you access to the survey, a 5-character code was created by the system and will be sent to your ILIAS mail inbox when you start the survey (after answering the first question). Your survey access code is<br /><span class=\"bold\">%s</span><br />Please enter it in the text field below. ');
INSERT INTO `lng_data` VALUES ('survey','anonymize_personalized','en','No anonymization');
INSERT INTO `lng_data` VALUES ('survey','anonymize_registered_user','en','Anonymized survey access');
INSERT INTO `lng_data` VALUES ('survey','anonymize_resume_introduction','en','Please enter your survey access code to resume the survey. It was sent to your ILIAS mail inbox when you started the survey.');
INSERT INTO `lng_data` VALUES ('survey','anonymize_survey','en','Anonymize survey data');
INSERT INTO `lng_data` VALUES ('survey','anonymize_with_code','en','Anonymization with personal access using a survey code');
INSERT INTO `lng_data` VALUES ('survey','anonymize_without_code','en','Anonymization with free access to the survey');
INSERT INTO `lng_data` VALUES ('survey','anonymous_with_personalized_survey','en','You must be a registered user to run a personalized survey!');
INSERT INTO `lng_data` VALUES ('survey','answer','en','Answer');
INSERT INTO `lng_data` VALUES ('survey','apply','en','Apply');
INSERT INTO `lng_data` VALUES ('survey','arithmetic_mean','en','Arithmetic mean');
INSERT INTO `lng_data` VALUES ('survey','ask_insert_questionblocks','en','Are you sure you want to insert the following question block(s) to the survey?');
INSERT INTO `lng_data` VALUES ('survey','ask_insert_questions','en','Are you sure you want to insert the following question(s) to the survey?');
INSERT INTO `lng_data` VALUES ('survey','back','en','<< Back');
INSERT INTO `lng_data` VALUES ('survey','before','en','before');
INSERT INTO `lng_data` VALUES ('survey','browse_for_questions','en','Browse for questions');
INSERT INTO `lng_data` VALUES ('survey','cancel_survey','en','Suspend the survey');
INSERT INTO `lng_data` VALUES ('survey','cannot_create_survey_codes','en','You do not possess sufficient permissions to create survey access codes!');
INSERT INTO `lng_data` VALUES ('survey','cannot_edit_survey','en','You do not possess sufficient permissions to edit the survey!');
INSERT INTO `lng_data` VALUES ('survey','cannot_export_questionpool','en','You do not possess sufficient permissions to export the survey question pool!');
INSERT INTO `lng_data` VALUES ('survey','cannot_export_survey','en','You do not possess sufficient permissions to export the survey!');
INSERT INTO `lng_data` VALUES ('survey','cannot_maintain_survey','en','You do not possess sufficient permissions to maintain the survey!');
INSERT INTO `lng_data` VALUES ('survey','cannot_manage_phrases','en','You do not possess sufficient permissions to manage the phrases!');
INSERT INTO `lng_data` VALUES ('survey','cannot_participate_survey','en','You do not possess sufficient permissions to participate in the survey!');
INSERT INTO `lng_data` VALUES ('survey','cannot_read_questionpool','en','You do not possess sufficient permissions to read the question pool data!');
INSERT INTO `lng_data` VALUES ('survey','cannot_read_survey','en','You do not possess sufficient permissions to read the survey data!');
INSERT INTO `lng_data` VALUES ('survey','cannot_save_metaobject','en','You do not possess sufficient permissions to save the meta data!');
INSERT INTO `lng_data` VALUES ('survey','cannot_switch_to_online_no_questions','en','The status cannot be changed to &quot;online&quot; because there are no questions in the survey!');
INSERT INTO `lng_data` VALUES ('survey','categories','en','Answers');
INSERT INTO `lng_data` VALUES ('survey','category','en','Answer');
INSERT INTO `lng_data` VALUES ('survey','category_delete_confirm','en','Are you sure you want to delete the following answers?');
INSERT INTO `lng_data` VALUES ('survey','category_delete_select_none','en','Please check at least one answer to delete it!');
INSERT INTO `lng_data` VALUES ('survey','category_nr_selected','en','Number of users that selected this answer');
INSERT INTO `lng_data` VALUES ('survey','chart','en','Chart');
INSERT INTO `lng_data` VALUES ('survey','check_category_to_save_phrase','en','You must select a least one answer to save a phrase!');
INSERT INTO `lng_data` VALUES ('survey','codes','en','Access codes');
INSERT INTO `lng_data` VALUES ('survey','combobox','en','Combobox');
INSERT INTO `lng_data` VALUES ('survey','concatenation','en','Concatenation');
INSERT INTO `lng_data` VALUES ('survey','confirm_delete_all_user_data','en','Are you sure you want to delete all user data of the survey?');
INSERT INTO `lng_data` VALUES ('survey','confirm_delete_single_user_data','en','Are you sure you want to delete the survey data of the selected users?');
INSERT INTO `lng_data` VALUES ('survey','confirm_remove_heading','en','Are you sure you want to remove the heading?');
INSERT INTO `lng_data` VALUES ('survey','confirm_sync_questions','en','The question you changed is a copy which has been created for use with the active survey. Do you want to change the original of the question too?');
INSERT INTO `lng_data` VALUES ('survey','constraint_add','en','Add precondition');
INSERT INTO `lng_data` VALUES ('survey','constraints','en','Preconditions');
INSERT INTO `lng_data` VALUES ('survey','constraints_first_question_description','en','The first entity could not have any preconditions because there are no previous questions.');
INSERT INTO `lng_data` VALUES ('survey','constraints_introduction','en','For every entity (a single question or a question block with multiple questions) one or more preconditions could be defined. These preconditions will be derived from the answers of the survey participants of questions which occur earlier in the survey. Since the first entity has no previous questions or questionblocks there is no possibility to define preconditions for it.');
INSERT INTO `lng_data` VALUES ('survey','constraints_list_of_entities','en','Available survey entities for preconditions');
INSERT INTO `lng_data` VALUES ('survey','constraints_no_nonessay_available','en','There are no previous questions or only essay questions available to calculate preconditions (essay questions are not valid to calculate preconditions)');
INSERT INTO `lng_data` VALUES ('survey','constraints_no_questions_or_questionblocks_selecte','en','Please select at least one question or questionblock!');
INSERT INTO `lng_data` VALUES ('survey','contains','en','Contains');
INSERT INTO `lng_data` VALUES ('survey','continue','en','Continue >>');
INSERT INTO `lng_data` VALUES ('survey','create_date','en','Created');
INSERT INTO `lng_data` VALUES ('survey','create_new','en','Create new');
INSERT INTO `lng_data` VALUES ('survey','create_questionpool_before_add_question','en','You must create at least one question pool to store your questions!');
INSERT INTO `lng_data` VALUES ('survey','dc_agree','en','agree');
INSERT INTO `lng_data` VALUES ('survey','dc_always','en','always');
INSERT INTO `lng_data` VALUES ('survey','dc_definitelyfalse','en','definitely false');
INSERT INTO `lng_data` VALUES ('survey','dc_definitelytrue','en','definitely true');
INSERT INTO `lng_data` VALUES ('survey','dc_desired','en','desired');
INSERT INTO `lng_data` VALUES ('survey','dc_disagree','en','disagree');
INSERT INTO `lng_data` VALUES ('survey','dc_fair','en','fair');
INSERT INTO `lng_data` VALUES ('survey','dc_false','en','false');
INSERT INTO `lng_data` VALUES ('survey','dc_good','en','good');
INSERT INTO `lng_data` VALUES ('survey','dc_manytimes','en','many times');
INSERT INTO `lng_data` VALUES ('survey','dc_morenegative','en','more negative');
INSERT INTO `lng_data` VALUES ('survey','dc_morepositive','en','more positive');
INSERT INTO `lng_data` VALUES ('survey','dc_mostcertainly','en','most certainly');
INSERT INTO `lng_data` VALUES ('survey','dc_mostcertainlynot','en','most certainly not');
INSERT INTO `lng_data` VALUES ('survey','dc_must','en','must');
INSERT INTO `lng_data` VALUES ('survey','dc_mustnot','en','must not');
INSERT INTO `lng_data` VALUES ('survey','dc_neutral','en','neutral');
INSERT INTO `lng_data` VALUES ('survey','dc_never','en','never');
INSERT INTO `lng_data` VALUES ('survey','dc_no','en','no');
INSERT INTO `lng_data` VALUES ('survey','dc_notacceptable','en','not acceptable');
INSERT INTO `lng_data` VALUES ('survey','dc_poor','en','poor');
INSERT INTO `lng_data` VALUES ('survey','dc_rarely','en','rarely');
INSERT INTO `lng_data` VALUES ('survey','dc_should','en','should');
INSERT INTO `lng_data` VALUES ('survey','dc_shouldnot','en','should not');
INSERT INTO `lng_data` VALUES ('survey','dc_sometimes','en','sometimes');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglyagree','en','strongly agree');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglydesired','en','strongly desired');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglydisagree','en','strongly disagree');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglyundesired','en','strongly undesired');
INSERT INTO `lng_data` VALUES ('survey','dc_true','en','true');
INSERT INTO `lng_data` VALUES ('survey','dc_undecided','en','undecided');
INSERT INTO `lng_data` VALUES ('survey','dc_undesired','en','undesired');
INSERT INTO `lng_data` VALUES ('survey','dc_varying','en','varying');
INSERT INTO `lng_data` VALUES ('survey','dc_verygood','en','very good');
INSERT INTO `lng_data` VALUES ('survey','dc_yes','en','yes');
INSERT INTO `lng_data` VALUES ('survey','define_questionblock','en','Define question block');
INSERT INTO `lng_data` VALUES ('survey','delete_user_data','en','Delete the survey data of the selected users');
INSERT INTO `lng_data` VALUES ('survey','description_maxchars','en','If nothing entered the maximum number of characters for this text answer is unlimited.');
INSERT INTO `lng_data` VALUES ('survey','disinvite','en','Disinvite');
INSERT INTO `lng_data` VALUES ('survey','display_all_available','en','Display all available');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree5','en','Standard attitude (strongly agree-agree-undecided-disagree-strongly disagree)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree_disagree','en','Standard attitude (agree-disagree)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree_undecided_disagree','en','Standard attitude (agree-undecided-disagree)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired5','en','Standard attitude (strongly desired-desired-neutral-undesired-strongly undesired)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired_neutral_undesired','en','Standard attitude (desired-neutral-undesired)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired_undesired','en','Standard attitude (desired-undesired)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good5','en','Standard attitude (very good-good-fair-poor-not acceptable)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good_fair_notacceptable','en','Standard attitude (good-fair-not acceptable)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good_notacceptable','en','Standard attitude (good-not acceptable)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_must5','en','Standard attitude (must-should-undecided-should not-must not)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_shold_shouldnot','en','Standard attitude (should-should not)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_should_undecided_shouldnot','en','Standard attitude (should-undecided-should not)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_certainly5','en','Standard behavior (most certainly-more positive-undecided-more negative-most certainly not)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_yes_no','en','Standard behavior (yes-no)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_yes_undecided_no','en','Standard behavior (yes-undecided-no)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always5','en','Standard beliefs (always-many times-varying-rarely-never)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always_never','en','Standard beliefs (always-never)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always_sometimes_never','en','Standard beliefs (always-sometimes-never)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true5','en','Standard beliefs (definitely true-true-undecided-false-definitely false)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true_false','en','Standard beliefs (true-false)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true_undecided_false','en','Standard beliefs (true-undecided-false)');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_numbers','en','Standard numbers');
INSERT INTO `lng_data` VALUES ('survey','duplicate','en','Duplicate');
INSERT INTO `lng_data` VALUES ('survey','duplicate_svy','en','Duplicate survey');
INSERT INTO `lng_data` VALUES ('survey','edit_ask_continue','en','Do you want to continue and edit this question?');
INSERT INTO `lng_data` VALUES ('survey','edit_constraints_introduction','en','You have selected the following question(s)/question block(s) to edit the preconditions');
INSERT INTO `lng_data` VALUES ('survey','edit_heading','en','Edit heading');
INSERT INTO `lng_data` VALUES ('survey','end_date','en','End date');
INSERT INTO `lng_data` VALUES ('survey','end_date_reached','en','You cannot start the survey. The end date is reached!');
INSERT INTO `lng_data` VALUES ('survey','enter_anonymous_id','en','Survey access code');
INSERT INTO `lng_data` VALUES ('survey','enter_phrase_title','en','Please enter a phrase title');
INSERT INTO `lng_data` VALUES ('survey','enter_questionblock_title','en','Please enter a questionblock title!');
INSERT INTO `lng_data` VALUES ('survey','enter_valid_number_of_codes','en','Please enter a valid number to generate survey access codes!');
INSERT INTO `lng_data` VALUES ('survey','enter_value','en','Enter a value');
INSERT INTO `lng_data` VALUES ('survey','error_add_heading','en','Please add a heading!');
INSERT INTO `lng_data` VALUES ('survey','error_importing_question','en','There was an error importing the question(s) from the file you have selected!');
INSERT INTO `lng_data` VALUES ('survey','error_retrieving_anonymous_survey','en','The system could not find your survey data for survey code &quot;%s&quot;. Please check the survey code you have entered!');
INSERT INTO `lng_data` VALUES ('survey','eval_legend_link','en','Please refer to the legend for the meaning of the column header symbols.');
INSERT INTO `lng_data` VALUES ('survey','evaluation','en','Evaluation');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access','en','Evaluation access');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_all','en','Evaluation access for all users');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_info','en','You have access to the survey evaluation');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_participants','en','Evaluation access for survey participants');
INSERT INTO `lng_data` VALUES ('survey','existing_constraints','en','Existing preconditions');
INSERT INTO `lng_data` VALUES ('survey','exit','en','Exit');
INSERT INTO `lng_data` VALUES ('survey','exp_type_csv','en','Comma separated value (CSV)');
INSERT INTO `lng_data` VALUES ('survey','exp_type_excel','en','Microsoft Excel');
INSERT INTO `lng_data` VALUES ('survey','export_data_as','en','Export data as');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_category_fields','en','Please fill out all answer fields before you add a new one!');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_add_category','en','Please fill out all required fields before you add answers!');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_delete_category','en','Please fill out all required fields before you delete answers!');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_move_category','en','Please fill out all required fields before you move answers!');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_save_phrase','en','Please fill out all required fields before you save a phrase!');
INSERT INTO `lng_data` VALUES ('survey','filter','en','Filter');
INSERT INTO `lng_data` VALUES ('survey','filter_all_question_types','en','All question types');
INSERT INTO `lng_data` VALUES ('survey','filter_all_questionpools','en','All question pools');
INSERT INTO `lng_data` VALUES ('survey','filter_show_question_types','en','Show question types');
INSERT INTO `lng_data` VALUES ('survey','filter_show_questionpools','en','Show question pools');
INSERT INTO `lng_data` VALUES ('survey','form_data_modified_press_save','en','The form data has been modified. Press the save button to keep the changes.');
INSERT INTO `lng_data` VALUES ('survey','found_questions','en','Found questions');
INSERT INTO `lng_data` VALUES ('survey','geometric_mean','en','Geometric mean');
INSERT INTO `lng_data` VALUES ('survey','given_answers','en','Given answers');
INSERT INTO `lng_data` VALUES ('survey','glossary_term','en','Glossary term');
INSERT INTO `lng_data` VALUES ('survey','harmonic_mean','en','Harmonic mean');
INSERT INTO `lng_data` VALUES ('survey','heading','en','Heading');
INSERT INTO `lng_data` VALUES ('survey','horizontal','en','horizontal');
INSERT INTO `lng_data` VALUES ('survey','import_error_closing_file','en','Error closing the import file!');
INSERT INTO `lng_data` VALUES ('survey','import_error_opening_file','en','Error opening the import file!');
INSERT INTO `lng_data` VALUES ('survey','import_error_survey_no_proper_values','en','The survey properties do not contain proper values!');
INSERT INTO `lng_data` VALUES ('survey','import_error_survey_no_properties','en','No survey properties found. Cannot import the survey!');
INSERT INTO `lng_data` VALUES ('survey','import_no_file_selected','en','No file selected!');
INSERT INTO `lng_data` VALUES ('survey','import_question','en','Import question(s)');
INSERT INTO `lng_data` VALUES ('survey','import_wrong_file_type','en','Wrong file type!');
INSERT INTO `lng_data` VALUES ('survey','insert_after','en','Insert after');
INSERT INTO `lng_data` VALUES ('survey','insert_before','en','Insert before');
INSERT INTO `lng_data` VALUES ('survey','insert_missing_question','en','Please select at least one question to insert it into the survey!');
INSERT INTO `lng_data` VALUES ('survey','insert_missing_questionblock','en','Please select at least one question block to insert it into the survey!');
INSERT INTO `lng_data` VALUES ('survey','introduction','en','Introduction');
INSERT INTO `lng_data` VALUES ('survey','introduction_manage_phrases','en','Manage your own phrases which are available for all the ordinal questions you edit/create.');
INSERT INTO `lng_data` VALUES ('survey','invitation','en','Invitation');
INSERT INTO `lng_data` VALUES ('survey','invitation_mode','en','Invitation mode');
INSERT INTO `lng_data` VALUES ('survey','invite_participants','en','Invite participants');
INSERT INTO `lng_data` VALUES ('survey','invited_groups','en','Invited groups');
INSERT INTO `lng_data` VALUES ('survey','invited_users','en','Invited users');
INSERT INTO `lng_data` VALUES ('survey','label_resume_survey','en','Enter your 5 digit survey code');
INSERT INTO `lng_data` VALUES ('survey','last_update','en','Last update');
INSERT INTO `lng_data` VALUES ('survey','legend','en','Legend');
INSERT INTO `lng_data` VALUES ('survey','lower_limit','en','Lower limit');
INSERT INTO `lng_data` VALUES ('survey','maintenance','en','Maintenance');
INSERT INTO `lng_data` VALUES ('survey','manage_phrases','en','Manage phrases');
INSERT INTO `lng_data` VALUES ('survey','material','en','Material');
INSERT INTO `lng_data` VALUES ('survey','material_added_successfully','en','You successfully set a material link!');
INSERT INTO `lng_data` VALUES ('survey','material_file','en','Material file');
INSERT INTO `lng_data` VALUES ('survey','maxchars','en','Maximum number of characters');
INSERT INTO `lng_data` VALUES ('survey','maximum','en','Maximum value');
INSERT INTO `lng_data` VALUES ('survey','median','en','Median');
INSERT INTO `lng_data` VALUES ('survey','median_between','en','between');
INSERT INTO `lng_data` VALUES ('survey','menuback','en','Back');
INSERT INTO `lng_data` VALUES ('survey','menubacktosurvey','en','Back to the survey');
INSERT INTO `lng_data` VALUES ('survey','message_mail_survey_id','en','You have started the anonymized survey &quot;%s&quot;. To resume this survey you need the following 5 digit survey code:<br><br><strong>%s</strong><br><br>Resuming a survey is only possible, if you interrupt the survey before finishing it.');
INSERT INTO `lng_data` VALUES ('survey','metric_question_floating_point','en','The value you entered is a floating point value. Floating point values are not allowed for this question type!');
INSERT INTO `lng_data` VALUES ('survey','metric_question_not_a_value','en','The value you entered is not a numeric value!');
INSERT INTO `lng_data` VALUES ('survey','metric_question_out_of_bounds','en','The value you entered is not between the minimum and maximum value!');
INSERT INTO `lng_data` VALUES ('survey','minimum','en','Minimum value');
INSERT INTO `lng_data` VALUES ('survey','missing_upper_or_lower_limit','en','Please enter a lower and an upper limit!');
INSERT INTO `lng_data` VALUES ('survey','mode','en','Most selected value');
INSERT INTO `lng_data` VALUES ('survey','mode_nr_of_selections','en','Nr of selections');
INSERT INTO `lng_data` VALUES ('survey','mode_text','en','Most selected value (Text)');
INSERT INTO `lng_data` VALUES ('survey','multiple_choice_multiple_response','en','Multiple choice (multiple response)');
INSERT INTO `lng_data` VALUES ('survey','multiple_choice_single_response','en','Multiple choice (single response)');
INSERT INTO `lng_data` VALUES ('survey','new_survey_codes','en','new survey access code(s)');
INSERT INTO `lng_data` VALUES ('survey','next_question_rows','en','Questions %d - %d of %d >>');
INSERT INTO `lng_data` VALUES ('survey','no_available_constraints','en','There are no preconditions defined!');
INSERT INTO `lng_data` VALUES ('survey','no_category_selected_for_deleting','en','Please select a least one answer if you want to delete answers!');
INSERT INTO `lng_data` VALUES ('survey','no_category_selected_for_move','en','Please check at least one answer to move it!');
INSERT INTO `lng_data` VALUES ('survey','no_constraints_checked','en','Please select a least one question or question block to edit the preconditions!');
INSERT INTO `lng_data` VALUES ('survey','no_question_selected_for_move','en','Please check at least one question to move it!');
INSERT INTO `lng_data` VALUES ('survey','no_question_selected_for_removal','en','Please check at least one question or question block to remove it!');
INSERT INTO `lng_data` VALUES ('survey','no_questionblocks_available','en','There are no question blocks available');
INSERT INTO `lng_data` VALUES ('survey','no_questions_available','en','There are no questions available!');
INSERT INTO `lng_data` VALUES ('survey','no_search_results','en','There are no search results!');
INSERT INTO `lng_data` VALUES ('survey','no_target_selected_for_move','en','You must select a target position!');
INSERT INTO `lng_data` VALUES ('survey','no_user_or_group_selected','en','Please check an option what are you searching for (users and/or groups)!');
INSERT INTO `lng_data` VALUES ('survey','no_user_phrases_defined','en','There are no user defined phrases available!');
INSERT INTO `lng_data` VALUES ('survey','nominal_question_mr_not_checked','en','Please check at least one of the offered answers!');
INSERT INTO `lng_data` VALUES ('survey','nominal_question_not_checked','en','Please check one of the offered answers!');
INSERT INTO `lng_data` VALUES ('survey','non_ratio','en','Interval');
INSERT INTO `lng_data` VALUES ('survey','not_used','en','not used');
INSERT INTO `lng_data` VALUES ('survey','obligatory','en','obligatory');
INSERT INTO `lng_data` VALUES ('survey','off','en','off');
INSERT INTO `lng_data` VALUES ('survey','offline','en','offline');
INSERT INTO `lng_data` VALUES ('survey','on','en','on');
INSERT INTO `lng_data` VALUES ('survey','online','en','online');
INSERT INTO `lng_data` VALUES ('survey','or','en','or');
INSERT INTO `lng_data` VALUES ('survey','ordinal_question_not_checked','en','Please check one of the offered answers!');
INSERT INTO `lng_data` VALUES ('survey','orientation','en','Orientation');
INSERT INTO `lng_data` VALUES ('survey','outro','en','Final statement');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_entered_values','en','Percentage of users that entered this value');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_offered_answers','en','Percentage of offered answers');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_selections','en','Percentage of users that selected this answer');
INSERT INTO `lng_data` VALUES ('survey','phrase_saved','en','The phrase was saved successfully!');
INSERT INTO `lng_data` VALUES ('survey','please_select','en','-- please select --');
INSERT INTO `lng_data` VALUES ('survey','predefined_users','en','Predefined user set');
INSERT INTO `lng_data` VALUES ('survey','preview','en','Preview');
INSERT INTO `lng_data` VALUES ('survey','previous_question_rows','en','<< Questions %d - %d of %d');
INSERT INTO `lng_data` VALUES ('survey','qpl_confirm_delete_phrases','en','Are you sure you want to delete the following phrase(s)?');
INSERT INTO `lng_data` VALUES ('survey','qpl_confirm_delete_questions','en','Are you sure you want to delete the following question(s)?');
INSERT INTO `lng_data` VALUES ('survey','qpl_copy_select_none','en','Please check at least one question to copy it!');
INSERT INTO `lng_data` VALUES ('survey','qpl_define_questionblock_select_missing','en','Please select a least two questions if you want to define a question block!');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_phrase_select_none','en','Please check at least one phrase to delete it');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_rbac_error','en','You have no rights to delete the question(s)!');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_select_none','en','Please check at least one question to delete it!');
INSERT INTO `lng_data` VALUES ('survey','qpl_duplicate_select_none','en','Please check at least one question to duplicate it!');
INSERT INTO `lng_data` VALUES ('survey','qpl_export_select_none','en','Please check at least one question to export it');
INSERT INTO `lng_data` VALUES ('survey','qpl_past_questions_confirmation','en','Are you sure you want to paste the following question(s) in the question pool?');
INSERT INTO `lng_data` VALUES ('survey','qpl_phrases_deleted','en','Phrase(s) deleted.');
INSERT INTO `lng_data` VALUES ('survey','qpl_questions_deleted','en','Question(s) deleted.');
INSERT INTO `lng_data` VALUES ('survey','qpl_questions_pasted','en','Question(s) pasted.');
INSERT INTO `lng_data` VALUES ('survey','qpl_savephrase_empty','en','Please enter a phrase title!');
INSERT INTO `lng_data` VALUES ('survey','qpl_savephrase_exists','en','The phrase title already exists! Please enter another phrase title.');
INSERT INTO `lng_data` VALUES ('survey','qpl_unfold_select_none','en','Please select at least one question block if you want to unfold question blocks!');
INSERT INTO `lng_data` VALUES ('survey','question_contains_no_categories','en','There are no answers defined for this question');
INSERT INTO `lng_data` VALUES ('survey','question_has_constraints','en','Preconditions');
INSERT INTO `lng_data` VALUES ('survey','question_icon','en','Question icon');
INSERT INTO `lng_data` VALUES ('survey','question_obligatory','en','The question is obligatory!');
INSERT INTO `lng_data` VALUES ('survey','question_saved_for_upload','en','The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!');
INSERT INTO `lng_data` VALUES ('survey','question_type','en','Question type');
INSERT INTO `lng_data` VALUES ('survey','questionblock','en','Question block');
INSERT INTO `lng_data` VALUES ('survey','questionblock_has_constraints','en','Preconditions');
INSERT INTO `lng_data` VALUES ('survey','questionblock_icon','en','Questionblock icon');
INSERT INTO `lng_data` VALUES ('survey','questionblocks','en','Question blocks');
INSERT INTO `lng_data` VALUES ('survey','questions','en','Questions');
INSERT INTO `lng_data` VALUES ('survey','questions_inserted','en','Question(s) inserted!');
INSERT INTO `lng_data` VALUES ('survey','questions_removed','en','Question(s) and/or question block(s) removed!');
INSERT INTO `lng_data` VALUES ('survey','questiontype','en','Question type');
INSERT INTO `lng_data` VALUES ('survey','ratio_absolute','en','Ratio-Absolute');
INSERT INTO `lng_data` VALUES ('survey','ratio_non_absolute','en','Ratio-Non-Absolute');
INSERT INTO `lng_data` VALUES ('survey','ratio_scale_ge_zero','en','The minimum value for a ratio scale must be greater or equal zero');
INSERT INTO `lng_data` VALUES ('survey','remove_question','en','Remove');
INSERT INTO `lng_data` VALUES ('survey','remove_questions','en','Are you sure you want to remove the following question(s) and/or question block(s) from the survey?');
INSERT INTO `lng_data` VALUES ('survey','reset_filter','en','Reset filter');
INSERT INTO `lng_data` VALUES ('survey','resume_survey','en','Resume the survey');
INSERT INTO `lng_data` VALUES ('survey','save_back_to_survey','en','Save and go back to the survey');
INSERT INTO `lng_data` VALUES ('survey','save_obligatory_state','en','Save obligatory states');
INSERT INTO `lng_data` VALUES ('survey','save_phrase','en','Save as phrase');
INSERT INTO `lng_data` VALUES ('survey','save_phrase_categories_not_checked','en','Please check at least two answers to save answers in a new phrase!');
INSERT INTO `lng_data` VALUES ('survey','save_phrase_introduction','en','If you want to save the answers below as default phrase, please enter a phrase title. You can access a default phrase whenever you want to add a phrase to an ordinal question.');
INSERT INTO `lng_data` VALUES ('survey','search_field_all','en','Search in all fields');
INSERT INTO `lng_data` VALUES ('survey','search_for','en','Search for');
INSERT INTO `lng_data` VALUES ('survey','search_groups','en','Found groups');
INSERT INTO `lng_data` VALUES ('survey','search_invitation','en','Search for users or groups to invite');
INSERT INTO `lng_data` VALUES ('survey','search_questions','en','Search questions');
INSERT INTO `lng_data` VALUES ('survey','search_roles','en','Found roles');
INSERT INTO `lng_data` VALUES ('survey','search_term','en','Search term');
INSERT INTO `lng_data` VALUES ('survey','search_type_all','en','Search in all question types');
INSERT INTO `lng_data` VALUES ('survey','search_users','en','Found users');
INSERT INTO `lng_data` VALUES ('survey','select_option','en','--- Please select an option ---');
INSERT INTO `lng_data` VALUES ('survey','select_phrase_to_add','en','Please select a phrase to add it to the question!');
INSERT INTO `lng_data` VALUES ('survey','select_prior_question','en','Select a prior question');
INSERT INTO `lng_data` VALUES ('survey','select_questionpool','en','Please select a question pool to store the created question');
INSERT INTO `lng_data` VALUES ('survey','select_questionpool_short','en','Question pool for Survey');
INSERT INTO `lng_data` VALUES ('survey','select_relation','en','Select a relation');
INSERT INTO `lng_data` VALUES ('survey','select_svy_option','en','--- Please select a survey ---');
INSERT INTO `lng_data` VALUES ('survey','select_target_position_for_move','en','Please select a target position to move the answers and press one of the insert buttons!');
INSERT INTO `lng_data` VALUES ('survey','select_target_position_for_move_question','en','Please select a target position to move the question(s) and press one of the insert buttons!');
INSERT INTO `lng_data` VALUES ('survey','select_value','en','Select a value');
INSERT INTO `lng_data` VALUES ('survey','selection','en','Selection');
INSERT INTO `lng_data` VALUES ('survey','set_filter','en','Set filter');
INSERT INTO `lng_data` VALUES ('survey','skipped','en','skipped');
INSERT INTO `lng_data` VALUES ('survey','spl_general_properties','en','General properties');
INSERT INTO `lng_data` VALUES ('survey','spl_online_property','en','Online');
INSERT INTO `lng_data` VALUES ('survey','spl_online_property_description','en','If the questionpool is not online, it cannot be used in surveys.');
INSERT INTO `lng_data` VALUES ('survey','spl_select_file_for_import','en','You must select a file for import!');
INSERT INTO `lng_data` VALUES ('survey','start_date','en','Start date');
INSERT INTO `lng_data` VALUES ('survey','start_date_not_reached','en','You cannot start the survey until the start date is reached!');
INSERT INTO `lng_data` VALUES ('survey','start_survey','en','Start survey');
INSERT INTO `lng_data` VALUES ('survey','subject_mail_survey_id','en','Your survey code for \"%s\" ');
INSERT INTO `lng_data` VALUES ('survey','subtype','en','Subtype');
INSERT INTO `lng_data` VALUES ('survey','survey_code','en','Survey access code');
INSERT INTO `lng_data` VALUES ('survey','survey_code_message_sent','en','A survey code which allows you to resume the survey was sent to your INBOX!');
INSERT INTO `lng_data` VALUES ('survey','survey_code_no_codes','en','You have not created any survey access codes yet.');
INSERT INTO `lng_data` VALUES ('survey','survey_code_url','en','URL for direct access');
INSERT INTO `lng_data` VALUES ('survey','survey_code_url_name','en','URL (use right mouse button to copy URL)');
INSERT INTO `lng_data` VALUES ('survey','survey_code_used','en','Code was used');
INSERT INTO `lng_data` VALUES ('survey','survey_codes_lang','en','Language of the survey');
INSERT INTO `lng_data` VALUES ('survey','survey_error_insert_incomplete_question','en','You tried to add an incomplete question to the survey! The question was not added.');
INSERT INTO `lng_data` VALUES ('survey','survey_finish','en','Finish survey');
INSERT INTO `lng_data` VALUES ('survey','survey_finished','en','You have finished the survey. Thank you for your participation!');
INSERT INTO `lng_data` VALUES ('survey','survey_has_datasets_warning','en','The survey already contains datasets. You cannot edit the survey questions until you remove these datasets in the maintenance section.');
INSERT INTO `lng_data` VALUES ('survey','survey_is_offline','en','You cannot start the survey! The survey is offline.');
INSERT INTO `lng_data` VALUES ('survey','survey_next','en','Next >>');
INSERT INTO `lng_data` VALUES ('survey','survey_offline_message','en','Can\'t invite users. The survey is offline!');
INSERT INTO `lng_data` VALUES ('survey','survey_online_warning','en','The survey is online. You cannot edit the survey questions!');
INSERT INTO `lng_data` VALUES ('survey','survey_previous','en','<< Previous');
INSERT INTO `lng_data` VALUES ('survey','survey_question_obligatory','en','This question is obligatory. You must answer the question!');
INSERT INTO `lng_data` VALUES ('survey','survey_question_optional','en','(Optional)');
INSERT INTO `lng_data` VALUES ('survey','survey_questions','en','Questions');
INSERT INTO `lng_data` VALUES ('survey','survey_selected_user_data_deleted','en','The survey data of the selected user(s) was deleted successfully');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_finish','en','skip and finish survey');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_next','en','skip >>');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_previous','en','<< skip');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_start','en','skip and go to start page');
INSERT INTO `lng_data` VALUES ('survey','survey_start','en','Go to start page');
INSERT INTO `lng_data` VALUES ('survey','svy_all_user_data_deleted','en','All user data of this survey has been deleted!');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_access_introduction','en','Since this survey evaluation is only accessable by survey participants you need to enter your survey access code to open the evaluation.');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_authentication_needed','en','Authentication needed');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_wrong_key','en','You entered a wrong survey access code or you have not participated the survey. Your access to the survey evaluation is denied.');
INSERT INTO `lng_data` VALUES ('survey','svy_create_export_file','en','Create export file');
INSERT INTO `lng_data` VALUES ('survey','svy_delete_all_user_data','en','Delete all user data');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_cumulated','en','Cumulated results');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_detail','en','Cumulated results (details)');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_user','en','User specific results');
INSERT INTO `lng_data` VALUES ('survey','svy_export_files','en','Export files');
INSERT INTO `lng_data` VALUES ('survey','svy_file','en','File');
INSERT INTO `lng_data` VALUES ('survey','svy_general_properties','en','General properties');
INSERT INTO `lng_data` VALUES ('survey','svy_maintenance_information_no_results','en','There are no existing user datasets for the survey. You need at least one user dataset to maintain the data.');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_author','en','You have not entered the author\'s name in the survey properties! Please add an authors name.');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_questions','en','You do not have any questions in the survey! Please add at least one question to the survey.');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_title','en','You have not entered a survey title! Please go to the metadata section and enter a title.');
INSERT INTO `lng_data` VALUES ('survey','svy_page_error','en','There was an error answering a survey question. Please refer to the question to get more information on the error!');
INSERT INTO `lng_data` VALUES ('survey','svy_page_errors','en','There were errors answering the survey questions. Please refer to the questions to get more information on the errors!');
INSERT INTO `lng_data` VALUES ('survey','svy_select_file_for_import','en','You must select a file for import!');
INSERT INTO `lng_data` VALUES ('survey','svy_select_questionpools','en','Please select a question pool to store the imported questions');
INSERT INTO `lng_data` VALUES ('survey','svy_select_surveys','en','Please select a survey for duplication');
INSERT INTO `lng_data` VALUES ('survey','svy_selected_user_data_deleted','en','The survey data of the selected user(s) was deleted successfully');
INSERT INTO `lng_data` VALUES ('survey','svy_show_questiontitles','en','Show question titles in survey');
INSERT INTO `lng_data` VALUES ('survey','svy_size','en','Size');
INSERT INTO `lng_data` VALUES ('survey','svy_statistical_evaluation','en','Statistical evaluation');
INSERT INTO `lng_data` VALUES ('survey','svy_status_missing','en','There are required elements missing in this survey!');
INSERT INTO `lng_data` VALUES ('survey','svy_status_missing_elements','en','The following elements are missing:');
INSERT INTO `lng_data` VALUES ('survey','svy_status_ok','en','The status of the survey is OK. There are no missing elements.');
INSERT INTO `lng_data` VALUES ('survey','text_maximum_chars_allowed','en','Please do not enter more than a maximum of %s characters. Any characters above will be cut.');
INSERT INTO `lng_data` VALUES ('survey','text_question_not_filled_out','en','Please fill out the answer field!');
INSERT INTO `lng_data` VALUES ('survey','text_resume_survey','en','You are trying to resume an anonymized survey. To continue the survey with your previously entered values please enter the 5 digit survey code which you received after starting the survey (it was sent with a message to your ILIAS mail folder). Instead of typing your survey code you also can copy it from your inbox and paste it into the text field below.');
INSERT INTO `lng_data` VALUES ('survey','title_resume_survey','en','Resume the survey - Enter survey code');
INSERT INTO `lng_data` VALUES ('survey','unfold','en','Unfold');
INSERT INTO `lng_data` VALUES ('survey','unlimited_users','en','Unlimited');
INSERT INTO `lng_data` VALUES ('survey','uploaded_material','en','Uploaded Material');
INSERT INTO `lng_data` VALUES ('survey','upper_limit','en','Upper limit');
INSERT INTO `lng_data` VALUES ('survey','upper_limit_must_be_greater','en','The upper limit must be greater than the lower limit!');
INSERT INTO `lng_data` VALUES ('survey','used','en','used');
INSERT INTO `lng_data` VALUES ('survey','users_answered','en','Users answered');
INSERT INTO `lng_data` VALUES ('survey','users_skipped','en','Users skipped');
INSERT INTO `lng_data` VALUES ('survey','value_nr_entered','en','Number of users that entered that value');
INSERT INTO `lng_data` VALUES ('survey','values','en','Values');
INSERT INTO `lng_data` VALUES ('survey','vertical','en','vertical');
INSERT INTO `lng_data` VALUES ('survey','view_constraints_introduction','en','You are viewing the preconditions of the following question/question block:');
INSERT INTO `lng_data` VALUES ('survey','view_phrase','en','View phrase');
INSERT INTO `lng_data` VALUES ('survey','warning_question_in_use','en','Warning! The question you want to edit is in use by the surveys listed below. If you decide to continue and save/apply the question, all answers of the surveys listed below will be deleted. If you want to change the question and use it in another survey, please choose duplicate in the question browser to create a new instance of this question.');
INSERT INTO `lng_data` VALUES ('survey','warning_question_not_complete','en','The question is not complete!');
INSERT INTO `lng_data` VALUES ('survey','wrong_categories_selected_for_insert','en','ILIAS could not perform the desired action. Please check exactly one answer as target position!');
INSERT INTO `lng_data` VALUES ('survey','wrong_survey_code_used','en','You cannot enter the survey, because you tried to start it with an unauthorized survey code.');
INSERT INTO `lng_data` VALUES ('trac','found_objects','en','Found objects');
INSERT INTO `lng_data` VALUES ('trac','found_too_much_objects','en','Thereby more than %s objects totally were found. Therefore refine your search request, please.');
INSERT INTO `lng_data` VALUES ('trac','info_all_objects','en','The following user tracking refers to all objects of the type \'%s\'.');
INSERT INTO `lng_data` VALUES ('trac','info_dwell_time','en','Attention: The total dwell time of an object isn\'t addicted to the given period of time!');
INSERT INTO `lng_data` VALUES ('trac','info_found_objects','en','The user tracking refers to the following objects of the type \'%s\' that were found according to your search terms.');
INSERT INTO `lng_data` VALUES ('trac','info_valid_request','en','The maximum valid time between two requests of an user.');
INSERT INTO `lng_data` VALUES ('trac','last_login','en','Last login');
INSERT INTO `lng_data` VALUES ('trac','meta_typical_learning_time','en','Typical learning time');
INSERT INTO `lng_data` VALUES ('trac','newUT_settings','en','Learning Module Statistics');
INSERT INTO `lng_data` VALUES ('trac','obj_types','en','Object Types');
INSERT INTO `lng_data` VALUES ('trac','search_area_info','en','Please choose one object.');
INSERT INTO `lng_data` VALUES ('trac','search_terms','en','Search term(s)');
INSERT INTO `lng_data` VALUES ('trac','select_one','en','Please select one object');
INSERT INTO `lng_data` VALUES ('trac','stats_access','en','Access');
INSERT INTO `lng_data` VALUES ('trac','stats_accesses','en','Accesses');
INSERT INTO `lng_data` VALUES ('trac','stats_all','en','All');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter','en','Chapter');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_average_page_number','en','Average Number of Pages per Chapter');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_depth_coverage','en','Degree of Coverage with Depth');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_fewest_access','en','Fewest Access');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_listing','en','Chapter Listing');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_longest_total_dwell_time_depth','en','Total Dwell Time Depth');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_most_access_depth','en','Most Access with Depth');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_most_pages','en','Most Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_number','en','Number of Chapters');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_statisics','en','Chapter Statistics');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_stubbiest_total_dwell_time','en','Stubbiest Total Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_top','en','Top-Chapter (variance, access, etc.)');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_total_statistic','en','Total-Chapter-Statistic');
INSERT INTO `lng_data` VALUES ('trac','stats_choice','en','Selection');
INSERT INTO `lng_data` VALUES ('trac','stats_current','en','Currently');
INSERT INTO `lng_data` VALUES ('trac','stats_depth','en','Depth');
INSERT INTO `lng_data` VALUES ('trac','stats_duration','en','Duration');
INSERT INTO `lng_data` VALUES ('trac','stats_equivalent','en','is equivalent to');
INSERT INTO `lng_data` VALUES ('trac','stats_hits','en','Hits');
INSERT INTO `lng_data` VALUES ('trac','stats_hour','en','h');
INSERT INTO `lng_data` VALUES ('trac','stats_interval','en','Interval');
INSERT INTO `lng_data` VALUES ('trac','stats_interval_dwell_time','en','Interval of Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_interval_page_access','en','Interval of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_last','en','Last');
INSERT INTO `lng_data` VALUES ('trac','stats_legend','en','Legend');
INSERT INTO `lng_data` VALUES ('trac','stats_measurable_hits','en','Measurable Hits (Hits within a Session)');
INSERT INTO `lng_data` VALUES ('trac','stats_minute','en','m');
INSERT INTO `lng_data` VALUES ('trac','stats_navigation','en','Navigation/Observation Model (requires JRE 1.5 or higher)');
INSERT INTO `lng_data` VALUES ('trac','stats_new_selection','en','New Selection');
INSERT INTO `lng_data` VALUES ('trac','stats_occurrence','en','Occurrence');
INSERT INTO `lng_data` VALUES ('trac','stats_of','en','of');
INSERT INTO `lng_data` VALUES ('trac','stats_page','en','Page');
INSERT INTO `lng_data` VALUES ('trac','stats_page_average_access','en','Average of Access to pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_average_dwell_time','en','Average of Dwell Time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_deviation_access','en','Deviation of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_deviation_dwell_time','en','Deviation of Dwell Time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_fewest_access','en','Fewest Access');
INSERT INTO `lng_data` VALUES ('trac','stats_page_highest_deviation','en','Highest Deviation');
INSERT INTO `lng_data` VALUES ('trac','stats_page_highest_varcoeff','en','Highest Variation Coefficient');
INSERT INTO `lng_data` VALUES ('trac','stats_page_least_deviation','en','Least Deviation');
INSERT INTO `lng_data` VALUES ('trac','stats_page_listing','en','Page Listing');
INSERT INTO `lng_data` VALUES ('trac','stats_page_longest_average_dwell_time','en','Average Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_page_longest_total_dwell_time','en','Total Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_page_lowest_varcoeff','en','Lowest Variation Coefficient');
INSERT INTO `lng_data` VALUES ('trac','stats_page_median_access','en','Median of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_median_dwell_time','en','Median of Dwell Time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_mode_access','en','Mode of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_most_access','en','Most Accesses');
INSERT INTO `lng_data` VALUES ('trac','stats_page_number','en','Number of Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_number_access','en','Number of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_range_access','en','Range of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_range_dwell_time','en','Range of Dwell Time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_stubbiest_average_dwell_time','en','Stubbiest Average Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_page_stubbiest_total_dwell_time','en','Stubbiest Total Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','stats_page_total_dwell_time','en','Total-Pages-Dwell time');
INSERT INTO `lng_data` VALUES ('trac','stats_page_total_statistic','en','Total-Pages-Statistic');
INSERT INTO `lng_data` VALUES ('trac','stats_page_varcoeff_access','en','Variation Coefficient of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_varcoeff_dwell_time','en','Variation Coefficient of Dwell time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_variance_access','en','Variance of Access to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_page_variance_dwell_time','en','Variance of Dwell Time to Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_pages','en','Pages');
INSERT INTO `lng_data` VALUES ('trac','stats_pages_statisics','en','Page Statistics');
INSERT INTO `lng_data` VALUES ('trac','stats_sec','en','sec');
INSERT INTO `lng_data` VALUES ('trac','stats_sel_lng','en','English');
INSERT INTO `lng_data` VALUES ('trac','stats_session','en','Session');
INSERT INTO `lng_data` VALUES ('trac','stats_session_average_length','en','Average Session Length');
INSERT INTO `lng_data` VALUES ('trac','stats_session_average_page_access','en','Average Access to Pages per Session');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable','en','Evaluable Sessions');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable_access','en','Evaluable Session Access');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable_usr','en','Evaluable User');
INSERT INTO `lng_data` VALUES ('trac','stats_session_involved_usr','en','Number of involved Users');
INSERT INTO `lng_data` VALUES ('trac','stats_session_listing','en','Session Listing');
INSERT INTO `lng_data` VALUES ('trac','stats_session_longest','en','Longest Session');
INSERT INTO `lng_data` VALUES ('trac','stats_session_longest_total_duration_usr','en','Longest Total Duration per User');
INSERT INTO `lng_data` VALUES ('trac','stats_session_most','en','Most Sessions');
INSERT INTO `lng_data` VALUES ('trac','stats_session_number','en','Number of Sessions');
INSERT INTO `lng_data` VALUES ('trac','stats_session_total_duration','en','Total Duration of all Sessions');
INSERT INTO `lng_data` VALUES ('trac','stats_session_total_statistic','en','Total-Session-Statistic');
INSERT INTO `lng_data` VALUES ('trac','stats_sessions','en','Sessions');
INSERT INTO `lng_data` VALUES ('trac','stats_sessions_statisics','en','Session Statistics');
INSERT INTO `lng_data` VALUES ('trac','stats_start','en','Start');
INSERT INTO `lng_data` VALUES ('trac','stats_summation','en','Summation');
INSERT INTO `lng_data` VALUES ('trac','stats_tracked_user','en','Selected Users');
INSERT INTO `lng_data` VALUES ('trac','stats_until','en','until');
INSERT INTO `lng_data` VALUES ('trac','stats_user','en','User(s)');
INSERT INTO `lng_data` VALUES ('trac','stats_user_selected','en','User selected');
INSERT INTO `lng_data` VALUES ('trac','stats_with','en','with');
INSERT INTO `lng_data` VALUES ('trac','total_dwell_time','en','Total Dwell Time');
INSERT INTO `lng_data` VALUES ('trac','trac_activated','en','Tracking activated');
INSERT INTO `lng_data` VALUES ('trac','trac_active_both','en','User Tracking and Learning progress activated');
INSERT INTO `lng_data` VALUES ('trac','trac_active_lp_only','en','Learning Progress activated');
INSERT INTO `lng_data` VALUES ('trac','trac_active_ut_only','en','User Tracking activated');
INSERT INTO `lng_data` VALUES ('trac','trac_added_no_shown_list','en','The selected objects will be hidden.');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized','en','Anonymized');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized_info','en','If enabled, all statistics will be anonymized.');
INSERT INTO `lng_data` VALUES ('trac','trac_assigned','en','Assigned');
INSERT INTO `lng_data` VALUES ('trac','trac_assignments','en','Assignments');
INSERT INTO `lng_data` VALUES ('trac','trac_below','en','Below:');
INSERT INTO `lng_data` VALUES ('trac','trac_collection_assign','en','Assign');
INSERT INTO `lng_data` VALUES ('trac','trac_collection_deassign','en','Deassign');
INSERT INTO `lng_data` VALUES ('trac','trac_comment','en','Comment');
INSERT INTO `lng_data` VALUES ('trac','trac_comments','en','Comments');
INSERT INTO `lng_data` VALUES ('trac','trac_completed','en','Completed');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_assignments','en','Assignment of course items');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_items','en','Assignable course items');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_members','en','Course members:');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_objects','en','Learning progress of course members');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_releavant_items','en','Course items');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_relevant_items','en','Course Materials');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_collection','en','Please assign materials. If the status of all assigned items is \'Completed\' the overall status is completed by the user.');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_progress','en','Edit learning progress');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_time','en','Processing time');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_visits','en','Please define the number of visits that is neccessary to complete this object.');
INSERT INTO `lng_data` VALUES ('trac','trac_edited_scos','en','Processed content');
INSERT INTO `lng_data` VALUES ('trac','trac_editing_time_passed','en','Editing time Passed');
INSERT INTO `lng_data` VALUES ('trac','trac_failed','en','Failed');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_area','en','Area');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_hidden','en','Hidden');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_limit_reached','en','The number of hits is limited to %s. Please use the filter to reduce the hits.');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_no_access','en','No objects found');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_none','en','None');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_repository','en','In the repository');
INSERT INTO `lng_data` VALUES ('trac','trac_fold_relevant_items','en','Folder Content');
INSERT INTO `lng_data` VALUES ('trac','trac_grp_relevant_items','en','Group Materials');
INSERT INTO `lng_data` VALUES ('trac','trac_head_timing','en','Edit Until');
INSERT INTO `lng_data` VALUES ('trac','trac_hide','en','Hide');
INSERT INTO `lng_data` VALUES ('trac','trac_in_progress','en','In progress');
INSERT INTO `lng_data` VALUES ('trac','trac_inactive_both','en','User Tracking and Learning progress deactivated');
INSERT INTO `lng_data` VALUES ('trac','trac_info_edited','en','Set the status to \'Completed\' if you think you have processed all content.');
INSERT INTO `lng_data` VALUES ('trac','trac_last_access','en','Last access');
INSERT INTO `lng_data` VALUES ('trac','trac_learning_progress','en','Learning Progress');
INSERT INTO `lng_data` VALUES ('trac','trac_learning_progress_tbl_header','en','Learning progress of:');
INSERT INTO `lng_data` VALUES ('trac','trac_lm_statistics','en','Access Statistics');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination','en','Learning Progress Status Determination');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination_info_crs','en','Select the items that determine the overall learning progress status.');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination_info_sco','en','Select the items that determine the overall learning progress status of the SCORM learning module.');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_filter','en','Filter');
INSERT INTO `lng_data` VALUES ('trac','trac_mark','en','Mark');
INSERT INTO `lng_data` VALUES ('trac','trac_marks','en','Marks');
INSERT INTO `lng_data` VALUES ('trac','trac_mode','en','Mode');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_collection','en','Collection of objects');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_deactivated','en','Deactivated');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_exercise_returned','en','Exercise Solved');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_manual','en','Manual');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_objectives','en','Learning objectives');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm','en','SCORM/AICC');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm_aicc','en','SCORM/AICC');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_finished','en','Test finished');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_passed','en','Test passed');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_tlt','en','Typical learning time');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_visits','en','Number of visits');
INSERT INTO `lng_data` VALUES ('trac','trac_modifications_saved','en','Saved settings');
INSERT INTO `lng_data` VALUES ('trac','trac_modus','en','Mode');
INSERT INTO `lng_data` VALUES ('trac','trac_no_attempted','en','Not attempted');
INSERT INTO `lng_data` VALUES ('trac','trac_no_content','en','No informations about the learning progress available.');
INSERT INTO `lng_data` VALUES ('trac','trac_no_sahs_items_found','en','No objects found.');
INSERT INTO `lng_data` VALUES ('trac','trac_not_accessed','en','Not accessed');
INSERT INTO `lng_data` VALUES ('trac','trac_not_assigned','en','Not assigned');
INSERT INTO `lng_data` VALUES ('trac','trac_not_attempted','en','Not attempted');
INSERT INTO `lng_data` VALUES ('trac','trac_not_completed','en','Not Completed');
INSERT INTO `lng_data` VALUES ('trac','trac_not_participated','en','Not Participated');
INSERT INTO `lng_data` VALUES ('trac','trac_not_registered','en','Not Registered');
INSERT INTO `lng_data` VALUES ('trac','trac_num_visits','en','Number of visits');
INSERT INTO `lng_data` VALUES ('trac','trac_objects','en','Learning Progress of Users');
INSERT INTO `lng_data` VALUES ('trac','trac_occurrences','en','Path:');
INSERT INTO `lng_data` VALUES ('trac','trac_participated','en','Participated');
INSERT INTO `lng_data` VALUES ('trac','trac_processing_time','en','Assumed processing time');
INSERT INTO `lng_data` VALUES ('trac','trac_progress','en','Personal Learning Progress');
INSERT INTO `lng_data` VALUES ('trac','trac_query','en','Title / Description:');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_objectives','en','Reached Learning Objectives');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_points','en','Achieved score');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_visits','en','Required visits');
INSERT INTO `lng_data` VALUES ('trac','trac_refresh','en','Refresh');
INSERT INTO `lng_data` VALUES ('trac','trac_registered','en','Registered');
INSERT INTO `lng_data` VALUES ('trac','trac_required_visits','en','Number of required visits');
INSERT INTO `lng_data` VALUES ('trac','trac_sahs_relevant_items','en','Content Items');
INSERT INTO `lng_data` VALUES ('trac','trac_select_one','en','You made no selection');
INSERT INTO `lng_data` VALUES ('trac','trac_settings','en','Settings');
INSERT INTO `lng_data` VALUES ('trac','trac_settings_saved','en','Saved settings.');
INSERT INTO `lng_data` VALUES ('trac','trac_show','en','Show learning progress');
INSERT INTO `lng_data` VALUES ('trac','trac_show_hidden','en','Show');
INSERT INTO `lng_data` VALUES ('trac','trac_spent_time','en','Spent time');
INSERT INTO `lng_data` VALUES ('trac','trac_status','en','Status');
INSERT INTO `lng_data` VALUES ('trac','trac_time_passed','en','Editing Time Exceeded');
INSERT INTO `lng_data` VALUES ('trac','trac_total_online','en','Total time online');
INSERT INTO `lng_data` VALUES ('trac','trac_update_edit_user','en','Saved settings');
INSERT INTO `lng_data` VALUES ('trac','trac_updated_status','en','Saved learning progress status.');
INSERT INTO `lng_data` VALUES ('trac','trac_user_data','en','User Data ');
INSERT INTO `lng_data` VALUES ('trac','trac_usr_list','en','Users');
INSERT INTO `lng_data` VALUES ('trac','trac_valid_request','en','Max. time between requests');
INSERT INTO `lng_data` VALUES ('trac','trac_view_crs','en','Back to course');
INSERT INTO `lng_data` VALUES ('trac','trac_view_list','en','Back to list');
INSERT INTO `lng_data` VALUES ('trac','trac_visits','en','Number of visits');
INSERT INTO `lng_data` VALUES ('trac','trac_visits_info','en','Every page visit counts as one visit.');
INSERT INTO `lng_data` VALUES ('trac','tracking_time_span_not_valid','en','Please enter a valid number of seconds.');
INSERT INTO `lng_data` VALUES ('trac','view_mode','en','View mode');
INSERT INTO `lng_data` VALUES ('trac','vm_access_of_users','en','Access of users');
INSERT INTO `lng_data` VALUES ('trac','vm_days_of_period','en','Days of period');
INSERT INTO `lng_data` VALUES ('trac','vm_times_of_day','en','Times of days');
INSERT INTO `lng_data` VALUES ('common','adopt_perm_from_template','en','Copy Permission Settings');
INSERT INTO `lng_data` VALUES ('crs','crs_mail_permanent_link','en','Choose the following link to access the course content:');
INSERT INTO `lng_data` VALUES ('grp','crs_add_grouping','en','Add Membership Limitation');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_enter_title','en','Please fill out all required fields.');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_added_grouping','en','Added new membership limitation.');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_delete_sure','en','Are you sure you want to delete this membership limitation ?');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_deleted','en','Deleted membership limitation.');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_added_grouping','en','Added new membership limitation.');
INSERT INTO `lng_data` VALUES ('common','edit_grouping','en','Edit Membership Limitation');
INSERT INTO `lng_data` VALUES ('crs','grouping_change_assignment','en','Change Assignment');
INSERT INTO `lng_data` VALUES ('common','grouping_select_exactly_one','en','Please choose exactly one membership limitation.');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_table_assigned_courses','en','Assigned Groups');
INSERT INTO `lng_data` VALUES ('grp','grouping_change_assignment','en','Change Assignment');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_assign_crs','en','Assignment of Groups');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_no_courses_assigned','en','No Groups Assigned');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_select_one','en','Please select one membership limitation.');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_info_reg','en','You can only register to one of this groups:');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized_info_short','en','(Anonymized)');
INSERT INTO `lng_data` VALUES ('barometer','barometer_add','en','Add new Feedback');

--
-- Table structure for table `lng_modules`
--

CREATE TABLE `lng_modules` (
  `module` varchar(30) NOT NULL default '',
  `lang_key` char(2) NOT NULL default '',
  `lang_array` mediumtext,
  PRIMARY KEY  (`module`,`lang_key`)
) TYPE=MyISAM;

--
-- Dumping data for table `lng_modules`
--

INSERT INTO `lng_modules` VALUES ('administration','en','a:65:{s:16:\"analysis_options\";s:16:\"Analysis options\";s:12:\"analyze_data\";s:33:\"Analyze and repair data integrity\";s:9:\"analyzing\";s:12:\"Analyzing...\";s:24:\"analyzing_tree_structure\";s:27:\"Analyzing tree structure...\";s:10:\"check_tree\";s:20:\"Check tree structure\";s:15:\"check_tree_desc\";s:89:\"Check consistence of entire tree structure. Depending on tree size this may take a while!\";s:5:\"clean\";s:8:\"Clean up\";s:10:\"clean_desc\";s:76:\"Remove invalid references & tree entries. Initialize gaps in tree structure.\";s:8:\"cleaning\";s:11:\"Cleaning...\";s:14:\"cleaning_final\";s:17:\"Final cleaning...\";s:8:\"disabled\";s:8:\"Disabled\";s:4:\"done\";s:4:\"Done\";s:9:\"dump_tree\";s:9:\"Dump tree\";s:14:\"dump_tree_desc\";s:82:\"Perform an analysis of the tree and print all tree nodes along with analysis data.\";s:12:\"dumping_tree\";s:15:\"Dumping tree...\";s:5:\"found\";s:6:\"found.\";s:10:\"found_none\";s:11:\"none found.\";s:17:\"initializing_gaps\";s:28:\"Initializing gaps in tree...\";s:8:\"log_scan\";s:16:\"Log scan results\";s:13:\"log_scan_desc\";s:61:\"Write scan results to \'scanlog.log\' in client data directory.\";s:16:\"nothing_to_purge\";s:19:\"Nothing to purge...\";s:17:\"nothing_to_remove\";s:20:\"Nothing to remove...\";s:18:\"nothing_to_restore\";s:21:\"Nothing to restore...\";s:7:\"options\";s:7:\"Options\";s:14:\"output_options\";s:14:\"Output options\";s:20:\"passwd_auto_generate\";s:30:\"Password Forwarding/Generation\";s:13:\"purge_missing\";s:21:\"Purge missing objects\";s:18:\"purge_missing_desc\";s:57:\"Remove all missing and unbound objects found from system.\";s:11:\"purge_trash\";s:21:\"Purge deleted objects\";s:16:\"purge_trash_desc\";s:44:\"Remove all objects in trash bin from system.\";s:7:\"purging\";s:10:\"Purging...\";s:20:\"purging_missing_objs\";s:26:\"Purging missing objects...\";s:13:\"purging_trash\";s:16:\"Purging trash...\";s:20:\"purging_unbound_objs\";s:26:\"Purging unbound objects...\";s:23:\"removing_invalid_childs\";s:32:\"Removing invalid tree entries...\";s:21:\"removing_invalid_refs\";s:30:\"Removing invalid references...\";s:22:\"removing_invalid_rolfs\";s:31:\"Removing invalid rolefolders...\";s:14:\"repair_options\";s:14:\"Repair options\";s:15:\"restore_missing\";s:23:\"Restore missing objects\";s:20:\"restore_missing_desc\";s:54:\"Restore missing and unbound objects to RecoveryFolder.\";s:13:\"restore_trash\";s:23:\"Restore deleted objects\";s:18:\"restore_trash_desc\";s:51:\"Restore all objects in trash bin to RecoveryFolder.\";s:9:\"restoring\";s:12:\"Restoring...\";s:22:\"restoring_missing_objs\";s:28:\"Restoring missing objects...\";s:15:\"restoring_trash\";s:18:\"Restoring trash...\";s:22:\"restoring_unbound_objs\";s:41:\"Restoring unbound objects & subobjects...\";s:4:\"scan\";s:4:\"Scan\";s:14:\"scan_completed\";s:14:\"Scan completed\";s:9:\"scan_desc\";s:58:\"Scan system for corrupted/invalid/missing/unbound objects.\";s:12:\"scan_details\";s:12:\"Scan details\";s:10:\"scan_modes\";s:15:\"Scan modes used\";s:15:\"scanning_system\";s:18:\"Scanning system...\";s:22:\"searching_deleted_objs\";s:32:\"Searching for deleted objects...\";s:24:\"searching_invalid_childs\";s:37:\"Searching for invalid tree entries...\";s:22:\"searching_invalid_refs\";s:35:\"Searching for invalid references...\";s:23:\"searching_invalid_rolfs\";s:36:\"Searching for invalid rolefolders...\";s:22:\"searching_missing_objs\";s:32:\"Searching for missing objects...\";s:22:\"searching_unbound_objs\";s:32:\"Searching for unbound objects...\";s:7:\"skipped\";s:7:\"skipped\";s:10:\"start_scan\";s:6:\"Start!\";s:9:\"stop_scan\";s:5:\"Stop!\";s:11:\"systemcheck\";s:12:\"System check\";s:12:\"tree_corrupt\";s:44:\"Tree is corrupted! See scan log for details.\";s:13:\"view_last_log\";s:18:\"View last Scan log\";s:8:\"view_log\";s:12:\"View details\";}');
INSERT INTO `lng_modules` VALUES ('assessment','en','a:631:{s:11:\"0_unlimited\";s:13:\"(0=unlimited)\";s:6:\"action\";s:6:\"Action\";s:10:\"add_answer\";s:10:\"Add answer\";s:13:\"add_answer_tf\";s:18:\"true/false answers\";s:13:\"add_answer_yn\";s:14:\"yes/no answers\";s:20:\"add_applet_parameter\";s:20:\"Add applet parameter\";s:8:\"add_area\";s:8:\"Add area\";s:7:\"add_gap\";s:12:\"Add Gap Text\";s:12:\"add_imagemap\";s:16:\"Import image map\";s:17:\"add_matching_pair\";s:17:\"Add matching pair\";s:16:\"add_questionpool\";s:17:\"Add question pool\";s:12:\"add_solution\";s:22:\"Add suggested solution\";s:28:\"all_available_question_pools\";s:28:\"All available question pools\";s:6:\"answer\";s:6:\"Answer\";s:34:\"answer_is_not_correct_but_positive\";s:66:\"You\'ve got points for your solution but it\'s not the best solution\";s:15:\"answer_is_right\";s:24:\"Your solution is correct\";s:15:\"answer_is_wrong\";s:22:\"Your solution is wrong\";s:14:\"answer_picture\";s:14:\"Answer picture\";s:11:\"answer_text\";s:11:\"Answer text\";s:17:\"applet_attributes\";s:17:\"Applet attributes\";s:20:\"applet_new_parameter\";s:13:\"New parameter\";s:16:\"applet_parameter\";s:9:\"Parameter\";s:17:\"applet_parameters\";s:17:\"Applet parameters\";s:5:\"apply\";s:5:\"Apply\";s:12:\"assClozeTest\";s:14:\"Cloze Question\";s:19:\"assImagemapQuestion\";s:18:\"Image Map Question\";s:13:\"assJavaApplet\";s:20:\"Java Applet Question\";s:19:\"assMatchingQuestion\";s:17:\"Matching Question\";s:17:\"assMultipleChoice\";s:44:\"Multiple Choice Question (multiple response)\";s:10:\"assNumeric\";s:16:\"Numeric question\";s:19:\"assOrderingQuestion\";s:17:\"Ordering Question\";s:12:\"assQuestions\";s:9:\"Questions\";s:15:\"assSingleChoice\";s:42:\"Multiple Choice Question (single response)\";s:15:\"assTextQuestion\";s:14:\"Essay Question\";s:13:\"assTextSubset\";s:20:\"Text subset question\";s:22:\"ass_create_export_file\";s:18:\"Create export file\";s:30:\"ass_create_export_test_results\";s:19:\"Export test results\";s:16:\"ass_export_files\";s:12:\"Export files\";s:8:\"ass_file\";s:4:\"File\";s:12:\"ass_question\";s:8:\"Question\";s:8:\"ass_size\";s:4:\"Size\";s:16:\"available_points\";s:16:\"Available points\";s:22:\"average_reached_points\";s:22:\"Average reached points\";s:17:\"backtocallingtest\";s:24:\"Back to the calling test\";s:2:\"by\";s:2:\"by\";s:11:\"cancel_test\";s:16:\"Suspend the test\";s:17:\"cannot_edit_marks\";s:154:\"There are already learners who ran the test. You can only change the marks if a score reporting date is enabled and the reporting date is not yet reached.\";s:16:\"cannot_edit_test\";s:59:\"You do not possess sufficient permissions to edit the test!\";s:19:\"cannot_execute_test\";s:58:\"You do not possess sufficient permissions to run the test!\";s:17:\"cannot_export_qpl\";s:70:\"You do not possess sufficient permissions to export the question pool!\";s:18:\"cannot_export_test\";s:61:\"You do not possess sufficient permissions to export the test!\";s:20:\"cannot_maintain_test\";s:63:\"You do not possess sufficient permissions to maintain the test!\";s:24:\"cannot_read_questionpool\";s:73:\"You do not possess sufficient permissions to read the question pool data!\";s:22:\"cannot_save_metaobject\";s:64:\"You do not possess sufficient permissions to save the meta data!\";s:41:\"change_properties_from_random_to_standard\";s:237:\"You are about to change your test properties from a random test to a non random test. The information on the question pools you already added to the random test will be removed from test. Do you really want to change the test properties?\";s:41:\"change_properties_from_standard_to_random\";s:257:\"You are about to change your test properties from a non random test to a random test. The questions you already added to the test will be removed, because you have to select question pools for a random test. Do you really want to change the test properties?\";s:15:\"change_solution\";s:25:\"Change suggested solution\";s:21:\"changelog_description\";s:86:\"The following table contains all changes of authors which have been made to this test.\";s:17:\"changelog_heading\";s:9:\"Changelog\";s:16:\"checkbox_checked\";s:7:\"Checked\";s:18:\"checkbox_unchecked\";s:9:\"Unchecked\";s:6:\"circle\";s:6:\"Circle\";s:19:\"circle_click_center\";s:43:\"Please click on center of the desired area.\";s:19:\"circle_click_circle\";s:51:\"Please click on a circle point of the desired area.\";s:8:\"clientip\";s:9:\"Client IP\";s:15:\"close_text_hint\";s:151:\"You can define a gap by entering [gap][/gap] at the text position of your choice. Press the \'Create gaps\' button to add an editable form for every gap.\";s:10:\"cloze_text\";s:10:\"Cloze text\";s:30:\"cloze_textgap_case_insensitive\";s:16:\"Case insensitive\";s:28:\"cloze_textgap_case_sensitive\";s:14:\"Case sensitive\";s:28:\"cloze_textgap_levenshtein_of\";s:26:\"Levenshtein distance of %s\";s:20:\"cloze_textgap_rating\";s:15:\"Text gap rating\";s:4:\"code\";s:4:\"Code\";s:8:\"codebase\";s:8:\"Codebase\";s:13:\"concatenation\";s:13:\"Concatenation\";s:28:\"confirm_delete_all_user_data\";s:58:\"Are you sure you want to delete all user data of the test?\";s:31:\"confirm_delete_single_user_data\";s:68:\"Are you sure you want to delete the test data of the selected users?\";s:22:\"confirm_sync_questions\";s:143:\"The question you changed is a copy which has been created for use with the active test. Do you want to change the original of the question too?\";s:11:\"coordinates\";s:11:\"Coordinates\";s:19:\"correct_solution_is\";s:23:\"The correct solution is\";s:7:\"counter\";s:7:\"Counter\";s:11:\"create_date\";s:7:\"Created\";s:11:\"create_gaps\";s:11:\"Create gaps\";s:15:\"create_imagemap\";s:19:\"Create an Image map\";s:10:\"create_new\";s:10:\"Create new\";s:10:\"definition\";s:10:\"Definition\";s:11:\"delete_area\";s:11:\"Delete area\";s:12:\"delete_image\";s:12:\"Delete image\";s:16:\"delete_user_data\";s:38:\"Delete test data of the selected users\";s:20:\"description_maxchars\";s:86:\"If nothing entered the maximum number of characters for this text answer is unlimited.\";s:26:\"detail_ending_time_reached\";s:79:\"You have reached the ending time of the test. The test isn\'t available since %s\";s:34:\"detail_max_processing_time_reached\";s:65:\"You have reached the maximum allowed processing time of the test!\";s:32:\"detail_starting_time_not_reached\";s:84:\"You have not reached the starting time of the test. The test will be available on %s\";s:15:\"detailed_output\";s:15:\"Detailed output\";s:25:\"detailed_output_printview\";s:40:\"Detailed output with question printviews\";s:25:\"detailed_output_solutions\";s:39:\"Detailed output with question solutions\";s:15:\"direct_feedback\";s:20:\"Verify your solution\";s:9:\"duplicate\";s:9:\"Duplicate\";s:34:\"duplicate_matching_values_selected\";s:44:\"You have selected duplicate matching values!\";s:30:\"duplicate_order_values_entered\";s:40:\"You have entered duplicate order values!\";s:13:\"duplicate_qpl\";s:32:\"Duplicate question pool for test\";s:13:\"duplicate_tst\";s:14:\"Duplicate test\";s:22:\"ects_allow_ects_grades\";s:43:\"Show ECTS grade additional to received mark\";s:24:\"ects_fill_out_all_values\";s:42:\"Please enter a value for every ECTS grade!\";s:10:\"ects_grade\";s:10:\"ECTS grade\";s:12:\"ects_grade_a\";s:46:\"outstanding performance with only minor errors\";s:18:\"ects_grade_a_short\";s:9:\"EXCELLENT\";s:12:\"ects_grade_b\";s:47:\"above the average standard but with some errors\";s:18:\"ects_grade_b_short\";s:9:\"VERY GOOD\";s:12:\"ects_grade_c\";s:52:\"generally sound work with a number of notable errors\";s:18:\"ects_grade_c_short\";s:4:\"GOOD\";s:12:\"ects_grade_d\";s:38:\"fair but with significant shortcomings\";s:18:\"ects_grade_d_short\";s:12:\"SATISFACTORY\";s:12:\"ects_grade_e\";s:38:\"performance meets the minimum criteria\";s:18:\"ects_grade_e_short\";s:10:\"SUFFICIENT\";s:12:\"ects_grade_f\";s:37:\"considerable further work is required\";s:18:\"ects_grade_f_short\";s:4:\"FAIL\";s:13:\"ects_grade_fx\";s:56:\"some more work required before the credit can be awarded\";s:19:\"ects_grade_fx_short\";s:4:\"FAIL\";s:26:\"ects_output_of_ects_grades\";s:21:\"Output of ECTS grades\";s:18:\"ects_range_error_a\";s:56:\"Please enter a value between 0 and 100 for ECTS grade A!\";s:18:\"ects_range_error_b\";s:56:\"Please enter a value between 0 and 100 for ECTS grade B!\";s:18:\"ects_range_error_c\";s:56:\"Please enter a value between 0 and 100 for ECTS grade C!\";s:18:\"ects_range_error_d\";s:56:\"Please enter a value between 0 and 100 for ECTS grade D!\";s:18:\"ects_range_error_e\";s:56:\"Please enter a value between 0 and 100 for ECTS grade E!\";s:17:\"ects_use_fx_grade\";s:59:\"Use the \'FX\' grade, if failed participants reached at least\";s:23:\"ects_use_fx_grade_part2\";s:28:\"percent of the total points.\";s:12:\"edit_content\";s:12:\"Edit content\";s:15:\"edit_properties\";s:15:\"Edit properties\";s:7:\"end_tag\";s:7:\"End tag\";s:19:\"ending_time_reached\";s:32:\"You have reached the ending time\";s:7:\"enlarge\";s:7:\"enlarge\";s:20:\"enter_anonymous_code\";s:27:\"Enter anonymous access code\";s:28:\"enter_enough_positive_points\";s:130:\"The maxium available points for the question must be greater than 0! Please enter sufficient non negative points for your answers.\";s:28:\"error_image_upload_copy_file\";s:76:\"There was an error moving the uploaded image file to its destination folder!\";s:31:\"error_image_upload_wrong_format\";s:80:\"Please upload a valid image file! Supported image formats are gif, jpeg and png.\";s:24:\"error_importing_question\";s:77:\"There was an error importing the question(s) from the file you have selected!\";s:21:\"error_open_image_file\";s:28:\"Error opening an image file!\";s:20:\"error_open_java_file\";s:29:\"Error opening an java applet!\";s:21:\"error_save_image_file\";s:27:\"Error saving an image file!\";s:14:\"eval_all_users\";s:24:\"Evaluation for all users\";s:18:\"eval_choice_result\";s:59:\"The choice with the value %s is %s. You received %s points.\";s:17:\"eval_cloze_result\";s:62:\"Gap number %s with the value %s is %s. You received %s points.\";s:18:\"eval_concatenation\";s:13:\"Concatenation\";s:9:\"eval_data\";s:15:\"Evaluation Data\";s:26:\"eval_found_selected_groups\";s:15:\"Selected groups\";s:25:\"eval_found_selected_users\";s:14:\"Selected users\";s:20:\"eval_imagemap_result\";s:54:\"The image map selection is %s. You received %s points.\";s:16:\"eval_java_result\";s:58:\"The answer for the value %s is %s. You received %s points.\";s:16:\"eval_legend_link\";s:72:\"Please refer to the legend for the meaning of the column header symbols.\";s:20:\"eval_matching_result\";s:56:\"The matching pair %s - %s is %s. You received %s points.\";s:17:\"eval_order_result\";s:57:\"The order for the value %s is %s. You received %s points.\";s:18:\"eval_search_groups\";s:6:\"Groups\";s:17:\"eval_search_roles\";s:5:\"Roles\";s:16:\"eval_search_term\";s:11:\"Search term\";s:17:\"eval_search_users\";s:5:\"Users\";s:25:\"eval_search_userselection\";s:62:\"Search the users you want to add to the statistical evaluation\";s:19:\"eval_selected_users\";s:29:\"Evaluation for selected users\";s:13:\"exp_eval_data\";s:25:\"Export evaluation data as\";s:14:\"exp_type_excel\";s:15:\"Microsoft Excel\";s:13:\"exp_type_spss\";s:27:\"Comma separated value (CSV)\";s:6:\"export\";s:6:\"Export\";s:15:\"failed_official\";s:6:\"failed\";s:12:\"failed_short\";s:6:\"failed\";s:5:\"false\";s:5:\"False\";s:26:\"fill_out_all_answer_fields\";s:64:\"Please fill out all answer text fields before you add a new one!\";s:27:\"fill_out_all_matching_pairs\";s:60:\"Please fill out all matching pairs before you add a new one!\";s:39:\"fill_out_all_required_fields_add_answer\";s:59:\"Please fill out all required fields before you add answers!\";s:41:\"fill_out_all_required_fields_add_matching\";s:67:\"Please fill out all required fields before you add a matching pair!\";s:40:\"fill_out_all_required_fields_create_gaps\";s:59:\"Please fill out all required fields before you create gaps!\";s:41:\"fill_out_all_required_fields_upload_image\";s:61:\"Please fill out all required fields before you upload images!\";s:44:\"fill_out_all_required_fields_upload_imagemap\";s:65:\"Please fill out all required fields before you upload image maps!\";s:44:\"fill_out_all_required_fields_upload_material\";s:64:\"Please fill out all required fields before you upload materials!\";s:6:\"filter\";s:6:\"Filter\";s:25:\"filter_all_question_types\";s:18:\"All question types\";s:24:\"filter_all_questionpools\";s:18:\"All question pools\";s:26:\"filter_show_question_types\";s:19:\"Show question types\";s:25:\"filter_show_questionpools\";s:19:\"Show question pools\";s:12:\"filter_users\";s:12:\"Filter users\";s:3:\"gap\";s:3:\"Gap\";s:14:\"gap_definition\";s:14:\"Gap definition\";s:13:\"gap_selection\";s:13:\"Gap selection\";s:13:\"glossary_term\";s:13:\"Glossary term\";s:17:\"graphical_answers\";s:24:\"Graphical answer support\";s:22:\"graphical_answers_hide\";s:29:\"Hide graphical answer support\";s:22:\"graphical_answers_show\";s:29:\"Show graphical answer support\";s:6:\"height\";s:6:\"Height\";s:8:\"imagemap\";s:9:\"Image map\";s:13:\"imagemap_file\";s:14:\"Image map file\";s:15:\"imagemap_source\";s:16:\"Image map source\";s:17:\"import_errors_qti\";s:63:\"The were errors parsing the QTI file. The import was cancelled.\";s:15:\"import_question\";s:18:\"Import question(s)\";s:12:\"insert_after\";s:12:\"Insert after\";s:13:\"insert_before\";s:13:\"Insert before\";s:14:\"internal_links\";s:14:\"Internal Links\";s:21:\"internal_links_update\";s:6:\"Update\";s:10:\"javaapplet\";s:11:\"Java Applet\";s:27:\"javaapplet_successful_saved\";s:40:\"Your results have been saved successful!\";s:29:\"javaapplet_unsuccessful_saved\";s:47:\"There was an error saving the question results!\";s:13:\"keywords_hint\";s:270:\"Enter a list of keywords, separated by spaces or newlines to add an automatic scoring option for the essay question. If any of the keywords will be found in the answertext of the learner, the default score will be set to the maximum available points instead of 0 points.\";s:11:\"last_update\";s:11:\"Last update\";s:6:\"legend\";s:6:\"Legend\";s:6:\"locked\";s:6:\"locked\";s:50:\"log_could_not_enter_test_due_to_simultaneous_users\";s:99:\"The user could not enter the test because the maximum number of simultaneous users has been reached\";s:19:\"log_create_new_test\";s:16:\"Created new test\";s:14:\"log_mark_added\";s:10:\"Mark added\";s:16:\"log_mark_changed\";s:12:\"Mark changed\";s:16:\"log_mark_removed\";s:12:\"Mark removed\";s:17:\"log_modified_test\";s:21:\"The test was modified\";s:26:\"log_no_test_fields_changed\";s:26:\"Saved, but nothing changed\";s:18:\"log_question_added\";s:26:\"Question added at position\";s:29:\"log_question_position_changed\";s:25:\"Question position changed\";s:20:\"log_question_removed\";s:16:\"Question removed\";s:30:\"log_random_question_pool_added\";s:66:\"Added the question pool \'%s\' with %s questions for the random test\";s:32:\"log_random_question_pool_deleted\";s:46:\"Removed all random question pools for the test\";s:30:\"log_selected_user_data_removed\";s:28:\"Removed test data of user %s\";s:29:\"log_total_amount_of_questions\";s:59:\"Set the total amount of questions for the random test to %s\";s:26:\"log_user_answered_question\";s:47:\"User answered a question and received %s points\";s:21:\"log_user_data_removed\";s:21:\"Removed all user data\";s:23:\"log_user_entered_values\";s:19:\"User entered values\";s:27:\"log_user_not_entered_values\";s:25:\"User did not enter values\";s:11:\"maintenance\";s:11:\"Maintenance\";s:11:\"mark_schema\";s:11:\"Mark schema\";s:27:\"match_terms_and_definitions\";s:27:\"Match terms and definitions\";s:24:\"match_terms_and_pictures\";s:24:\"Match terms and pictures\";s:7:\"matches\";s:7:\"matches\";s:13:\"matching_pair\";s:13:\"Matching pair\";s:33:\"matching_question_javascript_hint\";s:158:\"Please drag a definition/picture on the right side over a term on the left side and drop the definition/picture to match the term with the definition/picture.\";s:8:\"material\";s:8:\"Material\";s:17:\"material_download\";s:20:\"Material to download\";s:13:\"material_file\";s:13:\"Material file\";s:8:\"maxchars\";s:28:\"Maximum number of characters\";s:27:\"maximum_nr_of_tries_reached\";s:88:\"You have reached the maximum number of passes for this test. The test cannot be entered!\";s:14:\"maximum_points\";s:23:\"Maxium available points\";s:7:\"meaning\";s:7:\"Meaning\";s:19:\"min_percentage_ne_0\";s:80:\"You must define a minimum percentage of 0 percent! The mark schema wasn\'t saved.\";s:22:\"multiline_answers_hide\";s:23:\"Use single-line answers\";s:22:\"multiline_answers_show\";s:22:\"Use multi-line answers\";s:20:\"multiline_terms_hide\";s:21:\"Use single-line terms\";s:20:\"multiline_terms_show\";s:20:\"Use multi-line terms\";s:27:\"negative_points_not_allowed\";s:45:\"You are not allowed to enter negative points!\";s:18:\"next_question_rows\";s:26:\"Questions %d - %d of %d >>\";s:14:\"no_passed_mark\";s:71:\"You must set at least one mark to PASSED! The mark schema wasn\'t saved.\";s:29:\"no_question_selected_for_move\";s:46:\"Please check at least one question to move it!\";s:22:\"no_questions_available\";s:33:\"There are no questions available!\";s:27:\"no_target_selected_for_move\";s:34:\"You must select a target position!\";s:25:\"no_user_or_group_selected\";s:73:\"Please check an option what are you searching for (users, groups, roles)!\";s:18:\"not_worked_through\";s:12:\"Not answered\";s:21:\"nr_of_correct_answers\";s:27:\"Number of requested answers\";s:35:\"online_exam_show_answer_print_sheet\";s:151:\"You have finished your online exam. To call the answers printview to print out your test results please press the &quot;Answers printview&quot; button.\";s:28:\"online_exam_show_finish_test\";s:146:\"You still have to call the final submission of your online exam. Please press the &quot;Finish the test&quot; button to call the final submission.\";s:17:\"optional_keywords\";s:26:\"Optional input of keywords\";s:2:\"or\";s:2:\"or\";s:14:\"order_pictures\";s:14:\"Order pictures\";s:11:\"order_terms\";s:11:\"Order terms\";s:33:\"ordering_question_javascript_hint\";s:192:\"Please drag a definition/picture over the definition/picture where you want to put it and drop it. The underlying definition/picture and all following definitions/pictures will move downwards.\";s:11:\"output_mode\";s:11:\"Output mode\";s:12:\"participants\";s:12:\"Participants\";s:4:\"pass\";s:4:\"Pass\";s:15:\"passed_official\";s:6:\"passed\";s:11:\"passed_only\";s:17:\"Passed tests only\";s:12:\"passed_short\";s:6:\"passed\";s:17:\"percentage_solved\";s:46:\"You have solved %.2f percent of this question!\";s:10:\"percentile\";s:10:\"Percentile\";s:7:\"picture\";s:7:\"Picture\";s:13:\"please_select\";s:19:\"-- please select --\";s:5:\"point\";s:5:\"Point\";s:6:\"points\";s:6:\"Points\";s:14:\"points_checked\";s:19:\"Points when checked\";s:12:\"points_short\";s:3:\"Pt.\";s:16:\"points_unchecked\";s:21:\"Points when unchecked\";s:7:\"polygon\";s:7:\"Polygon\";s:26:\"polygon_click_next_or_save\";s:140:\"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)\";s:24:\"polygon_click_next_point\";s:46:\"Please click on the next point of the polygon.\";s:28:\"polygon_click_starting_point\";s:50:\"Please click on the starting point of the polygon.\";s:8:\"postpone\";s:17:\"Postpone question\";s:9:\"postponed\";s:9:\"postponed\";s:7:\"preview\";s:7:\"Preview\";s:22:\"previous_question_rows\";s:26:\"<< Questions %d - %d of %d\";s:13:\"print_answers\";s:13:\"Print Answers\";s:10:\"print_view\";s:10:\"Print view\";s:32:\"qpl_answertext_fields_not_filled\";s:73:\"The question could only be saved, if you fill out all answer text fields!\";s:41:\"qpl_assessment_no_assessment_of_questions\";s:111:\"There is no assessment of questions available for the selected question. The question was never used in a test.\";s:27:\"qpl_assessment_of_questions\";s:23:\"Assessment of questions\";s:31:\"qpl_assessment_total_of_answers\";s:16:\"Total of answers\";s:37:\"qpl_assessment_total_of_right_answers\";s:64:\"Total percentage of right answers (percentage of maximum points)\";s:28:\"qpl_confirm_delete_questions\";s:58:\"Are you sure you want to delete the following question(s)?\";s:25:\"qpl_copy_insert_clipboard\";s:52:\"The selected question(s) are copied to the clipboard\";s:20:\"qpl_copy_select_none\";s:62:\"Please check at least one question to copy it to the clipboard\";s:42:\"qpl_delete_describe_undeleteable_questions\";s:86:\"The following questions are in use in random tests. You cannot delete these questions:\";s:34:\"qpl_delete_no_deleteable_questions\";s:61:\"All questions you tried to delete are in use in a random test\";s:21:\"qpl_delete_rbac_error\";s:43:\"You have no rights to delete this question!\";s:22:\"qpl_delete_select_none\";s:47:\"Please check at least one question to delete it\";s:26:\"qpl_display_fullsize_image\";s:41:\"Click here to display the original image!\";s:25:\"qpl_duplicate_select_none\";s:50:\"Please check at least one question to duplicate it\";s:19:\"qpl_edit_rbac_error\";s:41:\"You have no rights to edit this question!\";s:24:\"qpl_edit_select_multiple\";s:42:\"Please check only one question for editing\";s:20:\"qpl_edit_select_none\";s:37:\"Please check one question for editing\";s:16:\"qpl_export_excel\";s:20:\"Microsoft Excel file\";s:22:\"qpl_export_select_none\";s:47:\"Please check at least one question to export it\";s:14:\"qpl_export_xml\";s:12:\"QTI XML file\";s:22:\"qpl_general_properties\";s:18:\"General properties\";s:28:\"qpl_imagemap_preview_missing\";s:304:\"ILIAS could not create the temporary preview file containing the imagemap areas. The original image is shown instead. This means that either the webserver\'s ImageMagick tool isn\'t configured correctly or there are no write permissions in the temporary directory! Please contact your system administrator.\";s:25:\"qpl_import_create_new_qpl\";s:43:\"Import the questions in a new question pool\";s:19:\"qpl_import_no_items\";s:45:\"Error: The import file contains no questions!\";s:26:\"qpl_import_non_ilias_files\";s:163:\"Error: The import file contains QTI files which are not created by an ILIAS system. Please contact the ILIAS team to get in import filter for your QTI file format.\";s:33:\"qpl_import_verify_found_questions\";s:103:\"ILIAS found the following questions in the import file. Please select the questions you want to import.\";s:25:\"qpl_move_insert_clipboard\";s:46:\"The selected question(s) are marked for moving\";s:20:\"qpl_move_select_none\";s:58:\"Please check at least one question to select it for moving\";s:19:\"qpl_online_property\";s:6:\"Online\";s:31:\"qpl_online_property_description\";s:50:\"Only online question pools could be used in tests.\";s:20:\"qpl_paste_no_objects\";s:91:\"There are no questions in the clipboard. Please copy or move a question into the clipboard.\";s:17:\"qpl_paste_success\";s:55:\"The question(s) have been pasted into the question pool\";s:22:\"qpl_question_is_in_use\";s:216:\"The question you are about to edit exists in %s test(s). If you change this question, you will NOT change the question(s) in the test(s), because the system creates a copy of a question when it is inserted in a test!\";s:21:\"qpl_questions_deleted\";s:20:\"Question(s) deleted.\";s:26:\"qpl_select_file_for_import\";s:34:\"You must select a file for import!\";s:18:\"qt_multiple_choice\";s:24:\"Multiple Choice Question\";s:25:\"question_saved_for_upload\";s:224:\"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!\";s:14:\"question_short\";s:1:\"Q\";s:16:\"question_summary\";s:16:\"Question Summary\";s:14:\"question_title\";s:14:\"Question title\";s:13:\"question_type\";s:13:\"Question Type\";s:24:\"questionpool_not_entered\";s:40:\"Please enter a name for a question pool!\";s:14:\"questions_from\";s:14:\"questions from\";s:9:\"radio_set\";s:3:\"Set\";s:11:\"radio_unset\";s:5:\"Unset\";s:20:\"random_accept_sample\";s:13:\"Accept sample\";s:21:\"random_another_sample\";s:18:\"Get another sample\";s:16:\"random_selection\";s:16:\"Random selection\";s:5:\"range\";s:5:\"Range\";s:17:\"range_lower_limit\";s:11:\"Lower limit\";s:17:\"range_upper_limit\";s:11:\"Upper limit\";s:9:\"rectangle\";s:9:\"Rectangle\";s:25:\"rectangle_click_br_corner\";s:60:\"Please click on the bottom right corner of the desired area.\";s:25:\"rectangle_click_tl_corner\";s:56:\"Please click on the top left corner of the desired area.\";s:6:\"region\";s:6:\"Region\";s:15:\"remove_question\";s:6:\"Remove\";s:15:\"remove_solution\";s:25:\"Remove suggested solution\";s:23:\"report_date_not_reached\";s:88:\"You have not reached the reporting date. You will be able to view the test results at %s\";s:17:\"reset_definitions\";s:26:\"Reset definition positions\";s:12:\"reset_filter\";s:12:\"Reset filter\";s:14:\"reset_pictures\";s:23:\"Reset picture positions\";s:6:\"result\";s:6:\"Result\";s:27:\"save_before_upload_imagemap\";s:63:\"You must apply your changes before you can upload an image map!\";s:29:\"save_before_upload_javaapplet\";s:64:\"You must apply your changes before you can upload a Java applet!\";s:9:\"save_edit\";s:21:\"Save and edit content\";s:11:\"save_finish\";s:15:\"Finish the test\";s:17:\"save_introduction\";s:18:\"Go to introduction\";s:9:\"save_next\";s:4:\"Next\";s:13:\"save_previous\";s:8:\"Previous\";s:23:\"save_text_answer_points\";s:17:\"Save essay points\";s:11:\"scored_pass\";s:11:\"Scored pass\";s:19:\"search_found_groups\";s:12:\"Found groups\";s:18:\"search_found_users\";s:11:\"Found users\";s:13:\"search_groups\";s:13:\"Search Groups\";s:12:\"search_roles\";s:12:\"Search Roles\";s:11:\"search_term\";s:11:\"Search Term\";s:12:\"search_users\";s:12:\"Search Users\";s:35:\"see_details_for_further_information\";s:35:\"See details for suggested solutions\";s:16:\"select_an_answer\";s:31:\"--- Please select an answer ---\";s:10:\"select_gap\";s:10:\"Select gap\";s:19:\"select_max_one_item\";s:27:\"Please select one item only\";s:25:\"select_one_submitted_test\";s:53:\"Please select at least one user who finished the test\";s:15:\"select_one_user\";s:31:\"Please select at least one user\";s:17:\"select_qpl_option\";s:37:\"--- Please select a question pool ---\";s:40:\"select_target_position_for_move_question\";s:92:\"Please select a target position to move the question(s) and press one of the insert buttons!\";s:17:\"select_tst_option\";s:28:\"--- Please select a test ---\";s:14:\"selected_image\";s:14:\"Selected image\";s:13:\"set_edit_mode\";s:13:\"Set edit mode\";s:10:\"set_filter\";s:10:\"Set filter\";s:5:\"shape\";s:5:\"Shape\";s:15:\"shuffle_answers\";s:15:\"Shuffle answers\";s:29:\"solution_comment_count_system\";s:75:\"Questions which are answered partially correct will be scored with 0 points\";s:27:\"solution_comment_mc_scoring\";s:77:\"Multiple choice questions with no checked answer will be scored with 0 points\";s:30:\"solution_comment_score_cutting\";s:75:\"If the question result is negative, the points have been cut to zero points\";s:13:\"solution_hint\";s:18:\"Suggested solution\";s:29:\"solution_may_contain_keywords\";s:54:\"The solution may contain one of the following keywords\";s:14:\"solution_order\";s:14:\"Solution order\";s:9:\"start_tag\";s:9:\"Start tag\";s:25:\"starting_time_not_reached\";s:38:\"You have not reached the starting time\";s:16:\"statistical_data\";s:16:\"Statistical data\";s:10:\"statistics\";s:10:\"Statistics\";s:37:\"suggested_solution_added_successfully\";s:42:\"You successfully set a suggested solution!\";s:6:\"symbol\";s:6:\"Symbol\";s:4:\"term\";s:4:\"Term\";s:14:\"test_cancelled\";s:22:\"The test was cancelled\";s:14:\"test_reference\";s:14:\"Test reference\";s:18:\"text_answers_saved\";s:22:\"Essay points modified!\";s:8:\"text_gap\";s:8:\"Text gap\";s:26:\"text_maximum_chars_allowed\";s:91:\"Please do not enter more than a maximum of %s characters. Any characters above will be cut.\";s:11:\"text_rating\";s:20:\"Text matching method\";s:11:\"time_format\";s:8:\"HH MM SS\";s:25:\"too_many_empty_parameters\";s:76:\"Please fill out your empty applet parameters before you add a new parameter!\";s:4:\"true\";s:4:\"True\";s:23:\"tst_access_code_created\";s:204:\"To provide you with permanent access to your test results and to offer you a possibility to resume this test, a unique test access code was created. Please write down this code use it for further actions.\";s:25:\"tst_all_user_data_deleted\";s:44:\"All user data of this test has been deleted!\";s:30:\"tst_allow_instant_verification\";s:37:\"Allow instant verification of answers\";s:17:\"tst_allowed_users\";s:55:\"Maximum number of users running the test simultaneously\";s:26:\"tst_allowed_users_time_gap\";s:26:\"Idle time for active users\";s:21:\"tst_already_submitted\";s:43:\"Test has already been finish and submitted.\";s:17:\"tst_already_taken\";s:19:\"Tests already taken\";s:16:\"tst_answer_sheet\";s:17:\"Test Answer Sheet\";s:22:\"tst_answered_questions\";s:18:\"Answered questions\";s:20:\"tst_best_solution_is\";s:20:\"The best solution is\";s:24:\"tst_browse_for_questions\";s:20:\"Browse for questions\";s:26:\"tst_confirm_delete_results\";s:287:\"You are about to delete all your previous entered question results of this test. This will reset all questions to its default values. Please note, that you cannot reset the number of passes, you already needed for this test. Do you really want to reset all your previous entered results?\";s:31:\"tst_confirm_delete_results_info\";s:90:\"Your previous entered question results were deleted. You have successfully reset the test!\";s:17:\"tst_confirm_print\";s:111:\"Press button to print all questions with points and solution. The question always appears at the end of a page.\";s:26:\"tst_confirm_submit_answers\";s:123:\"Please confirm your submission of your solution. You won\'t be able to revert your answers after pressing the submit button.\";s:27:\"tst_count_correct_solutions\";s:29:\"Count only complete solutions\";s:27:\"tst_count_partial_solutions\";s:23:\"Count partial solutions\";s:24:\"tst_delete_all_user_data\";s:20:\"Delete all user data\";s:23:\"tst_delete_missing_mark\";s:49:\"Please select at least one mark step to delete it\";s:18:\"tst_delete_results\";s:10:\"Reset test\";s:15:\"tst_ending_time\";s:11:\"Ending time\";s:22:\"tst_enter_questionpool\";s:71:\"Please enter a question pool name where the new question will be stored\";s:33:\"tst_eval_no_anonymous_aggregation\";s:90:\"No one has entered the test yet. There are no anonymous aggregated test results available.\";s:24:\"tst_eval_results_by_pass\";s:25:\"Detailed question results\";s:20:\"tst_eval_show_answer\";s:11:\"Show answer\";s:23:\"tst_eval_total_finished\";s:79:\"Total finished tests (users who submitted the test with the finish test button)\";s:36:\"tst_eval_total_finished_average_time\";s:28:\"Average test processing time\";s:21:\"tst_eval_total_passed\";s:18:\"Total passed tests\";s:36:\"tst_eval_total_passed_average_points\";s:30:\"Average points of passed tests\";s:34:\"tst_eval_total_passed_average_time\";s:43:\"Average processing time of all passed tests\";s:22:\"tst_eval_total_persons\";s:44:\"Total number of persons who started the test\";s:20:\"tst_eval_user_answer\";s:11:\"User answer\";s:25:\"tst_finish_confirm_button\";s:30:\"Yes, I want to finish the test\";s:32:\"tst_finish_confirm_cancel_button\";s:36:\"No, go back to the previous question\";s:32:\"tst_finish_confirmation_question\";s:192:\"You are going to finish this test and reach the maximum number of allowed test passes. You won\'t be able to enter this test again to change your answers. Do you really want to finish the test?\";s:12:\"tst_finished\";s:8:\"Finished\";s:22:\"tst_general_properties\";s:18:\"General properties\";s:16:\"tst_generate_xls\";s:14:\"Generate Excel\";s:19:\"tst_heading_scoring\";s:7:\"Scoring\";s:25:\"tst_hide_previous_results\";s:21:\"Hide previous results\";s:37:\"tst_hide_previous_results_description\";s:102:\"If checked, the previous results of a learner will not be used as default values in future test passes\";s:30:\"tst_hide_previous_results_hide\";s:41:\"Hide my results from a previous test pass\";s:38:\"tst_hide_previous_results_introduction\";s:118:\"If you\'re processing more than one pass of this test, your previous entered results will not be used as default values\";s:21:\"tst_hide_title_points\";s:21:\"Question title points\";s:33:\"tst_hide_title_points_description\";s:59:\"Hide the output of the maximum points in the question title\";s:19:\"tst_import_no_items\";s:45:\"Error: The import file contains no questions!\";s:33:\"tst_import_verify_found_questions\";s:123:\"ILIAS found the following questions in the test import file. Please select the questions you want to import with this test.\";s:34:\"tst_in_use_edit_questions_disabled\";s:97:\"The test is in use by %d user(s). You are not allowed to edit or move the questions in this test!\";s:27:\"tst_insert_missing_question\";s:63:\"Please select at least one question to insert it into the test!\";s:20:\"tst_insert_questions\";s:70:\"Are you sure you want to insert the following question(s) to the test?\";s:32:\"tst_insert_questions_and_results\";s:194:\"This test was already executed by %s user(s). Inserting questions to this test will remove all test results of these users. Are you sure you want to insert the following question(s) to the test?\";s:24:\"tst_instant_verification\";s:20:\"Instant verification\";s:16:\"tst_introduction\";s:12:\"Introduction\";s:38:\"tst_maintenance_information_no_results\";s:106:\"There are no existing user datasets for the test. You need at least one user dataset to maintain the data.\";s:8:\"tst_mark\";s:4:\"Mark\";s:29:\"tst_mark_create_new_mark_step\";s:20:\"Create new mark step\";s:34:\"tst_mark_create_simple_mark_schema\";s:25:\"Create simple mark schema\";s:22:\"tst_mark_minimum_level\";s:20:\"Minimum level (in %)\";s:22:\"tst_mark_official_form\";s:13:\"Official form\";s:15:\"tst_mark_passed\";s:6:\"Passed\";s:19:\"tst_mark_short_form\";s:10:\"Short form\";s:21:\"tst_max_allowed_users\";s:24:\"Participants restriction\";s:29:\"tst_max_allowed_users_heading\";s:70:\"The maximum number of simultaneous users in this test has been reached\";s:29:\"tst_max_allowed_users_message\";s:264:\"The maximum number of simultaneous active users in the test has been reached. Please try again later to start or resume the test. If one of the active users is inactive for more than %s seconds, you may be able to enter this test. Thank you for your understanding.\";s:18:\"tst_maximum_points\";s:14:\"Maximum points\";s:18:\"tst_missing_author\";s:89:\"You have not entered the authors name in the test properties! Please add an authors name.\";s:17:\"tst_missing_marks\";s:96:\"You do not have a mark schema in the test! Please add at least a simple mark schema to the test.\";s:21:\"tst_missing_questions\";s:90:\"You do not have any questions in the test! Please add at least one question into the test.\";s:17:\"tst_missing_title\";s:87:\"You have not entered a test title! Please go to the metadata section and enter a title.\";s:23:\"tst_must_be_online_exam\";s:47:\"This option is only available for online exams!\";s:20:\"tst_no_marks_defined\";s:72:\"There are no marks defined, please create at least a simple mark schema!\";s:35:\"tst_no_more_available_questionpools\";s:42:\"There are no more question pools available\";s:36:\"tst_no_question_selected_for_removal\";s:48:\"Please check at least one question to remove it!\";s:36:\"tst_no_questionpools_for_random_test\";s:98:\"You have not added a question pool for this random test! Please select at least one question pool.\";s:26:\"tst_no_questions_available\";s:91:\"There are no questions available! You need to create new questions or browse for questions.\";s:32:\"tst_no_questions_for_random_test\";s:170:\"You have taken no questions from the questionspools for this random test! Please take at least one question by setting the amount of questions for an added question pool.\";s:25:\"tst_no_solution_available\";s:55:\"Short answer questions don\'t have a specified solution.\";s:18:\"tst_no_taken_tests\";s:25:\"There are no taken tests!\";s:12:\"tst_no_tries\";s:4:\"none\";s:15:\"tst_nr_of_tries\";s:21:\"Max. number of passes\";s:23:\"tst_nr_of_tries_of_user\";s:24:\"Passes already completed\";s:23:\"tst_participating_users\";s:19:\"Participating Users\";s:18:\"tst_pass_best_pass\";s:29:\"Score the best pass of a user\";s:16:\"tst_pass_details\";s:12:\"Show details\";s:18:\"tst_pass_last_pass\";s:29:\"Score the last pass of a user\";s:16:\"tst_pass_scoring\";s:21:\"Multiple pass scoring\";s:12:\"tst_password\";s:13:\"Test password\";s:20:\"tst_password_details\";s:100:\"If you define a test password, all users with test access must enter this password to start the test\";s:35:\"tst_password_entered_wrong_password\";s:70:\"You cannot start the test because you entered the wrong test password!\";s:25:\"tst_password_introduction\";s:101:\"This test can only be accessed with a test password. Please enter the test password to start the test\";s:18:\"tst_percent_solved\";s:14:\"Percent solved\";s:12:\"tst_position\";s:17:\"Question %s of %s\";s:9:\"tst_print\";s:28:\"Test & Assessment Print View\";s:14:\"tst_print_date\";s:13:\"Date of Print\";s:19:\"tst_processing_time\";s:20:\"Max. processing time\";s:14:\"tst_properties\";s:15:\"Test properties\";s:13:\"tst_qst_order\";s:5:\"Order\";s:19:\"tst_qst_resetsolved\";s:12:\"Set unsolved\";s:20:\"tst_qst_result_sheet\";s:17:\"Show result sheet\";s:17:\"tst_qst_setsolved\";s:10:\"Set solved\";s:20:\"tst_qst_summary_text\";s:75:\"Here you can see all questions. Use the bulbs to mark a question as solved.\";s:15:\"tst_question_no\";s:5:\"Order\";s:18:\"tst_question_offer\";s:53:\"Do you accept this sample or do you want another one?\";s:22:\"tst_question_selection\";s:18:\"Question selection\";s:34:\"tst_question_selection_description\";s:287:\"If you only use question pools which contain questions with an equal maximum number of available points, the test will have an equal number of maximum points for all participating users and thus the test results will be better comparable. It is recommended to choose this selection mode.\";s:28:\"tst_question_selection_equal\";s:44:\"Use question pools with equal maximum points\";s:25:\"tst_question_solved_state\";s:6:\"Solved\";s:18:\"tst_question_title\";s:5:\"Title\";s:17:\"tst_question_type\";s:13:\"Question type\";s:22:\"tst_questions_inserted\";s:21:\"Question(s) inserted!\";s:21:\"tst_questions_removed\";s:20:\"Question(s) removed!\";s:26:\"tst_random_nr_of_questions\";s:19:\"How many questions?\";s:25:\"tst_random_qpl_unselected\";s:90:\"There is at least one unselected question pool! You don\'t need to add a new question pool.\";s:24:\"tst_random_questionpools\";s:21:\"Source question pools\";s:30:\"tst_random_select_questionpool\";s:53:\"Select the question pool to choose the questions from\";s:44:\"tst_random_selection_question_count_too_high\";s:140:\"The question count you entered was higher than the maximum number of available questions. The question count has been reduced automatically.\";s:50:\"tst_random_selection_question_total_count_too_high\";s:172:\"The question count you entered was higher than the maximum number of available questions for all selected question pools. The question count has been reduced automatically.\";s:15:\"tst_random_test\";s:11:\"Random test\";s:27:\"tst_random_test_description\";s:77:\"If checked, the questions of the test will be generated by a random generator\";s:18:\"tst_reached_points\";s:14:\"Reached points\";s:20:\"tst_remove_questions\";s:72:\"Are you sure you want to remove the following question(s) from the test?\";s:32:\"tst_remove_questions_and_results\";s:197:\"This test was already executed by %s user(s). Removing questions from this test will remove all test results of these users. Are you sure you want to remove the following question(s) from the test?\";s:31:\"tst_report_after_first_question\";s:49:\"Offer test results when the test has been started\";s:25:\"tst_report_after_question\";s:37:\"Allow instant verification of answers\";s:21:\"tst_report_after_test\";s:44:\"Offer test results when the test is finished\";s:26:\"tst_result_congratulations\";s:37:\"Congratulations! You passed the test.\";s:16:\"tst_result_sorry\";s:27:\"Sorry, you failed the test.\";s:20:\"tst_result_user_name\";s:19:\"Test results for %s\";s:11:\"tst_results\";s:12:\"Test results\";s:22:\"tst_results_aggregated\";s:23:\"Aggregated test results\";s:27:\"tst_results_back_evaluation\";s:27:\"Back to evaluation overview\";s:29:\"tst_results_back_introduction\";s:20:\"Back to introduction\";s:25:\"tst_results_back_overview\";s:24:\"Back to results overview\";s:15:\"tst_resume_test\";s:15:\"Resume the test\";s:22:\"tst_score_cut_question\";s:38:\"Cut negative points for every question\";s:18:\"tst_score_cut_test\";s:55:\"Cut negative points for the sum of all question results\";s:17:\"tst_score_cutting\";s:19:\"Cut negative points\";s:24:\"tst_score_mcmr_questions\";s:25:\"Multiple choice questions\";s:33:\"tst_score_mcmr_use_scoring_system\";s:54:\"Set the defined score, even when no answer was checked\";s:42:\"tst_score_mcmr_zero_points_when_unanswered\";s:41:\"Score 0 points when no answer was checked\";s:19:\"tst_score_reporting\";s:15:\"Score reporting\";s:24:\"tst_score_reporting_date\";s:20:\"Score reporting date\";s:14:\"tst_score_type\";s:20:\"Score reporting type\";s:26:\"tst_select_file_for_import\";s:34:\"You must select a file for import!\";s:15:\"tst_select_qpls\";s:45:\"Please select a question pool for duplication\";s:23:\"tst_select_questionpool\";s:59:\"Please select a question pool to store the created question\";s:24:\"tst_select_questionpools\";s:61:\"Please select a question pool to store the imported questions\";s:27:\"tst_select_random_questions\";s:75:\"Select the question pool(s) and the amount of questions for the random test\";s:15:\"tst_select_tsts\";s:36:\"Please select a test for duplication\";s:30:\"tst_selected_user_data_deleted\";s:62:\"The test data of the selected user(s) was deleted successfully\";s:12:\"tst_sequence\";s:8:\"Sequence\";s:18:\"tst_sequence_fixed\";s:34:\"The sequence of questions is fixed\";s:21:\"tst_sequence_postpone\";s:58:\"The learner may postpone a question to the end of the test\";s:23:\"tst_sequence_properties\";s:19:\"Sequence properties\";s:20:\"tst_session_settings\";s:16:\"Session settings\";s:27:\"tst_show_answer_print_sheet\";s:17:\"Answers Printview\";s:21:\"tst_show_answer_sheet\";s:12:\"Show answers\";s:16:\"tst_show_results\";s:17:\"Show test results\";s:25:\"tst_show_solution_details\";s:13:\"Score details\";s:37:\"tst_show_solution_details_description\";s:65:\"Learners may see all solution details of their answered questions\";s:27:\"tst_show_solution_printview\";s:18:\"Solution printview\";s:39:\"tst_show_solution_printview_description\";s:57:\"Learners may see their complete test results for printing\";s:16:\"tst_show_summary\";s:21:\"Show question summary\";s:28:\"tst_show_summary_description\";s:97:\"Offers a summary page with all test questions available for the test participants during the test\";s:21:\"tst_shuffle_questions\";s:17:\"Shuffle questions\";s:33:\"tst_shuffle_questions_description\";s:62:\"Shuffle the sequence of questions for every user on test start\";s:13:\"tst_signature\";s:9:\"Signature\";s:14:\"tst_start_test\";s:14:\"Start the test\";s:11:\"tst_started\";s:12:\"Test Started\";s:17:\"tst_starting_time\";s:13:\"Starting time\";s:18:\"tst_stat_all_users\";s:16:\"All participants\";s:21:\"tst_stat_choose_users\";s:45:\"(select one or more users from the user list)\";s:27:\"tst_stat_result_atimeofwork\";s:20:\"Average time of work\";s:28:\"tst_stat_result_distancemean\";s:27:\"Distance to arithmetic mean\";s:30:\"tst_stat_result_distancemedian\";s:18:\"Distance to median\";s:32:\"tst_stat_result_distancequintile\";s:31:\"Distance to arithmetic quintile\";s:26:\"tst_stat_result_firstvisit\";s:11:\"First visit\";s:25:\"tst_stat_result_lastvisit\";s:10:\"Last visit\";s:27:\"tst_stat_result_mark_median\";s:14:\"Mark of median\";s:22:\"tst_stat_result_median\";s:31:\"Median of test result in points\";s:30:\"tst_stat_result_pworkedthrough\";s:48:\"Percent of total workload already worked through\";s:30:\"tst_stat_result_qworkedthrough\";s:32:\"Questions already worked through\";s:27:\"tst_stat_result_rank_median\";s:14:\"Rank of median\";s:32:\"tst_stat_result_rank_participant\";s:19:\"Rank of participant\";s:28:\"tst_stat_result_resultsmarks\";s:21:\"Test results in marks\";s:29:\"tst_stat_result_resultspoints\";s:22:\"Test results in points\";s:29:\"tst_stat_result_specification\";s:32:\"Specification of evaluation data\";s:26:\"tst_stat_result_timeofwork\";s:12:\"Time of work\";s:34:\"tst_stat_result_total_participants\";s:28:\"Total number of participants\";s:23:\"tst_stat_selected_users\";s:21:\"Selected participants\";s:20:\"tst_stat_users_intro\";s:31:\"Show statistical evaluation for\";s:20:\"tst_status_completed\";s:9:\"completed\";s:40:\"tst_status_completed_more_tries_possible\";s:9:\"Completed\";s:18:\"tst_status_missing\";s:49:\"There are required elements missing in this test!\";s:27:\"tst_status_missing_elements\";s:35:\"The following elements are missing:\";s:22:\"tst_status_not_entered\";s:11:\"Not started\";s:13:\"tst_status_ok\";s:60:\"The status of the test is OK. There are no missing elements.\";s:19:\"tst_status_progress\";s:11:\"In progress\";s:18:\"tst_submit_answers\";s:32:\"Yes, I want to submit my answers\";s:22:\"tst_submit_answers_txt\";s:55:\"You now may finish the test by submitting your answers.\";s:18:\"tst_submit_results\";s:33:\"Yes, I do confirm the submission.\";s:15:\"tst_test_output\";s:11:\"Test output\";s:21:\"tst_text_count_system\";s:14:\"Scoring system\";s:22:\"tst_time_already_spent\";s:63:\"You started the test at %s. Your maximum processing time is %s.\";s:27:\"tst_time_already_spent_left\";s:17:\"You have %s left.\";s:19:\"tst_total_questions\";s:25:\"Total amount of questions\";s:31:\"tst_total_questions_description\";s:183:\"If you set this value, the amount of questions entered with the question pools are ignored. If you don\'t set this value, you need to enter an amount with every selected question pool!\";s:12:\"tst_tst_date\";s:12:\"Date of Test\";s:8:\"tst_type\";s:9:\"Test type\";s:16:\"tst_type_changed\";s:79:\"You have changed the test type. All previous processed tests have been deleted!\";s:16:\"tst_type_comment\";s:91:\"Warning: Changing the test type of a running test will delete all previous processed tests!\";s:9:\"tst_types\";s:10:\"Test types\";s:18:\"tst_use_javascript\";s:40:\"Use Javascript for drag and drop actions\";s:19:\"tst_your_answer_was\";s:15:\"Your answer was\";s:16:\"tst_your_answers\";s:56:\"These are your answers given to the following questions.\";s:21:\"tst_your_ects_mark_is\";s:18:\"Your ECTS grade is\";s:16:\"tst_your_mark_is\";s:12:\"Your mark is\";s:13:\"tt_assessment\";s:15:\"Assessment test\";s:14:\"tt_online_exam\";s:11:\"Online Exam\";s:18:\"tt_self_assessment\";s:20:\"Self assessment test\";s:21:\"tt_varying_randomtest\";s:19:\"Varying random test\";s:9:\"unlimited\";s:9:\"unlimited\";s:6:\"unlock\";s:6:\"Unlock\";s:15:\"unlock_question\";s:394:\"This question is in use of at least one test and there are %s submitted results. If you choose to unlock the question the complete test results of the affected users will be deleted after saving this question. If you want to use a changed version of this question but you do not want to delete the users test results, you can duplicate the question in the question pool and change that version.\";s:12:\"upload_image\";s:12:\"Upload image\";s:15:\"upload_imagemap\";s:19:\"Upload an Image map\";s:17:\"uploaded_material\";s:17:\"Uploaded Material\";s:16:\"user_not_invited\";s:39:\"You are not supposed to take this exam.\";s:19:\"user_wrong_clientip\";s:44:\"You don\'t have the right ip using this test.\";s:21:\"value_between_x_and_y\";s:37:\"The value should be between %s and %s\";s:29:\"warning_question_not_complete\";s:29:\"The question is not complete!\";s:25:\"warning_test_not_complete\";s:25:\"The test is not complete!\";s:4:\"when\";s:4:\"when\";s:5:\"width\";s:5:\"Width\";s:10:\"with_order\";s:10:\"with order\";s:14:\"worked_through\";s:8:\"Answered\";s:12:\"working_time\";s:12:\"Working Time\";s:26:\"you_received_a_of_b_points\";s:37:\"You received %d of %d possible points\";}');
INSERT INTO `lng_modules` VALUES ('barometer','en','a:53:{s:9:\"anonymous\";s:9:\"Anonymous\";s:15:\"barometer_title\";s:8:\"Feedback\";s:4:\"best\";s:4:\"Best\";s:13:\"change_course\";s:13:\"Change Course\";s:10:\"chart_type\";s:10:\"Chart type\";s:11:\"chart_users\";s:10:\"Chart user\";s:11:\"chart_votes\";s:11:\"Chart votes\";s:6:\"create\";s:19:\"Create New Feedback\";s:3:\"day\";s:3:\"Day\";s:4:\"days\";s:4:\"Days\";s:6:\"delete\";s:6:\"Delete\";s:8:\"duration\";s:8:\"Duration\";s:4:\"edit\";s:4:\"Edit\";s:14:\"edit_barometer\";s:13:\"Edit feedback\";s:5:\"every\";s:5:\"every\";s:19:\"feedb_edit_feedback\";s:13:\"Edit Feedback\";s:19:\"feedb_feedback_list\";s:13:\"Feedback List\";s:23:\"feedb_feedback_settings\";s:17:\"Feedback Settings\";s:10:\"feedb_time\";s:4:\"Time\";s:10:\"first_vote\";s:14:\"1. Vote is the\";s:4:\"from\";s:4:\"From\";s:5:\"hours\";s:5:\"Hours\";s:5:\"lines\";s:5:\"Lines\";s:5:\"login\";s:5:\"Login\";s:14:\"missing_fields\";s:39:\"Please fill in all required information\";s:5:\"month\";s:5:\"Month\";s:6:\"months\";s:6:\"Months\";s:8:\"new_vote\";s:8:\"New vote\";s:4:\"note\";s:7:\"Comment\";s:8:\"optional\";s:8:\"Optional\";s:7:\"options\";s:7:\"Options\";s:3:\"pie\";s:3:\"Pie\";s:6:\"repeat\";s:12:\"Repeat Every\";s:8:\"required\";s:8:\"Required\";s:4:\"save\";s:4:\"Save\";s:9:\"save_vote\";s:11:\"Submit vote\";s:4:\"skip\";s:4:\"Skip\";s:10:\"statistics\";s:10:\"Statistics\";s:6:\"status\";s:6:\"Status\";s:5:\"table\";s:5:\"Table\";s:4:\"text\";s:4:\"Text\";s:11:\"text_answer\";s:11:\"Text answer\";s:4:\"time\";s:7:\"Running\";s:5:\"title\";s:5:\"Title\";s:4:\"type\";s:4:\"Type\";s:5:\"until\";s:5:\"Until\";s:4:\"user\";s:4:\"User\";s:4:\"vote\";s:4:\"Vote\";s:5:\"votes\";s:5:\"Votes\";s:5:\"weeks\";s:5:\"Weeks\";s:5:\"worst\";s:5:\"Worst\";s:4:\"year\";s:4:\"Year\";s:13:\"barometer_add\";s:16:\"Add new Feedback\";}');
INSERT INTO `lng_modules` VALUES ('bibitem','en','a:58:{s:11:\"bibitem_add\";s:3:\"Add\";s:14:\"bibitem_author\";s:6:\"Author\";s:10:\"bibitem_av\";s:2:\"AV\";s:15:\"bibitem_bibitem\";s:27:\"Bibliographical information\";s:12:\"bibitem_book\";s:4:\"Book\";s:17:\"bibitem_booktitle\";s:10:\"Book title\";s:15:\"bibitem_catalog\";s:7:\"Catalog\";s:20:\"bibitem_choose_index\";s:44:\"Please select a bibliographical information:\";s:23:\"bibitem_cross_reference\";s:15:\"Cross reference\";s:14:\"bibitem_delete\";s:6:\"Delete\";s:20:\"bibitem_dissertation\";s:12:\"Dissertation\";s:15:\"bibitem_edition\";s:7:\"Edition\";s:14:\"bibitem_editor\";s:6:\"Editor\";s:13:\"bibitem_entry\";s:5:\"Entry\";s:18:\"bibitem_first_name\";s:10:\"First name\";s:23:\"bibitem_grey_literature\";s:15:\"Grey literature\";s:21:\"bibitem_how_published\";s:13:\"How published\";s:18:\"bibitem_identifier\";s:10:\"Identifier\";s:14:\"bibitem_inbook\";s:7:\"In book\";s:21:\"bibitem_inproceedings\";s:14:\"In proceedings\";s:19:\"bibitem_institution\";s:11:\"Institution\";s:16:\"bibitem_internet\";s:8:\"Internet\";s:12:\"bibitem_isbn\";s:4:\"ISBN\";s:12:\"bibitem_issn\";s:4:\"ISSN\";s:15:\"bibitem_journal\";s:7:\"Journal\";s:23:\"bibitem_journal_article\";s:15:\"Journal article\";s:15:\"bibitem_keyword\";s:7:\"Keyword\";s:13:\"bibitem_label\";s:5:\"Label\";s:16:\"bibitem_language\";s:8:\"Language\";s:17:\"bibitem_last_name\";s:9:\"Last name\";s:14:\"bibitem_manual\";s:6:\"Manual\";s:21:\"bibitem_master_thesis\";s:13:\"Master thesis\";s:19:\"bibitem_middle_name\";s:11:\"Middle name\";s:13:\"bibitem_month\";s:5:\"Month\";s:19:\"bibitem_new_element\";s:11:\"New element\";s:25:\"bibitem_newspaper_article\";s:17:\"Newspaper article\";s:17:\"bibitem_not_found\";s:41:\"No bibliographical information available.\";s:12:\"bibitem_note\";s:4:\"Note\";s:14:\"bibitem_number\";s:6:\"Number\";s:20:\"bibitem_organization\";s:12:\"Organization\";s:13:\"bibitem_pages\";s:5:\"Pages\";s:18:\"bibitem_phd_thesis\";s:10:\"PhD thesis\";s:21:\"bibitem_please_select\";s:13:\"Please select\";s:13:\"bibitem_print\";s:5:\"Print\";s:19:\"bibitem_proceedings\";s:11:\"Proceedings\";s:17:\"bibitem_publisher\";s:9:\"Publisher\";s:12:\"bibitem_save\";s:4:\"Save\";s:14:\"bibitem_school\";s:6:\"School\";s:14:\"bibitem_series\";s:6:\"Series\";s:21:\"bibitem_series_editor\";s:6:\"Editor\";s:20:\"bibitem_series_title\";s:12:\"Series title\";s:21:\"bibitem_series_volume\";s:6:\"Volume\";s:24:\"bibitem_technical_report\";s:16:\"Technical report\";s:12:\"bibitem_type\";s:4:\"Type\";s:19:\"bibitem_unpublished\";s:11:\"Unpublished\";s:11:\"bibitem_url\";s:3:\"URL\";s:23:\"bibitem_where_published\";s:15:\"Where published\";s:12:\"bibitem_year\";s:4:\"Year\";}');
INSERT INTO `lng_modules` VALUES ('chat','en','a:131:{s:11:\"cancel_talk\";s:14:\"Cancel address\";s:14:\"cancel_whisper\";s:14:\"Cancel whisper\";s:19:\"chat_access_blocked\";s:37:\"You are excluded from these chatrooms\";s:11:\"chat_active\";s:6:\"Active\";s:17:\"chat_active_users\";s:23:\"Further users (present)\";s:22:\"chat_add_allowed_hosts\";s:82:\"Please add the address of the host(s) which are allowed to access the chat server.\";s:20:\"chat_add_external_ip\";s:36:\"Please add the server\'s external IP.\";s:20:\"chat_add_internal_ip\";s:36:\"Please add the server\'s internal IP.\";s:27:\"chat_add_moderator_password\";s:32:\"Please add a moderator password.\";s:13:\"chat_add_port\";s:27:\"Please add the server port.\";s:25:\"chat_add_private_chatroom\";s:20:\"Add private chatroom\";s:12:\"chat_address\";s:7:\"Address\";s:17:\"chat_address_user\";s:7:\"Address\";s:9:\"chat_aqua\";s:4:\"aqua\";s:10:\"chat_arial\";s:5:\"Arial\";s:10:\"chat_black\";s:5:\"black\";s:15:\"chat_block_user\";s:5:\"Block\";s:12:\"chat_blocked\";s:17:\"Restricted access\";s:21:\"chat_blocked_unlocked\";s:6:\"Unlock\";s:18:\"chat_blocked_users\";s:13:\"Blocked users\";s:9:\"chat_blue\";s:4:\"blue\";s:9:\"chat_bold\";s:4:\"Bold\";s:18:\"chat_chatroom_body\";s:10:\"Chat room:\";s:20:\"chat_chatroom_rename\";s:14:\"Edit chat room\";s:14:\"chat_chatrooms\";s:10:\"Chat Rooms\";s:10:\"chat_color\";s:10:\"Font color\";s:16:\"chat_delete_sure\";s:47:\"Are you sure, you want to delete this chat room\";s:14:\"chat_drop_user\";s:11:\"User kicked\";s:9:\"chat_edit\";s:9:\"Edit chat\";s:10:\"chat_empty\";s:5:\"Empty\";s:25:\"chat_enter_valid_username\";s:30:\"Please enter a valid username.\";s:9:\"chat_face\";s:9:\"Font type\";s:12:\"chat_fuchsia\";s:7:\"fuchsia\";s:9:\"chat_gray\";s:4:\"gray\";s:10:\"chat_green\";s:5:\"green\";s:17:\"chat_hide_details\";s:12:\"Hide details\";s:16:\"chat_html_export\";s:11:\"HTML export\";s:10:\"chat_ilias\";s:17:\"ILIAS Chat module\";s:13:\"chat_inactive\";s:8:\"Inactive\";s:10:\"chat_input\";s:5:\"Input\";s:19:\"chat_insert_message\";s:23:\"Please insert a message\";s:20:\"chat_invitation_body\";s:24:\"Invitation to chat from:\";s:23:\"chat_invitation_subject\";s:15:\"Chat invitation\";s:16:\"chat_invite_user\";s:11:\"Invite user\";s:15:\"chat_invited_by\";s:10:\"Invited by\";s:11:\"chat_italic\";s:6:\"Italic\";s:22:\"chat_kick_user_session\";s:9:\"Kick user\";s:21:\"chat_kicked_from_room\";s:67:\"You have been kicked from this chatroom, you cannot write messages.\";s:14:\"chat_level_all\";s:3:\"All\";s:16:\"chat_level_debug\";s:5:\"Debug\";s:16:\"chat_level_error\";s:5:\"Error\";s:16:\"chat_level_fatal\";s:5:\"Fatal\";s:15:\"chat_level_info\";s:4:\"Info\";s:9:\"chat_lime\";s:4:\"lime\";s:11:\"chat_maroon\";s:6:\"maroon\";s:21:\"chat_messages_deleted\";s:27:\"Messages have been deleted.\";s:23:\"chat_moderator_password\";s:18:\"Moderator password\";s:9:\"chat_navy\";s:4:\"navy\";s:16:\"chat_new_message\";s:11:\"New message\";s:20:\"chat_no_active_users\";s:25:\"No further users present.\";s:15:\"chat_no_blocked\";s:26:\"No blocked users available\";s:18:\"chat_no_connection\";s:27:\"Cannot contact chat server.\";s:21:\"chat_no_delete_public\";s:38:\"The public chat room cannot be deleted\";s:28:\"chat_no_recordings_available\";s:42:\"No recordings are available at the moment.\";s:22:\"chat_no_refresh_public\";s:41:\"The public chat room cannot be refreshed.\";s:21:\"chat_no_rename_public\";s:33:\"The public room cannot be renamed\";s:22:\"chat_no_users_selected\";s:28:\"You have to select one user.\";s:18:\"chat_no_write_perm\";s:22:\"No permission to write\";s:10:\"chat_olive\";s:5:\"olive\";s:17:\"chat_online_users\";s:22:\"Further users (online)\";s:20:\"chat_private_message\";s:15:\"Private Message\";s:12:\"chat_profile\";s:7:\"Profile\";s:16:\"chat_public_room\";s:16:\"Public chat room\";s:11:\"chat_purple\";s:6:\"purple\";s:21:\"chat_recording_action\";s:6:\"Action\";s:26:\"chat_recording_description\";s:11:\"Description\";s:24:\"chat_recording_moderator\";s:9:\"Moderator\";s:24:\"chat_recording_not_found\";s:25:\"Could not find recording.\";s:22:\"chat_recording_running\";s:17:\"Recording running\";s:22:\"chat_recording_started\";s:17:\"Recording started\";s:22:\"chat_recording_stopped\";s:17:\"Recording stopped\";s:25:\"chat_recording_time_frame\";s:10:\"Time frame\";s:20:\"chat_recording_title\";s:18:\"Title of recording\";s:15:\"chat_recordings\";s:10:\"Recordings\";s:27:\"chat_recordings_delete_sure\";s:32:\"Deleting records - are you sure?\";s:23:\"chat_recordings_deleted\";s:24:\"Recordings were deleted.\";s:26:\"chat_recordings_select_one\";s:50:\"Please choose recordings you would like to delete.\";s:8:\"chat_red\";s:3:\"red\";s:12:\"chat_refresh\";s:7:\"Refresh\";s:14:\"chat_refreshed\";s:47:\"Deleted all messages of the selected chatrooms.\";s:15:\"chat_room_added\";s:19:\"Added new chat room\";s:14:\"chat_room_name\";s:17:\"Name of chat room\";s:17:\"chat_room_renamed\";s:18:\"Chat room renamed.\";s:16:\"chat_room_select\";s:17:\"Private chat room\";s:10:\"chat_rooms\";s:10:\"Chat Rooms\";s:18:\"chat_rooms_deleted\";s:21:\"Chat room(s) deleted.\";s:20:\"chat_select_one_room\";s:27:\"Please select one chat room\";s:19:\"chat_server_allowed\";s:13:\"Allowed hosts\";s:21:\"chat_server_allowed_b\";s:30:\"(e.g. 192.168.1.1,192.168.1.2)\";s:23:\"chat_server_external_ip\";s:18:\"Server external IP\";s:23:\"chat_server_internal_ip\";s:18:\"Server internal IP\";s:19:\"chat_server_logfile\";s:13:\"Log file path\";s:20:\"chat_server_loglevel\";s:9:\"Log level\";s:22:\"chat_server_not_active\";s:29:\"The chat server is not active\";s:16:\"chat_server_port\";s:11:\"Server Port\";s:20:\"chat_server_settings\";s:20:\"Chat server settings\";s:19:\"chat_settings_saved\";s:14:\"Settings saved\";s:17:\"chat_show_details\";s:12:\"Show details\";s:11:\"chat_silver\";s:6:\"silver\";s:20:\"chat_start_recording\";s:15:\"Start recording\";s:11:\"chat_status\";s:6:\"Status\";s:17:\"chat_status_saved\";s:27:\"The status has been changed\";s:19:\"chat_stop_recording\";s:14:\"Stop recording\";s:11:\"chat_tahoma\";s:6:\"Tahoma\";s:9:\"chat_teal\";s:4:\"teal\";s:10:\"chat_times\";s:5:\"Times\";s:18:\"chat_title_missing\";s:21:\"Please insert a name.\";s:17:\"chat_to_chat_body\";s:11:\"To the chat\";s:9:\"chat_type\";s:9:\"Font face\";s:19:\"chat_unblocked_user\";s:37:\"The selected user have been unlocked.\";s:15:\"chat_underlined\";s:10:\"Underlined\";s:24:\"chat_unkick_user_session\";s:11:\"Unkick user\";s:25:\"chat_user_already_blocked\";s:52:\"The access for the selected user is already blocked.\";s:17:\"chat_user_blocked\";s:37:\"Blocked access for the selected user.\";s:17:\"chat_user_dropped\";s:11:\"User kicked\";s:17:\"chat_user_invited\";s:21:\"Invited user to chat.\";s:14:\"chat_user_name\";s:8:\"Username\";s:12:\"chat_whisper\";s:7:\"Whisper\";s:11:\"chat_yellow\";s:6:\"yellow\";s:5:\"chats\";s:5:\"Chats\";s:8:\"my_chats\";s:8:\"My Chats\";}');
INSERT INTO `lng_modules` VALUES ('common','en','a:2527:{s:18:\"3rd_party_software\";s:18:\"3rd party software\";s:10:\"DD.MM.YYYY\";s:10:\"DD.MM.YYYY\";s:2:\"HH\";s:5:\"HH:MM\";s:13:\"absolute_path\";s:13:\"Absolute Path\";s:20:\"accept_usr_agreement\";s:22:\"Accept user agreement?\";s:6:\"access\";s:6:\"Access\";s:20:\"account_expires_body\";s:43:\"Your account is limited, it will expire at:\";s:23:\"account_expires_subject\";s:30:\"[ILIAS 3] Your account expires\";s:6:\"action\";s:6:\"Action\";s:14:\"action_aborted\";s:14:\"Action aborted\";s:7:\"actions\";s:7:\"Actions\";s:27:\"activate_assessment_logging\";s:32:\"Activate Test&Assessment logging\";s:14:\"activate_https\";s:43:\"HTTPS handling by ILIAS<br>(Payment, Login)\";s:17:\"activate_tracking\";s:10:\"Activation\";s:10:\"activation\";s:12:\"Edit Timings\";s:6:\"active\";s:6:\"Active\";s:12:\"active_roles\";s:12:\"Active Roles\";s:3:\"add\";s:3:\"Add\";s:10:\"add_author\";s:10:\"Add Author\";s:12:\"add_comments\";s:13:\"Edit comments\";s:13:\"add_condition\";s:22:\"Create new association\";s:10:\"add_member\";s:10:\"Add Member\";s:11:\"add_members\";s:11:\"Add Members\";s:26:\"add_new_user_defined_field\";s:26:\"Add New User-defined Field\";s:33:\"add_new_user_defined_select_field\";s:18:\"Add New Select Box\";s:31:\"add_new_user_defined_text_field\";s:18:\"Add New Text Field\";s:8:\"add_note\";s:8:\"Add Note\";s:15:\"add_translation\";s:15:\"Add translation\";s:8:\"add_user\";s:14:\"Add local user\";s:22:\"add_user_defined_field\";s:13:\"Add New Field\";s:19:\"added_new_condition\";s:22:\"Created new condition.\";s:15:\"additional_info\";s:22:\"Additional Information\";s:14:\"adm_create_tax\";s:15:\"Create taxonomy\";s:19:\"adm_edit_permission\";s:26:\"Change permission settings\";s:8:\"adm_read\";s:30:\"Read access to System settings\";s:11:\"adm_visible\";s:27:\"System settings are visible\";s:9:\"adm_write\";s:26:\"Edit Basic system settings\";s:11:\"admin_panel\";s:20:\"Administration Panel\";s:19:\"admin_panel_disable\";s:34:\"Switch Administration Commands Off\";s:18:\"admin_panel_enable\";s:33:\"Switch Administration Commands On\";s:12:\"administrate\";s:12:\"Administrate\";s:18:\"administrate_users\";s:25:\"Local user administration\";s:14:\"administration\";s:14:\"Administration\";s:13:\"administrator\";s:13:\"Administrator\";s:5:\"adopt\";s:5:\"Adopt\";s:32:\"advanced_editing_allow_html_tags\";s:45:\"Allow the selected HTML tags for text editing\";s:40:\"advanced_editing_allow_javascript_editor\";s:25:\"Enable a Rich Text Editor\";s:36:\"advanced_editing_assessment_settings\";s:52:\"Allowed HTML Tags for the ILIAS Test&Assessment tool\";s:33:\"advanced_editing_cat_page_editing\";s:41:\"Enable Content Editing for Category Pages\";s:38:\"advanced_editing_cat_page_editing_desc\";s:127:\"This enables the content editing of category pages. When deactivated, the categories are just displayed as a set of item lists.\";s:30:\"advanced_editing_lm_js_editing\";s:35:\"Enable HTMLArea for Content Editing\";s:35:\"advanced_editing_lm_js_editing_desc\";s:92:\"Enables HTMLArea and JavaScript support for page editing in learning modules and glossaries.\";s:28:\"advanced_editing_lm_settings\";s:37:\"Learning Module and Glossary Settings\";s:23:\"advanced_editing_no_rte\";s:28:\"Do not use rich text editing\";s:25:\"advanced_editing_settings\";s:25:\"Advanced Editing Settings\";s:32:\"advanced_editing_survey_settings\";s:43:\"Allowed HTML Tags for the ILIAS survey tool\";s:24:\"advanced_editing_tinymce\";s:14:\"TinyMCE Editor\";s:24:\"adve_assessment_settings\";s:26:\"Test & Assessment Settings\";s:17:\"adve_cat_settings\";s:17:\"Category Settings\";s:20:\"adve_edit_permission\";s:26:\"Change Permission Settings\";s:21:\"adve_general_settings\";s:16:\"General Settings\";s:16:\"adve_lm_settings\";s:22:\"LM / Glossary Settings\";s:9:\"adve_read\";s:38:\"Access Advanced Editing Administration\";s:20:\"adve_survey_settings\";s:15:\"Survey Settings\";s:12:\"adve_visible\";s:42:\"Advanced Editing Administration is Visible\";s:10:\"adve_write\";s:31:\"Advanced Editing Administration\";s:10:\"agree_date\";s:9:\"Agreed on\";s:11:\"all_authors\";s:11:\"All authors\";s:16:\"all_global_roles\";s:12:\"Global roles\";s:7:\"all_lms\";s:20:\"All learning modules\";s:15:\"all_local_roles\";s:17:\"Local roles (all)\";s:11:\"all_objects\";s:11:\"All Objects\";s:9:\"all_roles\";s:9:\"All Roles\";s:10:\"all_topics\";s:10:\"All Topics\";s:8:\"all_tsts\";s:9:\"All tests\";s:9:\"all_users\";s:9:\"All users\";s:18:\"allow_assign_users\";s:47:\"Allow user assignment for local administrators.\";s:14:\"allow_register\";s:44:\"Available in registration form for new users\";s:3:\"alm\";s:20:\"Learning Module AICC\";s:9:\"alm_added\";s:26:\"AICC Learning Module added\";s:10:\"alm_create\";s:27:\"Create AICC Learning Module\";s:10:\"alm_delete\";s:27:\"Delete AICC Learning Module\";s:19:\"alm_edit_permission\";s:26:\"Change permission settings\";s:8:\"alm_join\";s:33:\"Subscribe to AICC Learning Module\";s:9:\"alm_leave\";s:37:\"Unsubscribe from AICC Learning Module\";s:8:\"alm_read\";s:35:\"Read access to AICC Learning Module\";s:11:\"alm_visible\";s:31:\"AICC Learning Module is visible\";s:9:\"alm_write\";s:25:\"Edit AICC Learning Module\";s:23:\"already_delivered_files\";s:15:\"Submitted Files\";s:3:\"and\";s:3:\"and\";s:8:\"announce\";s:8:\"Announce\";s:16:\"announce_changes\";s:16:\"Announce Changes\";s:9:\"anonymous\";s:9:\"Anonymous\";s:7:\"answers\";s:7:\"Answers\";s:12:\"any_language\";s:12:\"Any language\";s:13:\"append_search\";s:21:\"Append search results\";s:21:\"application_completed\";s:23:\"Application is complete\";s:16:\"application_date\";s:16:\"Application date\";s:13:\"applied_users\";s:13:\"Applied users\";s:5:\"apply\";s:5:\"Apply\";s:12:\"apply_filter\";s:12:\"Apply filter\";s:11:\"appointment\";s:11:\"Appointment\";s:16:\"appointment_list\";s:16:\"Appointment List\";s:12:\"approve_date\";s:11:\"Approved on\";s:17:\"approve_recipient\";s:20:\"Login ID of Approver\";s:7:\"archive\";s:7:\"Archive\";s:12:\"are_you_sure\";s:13:\"Are you sure?\";s:15:\"arrow_downright\";s:28:\"Arrow from top to down right\";s:15:\"articels_unread\";s:15:\"Unread articels\";s:5:\"as_of\";s:5:\"as of\";s:15:\"ascending_order\";s:15:\"Ascending order\";s:14:\"assessment_log\";s:56:\"Create an Test&Assessment log for a specific time period\";s:23:\"assessment_log_datetime\";s:9:\"Date/Time\";s:23:\"assessment_log_for_test\";s:8:\"For test\";s:26:\"assessment_log_log_entries\";s:11:\"log entries\";s:21:\"assessment_log_no_log\";s:79:\"It is no log data available for the selected test and the selected time period!\";s:28:\"assessment_log_open_calendar\";s:71:\"Click here to open a calendar for date selection (JavaScript required!)\";s:23:\"assessment_log_question\";s:8:\"Question\";s:26:\"assessment_log_select_test\";s:28:\"--- Please select a test ---\";s:19:\"assessment_log_text\";s:11:\"Log message\";s:26:\"assessment_log_user_answer\";s:24:\"User answered a question\";s:27:\"assessment_log_user_answers\";s:17:\"Show user actions\";s:19:\"assessment_settings\";s:39:\"Test&Assessment Administration Settings\";s:38:\"assessment_settings_reporting_language\";s:18:\"Reporting language\";s:20:\"assf_edit_permission\";s:26:\"Change permission settings\";s:9:\"assf_read\";s:37:\"Access Test&Assessment Administration\";s:12:\"assf_visible\";s:41:\"Test&Assessment administration is visible\";s:10:\"assf_write\";s:35:\"Edit Test&Assessment administration\";s:6:\"assign\";s:6:\"Assign\";s:18:\"assign_global_role\";s:21:\"Assign to Global Role\";s:15:\"assign_lo_forum\";s:15:\"Assign LO Forum\";s:17:\"assign_local_role\";s:20:\"Assign to Local Role\";s:19:\"assign_user_to_role\";s:19:\"Assign User to Role\";s:14:\"assigned_roles\";s:14:\"Assigned Roles\";s:14:\"assigned_users\";s:14:\"Assigned Users\";s:15:\"associated_user\";s:15:\"associated User\";s:16:\"associated_users\";s:16:\"associated Users\";s:18:\"at_least_one_style\";s:41:\"At least one style must remain activated.\";s:11:\"at_location\";s:11:\"at location\";s:10:\"attachment\";s:10:\"Attachment\";s:11:\"attachments\";s:11:\"Attachments\";s:6:\"attend\";s:6:\"Attend\";s:17:\"auth_active_roles\";s:43:\"Global roles available on registration form\";s:16:\"auth_allow_local\";s:26:\"Allow Local Authentication\";s:8:\"auth_cas\";s:3:\"CAS\";s:25:\"auth_cas_allow_local_desc\";s:91:\"This allows CAS users to authenticate with their local ILIAS username and a local password.\";s:13:\"auth_cas_auth\";s:28:\"Configure CAS Authentication\";s:18:\"auth_cas_auth_desc\";s:66:\"CAS requires PHP 4.3.1 or higher with CURL support (7.5 or higher)\";s:26:\"auth_cas_create_users_desc\";s:136:\"Creates automatically an ILIAS user account, for users that successfully authenticated against CAS, without having an ILIAS account yet.\";s:18:\"auth_cas_port_desc\";s:75:\"E.g. 443 if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:20:\"auth_cas_server_desc\";s:91:\"E.g. auth.yourserver.com if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:23:\"auth_cas_settings_saved\";s:18:\"CAS settings saved\";s:17:\"auth_cas_uri_desc\";s:86:\"Local URI, e.g. cas if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:31:\"auth_cas_user_default_role_desc\";s:57:\"This role is assigned to automatically created CAS users.\";s:14:\"auth_configure\";s:12:\"configure...\";s:17:\"auth_create_users\";s:39:\"Create non-existing users automatically\";s:12:\"auth_default\";s:15:\"Default setting\";s:28:\"auth_default_mode_changed_to\";s:38:\"Default authentication mode changed to\";s:20:\"auth_edit_permission\";s:26:\"Change permission settings\";s:9:\"auth_ldap\";s:4:\"LDAP\";s:14:\"auth_ldap_desc\";s:34:\"Authenticate users via LDAP server\";s:16:\"auth_ldap_enable\";s:19:\"Enable LDAP support\";s:24:\"auth_ldap_not_configured\";s:26:\"LDAP is not configured yet\";s:24:\"auth_ldap_settings_saved\";s:19:\"LDAP settings saved\";s:10:\"auth_local\";s:14:\"ILIAS database\";s:15:\"auth_local_desc\";s:53:\"Authenticate users via local ILIAS database (default)\";s:23:\"auth_login_instructions\";s:32:\"Instructions shown on login page\";s:9:\"auth_mode\";s:19:\"Authentication mode\";s:21:\"auth_mode_not_changed\";s:17:\"(Nothing changed)\";s:23:\"auth_mode_roles_changed\";s:41:\"Changed authentication mode for this Role\";s:26:\"auth_new_account_mail_desc\";s:152:\"Send new account mail to user, if user is generated automatically. A password will only be generated, if \"Allow Local Authentication\" is also activated.\";s:16:\"auth_per_default\";s:11:\"Per Default\";s:11:\"auth_radius\";s:6:\"RADIUS\";s:21:\"auth_radius_configure\";s:31:\"Configure RADIUS-Authentication\";s:16:\"auth_radius_desc\";s:36:\"Authenticate users via RADIUS server\";s:18:\"auth_radius_enable\";s:21:\"Enable RADIUS support\";s:26:\"auth_radius_not_configured\";s:28:\"RADIUS is not configured yet\";s:16:\"auth_radius_port\";s:4:\"Port\";s:18:\"auth_radius_server\";s:7:\"Servers\";s:23:\"auth_radius_server_desc\";s:108:\"You may add multiple servers with commas separated. Servers are rotated in Round robin fashion when queried.\";s:26:\"auth_radius_settings_saved\";s:21:\"RADIUS settings saved\";s:25:\"auth_radius_shared_secret\";s:13:\"Shared secret\";s:9:\"auth_read\";s:30:\"Access authentication settings\";s:26:\"auth_remark_non_local_auth\";s:122:\"When selecting another authentication mode than ILIAS database, you may not change user\'s login name and password anymore.\";s:19:\"auth_role_auth_mode\";s:19:\"Authentication mode\";s:11:\"auth_script\";s:6:\"Custom\";s:16:\"auth_script_desc\";s:38:\"Authenticate users via external script\";s:11:\"auth_select\";s:26:\"Select authentication mode\";s:9:\"auth_shib\";s:10:\"Shibboleth\";s:14:\"auth_shib_desc\";s:78:\"Authenticate users via Shibboleth, can be used as second authentication method\";s:24:\"auth_shib_not_configured\";s:32:\"Shibboleth is not configured yet\";s:15:\"auth_shibboleth\";s:10:\"Shibboleth\";s:9:\"auth_soap\";s:4:\"SOAP\";s:26:\"auth_soap_allow_local_desc\";s:92:\"This allows SOAP users to authenticate with their local ILIAS username and a local password.\";s:14:\"auth_soap_auth\";s:29:\"Configure SOAP Authentication\";s:19:\"auth_soap_auth_desc\";s:95:\"This settings deal only with SOAP based user authentication, not with the ILIAS SOAP interface.\";s:27:\"auth_soap_create_users_desc\";s:137:\"Creates automatically an ILIAS user account, for users that successfully authenticated against SOAP, without having an ILIAS account yet.\";s:19:\"auth_soap_namespace\";s:9:\"Namespace\";s:24:\"auth_soap_namespace_desc\";s:66:\"As defined in WSDL. Must be specified, if .NET SOAP style is used.\";s:19:\"auth_soap_port_desc\";s:87:\"E.g. 8080 if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:21:\"auth_soap_server_desc\";s:102:\"E.g. auth.yourserver.com if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:24:\"auth_soap_settings_saved\";s:34:\"SOAP authentication settings saved\";s:18:\"auth_soap_uri_desc\";s:108:\"Local URI, e.g. dir/server.php if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:20:\"auth_soap_use_dotnet\";s:19:\"Use .NET SOAP Style\";s:19:\"auth_soap_use_https\";s:9:\"Use HTTPS\";s:27:\"auth_soap_user_default_role\";s:49:\"Default role assigned to SOAP authenticated users\";s:32:\"auth_soap_user_default_role_desc\";s:58:\"This role is assigned to automatically created SOAP users.\";s:22:\"auth_user_default_role\";s:12:\"Default Role\";s:12:\"auth_visible\";s:35:\"Authentication settings are visible\";s:10:\"auth_write\";s:28:\"Edit authentication settings\";s:23:\"authentication_settings\";s:14:\"Authentication\";s:6:\"author\";s:6:\"Author\";s:7:\"authors\";s:7:\"Authors\";s:17:\"auto_registration\";s:34:\"Automatically approve registration\";s:9:\"available\";s:9:\"Available\";s:19:\"available_languages\";s:19:\"Available Languages\";s:12:\"average_time\";s:12:\"Average time\";s:4:\"back\";s:4:\"Back\";s:19:\"back_to_crs_content\";s:22:\"Back to Course Content\";s:20:\"back_to_fold_content\";s:22:\"Back to Folder Content\";s:19:\"back_to_grp_content\";s:21:\"Back to Group Content\";s:6:\"basedn\";s:6:\"BaseDN\";s:10:\"basic_data\";s:10:\"Basic Data\";s:14:\"basic_settings\";s:14:\"Basic Settings\";s:9:\"benchmark\";s:9:\"Benchmark\";s:18:\"benchmark_settings\";s:18:\"Benchmark Settings\";s:10:\"benchmarks\";s:10:\"Benchmarks\";s:8:\"bib_data\";s:20:\"Bibliographical Data\";s:8:\"big_icon\";s:8:\"Big Icon\";s:10:\"bkm_import\";s:16:\"Import bookmarks\";s:13:\"bkm_import_ok\";s:59:\"Successfully imported %d bookmarks and %d bookmark folders.\";s:12:\"bkm_sendmail\";s:18:\"Send as attachment\";s:2:\"bm\";s:8:\"Bookmark\";s:3:\"bmf\";s:15:\"Bookmark Folder\";s:13:\"bookmark_edit\";s:13:\"Edit Bookmark\";s:20:\"bookmark_folder_edit\";s:20:\"Edit Bookmark Folder\";s:19:\"bookmark_folder_new\";s:19:\"New Bookmark Folder\";s:12:\"bookmark_new\";s:12:\"New Bookmark\";s:15:\"bookmark_target\";s:6:\"Target\";s:9:\"bookmarks\";s:9:\"Bookmarks\";s:12:\"bookmarks_of\";s:12:\"Bookmarks of\";s:12:\"bottom_frame\";s:12:\"Main Content\";s:7:\"btn_add\";s:3:\"Add\";s:13:\"btn_new_value\";s:9:\"New value\";s:8:\"btn_next\";s:8:\"Continue\";s:12:\"btn_previous\";s:4:\"Back\";s:17:\"btn_remove_system\";s:18:\"Remove from System\";s:12:\"btn_undelete\";s:8:\"Undelete\";s:2:\"by\";s:2:\"By\";s:11:\"by_location\";s:17:\"Order by location\";s:7:\"by_type\";s:13:\"Order by type\";s:5:\"bytes\";s:5:\"Bytes\";s:8:\"calendar\";s:8:\"Calendar\";s:6:\"cancel\";s:6:\"Cancel\";s:15:\"cannot_find_xml\";s:25:\"Cannot find any XML-file.\";s:32:\"cannot_uninstall_language_in_use\";s:51:\"You cannot uninstall the language currently in use!\";s:31:\"cannot_uninstall_systemlanguage\";s:41:\"You cannot uninstall the system language!\";s:17:\"cannot_unzip_file\";s:19:\"Cannot unpack file.\";s:33:\"cant_deactivate_if_users_assigned\";s:70:\"You cannot deactivate a style if there are still users assigned to it.\";s:3:\"cat\";s:8:\"Category\";s:5:\"cat_a\";s:10:\"a Category\";s:7:\"cat_add\";s:12:\"Add Category\";s:9:\"cat_added\";s:14:\"Category added\";s:26:\"cat_cat_administrate_users\";s:32:\"Administrate local user accounts\";s:14:\"cat_clear_page\";s:10:\"Clear Page\";s:10:\"cat_create\";s:15:\"Create Category\";s:14:\"cat_create_alm\";s:27:\"Create AICC Learning Module\";s:14:\"cat_create_cat\";s:15:\"Create Category\";s:15:\"cat_create_chat\";s:11:\"Create Chat\";s:14:\"cat_create_crs\";s:13:\"Create Course\";s:14:\"cat_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"cat_create_exc\";s:15:\"Create Exercise\";s:15:\"cat_create_file\";s:11:\"Upload File\";s:14:\"cat_create_frm\";s:12:\"Create Forum\";s:14:\"cat_create_glo\";s:15:\"Create Glossary\";s:14:\"cat_create_grp\";s:12:\"Create Group\";s:14:\"cat_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"cat_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"cat_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"cat_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"cat_create_mep\";s:17:\"Create Media Pool\";s:14:\"cat_create_qpl\";s:29:\"Create Question Pool for Test\";s:15:\"cat_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"cat_create_spl\";s:31:\"Create Question Pool for Survey\";s:14:\"cat_create_svy\";s:13:\"Create Survey\";s:14:\"cat_create_tst\";s:11:\"Create Test\";s:14:\"cat_create_url\";s:10:\"Create URL\";s:15:\"cat_create_webr\";s:19:\"Create Web Resource\";s:10:\"cat_delete\";s:15:\"Delete Category\";s:8:\"cat_edit\";s:13:\"Edit Category\";s:19:\"cat_edit_permission\";s:26:\"Change permission settings\";s:7:\"cat_new\";s:12:\"New Category\";s:9:\"cat_pages\";s:14:\"Category Pages\";s:15:\"cat_pages_clear\";s:22:\"Category page cleared.\";s:21:\"cat_pages_not_created\";s:32:\"Category page not createded yet.\";s:16:\"cat_pages_undone\";s:38:\"Last changes for cagegory page undone.\";s:8:\"cat_read\";s:23:\"Read access to Category\";s:14:\"cat_read_users\";s:34:\"Read access to local user accounts\";s:26:\"cat_undo_last_page_changes\";s:22:\"Undo Last Page Changes\";s:11:\"cat_visible\";s:19:\"Category is visible\";s:9:\"cat_write\";s:13:\"Edit Category\";s:10:\"categories\";s:10:\"Categories\";s:19:\"categories_imported\";s:25:\"Category import complete.\";s:2:\"cc\";s:2:\"CC\";s:3:\"cen\";s:12:\"Centra Event\";s:7:\"cen_add\";s:16:\"Add Centra Event\";s:9:\"cen_added\";s:18:\"Centra Event added\";s:10:\"cen_delete\";s:19:\"Delete Centra Event\";s:8:\"cen_edit\";s:17:\"Edit Centra Event\";s:7:\"cen_new\";s:16:\"New Centra Event\";s:8:\"cen_save\";s:17:\"Save Centra Event\";s:10:\"censorship\";s:10:\"Censorship\";s:14:\"centra_account\";s:20:\"Centra Admin Account\";s:12:\"centra_rooms\";s:12:\"Centra Rooms\";s:13:\"centra_server\";s:13:\"Centra Server\";s:20:\"chac_edit_permission\";s:26:\"Change permission settings\";s:9:\"chac_read\";s:28:\"Read access to chat settings\";s:12:\"chac_visible\";s:25:\"Chat settings are visible\";s:10:\"chac_write\";s:18:\"Edit chat settings\";s:6:\"change\";s:6:\"Change\";s:24:\"change_active_assignment\";s:24:\"Change active assignment\";s:17:\"change_assignment\";s:17:\"Change assignment\";s:23:\"change_existing_objects\";s:23:\"Change existing Objects\";s:19:\"change_header_title\";s:17:\"Edit Header Title\";s:14:\"change_lo_info\";s:14:\"Change LO Info\";s:15:\"change_metadata\";s:15:\"Change Metadata\";s:12:\"change_owner\";s:12:\"Change owner\";s:21:\"change_sort_direction\";s:21:\"Change sort direction\";s:10:\"changeable\";s:10:\"Changeable\";s:10:\"changed_to\";s:10:\"changed to\";s:7:\"chapter\";s:7:\"Chapter\";s:14:\"chapter_number\";s:14:\"Chapter Number\";s:13:\"chapter_title\";s:13:\"Chapter Title\";s:10:\"characters\";s:10:\"characters\";s:4:\"chat\";s:4:\"Chat\";s:14:\"chat_active_in\";s:15:\"Active in chat:\";s:8:\"chat_add\";s:8:\"Add Chat\";s:11:\"chat_delete\";s:11:\"Delete chat\";s:20:\"chat_edit_permission\";s:26:\"Change permission settings\";s:11:\"chat_invite\";s:4:\"Chat\";s:13:\"chat_moderate\";s:13:\"Moderate chat\";s:8:\"chat_new\";s:8:\"New Chat\";s:9:\"chat_read\";s:25:\"Read/Write access to chat\";s:17:\"chat_users_active\";s:12:\"Active users\";s:12:\"chat_visible\";s:15:\"Chat is visible\";s:10:\"chat_write\";s:9:\"Edit chat\";s:5:\"check\";s:5:\"Check\";s:9:\"check_all\";s:9:\"Check all\";s:14:\"check_langfile\";s:31:\"Please check your language file\";s:15:\"check_languages\";s:15:\"Check Languages\";s:10:\"check_link\";s:10:\"Link check\";s:15:\"check_link_desc\";s:91:\"If enabled all external links in ILIAS learning modules will be checked if they are active.\";s:29:\"check_max_allowed_packet_size\";s:35:\"The page content size is too large.\";s:19:\"check_user_accounts\";s:19:\"Check user accounts\";s:24:\"check_user_accounts_desc\";s:113:\"If cron jobs are activated and this option is enabled, all users whose account expires will be informed by email.\";s:19:\"check_web_resources\";s:19:\"Check Web Resources\";s:24:\"check_web_resources_desc\";s:64:\"If enabled all Web Resources will be checked if they are active.\";s:13:\"checked_files\";s:16:\"Importable files\";s:12:\"chg_language\";s:15:\"Change Language\";s:12:\"chg_password\";s:15:\"Change Password\";s:15:\"choose_language\";s:20:\"Choose Your Language\";s:15:\"choose_location\";s:15:\"Choose Location\";s:24:\"choose_only_one_language\";s:31:\"Please choose only one language\";s:13:\"chown_warning\";s:84:\"Attention, you may loose access permissions on this object after changing the owner.\";s:4:\"city\";s:11:\"City, State\";s:12:\"cleaned_file\";s:22:\"File has been cleaned.\";s:15:\"cleaning_failed\";s:16:\"Cleaning failed.\";s:5:\"clear\";s:5:\"Clear\";s:15:\"clear_clipboard\";s:15:\"Empty Clipboard\";s:6:\"client\";s:6:\"Client\";s:9:\"client_id\";s:9:\"Client ID\";s:9:\"client_ip\";s:9:\"Client IP\";s:9:\"clipboard\";s:9:\"Clipboard\";s:5:\"close\";s:5:\"Close\";s:12:\"close_window\";s:12:\"Close window\";s:7:\"cnt_new\";s:8:\"(%s New)\";s:8:\"collapse\";s:8:\"Collapse\";s:15:\"comma_separated\";s:15:\"Comma Separated\";s:7:\"comment\";s:7:\"Comment\";s:7:\"compose\";s:7:\"Compose\";s:9:\"condition\";s:9:\"Condition\";s:26:\"condition_already_assigned\";s:24:\"Object already assigned.\";s:24:\"condition_circle_created\";s:70:\"This association is not possible, since the objects would interdepend.\";s:17:\"condition_deleted\";s:18:\"Condition deleted.\";s:18:\"condition_finished\";s:8:\"Finished\";s:22:\"condition_not_finished\";s:12:\"Not finished\";s:16:\"condition_passed\";s:6:\"Passed\";s:22:\"condition_precondition\";s:14:\"Preconditions:\";s:23:\"condition_select_object\";s:25:\"Please select one object.\";s:20:\"condition_select_one\";s:29:\"-Please select one condition-\";s:16:\"condition_update\";s:4:\"Save\";s:18:\"conditions_updated\";s:16:\"Conditions saved\";s:7:\"confirm\";s:7:\"Confirm\";s:12:\"confirmation\";s:12:\"Confirmation\";s:17:\"conflict_handling\";s:17:\"Conflict handling\";s:11:\"cont_object\";s:6:\"Object\";s:12:\"contact_data\";s:19:\"Contact Information\";s:9:\"container\";s:9:\"Container\";s:7:\"content\";s:7:\"Content\";s:14:\"content_styles\";s:14:\"Content Styles\";s:7:\"context\";s:7:\"Context\";s:13:\"continue_work\";s:8:\"Continue\";s:6:\"contra\";s:6:\"Contra\";s:13:\"cookies_howto\";s:21:\"How to enable cookies\";s:13:\"copied_object\";s:13:\"Copied object\";s:4:\"copy\";s:4:\"Copy\";s:11:\"copyChapter\";s:4:\"Copy\";s:8:\"copyPage\";s:4:\"Copy\";s:7:\"copy_of\";s:7:\"Copy of\";s:7:\"copy_to\";s:2:\"to\";s:24:\"could_not_verify_account\";s:81:\"Sorry, we could not verify your account. Please contact the system administrator.\";s:5:\"count\";s:5:\"Count\";s:7:\"country\";s:7:\"Country\";s:6:\"course\";s:6:\"Course\";s:7:\"courses\";s:7:\"Courses\";s:6:\"create\";s:6:\"Create\";s:11:\"create_date\";s:10:\"Created on\";s:18:\"create_export_file\";s:18:\"Create export file\";s:9:\"create_in\";s:9:\"Create in\";s:17:\"create_stylesheet\";s:12:\"Create Style\";s:7:\"created\";s:11:\"Create date\";s:23:\"cron_forum_notification\";s:24:\"Send forum notifications\";s:28:\"cron_forum_notification_cron\";s:22:\"regularly per cron job\";s:28:\"cron_forum_notification_desc\";s:123:\"If enabled, all users, who want to be informed about new posts in specified forum topics, will get notifications by e-mail.\";s:32:\"cron_forum_notification_directly\";s:23:\"directly on new entries\";s:29:\"cron_forum_notification_never\";s:5:\"never\";s:9:\"cron_jobs\";s:9:\"Cron jobs\";s:14:\"cron_jobs_desc\";s:152:\"A cron job is an automated process that operates at predefined time intervals. You will find informations about the setup in the \'INSTALL Documentation.\";s:17:\"cron_lucene_index\";s:26:\"Update Lucene search index\";s:22:\"cron_lucene_index_info\";s:118:\"If enabled, the lucene search index will be updated. Please configure the lucene server at \'Administration -> Search\'.\";s:3:\"crs\";s:6:\"Course\";s:5:\"crs_a\";s:8:\"a Course\";s:28:\"crs_activation_start_invalid\";s:40:\"The start and the end time is not valid.\";s:7:\"crs_add\";s:10:\"Add Course\";s:9:\"crs_added\";s:12:\"Course added\";s:39:\"crs_all_questions_answered_successfully\";s:46:\"You have successfully answered every question.\";s:12:\"crs_archives\";s:8:\"Archives\";s:22:\"crs_at_least_one_admin\";s:50:\"There has to be at least one course administrator.\";s:13:\"crs_available\";s:17:\"Available Courses\";s:30:\"crs_container_link_not_allowed\";s:44:\"It is not possible to link container objects\";s:10:\"crs_create\";s:13:\"Create Course\";s:14:\"crs_create_alm\";s:27:\"Create AICC Learning Module\";s:15:\"crs_create_chat\";s:11:\"Create Chat\";s:14:\"crs_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"crs_create_exc\";s:15:\"Create Exercise\";s:15:\"crs_create_file\";s:11:\"Upload File\";s:15:\"crs_create_fold\";s:13:\"Create Folder\";s:14:\"crs_create_frm\";s:12:\"Create Forum\";s:14:\"crs_create_glo\";s:15:\"Create Glossary\";s:14:\"crs_create_grp\";s:12:\"Create Group\";s:14:\"crs_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"crs_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"crs_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"crs_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"crs_create_mep\";s:17:\"Create Media Pool\";s:14:\"crs_create_qpl\";s:29:\"Create Question Pool for Test\";s:15:\"crs_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"crs_create_spl\";s:31:\"Create Question Pool for Survey\";s:14:\"crs_create_svy\";s:13:\"Create Survey\";s:14:\"crs_create_tst\";s:11:\"Create Test\";s:15:\"crs_create_webr\";s:19:\"Create Web Resource\";s:10:\"crs_delete\";s:13:\"Delete Course\";s:8:\"crs_edit\";s:11:\"Edit Course\";s:26:\"crs_edit_learning_progress\";s:22:\"Edit learning progress\";s:19:\"crs_edit_permission\";s:26:\"Change permission settings\";s:8:\"crs_info\";s:4:\"Info\";s:8:\"crs_join\";s:11:\"Join Course\";s:9:\"crs_leave\";s:12:\"Leave Course\";s:21:\"crs_management_system\";s:24:\"Course Management System\";s:21:\"crs_member_not_passed\";s:10:\"Not passed\";s:17:\"crs_member_passed\";s:6:\"Passed\";s:19:\"crs_members_gallery\";s:22:\"Course Members Gallery\";s:7:\"crs_new\";s:10:\"New Course\";s:14:\"crs_no_content\";s:15:\"Without content\";s:8:\"crs_read\";s:21:\"Read access to Course\";s:18:\"crs_status_blocked\";s:16:\"[Access refused]\";s:18:\"crs_status_pending\";s:26:\"[Waiting for registration]\";s:24:\"crs_subscribers_assigned\";s:20:\"Assigned new user(s)\";s:11:\"crs_visible\";s:17:\"Course is visible\";s:9:\"crs_write\";s:11:\"Edit Course\";s:15:\"cumulative_time\";s:15:\"Cumulative time\";s:14:\"cur_number_rec\";s:25:\"Current number of records\";s:10:\"current_ip\";s:11:\"Current IP:\";s:16:\"current_ip_alert\";s:97:\"Notice: if you enter a wrong ip you won\'t be able to access the system with this profile anymore.\";s:16:\"current_password\";s:16:\"Current Password\";s:20:\"custom_icon_size_big\";s:22:\"Custom icon size (big)\";s:22:\"custom_icon_size_small\";s:24:\"Custom icon size (small)\";s:3:\"cut\";s:3:\"Cut\";s:7:\"cutPage\";s:3:\"Cut\";s:5:\"daily\";s:5:\"daily\";s:12:\"data_privacy\";s:21:\"Data Privacy Settings\";s:8:\"database\";s:8:\"Database\";s:16:\"database_version\";s:24:\"Current Database Version\";s:7:\"dataset\";s:4:\"Item\";s:4:\"date\";s:4:\"Date\";s:10:\"dateplaner\";s:8:\"Calendar\";s:3:\"day\";s:3:\"Day\";s:4:\"days\";s:4:\"Days\";s:14:\"days_of_period\";s:14:\"Days of period\";s:7:\"db_host\";s:13:\"Database Host\";s:7:\"db_name\";s:13:\"Database Name\";s:14:\"db_need_update\";s:25:\"Database needs an update!\";s:7:\"db_pass\";s:17:\"Database Password\";s:7:\"db_type\";s:13:\"Database Type\";s:7:\"db_user\";s:13:\"Database User\";s:10:\"db_version\";s:16:\"Database Version\";s:3:\"dbk\";s:12:\"Digilib Book\";s:5:\"dbk_a\";s:14:\"a Digilib Book\";s:7:\"dbk_add\";s:16:\"Add Digilib Book\";s:9:\"dbk_added\";s:18:\"Digilib Book added\";s:10:\"dbk_create\";s:19:\"Create Digilib Book\";s:10:\"dbk_delete\";s:19:\"Delete Digilib Book\";s:26:\"dbk_edit_learning_progress\";s:22:\"Edit learning progress\";s:19:\"dbk_edit_permission\";s:26:\"Change permission settings\";s:7:\"dbk_new\";s:16:\"New Digilib Book\";s:8:\"dbk_read\";s:27:\"Read access to Digilib Book\";s:11:\"dbk_visible\";s:23:\"Digilib Book is visible\";s:9:\"dbk_write\";s:17:\"Edit Digilib Book\";s:19:\"def_repository_view\";s:23:\"Default repository view\";s:7:\"default\";s:7:\"Default\";s:16:\"default_language\";s:16:\"Default Language\";s:21:\"default_perm_settings\";s:19:\"Default permissions\";s:12:\"default_role\";s:12:\"Default Role\";s:13:\"default_roles\";s:13:\"Default Roles\";s:12:\"default_skin\";s:12:\"Default Skin\";s:18:\"default_skin_style\";s:20:\"Default Skin / Style\";s:13:\"default_style\";s:13:\"Default Style\";s:13:\"default_value\";s:13:\"Default Value\";s:6:\"delete\";s:6:\"Delete\";s:10:\"delete_all\";s:10:\"Delete All\";s:14:\"delete_all_rec\";s:18:\"Delete all records\";s:13:\"delete_object\";s:16:\"Delete Object(s)\";s:15:\"delete_selected\";s:15:\"Delete Selected\";s:21:\"delete_selected_items\";s:21:\"Delete selected items\";s:14:\"delete_tr_data\";s:20:\"Delete tracking data\";s:7:\"deleted\";s:7:\"Deleted\";s:12:\"deleted_user\";s:25:\"The user has been deleted\";s:13:\"deleted_users\";s:13:\"Deleted users\";s:7:\"deliver\";s:7:\"Deliver\";s:10:\"department\";s:10:\"Department\";s:4:\"desc\";s:11:\"Description\";s:16:\"descending_order\";s:16:\"Descending order\";s:11:\"description\";s:11:\"Description\";s:16:\"desired_password\";s:16:\"Desired Password\";s:13:\"desktop_items\";s:22:\"Personal desktop items\";s:7:\"details\";s:7:\"Details\";s:7:\"disable\";s:7:\"disable\";s:13:\"disable_check\";s:13:\"Disable check\";s:8:\"disabled\";s:8:\"Disabled\";s:6:\"domain\";s:6:\"Domain\";s:4:\"down\";s:4:\"Down\";s:8:\"download\";s:8:\"Download\";s:27:\"download_all_returned_files\";s:27:\"Download all returned files\";s:6:\"drafts\";s:6:\"Drafts\";s:4:\"drop\";s:4:\"Drop\";s:4:\"edit\";s:4:\"Edit\";s:13:\"edit_comments\";s:35:\"Edit comments for the selected user\";s:12:\"edit_content\";s:12:\"Edit content\";s:9:\"edit_data\";s:9:\"edit data\";s:15:\"edit_operations\";s:15:\"Edit Operations\";s:9:\"edit_page\";s:9:\"Edit Page\";s:17:\"edit_page_content\";s:17:\"Edit Page Content\";s:17:\"edit_perm_ruleset\";s:29:\"Edit default permission rules\";s:15:\"edit_properties\";s:15:\"Edit Properties\";s:19:\"edit_roleassignment\";s:20:\"Edit role assignment\";s:15:\"edit_stylesheet\";s:10:\"Edit Style\";s:9:\"edited_at\";s:9:\"Edited at\";s:6:\"editor\";s:6:\"Editor\";s:5:\"email\";s:4:\"Mail\";s:14:\"email_feedback\";s:13:\"Mail feedback\";s:12:\"email_footer\";s:22:\"<br />powered by ILIAS\";s:15:\"email_not_valid\";s:43:\"The email address you entered is not valid!\";s:6:\"enable\";s:6:\"Enable\";s:15:\"enable_calendar\";s:15:\"Enable Calendar\";s:19:\"enable_custom_icons\";s:19:\"Enable custom icons\";s:24:\"enable_custom_icons_info\";s:171:\"This allows to define custom icons for single categories, courses and groups. The properties section of categories, courses and groups will provide an image upload dialog.\";s:22:\"enable_fora_statistics\";s:26:\"Enable Statistics in Forum\";s:27:\"enable_fora_statistics_desc\";s:59:\"If disabled, nobody is able to access the forum statistics.\";s:25:\"enable_hist_user_comments\";s:31:\"Enable user comments in history\";s:30:\"enable_hist_user_comments_desc\";s:73:\"Give authors the opportunity to add comments to the history log of pages.\";s:14:\"enable_js_edit\";s:25:\"Enable JavaScript Editing\";s:19:\"enable_js_edit_info\";s:136:\"This option enables JavaScript editing for all content objects (ILIAS Learning Modules, Glossaries, Assessment Questions, Digilib Books)\";s:26:\"enable_password_assistance\";s:26:\"Enable password assistance\";s:19:\"enable_registration\";s:28:\"Enable new user registration\";s:12:\"enable_trash\";s:12:\"Enable Trash\";s:17:\"enable_trash_info\";s:164:\"If enabled, deleted Objects are moved into Trash and may be recovered later. When deactivating this option deleted Objects are removed irreversibly from the System!\";s:7:\"enabled\";s:7:\"Enabled\";s:22:\"enter_filename_deliver\";s:26:\"Enter file to be delivered\";s:9:\"enumerate\";s:9:\"Enumerate\";s:11:\"err_1_param\";s:17:\"Only 1 parameter!\";s:11:\"err_2_param\";s:17:\"Only 2 parameter!\";s:26:\"err_auth_cas_no_ilias_user\";s:126:\"Login failed. CAS authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.\";s:24:\"err_auth_ext_user_exists\";s:83:\"External account \'%s\' for authentication mode \'%s\' is already existing. (User \'%s\')\";s:27:\"err_auth_soap_no_ilias_user\";s:127:\"Login failed. SOAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.\";s:15:\"err_count_param\";s:29:\"Reason: Wrong parameter count\";s:24:\"err_enter_current_passwd\";s:34:\"Please enter your current password\";s:11:\"err_in_line\";s:13:\"Error in line\";s:12:\"err_inactive\";s:88:\"This account has not been activated. Please contact the system administrator for access.\";s:16:\"err_invalid_port\";s:19:\"Invalid port number\";s:20:\"err_ldap_auth_failed\";s:102:\"User not authenticated on LDAP server! Please ensure that you have the same password in ILIAS and LDAP\";s:23:\"err_ldap_connect_failed\";s:60:\"Connection to LDAP server failed! Please check your settings\";s:22:\"err_ldap_search_failed\";s:69:\"Connection to LDAP server failed! PLease check BaseDN and Search base\";s:23:\"err_ldap_user_not_found\";s:84:\"User not found on LDAP server! Please check attribute for login name and Objectclass\";s:14:\"err_no_cookies\";s:46:\"Please enable session cookies in your browser!\";s:21:\"err_no_langfile_found\";s:23:\"No language file found!\";s:12:\"err_no_param\";s:13:\"No parameter!\";s:16:\"err_over_3_param\";s:23:\"More than 3 parameters!\";s:23:\"err_role_not_assignable\";s:53:\"You cannot assign users to this role at this location\";s:19:\"err_session_expired\";s:24:\"Your session is expired!\";s:17:\"err_unknown_error\";s:13:\"Unknown Error\";s:16:\"err_wrong_header\";s:21:\"Reason: Wrong header.\";s:15:\"err_wrong_login\";s:23:\"Wrong Login or Password\";s:18:\"err_wrong_password\";s:14:\"Wrong Password\";s:5:\"error\";s:5:\"Error\";s:12:\"error_parser\";s:26:\"Error starting the parser.\";s:15:\"error_recipient\";s:15:\"Error Recipient\";s:3:\"exc\";s:8:\"Exercise\";s:7:\"exc_add\";s:12:\"Add Exercise\";s:9:\"exc_added\";s:14:\"Exercise added\";s:14:\"exc_ask_delete\";s:12:\"Delete file?\";s:14:\"exc_assign_usr\";s:11:\"Assign User\";s:10:\"exc_create\";s:15:\"Create exercise\";s:18:\"exc_date_not_valid\";s:21:\"The date is not valid\";s:20:\"exc_deassign_members\";s:16:\"Delete member(s)\";s:10:\"exc_delete\";s:15:\"Delete exercise\";s:11:\"exc_details\";s:16:\"Exercise details\";s:16:\"exc_download_all\";s:12:\"Download All\";s:18:\"exc_download_files\";s:14:\"Download Files\";s:16:\"exc_download_new\";s:12:\"Download New\";s:8:\"exc_edit\";s:20:\"New exercise created\";s:17:\"exc_edit_exercise\";s:13:\"Edit exercise\";s:26:\"exc_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"exc_edit_permission\";s:26:\"Change permission settings\";s:14:\"exc_edit_until\";s:10:\"Edit Until\";s:17:\"exc_exercise_sent\";s:13:\"Exercise Sent\";s:17:\"exc_feedback_sent\";s:13:\"Feedback Sent\";s:9:\"exc_files\";s:5:\"Files\";s:18:\"exc_files_returned\";s:15:\"Submitted Files\";s:10:\"exc_groups\";s:6:\"Groups\";s:18:\"exc_header_members\";s:18:\"Exercise (members)\";s:15:\"exc_instruction\";s:17:\"Work Instructions\";s:19:\"exc_last_submission\";s:15:\"Last Submission\";s:14:\"exc_mail_users\";s:20:\"Send mail to user(s)\";s:28:\"exc_members_already_assigned\";s:48:\"These user are already assigned to this exercise\";s:20:\"exc_members_assigned\";s:16:\"Members assigned\";s:26:\"exc_members_comments_saved\";s:59:\"The exercise comments for the selected user have been saved\";s:7:\"exc_new\";s:12:\"New exercise\";s:23:\"exc_no_members_assigned\";s:19:\"No members assigned\";s:11:\"exc_notices\";s:7:\"Notices\";s:7:\"exc_obj\";s:8:\"Exercise\";s:8:\"exc_read\";s:15:\"Access exercise\";s:22:\"exc_resubmitted_advice\";s:114:\"This symbol will be displayed in case that a new file has been submitted after the \"solved\" field has been checked\";s:9:\"exc_roles\";s:5:\"Roles\";s:16:\"exc_save_changes\";s:4:\"Save\";s:12:\"exc_schedule\";s:8:\"Schedule\";s:14:\"exc_search_for\";s:10:\"Search for\";s:19:\"exc_select_one_file\";s:31:\"Please select exactly one file.\";s:17:\"exc_send_exercise\";s:21:\"Send exercise by mail\";s:8:\"exc_sent\";s:48:\"The exercise has been sent to the selected users\";s:11:\"exc_sent_at\";s:16:\"Sent at <br />%s\";s:10:\"exc_status\";s:6:\"Status\";s:22:\"exc_status_resubmitted\";s:11:\"Resubmitted\";s:16:\"exc_status_saved\";s:16:\"Exercise updated\";s:15:\"exc_status_sent\";s:9:\"Delivered\";s:17:\"exc_status_solved\";s:6:\"Solved\";s:20:\"exc_status_submitted\";s:9:\"Submitted\";s:14:\"exc_submission\";s:10:\"Submission\";s:19:\"exc_time_over_short\";s:13:\"Time is over.\";s:16:\"exc_time_to_send\";s:22:\"Remaining Working Time\";s:16:\"exc_upload_error\";s:20:\"Error uploading file\";s:9:\"exc_users\";s:5:\"Users\";s:11:\"exc_visible\";s:19:\"Exercise is visible\";s:9:\"exc_write\";s:13:\"Edit exercise\";s:4:\"excs\";s:9:\"Exercises\";s:7:\"execute\";s:7:\"Execute\";s:18:\"exercise_time_over\";s:79:\"You have reached the end time of the exercise. You cannot longer deliver files!\";s:8:\"exp_html\";s:11:\"Export HTML\";s:6:\"expand\";s:6:\"Expand\";s:14:\"explorer_frame\";s:13:\"Explorer Tree\";s:6:\"export\";s:6:\"Export\";s:20:\"export_group_members\";s:41:\"Export group members (to Microsoft Excel)\";s:11:\"export_html\";s:19:\"export as HTML file\";s:10:\"export_xml\";s:18:\"export as XML file\";s:14:\"extt_configure\";s:12:\"configure...\";s:20:\"extt_edit_permission\";s:26:\"Change permission settings\";s:10:\"extt_ilinc\";s:18:\"netucate LearnLinc\";s:29:\"extt_ilinc_additional_options\";s:18:\"Additional Options\";s:31:\"extt_ilinc_akclassvalues_active\";s:19:\"Enable cost centers\";s:36:\"extt_ilinc_akclassvalues_active_info\";s:93:\"With this option enabled you may use iLinc cost centers for Learnlinc-Seminars and Classrooms\";s:33:\"extt_ilinc_akclassvalues_required\";s:20:\"Cost center required\";s:38:\"extt_ilinc_akclassvalues_required_info\";s:71:\"Specifying at least one Cost center for a LearnLinc Seminar is required\";s:20:\"extt_ilinc_configure\";s:28:\"Configure netucate LearnLinc\";s:26:\"extt_ilinc_connection_data\";s:15:\"Connection data\";s:22:\"extt_ilinc_customer_id\";s:11:\"Customer ID\";s:15:\"extt_ilinc_desc\";s:131:\"Provides virtual classrooms. Commercial service. For an account and further information please contact netucate at www.netucate.com\";s:17:\"extt_ilinc_enable\";s:24:\"Enable LearnLinc support\";s:24:\"extt_ilinc_protocol_port\";s:15:\"Protocol & Port\";s:26:\"extt_ilinc_registrar_login\";s:8:\"Login ID\";s:27:\"extt_ilinc_registrar_passwd\";s:8:\"Password\";s:17:\"extt_ilinc_server\";s:6:\"Server\";s:25:\"extt_ilinc_settings_saved\";s:24:\"LearnLinc settings saved\";s:18:\"extt_ilinc_timeout\";s:36:\"Max time waiting for server response\";s:9:\"extt_name\";s:16:\"Software/Service\";s:9:\"extt_read\";s:36:\"Access third party software settings\";s:11:\"extt_remark\";s:123:\"All software and services listed above are not part of ILIAS and do not fall under the ILIAS open source licence agreement.\";s:20:\"extt_title_configure\";s:27:\"Configure external software\";s:12:\"extt_visible\";s:41:\"Third party software settings are visible\";s:10:\"extt_write\";s:30:\"Configure third party software\";s:12:\"faq_exercise\";s:12:\"FAQ Exercise\";s:3:\"fax\";s:3:\"Fax\";s:8:\"feedback\";s:8:\"Feedback\";s:18:\"feedback_recipient\";s:18:\"Feedback Recipient\";s:10:\"field_name\";s:10:\"Field Name\";s:10:\"field_type\";s:10:\"Field Type\";s:4:\"file\";s:4:\"File\";s:6:\"file_a\";s:6:\"a File\";s:8:\"file_add\";s:11:\"Upload File\";s:21:\"file_add_and_metadata\";s:29:\"Upload File and Edit Metadata\";s:10:\"file_added\";s:13:\"File uploaded\";s:11:\"file_delete\";s:11:\"Delete File\";s:9:\"file_edit\";s:9:\"Edit File\";s:20:\"file_edit_permission\";s:26:\"Change Permission settings\";s:9:\"file_icon\";s:9:\"File icon\";s:9:\"file_info\";s:16:\"File Information\";s:16:\"file_is_infected\";s:32:\"The file is infected by a virus.\";s:8:\"file_new\";s:8:\"New File\";s:14:\"file_not_found\";s:14:\"File Not Found\";s:14:\"file_not_valid\";s:15:\"File not valid!\";s:11:\"file_notice\";s:44:\"Please take note of the maximum file size of\";s:9:\"file_read\";s:13:\"Download File\";s:16:\"file_suffix_repl\";s:30:\"File Upload Suffix Replacement\";s:21:\"file_suffix_repl_info\";s:164:\"Files ending with these suffixes (separated by comma) will be renamed with a suffix \".sec\" if uploaded into the webspace. This is done per default for the suffixes:\";s:10:\"file_valid\";s:14:\"File is valid!\";s:12:\"file_version\";s:24:\"Version Provided in File\";s:12:\"file_visible\";s:15:\"File is visible\";s:10:\"file_write\";s:9:\"Edit File\";s:8:\"filename\";s:8:\"Filename\";s:5:\"files\";s:5:\"Files\";s:14:\"files_location\";s:14:\"Files Location\";s:28:\"fill_out_all_required_fields\";s:35:\"Please fill out all required fields\";s:6:\"filter\";s:7:\"Filter:\";s:9:\"firstname\";s:10:\"First name\";s:8:\"flatview\";s:9:\"Flat View\";s:4:\"fold\";s:6:\"Folder\";s:6:\"fold_a\";s:8:\"a Folder\";s:8:\"fold_add\";s:10:\"Add Folder\";s:10:\"fold_added\";s:12:\"Folder added\";s:15:\"fold_create_alm\";s:27:\"Create AICC Learning Module\";s:16:\"fold_create_chat\";s:11:\"Create Chat\";s:15:\"fold_create_dbk\";s:19:\"Create Digilib Book\";s:15:\"fold_create_exc\";s:15:\"Create Exercise\";s:16:\"fold_create_file\";s:11:\"Upload File\";s:16:\"fold_create_fold\";s:13:\"Create Folder\";s:15:\"fold_create_frm\";s:12:\"Create Forum\";s:15:\"fold_create_glo\";s:15:\"Create Glossary\";s:15:\"fold_create_hlm\";s:27:\"Create HACP Learning Module\";s:16:\"fold_create_htlm\";s:27:\"Create HTML Learning Module\";s:16:\"fold_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:14:\"fold_create_lm\";s:28:\"Create ILIAS Learning Module\";s:15:\"fold_create_mep\";s:17:\"Create Media Pool\";s:15:\"fold_create_qpl\";s:29:\"Create Question Pool for Test\";s:16:\"fold_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:15:\"fold_create_spl\";s:31:\"Create Question Pool for Survey\";s:15:\"fold_create_svy\";s:13:\"Create Survey\";s:15:\"fold_create_tst\";s:11:\"Create Test\";s:16:\"fold_create_webr\";s:19:\"Create Web Resource\";s:11:\"fold_delete\";s:13:\"Delete Folder\";s:9:\"fold_edit\";s:11:\"Edit Folder\";s:27:\"fold_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:20:\"fold_edit_permission\";s:26:\"Change Permission settings\";s:8:\"fold_new\";s:10:\"New Folder\";s:9:\"fold_read\";s:21:\"Read access to Folder\";s:12:\"fold_visible\";s:17:\"Folder is visible\";s:10:\"fold_write\";s:11:\"Edit Folder\";s:6:\"folder\";s:6:\"Folder\";s:7:\"folders\";s:7:\"Folders\";s:26:\"force_accept_usr_agreement\";s:35:\"You must accept the user agreement!\";s:8:\"forename\";s:8:\"Forename\";s:15:\"forgot_password\";s:16:\"Forgot password?\";s:15:\"forgot_username\";s:16:\"Forgot username?\";s:17:\"form_empty_fields\";s:29:\"Please complete these fields:\";s:5:\"forum\";s:5:\"Forum\";s:25:\"forum_direct_notification\";s:17:\"Dir. Notification\";s:26:\"forum_general_notification\";s:17:\"Gen. Notification\";s:12:\"forum_import\";s:12:\"Forum import\";s:17:\"forum_import_file\";s:11:\"Import file\";s:18:\"forum_notification\";s:12:\"Notification\";s:15:\"forum_notify_me\";s:32:\"Notify me when a reply is posted\";s:24:\"forum_notify_me_directly\";s:57:\"Please inform me about direct answers to my contribution.\";s:25:\"forum_notify_me_generally\";s:57:\"Please inform me about any new contributions to my topic.\";s:18:\"forum_post_replied\";s:34:\"Your forum entry has been replied.\";s:6:\"forums\";s:6:\"Forums\";s:15:\"forums_articles\";s:8:\"Articles\";s:16:\"forums_last_post\";s:12:\"Last Article\";s:17:\"forums_moderators\";s:10:\"Moderators\";s:19:\"forums_new_articles\";s:12:\"New articles\";s:15:\"forums_overview\";s:15:\"Forums Overview\";s:14:\"forums_threads\";s:6:\"Topics\";s:3:\"frm\";s:5:\"Forum\";s:5:\"frm_a\";s:7:\"a Forum\";s:7:\"frm_add\";s:9:\"Add Forum\";s:9:\"frm_added\";s:11:\"Forum added\";s:11:\"frm_article\";s:7:\"article\";s:10:\"frm_create\";s:12:\"Create Forum\";s:10:\"frm_delete\";s:12:\"Delete Forum\";s:15:\"frm_delete_post\";s:25:\"Delete a post, censorship\";s:8:\"frm_edit\";s:10:\"Edit Forum\";s:19:\"frm_edit_permission\";s:26:\"Change permission settings\";s:13:\"frm_edit_post\";s:23:\"Add new thread, posting\";s:7:\"frm_new\";s:9:\"New Forum\";s:8:\"frm_read\";s:20:\"Read access to Forum\";s:22:\"frm_statistics_ranking\";s:7:\"Ranking\";s:14:\"frm_status_new\";s:12:\"Status \'New\'\";s:19:\"frm_status_new_desc\";s:77:\"Please select a duration how long the status \'New\' is kept for forum entries.\";s:11:\"frm_visible\";s:16:\"Forum is visible\";s:9:\"frm_write\";s:10:\"Edit forum\";s:4:\"from\";s:4:\"From\";s:8:\"fullname\";s:9:\"Full name\";s:9:\"functions\";s:9:\"Functions\";s:7:\"gdf_add\";s:14:\"Add Definition\";s:7:\"gdf_new\";s:14:\"New Definition\";s:6:\"gender\";s:6:\"Gender\";s:8:\"gender_f\";s:6:\"Female\";s:8:\"gender_m\";s:4:\"Male\";s:16:\"general_settings\";s:16:\"General settings\";s:8:\"generate\";s:8:\"Generate\";s:3:\"glo\";s:8:\"Glossary\";s:5:\"glo_a\";s:10:\"a Glossary\";s:7:\"glo_add\";s:12:\"Add Glossary\";s:9:\"glo_added\";s:14:\"Glossary added\";s:10:\"glo_create\";s:15:\"Create Glossary\";s:10:\"glo_delete\";s:15:\"Delete Glossary\";s:19:\"glo_edit_permission\";s:26:\"Change permission settings\";s:8:\"glo_join\";s:21:\"Subscribe to Glossary\";s:9:\"glo_leave\";s:25:\"Unsubscribe from Glossary\";s:8:\"glo_mode\";s:4:\"Mode\";s:13:\"glo_mode_desc\";s:321:\"A virtual glossary works like a normal glossary. Additionally it contains the terms from all glossaries that are located on the same level in the repository like the virtual glossary (level) respectively from all glossaries that are located downwards in the repository from the position of the virtual glossary (subtree).\";s:14:\"glo_mode_level\";s:25:\"virtual (this level only)\";s:15:\"glo_mode_normal\";s:6:\"normal\";s:16:\"glo_mode_subtree\";s:24:\"virtual (entire subtree)\";s:7:\"glo_new\";s:12:\"New Glossary\";s:8:\"glo_read\";s:23:\"Read access to Glossary\";s:15:\"glo_upload_file\";s:4:\"File\";s:11:\"glo_visible\";s:19:\"Glossary is visible\";s:9:\"glo_write\";s:13:\"Edit Glossary\";s:6:\"global\";s:6:\"Global\";s:14:\"global_default\";s:14:\"Global Default\";s:12:\"global_fixed\";s:12:\"Global Fixed\";s:15:\"global_settings\";s:15:\"Global settings\";s:11:\"global_user\";s:12:\"Global users\";s:10:\"glossaries\";s:10:\"Glossaries\";s:8:\"glossary\";s:8:\"Glossary\";s:14:\"glossary_added\";s:14:\"Glossary added\";s:19:\"group_access_denied\";s:13:\"Access Denied\";s:17:\"group_any_objects\";s:23:\"No subobjects available\";s:17:\"group_create_chat\";s:11:\"Create chat\";s:10:\"group_desc\";s:17:\"Group Description\";s:13:\"group_details\";s:13:\"Group Details\";s:17:\"group_filesharing\";s:18:\"Group File Sharing\";s:12:\"group_import\";s:12:\"Group import\";s:17:\"group_import_file\";s:11:\"Import file\";s:14:\"group_info_reg\";s:19:\"Admission procedure\";s:13:\"group_members\";s:13:\"Group Members\";s:13:\"group_memstat\";s:13:\"Member Status\";s:19:\"group_memstat_admin\";s:13:\"Administrator\";s:20:\"group_memstat_member\";s:6:\"Member\";s:10:\"group_name\";s:10:\"Group name\";s:23:\"group_new_registrations\";s:13:\"Join requests\";s:21:\"group_no_registration\";s:10:\"Join group\";s:25:\"group_no_registration_msg\";s:33:\"You can join this group directly.\";s:19:\"group_not_available\";s:18:\"No group available\";s:13:\"group_objects\";s:13:\"Group Objects\";s:31:\"group_password_registration_msg\";s:126:\"If you know the group password, you can join this group. Please contact a group administrator, if you don\'t know the password.\";s:18:\"group_registration\";s:12:\"Registration\";s:34:\"group_registration_expiration_date\";s:15:\"Expiration Date\";s:34:\"group_registration_expiration_time\";s:15:\"Expiration Time\";s:26:\"group_registration_expired\";s:50:\"The time period for joining this group has expired\";s:30:\"group_registration_expired_msg\";s:121:\"The time period for joining this group has expired. Please contact a group administrator, if you want to join this group.\";s:23:\"group_registration_mode\";s:22:\"Registration procedure\";s:23:\"group_registration_time\";s:19:\"Registration period\";s:16:\"group_req_direct\";s:13:\"Join directly\";s:18:\"group_req_password\";s:24:\"Join with group password\";s:22:\"group_req_registration\";s:18:\"Request membership\";s:26:\"group_req_registration_msg\";s:135:\"You can request membership for this group. You will receive a message when a group administrator has accepted or declined your request.\";s:11:\"group_reset\";s:23:\"Reset Group Permissions\";s:12:\"group_status\";s:8:\"Group is\";s:19:\"group_status_closed\";s:6:\"Closed\";s:17:\"group_status_desc\";s:292:\"Determines the initial status of the group by using the permission settings from the role templates \'il_grp_status_closed\' or \'il_grp_status_open\'<br />Public: Group is visible; User may subscribe.<br />Closed: Group is not visible for non-members; User has to be invited by a member to join.\";s:19:\"group_status_public\";s:6:\"Public\";s:9:\"groupings\";s:22:\"Membership Limitations\";s:26:\"groupings_assigned_obj_crs\";s:16:\"Assigned Courses\";s:26:\"groupings_assigned_obj_grp\";s:15:\"Assigned Groups\";s:6:\"groups\";s:6:\"Groups\";s:15:\"groups_overview\";s:15:\"Groups Overview\";s:3:\"grp\";s:5:\"Group\";s:5:\"grp_a\";s:7:\"a Group\";s:7:\"grp_add\";s:9:\"Add Group\";s:14:\"grp_add_member\";s:13:\"Add Member(s)\";s:9:\"grp_added\";s:11:\"Group added\";s:19:\"grp_already_applied\";s:68:\"You have already applied to this group! Please wait for confirmation\";s:17:\"grp_app_send_mail\";s:24:\"Send applicant a message\";s:8:\"grp_back\";s:4:\"Back\";s:17:\"grp_count_members\";s:17:\"Number of members\";s:10:\"grp_create\";s:12:\"Create Group\";s:14:\"grp_create_alm\";s:27:\"Create AICC Learning Module\";s:15:\"grp_create_chat\";s:11:\"Create Chat\";s:14:\"grp_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"grp_create_exc\";s:15:\"Create Exercise\";s:15:\"grp_create_file\";s:11:\"Upload File\";s:15:\"grp_create_fold\";s:13:\"Create Folder\";s:14:\"grp_create_frm\";s:12:\"Create Forum\";s:14:\"grp_create_glo\";s:15:\"Create Glossary\";s:14:\"grp_create_grp\";s:12:\"Create Group\";s:14:\"grp_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"grp_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"grp_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"grp_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"grp_create_mep\";s:17:\"Create Media Pool\";s:14:\"grp_create_qpl\";s:29:\"Create Question Pool for Test\";s:15:\"grp_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"grp_create_spl\";s:31:\"Create Question Pool for Survey\";s:14:\"grp_create_svy\";s:13:\"Create Survey\";s:14:\"grp_create_tst\";s:11:\"Create Test\";s:15:\"grp_create_webr\";s:19:\"Create Web Resource\";s:10:\"grp_delete\";s:12:\"Delete Group\";s:24:\"grp_deleted_export_files\";s:23:\"Deleted selected files.\";s:18:\"grp_dismiss_member\";s:72:\"Are you sure you want to dismiss the following member(s) from the group?\";s:18:\"grp_dismiss_myself\";s:41:\"Are you sure you want to leave the group?\";s:8:\"grp_edit\";s:10:\"Edit Group\";s:26:\"grp_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"grp_edit_permission\";s:26:\"Change permission settings\";s:30:\"grp_err_administrator_required\";s:79:\"Member could not be removed, at least one administrator per group is required !\";s:49:\"grp_err_at_least_one_groupadministrator_is_needed\";s:49:\"Each group needs at least one group administrator\";s:13:\"grp_err_error\";s:17:\"An error occurred\";s:19:\"grp_err_last_member\";s:62:\"Last member could not be removed, please delete group instead.\";s:35:\"grp_err_member_could_not_be_removed\";s:73:\"Member could not be removed. Please verify all dependencies of this user.\";s:21:\"grp_err_no_permission\";s:54:\"You do not possess the permissions for this operation.\";s:25:\"grp_err_registration_data\";s:82:\"Please enter a password, the expiration date and time for a valid joining period !\";s:23:\"grp_header_edit_members\";s:12:\"Edit members\";s:8:\"grp_join\";s:19:\"User may join Group\";s:9:\"grp_leave\";s:20:\"User may leave Group\";s:14:\"grp_list_users\";s:10:\"List users\";s:30:\"grp_mail_body_new_subscription\";s:39:\"You have been subscribed to this group.\";s:36:\"grp_mail_body_subscription_cancelled\";s:35:\"Your membership has been cancelled.\";s:30:\"grp_mail_subj_new_subscription\";s:16:\"New subscription\";s:36:\"grp_mail_subj_subscription_cancelled\";s:22:\"Subscription cancelled\";s:21:\"grp_mem_change_status\";s:20:\"Change member status\";s:13:\"grp_mem_leave\";s:25:\"Dismiss member from group\";s:17:\"grp_mem_send_mail\";s:21:\"Send member a message\";s:19:\"grp_members_gallery\";s:21:\"Group Members Gallery\";s:27:\"grp_msg_applicants_assigned\";s:40:\"Applicant(s) assigned as group member(s)\";s:26:\"grp_msg_applicants_removed\";s:31:\"Applicant(s) removed from list.\";s:23:\"grp_msg_member_assigned\";s:35:\"User(s) assigned as group member(s)\";s:27:\"grp_msg_membership_annulled\";s:18:\"You left the group\";s:15:\"grp_name_exists\";s:68:\"There is already a group with this name! Please choose another name.\";s:7:\"grp_new\";s:9:\"New Group\";s:14:\"grp_new_search\";s:10:\"New search\";s:22:\"grp_no_groups_selected\";s:21:\"Please select a group\";s:20:\"grp_no_results_found\";s:16:\"No results found\";s:21:\"grp_no_roles_selected\";s:20:\"Please select a role\";s:11:\"grp_options\";s:7:\"Options\";s:8:\"grp_read\";s:20:\"Read access to Group\";s:12:\"grp_register\";s:4:\"Join\";s:16:\"grp_registration\";s:10:\"Join group\";s:26:\"grp_registration_completed\";s:25:\"You have joined the group\";s:30:\"grp_search_enter_search_string\";s:28:\"Please enter a search string\";s:18:\"grp_search_members\";s:11:\"User search\";s:19:\"grp_select_one_file\";s:23:\"Please select one file.\";s:24:\"grp_select_one_file_only\";s:31:\"Please select exactly one file.\";s:11:\"grp_visible\";s:16:\"Group is visible\";s:9:\"grp_write\";s:10:\"Edit Group\";s:5:\"guest\";s:5:\"Guest\";s:6:\"guests\";s:6:\"Guests\";s:17:\"header_searchable\";s:10:\"Searchable\";s:12:\"header_title\";s:12:\"Header Title\";s:4:\"help\";s:4:\"Help\";s:4:\"hide\";s:4:\"hide\";s:12:\"hide_details\";s:12:\"Hide Details\";s:18:\"hide_private_notes\";s:18:\"Hide private notes\";s:17:\"hide_public_notes\";s:17:\"Hide public notes\";s:14:\"hide_structure\";s:23:\"Disable Structured-View\";s:18:\"hist_dbk_delete_pg\";s:32:\"Page \"%1\" [%2] has been deleted.\";s:18:\"hist_dbk_delete_st\";s:35:\"Chapter \"%1\" [%2] has been deleted.\";s:18:\"hist_dbk_pg_create\";s:13:\"Page created.\";s:15:\"hist_dbk_pg_cut\";s:34:\"Page cut out of chapter \"%1\" [%2].\";s:17:\"hist_dbk_pg_paste\";s:35:\"Page pasted into chapter \"%1\" [%2].\";s:18:\"hist_dbk_pg_update\";s:13:\"Page changed.\";s:20:\"hist_dbk_st_cut_page\";s:34:\"Page \"%1\" [%2] cut out of chapter.\";s:22:\"hist_dbk_st_paste_page\";s:35:\"Page \"%1\" [%2] pasted into chapter.\";s:16:\"hist_file_create\";s:33:\"File created, file name is \"%1\". \";s:17:\"hist_file_replace\";s:57:\"File replaced, new file name is \"%1\", new version is %2. \";s:17:\"hist_lm_delete_pg\";s:32:\"Page \"%1\" [%2] has been deleted.\";s:17:\"hist_lm_delete_st\";s:35:\"Chapter \"%1\" [%2] has been deleted.\";s:17:\"hist_lm_pg_create\";s:13:\"Page created.\";s:14:\"hist_lm_pg_cut\";s:34:\"Page cut out of chapter \"%1\" [%2].\";s:16:\"hist_lm_pg_paste\";s:35:\"Page pasted into chapter \"%1\" [%2].\";s:17:\"hist_lm_pg_update\";s:13:\"Page changed.\";s:17:\"hist_lm_st_create\";s:16:\"Chapter created.\";s:19:\"hist_lm_st_cut_page\";s:34:\"Page \"%1\" [%2] cut out of chapter.\";s:21:\"hist_lm_st_paste_page\";s:35:\"Page \"%1\" [%2] pasted into chapter.\";s:15:\"hist_no_entries\";s:22:\"No entries in history.\";s:13:\"hist_webr_add\";s:39:\"Added new Web Resource with title: \"%1\"\";s:16:\"hist_webr_delete\";s:33:\"Deleted Web Resource. Title: \"%1\"\";s:16:\"hist_webr_update\";s:32:\"Update Web Resource. Title: \"%1\"\";s:7:\"history\";s:7:\"History\";s:13:\"hits_per_page\";s:9:\"Hits/Page\";s:3:\"hlm\";s:20:\"Learning Module HACP\";s:9:\"hlm_added\";s:26:\"HACP Learning Module added\";s:10:\"hlm_create\";s:27:\"Create HACP Learning Module\";s:10:\"hlm_delete\";s:27:\"Delete HACP Learning Module\";s:19:\"hlm_edit_permission\";s:26:\"Change permission settings\";s:8:\"hlm_join\";s:33:\"Subscribe to HACP Learning Module\";s:9:\"hlm_leave\";s:37:\"Unsubscribe from HACP Learning Module\";s:8:\"hlm_read\";s:35:\"Read access to HACP Learning Module\";s:11:\"hlm_visible\";s:31:\"HACP Learning Module is visible\";s:9:\"hlm_write\";s:25:\"Edit HACP Learning Module\";s:5:\"hobby\";s:17:\"Interests/Hobbies\";s:4:\"home\";s:11:\"Public Area\";s:4:\"host\";s:4:\"Host\";s:4:\"hour\";s:4:\"Hour\";s:5:\"hours\";s:7:\"Hour(s)\";s:12:\"hours_of_day\";s:12:\"Hours of day\";s:4:\"htlm\";s:20:\"Learning Module HTML\";s:8:\"htlm_add\";s:24:\"Add HTML Learning Module\";s:11:\"htlm_delete\";s:27:\"Delete HTML Learning Module\";s:9:\"htlm_edit\";s:36:\"Edit HTML Learning Module Properties\";s:27:\"htlm_edit_learning_progress\";s:22:\"Edit learning progress\";s:20:\"htlm_edit_permission\";s:26:\"Change permission settings\";s:8:\"htlm_new\";s:24:\"New HTML Learning Module\";s:9:\"htlm_read\";s:25:\"Read HTML Learning Module\";s:12:\"htlm_visible\";s:31:\"HTML Learning Module is visible\";s:10:\"htlm_write\";s:25:\"Edit HTML Learning Module\";s:4:\"http\";s:4:\"HTTP\";s:17:\"http_not_possible\";s:44:\"This server is not supporting http requests.\";s:9:\"http_path\";s:9:\"Http Path\";s:18:\"https_not_possible\";s:49:\"This server is not supporting HTTPS connnections.\";s:8:\"i2passwd\";s:16:\"ILIAS 2 password\";s:4:\"icla\";s:19:\"LearnLinc Classroom\";s:8:\"icla_add\";s:23:\"Add LearnLinc Classroom\";s:12:\"icla_deleted\";s:30:\"LearnLinc classroom(s) deleted\";s:9:\"icla_edit\";s:24:\"Edit LearnLinc Classroom\";s:8:\"icla_new\";s:23:\"New LearnLinc Classroom\";s:13:\"icon_settings\";s:13:\"Icon Settings\";s:15:\"icons_in_header\";s:10:\"Header row\";s:18:\"icons_in_item_rows\";s:9:\"Item rows\";s:20:\"icons_in_typed_lists\";s:27:\"Icon position in item lists\";s:25:\"icons_in_typed_lists_info\";s:123:\"Determines where to display icons in item lists that are ordered by type within the repository and on the personal desktop.\";s:4:\"icrs\";s:17:\"LearnLinc Seminar\";s:8:\"icrs_add\";s:21:\"Add LearnLinc Seminar\";s:10:\"icrs_added\";s:23:\"LearnLinc Seminar added\";s:16:\"icrs_create_icla\";s:27:\"Create LearnLinc Classrooms\";s:11:\"icrs_delete\";s:24:\"Delete LearnLinc Seminar\";s:9:\"icrs_edit\";s:22:\"Edit LearnLinc Seminar\";s:20:\"icrs_edit_permission\";s:24:\"Edit permission settings\";s:9:\"icrs_join\";s:31:\"User may join LearnLinc Seminar\";s:10:\"icrs_leave\";s:32:\"User may leave LearnLinc Seminar\";s:20:\"icrs_members_gallery\";s:23:\"Seminar members gallery\";s:8:\"icrs_new\";s:21:\"New LearnLinc Seminar\";s:9:\"icrs_read\";s:32:\"Read access to LearnLinc Seminar\";s:12:\"icrs_visible\";s:28:\"LearnLinc Seminar is visible\";s:10:\"icrs_write\";s:22:\"Edit LearnLinc Seminar\";s:2:\"id\";s:2:\"ID\";s:10:\"identifier\";s:10:\"identifier\";s:25:\"if_no_title_then_filename\";s:36:\"Leave blank to display the file name\";s:20:\"if_no_title_then_url\";s:30:\"Leave blank to display the URL\";s:18:\"ignore_on_conflict\";s:18:\"Ignore on conflict\";s:17:\"il_chat_moderator\";s:14:\"Chat moderator\";s:12:\"il_crs_admin\";s:20:\"Course administrator\";s:13:\"il_crs_member\";s:13:\"Course member\";s:12:\"il_crs_tutor\";s:12:\"Course tutor\";s:16:\"il_frm_moderator\";s:15:\"Forum moderator\";s:12:\"il_grp_admin\";s:19:\"Group administrator\";s:13:\"il_grp_member\";s:12:\"Group member\";s:13:\"il_icrs_admin\";s:31:\"LearnLinc Seminar administrator\";s:14:\"il_icrs_member\";s:24:\"LearnLinc Seminar member\";s:13:\"ilias_version\";s:13:\"ILIAS version\";s:14:\"ilinc_add_user\";s:11:\"Add user(s)\";s:18:\"ilinc_akclassvalue\";s:11:\"Cost center\";s:19:\"ilinc_akclassvalues\";s:12:\"Cost centers\";s:27:\"ilinc_classroom_always_open\";s:24:\"Classroom is always open\";s:22:\"ilinc_classroom_closed\";s:19:\"Classroom is closed\";s:20:\"ilinc_classroom_open\";s:17:\"Classroom is open\";s:16:\"ilinc_classrooms\";s:20:\"LearnLinc Classrooms\";s:25:\"ilinc_coursemember_status\";s:12:\"Attending as\";s:13:\"ilinc_courses\";s:18:\"LearnLinc Seminars\";s:20:\"ilinc_dismiss_member\";s:82:\"Are you sure you want to dismiss the following user(s) from the LearnLinc Seminar?\";s:20:\"ilinc_dismiss_myself\";s:69:\"Are you sure you want to dismiss yourself from the LearnLinc Seminar?\";s:12:\"ilinc_docent\";s:10:\"Instructor\";s:32:\"ilinc_err_administrator_required\";s:91:\"Member could not be removed, at least one administrator per LearnLinc Seminar is required !\";s:51:\"ilinc_err_at_least_one_groupadministrator_is_needed\";s:55:\"Each LearnLinc Seminar needs at least one administrator\";s:21:\"ilinc_err_last_member\";s:74:\"Last member could not be removed, please delete LearnLinc Seminar instead.\";s:37:\"ilinc_err_member_could_not_be_removed\";s:71:\"User could not be removed. Please verify all dependencies of that user.\";s:23:\"ilinc_err_no_permission\";s:54:\"You do not possess the permissions for this operation.\";s:27:\"ilinc_err_registration_data\";s:87:\"Please enter a password, the expiration date and time for a valid registration period !\";s:23:\"ilinc_header_edit_users\";s:27:\"Edit list of involved users\";s:8:\"ilinc_id\";s:8:\"iLinc ID\";s:20:\"ilinc_involved_users\";s:14:\"Involved Users\";s:32:\"ilinc_mail_body_new_subscription\";s:51:\"You have been subscribed to this LearnLinc Seminar.\";s:38:\"ilinc_mail_body_subscription_cancelled\";s:35:\"Your membership has been cancelled.\";s:32:\"ilinc_mail_subj_new_subscription\";s:16:\"New subscription\";s:38:\"ilinc_mail_subj_subscription_cancelled\";s:22:\"Subscription cancelled\";s:29:\"ilinc_manage_course_documents\";s:9:\"Materials\";s:23:\"ilinc_mem_change_status\";s:20:\"Change user\'s status\";s:15:\"ilinc_mem_leave\";s:35:\"Dismiss user from LearnLinc Seminar\";s:19:\"ilinc_mem_send_mail\";s:19:\"Send user a message\";s:16:\"ilinc_msg_joined\";s:32:\"You joined the LearnLinc Seminar\";s:25:\"ilinc_msg_member_assigned\";s:16:\"User(s) assigned\";s:29:\"ilinc_msg_membership_annulled\";s:22:\"Subscription cancelled\";s:22:\"ilinc_no_akclassvalues\";s:4:\"none\";s:24:\"ilinc_no_docent_assigned\";s:12:\"Not assigned\";s:12:\"ilinc_notset\";s:7:\"Not set\";s:12:\"ilinc_remark\";s:6:\"Remark\";s:23:\"ilinc_server_not_active\";s:26:\"iLinc Server not activated\";s:13:\"ilinc_student\";s:11:\"Participant\";s:25:\"ilinc_upload_pic_linktext\";s:6:\"Upload\";s:21:\"ilinc_upload_pic_text\";s:67:\"To display your picture in LearnLinc Seminars please use this link:\";s:5:\"image\";s:5:\"Image\";s:16:\"image_gen_unsucc\";s:93:\"Image generation unsuccessful. Contact your system administrator and verify the convert path.\";s:6:\"import\";s:6:\"Import\";s:10:\"import_alm\";s:19:\"Import AICC Package\";s:19:\"import_cat_localrol\";s:40:\"Create local role for every new category\";s:16:\"import_cat_table\";s:61:\"The following table is only meaningful if the checkbox is set\";s:17:\"import_categories\";s:17:\"Import Categories\";s:10:\"import_dbk\";s:19:\"Import Digilib Book\";s:18:\"import_failure_log\";s:18:\"Import failure log\";s:11:\"import_file\";s:11:\"Import File\";s:21:\"import_file_not_valid\";s:29:\"The import file is not valid.\";s:15:\"import_finished\";s:28:\"Number of imported messages.\";s:21:\"import_forum_finished\";s:28:\"The forum has been imported.\";s:15:\"import_glossary\";s:15:\"Import Glossary\";s:10:\"import_grp\";s:12:\"Import group\";s:19:\"import_grp_finished\";s:32:\"Imported group without any error\";s:10:\"import_hlm\";s:19:\"Import HACP Package\";s:9:\"import_lm\";s:28:\"Import ILIAS Learning module\";s:10:\"import_qpl\";s:25:\"Import Question pool Test\";s:25:\"import_questions_into_qpl\";s:37:\"Import question(s) into question pool\";s:16:\"import_root_user\";s:16:\"Import Root User\";s:11:\"import_sahs\";s:25:\"Import SCORM/AICC Package\";s:10:\"import_spl\";s:27:\"Import Question pool Survey\";s:10:\"import_svy\";s:13:\"Import Survey\";s:10:\"import_tst\";s:11:\"Import Test\";s:12:\"import_users\";s:12:\"Import Users\";s:18:\"import_warning_log\";s:18:\"Import warning log\";s:9:\"important\";s:9:\"Important\";s:8:\"imported\";s:8:\"imported\";s:2:\"in\";s:2:\"in\";s:6:\"in_use\";s:13:\"User Language\";s:8:\"inactive\";s:8:\"Inactive\";s:5:\"inbox\";s:5:\"Inbox\";s:13:\"include_local\";s:13:\"include local\";s:4:\"info\";s:11:\"Information\";s:27:\"info_access_and_status_info\";s:29:\"Access- and Statusinformation\";s:23:\"info_access_permissions\";s:18:\"Access permissions\";s:16:\"info_assign_sure\";s:54:\"Are you sure you want to assign the following user(s)?\";s:13:\"info_assigned\";s:8:\"assigned\";s:20:\"info_available_roles\";s:15:\"Available roles\";s:21:\"info_change_user_view\";s:11:\"Change User\";s:16:\"info_delete_sure\";s:59:\"Are you sure that you want to delete the following item(s)?\";s:28:\"info_delete_warning_no_trash\";s:102:\"(WARNING: Selected Objects will be removed irreversibly from System and may not be recovered anymore!)\";s:12:\"info_deleted\";s:17:\"Object(s) Deleted\";s:22:\"info_enter_login_or_id\";s:36:\"<i>(Enter login name or user ID)</i>\";s:23:\"info_err_user_not_exist\";s:52:\"User with that login name or user_id does not exists\";s:14:\"info_from_role\";s:27:\"Granted by Role / Ownership\";s:14:\"info_is_member\";s:14:\"User is member\";s:18:\"info_is_not_member\";s:20:\"User is not a member\";s:17:\"info_not_assigned\";s:12:\"not assigned\";s:20:\"info_owner_of_object\";s:15:\"Owner of object\";s:22:\"info_permission_origin\";s:17:\"Original Position\";s:22:\"info_permission_source\";s:15:\"Effective From*\";s:23:\"info_remark_interrupted\";s:116:\"Role is interrupted at this position. The role\'s default permission settings in effect are located in that position.\";s:10:\"info_short\";s:4:\"Info\";s:16:\"info_status_info\";s:19:\"Permissions of User\";s:10:\"info_trash\";s:15:\"Deleted Objects\";s:17:\"info_view_of_user\";s:4:\"User\";s:16:\"inform_user_mail\";s:39:\"Send email to inform user about changes\";s:16:\"information_abbr\";s:4:\"Info\";s:19:\"ingmedia_all_offers\";s:6:\"All LE\";s:19:\"ingmedia_back_to_le\";s:10:\"Back to LE\";s:23:\"ingmedia_good_afternoon\";s:14:\"Good afternoon\";s:21:\"ingmedia_good_evening\";s:12:\"Good evening\";s:21:\"ingmedia_good_morning\";s:12:\"Good morning\";s:19:\"ingmedia_good_night\";s:10:\"Good night\";s:14:\"ingmedia_hello\";s:5:\"Hello\";s:25:\"ingmedia_info_about_work1\";s:2:\"On\";s:25:\"ingmedia_info_about_work2\";s:77:\", you worked here for the last time. You can continue there by clicking here:\";s:19:\"ingmedia_level_zero\";s:8:\"Level up\";s:19:\"ingmedia_pers_dates\";s:13:\"Personal data\";s:15:\"ingmedia_reg_fo\";s:17:\"Registered forums\";s:15:\"ingmedia_reg_le\";s:13:\"Registered LE\";s:18:\"ingmedia_use_info1\";s:192:\"Here you can change your personal data. Except for the INGMEDIA username and password, you do not have to fill out other fields. Remember that lost passwords can only be returned by email (!).\";s:18:\"ingmedia_use_info2\";s:186:\"It is not allowed to use special characters (like , ; . = - * + #) in your INGMEDIA username and password. To be allowed to use the INGMEDIA platform, you must accept the user agreement.\";s:18:\"ingmedia_use_info3\";s:47:\"Please select one of the links in the side bar.\";s:18:\"ingmedia_use_title\";s:17:\"Change user data.\";s:19:\"ingmedia_user_agree\";s:9:\"Agreement\";s:15:\"ingmedia_vis_le\";s:10:\"Visited LE\";s:19:\"ingmedia_visited_le\";s:31:\"All LE you have visited so far.\";s:16:\"ingmedia_welcome\";s:36:\", welcome to your personal desktop!!\";s:7:\"inifile\";s:8:\"Ini-File\";s:11:\"input_error\";s:11:\"Input error\";s:6:\"insert\";s:6:\"Insert\";s:18:\"insert_object_here\";s:18:\"Insert object here\";s:7:\"inst_id\";s:15:\"Installation ID\";s:9:\"inst_info\";s:17:\"Installation Info\";s:9:\"inst_name\";s:17:\"Installation Name\";s:7:\"install\";s:7:\"Install\";s:13:\"install_local\";s:18:\"Install With Local\";s:9:\"installed\";s:9:\"Installed\";s:15:\"installed_local\";s:20:\"Installed With Local\";s:11:\"institution\";s:11:\"Institution\";s:25:\"internal_local_roles_only\";s:32:\"Local roles (only autogenerated)\";s:15:\"internal_system\";s:15:\"Internal system\";s:10:\"ip_address\";s:10:\"IP Address\";s:15:\"is_already_your\";s:15:\"is already your\";s:4:\"item\";s:4:\"Item\";s:11:\"java_server\";s:11:\"Java-Server\";s:16:\"java_server_host\";s:4:\"Host\";s:16:\"java_server_info\";s:83:\"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules\";s:25:\"java_server_no_connection\";s:41:\"Attention: Cannot connect to Java server.\";s:16:\"java_server_port\";s:4:\"Port\";s:18:\"java_server_readme\";s:18:\"Setup informations\";s:4:\"join\";s:4:\"Join\";s:2:\"kb\";s:5:\"KByte\";s:8:\"keywords\";s:8:\"Keywords\";s:7:\"lang_cs\";s:5:\"Czech\";s:7:\"lang_da\";s:6:\"Danish\";s:15:\"lang_dateformat\";s:5:\"Y-m-d\";s:7:\"lang_de\";s:6:\"German\";s:7:\"lang_el\";s:5:\"Greek\";s:7:\"lang_en\";s:7:\"English\";s:7:\"lang_es\";s:7:\"Spanish\";s:7:\"lang_fi\";s:7:\"Finnish\";s:7:\"lang_fr\";s:6:\"French\";s:7:\"lang_ge\";s:8:\"Georgian\";s:7:\"lang_hu\";s:9:\"Hungarian\";s:7:\"lang_id\";s:10:\"Indonesian\";s:7:\"lang_it\";s:7:\"Italian\";s:7:\"lang_ja\";s:8:\"Japanese\";s:7:\"lang_lt\";s:10:\"Lithuanian\";s:7:\"lang_nl\";s:5:\"Dutch\";s:7:\"lang_no\";s:9:\"Norwegian\";s:9:\"lang_path\";s:13:\"Language Path\";s:7:\"lang_pl\";s:6:\"Polish\";s:7:\"lang_pt\";s:10:\"Portuguese\";s:7:\"lang_ro\";s:8:\"Romanian\";s:16:\"lang_sep_decimal\";s:1:\".\";s:17:\"lang_sep_thousand\";s:1:\",\";s:7:\"lang_sq\";s:8:\"Albanian\";s:7:\"lang_sr\";s:7:\"Serbian\";s:7:\"lang_sv\";s:7:\"Swedish\";s:15:\"lang_timeformat\";s:5:\"H:i:s\";s:22:\"lang_timeformat_no_sec\";s:3:\"H:i\";s:7:\"lang_uk\";s:9:\"Ukrainian\";s:12:\"lang_version\";s:1:\"1\";s:7:\"lang_vi\";s:10:\"Vietnamese\";s:7:\"lang_xx\";s:6:\"Custom\";s:7:\"lang_zh\";s:18:\"Simplified Chinese\";s:14:\"langfile_found\";s:19:\"Language file found\";s:8:\"language\";s:8:\"Language\";s:22:\"language_not_installed\";s:52:\"is not installed. Please install that language first\";s:9:\"languages\";s:9:\"Languages\";s:27:\"languages_already_installed\";s:42:\"Selected language(s) are already installed\";s:29:\"languages_already_uninstalled\";s:44:\"Selected language(s) are already uninstalled\";s:17:\"languages_updated\";s:41:\"All installed languages have been updated\";s:11:\"last_access\";s:11:\"Last access\";s:11:\"last_change\";s:11:\"Last Change\";s:14:\"last_edited_on\";s:14:\"Last edited on\";s:10:\"last_login\";s:10:\"Last login\";s:11:\"last_update\";s:11:\"Last Update\";s:10:\"last_visit\";s:10:\"Last Visit\";s:8:\"lastname\";s:9:\"Last name\";s:6:\"launch\";s:6:\"Launch\";s:4:\"ldap\";s:4:\"LDAP\";s:11:\"ldap_basedn\";s:11:\"LDAP BaseDN\";s:14:\"ldap_configure\";s:29:\"Configure LDAP Authentication\";s:20:\"ldap_edit_permission\";s:26:\"Change permission settings\";s:14:\"ldap_login_key\";s:24:\"Attribute for login name\";s:16:\"ldap_objectclass\";s:28:\"ObjectClass of user accounts\";s:11:\"ldap_passwd\";s:21:\"Your current password\";s:9:\"ldap_port\";s:9:\"LDAP Port\";s:9:\"ldap_read\";s:28:\"Read access to LDAP settings\";s:16:\"ldap_search_base\";s:16:\"LDAP Search base\";s:11:\"ldap_server\";s:15:\"LDAP Server URL\";s:8:\"ldap_tls\";s:12:\"Use LDAP TLS\";s:7:\"ldap_v2\";s:6:\"LDAPv2\";s:7:\"ldap_v3\";s:6:\"LDAPv3\";s:12:\"ldap_version\";s:22:\"LDAP protokoll version\";s:12:\"ldap_visible\";s:25:\"LDAP settings are visible\";s:10:\"ldap_write\";s:18:\"Edit LDAP settings\";s:15:\"learning module\";s:15:\"Learning Module\";s:16:\"learning_objects\";s:16:\"Learning Objects\";s:17:\"learning_progress\";s:17:\"Learning Progress\";s:16:\"learning_resourc\";s:17:\"Learning Resource\";s:17:\"learning_resource\";s:17:\"Learning Resource\";s:18:\"learning_resources\";s:18:\"Learning Resources\";s:5:\"level\";s:5:\"Level\";s:4:\"link\";s:4:\"Link\";s:10:\"link_check\";s:10:\"Link check\";s:19:\"link_check_body_top\";s:108:\"You receive this mail because you want to be informed about invalid links of the following learning modules:\";s:20:\"link_check_message_b\";s:62:\"If enabled, you will be informed about invalid links by email.\";s:27:\"link_check_message_disabled\";s:16:\"Messages diabled\";s:26:\"link_check_message_enabled\";s:16:\"Messages enabled\";s:18:\"link_check_subject\";s:20:\"[ILIAS 3] Link check\";s:22:\"link_checker_refreshed\";s:14:\"Refreshed view\";s:17:\"link_dynamic_info\";s:54:\"You can add dynamic parameters like the ILIAS user id.\";s:19:\"link_selected_items\";s:19:\"Link selected items\";s:13:\"linked_object\";s:26:\"The object has been linked\";s:12:\"linked_pages\";s:12:\"Linked Pages\";s:15:\"links_add_param\";s:14:\"Add parameter:\";s:19:\"links_dyn_parameter\";s:18:\"Dynamic parameters\";s:13:\"links_dynamic\";s:28:\"Dynamic Web Links parameters\";s:18:\"links_dynamic_info\";s:109:\"If enabled, it is possible to append dynamic parameters to Web Links. E.g. the ILIAS user id or the username.\";s:21:\"links_existing_params\";s:20:\"Existing parameters:\";s:10:\"links_name\";s:14:\"Parameter name\";s:19:\"links_no_name_given\";s:31:\"Please choose a parameter name.\";s:20:\"links_no_value_given\";s:32:\"Please choose a parameter value.\";s:19:\"links_not_available\";s:13:\"Not available\";s:23:\"links_parameter_deleted\";s:18:\"Parameter deleted.\";s:16:\"links_select_one\";s:14:\"- Select one -\";s:16:\"links_session_id\";s:16:\"ILIAS session id\";s:13:\"links_user_id\";s:13:\"ILIAS user id\";s:15:\"links_user_name\";s:14:\"ILIAS username\";s:11:\"links_value\";s:15:\"Parameter value\";s:13:\"list_of_pages\";s:10:\"Pages List\";s:17:\"list_of_questions\";s:13:\"Question List\";s:10:\"literature\";s:10:\"Literature\";s:20:\"literature_bookmarks\";s:20:\"Literature Bookmarks\";s:2:\"lm\";s:21:\"Learning Module ILIAS\";s:4:\"lm_a\";s:24:\"an ILIAS Learning Module\";s:6:\"lm_add\";s:25:\"Add ILIAS Learning Module\";s:8:\"lm_added\";s:27:\"ILIAS Learning Module added\";s:9:\"lm_create\";s:28:\"Create ILIAS Learning Module\";s:9:\"lm_delete\";s:28:\"Delete ILIAS Learning Module\";s:25:\"lm_edit_learning_progress\";s:22:\"Edit learning progress\";s:18:\"lm_edit_permission\";s:26:\"Change permission settings\";s:7:\"lm_join\";s:34:\"Subscribe to ILIAS Learning Module\";s:8:\"lm_leave\";s:37:\"Unsubscribe from ILIASLearning Module\";s:6:\"lm_new\";s:25:\"New ILIAS Learning Module\";s:7:\"lm_read\";s:36:\"Read access to ILIAS Learning Module\";s:12:\"lm_type_aicc\";s:4:\"AICC\";s:12:\"lm_type_hacp\";s:4:\"HACP\";s:13:\"lm_type_scorm\";s:5:\"SCORM\";s:10:\"lm_visible\";s:32:\"ILIAS Learning Module is visible\";s:8:\"lm_write\";s:26:\"Edit ILIAS Learning Module\";s:3:\"lng\";s:8:\"Language\";s:4:\"lngf\";s:9:\"Languages\";s:20:\"lngf_edit_permission\";s:26:\"Change permission settings\";s:9:\"lngf_read\";s:32:\"Read access to Language settings\";s:12:\"lngf_visible\";s:29:\"Language settings are visible\";s:2:\"lo\";s:15:\"Learning Object\";s:12:\"lo_available\";s:35:\"Overview Learning Modules & Courses\";s:13:\"lo_categories\";s:13:\"LO Categories\";s:7:\"lo_edit\";s:20:\"Edit Learning Object\";s:6:\"lo_new\";s:19:\"New Learning Object\";s:13:\"lo_no_content\";s:31:\"No Learning Resources Available\";s:14:\"lo_other_langs\";s:22:\"LOs in Other Languages\";s:11:\"lo_overview\";s:11:\"LO Overview\";s:5:\"local\";s:5:\"Local\";s:19:\"local_language_file\";s:19:\"local language file\";s:20:\"local_language_files\";s:20:\"local language files\";s:33:\"local_languages_already_installed\";s:53:\"Selected local language file(s) are already installed\";s:7:\"locator\";s:9:\"Location:\";s:6:\"log_in\";s:5:\"Login\";s:9:\"logic_and\";s:3:\"and\";s:8:\"logic_or\";s:2:\"or\";s:5:\"login\";s:5:\"Login\";s:8:\"login_as\";s:12:\"Logged in as\";s:10:\"login_data\";s:10:\"Login data\";s:12:\"login_exists\";s:72:\"There is already a user with this login name! Please choose another one.\";s:13:\"login_invalid\";s:117:\"The chosen login is invalid! Only the following characters are allowed (minimum 4 characters): A-Z a-z 0-9 _.-+*@!$%~\";s:10:\"login_time\";s:11:\"Time online\";s:14:\"login_to_ilias\";s:14:\"Login to ILIAS\";s:22:\"login_to_ilias_via_cas\";s:49:\"Login to ILIAS via Central Authentication Service\";s:29:\"login_to_ilias_via_shibboleth\";s:18:\"Login to ILIAS via\";s:6:\"logout\";s:6:\"Logout\";s:11:\"logout_text\";s:56:\"You logged off from ILIAS. Your session has been closed.\";s:4:\"logs\";s:8:\"Log data\";s:3:\"los\";s:16:\"Learning Objects\";s:16:\"los_last_visited\";s:29:\"Last Visited Learning Objects\";s:4:\"lres\";s:18:\"Learning Resources\";s:4:\"mail\";s:4:\"Mail\";s:11:\"mail_a_root\";s:7:\"Mailbox\";s:16:\"mail_addressbook\";s:12:\"Address book\";s:15:\"mail_allow_smtp\";s:10:\"Allow SMTP\";s:12:\"mail_b_inbox\";s:5:\"Inbox\";s:12:\"mail_c_trash\";s:5:\"Trash\";s:13:\"mail_d_drafts\";s:6:\"Drafts\";s:17:\"mail_delete_error\";s:20:\"Error while deleting\";s:22:\"mail_delete_error_file\";s:19:\"Error deleting file\";s:11:\"mail_e_sent\";s:4:\"Sent\";s:20:\"mail_edit_permission\";s:26:\"Change Permission Settings\";s:13:\"mail_feedback\";s:13:\"Mail Feedback\";s:12:\"mail_folders\";s:12:\"Mail Folders\";s:11:\"mail_import\";s:6:\"Import\";s:16:\"mail_import_file\";s:11:\"Export file\";s:18:\"mail_intern_enable\";s:6:\"Enable\";s:17:\"mail_mail_visible\";s:24:\"User may use mail system\";s:13:\"mail_mails_of\";s:4:\"Mail\";s:19:\"mail_maxsize_attach\";s:20:\"Max. attachment size\";s:16:\"mail_maxsize_box\";s:17:\"Max. mailbox size\";s:17:\"mail_maxsize_mail\";s:14:\"Max. mail size\";s:19:\"mail_maxtime_attach\";s:29:\"Max. days to keep attachments\";s:17:\"mail_maxtime_mail\";s:22:\"Max. days to keep mail\";s:12:\"mail_members\";s:15:\"Mail to Members\";s:13:\"mail_not_sent\";s:14:\"Mail not sent!\";s:9:\"mail_read\";s:28:\"Read access to Mail settings\";s:14:\"mail_search_no\";s:17:\"No entries found.\";s:16:\"mail_search_word\";s:11:\"Search word\";s:15:\"mail_select_one\";s:24:\"You must select one mail\";s:15:\"mail_send_error\";s:18:\"Error sending mail\";s:9:\"mail_sent\";s:10:\"Mail sent!\";s:14:\"mail_smtp_mail\";s:27:\"User may send mail via SMTP\";s:11:\"mail_system\";s:14:\"System Message\";s:19:\"mail_system_message\";s:38:\"User may send internal system messages\";s:12:\"mail_visible\";s:25:\"Mail settings are visible\";s:10:\"mail_write\";s:18:\"Edit Mail settings\";s:12:\"mail_z_local\";s:12:\"User Folders\";s:5:\"mails\";s:4:\"Mail\";s:15:\"main_menu_frame\";s:14:\"Top Level Menu\";s:20:\"manage_tracking_data\";s:20:\"Manage Tracking Data\";s:13:\"mark_all_read\";s:16:\"Mark All as Read\";s:15:\"mark_all_unread\";s:18:\"Mark All as Unread\";s:13:\"matriculation\";s:20:\"Matriculation number\";s:14:\"max_number_rec\";s:25:\"Maximum number of records\";s:8:\"max_time\";s:12:\"Maximum time\";s:6:\"member\";s:6:\"Member\";s:13:\"member_status\";s:13:\"Member Status\";s:7:\"members\";s:7:\"Members\";s:19:\"membership_annulled\";s:34:\"Your membership has been cancelled\";s:3:\"mep\";s:10:\"Media Pool\";s:7:\"mep_add\";s:14:\"Add Media Pool\";s:9:\"mep_added\";s:16:\"Added Media Pool\";s:10:\"mep_delete\";s:17:\"Delete Media Pool\";s:8:\"mep_edit\";s:26:\"Edit Media Pool Properties\";s:19:\"mep_edit_permission\";s:26:\"Change permission settings\";s:7:\"mep_new\";s:14:\"New Media Pool\";s:28:\"mep_not_insert_already_exist\";s:86:\"The following items have not been inserted because they are already in the media pool:\";s:8:\"mep_read\";s:23:\"Read Media Pool Content\";s:11:\"mep_visible\";s:21:\"Media Pool is visible\";s:9:\"mep_write\";s:23:\"Edit Media Pool Content\";s:7:\"message\";s:7:\"Message\";s:15:\"message_content\";s:15:\"Message Content\";s:26:\"message_no_delivered_files\";s:36:\"You do not have submitted any files.\";s:10:\"message_to\";s:11:\"Message to:\";s:9:\"meta_data\";s:8:\"Metadata\";s:7:\"migrate\";s:7:\"Migrate\";s:8:\"min_time\";s:12:\"Minimum time\";s:6:\"minute\";s:6:\"Minute\";s:7:\"minutes\";s:7:\"Minutes\";s:7:\"missing\";s:7:\"Missing\";s:3:\"mob\";s:12:\"Media Object\";s:6:\"module\";s:6:\"module\";s:7:\"modules\";s:7:\"Modules\";s:5:\"month\";s:5:\"Month\";s:13:\"month_01_long\";s:7:\"January\";s:14:\"month_01_short\";s:3:\"Jan\";s:13:\"month_02_long\";s:8:\"February\";s:14:\"month_02_short\";s:3:\"Feb\";s:13:\"month_03_long\";s:5:\"March\";s:14:\"month_03_short\";s:3:\"Mar\";s:13:\"month_04_long\";s:5:\"April\";s:14:\"month_04_short\";s:3:\"Apr\";s:13:\"month_05_long\";s:3:\"May\";s:14:\"month_05_short\";s:3:\"May\";s:13:\"month_06_long\";s:4:\"June\";s:14:\"month_06_short\";s:3:\"Jun\";s:13:\"month_07_long\";s:4:\"July\";s:14:\"month_07_short\";s:3:\"Jul\";s:13:\"month_08_long\";s:6:\"August\";s:14:\"month_08_short\";s:3:\"Aug\";s:13:\"month_09_long\";s:9:\"September\";s:14:\"month_09_short\";s:3:\"Sep\";s:13:\"month_10_long\";s:7:\"October\";s:14:\"month_10_short\";s:3:\"Oct\";s:13:\"month_11_long\";s:8:\"November\";s:14:\"month_11_short\";s:3:\"Nov\";s:13:\"month_12_long\";s:8:\"December\";s:14:\"month_12_short\";s:3:\"Dec\";s:7:\"monthly\";s:7:\"monthly\";s:6:\"months\";s:6:\"Months\";s:4:\"move\";s:4:\"Move\";s:11:\"moveChapter\";s:4:\"Move\";s:8:\"movePage\";s:4:\"Move\";s:19:\"move_selected_items\";s:19:\"Move selected items\";s:7:\"move_to\";s:7:\"Move to\";s:19:\"move_users_to_style\";s:19:\"Move Users to Style\";s:10:\"msg_cancel\";s:16:\"Action cancelled\";s:14:\"msg_changes_ok\";s:19:\"The changes were OK\";s:19:\"msg_clear_clipboard\";s:17:\"Clipboard cleared\";s:10:\"msg_cloned\";s:25:\"Selected object(s) copied\";s:18:\"msg_copy_clipboard\";s:53:\"Selected object(s) stored in clipboard (Action: copy)\";s:17:\"msg_cut_clipboard\";s:52:\"Selected object(s) stored in clipboard (Action: cut)\";s:14:\"msg_cut_copied\";s:25:\"Selected object(s) moved.\";s:16:\"msg_deleted_role\";s:12:\"Role deleted\";s:17:\"msg_deleted_roles\";s:13:\"Roles deleted\";s:23:\"msg_deleted_roles_rolts\";s:30:\"Roles & Role Templates deleted\";s:16:\"msg_deleted_rolt\";s:21:\"Role Template deleted\";s:17:\"msg_deleted_rolts\";s:21:\"Role Template deleted\";s:14:\"msg_error_copy\";s:10:\"Copy Error\";s:10:\"msg_failed\";s:20:\"Sorry, action failed\";s:20:\"msg_invalid_filetype\";s:17:\"Invalid file type\";s:16:\"msg_is_last_role\";s:57:\"You removed the last global role from the following users\";s:30:\"msg_last_role_for_registration\";s:122:\"At least one role must be available in the registration form for new users. This role is currently the only one available.\";s:18:\"msg_link_clipboard\";s:53:\"Selected object(s) stored in clipboard (Action: link)\";s:10:\"msg_linked\";s:26:\"Selected object(s) linked.\";s:19:\"msg_may_not_contain\";s:44:\"This object may not contain objects of type:\";s:23:\"msg_min_one_active_role\";s:52:\"Each user must have at least one active global role!\";s:16:\"msg_min_one_role\";s:45:\"Each user must have at least one global role!\";s:27:\"msg_multi_language_selected\";s:58:\"You selected the same language for different translations!\";s:23:\"msg_no_default_language\";s:86:\"No default language specified! You must define one translation as default translation.\";s:22:\"msg_no_delete_yourself\";s:40:\"You cannot delete your own user account.\";s:11:\"msg_no_file\";s:24:\"You didn\'t choose a file\";s:24:\"msg_no_language_selected\";s:82:\"No translation language specified! You must define a language for each translation\";s:31:\"msg_no_perm_assign_role_to_user\";s:55:\"You have no permission to change user\'s role assignment\";s:31:\"msg_no_perm_assign_user_to_role\";s:52:\"You have no permission to change the user assignment\";s:16:\"msg_no_perm_copy\";s:67:\"You have no permission to create a copy of the following object(s):\";s:18:\"msg_no_perm_create\";s:57:\"You have no permission to create the following object(s):\";s:26:\"msg_no_perm_create_object1\";s:32:\"You have no permission to create\";s:26:\"msg_no_perm_create_object2\";s:17:\"at this location!\";s:23:\"msg_no_perm_create_role\";s:35:\"You have no permission to add roles\";s:23:\"msg_no_perm_create_rolf\";s:120:\"You have no permission to create a Role Folder. Therefore you may not stop inheritance of roles or add local roles here.\";s:23:\"msg_no_perm_create_rolt\";s:44:\"You have no permission to add role templates\";s:23:\"msg_no_perm_create_user\";s:35:\"You have no permission to add users\";s:15:\"msg_no_perm_cut\";s:54:\"You have no permission to cut the following object(s):\";s:18:\"msg_no_perm_delete\";s:57:\"You have no permission to delete the following object(s):\";s:24:\"msg_no_perm_delete_track\";s:47:\"You have no permission to delete tracking data.\";s:16:\"msg_no_perm_link\";s:69:\"You have no permission to create a link from the following object(s):\";s:23:\"msg_no_perm_modify_role\";s:38:\"You have no permission to modify roles\";s:23:\"msg_no_perm_modify_rolt\";s:47:\"You have no permission to modify role templates\";s:23:\"msg_no_perm_modify_user\";s:42:\"You have no permission to modify user data\";s:17:\"msg_no_perm_paste\";s:56:\"You have no permission to paste the following object(s):\";s:16:\"msg_no_perm_perm\";s:50:\"You have no permission to edit permission settings\";s:16:\"msg_no_perm_read\";s:43:\"You have no permission to access this item.\";s:21:\"msg_no_perm_read_item\";s:43:\"You have no permission to access item \'%s\'.\";s:19:\"msg_no_perm_read_lm\";s:52:\"You have no permission to read this learning module.\";s:22:\"msg_no_perm_read_track\";s:51:\"You have no permission to access the user tracking.\";s:20:\"msg_no_perm_undelete\";s:59:\"You have no permission to undelete the following object(s):\";s:17:\"msg_no_perm_write\";s:31:\"You have no permission to write\";s:20:\"msg_no_rolf_allowed1\";s:10:\"The object\";s:20:\"msg_no_rolf_allowed2\";s:39:\"is not allowed to contain a Role Folder\";s:15:\"msg_no_scan_log\";s:28:\"Scan log not implemented yet\";s:20:\"msg_no_search_result\";s:16:\"No entries found\";s:20:\"msg_no_search_string\";s:23:\"Please enter your query\";s:38:\"msg_no_sysadmin_sysrole_not_assignable\";s:77:\"Only a System Administrator may assign users to the System Administrator Role\";s:12:\"msg_no_title\";s:21:\"Please enter a title.\";s:22:\"msg_no_type_accessible\";s:73:\"Sorry. You do not have the permissions to access any [type] of this list.\";s:21:\"msg_no_type_available\";s:50:\"Sorry. There is no [type] available at the moment.\";s:10:\"msg_no_url\";s:22:\"You didn\'t enter a URL\";s:26:\"msg_not_available_for_anon\";s:64:\"The page you have chosen is only accessible for registered users\";s:17:\"msg_not_in_itself\";s:47:\"It\'s not possible to paste the object in itself\";s:17:\"msg_nothing_found\";s:17:\"msg_nothing_found\";s:15:\"msg_obj_created\";s:15:\"Object created.\";s:14:\"msg_obj_exists\";s:41:\"This object already exists in this folder\";s:16:\"msg_obj_modified\";s:20:\"Modifications saved.\";s:15:\"msg_obj_no_link\";s:28:\"are not allowed to be linked\";s:26:\"msg_obj_not_deletable_sold\";s:71:\"Payment is activated for the following objects. They can no be deleted.\";s:22:\"msg_perm_adopted_from1\";s:32:\"Permission settings adopted from\";s:22:\"msg_perm_adopted_from2\";s:27:\"(Settings have been saved!)\";s:28:\"msg_perm_adopted_from_itself\";s:80:\"You cannot adopt permission settings from the current role/role template itself.\";s:11:\"msg_removed\";s:30:\"Object(s) removed from system.\";s:16:\"msg_role_exists1\";s:34:\"A role/role template with the name\";s:16:\"msg_role_exists2\";s:42:\"already exists! Please choose another name\";s:24:\"msg_role_reserved_prefix\";s:90:\"The prefix \'il_\' is reserved for automatically generated roles. Please choose another name\";s:33:\"msg_roleassignment_active_changed\";s:30:\"Active role assignment changed\";s:41:\"msg_roleassignment_active_changed_comment\";s:132:\"This setting is not saved to the user\'s profile! If the user logs in again, all active role assignments reset to their saved values.\";s:26:\"msg_roleassignment_changed\";s:23:\"Role assignment changed\";s:25:\"msg_sysrole_not_deletable\";s:33:\"The system role cannot be deleted\";s:24:\"msg_sysrole_not_editable\";s:149:\"The permission settings of the system role may not be changed. The system role grants all assigned users unlimited access to all objects & functions.\";s:15:\"msg_trash_empty\";s:28:\"There are no deleted objects\";s:13:\"msg_undeleted\";s:20:\"Object(s) undeleted.\";s:19:\"msg_user_last_role1\";s:51:\"The following users are assigned to this role only:\";s:19:\"msg_user_last_role2\";s:84:\"Please delete the users or assign them to another role in order to delete this role.\";s:26:\"msg_userassignment_changed\";s:23:\"User assignment changed\";s:10:\"multimedia\";s:10:\"Multimedia\";s:6:\"my_bms\";s:12:\"My Bookmarks\";s:7:\"my_frms\";s:9:\"My Forums\";s:7:\"my_grps\";s:9:\"My Groups\";s:6:\"my_los\";s:19:\"My Learning Objects\";s:7:\"my_tsts\";s:8:\"My Tests\";s:4:\"name\";s:4:\"Name\";s:5:\"never\";s:5:\"never\";s:3:\"new\";s:3:\"New\";s:15:\"new_appointment\";s:15:\"New Appointment\";s:10:\"new_folder\";s:10:\"New Folder\";s:9:\"new_group\";s:9:\"New Group\";s:12:\"new_language\";s:12:\"New Language\";s:17:\"new_list_password\";s:15:\"New suggestions\";s:13:\"new_lowercase\";s:3:\"new\";s:8:\"new_mail\";s:9:\"New mail!\";s:4:\"news\";s:4:\"News\";s:4:\"next\";s:4:\"next\";s:8:\"nickname\";s:8:\"Nickname\";s:2:\"no\";s:2:\"No\";s:14:\"no_access_item\";s:43:\"You have no permission to access this item.\";s:21:\"no_access_item_public\";s:48:\"This item cannot be accessed in the public area.\";s:21:\"no_access_link_object\";s:39:\"You are not allowed to link this object\";s:22:\"no_bm_in_personal_list\";s:21:\"No bookmarks defined.\";s:24:\"no_chat_in_personal_list\";s:25:\"No chats in personal list\";s:11:\"no_checkbox\";s:20:\"No checkbox checked!\";s:21:\"no_condition_selected\";s:31:\"Please select one precondition.\";s:19:\"no_conditions_found\";s:25:\"No preconditions created.\";s:11:\"no_datasets\";s:18:\"The table is empty\";s:7:\"no_date\";s:7:\"No date\";s:14:\"no_description\";s:14:\"No description\";s:23:\"no_frm_in_personal_list\";s:27:\"No forums in personal list.\";s:19:\"no_global_role_left\";s:42:\"Every user has to be assigned to one role.\";s:23:\"no_grp_in_personal_list\";s:27:\"No groups in personal list.\";s:19:\"no_import_available\";s:29:\"Import not available for type\";s:20:\"no_import_file_found\";s:20:\"No import file found\";s:16:\"no_invalid_links\";s:23:\"No invalid links found.\";s:8:\"no_limit\";s:8:\"No limit\";s:22:\"no_lo_in_personal_list\";s:37:\"No learning objects in personal list.\";s:14:\"no_local_users\";s:23:\"There are no local user\";s:10:\"no_objects\";s:10:\"No objects\";s:16:\"no_parent_access\";s:37:\"No access to a superordinated object!\";s:13:\"no_permission\";s:41:\"You do not have the necessary permission.\";s:21:\"no_permission_to_join\";s:39:\"You are not allowed to join this group!\";s:32:\"no_roles_user_can_be_assigned_to\";s:98:\"There are no global roles the user can be assigned to. Therefore you are not allowed to add users.\";s:18:\"no_submission_made\";s:3:\"---\";s:8:\"no_title\";s:8:\"No Title\";s:23:\"no_tst_in_personal_list\";s:26:\"No tests in personal list.\";s:30:\"no_user_defined_fields_defined\";s:33:\"No user-defined fields available.\";s:16:\"no_users_applied\";s:21:\"Please select a user.\";s:17:\"no_users_selected\";s:23:\"Please select one user.\";s:24:\"no_xml_file_found_in_zip\";s:35:\"XML file within zip file not found:\";s:11:\"no_zip_file\";s:18:\"No zip file found.\";s:29:\"non_internal_local_roles_only\";s:30:\"Local roles (only userdefined)\";s:4:\"none\";s:4:\"None\";s:6:\"normal\";s:6:\"Normal\";s:12:\"not_accessed\";s:12:\"Not accessed\";s:16:\"not_accessed_yet\";s:16:\"Not accessed yet\";s:13:\"not_available\";s:13:\"Not Available\";s:19:\"not_implemented_yet\";s:19:\"Not implemented yet\";s:13:\"not_installed\";s:13:\"Not Installed\";s:13:\"not_logged_in\";s:21:\"You are not logged in\";s:4:\"note\";s:4:\"Note\";s:18:\"note_all_pub_notes\";s:9:\"All notes\";s:17:\"note_my_pub_notes\";s:13:\"My notes only\";s:5:\"notes\";s:5:\"Notes\";s:9:\"num_users\";s:15:\"Number of Users\";s:18:\"number_of_accesses\";s:18:\"Number of accesses\";s:17:\"number_of_records\";s:17:\"Number of records\";s:3:\"obj\";s:6:\"Object\";s:7:\"obj_adm\";s:14:\"Administration\";s:12:\"obj_adm_desc\";s:90:\"Main system settings folder containing all panels to administrate your ILIAS installation.\";s:8:\"obj_adve\";s:16:\"Advanced Editing\";s:13:\"obj_adve_desc\";s:105:\"Administration settings for advanced editing like JavaScript based Rich Text Editors, LaTeX support etc..\";s:7:\"obj_alm\";s:20:\"Learning Module AICC\";s:8:\"obj_assf\";s:19:\"Test and Assessment\";s:13:\"obj_assf_desc\";s:29:\"Test&Assessment log settings.\";s:8:\"obj_auth\";s:31:\"Authentication and Registration\";s:13:\"obj_auth_desc\";s:97:\"Configure your authentication mode (local, LDAP, ...) and new account registration settings here.\";s:7:\"obj_cat\";s:8:\"Category\";s:7:\"obj_cen\";s:12:\"Centra Event\";s:8:\"obj_chac\";s:13:\"Chat Settings\";s:13:\"obj_chac_desc\";s:54:\"Configure your chat server here. Enable/disable chats.\";s:8:\"obj_chat\";s:4:\"Chat\";s:7:\"obj_crs\";s:6:\"Course\";s:7:\"obj_dbk\";s:12:\"Digilib Book\";s:7:\"obj_exc\";s:8:\"Exercise\";s:8:\"obj_extt\";s:20:\"Third Party Software\";s:13:\"obj_extt_desc\";s:67:\"Configure external software or services that are supported by ILIAS\";s:8:\"obj_file\";s:4:\"File\";s:8:\"obj_fold\";s:6:\"Folder\";s:7:\"obj_frm\";s:5:\"Forum\";s:7:\"obj_glo\";s:8:\"Glossary\";s:7:\"obj_grp\";s:5:\"Group\";s:7:\"obj_hlm\";s:20:\"Learning Module HACP\";s:8:\"obj_htlm\";s:20:\"Learning Module HTML\";s:8:\"obj_icla\";s:19:\"LearnLinc Classroom\";s:8:\"obj_icrs\";s:17:\"LearnLinc Seminar\";s:8:\"obj_ldap\";s:13:\"LDAP Settings\";s:13:\"obj_ldap_desc\";s:36:\"Configure global LDAP Settings here.\";s:6:\"obj_lm\";s:21:\"Learning Module ILIAS\";s:7:\"obj_lng\";s:8:\"Language\";s:8:\"obj_lngf\";s:9:\"Languages\";s:13:\"obj_lngf_desc\";s:34:\"Manage your system languages here.\";s:6:\"obj_lo\";s:14:\"LearningObject\";s:8:\"obj_mail\";s:13:\"Mail Settings\";s:13:\"obj_mail_desc\";s:36:\"Configure global mail settings here.\";s:7:\"obj_mep\";s:10:\"Media Pool\";s:7:\"obj_mob\";s:12:\"Media Object\";s:13:\"obj_not_found\";s:16:\"Object Not Found\";s:8:\"obj_note\";s:4:\"Note\";s:8:\"obj_notf\";s:19:\"Note Administration\";s:8:\"obj_objf\";s:18:\"Object Definitions\";s:13:\"obj_objf_desc\";s:69:\"Manage ILIAS object types and object permissions. (only for experts!)\";s:9:\"obj_owner\";s:23:\"This Object is owned by\";s:8:\"obj_pays\";s:16:\"Payment Settings\";s:13:\"obj_pays_desc\";s:38:\"Configure payment settings and vendors\";s:6:\"obj_pg\";s:4:\"Page\";s:7:\"obj_qpl\";s:18:\"Question Pool Test\";s:8:\"obj_recf\";s:16:\"Restored Objects\";s:13:\"obj_recf_desc\";s:44:\"Contains restored Objects from System Check.\";s:8:\"obj_role\";s:4:\"Role\";s:8:\"obj_rolf\";s:5:\"Roles\";s:13:\"obj_rolf_desc\";s:23:\"Manage your roles here.\";s:14:\"obj_rolf_local\";s:11:\"Local Roles\";s:19:\"obj_rolf_local_desc\";s:34:\"Contains local roles of object no.\";s:8:\"obj_rolt\";s:13:\"Role Template\";s:8:\"obj_root\";s:15:\"ILIAS root node\";s:8:\"obj_sahs\";s:26:\"Learning Module SCORM/AICC\";s:8:\"obj_seas\";s:6:\"Search\";s:13:\"obj_seas_desc\";s:32:\"Manage the search settings here.\";s:7:\"obj_spl\";s:20:\"Question Pool Survey\";s:6:\"obj_st\";s:7:\"Chapter\";s:8:\"obj_stys\";s:16:\"Style and Layout\";s:13:\"obj_stys_desc\";s:42:\"Manage system skin and style settings here\";s:7:\"obj_svy\";s:6:\"Survey\";s:7:\"obj_tax\";s:8:\"Taxonomy\";s:8:\"obj_taxf\";s:10:\"Taxonomies\";s:13:\"obj_taxf_desc\";s:21:\"Folder for taxonomies\";s:8:\"obj_trac\";s:30:\"Tracking and Learning Progress\";s:13:\"obj_trac_desc\";s:25:\"User access tracking data\";s:7:\"obj_tst\";s:4:\"Test\";s:7:\"obj_typ\";s:22:\"Object Type Definition\";s:8:\"obj_type\";s:11:\"Object Type\";s:7:\"obj_url\";s:3:\"URL\";s:8:\"obj_uset\";s:13:\"User Settings\";s:7:\"obj_usr\";s:4:\"User\";s:8:\"obj_usrf\";s:13:\"User Accounts\";s:13:\"obj_usrf_desc\";s:26:\"Manage user accounts here.\";s:8:\"obj_webr\";s:12:\"Web Resource\";s:6:\"object\";s:6:\"Object\";s:12:\"object_added\";s:12:\"Object added\";s:17:\"object_duplicated\";s:17:\"Object duplicated\";s:15:\"object_imported\";s:15:\"Object imported\";s:7:\"objects\";s:7:\"Objects\";s:4:\"objf\";s:18:\"Object definitions\";s:20:\"objf_edit_permission\";s:26:\"Change permission settings\";s:9:\"objf_read\";s:33:\"Read access to Object definitions\";s:12:\"objf_visible\";s:30:\"Object definitions are visible\";s:10:\"objf_write\";s:23:\"Edit Object definitions\";s:8:\"objs_alm\";s:21:\"AICC Learning Modules\";s:8:\"objs_cat\";s:10:\"Categories\";s:9:\"objs_chat\";s:5:\"Chats\";s:12:\"objs_confirm\";s:14:\"Confirm Action\";s:8:\"objs_crs\";s:7:\"Courses\";s:8:\"objs_dbk\";s:13:\"Digilib Books\";s:11:\"objs_delete\";s:14:\"Delete objects\";s:8:\"objs_exc\";s:9:\"Exercises\";s:9:\"objs_file\";s:5:\"Files\";s:9:\"objs_fold\";s:7:\"Folders\";s:8:\"objs_frm\";s:6:\"Forums\";s:8:\"objs_glo\";s:10:\"Glossaries\";s:8:\"objs_grp\";s:6:\"Groups\";s:8:\"objs_hlm\";s:21:\"HACP Learning Modules\";s:9:\"objs_htlm\";s:21:\"HTML Learning Modules\";s:9:\"objs_icla\";s:20:\"LearnLinc Classrooms\";s:9:\"objs_icrs\";s:18:\"LearnLinc Seminars\";s:7:\"objs_lm\";s:22:\"ILIAS Learning Modules\";s:8:\"objs_lng\";s:9:\"Languages\";s:7:\"objs_lo\";s:16:\"Learning Objects\";s:8:\"objs_mep\";s:11:\"Media Pools\";s:8:\"objs_mob\";s:13:\"Media Objects\";s:9:\"objs_note\";s:5:\"Notes\";s:7:\"objs_pg\";s:5:\"Pages\";s:8:\"objs_qpl\";s:19:\"Question Pools Test\";s:9:\"objs_role\";s:5:\"Roles\";s:9:\"objs_rolt\";s:14:\"Role Templates\";s:9:\"objs_sahs\";s:27:\"SCORM/AICC Learning Modules\";s:8:\"objs_spl\";s:21:\"Question Pools Survey\";s:7:\"objs_st\";s:8:\"Chapters\";s:8:\"objs_svy\";s:7:\"Surveys\";s:8:\"objs_tst\";s:5:\"Tests\";s:9:\"objs_type\";s:12:\"Object Types\";s:8:\"objs_url\";s:4:\"URLs\";s:8:\"objs_usr\";s:5:\"Users\";s:9:\"objs_webr\";s:13:\"Web Resources\";s:2:\"of\";s:2:\"Of\";s:7:\"offline\";s:7:\"offline\";s:15:\"offline_version\";s:15:\"Offline Version\";s:2:\"ok\";s:2:\"OK\";s:3:\"old\";s:3:\"Old\";s:6:\"online\";s:6:\"Online\";s:14:\"online_chapter\";s:14:\"Online Chapter\";s:11:\"online_time\";s:25:\"Time online (DD:HH:MM:SS)\";s:14:\"online_version\";s:14:\"Online Version\";s:26:\"open_views_inside_frameset\";s:26:\"Open views inside frameset\";s:9:\"operation\";s:9:\"Operation\";s:8:\"optimize\";s:8:\"Optimize\";s:7:\"options\";s:7:\"Options\";s:22:\"options_for_subobjects\";s:22:\"Options for subobjects\";s:8:\"order_by\";s:8:\"Order by\";s:16:\"order_by_answers\";s:16:\"Order by Answers\";s:13:\"order_by_date\";s:13:\"Order by Date\";s:5:\"other\";s:5:\"Other\";s:8:\"overview\";s:8:\"Overview\";s:9:\"overwrite\";s:9:\"Overwrite\";s:5:\"owner\";s:5:\"Owner\";s:13:\"owner_updated\";s:14:\"Owner updated.\";s:4:\"page\";s:4:\"Page\";s:9:\"page_edit\";s:9:\"Edit Page\";s:5:\"pages\";s:5:\"Pages\";s:9:\"parameter\";s:9:\"Parameter\";s:5:\"parse\";s:5:\"Parse\";s:6:\"passed\";s:6:\"Passed\";s:6:\"passwd\";s:8:\"Password\";s:17:\"passwd_generation\";s:19:\"Password Generation\";s:22:\"passwd_generation_info\";s:65:\"If enabled, passwords can only be selected from a pretended list.\";s:14:\"passwd_invalid\";s:119:\"The new password is invalid! Only the following characters are allowed (minimum 6 characters): A-Z a-z 0-9 _.-+?#*@!$%~\";s:16:\"passwd_not_match\";s:82:\"Your entries for the new password don\'t match! Please re-enter your new password. \";s:12:\"passwd_wrong\";s:34:\"The password you entered is wrong!\";s:8:\"password\";s:8:\"Password\";s:28:\"password_assistance_disabled\";s:102:\"Password assistance is only then available, when user authentication is done via local ILIAS database.\";s:24:\"password_assistance_info\";s:239:\"If password assistance is enabled, a link with the text \"Forgot Password?\" is shown on the login page of ILIAS. Users can use this link to assign a new password to their user account, without needing assistance from a system administrator.\";s:5:\"paste\";s:5:\"Paste\";s:12:\"pasteChapter\";s:5:\"Paste\";s:9:\"pastePage\";s:5:\"Paste\";s:21:\"paste_clipboard_items\";s:26:\"Paste items from clipboard\";s:4:\"path\";s:4:\"Path\";s:12:\"path_not_set\";s:12:\"Path not set\";s:15:\"path_to_babylon\";s:15:\"Path to Babylon\";s:15:\"path_to_convert\";s:15:\"Path to Convert\";s:15:\"path_to_htmldoc\";s:15:\"Path to HTMLdoc\";s:12:\"path_to_java\";s:12:\"Path to Java\";s:13:\"path_to_unzip\";s:13:\"Path to Unzip\";s:11:\"path_to_zip\";s:11:\"Path to Zip\";s:6:\"pathes\";s:5:\"Paths\";s:11:\"pay_methods\";s:11:\"Pay methods\";s:15:\"payment_buyable\";s:7:\"Buyable\";s:13:\"payment_in_sc\";s:24:\"Already in shopping cart\";s:20:\"payment_payed_access\";s:12:\"Payed/Access\";s:14:\"payment_system\";s:14:\"Payment System\";s:9:\"pays_edit\";s:21:\"Edit payment settings\";s:20:\"pays_edit_permission\";s:26:\"Change permission settings\";s:9:\"pays_read\";s:23:\"Access payment settings\";s:12:\"pays_visible\";s:28:\"Payment settings are visible\";s:10:\"pays_write\";s:21:\"Edit payment settings\";s:10:\"pdf_export\";s:10:\"PDF Export\";s:10:\"per_object\";s:17:\"Access per object\";s:16:\"perm_role_info_1\";s:98:\"This form determines the permissions of role \'%s\' for newly created objects under the object \'%s\'.\";s:16:\"perm_role_info_2\";s:180:\"If you want to change the permissions of role \'%s\' for all already existing objects underneath \'%s\' you must check the option \'Change Existing Objects\' at the bottom of the screen.\";s:21:\"perm_role_info_glob_1\";s:94:\"This form determines the permissions of role \'%s\' for newly created objects in the repository.\";s:21:\"perm_role_info_glob_2\";s:174:\"If you want to change the permissions of role \'%s\' for all existing objects in the repository you must check the option \'Change Existing Objects\' at the bottom of the screen.\";s:13:\"perm_settings\";s:11:\"Permissions\";s:10:\"perma_link\";s:14:\"Permanent Link\";s:10:\"permission\";s:10:\"Permission\";s:17:\"permission_denied\";s:17:\"Permission Denied\";s:19:\"permission_settings\";s:26:\"Object Permission Settings\";s:24:\"permission_settings_info\";s:83:\"This form determines which role is allowed to do what with the current object \'%s\'.\";s:12:\"person_title\";s:5:\"Title\";s:13:\"personal_data\";s:20:\"Personal information\";s:16:\"personal_desktop\";s:16:\"Personal Desktop\";s:16:\"personal_picture\";s:16:\"Personal Picture\";s:16:\"personal_profile\";s:16:\"Personal Profile\";s:7:\"persons\";s:7:\"Persons\";s:4:\"pg_a\";s:6:\"a page\";s:6:\"pg_add\";s:8:\"Add page\";s:8:\"pg_added\";s:10:\"Page added\";s:7:\"pg_edit\";s:9:\"Edit page\";s:6:\"pg_new\";s:8:\"New page\";s:5:\"phone\";s:5:\"Phone\";s:10:\"phone_home\";s:11:\"Phone, Home\";s:12:\"phone_mobile\";s:13:\"Phone, Mobile\";s:12:\"phone_office\";s:13:\"Phone, Office\";s:6:\"phrase\";s:6:\"Phrase\";s:13:\"please_choose\";s:12:\"-- Select --\";s:19:\"please_enter_target\";s:21:\"Please enter a target\";s:18:\"please_enter_title\";s:20:\"Please enter a title\";s:13:\"please_select\";s:19:\"-- Please Select --\";s:40:\"please_select_a_delivered_file_to_delete\";s:57:\"You must select at least one delivered file to delete it!\";s:42:\"please_select_a_delivered_file_to_download\";s:59:\"You must select at least one delivered file to download it!\";s:11:\"please_wait\";s:14:\"Please wait...\";s:4:\"port\";s:4:\"Port\";s:8:\"position\";s:8:\"Position\";s:27:\"precondition_not_accessible\";s:79:\"You do not have sufficient permission to view the precondition(s) of this item.\";s:13:\"preconditions\";s:13:\"Preconditions\";s:19:\"predefined_template\";s:24:\"Predefined role template\";s:20:\"presentation_options\";s:20:\"Presentation Options\";s:8:\"previous\";s:8:\"previous\";s:5:\"print\";s:5:\"Print\";s:10:\"print_view\";s:10:\"Print View\";s:13:\"private_notes\";s:13:\"Private Notes\";s:3:\"pro\";s:3:\"Pro\";s:7:\"profile\";s:7:\"Profile\";s:15:\"profile_changed\";s:42:\"ILIAS eLearning - Your profile has changed\";s:18:\"profile_incomplete\";s:61:\"Your profile is incomplete. Please fill in all required data.\";s:10:\"profile_of\";s:10:\"Profile of\";s:10:\"properties\";s:10:\"Properties\";s:11:\"pub_section\";s:11:\"Public Area\";s:6:\"public\";s:6:\"public\";s:12:\"public_notes\";s:12:\"Public Notes\";s:14:\"public_profile\";s:14:\"Public Profile\";s:26:\"public_profile_not_visible\";s:30:\"The User Profile is not public\";s:11:\"publication\";s:11:\"Publication\";s:16:\"publication_date\";s:16:\"Publication Date\";s:9:\"published\";s:9:\"Published\";s:23:\"publishing_organisation\";s:23:\"Publishing Organization\";s:7:\"purpose\";s:7:\"Purpose\";s:3:\"qpl\";s:18:\"Question Pool Test\";s:7:\"qpl_add\";s:26:\"Add question pool for test\";s:10:\"qpl_delete\";s:29:\"Delete Question Pool for Test\";s:19:\"qpl_edit_permission\";s:26:\"Change permission settings\";s:7:\"qpl_new\";s:26:\"New question pool for test\";s:8:\"qpl_read\";s:37:\"Read access to Question Pool for Test\";s:15:\"qpl_upload_file\";s:11:\"Upload file\";s:11:\"qpl_visible\";s:33:\"Question Pool for Test is visible\";s:9:\"qpl_write\";s:27:\"Edit Question Pool for Test\";s:9:\"quarterly\";s:9:\"quarterly\";s:10:\"query_data\";s:10:\"Query data\";s:8:\"question\";s:8:\"Question\";s:14:\"question_pools\";s:14:\"Question pools\";s:4:\"quit\";s:4:\"Quit\";s:5:\"quote\";s:5:\"Quote\";s:4:\"read\";s:4:\"Read\";s:9:\"recf_edit\";s:19:\"Edit RecoveryFolder\";s:9:\"recipient\";s:9:\"Recipient\";s:16:\"referral_comment\";s:29:\"How did you hear about ILIAS?\";s:7:\"refresh\";s:7:\"Refresh\";s:17:\"refresh_languages\";s:17:\"Refresh Languages\";s:12:\"refresh_list\";s:12:\"Refresh List\";s:6:\"refuse\";s:6:\"Refuse\";s:24:\"reg_mail_body_salutation\";s:5:\"Hello\";s:19:\"reg_mail_body_text1\";s:27:\"Welcome to ILIAS eLearning!\";s:19:\"reg_mail_body_text2\";s:39:\"To access ILIAS use the following data:\";s:19:\"reg_mail_body_text3\";s:29:\"Further personal information:\";s:16:\"reg_mail_subject\";s:34:\"ILIAS eLearning - Your access data\";s:19:\"reg_passwd_via_mail\";s:61:\"Your password will be sent to your email address given below.\";s:8:\"register\";s:8:\"Register\";s:13:\"register_info\";s:95:\"Please fill out the form to register (Fields marked with an asterisk are required information).\";s:16:\"registered_since\";s:16:\"Registered since\";s:15:\"registered_user\";s:15:\"registered User\";s:16:\"registered_users\";s:16:\"registered Users\";s:12:\"registration\";s:24:\"New account registration\";s:21:\"registration_disabled\";s:46:\"Only available when using local authentication\";s:20:\"registration_expired\";s:30:\"Registration period expired...\";s:10:\"related_to\";s:10:\"Related to\";s:6:\"remove\";s:6:\"Remove\";s:23:\"remove_personal_picture\";s:6:\"Remove\";s:18:\"remove_translation\";s:18:\"Remove translation\";s:6:\"rename\";s:6:\"Rename\";s:11:\"rename_file\";s:11:\"Rename File\";s:11:\"repeat_scan\";s:23:\"Repeating virus scan...\";s:18:\"repeat_scan_failed\";s:19:\"Repeat scan failed.\";s:20:\"repeat_scan_succeded\";s:21:\"Repeat scan succeded.\";s:12:\"replace_file\";s:12:\"Replace File\";s:5:\"reply\";s:5:\"Reply\";s:10:\"repository\";s:10:\"Repository\";s:16:\"repository_admin\";s:32:\"Repository Trash and Permissions\";s:21:\"repository_admin_desc\";s:81:\"Set permissions for repository items, restore or remove objects from system trash\";s:16:\"repository_frame\";s:18:\"Repository Content\";s:18:\"request_membership\";s:18:\"Request membership\";s:12:\"require_city\";s:12:\"Require city\";s:15:\"require_country\";s:15:\"Require country\";s:20:\"require_default_role\";s:12:\"Require role\";s:18:\"require_department\";s:18:\"Require department\";s:13:\"require_email\";s:13:\"Require email\";s:11:\"require_fax\";s:11:\"Require fax\";s:17:\"require_firstname\";s:18:\"Require first name\";s:14:\"require_gender\";s:14:\"Require gender\";s:13:\"require_hobby\";s:13:\"Require hobby\";s:19:\"require_institution\";s:19:\"Require institution\";s:16:\"require_lastname\";s:17:\"Require last name\";s:13:\"require_login\";s:13:\"Require login\";s:17:\"require_mandatory\";s:9:\"mandatory\";s:21:\"require_matriculation\";s:28:\"Require matriculation number\";s:14:\"require_passwd\";s:16:\"Require password\";s:15:\"require_passwd2\";s:23:\"Require retype password\";s:18:\"require_phone_home\";s:18:\"Require home phone\";s:20:\"require_phone_mobile\";s:20:\"Require mobile phone\";s:20:\"require_phone_office\";s:20:\"Require office phone\";s:24:\"require_referral_comment\";s:24:\"Require referral comment\";s:14:\"require_street\";s:14:\"Require street\";s:15:\"require_zipcode\";s:16:\"Require zip code\";s:14:\"required_field\";s:8:\"Required\";s:5:\"reset\";s:5:\"Reset\";s:9:\"resources\";s:9:\"Resources\";s:15:\"retype_password\";s:15:\"Retype Password\";s:5:\"right\";s:5:\"Right\";s:6:\"rights\";s:6:\"Rights\";s:4:\"role\";s:4:\"Role\";s:6:\"role_a\";s:6:\"a Role\";s:8:\"role_add\";s:8:\"Add Role\";s:14:\"role_add_local\";s:14:\"Add local Role\";s:13:\"role_add_user\";s:19:\"Add User(s) to role\";s:10:\"role_added\";s:10:\"Role added\";s:24:\"role_assigned_desk_items\";s:22:\"Assigned desktop items\";s:26:\"role_assigned_desktop_item\";s:23:\"Created new assignment.\";s:15:\"role_assignment\";s:15:\"Role Assignment\";s:23:\"role_assignment_updated\";s:33:\"Role assignment has been updated.\";s:16:\"role_count_users\";s:15:\"Number of users\";s:12:\"role_deleted\";s:12:\"Role deleted\";s:26:\"role_deleted_desktop_items\";s:19:\"Deleted assignment.\";s:13:\"role_desk_add\";s:19:\"Assign desktop item\";s:22:\"role_desk_none_created\";s:39:\"No desktop items assigned to this role.\";s:9:\"role_edit\";s:9:\"Edit Role\";s:22:\"role_header_edit_users\";s:22:\"Change User Assignment\";s:15:\"role_list_users\";s:10:\"List users\";s:11:\"role_mailto\";s:26:\"Mail to all assigned Users\";s:8:\"role_new\";s:8:\"New Role\";s:15:\"role_new_search\";s:10:\"New search\";s:23:\"role_no_groups_selected\";s:21:\"Please select a group\";s:21:\"role_no_results_found\";s:16:\"No results found\";s:22:\"role_no_roles_selected\";s:20:\"Please select a role\";s:27:\"role_no_users_no_desk_items\";s:96:\"It is not possible to assign personal desktop items, since you cannot assign users to this role.\";s:24:\"role_protect_permissions\";s:19:\"Protect permissions\";s:31:\"role_search_enter_search_string\";s:28:\"Please enter a search string\";s:17:\"role_search_users\";s:11:\"User search\";s:24:\"role_select_desktop_item\";s:60:\"Please select one object that will be assigned to this role.\";s:20:\"role_select_one_item\";s:25:\"Please select one object.\";s:27:\"role_sure_delete_desk_items\";s:58:\"Are you sure you want to delete the following assignments?\";s:19:\"role_templates_only\";s:19:\"Role templates only\";s:18:\"role_user_deassign\";s:23:\"Deassign user from role\";s:14:\"role_user_edit\";s:17:\"Edit account data\";s:19:\"role_user_send_mail\";s:19:\"Send user a message\";s:5:\"roles\";s:5:\"Roles\";s:22:\"roles_of_import_global\";s:27:\"Global roles of import file\";s:21:\"roles_of_import_local\";s:26:\"Local roles of import file\";s:4:\"rolf\";s:5:\"Roles\";s:10:\"rolf_added\";s:17:\"Role Folder added\";s:16:\"rolf_create_role\";s:26:\"Create new Role definition\";s:16:\"rolf_create_rolt\";s:35:\"Create new Role definition template\";s:11:\"rolf_delete\";s:27:\"Delete Roles/Role templates\";s:20:\"rolf_edit_permission\";s:26:\"Change permission settings\";s:24:\"rolf_edit_userassignment\";s:31:\"Change user assignment of Roles\";s:9:\"rolf_read\";s:35:\"Read access to Roles/Role templates\";s:12:\"rolf_visible\";s:32:\"Roles/Role templates are visible\";s:10:\"rolf_write\";s:56:\"Edit default permission settings of Roles/Role templates\";s:4:\"rolt\";s:13:\"Role Template\";s:6:\"rolt_a\";s:15:\"a Role Template\";s:8:\"rolt_add\";s:17:\"Add Role Template\";s:10:\"rolt_added\";s:19:\"Role template added\";s:9:\"rolt_edit\";s:18:\"Edit Role Template\";s:8:\"rolt_new\";s:17:\"New Role Template\";s:15:\"root_create_cat\";s:26:\"User may create Categories\";s:9:\"root_edit\";s:21:\"Edit system root node\";s:20:\"root_edit_permission\";s:26:\"Change permission settings\";s:9:\"root_read\";s:27:\"Read access to ILIAS system\";s:12:\"root_visible\";s:23:\"ILIAS system is visible\";s:10:\"root_write\";s:33:\"Edit metadata of system root node\";s:4:\"sahs\";s:26:\"Learning Module SCORM/AICC\";s:10:\"sahs_added\";s:32:\"SCORM/AICC Learning Module added\";s:11:\"sahs_create\";s:33:\"Create SCORM/AICC Learning Module\";s:11:\"sahs_delete\";s:33:\"Delete SCORM/AICC Learning Module\";s:27:\"sahs_edit_learning_progress\";s:22:\"Edit learning progress\";s:20:\"sahs_edit_permission\";s:26:\"Change permission settings\";s:9:\"sahs_join\";s:39:\"Subscribe to SCORM/AICC Learning Module\";s:10:\"sahs_leave\";s:43:\"Unsubscribe from SCORM/AICC Learning Module\";s:9:\"sahs_read\";s:41:\"Read access to SCORM/AICC Learning Module\";s:12:\"sahs_visible\";s:37:\"SCORM/AICC Learning Module is visible\";s:10:\"sahs_write\";s:31:\"Edit SCORM/AICC Learning Module\";s:10:\"salutation\";s:10:\"Salutation\";s:12:\"salutation_f\";s:8:\"Ms./Mrs.\";s:12:\"salutation_m\";s:3:\"Mr.\";s:4:\"save\";s:4:\"Save\";s:13:\"save_and_back\";s:13:\"Save And Back\";s:12:\"save_message\";s:12:\"Save Message\";s:12:\"save_refresh\";s:16:\"Save and Refresh\";s:11:\"save_return\";s:15:\"Save and Return\";s:13:\"save_settings\";s:13:\"Save Settings\";s:22:\"save_user_related_data\";s:29:\"Save user related access data\";s:5:\"saved\";s:5:\"Saved\";s:18:\"saved_successfully\";s:18:\"Saved Successfully\";s:6:\"search\";s:6:\"Search\";s:13:\"search_active\";s:20:\"Include active users\";s:10:\"search_for\";s:10:\"Search For\";s:9:\"search_in\";s:9:\"Search in\";s:15:\"search_inactive\";s:22:\"Include inactive users\";s:25:\"search_minimum_characters\";s:27:\"The minimum word length is:\";s:10:\"search_new\";s:10:\"New Search\";s:11:\"search_note\";s:125:\"If &quot;search in&quot; is left blank, all users will be searched. This allows you to find all active or all inactive users.\";s:16:\"search_recipient\";s:16:\"Search Recipient\";s:13:\"search_result\";s:13:\"Search result\";s:15:\"search_to_short\";s:23:\"Your query is to short.\";s:11:\"search_user\";s:11:\"Search User\";s:20:\"seas_edit_permission\";s:26:\"Change permission settings\";s:13:\"seas_max_hits\";s:8:\"Max hits\";s:18:\"seas_max_hits_info\";s:63:\"Please enter a number for the maximum number of search results.\";s:9:\"seas_read\";s:20:\"Read search settings\";s:11:\"seas_search\";s:23:\"Allow to use the search\";s:13:\"seas_settings\";s:15:\"Search settings\";s:12:\"seas_visible\";s:27:\"Search settings are visible\";s:10:\"seas_write\";s:20:\"Edit search settings\";s:6:\"second\";s:6:\"Second\";s:7:\"seconds\";s:7:\"Seconds\";s:8:\"sections\";s:8:\"Sections\";s:6:\"select\";s:6:\"Select\";s:10:\"select_all\";s:10:\"Select All\";s:11:\"select_file\";s:11:\"Select file\";s:19:\"select_max_one_item\";s:27:\"Please select one item only\";s:11:\"select_mode\";s:11:\"Select mode\";s:21:\"select_object_to_copy\";s:41:\"Please select the object you want to copy\";s:21:\"select_object_to_link\";s:47:\"Please select the object which you want to link\";s:15:\"select_password\";s:21:\"Select a new password\";s:19:\"select_questionpool\";s:22:\"Question pool for Test\";s:26:\"select_questionpool_option\";s:37:\"--- Please select a question pool ---\";s:8:\"selected\";s:8:\"Selected\";s:14:\"selected_items\";s:14:\"Personal Items\";s:4:\"send\";s:4:\"Send\";s:16:\"send_mail_admins\";s:22:\"Mail to administrators\";s:17:\"send_mail_members\";s:15:\"Mail to members\";s:16:\"send_mail_tutors\";s:14:\"Mail to tutors\";s:6:\"sender\";s:6:\"Sender\";s:4:\"sent\";s:4:\"Sent\";s:8:\"sequence\";s:8:\"Sequence\";s:9:\"sequences\";s:9:\"Sequences\";s:6:\"server\";s:6:\"Server\";s:11:\"server_data\";s:11:\"Server data\";s:15:\"server_software\";s:15:\"Server Software\";s:3:\"set\";s:3:\"Set\";s:17:\"setSystemLanguage\";s:19:\"Set System Language\";s:15:\"setUserLanguage\";s:17:\"Set User Language\";s:11:\"set_offline\";s:11:\"Set Offline\";s:10:\"set_online\";s:10:\"Set Online\";s:8:\"settings\";s:8:\"Settings\";s:14:\"settings_saved\";s:14:\"Saved settings\";s:4:\"shib\";s:10:\"Shibboleth\";s:11:\"shib_active\";s:25:\"Enable Shibboleth support\";s:9:\"shib_city\";s:18:\"Attribute for city\";s:14:\"shib_configure\";s:34:\"Configure Shibboleh Authentication\";s:12:\"shib_country\";s:21:\"Attribute for country\";s:14:\"shib_data_conv\";s:38:\"Absolute path to data manipulation API\";s:22:\"shib_data_conv_warning\";s:59:\"The data manipulation API file you specified cannot be read\";s:15:\"shib_department\";s:24:\"Attribute for department\";s:20:\"shib_edit_permission\";s:26:\"Change permission settings\";s:10:\"shib_email\";s:27:\"Attribute for email address\";s:20:\"shib_federation_name\";s:34:\"Name of your Shibboleth federation\";s:14:\"shib_firstname\";s:23:\"Attribute for firstname\";s:11:\"shib_gender\";s:41:\"Attribute for gender (must be \'m\' or \'f\')\";s:31:\"shib_general_login_instructions\";s:159:\"To log in via %s, please click on the login button and choose your organization of the following page.<br>If you have questions concerning this, please ask the\";s:36:\"shib_general_wayf_login_instructions\";s:126:\"In case you are not associated with the given organizations and you need access to a course on this server, please contact the\";s:13:\"shib_idp_list\";s:496:\"Provide a list of Identity Providers to let the user choose from on the ILIAS login page.<br>On each line there must be a comma-separated tuple for <strong>providerID of IdP</strong> (see the Shibboleth metadata file) and <strong>Name of IdP</strong> as it shall be displayed in the drow-down list.<br>As an optional third parameter you can add the <strong>location of a Shibboleth session initiator</strong> that shall be used in case your ILIAS installation is part of a multi federation setup.\";s:16:\"shib_institution\";s:25:\"Attribute for institution\";s:17:\"shib_instructions\";s:146:\"Be sure to read the <a href=\"README.SHIBBOLETH.txt\" target=\"_blank\">README</a> for instructions on how to configure Shibboleth support for ILIAS. \";s:30:\"shib_invalid_home_organization\";s:35:\"Please choose a valid organization!\";s:13:\"shib_language\";s:22:\"Attribute for language\";s:13:\"shib_lastname\";s:22:\"Attribute for lastname\";s:10:\"shib_login\";s:27:\"Unique Shibboleth attribute\";s:17:\"shib_login_button\";s:131:\"Path to the image of a Shibboleth login button that is used to redirect users to the WAYF specified in the Shibboleth configuration\";s:24:\"shib_login_external_wayf\";s:25:\"Use external WAYF service\";s:24:\"shib_login_internal_wayf\";s:22:\"Use ILIAS WAYF service\";s:15:\"shib_login_type\";s:22:\"Organization selection\";s:14:\"shib_member_of\";s:19:\"I\'m a member of ...\";s:15:\"shib_phone_home\";s:31:\"Attribute for home phone number\";s:17:\"shib_phone_mobile\";s:33:\"Attribute for mobile phone number\";s:17:\"shib_phone_office\";s:33:\"Attribute for office phone number\";s:9:\"shib_read\";s:34:\"Read access to Shibboleth settings\";s:29:\"shib_select_home_organization\";s:83:\"For authentication via %s, please select your organization from the drop down list.\";s:19:\"shib_settings_saved\";s:34:\"The Shibboleth settings were saved\";s:11:\"shib_street\";s:20:\"Attribute for street\";s:10:\"shib_title\";s:19:\"Attribute for title\";s:11:\"shib_update\";s:26:\"Update this field on login\";s:22:\"shib_user_default_role\";s:41:\"Default role assigned to Shibboleth users\";s:12:\"shib_visible\";s:31:\"Shibboleth settings are visible\";s:10:\"shib_write\";s:24:\"Edit Shibboleth settings\";s:12:\"shib_zipcode\";s:21:\"Attribute for zipcode\";s:4:\"show\";s:4:\"Show\";s:12:\"show_details\";s:12:\"Show Details\";s:9:\"show_list\";s:9:\"Show List\";s:12:\"show_members\";s:15:\"Display Members\";s:16:\"show_notes_on_pd\";s:30:\"Show notes on personal desktop\";s:10:\"show_owner\";s:10:\"Show Owner\";s:18:\"show_private_notes\";s:18:\"Show private notes\";s:17:\"show_public_notes\";s:17:\"Show public notes\";s:14:\"show_structure\";s:22:\"Enable Structured-View\";s:17:\"show_users_online\";s:17:\"Show active users\";s:9:\"signature\";s:9:\"Signature\";s:4:\"size\";s:4:\"Size\";s:10:\"skin_style\";s:20:\"Default Skin / Style\";s:10:\"small_icon\";s:10:\"Small Icon\";s:4:\"smtp\";s:4:\"SMTP\";s:24:\"soap_user_administration\";s:35:\"External user administration (SOAP)\";s:29:\"soap_user_administration_desc\";s:78:\"If enabled, all user accounts can be administrated by an external SOAP-Client.\";s:19:\"sort_by_this_column\";s:19:\"Sort by this column\";s:6:\"spacer\";s:6:\"Spacer\";s:3:\"spl\";s:20:\"Question Pool Survey\";s:7:\"spl_add\";s:28:\"Add question pool for survey\";s:10:\"spl_delete\";s:31:\"Delete Question Pool for Survey\";s:19:\"spl_edit_permission\";s:26:\"Change permission settings\";s:7:\"spl_new\";s:28:\"New question pool for survey\";s:8:\"spl_read\";s:39:\"Read access to Question Pool for Survey\";s:15:\"spl_upload_file\";s:11:\"Upload file\";s:11:\"spl_visible\";s:35:\"Question Pool for Survey is visible\";s:9:\"spl_write\";s:29:\"Edit Question Pool for Survey\";s:3:\"ssl\";s:11:\"SSL (HTTPS)\";s:4:\"st_a\";s:9:\"a chapter\";s:6:\"st_add\";s:11:\"Add chapter\";s:8:\"st_added\";s:13:\"Chapter added\";s:7:\"st_edit\";s:12:\"Edit chapter\";s:6:\"st_new\";s:11:\"New chapter\";s:15:\"standard_fields\";s:15:\"Standard Fields\";s:9:\"startpage\";s:10:\"Start page\";s:9:\"statistic\";s:9:\"Statistic\";s:6:\"status\";s:6:\"Status\";s:4:\"step\";s:4:\"Step\";s:16:\"stop_inheritance\";s:16:\"Stop inheritance\";s:6:\"street\";s:6:\"Street\";s:9:\"structure\";s:9:\"Structure\";s:3:\"sty\";s:5:\"Style\";s:16:\"style_activation\";s:16:\"Style Activation\";s:20:\"stys_edit_permission\";s:26:\"Change permission settings\";s:9:\"stys_read\";s:29:\"Read access to style settings\";s:12:\"stys_visible\";s:26:\"Style settings are visible\";s:10:\"stys_write\";s:19:\"Edit style settings\";s:11:\"subcat_name\";s:16:\"Subcategory Name\";s:14:\"subchapter_new\";s:14:\"New Subchapter\";s:7:\"subject\";s:7:\"Subject\";s:14:\"subject_module\";s:14:\"Subject Module\";s:6:\"submit\";s:6:\"Submit\";s:10:\"subobjects\";s:10:\"Subobjects\";s:12:\"subscription\";s:12:\"Subscription\";s:7:\"summary\";s:7:\"Summary\";s:26:\"sure_delete_selected_users\";s:52:\"Are you sure you want to delete the selected user(s)\";s:3:\"svy\";s:6:\"Survey\";s:7:\"svy_add\";s:10:\"Add survey\";s:10:\"svy_delete\";s:13:\"Delete survey\";s:19:\"svy_edit_permission\";s:26:\"Change permission settings\";s:14:\"svy_evaluation\";s:10:\"Evaluation\";s:12:\"svy_finished\";s:8:\"finished\";s:10:\"svy_invite\";s:24:\"Invite users to a survey\";s:7:\"svy_new\";s:10:\"New survey\";s:14:\"svy_no_content\";s:20:\"No surveys available\";s:16:\"svy_not_finished\";s:12:\"not finished\";s:15:\"svy_not_started\";s:11:\"not started\";s:15:\"svy_participate\";s:23:\"Participate in a survey\";s:8:\"svy_read\";s:21:\"Read access to survey\";s:7:\"svy_run\";s:3:\"Run\";s:15:\"svy_upload_file\";s:11:\"Upload file\";s:11:\"svy_visible\";s:17:\"Survey is visible\";s:31:\"svy_warning_survey_not_complete\";s:27:\"The survey is not finished!\";s:9:\"svy_write\";s:11:\"Edit survey\";s:6:\"system\";s:6:\"System\";s:12:\"system_check\";s:12:\"System Check\";s:22:\"system_choose_language\";s:22:\"System Choose Language\";s:13:\"system_groups\";s:13:\"System Groups\";s:10:\"system_grp\";s:12:\"System Group\";s:18:\"system_information\";s:18:\"System Information\";s:15:\"system_language\";s:15:\"System Language\";s:14:\"system_message\";s:14:\"System Message\";s:21:\"system_style_settings\";s:21:\"System Style Settings\";s:13:\"system_styles\";s:13:\"System Styles\";s:17:\"table_mail_import\";s:11:\"Mail import\";s:6:\"target\";s:6:\"Target\";s:3:\"tax\";s:8:\"Taxonomy\";s:7:\"tax_add\";s:12:\"Add Taxonomy\";s:10:\"tax_delete\";s:17:\"Delete taxonomies\";s:8:\"tax_edit\";s:13:\"Edit Taxonomy\";s:19:\"tax_edit_permission\";s:26:\"Change permission settings\";s:7:\"tax_new\";s:12:\"New Taxonomy\";s:8:\"tax_read\";s:25:\"Read access to taxonomies\";s:11:\"tax_visible\";s:19:\"Taxonomy is visible\";s:9:\"tax_write\";s:26:\"Write access to taxonomies\";s:20:\"taxf_edit_permission\";s:26:\"Change permission settings\";s:9:\"taxf_read\";s:30:\"Read access to taxonomy folder\";s:12:\"taxf_visible\";s:26:\"Taxonomy folder is visible\";s:10:\"taxf_write\";s:31:\"Write access to taxonomy folder\";s:4:\"term\";s:4:\"Term\";s:4:\"test\";s:4:\"Test\";s:11:\"test_intern\";s:11:\"Test Intern\";s:11:\"test_module\";s:11:\"Test Module\";s:5:\"tests\";s:5:\"Tests\";s:6:\"thread\";s:6:\"Thread\";s:9:\"thumbnail\";s:9:\"Thumbnail\";s:4:\"time\";s:4:\"Time\";s:6:\"time_d\";s:3:\"Day\";s:6:\"time_h\";s:4:\"Hour\";s:10:\"time_limit\";s:6:\"Access\";s:38:\"time_limit_add_time_limit_for_selected\";s:50:\"Please enter a time period for the selected users.\";s:24:\"time_limit_applied_users\";s:13:\"Applied users\";s:15:\"time_limit_from\";s:17:\"From (time limit)\";s:18:\"time_limit_message\";s:20:\"Message (time limit)\";s:28:\"time_limit_no_users_selected\";s:21:\"Please select a user.\";s:20:\"time_limit_not_valid\";s:24:\"The period is not valid.\";s:28:\"time_limit_not_within_owners\";s:60:\"Your access is limited. The period is outside of your limit.\";s:16:\"time_limit_owner\";s:18:\"Owner (time limit)\";s:18:\"time_limit_reached\";s:30:\"Your access period is expired.\";s:20:\"time_limit_unlimited\";s:22:\"Unlimited (time limit)\";s:16:\"time_limit_until\";s:18:\"Until (time limit)\";s:24:\"time_limit_users_updated\";s:17:\"User data updated\";s:11:\"time_limits\";s:6:\"Access\";s:12:\"time_segment\";s:14:\"Period of time\";s:5:\"title\";s:5:\"Title\";s:2:\"to\";s:2:\"To\";s:14:\"to_client_list\";s:16:\"Client Selection\";s:10:\"to_desktop\";s:14:\"Add to desktop\";s:5:\"today\";s:5:\"Today\";s:19:\"toggleGlobalDefault\";s:21:\"Toggle Global Default\";s:17:\"toggleGlobalFixed\";s:19:\"Toggle Global Fixed\";s:5:\"total\";s:5:\"Total\";s:8:\"tpl_path\";s:13:\"Template Path\";s:11:\"trac_delete\";s:20:\"Delete Tracking Data\";s:20:\"trac_edit_permission\";s:26:\"Change permission settings\";s:9:\"trac_read\";s:18:\"Read Tracking Data\";s:12:\"trac_visible\";s:24:\"User tracking is visible\";s:15:\"tracked_objects\";s:15:\"Tracked objects\";s:13:\"tracking_data\";s:13:\"Tracking Data\";s:25:\"tracking_data_del_confirm\";s:81:\"Do you really want to delete all tracking data of the specified month and before?\";s:21:\"tracking_data_deleted\";s:21:\"Tracking data deleted\";s:17:\"tracking_settings\";s:17:\"Tracking Settings\";s:11:\"translation\";s:11:\"Translation\";s:5:\"trash\";s:5:\"Trash\";s:10:\"tree_frame\";s:10:\"Tree Frame\";s:15:\"tree_frame_info\";s:96:\"Defines whether the tree frame (e.g. repository tree) should appear on the left or on the right.\";s:9:\"tree_left\";s:4:\"Left\";s:10:\"tree_right\";s:5:\"Right\";s:8:\"treeview\";s:9:\"Tree View\";s:3:\"tst\";s:4:\"Test\";s:7:\"tst_add\";s:8:\"Add test\";s:13:\"tst_anon_eval\";s:7:\"Results\";s:10:\"tst_delete\";s:11:\"Delete Test\";s:26:\"tst_edit_learning_progress\";s:22:\"Edit learning progress\";s:19:\"tst_edit_permission\";s:26:\"Change permission settings\";s:7:\"tst_new\";s:8:\"New test\";s:14:\"tst_no_content\";s:18:\"No tests available\";s:8:\"tst_read\";s:19:\"Read access to Test\";s:7:\"tst_run\";s:3:\"Run\";s:26:\"tst_statistical_evaluation\";s:10:\"Statistics\";s:15:\"tst_upload_file\";s:11:\"Upload file\";s:20:\"tst_user_not_invited\";s:39:\"You are not supposed to take this exam.\";s:23:\"tst_user_wrong_clientip\";s:43:\"You don\'t have the right ip using this test\";s:11:\"tst_visible\";s:15:\"Test is visible\";s:29:\"tst_warning_test_not_complete\";s:25:\"The test is not complete!\";s:9:\"tst_write\";s:9:\"Edit Test\";s:27:\"txt_add_object_instruction1\";s:44:\"Browse to the location where you want to add\";s:27:\"txt_add_object_instruction2\";s:1:\".\";s:14:\"txt_registered\";s:112:\"You successfully registered to ILIAS. Please click on the button below to login to ILIAS with your user account.\";s:13:\"txt_submitted\";s:228:\"You successfully submitted an account request to ILIAS. Your account request will be reviewed by the system administrators, and should be activated within 48 hours. You will not be able to log in until your account is activated.\";s:3:\"typ\";s:22:\"Object Type Definition\";s:4:\"type\";s:4:\"Type\";s:22:\"type_your_message_here\";s:22:\"Type Your Message Here\";s:13:\"udf_add_field\";s:9:\"Add Field\";s:15:\"udf_added_field\";s:16:\"Added new field.\";s:17:\"udf_delete_header\";s:12:\"Delete Field\";s:15:\"udf_delete_sure\";s:71:\"Are you sure you want to delete this field and all assigned user data ?\";s:21:\"udf_duplicate_entries\";s:29:\"The values have to be unique.\";s:17:\"udf_field_deleted\";s:14:\"Deleted field.\";s:23:\"udf_name_already_exists\";s:63:\"This field name already exists. Please choose a different name.\";s:14:\"udf_no_entries\";s:31:\"Please enter minimum one value.\";s:17:\"udf_no_name_given\";s:26:\"Please enter a field name.\";s:15:\"udf_type_select\";s:25:\"Select Box (fixed values)\";s:13:\"udf_type_text\";s:28:\"Text Field (optional values)\";s:23:\"udf_update_select_field\";s:15:\"Edit Select Box\";s:18:\"udf_update_success\";s:20:\"Saved modifications.\";s:21:\"udf_update_text_field\";s:15:\"Edit Text Field\";s:9:\"udf_value\";s:5:\"Value\";s:17:\"udf_value_deleted\";s:27:\"The value has been deleted.\";s:3:\"uid\";s:3:\"UID\";s:22:\"ums_create_new_account\";s:18:\"Create New Account\";s:15:\"ums_explanation\";s:183:\"Your external account could not be mapped to an ILIAS account. But ILIAS has found an account with your e-mail address. If this is your account, please login with your ILIAS password.\";s:17:\"ums_explanation_2\";s:61:\"If this is not your account, please hit \'Create New Account\'.\";s:17:\"ums_explanation_3\";s:198:\"Your external account could not be mapped to an ILIAS account. But ILIAS has found multiple accounts with your e-mail address. If one of those is your account, please login with your ILIAS password.\";s:17:\"ums_explanation_4\";s:65:\"If none of them is your account, please hit \'Create New Account\'.\";s:17:\"ums_login_account\";s:13:\"Login Account\";s:15:\"unambiguousness\";s:15:\"Unambiguousness\";s:11:\"uncheck_all\";s:11:\"Uncheck all\";s:9:\"uninstall\";s:9:\"Uninstall\";s:11:\"uninstalled\";s:12:\"uninstalled.\";s:7:\"unknown\";s:7:\"UNKNOWN\";s:9:\"unlabeled\";s:9:\"Unlabeled\";s:6:\"unread\";s:6:\"Unread\";s:16:\"unread_lowercase\";s:6:\"unread\";s:10:\"unselected\";s:10:\"Unselected\";s:11:\"unsubscribe\";s:19:\"Remove from desktop\";s:5:\"unzip\";s:5:\"Unzip\";s:2:\"up\";s:2:\"Up\";s:6:\"update\";s:4:\"Edit\";s:14:\"update_applied\";s:14:\"Update Applied\";s:15:\"update_language\";s:15:\"Update Language\";s:18:\"update_on_conflict\";s:18:\"Update on conflict\";s:6:\"upload\";s:6:\"Upload\";s:27:\"upload_error_file_not_found\";s:29:\"Upload error: File not found.\";s:20:\"uploaded_and_checked\";s:71:\"The file has been uploaded and checked, you can now start to import it.\";s:3:\"uri\";s:3:\"URI\";s:3:\"url\";s:3:\"URL\";s:5:\"url_a\";s:5:\"a URL\";s:7:\"url_add\";s:7:\"Add URL\";s:9:\"url_added\";s:9:\"URL added\";s:14:\"url_create_url\";s:10:\"Create URL\";s:10:\"url_delete\";s:10:\"Delete URL\";s:15:\"url_description\";s:15:\"URL Description\";s:8:\"url_edit\";s:8:\"Edit URL\";s:19:\"url_edit_permission\";s:26:\"Change Permission settings\";s:7:\"url_new\";s:7:\"New URL\";s:13:\"url_not_found\";s:14:\"File Not Found\";s:8:\"url_read\";s:8:\"Open URL\";s:12:\"url_to_latex\";s:23:\"URL to LaTeX CGI script\";s:11:\"url_visible\";s:14:\"URL is visible\";s:9:\"url_write\";s:8:\"Edit URL\";s:4:\"user\";s:4:\"User\";s:11:\"user_access\";s:15:\"Access per user\";s:10:\"user_added\";s:10:\"User added\";s:15:\"user_assignment\";s:15:\"User Assignment\";s:22:\"user_cant_receive_mail\";s:42:\"user is not allowed to use the mail system\";s:12:\"user_comment\";s:12:\"User comment\";s:19:\"user_defined_fields\";s:19:\"User-defined Fields\";s:17:\"user_defined_list\";s:28:\"Overview User-defined Fields\";s:12:\"user_deleted\";s:12:\"User deleted\";s:11:\"user_detail\";s:11:\"Detail Data\";s:16:\"user_ext_account\";s:16:\"External Account\";s:21:\"user_ext_account_desc\";s:70:\"Account used for external authentication. (CAS or SOAP authentication)\";s:18:\"user_import_failed\";s:19:\"User import failed.\";s:13:\"user_imported\";s:21:\"User import complete.\";s:27:\"user_imported_with_warnings\";s:35:\"User import complete with warnings.\";s:13:\"user_language\";s:13:\"User Language\";s:21:\"user_new_account_mail\";s:16:\"New Account Mail\";s:26:\"user_new_account_mail_desc\";s:90:\"This mail can be sent when an ILIAS user is created by other means then self-registration.\";s:15:\"user_not_chosen\";s:34:\"You did not choose a group-member!\";s:14:\"user_not_known\";s:31:\"Please insert a valid username.\";s:18:\"user_profile_other\";s:17:\"Other Information\";s:26:\"user_send_new_account_mail\";s:21:\"Send new account mail\";s:15:\"user_statistics\";s:16:\"Statistical Data\";s:8:\"userdata\";s:9:\"User data\";s:21:\"userfolder_export_csv\";s:22:\"Comma Separated Values\";s:27:\"userfolder_export_excel_x86\";s:15:\"Microsoft Excel\";s:22:\"userfolder_export_file\";s:4:\"File\";s:27:\"userfolder_export_file_size\";s:9:\"File size\";s:23:\"userfolder_export_files\";s:5:\"Files\";s:21:\"userfolder_export_xml\";s:3:\"XML\";s:8:\"username\";s:9:\"User name\";s:5:\"users\";s:5:\"Users\";s:18:\"users_not_imported\";s:71:\"The following users do not exist, their messages cannot become imported\";s:12:\"users_online\";s:12:\"Active users\";s:28:\"users_online_show_associated\";s:42:\"Show members of my courses and groups only\";s:19:\"users_online_show_n\";s:23:\"Don\'t show active users\";s:19:\"users_online_show_y\";s:21:\"Show all active users\";s:12:\"usertracking\";s:13:\"User Tracking\";s:3:\"usr\";s:4:\"User\";s:5:\"usr_a\";s:6:\"a User\";s:15:\"usr_active_only\";s:17:\"Active Users only\";s:7:\"usr_add\";s:8:\"Add User\";s:9:\"usr_added\";s:10:\"User added\";s:13:\"usr_agreement\";s:14:\"User Agreement\";s:19:\"usr_agreement_empty\";s:30:\"The agreement contains no text\";s:8:\"usr_edit\";s:9:\"Edit User\";s:17:\"usr_hits_per_page\";s:19:\"Hits/page in tables\";s:17:\"usr_inactive_only\";s:19:\"Inactive Users only\";s:7:\"usr_new\";s:8:\"New User\";s:32:\"usr_settings_explanation_profile\";s:435:\"Check \'Visible\' to show fields in the registration form and personal user profile on the personal desktop. Check \'Changeable\' to allow the user to change the value in the personal profile. Please note that visible fields can always be entered in the registration form. Required fields are required in the registration form and the personal user profile. All data can be changed in the user administration independent on these settings.\";s:27:\"usr_settings_header_profile\";s:21:\"User profile settings\";s:35:\"usr_settings_header_profile_profile\";s:24:\"Personal profile setting\";s:18:\"usr_settings_saved\";s:40:\"Global user settings saved successfully!\";s:14:\"usr_skin_style\";s:12:\"Skin / Style\";s:9:\"usr_style\";s:10:\"User Style\";s:4:\"usrf\";s:13:\"User accounts\";s:16:\"usrf_create_user\";s:23:\"Create new user account\";s:11:\"usrf_delete\";s:20:\"Delete user accounts\";s:20:\"usrf_edit_permission\";s:30:\"Change access to user accounts\";s:24:\"usrf_edit_roleassignment\";s:39:\"Change role assignment of user accounts\";s:23:\"usrf_push_desktop_items\";s:44:\"Allow to push items on the personal desktop.\";s:9:\"usrf_read\";s:28:\"Read access to user accounts\";s:15:\"usrf_read_users\";s:40:\"Role assignment for local administrators\";s:12:\"usrf_visible\";s:25:\"User accounts are visible\";s:10:\"usrf_write\";s:18:\"Edit user accounts\";s:23:\"usrimport_action_failed\";s:19:\"Action %1$s failed.\";s:24:\"usrimport_action_ignored\";s:20:\"Ignored action %1$s.\";s:25:\"usrimport_action_replaced\";s:29:\"Replaced action %1$s by %2$s.\";s:21:\"usrimport_cant_delete\";s:57:\"Can\'t perform \"Delete\" action. No such user in database. \";s:21:\"usrimport_cant_insert\";s:60:\"Can\'t perform \"Insert\" action. User is already in database. \";s:21:\"usrimport_cant_update\";s:57:\"Can\'t perform \"Update\" action. No such user in database. \";s:32:\"usrimport_conflict_handling_info\";s:413:\"When \"Ignore on conflict\" is selected, ILIAS ignores an action, if it can not be performed (e. g. an \"Insert\" action is not done, if there is already a user with the same login in the database.)\\nWhen \"Update on conflict\" is selected, ILIAS updates the database if an action can not be performed. (e. g. an \"Insert\" action is replaced by an \"Update\" action, if a user with the same login exists in the database). \";s:41:\"usrimport_global_role_for_action_required\";s:62:\"At least one global role must be specified for \"%1$s\" action. \";s:21:\"usrimport_ignore_role\";s:11:\"Ignore role\";s:29:\"usrimport_login_is_not_unique\";s:20:\"Login is not unique.\";s:43:\"usrimport_with_specified_role_not_permitted\";s:41:\"Import with specified role not permitted.\";s:31:\"usrimport_xml_attribute_missing\";s:47:\"Attribute \"%2$s\" in element \"%1$s\" is missing. \";s:37:\"usrimport_xml_attribute_value_illegal\";s:63:\"Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is illegal. \";s:42:\"usrimport_xml_attribute_value_inapplicable\";s:86:\"Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is inapplicable for \"%4$s\" action. \";s:37:\"usrimport_xml_element_content_illegal\";s:45:\"Content \"%2$s\" of element \"%1$s\" is illegal. \";s:41:\"usrimport_xml_element_for_action_required\";s:52:\"Element \"%1$s\" must be specified for \"%2$s\" action. \";s:34:\"usrimport_xml_element_inapplicable\";s:50:\"Element \"%1$s\" is inapplicable for \"%2$s\" action. \";s:38:\"usrimport_no_insert_ext_account_exists\";s:63:\"Can\'t perform \"Insert\" action. External account already exists.\";s:38:\"usrimport_no_update_ext_account_exists\";s:63:\"Can\'t perform \"Update\" action. External account already exists.\";s:5:\"valid\";s:5:\"Valid\";s:8:\"validate\";s:8:\"Validate\";s:5:\"value\";s:5:\"Value\";s:5:\"vcard\";s:13:\"Visiting card\";s:14:\"vcard_download\";s:22:\"Download visiting card\";s:7:\"vendors\";s:7:\"Vendors\";s:19:\"verification_failed\";s:19:\"Verification failed\";s:24:\"verification_failure_log\";s:24:\"Verification failure log\";s:16:\"verification_log\";s:16:\"Verification log\";s:24:\"verification_warning_log\";s:24:\"Verification warning log\";s:7:\"version\";s:7:\"Version\";s:8:\"versions\";s:8:\"Versions\";s:4:\"view\";s:4:\"View\";s:12:\"view_content\";s:12:\"View Content\";s:7:\"visible\";s:7:\"Visible\";s:14:\"visible_layers\";s:14:\"Visible Layers\";s:7:\"visitor\";s:7:\"Visitor\";s:8:\"visitors\";s:8:\"Visitors\";s:6:\"visits\";s:6:\"Visits\";s:13:\"web_resources\";s:13:\"Web Resources\";s:4:\"webr\";s:12:\"Web Resource\";s:11:\"webr_active\";s:6:\"Active\";s:8:\"webr_add\";s:16:\"Add Web Resource\";s:13:\"webr_add_item\";s:16:\"Add Web Resource\";s:11:\"webr_delete\";s:19:\"Delete Web Resource\";s:17:\"webr_delete_items\";s:22:\"Delete Web Resource(s)\";s:18:\"webr_deleted_items\";s:24:\"Deleted Web Resource(s).\";s:18:\"webr_disable_check\";s:13:\"Disable check\";s:9:\"webr_edit\";s:17:\"Edit Web Resource\";s:14:\"webr_edit_item\";s:17:\"Edit Web Resource\";s:20:\"webr_edit_permission\";s:26:\"Change permission settings\";s:16:\"webr_fillout_all\";s:36:\"Please fill out all required fields.\";s:17:\"webr_item_updated\";s:19:\"Saved modifications\";s:9:\"webr_join\";s:22:\"Subscribe Web Resource\";s:15:\"webr_last_check\";s:10:\"Last check\";s:21:\"webr_last_check_table\";s:11:\"Last check:\";s:10:\"webr_leave\";s:24:\"Unsubscribe Web Resource\";s:19:\"webr_modified_items\";s:20:\"Saved modifications.\";s:18:\"webr_never_checked\";s:13:\"Never checked\";s:8:\"webr_new\";s:20:\"Add new Web Resource\";s:21:\"webr_no_items_created\";s:24:\"No Web Resources created\";s:9:\"webr_read\";s:27:\"Read access to Web Resource\";s:22:\"webr_sure_delete_items\";s:59:\"Do you really want to delete the following Web Resource(s)?\";s:12:\"webr_visible\";s:23:\"Web Resource is visible\";s:10:\"webr_write\";s:17:\"Edit Web Resource\";s:11:\"webservices\";s:11:\"Webservices\";s:4:\"week\";s:4:\"Week\";s:6:\"weekly\";s:6:\"weekly\";s:5:\"weeks\";s:5:\"Weeks\";s:7:\"welcome\";s:7:\"Welcome\";s:13:\"who_is_online\";s:14:\"Who is online?\";s:14:\"width_x_height\";s:14:\"Width x Height\";s:4:\"with\";s:4:\"with\";s:5:\"write\";s:5:\"Write\";s:17:\"wrong_ip_detected\";s:95:\"Your access is denied because of a wrong client ip.<br>Please contact the system administrator.\";s:4:\"year\";s:4:\"Year\";s:5:\"years\";s:5:\"Years\";s:3:\"yes\";s:3:\"Yes\";s:23:\"you_may_add_local_roles\";s:23:\"You May Add Local Roles\";s:12:\"your_message\";s:12:\"Your Message\";s:3:\"zip\";s:8:\"Zip Code\";s:7:\"zipcode\";s:8:\"Zip Code\";s:24:\"adopt_perm_from_template\";s:24:\"Copy Permission Settings\";s:13:\"edit_grouping\";s:26:\"Edit Membership Limitation\";s:27:\"grouping_select_exactly_one\";s:48:\"Please choose exactly one membership limitation.\";}');
INSERT INTO `lng_modules` VALUES ('content','en','a:461:{s:11:\"HTML export\";s:11:\"HTML Export\";s:10:\"PDF export\";s:10:\"PDF Export\";s:5:\"Pages\";s:5:\"Pages\";s:14:\"add_menu_entry\";s:17:\"Add menu entry >>\";s:3:\"all\";s:3:\"All\";s:9:\"all_pages\";s:26:\"the entire Learning module\";s:18:\"choose_public_mode\";s:29:\"Unregistered users may access\";s:19:\"choose_public_pages\";s:30:\"Choose public accessible pages\";s:6:\"citate\";s:6:\"Citate\";s:11:\"citate_from\";s:15:\"Citate From ...\";s:11:\"citate_page\";s:16:\"Citate this Page\";s:9:\"citate_to\";s:13:\"Citate To ...\";s:15:\"cont_Additional\";s:10:\"Additional\";s:15:\"cont_Alphabetic\";s:22:\"Alphabetic a, b, ...  \";s:11:\"cont_Circle\";s:6:\"Circle\";s:13:\"cont_Citation\";s:8:\"Citation\";s:9:\"cont_Code\";s:4:\"Code\";s:12:\"cont_Example\";s:6:\"e.g.  \";s:14:\"cont_Headline1\";s:10:\"Headline 1\";s:14:\"cont_Headline2\";s:10:\"Headline 2\";s:14:\"cont_Headline3\";s:10:\"Headline 3\";s:9:\"cont_List\";s:4:\"List\";s:14:\"cont_LocalFile\";s:10:\"Local File\";s:13:\"cont_Mnemonic\";s:8:\"Mnemonic\";s:11:\"cont_Number\";s:6:\"Number\";s:9:\"cont_Poly\";s:7:\"Polygon\";s:9:\"cont_Rect\";s:9:\"Rectangle\";s:14:\"cont_Reference\";s:9:\"Reference\";s:11:\"cont_Remark\";s:6:\"Remark\";s:10:\"cont_Roman\";s:18:\"Roman i, ii, ...  \";s:17:\"cont_TableContent\";s:13:\"Table Content\";s:14:\"cont_Unordered\";s:9:\"Unordered\";s:15:\"cont_act_number\";s:18:\"Chapter Numeration\";s:18:\"cont_activate_page\";s:13:\"Activate Page\";s:11:\"cont_active\";s:11:\"Enable Menu\";s:13:\"cont_add_area\";s:8:\"Add Area\";s:23:\"cont_add_change_comment\";s:18:\"Add change comment\";s:19:\"cont_add_definition\";s:14:\"Add Definition\";s:19:\"cont_add_fullscreen\";s:15:\"Add Full Screen\";s:18:\"cont_added_comment\";s:34:\"Comment has been added to history.\";s:15:\"cont_added_term\";s:10:\"Term added\";s:20:\"cont_all_definitions\";s:15:\"All Definitions\";s:14:\"cont_all_pages\";s:9:\"All Pages\";s:10:\"cont_annex\";s:5:\"Annex\";s:16:\"cont_api_adapter\";s:16:\"API Adapter Name\";s:20:\"cont_api_func_prefix\";s:20:\"API Functions Prefix\";s:18:\"cont_areas_deleted\";s:18:\"Map areas deleted.\";s:16:\"cont_assign_full\";s:18:\"Assign Full Screen\";s:15:\"cont_assign_std\";s:15:\"Assign Standard\";s:23:\"cont_assign_translation\";s:18:\"Assign translation\";s:24:\"cont_assignments_deleted\";s:33:\"The assignments have been deleted\";s:15:\"cont_autoindent\";s:11:\"Auto Indent\";s:9:\"cont_back\";s:4:\"Back\";s:14:\"cont_booktitle\";s:10:\"Book title\";s:11:\"cont_bottom\";s:6:\"Bottom\";s:27:\"cont_browser_not_js_capable\";s:61:\"JavaScript enabled editing is not supported for your browser.\";s:22:\"cont_cant_copy_folders\";s:38:\"Folders cannot be copied to clipboard.\";s:18:\"cont_cant_del_full\";s:42:\"Deletion of full screen file not possible.\";s:17:\"cont_cant_del_std\";s:44:\"Deletion of standard view file not possible.\";s:12:\"cont_caption\";s:7:\"Caption\";s:16:\"cont_change_type\";s:11:\"Change Type\";s:19:\"cont_chap_and_pages\";s:18:\"Chapters and Pages\";s:32:\"cont_chap_copy_select_target_now\";s:46:\"Chapter marked for copying. Select target now.\";s:27:\"cont_chap_select_target_now\";s:45:\"Chapter marked for moving. Select target now.\";s:13:\"cont_chapters\";s:8:\"Chapters\";s:23:\"cont_chapters_and_pages\";s:18:\"Chapters and Pages\";s:18:\"cont_chapters_only\";s:13:\"Chapters only\";s:19:\"cont_characteristic\";s:14:\"Characteristic\";s:20:\"cont_choose_cont_obj\";s:21:\"Choose Content Object\";s:20:\"cont_choose_glossary\";s:15:\"Choose Glossary\";s:24:\"cont_choose_media_source\";s:19:\"Choose Media Source\";s:21:\"cont_citation_err_one\";s:35:\"You must select exactly one edition\";s:33:\"cont_citation_selection_not_valid\";s:29:\"You\'re selection is not valid\";s:14:\"cont_citations\";s:9:\"Citations\";s:20:\"cont_click_br_corner\";s:60:\"Please click on the bottom right corner of the desired area.\";s:17:\"cont_click_center\";s:43:\"Please click on center of the desired area.\";s:17:\"cont_click_circle\";s:51:\"Please click on a circle point of the desired area.\";s:23:\"cont_click_next_or_save\";s:140:\"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)\";s:21:\"cont_click_next_point\";s:46:\"Please click on the next point of the polygon.\";s:25:\"cont_click_starting_point\";s:50:\"Please click on the starting point of the polygon.\";s:20:\"cont_click_tl_corner\";s:56:\"Please click on the top left corner of the desired area.\";s:19:\"cont_confirm_delete\";s:15:\"really delete ?\";s:12:\"cont_content\";s:7:\"Content\";s:16:\"cont_content_obj\";s:14:\"Content Object\";s:13:\"cont_contents\";s:8:\"Contents\";s:11:\"cont_coords\";s:11:\"Coordinates\";s:16:\"cont_copy_object\";s:11:\"copy object\";s:22:\"cont_copy_to_clipboard\";s:17:\"Copy to clipboard\";s:23:\"cont_copy_to_media_pool\";s:18:\"Copy to media pool\";s:15:\"cont_create_dir\";s:16:\"Create Directory\";s:23:\"cont_create_export_file\";s:18:\"Create Export File\";s:28:\"cont_create_export_file_html\";s:25:\"Create Export File (HTML)\";s:29:\"cont_create_export_file_scorm\";s:26:\"Create Export File (SCORM)\";s:27:\"cont_create_export_file_xml\";s:24:\"Create Export File (XML)\";s:18:\"cont_create_folder\";s:13:\"Create Folder\";s:24:\"cont_create_html_version\";s:19:\"Create HTML Package\";s:15:\"cont_create_mob\";s:19:\"Create Media Object\";s:16:\"cont_credit_mode\";s:38:\"Credit mode (for lesson mode \'normal\')\";s:15:\"cont_credit_off\";s:9:\"No Credit\";s:14:\"cont_credit_on\";s:6:\"Credit\";s:12:\"cont_credits\";s:7:\"Credits\";s:20:\"cont_cross_reference\";s:15:\"Cross reference\";s:18:\"cont_data_from_lms\";s:17:\"adlcp:datafromlms\";s:16:\"cont_de_activate\";s:13:\"(De-)Activate\";s:20:\"cont_deactivate_page\";s:15:\"Deactivate Page\";s:15:\"cont_def_layout\";s:14:\"Default Layout\";s:20:\"cont_def_lesson_mode\";s:19:\"Default lesson mode\";s:21:\"cont_def_organization\";s:7:\"default\";s:15:\"cont_definition\";s:10:\"Definition\";s:16:\"cont_definitions\";s:11:\"Definitions\";s:19:\"cont_del_assignment\";s:17:\"Delete assignment\";s:20:\"cont_delete_selected\";s:6:\"Delete\";s:17:\"cont_dependencies\";s:12:\"Dependencies\";s:20:\"cont_derive_from_obj\";s:18:\"Derive from Object\";s:12:\"cont_details\";s:7:\"Details\";s:13:\"cont_dir_file\";s:14:\"Directory/File\";s:15:\"cont_disable_js\";s:19:\"JavaScript inactive\";s:18:\"cont_disable_media\";s:14:\"Media inactive\";s:17:\"cont_disable_html\";s:13:\"HTML inactive\";s:16:\"cont_enable_html\";s:11:\"HTML active\";s:19:\"cont_download_title\";s:14:\"Download Title\";s:14:\"cont_downloads\";s:9:\"Downloads\";s:19:\"cont_downloads_desc\";s:43:\"Enable download of all public export files.\";s:26:\"cont_downloads_public_desc\";s:56:\"Allow download even for anonymous users (in public area)\";s:20:\"cont_ed_align_center\";s:13:\"Align: Center\";s:18:\"cont_ed_align_left\";s:11:\"Align: Left\";s:24:\"cont_ed_align_left_float\";s:17:\"Align: Left Float\";s:19:\"cont_ed_align_right\";s:12:\"Align: Right\";s:25:\"cont_ed_align_right_float\";s:18:\"Align: Right Float\";s:13:\"cont_ed_class\";s:5:\"Style\";s:16:\"cont_ed_col_left\";s:16:\"Move Column Left\";s:17:\"cont_ed_col_right\";s:17:\"Move Column Right\";s:17:\"cont_ed_copy_clip\";s:17:\"Copy to Clipboard\";s:14:\"cont_ed_delete\";s:6:\"Delete\";s:18:\"cont_ed_delete_col\";s:13:\"Delete Column\";s:19:\"cont_ed_delete_item\";s:11:\"Delete Item\";s:18:\"cont_ed_delete_row\";s:10:\"Delete Row\";s:12:\"cont_ed_edit\";s:4:\"Edit\";s:17:\"cont_ed_edit_prop\";s:15:\"Edit Properties\";s:14:\"cont_ed_enable\";s:22:\"(De-)Activate Elements\";s:10:\"cont_ed_go\";s:2:\"Go\";s:19:\"cont_ed_insert_code\";s:11:\"Insert Code\";s:23:\"cont_ed_insert_filelist\";s:16:\"Insert File List\";s:19:\"cont_ed_insert_list\";s:11:\"Insert List\";s:20:\"cont_ed_insert_media\";s:12:\"Insert Media\";s:18:\"cont_ed_insert_par\";s:14:\"Insert Paragr.\";s:20:\"cont_ed_insert_table\";s:12:\"Insert Table\";s:17:\"cont_ed_item_down\";s:14:\"Move Item Down\";s:15:\"cont_ed_item_up\";s:12:\"Move Item Up\";s:17:\"cont_ed_moveafter\";s:10:\"Move After\";s:18:\"cont_ed_movebefore\";s:11:\"Move Before\";s:21:\"cont_ed_new_col_after\";s:16:\"New Column After\";s:22:\"cont_ed_new_col_before\";s:17:\"New Column Before\";s:22:\"cont_ed_new_item_after\";s:14:\"New Item After\";s:23:\"cont_ed_new_item_before\";s:15:\"New Item Before\";s:21:\"cont_ed_new_row_after\";s:13:\"New Row After\";s:22:\"cont_ed_new_row_before\";s:14:\"New Row Before\";s:18:\"cont_ed_paste_clip\";s:20:\"Paste From Clipboard\";s:16:\"cont_ed_row_down\";s:13:\"Move Row Down\";s:14:\"cont_ed_row_up\";s:11:\"Move Row Up\";s:18:\"cont_ed_split_page\";s:17:\"Split to New Page\";s:23:\"cont_ed_split_page_next\";s:18:\"Split to Next Page\";s:13:\"cont_ed_width\";s:5:\"Width\";s:14:\"cont_edit_area\";s:9:\"Edit Area\";s:30:\"cont_edit_file_list_properties\";s:25:\"Edit File List Properties\";s:13:\"cont_edit_mob\";s:17:\"Edit Media Object\";s:24:\"cont_edit_mob_alias_prop\";s:37:\"Edit Media Object Instance Properties\";s:19:\"cont_edit_mob_files\";s:12:\"Object Files\";s:24:\"cont_edit_mob_properties\";s:28:\"Edit Media Object Properties\";s:13:\"cont_edit_par\";s:14:\"Edit Paragraph\";s:13:\"cont_edit_src\";s:16:\"Edit source code\";s:24:\"cont_edit_tab_properties\";s:16:\"Table Properties\";s:14:\"cont_edit_term\";s:9:\"Edit Term\";s:12:\"cont_edition\";s:7:\"Edition\";s:21:\"cont_empty_mep_folder\";s:42:\"There are no media objects in this folder.\";s:14:\"cont_enable_js\";s:17:\"JavaScript active\";s:17:\"cont_enable_media\";s:12:\"Media active\";s:17:\"cont_export_files\";s:12:\"Export Files\";s:13:\"cont_external\";s:8:\"external\";s:17:\"cont_external_url\";s:12:\"external url\";s:9:\"cont_file\";s:4:\"File\";s:10:\"cont_files\";s:5:\"Files\";s:13:\"cont_fix_tree\";s:13:\"Fix structure\";s:21:\"cont_fix_tree_confirm\";s:140:\"Please execute this command only if the tree structure of this learning module is corrupted, e.g. if blank items occur in the explorer view.\";s:11:\"cont_footer\";s:6:\"Footer\";s:11:\"cont_format\";s:6:\"Format\";s:17:\"cont_format_error\";s:35:\"This operation is not allowed here!\";s:19:\"cont_frame_botright\";s:26:\"Content Details (Glossary)\";s:22:\"cont_frame_maincontent\";s:30:\"Learning Resource Main Content\";s:16:\"cont_frame_right\";s:15:\"Content Details\";s:14:\"cont_frame_toc\";s:17:\"Table of Contents\";s:19:\"cont_frame_topright\";s:31:\"Content Details (FAQ and Media)\";s:15:\"cont_free_pages\";s:10:\"Free Pages\";s:19:\"cont_full_is_in_dir\";s:56:\"Deletion not possible. Full screen file is in directory.\";s:15:\"cont_fullscreen\";s:11:\"Full Screen\";s:13:\"cont_get_link\";s:8:\"get link\";s:18:\"cont_get_orig_size\";s:17:\"Set original size\";s:13:\"cont_glo_menu\";s:4:\"Menu\";s:19:\"cont_glo_properties\";s:19:\"Glossary Properties\";s:11:\"cont_header\";s:6:\"Header\";s:11:\"cont_height\";s:6:\"Height\";s:18:\"cont_how_published\";s:13:\"How published\";s:9:\"cont_href\";s:4:\"href\";s:11:\"cont_id_ref\";s:13:\"identifierref\";s:13:\"cont_imagemap\";s:9:\"Image Map\";s:14:\"cont_import_id\";s:10:\"identifier\";s:21:\"cont_insert_file_item\";s:16:\"Insert File Item\";s:21:\"cont_insert_file_list\";s:16:\"Insert File List\";s:16:\"cont_insert_list\";s:11:\"Insert List\";s:15:\"cont_insert_mob\";s:19:\"Insert Media Object\";s:24:\"cont_insert_new_footnote\";s:19:\"insert new footnote\";s:15:\"cont_insert_par\";s:16:\"Insert Paragraph\";s:18:\"cont_insert_search\";s:27:\"Please insert a search term\";s:15:\"cont_insert_src\";s:18:\"Insert source code\";s:17:\"cont_insert_table\";s:12:\"Insert Table\";s:13:\"cont_internal\";s:8:\"internal\";s:18:\"cont_internal_link\";s:13:\"internal link\";s:15:\"cont_is_visible\";s:9:\"isvisible\";s:9:\"cont_isbn\";s:4:\"ISBN\";s:9:\"cont_issn\";s:4:\"ISSN\";s:9:\"cont_item\";s:4:\"Item\";s:12:\"cont_journal\";s:7:\"Journal\";s:12:\"cont_keyword\";s:7:\"Keyword\";s:9:\"cont_link\";s:4:\"Link\";s:14:\"cont_link_area\";s:9:\"Link Area\";s:13:\"cont_link_ext\";s:15:\"Link (external)\";s:13:\"cont_link_int\";s:15:\"Link (internal)\";s:16:\"cont_link_select\";s:13:\"Internal Link\";s:14:\"cont_link_type\";s:9:\"Link Type\";s:16:\"cont_linked_mobs\";s:20:\"Linked media objects\";s:15:\"cont_list_files\";s:10:\"List Files\";s:20:\"cont_list_properties\";s:15:\"List Properties\";s:15:\"cont_lk_chapter\";s:7:\"Chapter\";s:19:\"cont_lk_chapter_new\";s:19:\"Chapter (New Frame)\";s:17:\"cont_lk_media_faq\";s:17:\"Media (FAQ Frame)\";s:20:\"cont_lk_media_inline\";s:14:\"Media (Inline)\";s:19:\"cont_lk_media_media\";s:19:\"Media (Media Frame)\";s:17:\"cont_lk_media_new\";s:17:\"Media (New Frame)\";s:12:\"cont_lk_page\";s:4:\"Page\";s:16:\"cont_lk_page_faq\";s:16:\"Page (FAQ Frame)\";s:16:\"cont_lk_page_new\";s:16:\"Page (New Frame)\";s:14:\"cont_lk_survey\";s:6:\"Survey\";s:12:\"cont_lk_term\";s:13:\"Glossary Term\";s:16:\"cont_lk_term_new\";s:25:\"Glossary Term (New Frame)\";s:12:\"cont_lm_menu\";s:4:\"Menu\";s:18:\"cont_lm_properties\";s:26:\"Learning Module Properties\";s:11:\"cont_lvalue\";s:12:\"Data element\";s:13:\"cont_manifest\";s:8:\"Manifest\";s:14:\"cont_map_areas\";s:10:\"Link Areas\";s:18:\"cont_mastery_score\";s:18:\"adlcp:masteryscore\";s:21:\"cont_max_time_allowed\";s:20:\"adlcp:maxtimeallowed\";s:17:\"cont_media_source\";s:12:\"Media Source\";s:18:\"cont_mep_structure\";s:20:\"Media Pool Structure\";s:26:\"cont_missing_preconditions\";s:76:\"You need to fulfill the following preconditions to access the chapter \"%s\". \";s:14:\"cont_mob_files\";s:12:\"Object Files\";s:18:\"cont_mob_inst_prop\";s:19:\"Instance Properties\";s:13:\"cont_mob_prop\";s:17:\"Object Properties\";s:15:\"cont_mob_usages\";s:5:\"Usage\";s:10:\"cont_month\";s:5:\"Month\";s:16:\"cont_move_object\";s:11:\"move object\";s:26:\"cont_msg_multiple_editions\";s:54:\"It\'s not possible to show details of multiple editions\";s:9:\"cont_name\";s:4:\"Name\";s:13:\"cont_new_area\";s:13:\"New Link Area\";s:19:\"cont_new_assignment\";s:14:\"New assignment\";s:12:\"cont_new_dir\";s:13:\"New Directory\";s:13:\"cont_new_file\";s:8:\"New File\";s:18:\"cont_new_media_obj\";s:16:\"New Media Object\";s:13:\"cont_new_term\";s:8:\"New Term\";s:14:\"cont_no_access\";s:9:\"No Access\";s:21:\"cont_no_assign_itself\";s:39:\"The object cannot be assigned to itself\";s:16:\"cont_no_manifest\";s:48:\"No imsmanifest.xml file found in main directory.\";s:20:\"cont_no_object_found\";s:41:\"Could not find any object with this title\";s:12:\"cont_no_page\";s:14:\"No Page found.\";s:21:\"cont_no_subdir_in_zip\";s:83:\"Zip command failed or import file invalid.<br>It does not contain a subfolder \'%s\'.\";s:16:\"cont_no_zip_file\";s:30:\"Import file is not a zip file.\";s:9:\"cont_none\";s:4:\"None\";s:12:\"cont_nr_cols\";s:17:\"Number of Columns\";s:13:\"cont_nr_items\";s:15:\"Number of Items\";s:12:\"cont_nr_rows\";s:14:\"Number of Rows\";s:16:\"cont_obj_removed\";s:16:\"Objects removed.\";s:12:\"cont_offline\";s:16:\"Offline Versions\";s:18:\"cont_offline_files\";s:16:\"Offline versions\";s:21:\"cont_offline_versions\";s:16:\"Offline Versions\";s:11:\"cont_online\";s:6:\"Online\";s:7:\"cont_or\";s:2:\"or\";s:10:\"cont_order\";s:10:\"Order Type\";s:17:\"cont_organization\";s:12:\"Organization\";s:18:\"cont_organizations\";s:13:\"Organizations\";s:14:\"cont_orig_size\";s:13:\"Original Size\";s:21:\"cont_page_deactivated\";s:20:\"Page is deactivated.\";s:30:\"cont_page_deactivated_elements\";s:35:\"Page contains deactivated elements.\";s:16:\"cont_page_header\";s:11:\"Page Header\";s:14:\"cont_page_link\";s:9:\"Page Link\";s:27:\"cont_page_select_target_now\";s:42:\"Page marked for moving. Select target now.\";s:10:\"cont_pages\";s:5:\"Pages\";s:14:\"cont_parameter\";s:9:\"Parameter\";s:15:\"cont_parameters\";s:10:\"parameters\";s:25:\"cont_paste_from_clipboard\";s:20:\"Paste from clipboard\";s:23:\"cont_personal_clipboard\";s:18:\"Personal Clipboard\";s:15:\"cont_pg_content\";s:12:\"Page Content\";s:13:\"cont_pg_title\";s:10:\"Page Title\";s:18:\"cont_please_select\";s:13:\"please select\";s:16:\"cont_prereq_type\";s:24:\"adlcp:prerequisites.type\";s:18:\"cont_prerequisites\";s:19:\"adlcp:prerequisites\";s:12:\"cont_preview\";s:7:\"Preview\";s:15:\"cont_print_view\";s:10:\"Print View\";s:18:\"cont_public_access\";s:13:\"Public access\";s:17:\"cont_public_notes\";s:12:\"Public Notes\";s:22:\"cont_public_notes_desc\";s:64:\"Allow users to share notes on every page of the learning module.\";s:14:\"cont_publisher\";s:9:\"Publisher\";s:12:\"cont_purpose\";s:7:\"Purpose\";s:17:\"cont_ref_helptext\";s:40:\"(e.g. http://www.server.org/myimage.jpg)\";s:15:\"cont_ref_images\";s:17:\"Referenced Images\";s:14:\"cont_reference\";s:9:\"Reference\";s:22:\"cont_remove_fullscreen\";s:18:\"Remove Full Screen\";s:14:\"cont_removeiln\";s:29:\"really remove internal link ?\";s:20:\"cont_repository_item\";s:15:\"Repository Item\";s:26:\"cont_repository_item_links\";s:21:\"Repository Item Links\";s:23:\"cont_resize_explanation\";s:109:\"If this option is activated uploaded image files are automatically resized to the specified width and height.\";s:24:\"cont_resize_explanation2\";s:74:\"This function resizes local image files to the specified width and height.\";s:17:\"cont_resize_image\";s:13:\"Resize images\";s:13:\"cont_resource\";s:8:\"Resource\";s:18:\"cont_resource_type\";s:4:\"type\";s:14:\"cont_resources\";s:9:\"Resources\";s:11:\"cont_rvalue\";s:5:\"Value\";s:19:\"cont_saved_map_area\";s:14:\"Saved map area\";s:19:\"cont_saved_map_data\";s:14:\"Saved map data\";s:19:\"cont_sc_auto_review\";s:49:\"Set lesson mode \'review\' if student completed SCO\";s:24:\"cont_sc_less_mode_browse\";s:6:\"Browse\";s:24:\"cont_sc_less_mode_normal\";s:6:\"Normal\";s:20:\"cont_sc_stat_browsed\";s:7:\"Browsed\";s:22:\"cont_sc_stat_completed\";s:9:\"Completed\";s:19:\"cont_sc_stat_failed\";s:6:\"Failed\";s:23:\"cont_sc_stat_incomplete\";s:10:\"Incomplete\";s:26:\"cont_sc_stat_not_attempted\";s:13:\"Not attempted\";s:19:\"cont_sc_stat_passed\";s:6:\"Passed\";s:20:\"cont_sc_stat_running\";s:7:\"Running\";s:13:\"cont_sc_title\";s:5:\"title\";s:11:\"cont_school\";s:6:\"School\";s:10:\"cont_score\";s:5:\"Score\";s:15:\"cont_scorm_type\";s:15:\"adlcp:scormtype\";s:16:\"cont_select_item\";s:25:\"Select at least one item.\";s:24:\"cont_select_max_one_item\";s:27:\"Please select one item only\";s:24:\"cont_select_max_one_term\";s:20:\"Select one term only\";s:23:\"cont_select_one_edition\";s:35:\"Please select at least one edition.\";s:27:\"cont_select_one_translation\";s:29:\"Please select one translation\";s:35:\"cont_select_one_translation_warning\";s:53:\"It is not possible to show more than one translation.\";s:16:\"cont_select_term\";s:13:\"Select a term\";s:23:\"cont_select_translation\";s:48:\"Please select the assignment from the list above\";s:11:\"cont_series\";s:6:\"Series\";s:18:\"cont_series_editor\";s:13:\"Series editor\";s:17:\"cont_series_title\";s:12:\"Series title\";s:18:\"cont_series_volume\";s:13:\"Series volume\";s:14:\"cont_set_after\";s:12:\"insert after\";s:15:\"cont_set_before\";s:13:\"insert before\";s:15:\"cont_set_cancel\";s:6:\"cancel\";s:14:\"cont_set_class\";s:9:\"Set Class\";s:18:\"cont_set_edit_mode\";s:13:\"Set Edit Mode\";s:13:\"cont_set_into\";s:11:\"insert into\";s:13:\"cont_set_link\";s:9:\"Edit Link\";s:14:\"cont_set_shape\";s:10:\"Edit Shape\";s:19:\"cont_set_start_file\";s:14:\"Set Start File\";s:14:\"cont_set_width\";s:9:\"Set Width\";s:10:\"cont_shape\";s:5:\"Shape\";s:9:\"cont_show\";s:4:\"Show\";s:18:\"cont_show_citation\";s:18:\"Show with citation\";s:22:\"cont_show_line_numbers\";s:17:\"Show line numbers\";s:20:\"cont_show_print_view\";s:15:\"Show Print View\";s:9:\"cont_size\";s:12:\"Size (Bytes)\";s:17:\"cont_skip_chapter\";s:17:\"Skip this chapter\";s:11:\"cont_source\";s:6:\"Source\";s:8:\"cont_src\";s:11:\"Source code\";s:14:\"cont_src_other\";s:5:\"other\";s:13:\"cont_st_on_pg\";s:29:\"this function is not allowed.\";s:13:\"cont_st_title\";s:13:\"Chapter Title\";s:14:\"cont_startfile\";s:10:\"Start File\";s:11:\"cont_status\";s:6:\"Status\";s:18:\"cont_std_is_in_dir\";s:58:\"Deletion not possible. Standard view file is in directory.\";s:13:\"cont_std_view\";s:13:\"Standard View\";s:14:\"cont_structure\";s:9:\"structure\";s:10:\"cont_style\";s:5:\"Style\";s:16:\"cont_subchapters\";s:11:\"Subchapters\";s:23:\"cont_synchronize_frames\";s:18:\"Synchronise frames\";s:28:\"cont_synchronize_frames_desc\";s:157:\"This option synchronises the table of contents frame with the content frame and clears additional frames in 3 window view. But it also decreases performance.\";s:10:\"cont_table\";s:5:\"Table\";s:17:\"cont_table_border\";s:12:\"Table Border\";s:22:\"cont_table_cellpadding\";s:18:\"Table Cell Padding\";s:22:\"cont_table_cellspacing\";s:18:\"Table Cell Spacing\";s:22:\"cont_table_html_import\";s:17:\"Import HTML Table\";s:27:\"cont_table_html_import_info\";s:68:\"Import only works with XHTML conform tables. Table must be root tag!\";s:29:\"cont_table_spreadsheet_import\";s:18:\"Spreadsheet Import\";s:34:\"cont_table_spreadsheet_import_info\";s:73:\"Paste table from spreadsheet application via clipboard into the textarea.\";s:16:\"cont_table_width\";s:11:\"Table Width\";s:25:\"cont_target_within_source\";s:40:\"Target must not be within source object.\";s:9:\"cont_term\";s:4:\"Term\";s:10:\"cont_terms\";s:5:\"Terms\";s:14:\"cont_text_code\";s:5:\"Code:\";s:13:\"cont_text_com\";s:8:\"Comment:\";s:13:\"cont_text_emp\";s:14:\"Emphatic Text:\";s:12:\"cont_text_fn\";s:9:\"Footnote:\";s:13:\"cont_text_iln\";s:20:\"Internal Link, e.g.:\";s:14:\"cont_text_quot\";s:10:\"Quotation:\";s:13:\"cont_text_str\";s:12:\"Strong Text:\";s:13:\"cont_text_tex\";s:11:\"LaTeX Code:\";s:13:\"cont_text_xln\";s:14:\"External Link:\";s:9:\"cont_time\";s:4:\"Time\";s:22:\"cont_time_limit_action\";s:21:\"adlcp:timelimitaction\";s:10:\"cont_title\";s:5:\"title\";s:20:\"cont_title_footnotes\";s:9:\"Footnotes\";s:8:\"cont_toc\";s:17:\"Table of Contents\";s:13:\"cont_toc_mode\";s:23:\"Table of Contents shows\";s:8:\"cont_top\";s:3:\"Top\";s:15:\"cont_total_time\";s:10:\"Total Time\";s:18:\"cont_tracking_data\";s:13:\"Tracking Data\";s:19:\"cont_tracking_items\";s:14:\"Tracking Items\";s:17:\"cont_translations\";s:14:\"Translation(s)\";s:26:\"cont_translations_assigned\";s:37:\"The translation(s) have been assigned\";s:15:\"cont_tree_fixed\";s:30:\"Tree structure has been fixed.\";s:11:\"cont_update\";s:6:\"Update\";s:17:\"cont_update_names\";s:12:\"Update Names\";s:16:\"cont_upload_file\";s:11:\"Upload File\";s:8:\"cont_url\";s:3:\"URL\";s:10:\"cont_usage\";s:5:\"Usage\";s:28:\"cont_users_have_mob_in_clip1\";s:40:\"This media object is in the clipboard of\";s:28:\"cont_users_have_mob_in_clip2\";s:8:\"user(s).\";s:18:\"cont_validate_file\";s:13:\"Validate File\";s:12:\"cont_version\";s:7:\"version\";s:25:\"cont_view_last_export_log\";s:15:\"Last Export Log\";s:20:\"cont_where_published\";s:15:\"Where published\";s:10:\"cont_width\";s:5:\"Width\";s:12:\"cont_wysiwyg\";s:15:\"Content WYSIWYG\";s:13:\"cont_xml_base\";s:8:\"xml:base\";s:9:\"cont_year\";s:4:\"Year\";s:21:\"cont_zip_file_invalid\";s:68:\"File is not a valid import file.<br>It does not contain a file \'%s\'.\";s:19:\"copied_to_clipboard\";s:30:\"Copied object(s) to clipboard.\";s:13:\"dgl_pagebreak\";s:9:\"Pagebreak\";s:19:\"glo_definition_abbr\";s:4:\"Def.\";s:16:\"glo_term_used_in\";s:44:\"The following resources linking to that term\";s:18:\"lm_menu_edit_entry\";s:15:\"Edit menu entry\";s:20:\"lm_menu_entry_target\";s:6:\"Target\";s:19:\"lm_menu_entry_title\";s:5:\"Title\";s:17:\"lm_menu_new_entry\";s:23:\"Create a new menu entry\";s:30:\"lm_menu_select_internal_object\";s:25:\"Select internal object >>\";s:28:\"lm_menu_select_object_to_add\";s:52:\"Please select the object you want to add to the menu\";s:15:\"msg_entry_added\";s:16:\"Menu entry added\";s:17:\"msg_entry_removed\";s:18:\"Menu entry removed\";s:17:\"msg_entry_updated\";s:18:\"Menu entry updated\";s:25:\"msg_page_no_public_access\";s:138:\"The page you called is not available in the public area. Only registered users may view this page. Please login first to access this page.\";s:19:\"msg_page_not_public\";s:18:\"Page is not public\";s:10:\"pages from\";s:10:\"Pages From\";s:3:\"par\";s:9:\"Paragraph\";s:2:\"pg\";s:4:\"Page\";s:14:\"public_section\";s:11:\"Public Area\";s:12:\"read offline\";s:12:\"Read Offline\";s:12:\"selectFooter\";s:16:\"Select As Footer\";s:12:\"selectHeader\";s:16:\"Select As Header\";s:13:\"select_a_file\";s:21:\"Please select a file.\";s:19:\"selected_pages_only\";s:30:\"only that pages selected below\";s:15:\"set_public_mode\";s:22:\"Set public access mode\";s:2:\"st\";s:7:\"Chapter\";s:12:\"start export\";s:12:\"Start Export\";}');
INSERT INTO `lng_modules` VALUES ('crs','en','a:478:{s:26:\"activation_times_not_valid\";s:37:\"The availability period is not valid.\";s:9:\"add_event\";s:11:\"Add Session\";s:8:\"assigned\";s:8:\"Assigned\";s:23:\"contact_email_not_valid\";s:31:\"the contact email is not valid.\";s:21:\"crs_accept_subscriber\";s:25:\"Admission to course \"%s\" \";s:26:\"crs_accept_subscriber_body\";s:39:\"You have been admitted to course \"%s\". \";s:19:\"crs_access_password\";s:8:\"Password\";s:14:\"crs_activation\";s:10:\"Activation\";s:20:\"crs_add_archive_html\";s:21:\"Create a HTML Archive\";s:19:\"crs_add_archive_xml\";s:20:\"Create a XML Archive\";s:16:\"crs_add_grouping\";s:25:\"Add Membership Limitation\";s:22:\"crs_add_grp_assignment\";s:16:\"Assign course(s)\";s:20:\"crs_add_html_archive\";s:16:\"Add HTML archive\";s:14:\"crs_add_member\";s:13:\"Add Member(s)\";s:17:\"crs_add_objective\";s:13:\"Add objective\";s:27:\"crs_add_remove_from_desktop\";s:23:\"Add/Remove from Desktop\";s:32:\"crs_add_remove_from_desktop_info\";s:62:\"Allow the members to add course items to the personal desktop.\";s:15:\"crs_add_starter\";s:16:\"Add Start Object\";s:19:\"crs_add_subscribers\";s:14:\"Add subscriber\";s:9:\"crs_added\";s:16:\"Added new course\";s:16:\"crs_added_member\";s:26:\"Addmission to course \"%s\" \";s:21:\"crs_added_member_body\";s:39:\"You have been admitted to course \"%s\". \";s:21:\"crs_added_new_archive\";s:28:\"A new archive has been added\";s:19:\"crs_added_objective\";s:42:\"A new learning objective has been created.\";s:18:\"crs_added_starters\";s:25:\"Assigned start object(s).\";s:17:\"crs_added_to_list\";s:96:\"You have been assigned to the waiting list. You are assigned to position %s on the waiting list.\";s:9:\"crs_admin\";s:13:\"Administrator\";s:19:\"crs_admin_no_notify\";s:31:\"Administrator (no notification)\";s:16:\"crs_admin_notify\";s:28:\"Administrator (notification)\";s:18:\"crs_administrators\";s:14:\"Administrators\";s:13:\"crs_allow_abo\";s:34:\"Allow subscription of course items\";s:28:\"crs_already_assigned_to_list\";s:45:\"You are already assigned to the waiting list.\";s:11:\"crs_archive\";s:8:\"Archives\";s:20:\"crs_archive_disabled\";s:11:\"Deactivated\";s:20:\"crs_archive_download\";s:37:\"Allow the Download of Course Archives\";s:16:\"crs_archive_info\";s:121:\"If enabled, all course content will we suppressed. Only HTML archives of this course will be available to course members.\";s:16:\"crs_archive_lang\";s:8:\"Language\";s:16:\"crs_archive_read\";s:11:\"Read access\";s:23:\"crs_archive_select_type\";s:12:\"Archive view\";s:16:\"crs_archive_type\";s:12:\"Archive type\";s:25:\"crs_archive_type_disabled\";s:13:\"Not available\";s:20:\"crs_archives_deleted\";s:32:\"The archive(s) have been deleted\";s:13:\"crs_auto_fill\";s:9:\"Auto fill\";s:31:\"crs_availability_limitless_info\";s:120:\"Choose this mode for making the course available and accessible to users (depending on the registration settings below).\";s:27:\"crs_availability_until_info\";s:147:\"Choose this mode for making the course available and accessible to users for a fixed period of time (depending on the registration settings below).\";s:31:\"crs_availability_unvisible_info\";s:108:\"Choose this mode for preparing the course. Only course administators and tutors can see and edit the course.\";s:11:\"crs_blocked\";s:14:\"Access refused\";s:18:\"crs_blocked_member\";s:33:\"Membership status in course \"%s\" \";s:23:\"crs_blocked_member_body\";s:50:\"Your membership for course \"%s\" has been blocked. \";s:23:\"crs_cancel_subscription\";s:26:\"Resigned from course \"%s\" \";s:28:\"crs_cancel_subscription_body\";s:40:\"A member has resigned from course \"%s\". \";s:17:\"crs_change_status\";s:28:\"Changes status of objective:\";s:28:\"crs_chapter_already_assigned\";s:36:\"These chapters are already assigned.\";s:11:\"crs_contact\";s:7:\"Contact\";s:24:\"crs_contact_consultation\";s:12:\"Consultation\";s:17:\"crs_contact_email\";s:4:\"Mail\";s:16:\"crs_contact_name\";s:4:\"Name\";s:17:\"crs_contact_phone\";s:9:\"Telephone\";s:26:\"crs_contact_responsibility\";s:14:\"Responsibility\";s:11:\"crs_content\";s:14:\"Course Content\";s:24:\"crs_copy_cat_not_allowed\";s:37:\"It is not possible to copy categories\";s:17:\"crs_count_members\";s:17:\"Number of members\";s:19:\"crs_count_questions\";s:19:\"Number of questions\";s:15:\"crs_create_date\";s:11:\"Create date\";s:17:\"crs_crs_structure\";s:16:\"Course structure\";s:9:\"crs_dates\";s:5:\"Dates\";s:20:\"crs_deassign_lm_sure\";s:48:\"Are you sure you want to delete this assignment?\";s:15:\"crs_delete_file\";s:12:\"Delete File?\";s:25:\"crs_delete_from_list_sure\";s:69:\"Are you sure, you want to deassign the following users from the list?\";s:28:\"crs_delete_from_waiting_list\";s:24:\"Remove from waiting list\";s:17:\"crs_delete_member\";s:18:\"Deassign member(s)\";s:23:\"crs_delete_members_sure\";s:60:\"Do you want to delete the following members from this course\";s:24:\"crs_delete_objectve_sure\";s:57:\"Are you sure, you want to delete the selected objectives?\";s:22:\"crs_delete_subscribers\";s:17:\"Delete subscriber\";s:27:\"crs_delete_subscribers_sure\";s:41:\"Do you want to delete the following users\";s:11:\"crs_details\";s:14:\"Course Details\";s:18:\"crs_dismiss_member\";s:38:\"Terminated membership for course \"%s\" \";s:23:\"crs_dismiss_member_body\";s:51:\"You membership for course \"%s\" has been terminated \";s:16:\"crs_edit_archive\";s:13:\"Edit Archives\";s:16:\"crs_edit_content\";s:10:\"Edit items\";s:22:\"crs_edit_start_objects\";s:18:\"Edit Start Objects\";s:16:\"crs_edit_timings\";s:12:\"Edit Timings\";s:7:\"crs_end\";s:3:\"End\";s:18:\"crs_existing_files\";s:15:\"Existing Files:\";s:10:\"crs_export\";s:13:\"Course export\";s:8:\"crs_file\";s:4:\"File\";s:17:\"crs_file_download\";s:18:\"Files for Download\";s:13:\"crs_file_name\";s:9:\"File name\";s:18:\"crs_file_size_info\";s:8:\"Filesize\";s:12:\"crs_filename\";s:8:\"Filename\";s:15:\"crs_free_places\";s:16:\"Available places\";s:8:\"crs_from\";s:5:\"From:\";s:20:\"crs_further_settings\";s:16:\"Further Settings\";s:16:\"crs_general_info\";s:20:\"General Informations\";s:24:\"crs_general_informations\";s:20:\"General Informations\";s:12:\"crs_grouping\";s:15:\"Course grouping\";s:19:\"crs_grouping_assign\";s:17:\"Change assignment\";s:24:\"crs_grouping_delete_sure\";s:66:\"Do you really want to delete the following membership limitations?\";s:20:\"crs_grouping_deleted\";s:30:\"Deleted membership limitation.\";s:32:\"crs_grouping_modified_assignment\";s:19:\"Changed assignment.\";s:23:\"crs_grouping_select_one\";s:38:\"Please select a membership limitation.\";s:13:\"crs_groupings\";s:29:\"Course membership limitations\";s:24:\"crs_groupings_ask_delete\";s:28:\"Delete Membership Limitation\";s:24:\"crs_grp_already_assigned\";s:47:\"You are already member of this course grouping.\";s:18:\"crs_grp_assign_crs\";s:13:\"Assign course\";s:24:\"crs_grp_assigned_courses\";s:17:\"Assigned courses.\";s:29:\"crs_grp_assigned_courses_info\";s:17:\"Assigned courses:\";s:32:\"crs_grp_courses_already_assigned\";s:43:\"The selected courses were already assigned.\";s:22:\"crs_grp_crs_assignment\";s:17:\"Course assignment\";s:26:\"crs_grp_deassigned_courses\";s:17:\"Delete assignment\";s:19:\"crs_grp_enter_title\";s:21:\"Please enter a title.\";s:16:\"crs_grp_info_reg\";s:45:\"You can only register to one of this courses:\";s:30:\"crs_grp_matriculation_required\";s:140:\"This membership limitation requires an unique matriculation number. <br />Please insert this value in your settings on the personal desktop.\";s:25:\"crs_grp_modified_grouping\";s:20:\"Saved modifications.\";s:26:\"crs_grp_no_course_selected\";s:25:\"Please select one course.\";s:27:\"crs_grp_no_courses_assigned\";s:20:\"No assigned courses.\";s:30:\"crs_grp_table_assigned_courses\";s:16:\"Assigned Courses\";s:19:\"crs_header_archives\";s:15:\"Course archives\";s:25:\"crs_header_delete_members\";s:14:\"Delete members\";s:29:\"crs_header_delete_subscribers\";s:18:\"Delete subscribers\";s:23:\"crs_header_edit_members\";s:12:\"Edit members\";s:18:\"crs_header_members\";s:14:\"Course members\";s:35:\"crs_header_remove_from_waiting_list\";s:28:\"Waiting list: deassign users\";s:17:\"crs_hide_link_lms\";s:23:\"Hide learning materials\";s:24:\"crs_hide_link_objectives\";s:15:\"Hide objectives\";s:16:\"crs_hide_link_or\";s:20:\"Hide other resources\";s:17:\"crs_hide_link_tst\";s:10:\"Hide tests\";s:8:\"crs_html\";s:4:\"HTML\";s:18:\"crs_important_info\";s:22:\"Important Informations\";s:17:\"crs_info_download\";s:18:\"Files for Download\";s:12:\"crs_info_reg\";s:10:\"Admittance\";s:25:\"crs_info_reg_confirmation\";s:143:\"You can request membership for this course. You will get a message from a course administrator when your request has been admitted or declined.\";s:24:\"crs_info_reg_deactivated\";s:28:\"Course admittance is closed.\";s:19:\"crs_info_reg_direct\";s:34:\"You can join this course directly.\";s:21:\"crs_info_reg_password\";s:86:\"If a course administrator has given you the course password, you can join this course.\";s:17:\"crs_info_settings\";s:19:\"Course Informations\";s:14:\"crs_info_start\";s:146:\"Please work through all of the course items stated below.<br />After you have processed all red marked objects new course items will be activated.\";s:26:\"crs_item_availability_info\";s:167:\"Choose this option for making the item available for a fixed period of time. If \'Visiblity\' is checked the item will remain visble but not accessible for the learners.\";s:24:\"crs_item_presetting_info\";s:65:\"Choose this option to offer the learners suggested editing times.\";s:22:\"crs_learning_materials\";s:18:\"Learning materials\";s:14:\"crs_list_users\";s:10:\"List users\";s:17:\"crs_lm_assignment\";s:28:\"Learning material assignment\";s:25:\"crs_lm_assignment_deleted\";s:19:\"Deleted assignment.\";s:15:\"crs_lm_deassign\";s:18:\"Delete assignment.\";s:30:\"crs_lm_no_assignments_selected\";s:29:\"Please select one assignment.\";s:24:\"crs_lms_already_assigned\";s:47:\"These learning materials were already assigned.\";s:13:\"crs_materials\";s:16:\"Course Materials\";s:23:\"crs_max_members_reached\";s:46:\"The maximum number of members has been reached\";s:21:\"crs_mem_change_status\";s:13:\"Change status\";s:17:\"crs_mem_send_mail\";s:9:\"Send mail\";s:10:\"crs_member\";s:6:\"Member\";s:25:\"crs_member_administration\";s:17:\"Edit Participants\";s:18:\"crs_member_blocked\";s:16:\"Member (blocked)\";s:13:\"crs_member_of\";s:17:\"Member of course:\";s:20:\"crs_member_unblocked\";s:18:\"Member (unblocked)\";s:18:\"crs_member_updated\";s:27:\"The member has been updated\";s:11:\"crs_members\";s:7:\"Members\";s:19:\"crs_members_deleted\";s:15:\"Deleted members\";s:18:\"crs_members_footer\";s:16:\"course member(s)\";s:25:\"crs_members_footer_passed\";s:6:\"passed\";s:23:\"crs_members_print_title\";s:14:\"Course members\";s:17:\"crs_members_table\";s:19:\"Course Participants\";s:17:\"crs_members_title\";s:14:\"Course members\";s:13:\"crs_move_down\";s:9:\"Move down\";s:11:\"crs_move_up\";s:7:\"Move up\";s:14:\"crs_moved_item\";s:17:\"Moved course item\";s:19:\"crs_moved_objective\";s:25:\"Moved learning objective.\";s:14:\"crs_new_search\";s:10:\"New search\";s:20:\"crs_new_subscription\";s:24:\"User joined course \"%s\" \";s:25:\"crs_new_subscription_body\";s:31:\"A user has joined course \"%s\". \";s:28:\"crs_new_subscription_request\";s:28:\"Request to join course \"%s\" \";s:33:\"crs_new_subscription_request_body\";s:42:\"A user has requested to join course \"%s\". \";s:34:\"crs_new_subscription_request_body2\";s:107:\"You have to call the member administration of that course for accepting or refusing the membership request.\";s:23:\"crs_no_archive_selected\";s:20:\"No archives selected\";s:25:\"crs_no_archives_available\";s:31:\"There are no archives available\";s:24:\"crs_no_archives_selected\";s:24:\"Please select an archive\";s:23:\"crs_no_chapter_selected\";s:24:\"Please select a chapter.\";s:25:\"crs_no_groupings_assigned\";s:37:\"No groupings assigned to this course.\";s:22:\"crs_no_groups_selected\";s:21:\"Please select a group\";s:18:\"crs_no_items_found\";s:8:\"No items\";s:15:\"crs_no_language\";s:11:\"No language\";s:18:\"crs_no_lm_selected\";s:36:\"Please select one learning material.\";s:19:\"crs_no_lms_assigned\";s:41:\"There are no learning materials assigned.\";s:24:\"crs_no_lms_inside_course\";s:47:\"No learning materials found inside this course.\";s:21:\"crs_no_lms_inside_crs\";s:91:\"No learning materials inside this course, which can be assigned to this learning objective.\";s:22:\"crs_no_member_selected\";s:24:\"Please select one member\";s:23:\"crs_no_members_assigned\";s:44:\"There are no members assigned to this course\";s:13:\"crs_no_notify\";s:31:\"No notify for new registrations\";s:25:\"crs_no_objective_selected\";s:28:\"Please select one objective.\";s:25:\"crs_no_objectives_created\";s:33:\"There are no objectives assigned.\";s:24:\"crs_no_question_selected\";s:27:\"Please select one question.\";s:25:\"crs_no_questions_assigned\";s:32:\"There are no questions assigned.\";s:20:\"crs_no_results_found\";s:16:\"No results found\";s:21:\"crs_no_roles_selected\";s:20:\"Please select a role\";s:22:\"crs_no_starter_created\";s:41:\"No start objects assigned to this course.\";s:27:\"crs_no_subscribers_selected\";s:20:\"Please select a user\";s:23:\"crs_no_tests_inside_crs\";s:78:\"No tests inside this course, which can be assigned to this learning objective.\";s:18:\"crs_no_users_added\";s:16:\"No members added\";s:21:\"crs_no_users_selected\";s:27:\"You did not select any user\";s:28:\"crs_no_valid_member_id_given\";s:18:\"No valid member Id\";s:17:\"crs_not_available\";s:15:\"-Not available-\";s:16:\"crs_notification\";s:12:\"Notification\";s:10:\"crs_notify\";s:28:\"Notify for new registrations\";s:6:\"crs_nr\";s:3:\"Nr.\";s:22:\"crs_number_users_added\";s:62:\"The following number of users has been assigned to the course:\";s:26:\"crs_objective_accomplished\";s:12:\"Accomplished\";s:28:\"crs_objective_assign_chapter\";s:15:\"Assign chapters\";s:23:\"crs_objective_assign_lm\";s:24:\"Assign learning material\";s:29:\"crs_objective_assign_question\";s:15:\"Assign question\";s:31:\"crs_objective_deassign_question\";s:17:\"Delete assignment\";s:34:\"crs_objective_delete_lm_assignment\";s:17:\"Delete assignment\";s:28:\"crs_objective_insert_percent\";s:44:\"Please enter only numbers between 0 and 100.\";s:22:\"crs_objective_modified\";s:27:\"Updated learning objective.\";s:28:\"crs_objective_no_title_given\";s:21:\"Please enter a title.\";s:30:\"crs_objective_not_accomplished\";s:16:\"Not accomplished\";s:33:\"crs_objective_overview_objectives\";s:19:\"Overview objectives\";s:42:\"crs_objective_overview_question_assignment\";s:28:\"Overview question assignment\";s:21:\"crs_objective_pretest\";s:15:\"Self assessment\";s:33:\"crs_objective_question_assignment\";s:19:\"Question assignment\";s:20:\"crs_objective_result\";s:10:\"After test\";s:26:\"crs_objective_updated_test\";s:22:\"Updated modifications.\";s:18:\"crs_objective_view\";s:23:\"Objective oriented view\";s:14:\"crs_objectives\";s:19:\"Learning Objectives\";s:29:\"crs_objectives_assign_chapter\";s:14:\"Assign Chapter\";s:26:\"crs_objectives_assigned_lm\";s:51:\"The selected learning materials have been assigned.\";s:27:\"crs_objectives_assigned_lms\";s:27:\"Assigned learning materials\";s:37:\"crs_objectives_assigned_new_questions\";s:21:\"Added new assignment.\";s:33:\"crs_objectives_assigned_questions\";s:18:\"Assigned questions\";s:33:\"crs_objectives_chapter_assignment\";s:18:\"Chapter assignment\";s:37:\"crs_objectives_deassign_question_sure\";s:57:\"Are you sure, you want to delete the following questions?\";s:22:\"crs_objectives_deleted\";s:26:\"Delete learning objectives\";s:40:\"crs_objectives_edit_question_assignments\";s:24:\"Edit question assignment\";s:25:\"crs_objectives_info_final\";s:258:\"You did not accomplish all course objectives in the previous exam. <br />Please select all red marked objectives one after another and review the related lerning materials. <br />After you have reviewed all red marked objectives, you can take the exam again.\";s:28:\"crs_objectives_info_finished\";s:69:\"Congratulations, you have accomplished all objectives of this course!\";s:24:\"crs_objectives_info_none\";s:151:\"The following is a list of the course objectives.<br /> Please select the objectives one after another and work through the related learning materials.\";s:27:\"crs_objectives_info_pretest\";s:321:\"The following are the results of your self assessment. <br />Please select the red marked objectives one after another and work through their related learning material. <br />After you have processed all red marked objectives, you can take the final exam of this course, which is located in the test section of this page.\";s:39:\"crs_objectives_info_pretest_non_suggest\";s:221:\"The following are the results of your self assessment. <br />According to this you have fullfilled any learning objective. You can now take the final exam of this course, which is located in the test section of this page.\";s:28:\"crs_objectives_lm_assignment\";s:28:\"Learning material assignment\";s:25:\"crs_objectives_max_points\";s:14:\"Maximum points\";s:35:\"crs_objectives_no_question_selected\";s:27:\"Please select one question.\";s:27:\"crs_objectives_nr_questions\";s:19:\"Number of questions\";s:29:\"crs_objectives_qst_deassigned\";s:41:\"The question assignment has been deleted.\";s:25:\"crs_objectives_reset_sure\";s:86:\"You want to delete all results of this course. <br />All test results will be deleted.\";s:22:\"crs_objectives_reseted\";s:16:\"Reseted results.\";s:11:\"crs_offline\";s:7:\"Offline\";s:11:\"crs_options\";s:7:\"Options\";s:19:\"crs_other_groupings\";s:26:\"Groupings of other courses\";s:19:\"crs_other_resources\";s:15:\"Other resources\";s:10:\"crs_passed\";s:6:\"Passed\";s:22:\"crs_password_not_valid\";s:26:\"Your password is not valid\";s:21:\"crs_password_required\";s:48:\"This registration procedure requires a password.\";s:7:\"crs_pdf\";s:3:\"PDF\";s:27:\"crs_persons_on_waiting_list\";s:27:\"Persons on the waiting list\";s:14:\"crs_print_list\";s:10:\"Print list\";s:23:\"crs_question_assignment\";s:19:\"Question assignment\";s:7:\"crs_reg\";s:12:\"Registration\";s:19:\"crs_reg_deactivated\";s:8:\"Disabled\";s:16:\"crs_reg_lim_info\";s:62:\"Registrations are only possible during a fixed period of time.\";s:16:\"crs_reg_max_info\";s:92:\"Define the maximum number of users that can be assigned to this course. \'0\' means unlimited.\";s:19:\"crs_reg_notify_info\";s:115:\"If enabled all course administrators/tutors with status \'Notify\' will be informed by email about new registrations.\";s:32:\"crs_reg_subscription_deactivated\";s:24:\"Registration is disabled\";s:32:\"crs_reg_subscription_end_earlier\";s:32:\"The registration time is expired\";s:40:\"crs_reg_subscription_max_members_reached\";s:40:\"The maximum number of users is exceeded.\";s:32:\"crs_reg_subscription_start_later\";s:34:\"The registration time starts later\";s:18:\"crs_reg_unlim_info\";s:109:\"If enabled, there is no time limit for registrations. Please choose one of the registration procedures below.\";s:13:\"crs_reg_until\";s:19:\"Registration period\";s:29:\"crs_reg_user_already_assigned\";s:39:\"You are already assigned to this course\";s:31:\"crs_reg_user_already_subscribed\";s:53:\"You have already requested membership for this course\";s:20:\"crs_reg_user_blocked\";s:32:\"You are blocked from this course\";s:16:\"crs_registration\";s:19:\"Course registration\";s:28:\"crs_registration_deactivated\";s:83:\"Choose this option for disabling course registration. No user can join this course.\";s:24:\"crs_registration_limited\";s:27:\"Limited Registration Period\";s:21:\"crs_registration_type\";s:22:\"Registration Procedure\";s:26:\"crs_registration_unlimited\";s:29:\"Unlimited Registration Period\";s:21:\"crs_reject_subscriber\";s:25:\"Declined for course \"%s\" \";s:26:\"crs_reject_subscriber_body\";s:52:\"Your request to join course \"%s\" has been declined. \";s:17:\"crs_reset_results\";s:13:\"Reset results\";s:8:\"crs_role\";s:4:\"Role\";s:15:\"crs_role_status\";s:13:\"Role / Status\";s:30:\"crs_search_enter_search_string\";s:28:\"Please enter a search string\";s:14:\"crs_search_for\";s:10:\"Search for\";s:18:\"crs_search_members\";s:11:\"User search\";s:14:\"crs_search_str\";s:11:\"Search term\";s:27:\"crs_select_archive_language\";s:40:\"Please select a language for the archive\";s:25:\"crs_select_exactly_one_lm\";s:42:\"Please select exactly one learning module.\";s:26:\"crs_select_exactly_one_tst\";s:31:\"Please select exactly one test.\";s:20:\"crs_select_native_lm\";s:70:\"Single chapters can only be assigned to native ILIAS learning modules.\";s:22:\"crs_select_one_archive\";s:25:\"Please select one archive\";s:21:\"crs_select_one_object\";s:30:\"Please select one course item.\";s:28:\"crs_select_registration_type\";s:38:\"Please select an admittance procedure.\";s:18:\"crs_select_starter\";s:19:\"Select Start Object\";s:23:\"crs_set_on_waiting_list\";s:154:\"You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.\";s:12:\"crs_settings\";s:15:\"Course Settings\";s:18:\"crs_settings_saved\";s:14:\"Settings saved\";s:17:\"crs_show_link_lms\";s:23:\"Show learning materials\";s:24:\"crs_show_link_objectives\";s:15:\"Show objectives\";s:16:\"crs_show_link_or\";s:20:\"Show other resources\";s:17:\"crs_show_link_tst\";s:10:\"Show tests\";s:16:\"crs_show_members\";s:12:\"Show Members\";s:21:\"crs_show_members_info\";s:97:\"If activated, course members can access the members gallery and the send mail to members feature.\";s:24:\"crs_show_objectives_view\";s:14:\"Objective view\";s:8:\"crs_size\";s:9:\"File size\";s:19:\"crs_sort_activation\";s:18:\"Sort by Activation\";s:15:\"crs_sort_manual\";s:13:\"Sort Manually\";s:20:\"crs_sort_manual_info\";s:67:\"This mode offers you the possibility to sort course items manually.\";s:20:\"crs_sort_timing_info\";s:65:\"Sort course items be their activation time or timing presettings.\";s:14:\"crs_sort_title\";s:13:\"Sort by Title\";s:19:\"crs_sort_title_info\";s:61:\"Choose this mode to sort course items automatically by title.\";s:13:\"crs_sortorder\";s:4:\"Sort\";s:17:\"crs_sortorder_abo\";s:20:\"Content Item Sorting\";s:9:\"crs_start\";s:5:\"Start\";s:17:\"crs_start_objects\";s:13:\"Start Objects\";s:19:\"crs_starter_deleted\";s:19:\"Removed assignment.\";s:29:\"crs_starters_already_assigned\";s:33:\"This object was already assigned.\";s:10:\"crs_status\";s:6:\"Status\";s:18:\"crs_status_changed\";s:22:\"Status in course \"%s\" \";s:23:\"crs_status_changed_body\";s:45:\"Your status in course \"%s\" has been changed. \";s:13:\"crs_structure\";s:16:\"Course structure\";s:15:\"crs_subscribers\";s:11:\"Subscribers\";s:23:\"crs_subscribers_deleted\";s:21:\"Deleted subscriber(s)\";s:16:\"crs_subscription\";s:12:\"Subscription\";s:28:\"crs_subscription_max_members\";s:16:\"Maximum of Users\";s:23:\"crs_subscription_notify\";s:24:\"Notify for subscriptions\";s:37:\"crs_subscription_options_confirmation\";s:18:\"Request Membership\";s:36:\"crs_subscription_options_deactivated\";s:11:\"Deactivated\";s:31:\"crs_subscription_options_direct\";s:13:\"Join Directly\";s:33:\"crs_subscription_options_password\";s:25:\"Join with Course Password\";s:26:\"crs_subscription_requested\";s:45:\"You have requested membership for the course.\";s:27:\"crs_subscription_successful\";s:26:\"You have joined the course\";s:21:\"crs_subscription_type\";s:17:\"Subscription type\";s:14:\"crs_suggest_lm\";s:30:\"Suggest learning materials if:\";s:18:\"crs_suggestion_end\";s:13:\"Suggested End\";s:33:\"crs_sure_delete_selected_archives\";s:44:\"Are you sure to delete the selected archives\";s:12:\"crs_syllabus\";s:8:\"Syllabus\";s:23:\"crs_table_start_objects\";s:13:\"Start Objects\";s:24:\"crs_test_status_complete\";s:8:\"Complete\";s:28:\"crs_test_status_not_complete\";s:12:\"Not complete\";s:22:\"crs_test_status_random\";s:11:\"Random test\";s:8:\"crs_time\";s:17:\"Subscription time\";s:32:\"crs_timings_availability_enabled\";s:21:\"Temporarily Available\";s:28:\"crs_timings_availability_tbl\";s:12:\"Availability\";s:22:\"crs_timings_changeable\";s:22:\"Time Target Changeable\";s:19:\"crs_timings_changed\";s:16:\"Timings Modified\";s:20:\"crs_timings_disabled\";s:16:\"Timings Disabled\";s:25:\"crs_timings_disabled_info\";s:42:\"Choose this option to disable any timings.\";s:20:\"crs_timings_duration\";s:8:\"Duration\";s:23:\"crs_timings_early_begin\";s:14:\"Earliest Start\";s:15:\"crs_timings_end\";s:11:\"Ending Time\";s:22:\"crs_timings_from_until\";s:12:\"(From/Until)\";s:19:\"crs_timings_in_days\";s:9:\"(In Days)\";s:23:\"crs_timings_info_active\";s:8:\"(Active)\";s:20:\"crs_timings_late_end\";s:10:\"Latest End\";s:23:\"crs_timings_not_changed\";s:20:\"Timings not Modified\";s:23:\"crs_timings_planed_info\";s:19:\"Planed Editing Time\";s:24:\"crs_timings_planed_start\";s:6:\"Planed\";s:22:\"crs_timings_presetting\";s:19:\"Time Target Enabled\";s:26:\"crs_timings_presetting_tbl\";s:11:\"Time Target\";s:24:\"crs_timings_short_active\";s:7:\"Enabled\";s:28:\"crs_timings_short_changeable\";s:10:\"Changeable\";s:33:\"crs_timings_short_limit_start_end\";s:10:\"Changeable\";s:27:\"crs_timings_short_start_end\";s:10:\"Suggestion\";s:17:\"crs_timings_start\";s:13:\"Starting Time\";s:26:\"crs_timings_start_end_info\";s:11:\"(Start/End)\";s:21:\"crs_timings_sug_begin\";s:15:\"Suggested Start\";s:19:\"crs_timings_sug_end\";s:13:\"Suggested End\";s:26:\"crs_timings_suggested_info\";s:22:\"Suggested Editing Time\";s:22:\"crs_timings_time_frame\";s:10:\"Time Frame\";s:24:\"crs_timings_update_error\";s:90:\"Your settings are not valid, please verify the timings for the following course materials:\";s:22:\"crs_timings_visibility\";s:10:\"Visibility\";s:6:\"crs_to\";s:6:\"Until:\";s:9:\"crs_tutor\";s:5:\"Tutor\";s:19:\"crs_tutor_no_notify\";s:23:\"Tutor (no notification)\";s:16:\"crs_tutor_notify\";s:20:\"Tutor (notification)\";s:10:\"crs_tutors\";s:6:\"Tutors\";s:13:\"crs_unblocked\";s:13:\"Free entrance\";s:20:\"crs_unblocked_member\";s:22:\"Status in course \"%s\" \";s:25:\"crs_unblocked_member_body\";s:49:\"Your membership in course \"%s\" has been restored \";s:13:\"crs_unlimited\";s:9:\"Unlimited\";s:15:\"crs_unsubscribe\";s:11:\"Unsubscribe\";s:20:\"crs_unsubscribe_sure\";s:43:\"Do you want to unsubscribe from this course\";s:25:\"crs_unsubscribed_from_crs\";s:43:\"You have been unsubscribed from this course\";s:20:\"crs_update_objective\";s:23:\"Edit learning objective\";s:15:\"crs_users_added\";s:24:\"Added user to the course\";s:26:\"crs_users_already_assigned\";s:43:\"The user is already assigned to this course\";s:27:\"crs_users_removed_from_list\";s:58:\"The selected users have been removed from the waiting list\";s:16:\"crs_view_archive\";s:12:\"Archive View\";s:23:\"crs_view_info_objective\";s:75:\"This presentation mode is used for the presentation of learning objectives.\";s:22:\"crs_view_info_standard\";s:88:\"This content presentation mode is similar to the presentation of the repository content.\";s:20:\"crs_view_info_timing\";s:41:\"Presentation mode for timing presettings.\";s:13:\"crs_view_mode\";s:19:\"Course Presentation\";s:18:\"crs_view_objective\";s:23:\"Objective Oriented View\";s:17:\"crs_view_standard\";s:13:\"Standard View\";s:15:\"crs_view_timing\";s:12:\"Timings View\";s:14:\"crs_visibility\";s:12:\"Availability\";s:24:\"crs_visibility_limitless\";s:9:\"Unlimited\";s:20:\"crs_visibility_until\";s:21:\"Temporarily Available\";s:24:\"crs_visibility_unvisible\";s:13:\"Not Available\";s:13:\"crs_wait_info\";s:107:\"If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.\";s:16:\"crs_waiting_list\";s:12:\"Waiting List\";s:7:\"crs_xml\";s:3:\"XML\";s:18:\"crs_youre_position\";s:33:\"Your position on the waiting list\";s:12:\"edit_content\";s:12:\"Edit Content\";s:17:\"edit_timings_list\";s:12:\"Edit Timings\";s:5:\"event\";s:7:\"Session\";s:19:\"event_add_new_event\";s:17:\"Added new session\";s:22:\"event_assign_materials\";s:16:\"Assign Materials\";s:27:\"event_assign_materials_info\";s:71:\"Assigned course materials will be displayed directly below the session.\";s:28:\"event_assign_materials_table\";s:30:\"Assignment of Course Materials\";s:13:\"event_btn_add\";s:11:\"Add Session\";s:10:\"event_date\";s:16:\"Date of Session:\";s:15:\"event_date_time\";s:11:\"Date & Time\";s:17:\"event_delete_file\";s:12:\"Delete File?\";s:17:\"event_delete_sure\";s:38:\"Do really want to delete this session?\";s:10:\"event_desc\";s:11:\"Description\";s:22:\"event_details_workflow\";s:16:\"Details/Workflow\";s:18:\"event_edit_members\";s:17:\"Edit Participants\";s:14:\"event_end_date\";s:3:\"End\";s:25:\"event_etime_smaller_stime\";s:82:\"The ending time is earlier than the starting time. Please enter a valid time span.\";s:20:\"event_existing_files\";s:15:\"Existing Files:\";s:10:\"event_file\";s:4:\"File\";s:19:\"event_file_download\";s:18:\"Files for Download\";s:15:\"event_file_name\";s:8:\"Filename\";s:20:\"event_file_size_info\";s:8:\"Filesize\";s:20:\"event_full_time_info\";s:9:\"full-time\";s:13:\"event_fullday\";s:9:\"Full-Time\";s:19:\"event_fulltime_info\";s:17:\"No Time Specified\";s:26:\"event_further_informations\";s:20:\"Further Informations\";s:19:\"event_general_infos\";s:20:\"General Informations\";s:24:\"event_general_properties\";s:20:\"General Informations\";s:14:\"event_lecturer\";s:4:\"Name\";s:14:\"event_location\";s:8:\"Location\";s:19:\"event_participation\";s:13:\"Participation\";s:14:\"event_register\";s:8:\"Register\";s:16:\"event_registered\";s:41:\"You have been registered to this session.\";s:18:\"event_registration\";s:12:\"Registration\";s:23:\"event_registration_info\";s:39:\"Allow users to register to the session.\";s:31:\"event_registration_participance\";s:12:\"Registration\";s:23:\"event_save_participants\";s:17:\"Save Participance\";s:16:\"event_start_date\";s:5:\"Start\";s:18:\"event_table_create\";s:11:\"New Session\";s:18:\"event_table_update\";s:12:\"Edit Session\";s:22:\"event_tbl_participants\";s:20:\"List of Participants\";s:22:\"event_tbl_participated\";s:12:\"Participated\";s:20:\"event_tbl_registered\";s:10:\"Registered\";s:10:\"event_time\";s:4:\"Time\";s:11:\"event_title\";s:5:\"Title\";s:16:\"event_tutor_data\";s:31:\"Informations About the Lecturer\";s:16:\"event_unregister\";s:10:\"Unregister\";s:18:\"event_unregistered\";s:27:\"You have been unregistered.\";s:13:\"event_updated\";s:14:\"Saved Settings\";s:6:\"events\";s:8:\"Sessions\";s:14:\"events_deleted\";s:15:\"Session deleted\";s:10:\"import_crs\";s:13:\"Import Course\";s:13:\"learners_view\";s:13:\"Learners view\";s:28:\"subscription_times_not_valid\";s:37:\"The registration period is not valid.\";s:19:\"timing_accept_table\";s:16:\"Timings: Remarks\";s:15:\"timing_accepted\";s:8:\"Accepted\";s:19:\"timing_not_accepted\";s:12:\"Not Accepted\";s:13:\"timing_remark\";s:6:\"Remark\";s:20:\"timing_tutor_visible\";s:35:\"Remark is visible for course tutors\";s:18:\"timing_user_accept\";s:14:\"Accept Timings\";s:20:\"timing_user_accepted\";s:16:\"Timings Accepted\";s:7:\"timings\";s:7:\"Timings\";s:12:\"timings_edit\";s:12:\"Edit Timings\";s:10:\"timings_of\";s:11:\"Timings Off\";s:15:\"timings_timings\";s:7:\"Timings\";s:19:\"timings_timings_off\";s:33:\"Switch Timings Administration Off\";s:18:\"timings_timings_on\";s:32:\"Switch Timings Administration On\";s:16:\"timings_usr_edit\";s:12:\"Edit Timings\";s:11:\"tutor_email\";s:4:\"Mail\";s:15:\"tutor_firstname\";s:9:\"Firstname\";s:14:\"tutor_lastname\";s:8:\"Lastname\";s:10:\"tutor_name\";s:4:\"Name\";s:11:\"tutor_phone\";s:5:\"Phone\";s:11:\"tutor_title\";s:5:\"Title\";s:23:\"crs_mail_permanent_link\";s:55:\"Choose the following link to access the course content:\";s:22:\"crs_grp_added_grouping\";s:32:\"Added new membership limitation.\";s:26:\"grouping_change_assignment\";s:17:\"Change Assignment\";}');
INSERT INTO `lng_modules` VALUES ('crs_','en','a:1:{s:12:\"crs_archives\";s:8:\"Archives\";}');
INSERT INTO `lng_modules` VALUES ('dateplaner','en','a:221:{s:8:\"DateText\";s:7:\"Message\";s:8:\"Day_long\";s:8:\"Day View\";s:17:\"ERROR_DATE_EXISTS\";s:26:\"This event already exists.\";s:8:\"ERROR_DB\";s:21:\"Database write error!\";s:16:\"ERROR_DB_CONNECT\";s:29:\"The database is disconnected.\";s:13:\"ERROR_DEL_MSG\";s:75:\"This is a recurring event. Would you like to delete one event or the series\";s:13:\"ERROR_ENDDATE\";s:40:\"Wrong end date input. Format: dd/mm/yyyy\";s:13:\"ERROR_ENDTIME\";s:29:\"Wrong end time. Format: hh:mm\";s:15:\"ERROR_END_START\";s:52:\"Wrong end date input. End date is before start date.\";s:18:\"ERROR_FILE_CSV_MSG\";s:29:\"Please take a valid CSV File.\";s:16:\"ERROR_JAVASCRIPT\";s:131:\"<B><CENTER>your browser doesn\'t accept JavaScript.<br />Please close this Window after insert manually.<br />Thank you</CENTER></B>\";s:17:\"ERROR_ROTATIONEND\";s:50:\"Wrong recurring end date input. Format: dd/mm/yyyy\";s:19:\"ERROR_ROT_END_START\";s:72:\"Wrong recurring end date input. Recurring end date is before start date.\";s:15:\"ERROR_SHORTTEXT\";s:47:\"Wrong short text input. Short text is required.\";s:15:\"ERROR_STARTDATE\";s:42:\"Wrong start date input. Format: dd/mm/yyyy\";s:15:\"ERROR_STARTTIME\";s:31:\"Wrong start time. Format: hh:mm\";s:8:\"ERROR_TS\";s:21:\"Incorrect date format\";s:7:\"Fr_long\";s:6:\"Friday\";s:8:\"Fr_short\";s:2:\"Fr\";s:13:\"Language_file\";s:7:\"English\";s:12:\"Listbox_long\";s:14:\"List of Events\";s:7:\"Mo_long\";s:6:\"Monday\";s:8:\"Mo_short\";s:2:\"Mo\";s:10:\"Month_long\";s:10:\"Month View\";s:7:\"Sa_long\";s:8:\"Saturday\";s:8:\"Sa_short\";s:2:\"Sa\";s:7:\"Su_long\";s:6:\"Sunday\";s:8:\"Su_short\";s:2:\"Su\";s:4:\"Text\";s:4:\"Text\";s:7:\"Th_long\";s:8:\"Thursday\";s:8:\"Th_short\";s:2:\"Th\";s:7:\"Tu_long\";s:7:\"Tuesday\";s:8:\"Tu_short\";s:2:\"Tu\";s:4:\"View\";s:5:\"View:\";s:7:\"We_long\";s:9:\"Wednesday\";s:8:\"We_short\";s:2:\"We\";s:9:\"Week_long\";s:9:\"Week View\";s:8:\"add_data\";s:15:\"Additional Data\";s:4:\"app_\";s:18:\"Group Events Inbox\";s:8:\"app_date\";s:12:\"Create Event\";s:7:\"app_day\";s:8:\"Day View\";s:12:\"app_freetime\";s:47:\"Free time of other group members (catch a time)\";s:9:\"app_inbox\";s:18:\"Group Events Inbox\";s:8:\"app_list\";s:14:\"List of Events\";s:9:\"app_month\";s:10:\"Month View\";s:14:\"app_properties\";s:10:\"Properties\";s:8:\"app_week\";s:9:\"Week View\";s:11:\"application\";s:8:\"Calendar\";s:5:\"apply\";s:5:\"Apply\";s:4:\"back\";s:4:\"Back\";s:10:\"begin_date\";s:10:\"Begin Date\";s:8:\"busytime\";s:18:\"Busy time in group\";s:6:\"c_date\";s:12:\"Create Event\";s:8:\"changeTo\";s:10:\"Change to:\";s:12:\"changedDates\";s:14:\"Changed Events\";s:16:\"checkforfreetime\";s:19:\"Check for free time\";s:7:\"created\";s:7:\"Created\";s:4:\"date\";s:4:\"Date\";s:11:\"date_format\";s:9:\"m/d/Y H:i\";s:18:\"date_format_middle\";s:5:\"m/d/y\";s:7:\"del_all\";s:17:\"Delete all events\";s:7:\"del_one\";s:16:\"Delete one event\";s:6:\"delete\";s:6:\"Delete\";s:12:\"deletedDates\";s:14:\"Deleted Events\";s:7:\"discard\";s:7:\"Discard\";s:12:\"dv_Grouptime\";s:9:\"Free time\";s:16:\"dv_button_cancel\";s:6:\"Cancel\";s:16:\"dv_button_delete\";s:6:\"Delete\";s:16:\"dv_button_insert\";s:6:\"Insert\";s:16:\"dv_button_update\";s:6:\"Update\";s:13:\"dv_date_begin\";s:11:\"Start Date:\";s:11:\"dv_date_end\";s:9:\"End Date:\";s:10:\"dv_date_hm\";s:11:\"Hour:Minute\";s:10:\"dv_enddate\";s:9:\"End date:\";s:14:\"dv_groupselect\";s:13:\"Group select:\";s:12:\"dv_groupview\";s:12:\"Group event:\";s:17:\"dv_groupview_text\";s:12:\"Group:<br />\";s:11:\"dv_keywords\";s:9:\"Keywords:\";s:16:\"dv_keywordselect\";s:15:\"Keyword select:\";s:10:\"dv_message\";s:8:\"Message:\";s:10:\"dv_noGroup\";s:8:\"no Group\";s:8:\"dv_noKey\";s:10:\"no Keyword\";s:10:\"dv_preview\";s:18:\"<b>! Preview !</b>\";s:11:\"dv_rotation\";s:11:\"Recurrence:\";s:16:\"dv_rotation_date\";s:16:\"Recurrence date:\";s:15:\"dv_rotation_end\";s:15:\"Recurrence end:\";s:12:\"dv_shorttext\";s:11:\"Short text:\";s:12:\"dv_startdate\";s:11:\"Start date:\";s:7:\"dv_text\";s:5:\"Text:\";s:12:\"dv_whole_day\";s:10:\"Whole day:\";s:17:\"dv_whole_rotation\";s:74:\"Would you like to delete the entire recurring series? (click the checkbox)\";s:8:\"end_date\";s:8:\"End Date\";s:16:\"endtime_for_view\";s:18:\"End time for view:\";s:17:\"error_minical_img\";s:31:\"Cannot create GD-picture-stream\";s:7:\"execute\";s:15:\"Execute choices\";s:11:\"extra_dates\";s:14:\"One Day Events\";s:4:\"free\";s:4:\"Free\";s:8:\"freetime\";s:18:\"Free Time in group\";s:5:\"group\";s:5:\"Group\";s:8:\"help_day\";s:17:\"Calendar Day View\";s:10:\"help_day_l\";s:57:\"In the day view all events of a chosen day are displayed.\";s:12:\"help_enddate\";s:29:\"End date - syntax[dd/mm/yyyy]\";s:14:\"help_enddate_l\";s:109:\"Contains the end time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.\";s:16:\"help_endrotation\";s:27:\"End time syntax[dd/mm/yyyy]\";s:18:\"help_endrotation_l\";s:109:\"At this day the repetition will end.<br />The symbol opens a small calendar for choosing the appropriate date\";s:12:\"help_endtime\";s:39:\"End time - syntax[hh/mm] 24-hour format\";s:14:\"help_endtime_l\";s:62:\"Contains the end time of the appointment using 24-hour format.\";s:13:\"help_filename\";s:15:\"dp_help_en.html\";s:12:\"help_fullday\";s:32:\"Whole day event - syntax[on/off]\";s:14:\"help_fullday_l\";s:127:\"If the event stretches over a whole day, please choose this option.<br />This will hide the start time, end time, and end date.\";s:12:\"help_further\";s:48:\"<br /><b>click here for further information.</b>\";s:10:\"help_group\";s:22:\"Group events selection\";s:12:\"help_group_l\";s:193:\"Contains the groups for which the logged-in user has administrator rights and for which a date can be created.<br />After choosing this it is possible to view the unscheduled time of the group.\";s:10:\"help_inbox\";s:14:\"Calendar Inbox\";s:12:\"help_inbox_l\";s:62:\"Here all new, changed, and deleted group events are displayed.\";s:12:\"help_keyword\";s:17:\"Keyword selection\";s:15:\"help_keywordUse\";s:17:\"Keyword selection\";s:17:\"help_keywordUse_l\";s:106:\"Choose one or more keywords from the dialog box.<br />TIP: use the CTRL key for selecting several entries.\";s:14:\"help_keyword_l\";s:58:\"Contains the keywords which a user can associate to dates.\";s:9:\"help_list\";s:19:\"Calendar event list\";s:11:\"help_list_l\";s:70:\"In the event list, all events of a given period of time are displayed.\";s:10:\"help_month\";s:19:\"Calendar month view\";s:12:\"help_month_l\";s:60:\"In the month view all events of a given month are displayed.\";s:19:\"help_properties_alt\";s:19:\"Changes the keyword\";s:21:\"help_properties_alt_l\";s:111:\"Choose a keyword from the dialog box.<br />Change the keyword in the text field. Important: max. 20 characters.\";s:19:\"help_properties_del\";s:19:\"Deletes the keyword\";s:21:\"help_properties_del_l\";s:77:\"Choose a keyword from the dialog box. Click the button to delete the keyword.\";s:22:\"help_properties_import\";s:27:\"Import of Outlook-CSV-Files\";s:24:\"help_properties_import_l\";s:112:\"Here a CSC-File can be selected, which contains Outlook-Events. These events will be imported into the calendar.\";s:19:\"help_properties_new\";s:33:\"Add a keyword, max. 20 characters\";s:21:\"help_properties_new_l\";s:71:\"Add a new keyword to the field \\\"new\\\". Important: max. 20 characters. \";s:20:\"help_properties_time\";s:35:\"Display time for day view/week view\";s:22:\"help_properties_time_l\";s:213:\"The standard display time for the day view and week view can be changed. If dates are outside of the display time for a given days or week, the display time will be changed for that time span. Standard is 8h -18h.\";s:13:\"help_rotation\";s:10:\"Recurrence\";s:15:\"help_rotation_l\";s:49:\"Contains the type of the recurrence / repetition.\";s:14:\"help_shorttext\";s:30:\"Short text, max. 50 characters\";s:16:\"help_shorttext_l\";s:51:\"Here one can enter the short text for a given date.\";s:14:\"help_startdate\";s:31:\"Start date - syntax[dd/mm/yyyy]\";s:16:\"help_startdate_l\";s:114:\"Contains the starting time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.\";s:14:\"help_starttime\";s:41:\"Start time - syntax[hh/mm] 24-hour format\";s:16:\"help_starttime_l\";s:61:\"Contains the starting time of the event using 24-hour format.\";s:9:\"help_text\";s:4:\"Text\";s:11:\"help_text_l\";s:46:\"Here one can enter the text for a given event.\";s:9:\"help_week\";s:18:\"Calendar week view\";s:11:\"help_week_l\";s:58:\"In the week view all events of a given week are displayed.\";s:4:\"hour\";s:4:\"hour\";s:11:\"importDates\";s:24:\"Import of Outlook Events\";s:5:\"inbox\";s:5:\"Inbox\";s:17:\"insertImportDates\";s:42:\"These events were successfully registered:\";s:10:\"k_alldates\";s:10:\"All Events\";s:4:\"keep\";s:4:\"Keep\";s:7:\"keyword\";s:7:\"Keyword\";s:8:\"keywords\";s:8:\"Keywords\";s:11:\"last_change\";s:12:\"Last changed\";s:7:\"long_01\";s:7:\"January\";s:7:\"long_02\";s:8:\"February\";s:7:\"long_03\";s:5:\"March\";s:7:\"long_04\";s:5:\"April\";s:7:\"long_05\";s:3:\"May\";s:7:\"long_06\";s:4:\"June\";s:7:\"long_07\";s:4:\"July\";s:7:\"long_08\";s:6:\"August\";s:7:\"long_09\";s:9:\"September\";s:7:\"long_10\";s:7:\"October\";s:7:\"long_11\";s:8:\"November\";s:7:\"long_12\";s:8:\"December\";s:10:\"main_dates\";s:11:\"Main Events\";s:5:\"menue\";s:4:\"Menu\";s:6:\"mmonth\";s:10:\"Last Month\";s:5:\"month\";s:5:\"Month\";s:4:\"more\";s:4:\"More\";s:5:\"mweek\";s:9:\"Last Week\";s:6:\"myeahr\";s:9:\"Last Year\";s:8:\"newDates\";s:10:\"New Events\";s:10:\"newKeyword\";s:4:\"New:\";s:7:\"new_doc\";s:16:\"Create new event\";s:8:\"no_entry\";s:19:\"No events available\";s:10:\"o_day_date\";s:13:\"24-hour event\";s:2:\"of\";s:2:\"of\";s:8:\"open_day\";s:8:\"Day View\";s:6:\"pmonth\";s:10:\"Next Month\";s:9:\"printlist\";s:5:\"Print\";s:10:\"properties\";s:10:\"Properties\";s:5:\"pweek\";s:9:\"Next Week\";s:5:\"pyear\";s:9:\"Next Year\";s:4:\"r_14\";s:13:\"Every 14 days\";s:9:\"r_4_weeks\";s:13:\"Every 4 weeks\";s:5:\"r_day\";s:9:\"Every day\";s:10:\"r_halfyear\";s:15:\"Every half year\";s:7:\"r_month\";s:11:\"Every month\";s:14:\"r_nonrecurring\";s:4:\"Once\";s:6:\"r_week\";s:10:\"Every week\";s:6:\"r_year\";s:10:\"Every year\";s:14:\"readimportfile\";s:6:\"Insert\";s:8:\"rotation\";s:10:\"Recurrence\";s:14:\"rotation_dates\";s:17:\"Recurrence events\";s:13:\"semester_name\";s:13:\"Semester Name\";s:8:\"short_01\";s:3:\"Jan\";s:8:\"short_02\";s:3:\"Feb\";s:8:\"short_03\";s:3:\"Mar\";s:8:\"short_04\";s:3:\"Apr\";s:8:\"short_05\";s:3:\"May\";s:8:\"short_06\";s:3:\"Jun\";s:8:\"short_07\";s:3:\"Jul\";s:8:\"short_08\";s:3:\"Aug\";s:8:\"short_09\";s:3:\"Sep\";s:8:\"short_10\";s:3:\"Oct\";s:8:\"short_11\";s:3:\"Nov\";s:8:\"short_12\";s:3:\"Dec\";s:9:\"shorttext\";s:10:\"Short Text\";s:10:\"singleDate\";s:12:\"Single Event\";s:18:\"starttime_for_view\";s:20:\"Start time for view:\";s:8:\"timedate\";s:11:\"Time / Date\";s:9:\"timeslice\";s:5:\"Time:\";s:5:\"title\";s:14:\"ILIAS calendar\";s:2:\"to\";s:2:\"to\";s:5:\"today\";s:5:\"Today\";s:8:\"viewlist\";s:4:\"View\";s:4:\"week\";s:4:\"Week\";s:8:\"wk_short\";s:2:\"WK\";s:4:\"year\";s:4:\"Year\";}');
INSERT INTO `lng_modules` VALUES ('forum','en','a:64:{s:15:\"forum_anonymize\";s:17:\"Write anonymously\";s:20:\"forum_anonymize_desc\";s:78:\"Write this message anonymously (your ILIAS user name won\'t be shown anywhere).\";s:6:\"forums\";s:6:\"Forums\";s:30:\"forums_all_threads_marked_read\";s:36:\"All threads have been marked as read\";s:18:\"forums_attachments\";s:11:\"Attachments\";s:22:\"forums_attachments_add\";s:14:\"Add attachment\";s:23:\"forums_attachments_edit\";s:15:\"Edit attachment\";s:16:\"forums_available\";s:16:\"Available Forums\";s:21:\"forums_censor_comment\";s:17:\"Comment of Censor\";s:12:\"forums_count\";s:16:\"Number of Forums\";s:16:\"forums_count_art\";s:18:\"Number of Articles\";s:16:\"forums_count_thr\";s:17:\"Number of Threads\";s:17:\"forums_created_by\";s:10:\"Created by\";s:18:\"forums_delete_file\";s:17:\"Delete attachment\";s:27:\"forums_disable_notification\";s:20:\"Disable notification\";s:26:\"forums_download_attachment\";s:13:\"Download file\";s:16:\"forums_edit_post\";s:12:\"Edit Article\";s:26:\"forums_enable_notification\";s:19:\"Enable notification\";s:24:\"forums_info_censor2_post\";s:18:\"Revoke Censorship?\";s:23:\"forums_info_censor_post\";s:43:\"Are you sure you want to hide this article?\";s:23:\"forums_info_delete_post\";s:69:\"Are you sure you want to delete this article including any responses?\";s:16:\"forums_mark_read\";s:13:\"Mark all read\";s:18:\"forums_new_entries\";s:18:\"New Forums Entries\";s:17:\"forums_new_thread\";s:9:\"New Topic\";s:20:\"forums_not_available\";s:20:\"Forums Not Available\";s:19:\"forums_notification\";s:12:\"Notification\";s:27:\"forums_notification_enabled\";s:20:\"Notification enabled\";s:25:\"forums_notification_intro\";s:74:\"This e-mail was automatically sent to you by the ILIAS installation %s, %s\";s:31:\"forums_notification_is_disabled\";s:70:\"Your notification about new posts in this thread is not (yet) enabled.\";s:30:\"forums_notification_is_enabled\";s:82:\"At the moment your notification about new posts in this thread is already enabled.\";s:29:\"forums_notification_show_post\";s:13:\"Show post: %s\";s:27:\"forums_notification_subject\";s:25:\"New post in a forum topic\";s:15:\"forums_overview\";s:15:\"Forums Overview\";s:19:\"forums_post_deleted\";s:24:\"Article has been deleted\";s:20:\"forums_post_modified\";s:25:\"Article has been modified\";s:21:\"forums_post_new_entry\";s:28:\"New article has been created\";s:12:\"forums_posts\";s:12:\"All articles\";s:26:\"forums_posts_not_available\";s:22:\"Articles Not Available\";s:19:\"forums_print_thread\";s:12:\"Print Thread\";s:17:\"forums_print_view\";s:10:\"Print view\";s:12:\"forums_quote\";s:5:\"Quote\";s:14:\"forums_respond\";s:10:\"Post Reply\";s:14:\"forums_subject\";s:7:\"Subject\";s:15:\"forums_the_post\";s:7:\"Article\";s:13:\"forums_thread\";s:5:\"Topic\";s:22:\"forums_thread_articles\";s:21:\"Articles of the topic\";s:25:\"forums_thread_create_date\";s:10:\"Created at\";s:25:\"forums_thread_create_from\";s:12:\"Created from\";s:20:\"forums_thread_marked\";s:35:\"The Thread has been marked as read.\";s:23:\"forums_thread_new_entry\";s:26:\"New topic has been created\";s:28:\"forums_threads_not_available\";s:20:\"Topics Not Available\";s:22:\"forums_topics_overview\";s:15:\"Topics Overview\";s:17:\"forums_your_reply\";s:10:\"Your Reply\";s:21:\"frm_anonymous_posting\";s:17:\"Anonymous posting\";s:26:\"frm_anonymous_posting_desc\";s:59:\"If enabled, anonymous posting is allowed within this forum.\";s:16:\"frm_default_view\";s:12:\"Default view\";s:40:\"frm_statistics_disabled_for_participants\";s:42:\"Statistics are disabled for forum members.\";s:22:\"frm_statistics_enabled\";s:17:\"Enable Statistics\";s:27:\"frm_statistics_enabled_desc\";s:46:\"Enable Posting Statistics for all participants\";s:22:\"frm_statistics_ranking\";s:7:\"Ranking\";s:18:\"frm_title_required\";s:22:\"Please insert a title.\";s:7:\"is_read\";s:9:\"mark read\";s:8:\"new_post\";s:8:\"New post\";s:6:\"thread\";s:5:\"Topic\";}');
INSERT INTO `lng_modules` VALUES ('grp','en','a:12:{s:26:\"grp_registration_unlimited\";s:29:\"Unlimited registration period\";s:16:\"crs_add_grouping\";s:25:\"Add Membership Limitation\";s:19:\"crs_grp_enter_title\";s:36:\"Please fill out all required fields.\";s:22:\"crs_grp_added_grouping\";s:32:\"Added new membership limitation.\";s:24:\"crs_grouping_delete_sure\";s:60:\"Are you sure you want to delete this membership limitation ?\";s:20:\"crs_grouping_deleted\";s:30:\"Deleted membership limitation.\";s:30:\"crs_grp_table_assigned_courses\";s:15:\"Assigned Groups\";s:26:\"grouping_change_assignment\";s:17:\"Change Assignment\";s:18:\"crs_grp_assign_crs\";s:20:\"Assignment of Groups\";s:27:\"crs_grp_no_courses_assigned\";s:18:\"No Groups Assigned\";s:23:\"crs_grouping_select_one\";s:40:\"Please select one membership limitation.\";s:16:\"crs_grp_info_reg\";s:44:\"You can only register to one of this groups:\";}');
INSERT INTO `lng_modules` VALUES ('ilinc','en','a:13:{s:13:\"akclassvalue1\";s:13:\"Cost center 1\";s:13:\"akclassvalue2\";s:13:\"Cost center 2\";s:13:\"akclassvalues\";s:12:\"Cost centers\";s:18:\"ilinc_akuservalue1\";s:13:\"Cost center 1\";s:18:\"ilinc_akuservalue2\";s:13:\"Cost center 2\";s:18:\"ilinc_akuservalues\";s:12:\"Cost centers\";s:23:\"ilinc_akuservalues_desc\";s:105:\"Enter here the code of the cost center(s) for this user. These values will be stored at the iLinc server.\";s:28:\"ilinc_akuservalues_refreshed\";s:20:\"Cost centers updated\";s:22:\"ilinc_connection_error\";s:37:\"Error: No connection to iLinc Server!\";s:20:\"ilinc_no_account_yet\";s:20:\"No iLinc Account yet\";s:16:\"ilinc_user_added\";s:36:\"User account created on iLinc server\";s:13:\"ilinc_user_id\";s:12:\"iLinc UserID\";s:19:\"ilinc_user_settings\";s:19:\"iLinc User settings\";}');
INSERT INTO `lng_modules` VALUES ('jscalendar','en','a:58:{s:14:\"about_calendar\";s:18:\"About the calendar\";s:19:\"about_calendar_long\";s:370:\"DHTML Date/Time Selector\\n(c) dynarch.com 2002-2003\\nFor latest version visit: http://dynarch.com/mishoo/calendar.epl\\nDistributed under GNU LGPL.  See http://gnu.org/licenses/lgpl.html for details.\\n\\nDate selection:\\n- Use the «, » buttons to select year\\n- Use the <, > buttons to select month\\n- Hold mouse button on any of the above buttons for faster selection. \";s:10:\"about_time\";s:145:\"\\n\\nTime selection:\\n- Click on any of the time parts to increase it\\n- or Shift-click to decrease it\\n- or click and drag for faster selection. \";s:5:\"close\";s:5:\"Close\";s:9:\"day_first\";s:16:\"Display %s first\";s:15:\"def_date_format\";s:8:\"%Y-%m-%d\";s:12:\"drag_to_move\";s:12:\"Drag to move\";s:8:\"go_today\";s:8:\"Go Today\";s:4:\"l_01\";s:7:\"January\";s:4:\"l_02\";s:8:\"Feburary\";s:4:\"l_03\";s:5:\"March\";s:4:\"l_04\";s:5:\"April\";s:4:\"l_05\";s:3:\"May\";s:4:\"l_06\";s:4:\"June\";s:4:\"l_07\";s:4:\"July\";s:4:\"l_08\";s:6:\"August\";s:4:\"l_09\";s:9:\"September\";s:4:\"l_10\";s:7:\"October\";s:4:\"l_11\";s:8:\"November\";s:4:\"l_12\";s:8:\"December\";s:4:\"l_fr\";s:6:\"Friday\";s:4:\"l_mo\";s:6:\"Monday\";s:4:\"l_sa\";s:8:\"Saturday\";s:4:\"l_su\";s:6:\"Sunday\";s:4:\"l_th\";s:8:\"Thursday\";s:4:\"l_tu\";s:7:\"Tuesday\";s:4:\"l_we\";s:9:\"Wednesday\";s:10:\"next_month\";s:26:\"Next month (hold for menu)\";s:9:\"next_year\";s:25:\"Next year (hold for menu)\";s:13:\"open_calendar\";s:71:\"Click here to open a calendar for date selection (JavaScript required!)\";s:10:\"part_today\";s:8:\" (today)\";s:10:\"prev_month\";s:27:\"Prev. month (hold for menu)\";s:9:\"prev_year\";s:26:\"Prev. year (hold for menu)\";s:4:\"s_01\";s:3:\"Jan\";s:4:\"s_02\";s:3:\"Feb\";s:4:\"s_03\";s:3:\"Mar\";s:4:\"s_04\";s:3:\"Apr\";s:4:\"s_05\";s:3:\"May\";s:4:\"s_06\";s:3:\"Jun\";s:4:\"s_07\";s:3:\"Jul\";s:4:\"s_08\";s:3:\"Aug\";s:4:\"s_09\";s:3:\"Sep\";s:4:\"s_10\";s:3:\"Oct\";s:4:\"s_11\";s:3:\"Nov\";s:4:\"s_12\";s:3:\"Dec\";s:4:\"s_fr\";s:2:\"Fr\";s:4:\"s_mo\";s:2:\"Mo\";s:4:\"s_sa\";s:2:\"Sa\";s:4:\"s_su\";s:2:\"Su\";s:4:\"s_th\";s:2:\"Th\";s:4:\"s_tu\";s:2:\"Tu\";s:4:\"s_we\";s:2:\"We\";s:11:\"select_date\";s:11:\"Select date\";s:4:\"time\";s:4:\"Time\";s:9:\"time_part\";s:37:\"(Shift-)Click or drag to change value\";s:5:\"today\";s:5:\"Today\";s:14:\"tt_date_format\";s:9:\"%a, %b %e\";s:2:\"wk\";s:2:\"wk\";}');
INSERT INTO `lng_modules` VALUES ('mail','en','a:95:{s:13:\"also_as_email\";s:13:\"Also as Email\";s:2:\"bc\";s:3:\"BCC\";s:7:\"forward\";s:7:\"Forward\";s:9:\"linebreak\";s:10:\"Line break\";s:17:\"mail_account_mail\";s:12:\"Account Mail\";s:23:\"mail_account_mail_check\";s:17:\"Send Account Mail\";s:18:\"mail_add_recipient\";s:24:\"Please enter a recipient\";s:18:\"mail_add_subfolder\";s:13:\"Add Subfolder\";s:16:\"mail_add_subject\";s:22:\"Please enter a subject\";s:23:\"mail_add_to_addressbook\";s:19:\"Add to address book\";s:13:\"mail_add_type\";s:44:\"Please add the type of mail you want to send\";s:17:\"mail_addr_entries\";s:7:\"Entries\";s:16:\"mail_attachments\";s:11:\"Attachments\";s:17:\"mail_bc_not_valid\";s:30:\"The BCC recipient is not valid\";s:14:\"mail_bc_search\";s:10:\"BCC search\";s:9:\"mail_byte\";s:4:\"Byte\";s:17:\"mail_cc_not_valid\";s:29:\"The CC recipient is not valid\";s:14:\"mail_cc_search\";s:9:\"CC search\";s:21:\"mail_change_to_folder\";s:17:\"Switch to folder:\";s:26:\"mail_check_your_email_addr\";s:31:\"Your email address is not valid\";s:12:\"mail_compose\";s:15:\"Compose Message\";s:12:\"mail_deleted\";s:19:\"The mail is deleted\";s:18:\"mail_deleted_entry\";s:23:\"The entries are deleted\";s:20:\"mail_email_forbidden\";s:33:\"You are not allowed to send email\";s:30:\"mail_enter_login_or_email_addr\";s:50:\"Please enter a valid login name or e-mail address.\";s:27:\"mail_enter_valid_email_addr\";s:36:\"Please enter a valid e-mail address.\";s:22:\"mail_enter_valid_login\";s:32:\"Please enter a valid login name.\";s:16:\"mail_entry_added\";s:15:\"Added new Entry\";s:18:\"mail_entry_changed\";s:20:\"The entry is changed\";s:17:\"mail_entry_exists\";s:68:\"An entry with the given login name or e-mail address already exists.\";s:14:\"mail_file_name\";s:9:\"File name\";s:14:\"mail_file_size\";s:9:\"File size\";s:18:\"mail_files_deleted\";s:23:\"The file(s) are deleted\";s:19:\"mail_folder_created\";s:29:\"A new folder has been created\";s:19:\"mail_folder_deleted\";s:27:\"The folder has been deleted\";s:18:\"mail_folder_exists\";s:38:\"A folder already exists with this name\";s:16:\"mail_folder_name\";s:11:\"Folder name\";s:24:\"mail_folder_name_changed\";s:27:\"The folder has been renamed\";s:19:\"mail_folder_options\";s:14:\"Folder Options\";s:28:\"mail_following_rcp_not_valid\";s:39:\"The following recipients are not valid:\";s:19:\"mail_global_options\";s:14:\"Global options\";s:13:\"mail_incoming\";s:13:\"Incoming mail\";s:18:\"mail_incoming_both\";s:20:\"local and forwarding\";s:19:\"mail_incoming_local\";s:10:\"only local\";s:18:\"mail_incoming_smtp\";s:24:\"forward to email address\";s:23:\"mail_insert_folder_name\";s:27:\"Please insert a folder name\";s:17:\"mail_insert_query\";s:21:\"Please insert a query\";s:11:\"mail_intern\";s:8:\"Internal\";s:14:\"mail_mark_read\";s:14:\"Mark mail read\";s:16:\"mail_mark_unread\";s:16:\"Mark mail unread\";s:29:\"mail_maxsize_attachment_error\";s:20:\"The upload limit is:\";s:17:\"mail_message_send\";s:12:\"Message sent\";s:15:\"mail_move_error\";s:17:\"Error moving mail\";s:12:\"mail_move_to\";s:8:\"Move to:\";s:10:\"mail_moved\";s:23:\"The mail has been moved\";s:19:\"mail_moved_to_trash\";s:28:\"Mail has been moved to trash\";s:20:\"mail_nacc_admin_mail\";s:32:\"E-Mail address of Administrator.\";s:21:\"mail_nacc_client_name\";s:12:\"Client Name.\";s:19:\"mail_nacc_ilias_url\";s:20:\"URL of ILIAS system.\";s:15:\"mail_nacc_login\";s:14:\"Login Account.\";s:21:\"mail_nacc_no_pw_block\";s:94:\"This text block is only included, if the new user account has been created without a password.\";s:18:\"mail_nacc_pw_block\";s:96:\"This text block is only included, if the new user account has been created including a password.\";s:20:\"mail_nacc_salutation\";s:11:\"Salutation.\";s:16:\"mail_nacc_target\";s:78:\"URL of target item, e.g. a linked course that is passed to ILIAS from outside.\";s:22:\"mail_nacc_target_block\";s:57:\"This text is only included, if a target item is provided.\";s:22:\"mail_nacc_target_title\";s:40:\"Title of target item, e.g. course title.\";s:21:\"mail_nacc_target_type\";s:53:\"Type of target item, e.g. \"Course\" for a course item.\";s:25:\"mail_nacc_use_placeholder\";s:38:\"The following placeholders may be used\";s:13:\"mail_new_file\";s:13:\"Add new file:\";s:22:\"mail_no_attach_allowed\";s:54:\"System messages are not allowed to contain attachments\";s:25:\"mail_no_attachments_found\";s:20:\"No attachments found\";s:30:\"mail_no_permissions_write_smtp\";s:45:\"You have no permission to write external mail\";s:15:\"mail_options_of\";s:7:\"Options\";s:18:\"mail_options_saved\";s:13:\"Options saved\";s:24:\"mail_recipient_not_valid\";s:26:\"The recipient is not valid\";s:6:\"mail_s\";s:4:\"Mail\";s:13:\"mail_s_unread\";s:11:\"Unread Mail\";s:22:\"mail_salutation_female\";s:18:\"Salutation, female\";s:23:\"mail_salutation_general\";s:19:\"Salutation, general\";s:20:\"mail_salutation_male\";s:16:\"Salutation, male\";s:10:\"mail_saved\";s:26:\"The message has been saved\";s:23:\"mail_search_addressbook\";s:22:\"search in address book\";s:18:\"mail_search_system\";s:16:\"search in system\";s:21:\"mail_select_one_entry\";s:25:\"You must select one entry\";s:20:\"mail_select_one_file\";s:24:\"You must select one file\";s:29:\"mail_send_with_system_address\";s:24:\"Send With System Address\";s:16:\"mail_sure_delete\";s:43:\"Are sure you want to delete the marked mail\";s:22:\"mail_sure_delete_entry\";s:49:\"Are sure you want to delete the following entries\";s:21:\"mail_sure_delete_file\";s:36:\"The file will be removed permanently\";s:23:\"mail_sure_delete_folder\";s:55:\"The folder and its contents will be removed permanently\";s:7:\"mail_to\";s:2:\"To\";s:14:\"mail_to_search\";s:9:\"To search\";s:22:\"mail_user_addr_n_valid\";s:43:\"Following users have no valid email address\";s:19:\"search_bc_recipient\";s:20:\"Search BCC Recipient\";s:19:\"search_cc_recipient\";s:19:\"Search CC Recipient\";}');
INSERT INTO `lng_modules` VALUES ('meta','en','a:548:{s:7:\"md_days\";s:5:\"Days:\";s:9:\"md_months\";s:6:\"Month:\";s:7:\"md_time\";s:5:\"Time:\";s:31:\"meta_accessibility_restrictions\";s:26:\"Accessibility Restrictions\";s:11:\"meta_active\";s:6:\"Active\";s:8:\"meta_add\";s:3:\"Add\";s:15:\"meta_annotation\";s:10:\"Annotation\";s:11:\"meta_atomic\";s:6:\"Atomic\";s:11:\"meta_author\";s:6:\"Author\";s:12:\"meta_browser\";s:7:\"Browser\";s:9:\"meta_c_AD\";s:7:\"Andorra\";s:9:\"meta_c_AE\";s:20:\"United Arab Emirates\";s:9:\"meta_c_AF\";s:11:\"Afghanistan\";s:9:\"meta_c_AG\";s:19:\"Antigua And Barbuda\";s:9:\"meta_c_AI\";s:8:\"Anguilla\";s:9:\"meta_c_AL\";s:7:\"Albania\";s:9:\"meta_c_AM\";s:7:\"Armenia\";s:9:\"meta_c_AN\";s:20:\"Netherlands Antilles\";s:9:\"meta_c_AO\";s:6:\"Angola\";s:9:\"meta_c_AQ\";s:10:\"Antarctica\";s:9:\"meta_c_AR\";s:9:\"Argentina\";s:9:\"meta_c_AS\";s:14:\"American Samoa\";s:9:\"meta_c_AT\";s:7:\"Austria\";s:9:\"meta_c_AU\";s:9:\"Australia\";s:9:\"meta_c_AW\";s:5:\"Aruba\";s:9:\"meta_c_AZ\";s:10:\"Azerbaijan\";s:9:\"meta_c_BA\";s:22:\"Bosnia And Herzegowina\";s:9:\"meta_c_BB\";s:8:\"Barbados\";s:9:\"meta_c_BD\";s:10:\"Bangladesh\";s:9:\"meta_c_BE\";s:7:\"Belgium\";s:9:\"meta_c_BF\";s:12:\"Burkina Faso\";s:9:\"meta_c_BG\";s:8:\"Bulgaria\";s:9:\"meta_c_BH\";s:7:\"Bahrain\";s:9:\"meta_c_BI\";s:7:\"Burundi\";s:9:\"meta_c_BJ\";s:5:\"Benin\";s:9:\"meta_c_BM\";s:7:\"Bermuda\";s:9:\"meta_c_BN\";s:17:\"Brunei Darussalam\";s:9:\"meta_c_BO\";s:7:\"Bolivia\";s:9:\"meta_c_BR\";s:6:\"Brazil\";s:9:\"meta_c_BS\";s:7:\"Bahamas\";s:9:\"meta_c_BT\";s:6:\"Bhutan\";s:9:\"meta_c_BV\";s:13:\"Bouvet Island\";s:9:\"meta_c_BW\";s:8:\"Botswana\";s:9:\"meta_c_BY\";s:7:\"Belarus\";s:9:\"meta_c_BZ\";s:6:\"Belize\";s:9:\"meta_c_CA\";s:6:\"Canada\";s:9:\"meta_c_CC\";s:23:\"Cocos (Keeling) Islands\";s:9:\"meta_c_CF\";s:24:\"Central African Republic\";s:9:\"meta_c_CG\";s:5:\"Congo\";s:9:\"meta_c_CH\";s:11:\"Switzerland\";s:9:\"meta_c_CI\";s:14:\"Cote D\' Ivoire\";s:9:\"meta_c_CK\";s:12:\"Cook Islands\";s:9:\"meta_c_CL\";s:5:\"Chile\";s:9:\"meta_c_CM\";s:8:\"Cameroon\";s:9:\"meta_c_CN\";s:5:\"China\";s:9:\"meta_c_CO\";s:8:\"Colombia\";s:9:\"meta_c_CR\";s:10:\"Costa Rica\";s:9:\"meta_c_CU\";s:4:\"Cuba\";s:9:\"meta_c_CV\";s:10:\"Cape Verde\";s:9:\"meta_c_CX\";s:16:\"Christmas Island\";s:9:\"meta_c_CY\";s:6:\"Cyprus\";s:9:\"meta_c_CZ\";s:14:\"Czech Republic\";s:9:\"meta_c_DE\";s:7:\"Germany\";s:9:\"meta_c_DJ\";s:8:\"Djibouti\";s:9:\"meta_c_DK\";s:7:\"Denmark\";s:9:\"meta_c_DM\";s:8:\"Dominica\";s:9:\"meta_c_DO\";s:18:\"Dominican Republic\";s:9:\"meta_c_DZ\";s:7:\"Algeria\";s:9:\"meta_c_EC\";s:7:\"Ecuador\";s:9:\"meta_c_EE\";s:7:\"Estonia\";s:9:\"meta_c_EG\";s:5:\"Egypt\";s:9:\"meta_c_EH\";s:14:\"Western Sahara\";s:9:\"meta_c_ER\";s:7:\"Eritrea\";s:9:\"meta_c_ES\";s:5:\"Spain\";s:9:\"meta_c_ET\";s:8:\"Ethiopia\";s:9:\"meta_c_FI\";s:7:\"Finland\";s:9:\"meta_c_FJ\";s:4:\"Fiji\";s:9:\"meta_c_FK\";s:16:\"Falkland Islands\";s:9:\"meta_c_FM\";s:10:\"Micronesia\";s:9:\"meta_c_FO\";s:13:\"Faroe Islands\";s:9:\"meta_c_FR\";s:6:\"France\";s:9:\"meta_c_FX\";s:20:\"France, Metropolitan\";s:9:\"meta_c_GA\";s:5:\"Gabon\";s:9:\"meta_c_GB\";s:14:\"United Kingdom\";s:9:\"meta_c_GD\";s:7:\"Grenada\";s:9:\"meta_c_GE\";s:7:\"Giorgia\";s:9:\"meta_c_GF\";s:13:\"French Guiana\";s:9:\"meta_c_GH\";s:5:\"Ghana\";s:9:\"meta_c_GI\";s:9:\"Gibraltar\";s:9:\"meta_c_GL\";s:9:\"Greenland\";s:9:\"meta_c_GM\";s:6:\"Gambia\";s:9:\"meta_c_GN\";s:6:\"Guinea\";s:9:\"meta_c_GP\";s:10:\"Guadeloupe\";s:9:\"meta_c_GQ\";s:17:\"Equatorial Guinea\";s:9:\"meta_c_GR\";s:6:\"Greece\";s:9:\"meta_c_GS\";s:44:\"South Georgia And The South Sandwich Islands\";s:9:\"meta_c_GT\";s:9:\"Guatemala\";s:9:\"meta_c_GU\";s:4:\"Guam\";s:9:\"meta_c_GW\";s:13:\"Guinea-Bissau\";s:9:\"meta_c_GY\";s:6:\"Guyana\";s:9:\"meta_c_HM\";s:27:\"Heard And Nc Donald Islands\";s:9:\"meta_c_HN\";s:8:\"Honduras\";s:9:\"meta_c_HR\";s:7:\"Croatia\";s:9:\"meta_c_HT\";s:5:\"Haiti\";s:9:\"meta_c_HU\";s:7:\"Hungary\";s:9:\"meta_c_ID\";s:9:\"Indonesia\";s:9:\"meta_c_IE\";s:7:\"Ireland\";s:9:\"meta_c_IL\";s:6:\"Israel\";s:9:\"meta_c_IN\";s:5:\"India\";s:9:\"meta_c_IO\";s:30:\"British Indian Ocean Territory\";s:9:\"meta_c_IQ\";s:4:\"Iraq\";s:9:\"meta_c_IR\";s:4:\"Iran\";s:9:\"meta_c_IS\";s:7:\"Iceland\";s:9:\"meta_c_IT\";s:5:\"Italy\";s:9:\"meta_c_JM\";s:7:\"Jamaica\";s:9:\"meta_c_JO\";s:6:\"Jordan\";s:9:\"meta_c_JP\";s:5:\"Japan\";s:9:\"meta_c_KE\";s:5:\"Kenya\";s:9:\"meta_c_KG\";s:10:\"Kyrgyzstan\";s:9:\"meta_c_KH\";s:8:\"Cambodia\";s:9:\"meta_c_KI\";s:8:\"Kiribati\";s:9:\"meta_c_KM\";s:7:\"Comoros\";s:9:\"meta_c_KN\";s:21:\"Saint Kitts And Nevis\";s:9:\"meta_c_KP\";s:40:\"North Korea (People\'s Republic Of Korea)\";s:9:\"meta_c_KR\";s:31:\"South Korea (Republic Of Korea)\";s:9:\"meta_c_KW\";s:6:\"Kuwait\";s:9:\"meta_c_KY\";s:14:\"Cayman Islands\";s:9:\"meta_c_KZ\";s:10:\"Kazakhstan\";s:9:\"meta_c_LA\";s:21:\"Lao People\'s Republic\";s:9:\"meta_c_LB\";s:7:\"Lebanon\";s:9:\"meta_c_LC\";s:11:\"Saint Lucia\";s:9:\"meta_c_LI\";s:13:\"Liechtenstein\";s:9:\"meta_c_LK\";s:9:\"Sri Lanka\";s:9:\"meta_c_LR\";s:7:\"Liberia\";s:9:\"meta_c_LS\";s:7:\"Lesotho\";s:9:\"meta_c_LT\";s:8:\"Lithunia\";s:9:\"meta_c_LU\";s:10:\"Luxembourg\";s:9:\"meta_c_LV\";s:6:\"Latvia\";s:9:\"meta_c_LY\";s:22:\"Libyan Arab Jamahiriya\";s:9:\"meta_c_MA\";s:7:\"Morocco\";s:9:\"meta_c_MC\";s:6:\"Monaco\";s:9:\"meta_c_MD\";s:7:\"Moldova\";s:9:\"meta_c_MG\";s:10:\"Madagascar\";s:9:\"meta_c_MH\";s:16:\"Marshall Islands\";s:9:\"meta_c_MK\";s:9:\"Macedonia\";s:9:\"meta_c_ML\";s:4:\"Mali\";s:9:\"meta_c_MM\";s:7:\"Myanmar\";s:9:\"meta_c_MN\";s:8:\"Mongolia\";s:9:\"meta_c_MO\";s:5:\"Macau\";s:9:\"meta_c_MP\";s:24:\"Northern Mariana Islands\";s:9:\"meta_c_MQ\";s:10:\"Martinique\";s:9:\"meta_c_MR\";s:10:\"Mauritania\";s:9:\"meta_c_MS\";s:10:\"Montserrat\";s:9:\"meta_c_MT\";s:5:\"Malta\";s:9:\"meta_c_MU\";s:9:\"Mauritius\";s:9:\"meta_c_MV\";s:8:\"Maldives\";s:9:\"meta_c_MW\";s:6:\"Malawi\";s:9:\"meta_c_MX\";s:6:\"Mexico\";s:9:\"meta_c_MY\";s:8:\"Malaysia\";s:9:\"meta_c_MZ\";s:10:\"Mozambique\";s:9:\"meta_c_NA\";s:7:\"Namibia\";s:9:\"meta_c_NC\";s:13:\"New Caledonia\";s:9:\"meta_c_NE\";s:5:\"Niger\";s:9:\"meta_c_NF\";s:14:\"Norfolk Island\";s:9:\"meta_c_NG\";s:7:\"Nigeria\";s:9:\"meta_c_NI\";s:9:\"Nicaragua\";s:9:\"meta_c_NL\";s:11:\"Netherlands\";s:9:\"meta_c_NO\";s:6:\"Norway\";s:9:\"meta_c_NP\";s:5:\"Nepal\";s:9:\"meta_c_NR\";s:5:\"Nauru\";s:9:\"meta_c_NU\";s:4:\"Niue\";s:9:\"meta_c_NZ\";s:11:\"New Zealand\";s:9:\"meta_c_OM\";s:4:\"Oman\";s:9:\"meta_c_PA\";s:6:\"Panama\";s:9:\"meta_c_PE\";s:4:\"Peru\";s:9:\"meta_c_PF\";s:16:\"French Polynesia\";s:9:\"meta_c_PG\";s:16:\"Papua New Guinea\";s:9:\"meta_c_PH\";s:11:\"Philippines\";s:9:\"meta_c_PK\";s:8:\"Pakistan\";s:9:\"meta_c_PL\";s:6:\"Poland\";s:9:\"meta_c_PM\";s:23:\"St. Pierre And Miquelon\";s:9:\"meta_c_PN\";s:8:\"Pitcairn\";s:9:\"meta_c_PR\";s:11:\"Puerto Rico\";s:9:\"meta_c_PT\";s:8:\"Portugal\";s:9:\"meta_c_PW\";s:5:\"Palau\";s:9:\"meta_c_PY\";s:8:\"Paraguay\";s:9:\"meta_c_QA\";s:5:\"Qatar\";s:9:\"meta_c_RE\";s:7:\"Reunion\";s:9:\"meta_c_RO\";s:7:\"Romania\";s:9:\"meta_c_RU\";s:14:\"Ran Federation\";s:9:\"meta_c_RW\";s:6:\"Rwanda\";s:9:\"meta_c_SA\";s:12:\"Saudi Arabia\";s:9:\"meta_c_SB\";s:15:\"Solomon Islands\";s:9:\"meta_c_SC\";s:10:\"Seychelles\";s:9:\"meta_c_SD\";s:5:\"Sudan\";s:9:\"meta_c_SE\";s:6:\"Sweden\";s:9:\"meta_c_SG\";s:9:\"Singapore\";s:9:\"meta_c_SH\";s:10:\"St. Helena\";s:9:\"meta_c_SI\";s:8:\"Slovenia\";s:9:\"meta_c_SJ\";s:30:\"Svalbard And Jan Mayen Islands\";s:9:\"meta_c_SK\";s:8:\"Slovakia\";s:9:\"meta_c_SL\";s:13:\"Siearra Leone\";s:9:\"meta_c_SM\";s:10:\"San Marino\";s:9:\"meta_c_SN\";s:7:\"Senegal\";s:9:\"meta_c_SO\";s:7:\"Somalia\";s:9:\"meta_c_SR\";s:8:\"Suriname\";s:9:\"meta_c_ST\";s:21:\"Sao Tome And Principe\";s:9:\"meta_c_SV\";s:11:\"El Salvador\";s:9:\"meta_c_SY\";s:20:\"Syrian Arab Republic\";s:9:\"meta_c_SZ\";s:9:\"Swaziland\";s:9:\"meta_c_TC\";s:24:\"Turks And Caicos Islands\";s:9:\"meta_c_TD\";s:4:\"Chad\";s:9:\"meta_c_TF\";s:27:\"French Southern Territories\";s:9:\"meta_c_TG\";s:4:\"Togo\";s:9:\"meta_c_TH\";s:8:\"Thailand\";s:9:\"meta_c_TJ\";s:10:\"Tajikistan\";s:9:\"meta_c_TK\";s:7:\"Tokelau\";s:9:\"meta_c_TM\";s:12:\"Turkmenistan\";s:9:\"meta_c_TN\";s:7:\"Tunisia\";s:9:\"meta_c_TO\";s:5:\"Tonga\";s:9:\"meta_c_TP\";s:10:\"East Timor\";s:9:\"meta_c_TR\";s:6:\"Turkey\";s:9:\"meta_c_TT\";s:19:\"Trinidad And Tobago\";s:9:\"meta_c_TV\";s:6:\"Tuvalu\";s:9:\"meta_c_TW\";s:6:\"Taiwan\";s:9:\"meta_c_TZ\";s:8:\"Tanzania\";s:9:\"meta_c_UA\";s:7:\"Ukraine\";s:9:\"meta_c_UG\";s:6:\"Uganda\";s:9:\"meta_c_UM\";s:27:\"U.S. Minor Outlying Islands\";s:9:\"meta_c_US\";s:5:\"U.S.A\";s:9:\"meta_c_UY\";s:7:\"Uruguay\";s:9:\"meta_c_UZ\";s:10:\"Uzbekistan\";s:9:\"meta_c_VA\";s:18:\"Vatican City State\";s:9:\"meta_c_VC\";s:32:\"Saint Vincent And The Grenadines\";s:9:\"meta_c_VE\";s:9:\"Venezuela\";s:9:\"meta_c_VG\";s:24:\"Virgin Islands (British)\";s:9:\"meta_c_VI\";s:19:\"Virgin Islands (US)\";s:9:\"meta_c_VN\";s:8:\"Viet Nam\";s:9:\"meta_c_VU\";s:7:\"Vanuatu\";s:9:\"meta_c_WF\";s:25:\"Wallis And Futuna Islands\";s:9:\"meta_c_WS\";s:5:\"Samoa\";s:9:\"meta_c_YE\";s:5:\"Yemen\";s:9:\"meta_c_YT\";s:7:\"Mayotte\";s:9:\"meta_c_ZA\";s:12:\"South Africa\";s:9:\"meta_c_ZM\";s:6:\"Zambia\";s:9:\"meta_c_ZR\";s:5:\"Zaire\";s:9:\"meta_c_ZW\";s:8:\"Zimbabwe\";s:9:\"meta_c_ZZ\";s:13:\"Other Country\";s:12:\"meta_catalog\";s:7:\"Catalog\";s:19:\"meta_choose_element\";s:41:\"Please choose an element you want to add!\";s:20:\"meta_choose_language\";s:24:\"Please choose a language\";s:19:\"meta_choose_section\";s:23:\"Please choose a section\";s:19:\"meta_classification\";s:14:\"Classification\";s:15:\"meta_collection\";s:10:\"Collection\";s:15:\"meta_competency\";s:10:\"Competency\";s:20:\"meta_contentprovider\";s:16:\"Content provider\";s:12:\"meta_context\";s:7:\"Context\";s:15:\"meta_contribute\";s:10:\"Contribute\";s:14:\"meta_copyright\";s:9:\"Copyright\";s:37:\"meta_copyright_and_other_restrictions\";s:32:\"Copyright and Other Restrictions\";s:9:\"meta_cost\";s:4:\"Cost\";s:13:\"meta_coverage\";s:8:\"Coverage\";s:12:\"meta_creator\";s:7:\"Creator\";s:18:\"meta_current_value\";s:13:\"Current value\";s:9:\"meta_date\";s:4:\"Date\";s:11:\"meta_delete\";s:6:\"Delete\";s:16:\"meta_description\";s:11:\"Description\";s:13:\"meta_diagramm\";s:7:\"Diagram\";s:14:\"meta_difficult\";s:9:\"Difficult\";s:15:\"meta_difficulty\";s:10:\"Difficulty\";s:10:\"meta_draft\";s:5:\"Draft\";s:13:\"meta_duration\";s:8:\"Duration\";s:9:\"meta_easy\";s:4:\"Easy\";s:11:\"meta_editor\";s:6:\"Editor\";s:14:\"meta_education\";s:9:\"Education\";s:16:\"meta_educational\";s:11:\"Educational\";s:22:\"meta_educational_level\";s:17:\"Educational Level\";s:26:\"meta_educational_objective\";s:21:\"Educational Objective\";s:25:\"meta_educationalvalidator\";s:21:\"Educational validator\";s:11:\"meta_entity\";s:6:\"Entity\";s:10:\"meta_entry\";s:5:\"Entry\";s:9:\"meta_exam\";s:4:\"Exam\";s:13:\"meta_exercise\";s:8:\"Exercise\";s:15:\"meta_experiment\";s:10:\"Experiment\";s:15:\"meta_expositive\";s:10:\"Expositive\";s:11:\"meta_figure\";s:6:\"Figure\";s:10:\"meta_final\";s:5:\"Final\";s:11:\"meta_format\";s:6:\"Format\";s:12:\"meta_general\";s:7:\"General\";s:10:\"meta_graph\";s:5:\"Graph\";s:22:\"meta_graphicaldesigner\";s:18:\"Graphical designer\";s:15:\"meta_has_format\";s:10:\"Has Format\";s:13:\"meta_has_part\";s:8:\"Has Part\";s:16:\"meta_has_version\";s:11:\"Has Version\";s:17:\"meta_hierarchical\";s:12:\"Hierarchical\";s:9:\"meta_high\";s:4:\"High\";s:21:\"meta_higher_education\";s:16:\"Higher Education\";s:7:\"meta_id\";s:2:\"Id\";s:9:\"meta_idea\";s:4:\"Idea\";s:15:\"meta_identifier\";s:10:\"Identifier\";s:10:\"meta_index\";s:5:\"Index\";s:23:\"meta_info_tlt_not_valid\";s:176:\"The current value is not valid. Therefore it can not be used other sections, e.g for learning progress statistics. Please insert atypical learning time in hours and/or minutes.\";s:14:\"meta_initiator\";s:9:\"Initiator\";s:25:\"meta_installation_remarks\";s:20:\"Installation Remarks\";s:27:\"meta_instructional_designer\";s:22:\"Instructional designer\";s:26:\"meta_instructionaldesigner\";s:22:\"Instructional designer\";s:27:\"meta_intended_end_user_role\";s:22:\"Intended End User Role\";s:24:\"meta_interactivity_level\";s:19:\"Interactivity Level\";s:23:\"meta_interactivity_type\";s:18:\"Interactivity Type\";s:16:\"meta_is_based_on\";s:11:\"Is Based On\";s:17:\"meta_is_basis_for\";s:12:\"Is Basis For\";s:17:\"meta_is_format_of\";s:12:\"Is Format Of\";s:15:\"meta_is_part_of\";s:10:\"Is Part Of\";s:21:\"meta_is_referenced_by\";s:16:\"Is Referenced By\";s:19:\"meta_is_required_by\";s:14:\"Is Required By\";s:18:\"meta_is_version_of\";s:13:\"Is Version Of\";s:12:\"meta_keyword\";s:7:\"Keyword\";s:9:\"meta_kind\";s:4:\"Kind\";s:9:\"meta_l_aa\";s:4:\"Afar\";s:9:\"meta_l_ab\";s:9:\"Abkhazian\";s:9:\"meta_l_af\";s:9:\"Afrikaans\";s:9:\"meta_l_am\";s:7:\"Amharic\";s:9:\"meta_l_ar\";s:6:\"Arabic\";s:9:\"meta_l_as\";s:8:\"Assamese\";s:9:\"meta_l_ay\";s:6:\"Aymara\";s:9:\"meta_l_az\";s:11:\"Azerbaijani\";s:9:\"meta_l_ba\";s:7:\"Bashkir\";s:9:\"meta_l_be\";s:12:\"Byelorussian\";s:9:\"meta_l_bg\";s:9:\"Bulgarian\";s:9:\"meta_l_bh\";s:6:\"Bihari\";s:9:\"meta_l_bi\";s:7:\"Bislama\";s:9:\"meta_l_bn\";s:14:\"Bengali;bangla\";s:9:\"meta_l_bo\";s:7:\"Tibetan\";s:9:\"meta_l_br\";s:6:\"Breton\";s:9:\"meta_l_ca\";s:7:\"Catalan\";s:9:\"meta_l_co\";s:8:\"Corsican\";s:9:\"meta_l_cs\";s:5:\"Czech\";s:9:\"meta_l_cy\";s:5:\"Welsh\";s:9:\"meta_l_da\";s:6:\"Danish\";s:9:\"meta_l_de\";s:6:\"German\";s:9:\"meta_l_dz\";s:7:\"Bhutani\";s:9:\"meta_l_el\";s:5:\"Greek\";s:9:\"meta_l_en\";s:7:\"English\";s:9:\"meta_l_eo\";s:9:\"Esperanto\";s:9:\"meta_l_es\";s:7:\"Spanish\";s:9:\"meta_l_et\";s:8:\"Estonian\";s:9:\"meta_l_eu\";s:6:\"Basque\";s:9:\"meta_l_fa\";s:15:\"Persian (farsi)\";s:9:\"meta_l_fi\";s:7:\"Finnish\";s:9:\"meta_l_fj\";s:4:\"Fiji\";s:9:\"meta_l_fo\";s:7:\"Faroese\";s:9:\"meta_l_fr\";s:6:\"French\";s:9:\"meta_l_fy\";s:7:\"Frisian\";s:9:\"meta_l_ga\";s:5:\"Irish\";s:9:\"meta_l_gd\";s:12:\"Scots gaelic\";s:9:\"meta_l_gl\";s:8:\"Galician\";s:9:\"meta_l_gn\";s:7:\"Guarani\";s:9:\"meta_l_gu\";s:8:\"Gujarati\";s:9:\"meta_l_ha\";s:5:\"Hausa\";s:9:\"meta_l_he\";s:6:\"Hebrew\";s:9:\"meta_l_hi\";s:5:\"Hindi\";s:9:\"meta_l_hr\";s:8:\"Croatian\";s:9:\"meta_l_hu\";s:9:\"Hungarian\";s:9:\"meta_l_hy\";s:8:\"Armenian\";s:9:\"meta_l_ia\";s:11:\"Interlingua\";s:9:\"meta_l_id\";s:10:\"Indonesian\";s:9:\"meta_l_ie\";s:11:\"Interlingue\";s:9:\"meta_l_ik\";s:7:\"Inupiak\";s:9:\"meta_l_is\";s:9:\"Icelandic\";s:9:\"meta_l_it\";s:7:\"Italian\";s:9:\"meta_l_iu\";s:9:\"Inuktitut\";s:9:\"meta_l_ja\";s:8:\"Japanese\";s:9:\"meta_l_jv\";s:8:\"Javanese\";s:9:\"meta_l_ka\";s:8:\"Georgian\";s:9:\"meta_l_kk\";s:6:\"Kazakh\";s:9:\"meta_l_kl\";s:11:\"Greenlandic\";s:9:\"meta_l_km\";s:9:\"Cambodian\";s:9:\"meta_l_kn\";s:7:\"Kannada\";s:9:\"meta_l_ko\";s:6:\"Korean\";s:9:\"meta_l_ks\";s:8:\"Kashmiri\";s:9:\"meta_l_ku\";s:7:\"Kurdish\";s:9:\"meta_l_ky\";s:7:\"Kirghiz\";s:9:\"meta_l_la\";s:5:\"Latin\";s:9:\"meta_l_ln\";s:7:\"Lingala\";s:9:\"meta_l_lo\";s:8:\"Laothian\";s:9:\"meta_l_lt\";s:10:\"Lithuanian\";s:9:\"meta_l_lv\";s:15:\"Latvian;lettish\";s:9:\"meta_l_mg\";s:8:\"Malagasy\";s:9:\"meta_l_mi\";s:5:\"Maori\";s:9:\"meta_l_mk\";s:10:\"Macedonian\";s:9:\"meta_l_ml\";s:9:\"Malayalam\";s:9:\"meta_l_mn\";s:9:\"Mongolian\";s:9:\"meta_l_mo\";s:9:\"Moldavian\";s:9:\"meta_l_mr\";s:7:\"Marathi\";s:9:\"meta_l_ms\";s:5:\"Malay\";s:9:\"meta_l_mt\";s:7:\"Maltese\";s:9:\"meta_l_my\";s:7:\"Burmese\";s:9:\"meta_l_na\";s:5:\"Nauru\";s:9:\"meta_l_ne\";s:6:\"Nepali\";s:9:\"meta_l_nl\";s:5:\"Dutch\";s:9:\"meta_l_no\";s:9:\"Norwegian\";s:9:\"meta_l_oc\";s:7:\"Occitan\";s:9:\"meta_l_om\";s:12:\"Afan (oromo)\";s:9:\"meta_l_or\";s:5:\"Oriya\";s:9:\"meta_l_pa\";s:7:\"Punjabi\";s:9:\"meta_l_pl\";s:6:\"Polish\";s:9:\"meta_l_ps\";s:13:\"Pashto;pushto\";s:9:\"meta_l_pt\";s:10:\"Portuguese\";s:9:\"meta_l_qu\";s:7:\"Quechua\";s:9:\"meta_l_rm\";s:14:\"Rhaeto-romance\";s:9:\"meta_l_rn\";s:7:\"Kurundi\";s:9:\"meta_l_ro\";s:8:\"Romanian\";s:9:\"meta_l_ru\";s:7:\"Russian\";s:9:\"meta_l_rw\";s:11:\"Kinyarwanda\";s:9:\"meta_l_sa\";s:8:\"Sanskrit\";s:9:\"meta_l_sd\";s:6:\"Sindhi\";s:9:\"meta_l_sg\";s:6:\"Sangho\";s:9:\"meta_l_sh\";s:14:\"Serbo-croatian\";s:9:\"meta_l_si\";s:10:\"Singhalese\";s:9:\"meta_l_sk\";s:6:\"Slovak\";s:9:\"meta_l_sl\";s:9:\"Slovenian\";s:9:\"meta_l_sm\";s:6:\"Samoan\";s:9:\"meta_l_sn\";s:5:\"Shona\";s:9:\"meta_l_so\";s:6:\"Somali\";s:9:\"meta_l_sq\";s:8:\"Albanian\";s:9:\"meta_l_sr\";s:7:\"Serbian\";s:9:\"meta_l_ss\";s:7:\"Siswati\";s:9:\"meta_l_st\";s:7:\"Sesotho\";s:9:\"meta_l_su\";s:9:\"Sundanese\";s:9:\"meta_l_sv\";s:7:\"Swedish\";s:9:\"meta_l_sw\";s:7:\"Swahili\";s:9:\"meta_l_ta\";s:5:\"Tamil\";s:9:\"meta_l_te\";s:6:\"Telugu\";s:9:\"meta_l_tg\";s:5:\"Tajik\";s:9:\"meta_l_th\";s:4:\"Thai\";s:9:\"meta_l_ti\";s:8:\"Tigrinya\";s:9:\"meta_l_tk\";s:7:\"Turkmen\";s:9:\"meta_l_tl\";s:7:\"Tagalog\";s:9:\"meta_l_tn\";s:8:\"Setswana\";s:9:\"meta_l_to\";s:5:\"Tonga\";s:9:\"meta_l_tr\";s:7:\"Turkish\";s:9:\"meta_l_ts\";s:6:\"Tsonga\";s:9:\"meta_l_tt\";s:5:\"Tatar\";s:9:\"meta_l_tw\";s:3:\"Twi\";s:9:\"meta_l_ug\";s:5:\"Uigur\";s:9:\"meta_l_uk\";s:9:\"Ukrainian\";s:9:\"meta_l_ur\";s:4:\"Urdu\";s:9:\"meta_l_uz\";s:5:\"Uzbek\";s:9:\"meta_l_vi\";s:10:\"Vietnamese\";s:9:\"meta_l_vo\";s:7:\"Volapuk\";s:9:\"meta_l_wo\";s:5:\"Wolof\";s:9:\"meta_l_xh\";s:5:\"Xhosa\";s:9:\"meta_l_yi\";s:7:\"Yiddish\";s:9:\"meta_l_yo\";s:6:\"Yoruba\";s:9:\"meta_l_za\";s:6:\"Zhuang\";s:9:\"meta_l_zh\";s:7:\"Chinese\";s:9:\"meta_l_zu\";s:4:\"Zulu\";s:13:\"meta_language\";s:8:\"Language\";s:12:\"meta_learner\";s:7:\"Learner\";s:27:\"meta_learning_resource_type\";s:22:\"Learning Resource Type\";s:12:\"meta_lecture\";s:7:\"Lecture\";s:14:\"meta_lifecycle\";s:9:\"Lifecycle\";s:11:\"meta_linear\";s:6:\"Linear\";s:15:\"meta_local_file\";s:10:\"Local File\";s:13:\"meta_location\";s:8:\"Location\";s:8:\"meta_low\";s:3:\"Low\";s:11:\"meta_mac_os\";s:5:\"MacOS\";s:12:\"meta_manager\";s:7:\"Manager\";s:20:\"meta_maximum_version\";s:15:\"Maximum Version\";s:11:\"meta_medium\";s:6:\"Medium\";s:18:\"meta_meta_metadata\";s:13:\"Meta-Metadata\";s:19:\"meta_metadatascheme\";s:15:\"Metadata Scheme\";s:20:\"meta_minimum_version\";s:15:\"Minimum Version\";s:10:\"meta_mixed\";s:5:\"Mixed\";s:15:\"meta_ms_windows\";s:10:\"MS-Windows\";s:13:\"meta_multi_os\";s:8:\"Multi-OS\";s:9:\"meta_name\";s:4:\"Name\";s:19:\"meta_narrative_text\";s:14:\"Narrative Text\";s:14:\"meta_networked\";s:9:\"Networked\";s:16:\"meta_new_element\";s:11:\"New Element\";s:7:\"meta_no\";s:2:\"No\";s:18:\"meta_no_annotation\";s:49:\"No metadata available for the Annotation section.\";s:22:\"meta_no_classification\";s:53:\"No metadata available for the Classification section.\";s:19:\"meta_no_educational\";s:46:\"No metadata available for Educational section.\";s:17:\"meta_no_lifecycle\";s:44:\"No metadata available for Lifecycle section.\";s:21:\"meta_no_meta_metadata\";s:48:\"No metadata available for Meta-Metadata section.\";s:16:\"meta_no_relation\";s:47:\"No metadata available for the Relation section.\";s:14:\"meta_no_rights\";s:45:\"No metadata available for the Rights section.\";s:17:\"meta_no_technical\";s:44:\"No metadata available for Technical section.\";s:9:\"meta_none\";s:4:\"None\";s:21:\"meta_operating_system\";s:16:\"Operating System\";s:17:\"meta_or_composite\";s:12:\"Or Composite\";s:10:\"meta_other\";s:5:\"Other\";s:33:\"meta_other_plattform_requirements\";s:27:\"Other Platform Requirements\";s:11:\"meta_pc_dos\";s:6:\"PC-DOS\";s:18:\"meta_please_select\";s:13:\"Please select\";s:17:\"meta_prerequisite\";s:12:\"Prerequisite\";s:22:\"meta_problem_statement\";s:17:\"Problem Statement\";s:14:\"meta_publisher\";s:9:\"Publisher\";s:12:\"meta_purpose\";s:7:\"Purpose\";s:18:\"meta_questionnaire\";s:13:\"Questionnaire\";s:14:\"meta_quickedit\";s:10:\"Quick Edit\";s:14:\"meta_reference\";s:9:\"Reference\";s:15:\"meta_references\";s:10:\"References\";s:13:\"meta_relation\";s:8:\"Relation\";s:16:\"meta_requirement\";s:11:\"Requirement\";s:13:\"meta_requires\";s:8:\"Requires\";s:13:\"meta_resource\";s:8:\"Resource\";s:12:\"meta_revised\";s:7:\"Revised\";s:11:\"meta_rights\";s:6:\"Rights\";s:9:\"meta_role\";s:4:\"Role\";s:11:\"meta_school\";s:6:\"School\";s:17:\"meta_scriptwriter\";s:12:\"Scriptwriter\";s:19:\"meta_security_level\";s:14:\"Security Level\";s:20:\"meta_self_assessment\";s:15:\"Self Assessment\";s:21:\"meta_semantic_density\";s:16:\"Semantic Density\";s:15:\"meta_simulation\";s:10:\"Simulation\";s:9:\"meta_size\";s:4:\"Size\";s:16:\"meta_skill_level\";s:11:\"Skill Level\";s:10:\"meta_slide\";s:5:\"Slide\";s:11:\"meta_source\";s:6:\"Source\";s:11:\"meta_status\";s:6:\"Status\";s:14:\"meta_structure\";s:9:\"Structure\";s:24:\"meta_subjectmatterexpert\";s:21:\"Subject matter expert\";s:10:\"meta_table\";s:5:\"Table\";s:10:\"meta_taxon\";s:5:\"Taxon\";s:15:\"meta_taxon_path\";s:10:\"Taxon Path\";s:12:\"meta_teacher\";s:7:\"Teacher\";s:14:\"meta_technical\";s:9:\"Technical\";s:25:\"meta_technicalimplementer\";s:21:\"Technical implementer\";s:23:\"meta_technicalvalidator\";s:19:\"Technical validator\";s:15:\"meta_terminator\";s:10:\"Terminator\";s:10:\"meta_title\";s:5:\"Title\";s:13:\"meta_training\";s:8:\"Training\";s:9:\"meta_type\";s:4:\"Type\";s:22:\"meta_typical_age_range\";s:17:\"Typical Age Range\";s:26:\"meta_typical_learning_time\";s:21:\"Typical Learning Time\";s:16:\"meta_unavailable\";s:11:\"Unavailable\";s:9:\"meta_unix\";s:4:\"Unix\";s:12:\"meta_unknown\";s:7:\"Unknown\";s:14:\"meta_validator\";s:9:\"Validator\";s:10:\"meta_value\";s:5:\"Value\";s:12:\"meta_version\";s:7:\"Version\";s:19:\"meta_very_difficult\";s:14:\"Very Difficult\";s:14:\"meta_very_easy\";s:9:\"Very Easy\";s:14:\"meta_very_high\";s:9:\"Very High\";s:13:\"meta_very_low\";s:8:\"Very Low\";s:8:\"meta_yes\";s:3:\"Yes\";}');
INSERT INTO `lng_modules` VALUES ('payment','en','a:231:{s:13:\"currency_cent\";s:4:\"Cent\";s:13:\"currency_euro\";s:4:\"Euro\";s:8:\"duration\";s:8:\"Duration\";s:12:\"excel_export\";s:12:\"Excel export\";s:4:\"info\";s:33:\"Informations about the pay method\";s:24:\"pay_add_to_shopping_cart\";s:20:\"Add to shopping cart\";s:26:\"pay_added_to_shopping_cart\";s:28:\"Added item to shopping cart.\";s:7:\"pay_all\";s:3:\"All\";s:11:\"pay_article\";s:7:\"Article\";s:13:\"pay_bank_data\";s:9:\"Bank data\";s:11:\"pay_bill_no\";s:11:\"Incoice no.\";s:22:\"pay_bmf_account_holder\";s:14:\"Account holder\";s:22:\"pay_bmf_account_number\";s:14:\"Account number\";s:12:\"pay_bmf_back\";s:4:\"back\";s:17:\"pay_bmf_bank_code\";s:9:\"Bank code\";s:19:\"pay_bmf_card_holder\";s:11:\"Card holder\";s:19:\"pay_bmf_card_number\";s:11:\"Card number\";s:20:\"pay_bmf_check_number\";s:12:\"Check number\";s:30:\"pay_bmf_check_terms_conditions\";s:71:\"Please confirm that you\'ve read the terms and conditions and accept it.\";s:19:\"pay_bmf_credit_card\";s:11:\"Credit card\";s:24:\"pay_bmf_credit_card_data\";s:11:\"Credit card\";s:29:\"pay_bmf_credit_card_not_valid\";s:111:\"The credit card data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly. \";s:19:\"pay_bmf_debit_entry\";s:39:\"Debit entry (german bank accounts only)\";s:24:\"pay_bmf_debit_entry_data\";s:11:\"Debit entry\";s:29:\"pay_bmf_debit_entry_not_valid\";s:111:\"The debit entry data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly. \";s:31:\"pay_bmf_description_credit_card\";s:250:\"Please check out whether all articles you would like to order are in the shopping cart. By filling in your credit card data and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds. \";s:31:\"pay_bmf_description_debit_entry\";s:258:\"Please check out whether all articles you would like to order are in the shopping cart. By filling in your data for the debit entry and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds. \";s:32:\"pay_bmf_description_payment_type\";s:25:\"Please select how to pay.\";s:33:\"pay_bmf_description_personal_data\";s:46:\"Please fill out the following form completely.\";s:20:\"pay_bmf_house_number\";s:12:\"House number\";s:16:\"pay_bmf_optional\";s:8:\"optional\";s:10:\"pay_bmf_or\";s:2:\"or\";s:26:\"pay_bmf_password_not_valid\";s:27:\"Your password wasn\'t valid.\";s:20:\"pay_bmf_payment_type\";s:14:\"Kind of paying\";s:30:\"pay_bmf_payment_type_not_valid\";s:76:\"The kind of paying you\'ve choosen isn\'t valid. Please select another option.\";s:21:\"pay_bmf_personal_data\";s:18:\"Your personal data\";s:31:\"pay_bmf_personal_data_not_valid\";s:93:\"Your personal data isn\'t valid. Please check out whether all fields are filled out correctly.\";s:21:\"pay_bmf_please_select\";s:13:\"Please select\";s:14:\"pay_bmf_po_box\";s:6:\"PO Box\";s:25:\"pay_bmf_server_error_code\";s:33:\"Payment server returns error code\";s:34:\"pay_bmf_server_error_communication\";s:46:\"Error while communictaion with payment server.\";s:29:\"pay_bmf_server_error_sysadmin\";s:60:\"Please contact system administrator for further information.\";s:27:\"pay_bmf_shopping_cart_empty\";s:28:\"Your shopping card is empty.\";s:23:\"pay_bmf_street_or_pobox\";s:47:\"Please enter street and house number or po box.\";s:24:\"pay_bmf_terms_conditions\";s:28:\"General terms and conditions\";s:29:\"pay_bmf_terms_conditions_read\";s:57:\"I\'ve read the general terms and conditions and accept it.\";s:29:\"pay_bmf_terms_conditions_show\";s:4:\"show\";s:14:\"pay_bmf_thanks\";s:36:\"Thank you. Your order was submitted.\";s:20:\"pay_bmf_total_amount\";s:12:\"Total amount\";s:16:\"pay_bmf_validity\";s:11:\"valid until\";s:20:\"pay_bmf_vat_included\";s:12:\"VAT included\";s:18:\"pay_bmf_your_order\";s:10:\"Your order\";s:16:\"pay_change_price\";s:33:\"Change price/duration combination\";s:16:\"pay_click_to_buy\";s:7:\"Buy now\";s:17:\"pay_confirm_order\";s:52:\"Please confirm your order by entering your password.\";s:15:\"pay_customer_no\";s:12:\"Customer no.\";s:19:\"pay_deleted_booking\";s:27:\"The entry has been deleted.\";s:17:\"pay_deleted_items\";s:37:\"The selected items have been deleted.\";s:10:\"pay_ending\";s:9:\"ends with\";s:21:\"pay_entitled_retrieve\";s:29:\"Entitled to retrieve data for\";s:16:\"pay_expires_info\";s:76:\"This object is disposable. The payment has been expired, you can not buy it.\";s:10:\"pay_filter\";s:6:\"Filter\";s:22:\"pay_goto_buyed_objects\";s:23:\"Goto your buyed objects\";s:22:\"pay_goto_shopping_cart\";s:22:\"Goto the shopping cart\";s:10:\"pay_header\";s:7:\"Payment\";s:15:\"pay_hint_paypal\";s:15:\"Hint for PayPal\";s:8:\"pay_info\";s:310:\"Access to the following material is not for free. If you want to gain access to a certain learning object please select a price. You can purchase one or several learning objects by using the button \"shopping cart\" on your personal desktop.  You are going to gain immediate access to a chosen object and period.\";s:15:\"pay_info_paypal\";s:401:\"To pay for those objects that are in your shopping cart you\'ll leave ILIAS temporary and head for the PayPal website. Please follow the steps that are shown to you there. After paying successfully you\'ll be directed back to ILIAS automatically. Don\'t close the window of your browser at any time whilst the selling process. Otherwise the objects you\'ve bought can\'t be activated for you automatically.\";s:22:\"pay_item_already_in_sc\";s:49:\"This object already exists in your shopping cart.\";s:37:\"pay_item_already_in_sc_choose_another\";s:109:\"This object was already taken up in your shopping cart. Select if necessary a new price/duration combination.\";s:11:\"pay_locator\";s:7:\"Payment\";s:22:\"pay_message_attachment\";s:79:\"As a confirmation for your order we send you a bill (PDF format) as attachment.\";s:17:\"pay_message_hello\";s:4:\"Dear\";s:19:\"pay_message_regards\";s:15:\"Yours sincerely\";s:19:\"pay_message_subject\";s:16:\"Your ILIAS order\";s:18:\"pay_message_thanks\";s:33:\"Thank you for your ILIAS 3 order.\";s:22:\"pay_no_vendors_created\";s:18:\"No vendors created\";s:24:\"pay_not_buyed_any_object\";s:31:\"You have not bought any object.\";s:19:\"pay_order_date_from\";s:15:\"Order date from\";s:18:\"pay_order_date_til\";s:14:\"Order date til\";s:21:\"pay_payed_credit_card\";s:34:\"The order was paid by credit card.\";s:21:\"pay_payed_debit_entry\";s:34:\"The order was paid by debit entry.\";s:16:\"pay_payed_paypal\";s:29:\"The order was paid by PayPal.\";s:22:\"pay_paypal_error_fails\";s:58:\"PayPal reports errors that occured during the transaction.\";s:21:\"pay_paypal_error_info\";s:86:\"If necessary feel free to contact the system administrator of this ILIAS installation.\";s:30:\"pay_paypal_error_not_completed\";s:44:\"The transaction isn\'t totally completed yet.\";s:30:\"pay_paypal_error_prev_trans_id\";s:59:\"The transaction id given by PayPal was already used before.\";s:31:\"pay_paypal_error_wrong_customer\";s:63:\"Checking this transaction resulted in no match of the customer.\";s:28:\"pay_paypal_error_wrong_items\";s:65:\"Checking this transaction resulted in no match of the sold items.\";s:29:\"pay_paypal_error_wrong_vendor\";s:61:\"Checking this transaction resulted in no match of the vendor.\";s:17:\"pay_paypal_failed\";s:50:\"Your puchase of ILIAS objects using PayPal failed!\";s:18:\"pay_paypal_success\";s:118:\"Thanks for your purchase of ILIAS objects using PayPal! You\'ll receive a written confirmation in PDF format by e-mail.\";s:22:\"pay_paypal_unreachable\";s:54:\"The connection to the payment server of PayPal failed.\";s:16:\"pay_reset_filter\";s:12:\"Reset filter\";s:19:\"pay_select_one_item\";s:23:\"Please select one item.\";s:16:\"pay_select_price\";s:43:\"Please select a price/duration combination.\";s:14:\"pay_send_order\";s:10:\"Send order\";s:23:\"pay_shopping_cart_empty\";s:28:\"Your shopping cart is empty.\";s:12:\"pay_starting\";s:11:\"starts with\";s:9:\"pay_step1\";s:50:\"Your order - Schritt 1/3: Enter your personal data\";s:9:\"pay_step2\";s:48:\"Your order - Schritt 2/3: Choose kind of payment\";s:21:\"pay_step3_credit_card\";s:73:\"Your order - Schritt 3/3: Enter your credit card data and send your order\";s:21:\"pay_step3_debit_entry\";s:66:\"Your order - Schritt 3/3: Enter your bank data and send your order\";s:15:\"pay_update_view\";s:11:\"Update view\";s:11:\"paya_access\";s:6:\"Access\";s:17:\"paya_add_customer\";s:19:\"Add Selling Process\";s:14:\"paya_add_price\";s:13:\"Add new price\";s:20:\"paya_add_price_title\";s:9:\"New price\";s:21:\"paya_added_new_object\";s:60:\"Added new object. Please edit the pay method and the prices.\";s:20:\"paya_added_new_price\";s:17:\"Created new price\";s:18:\"paya_added_trustee\";s:20:\"Created new trustee.\";s:23:\"paya_bookings_available\";s:66:\"This object has been sold. Please delete all statistic data first.\";s:12:\"paya_buyable\";s:7:\"Buyable\";s:18:\"paya_buyed_objects\";s:14:\"Bought Objects\";s:20:\"paya_count_purchaser\";s:20:\"Number of purchasers\";s:13:\"paya_customer\";s:8:\"Customer\";s:32:\"paya_customer_added_successfully\";s:60:\"The selling process was added to the statistics sucessfully.\";s:17:\"paya_delete_price\";s:12:\"Delete price\";s:23:\"paya_delete_trustee_msg\";s:26:\"Deleted selected trustees.\";s:23:\"paya_deleted_last_price\";s:32:\"The last price has been deleted.\";s:19:\"paya_deleted_object\";s:39:\"Stoped payment for the selected object.\";s:20:\"paya_details_updated\";s:16:\"Details updated.\";s:13:\"paya_disabled\";s:8:\"Disabled\";s:17:\"paya_edit_details\";s:12:\"Edit details\";s:20:\"paya_edit_pay_method\";s:15:\"Edit pay method\";s:16:\"paya_edit_prices\";s:11:\"Edit prices\";s:22:\"paya_edit_prices_first\";s:29:\"Please edit the prices first.\";s:12:\"paya_enabled\";s:7:\"Enabled\";s:16:\"paya_enter_login\";s:26:\"Please enter an user name.\";s:22:\"paya_err_adding_object\";s:19:\"Error adding object\";s:26:\"paya_error_adding_customer\";s:68:\"An error occured while adding the selling process to the statistics.\";s:27:\"paya_error_mandatory_fields\";s:40:\"Please fill in all mandatory fields (*).\";s:29:\"paya_error_no_object_id_given\";s:24:\"Please choose an object.\";s:25:\"paya_error_update_booking\";s:28:\"Error saving statistic data.\";s:12:\"paya_expires\";s:14:\"Expire payment\";s:19:\"paya_filter_reseted\";s:15:\"Filter reseted.\";s:11:\"paya_header\";s:22:\"Payment administration\";s:24:\"paya_insert_only_numbers\";s:28:\"Please insert only integers.\";s:12:\"paya_locator\";s:22:\"Payment administration\";s:11:\"paya_months\";s:8:\"Month(s)\";s:24:\"paya_no_booking_id_given\";s:28:\"Error: no \'booking id\' given\";s:16:\"paya_no_bookings\";s:23:\"No statistic available.\";s:23:\"paya_no_object_selected\";s:25:\"Please select one object.\";s:24:\"paya_no_objects_assigned\";s:30:\"There are no sellable objects.\";s:23:\"paya_no_price_available\";s:19:\"No prices available\";s:23:\"paya_no_prices_selected\";s:23:\"Please select one price\";s:26:\"paya_no_settings_necessary\";s:51:\"There are no settings necessary for this pay method\";s:16:\"paya_no_trustees\";s:20:\"No trustees created.\";s:19:\"paya_no_valid_login\";s:28:\"This user name is not valid.\";s:23:\"paya_no_vendor_selected\";s:30:\"You haven\'t selected a vendor.\";s:24:\"paya_not_assign_yourself\";s:38:\"It is not possible to assign yourself.\";s:16:\"paya_not_buyable\";s:11:\"Not buyable\";s:11:\"paya_object\";s:7:\"Objekts\";s:27:\"paya_object_not_purchasable\";s:39:\"It is not possible to sell this object.\";s:15:\"paya_order_date\";s:10:\"Order date\";s:15:\"paya_pay_method\";s:10:\"Pay method\";s:29:\"paya_pay_method_not_specified\";s:13:\"Not specified\";s:10:\"paya_payed\";s:5:\"Payed\";s:17:\"paya_payed_access\";s:12:\"Payed/Access\";s:13:\"paya_perm_obj\";s:12:\"Edit objects\";s:14:\"paya_perm_stat\";s:15:\"Edit statistics\";s:20:\"paya_price_not_valid\";s:51:\"This price is not valid. Please insert only numbers\";s:26:\"paya_select_object_to_sell\";s:48:\"Please select the object which you want to sell.\";s:28:\"paya_select_pay_method_first\";s:35:\"Please select one pay method first.\";s:16:\"paya_sell_object\";s:11:\"Sell object\";s:18:\"paya_shopping_cart\";s:13:\"Shopping cart\";s:14:\"paya_statistic\";s:9:\"Statistic\";s:23:\"paya_sure_delete_object\";s:88:\"Are you sure, you want to stop payment for this object? All assigned data will get lost.\";s:32:\"paya_sure_delete_selected_prices\";s:52:\"Are you sure you want to delete the selected prices?\";s:34:\"paya_sure_delete_selected_trustees\";s:54:\"Are you sure you want to delete the selected trustees?\";s:21:\"paya_sure_delete_stat\";s:48:\"Are you sure, you want to delete this statistic?\";s:16:\"paya_transaction\";s:11:\"Transaction\";s:18:\"paya_trustee_table\";s:8:\"Trustees\";s:13:\"paya_trustees\";s:8:\"Trustees\";s:17:\"paya_update_price\";s:13:\"Update prices\";s:20:\"paya_updated_booking\";s:18:\"Updated statistic.\";s:19:\"paya_updated_prices\";s:14:\"Updated prices\";s:21:\"paya_updated_trustees\";s:20:\"Updated permissions.\";s:26:\"paya_user_already_assigned\";s:22:\"User already assigned.\";s:11:\"paya_vendor\";s:6:\"Vendor\";s:20:\"pays_active_bookings\";s:75:\"There active bookings for the selected vendor(s). Please delete them first.\";s:13:\"pays_add_info\";s:42:\"Additional information for bill (optional)\";s:15:\"pays_add_vendor\";s:10:\"Add vendor\";s:17:\"pays_added_vendor\";s:16:\"Added new vendor\";s:12:\"pays_address\";s:16:\"Address for bill\";s:29:\"pays_already_assigned_vendors\";s:52:\"The following number of users were already assigned:\";s:21:\"pays_assigned_vendors\";s:68:\"The following number of users have been assigned to the vendor list:\";s:15:\"pays_auth_token\";s:28:\"Unique token given by PayPal\";s:14:\"pays_bank_data\";s:18:\"Bank data for bill\";s:9:\"pays_bill\";s:4:\"Bill\";s:8:\"pays_bmf\";s:3:\"BMF\";s:16:\"pays_cost_center\";s:11:\"Cost center\";s:26:\"pays_cost_center_not_valid\";s:33:\"Please enter a valid cost center.\";s:21:\"pays_currency_subunit\";s:28:\"Currency (1/100) (e.g. Cent)\";s:18:\"pays_currency_unit\";s:19:\"Currency (e.g. EUR)\";s:18:\"pays_delete_vendor\";s:13:\"Deassign user\";s:27:\"pays_deleted_number_vendors\";s:50:\"The following number of vendors have been deleted:\";s:16:\"pays_edit_vendor\";s:9:\"Edit user\";s:17:\"pays_email_vendor\";s:28:\"E-Mail address of the vendor\";s:12:\"pays_general\";s:7:\"General\";s:21:\"pays_general_settings\";s:16:\"General settings\";s:31:\"pays_general_settings_not_valid\";s:97:\"Your general settings aren\'t valid. Please check out whether all fields are filled out correctly.\";s:25:\"pays_header_select_vendor\";s:16:\"Vendor selection\";s:22:\"pays_no_username_given\";s:17:\"No username given\";s:28:\"pays_no_valid_username_given\";s:23:\"No valid username given\";s:23:\"pays_no_vendor_selected\";s:18:\"No vendor selected\";s:20:\"pays_number_bookings\";s:15:\"Active bookings\";s:23:\"pays_objects_bill_exist\";s:85:\"Pay method \'bill\' is activated for some objects. Therefore it can not be deactivated.\";s:22:\"pays_objects_bmf_exist\";s:84:\"Pay method \'BMF\' is activated for some objects. Therefore it can not be deactivated.\";s:25:\"pays_objects_paypal_exist\";s:87:\"Pay method \'PayPal\' is activated for some objects. Therefore it can not be deactivated.\";s:12:\"pays_offline\";s:7:\"Offline\";s:11:\"pays_online\";s:6:\"Online\";s:15:\"pays_page_style\";s:10:\"Page style\";s:16:\"pays_pay_methods\";s:11:\"Pay methods\";s:11:\"pays_paypal\";s:6:\"PayPal\";s:20:\"pays_paypal_settings\";s:19:\"Settings for PayPal\";s:30:\"pays_paypal_settings_not_valid\";s:100:\"Your settings for PayPal aren\'t valid. Please check out whether all fields are filled out correctly.\";s:13:\"pays_pdf_path\";s:36:\"Path for generating bill as PDF file\";s:16:\"pays_server_host\";s:33:\"Server host (e.g. www.paypal.com)\";s:16:\"pays_server_path\";s:42:\"Path to the scripts (e.g. /cgi-bin/webscr)\";s:33:\"pays_sure_delete_selected_vendors\";s:51:\"Do you really want to delete the selected vendor(s)\";s:30:\"pays_too_many_vendors_selected\";s:55:\"Please select only one customer to perform this action.\";s:29:\"pays_updated_general_settings\";s:35:\"Your general settings were updated.\";s:23:\"pays_updated_pay_method\";s:19:\"Changed pay method.\";s:28:\"pays_updated_paypal_settings\";s:38:\"Your settings for PayPal were updated.\";s:26:\"pays_user_already_assigned\";s:48:\"This user is already assigned to the vendor list\";s:13:\"pays_vat_rate\";s:24:\"VAT rate in % (optional)\";s:11:\"pays_vendor\";s:6:\"Vendor\";s:7:\"price_a\";s:5:\"Price\";s:6:\"prices\";s:6:\"Prices\";s:6:\"update\";s:6:\"Update\";}');
INSERT INTO `lng_modules` VALUES ('pwassist','en','a:16:{s:19:\"password_assistance\";s:19:\"Password Assistance\";s:20:\"pwassist_enter_email\";s:345:\"Please enter an email address and submit the form.\\nILIAS will send an email to that address. The email contains all usernames which have registered this email address.\\nChoose a suitable username and use the password service to retrieve a new password. If you do not retrieve any email by this service please contact your course admin or %1$s. \";s:33:\"pwassist_enter_username_and_email\";s:374:\"Enter a user name and the associated email address in the fields shown below.\\nILIAS will send a message to that email address. The message contains an address for a web page, where you can enter a new password for the user account.\\nIn case your unable to assign a password to your user account using this form, contact your course administration or send an email to %1$s. \";s:40:\"pwassist_enter_username_and_new_password\";s:61:\"Enter the user name and the new password in the fields below.\";s:22:\"pwassist_invalid_email\";s:96:\"Please correct your email address.\\nThe given email address could not be found in the database. \";s:34:\"pwassist_invalid_username_or_email\";s:134:\"Please correct the text in the entry fields.\\nThe user name and email address you have entered do not match an entry in the database. \";s:26:\"pwassist_invalid_auth_mode\";s:90:\"The user won\'t be authenticated directly at ILIAS. Thus, sending a password is impossible.\";s:24:\"pwassist_login_not_match\";s:142:\"Please enter another user name.\\nThe user name you have entered does not match the user name for which you had asked for password assistance. \";s:18:\"pwassist_mail_body\";s:1175:\"Register a new password for your user account:\\n\\t%1$s\\n\\nThis message has been generated automatically by the ILIAS server\\n\\t%2$s\\n\\nYou (or someone at %3$s) has asked for password assistance for the user account \"%4$s\".\\n\\nPlease check carefully the conditions listed below, and proceed accordingly:\\n\\n- If you have used the password assistance form on the ILIAS server by accident:\\nDelete this mail.\\n\\n- If you are certain, that you never asked for password assistance at this ILIAS server:\\nPlease contact %5$s.\\n\\n- If you asked for password assistance, please proceed as follows:\\n\\n1. Open your browser.\\n\\n2. Enter the following address in your browser:\\n\\t%1$s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. On the web page shown by your browser, enter a new password for your user account.\\n\\nPlease note, that for security reasons, you can perform you can perform the three steps abeove only exactly once and for a limited time only. Afterwards the address becomes invalid, and you have to use the password assistance page on the ILIAS server again. \";s:18:\"pwassist_mail_sent\";s:62:\"A message has been sent to %1$s.\\nPlease check your mail box. \";s:21:\"pwassist_mail_subject\";s:25:\"ILIAS Password Assistance\";s:22:\"pwassist_not_permitted\";s:106:\"Please enter another user name.\\nPassword assistance is not permitted for the user name you have entered. \";s:26:\"pwassist_password_assigned\";s:60:\"The password has been successfully assigned to user \"%1$s\". \";s:24:\"pwassist_session_expired\";s:255:\"Please fill in this form again.\\nYour password assistance session has expired. This may have happened, because you tried to use the link that has been emailed to you more than once, or because too much time has passed since the link has been sent to you. \";s:21:\"pwassist_update_error\";s:142:\"Please contact your system administrator.\\nThe password could not be assigned to the user account due to an error whe updating the data base. \";s:27:\"pwassist_username_mail_body\";s:900:\"These are the active username found for the given email address:\\n%s\\n\\nThis message has been created automatically by the following ILIAS Server:\\n\\t%s\\n\\nYou (or somebody with IP  %s) have requested support for forgotten usernames for the email address \'%s\'.\\n\\nPlease check the following and act as suggested::\\n\\n-You have requested this mail by accident:\\nDelete this email.\\n\\n-You are sure, that you never requested this email:\\nPlease contact %s.\\n\\n- If you requested this email, please proceed as follows::\\n\\n1. Start your internet browser.\\n\\n2. Enter the following url:\\n\\t%s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. Your Browser now shows the Password-Service. Use this page together with one of the usernames and the according email address to retrieve a new password. \";}');
INSERT INTO `lng_modules` VALUES ('rbac','en','a:22:{s:22:\"edit_learning_progress\";s:22:\"Edit learning progress\";s:16:\"filter_all_roles\";s:33:\"Show all roles of current context\";s:19:\"filter_global_roles\";s:22:\"Show only global roles\";s:18:\"filter_local_roles\";s:40:\"Show only local roles of current context\";s:25:\"filter_local_roles_object\";s:46:\"Show only local roles defined at this position\";s:25:\"filter_roles_local_policy\";s:53:\"Show only roles using a local policy at this position\";s:22:\"info_user_view_changed\";s:17:\"User view changed\";s:5:\"leave\";s:5:\"Leave\";s:20:\"msg_no_roles_of_type\";s:47:\"No Roles available with selected filter setting\";s:17:\"perm_administrate\";s:12:\"Administrate\";s:17:\"perm_class_create\";s:18:\"Create new objects\";s:22:\"perm_class_create_desc\";s:69:\"Determine which object types may be created under the current object.\";s:18:\"perm_class_general\";s:18:\"General operations\";s:23:\"perm_class_general_desc\";s:107:\"Common operations available for all objects. Hover the mousepointer over operation to get more information.\";s:17:\"perm_class_object\";s:18:\"Special operations\";s:22:\"perm_class_object_desc\";s:67:\"Object-specific operations, only available to certain object types.\";s:15:\"perm_class_rbac\";s:19:\"Permission settings\";s:20:\"perm_class_rbac_desc\";s:134:\"Access control to Permission settings (this menu) and local policy settings for automatic permission settings for new created objects.\";s:15:\"perm_local_role\";s:10:\"Local role\";s:20:\"perm_local_role_desc\";s:83:\"This role is locally defined at the current object and correspond to a local policy\";s:21:\"perm_use_local_policy\";s:16:\"Use local policy\";s:26:\"perm_use_local_policy_desc\";s:106:\"If local policy is activated, you may define different default permission settings for the current object.\";}');
INSERT INTO `lng_modules` VALUES ('registration','en','a:32:{s:18:\"reg_add_assignment\";s:14:\"New Assignment\";s:20:\"reg_added_assignment\";s:21:\"Added new assignment.\";s:11:\"reg_approve\";s:29:\"Registration with Approvement\";s:16:\"reg_approve_info\";s:76:\"If checked any new user registration has to be approved by an administrator.\";s:19:\"reg_available_roles\";s:16:\"Available Roles:\";s:11:\"reg_default\";s:7:\"Default\";s:22:\"reg_deleted_assignment\";s:22:\"Deleted assignment(s).\";s:10:\"reg_direct\";s:19:\"Direct Registration\";s:15:\"reg_direct_info\";s:80:\"If this is checked, any new user registration request is automatically approved.\";s:12:\"reg_disabled\";s:24:\"No Registration Possible\";s:10:\"reg_domain\";s:6:\"Domain\";s:9:\"reg_email\";s:25:\"Automatic Role Assignment\";s:25:\"reg_email_role_assignment\";s:25:\"Role Assignment By Domain\";s:9:\"reg_fixed\";s:29:\"Selection From Specified List\";s:12:\"reg_info_pwd\";s:76:\"If enabled passwords will be send automatically to the new users per E-mail.\";s:21:\"reg_mail_body_approve\";s:147:\"You already have registered to ILIAS eLearning and received a mail with your account data. Now your account has been activated by an administrator.\";s:21:\"reg_mail_body_profile\";s:13:\"Profile data:\";s:29:\"reg_mail_body_profile_changed\";s:26:\"your profile has changed !\";s:28:\"reg_mail_body_pwd_generation\";s:152:\"Your account request will be reviewed by an administrator, and should be activated within 48 hours. You will be informed about the approvement by email.\";s:22:\"reg_mail_new_user_body\";s:31:\"A new user has been registered.\";s:18:\"reg_missing_domain\";s:27:\"Please fill out all fields.\";s:16:\"reg_missing_role\";s:27:\"Please fill out all fields.\";s:16:\"reg_notification\";s:13:\"Notifications\";s:21:\"reg_notification_info\";s:116:\"Enter one or more Login-Ids of users (comma seperated) that will be informed about new user registrations per email.\";s:19:\"reg_role_assignment\";s:15:\"Role Assignment\";s:13:\"reg_role_info\";s:14:\"Assigned Roles\";s:14:\"reg_select_one\";s:24:\"Please select one entry.\";s:20:\"reg_selectable_roles\";s:16:\"Selectable Roles\";s:19:\"reg_settings_header\";s:25:\"New Registration Settings\";s:8:\"reg_type\";s:17:\"Registration Type\";s:22:\"reg_unknown_recipients\";s:35:\"The following logins are not valid:\";s:21:\"registration_settings\";s:17:\"New Registrations\";}');
INSERT INTO `lng_modules` VALUES ('search','en','a:81:{s:18:\"add_members_header\";s:11:\"Add members\";s:14:\"append_results\";s:14:\"Append results\";s:13:\"search_active\";s:20:\"Include active users\";s:23:\"search_added_new_folder\";s:17:\"Added new folder.\";s:15:\"search_advanced\";s:15:\"Advanced search\";s:18:\"search_all_results\";s:11:\"All results\";s:16:\"search_all_words\";s:9:\"All words\";s:10:\"search_and\";s:3:\"and\";s:10:\"search_any\";s:9:\"-- Any --\";s:15:\"search_any_word\";s:8:\"Any word\";s:11:\"search_area\";s:11:\"Search area\";s:16:\"search_area_info\";s:52:\"Please select an area where the search should start.\";s:12:\"search_below\";s:8:\"Beneath:\";s:13:\"search_change\";s:6:\"Change\";s:25:\"search_choose_object_type\";s:30:\"Please choose one object type.\";s:20:\"search_concatenation\";s:13:\"Concatenation\";s:14:\"search_content\";s:12:\"Page Content\";s:18:\"search_dbk_content\";s:25:\"Digital Library (content)\";s:15:\"search_dbk_meta\";s:26:\"Digital Library (metadata)\";s:18:\"search_delete_sure\";s:55:\"The object and its contents will be deleted permanently\";s:19:\"search_details_info\";s:55:\"Detail search. Please select one or more objects above.\";s:13:\"search_direct\";s:13:\"Direct search\";s:16:\"search_fast_info\";s:64:\"Search for titles, descriptions and keywords in all object types\";s:22:\"search_for_grp_members\";s:24:\"Search for group members\";s:23:\"search_for_role_members\";s:23:\"Search for role members\";s:16:\"search_for_users\";s:16:\"Search for users\";s:16:\"search_full_info\";s:55:\"Choose this option to search in a large amount of data.\";s:12:\"search_group\";s:6:\"Groups\";s:16:\"search_grp_title\";s:10:\"Group name\";s:11:\"search_hits\";s:9:\"Found in:\";s:17:\"search_in_magazin\";s:17:\"In the repository\";s:16:\"search_in_result\";s:21:\"Search within results\";s:15:\"search_inactive\";s:22:\"Include inactive users\";s:12:\"search_index\";s:14:\"Indexed search\";s:16:\"search_like_info\";s:39:\"Choose this option to get best results.\";s:20:\"search_limit_reached\";s:107:\"Your search produced more than %s hits. You can restrict the search terms to receive more detailed results.\";s:17:\"search_lm_content\";s:28:\"Learning materials (content)\";s:14:\"search_lm_meta\";s:29:\"Learning materials (metadata)\";s:13:\"search_lucene\";s:13:\"Lucene search\";s:18:\"search_lucene_host\";s:13:\"Lucene-Server\";s:18:\"search_lucene_info\";s:83:\"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules\";s:18:\"search_lucene_port\";s:11:\"Lucene-Port\";s:20:\"search_lucene_readme\";s:18:\"Setup informations\";s:11:\"search_meta\";s:8:\"Metadata\";s:20:\"search_minimum_three\";s:50:\"Your search must be at least three characters long\";s:30:\"search_move_folder_not_allowed\";s:23:\"Folder cannot be moved.\";s:14:\"search_move_to\";s:8:\"Move to:\";s:24:\"search_my_search_results\";s:17:\"My search results\";s:17:\"search_new_folder\";s:10:\"New folder\";s:18:\"search_no_category\";s:43:\"You have not selected any search categories\";s:27:\"search_no_connection_lucene\";s:32:\"Cannot connect to Lucene server.\";s:15:\"search_no_match\";s:37:\"Your search did not match any results\";s:23:\"search_no_results_saved\";s:17:\"No results saved.\";s:21:\"search_no_search_term\";s:38:\"You have not selected any search terms\";s:19:\"search_no_selection\";s:22:\"You made no selection.\";s:21:\"search_object_renamed\";s:15:\"Object renamed.\";s:22:\"search_objects_deleted\";s:18:\"Object(s) deleted.\";s:20:\"search_objects_moved\";s:14:\"Objects moved.\";s:17:\"search_one_action\";s:18:\"Select one action.\";s:9:\"search_or\";s:2:\"or\";s:19:\"search_rename_title\";s:12:\"Rename title\";s:14:\"search_results\";s:14:\"Search results\";s:20:\"search_results_saved\";s:20:\"Search results saved\";s:17:\"search_role_title\";s:9:\"Role name\";s:21:\"search_save_as_select\";s:8:\"Save as:\";s:17:\"search_search_for\";s:10:\"Search for\";s:30:\"search_search_no_results_saved\";s:33:\"There are no search results saved\";s:21:\"search_search_results\";s:14:\"Search results\";s:18:\"search_search_term\";s:11:\"Search term\";s:32:\"search_select_exactly_one_object\";s:35:\"You must select exactly one object.\";s:20:\"search_select_folder\";s:78:\"Please select exactly one folder. It is not possible to rename search results.\";s:17:\"search_select_one\";s:17:\"Select one folder\";s:24:\"search_select_one_action\";s:21:\"--Select one action--\";s:31:\"search_select_one_folder_select\";s:21:\"--Select one folder--\";s:24:\"search_select_one_result\";s:33:\"Select at least one search result\";s:24:\"search_select_one_select\";s:21:\"--Select one folder--\";s:18:\"search_show_result\";s:4:\"Show\";s:14:\"search_tst_svy\";s:13:\"Tests/Surveys\";s:11:\"search_type\";s:11:\"Search type\";s:11:\"search_user\";s:5:\"Users\";s:5:\"until\";s:5:\"up to\";}');
INSERT INTO `lng_modules` VALUES ('style','en','a:56:{s:7:\"sty_all\";s:3:\"All\";s:14:\"sty_background\";s:10:\"Background\";s:25:\"sty_background_attachment\";s:21:\"Background Attachment\";s:20:\"sty_background_color\";s:16:\"Background Color\";s:20:\"sty_background_image\";s:16:\"Background Image\";s:23:\"sty_background_position\";s:19:\"Background Position\";s:21:\"sty_background_repeat\";s:17:\"Background Repeat\";s:10:\"sty_border\";s:6:\"Border\";s:16:\"sty_border_color\";s:12:\"Border Color\";s:16:\"sty_border_style\";s:12:\"Border Style\";s:16:\"sty_border_width\";s:12:\"Border Width\";s:10:\"sty_bottom\";s:6:\"Bottom\";s:9:\"sty_clear\";s:5:\"Clear\";s:9:\"sty_color\";s:6:\"Colour\";s:26:\"sty_confirm_del_ind_styles\";s:45:\"Confirm Deletion of Individual Content Styles\";s:31:\"sty_confirm_del_ind_styles_desc\";s:154:\"All learning modules with individual styles will be assigned to style \'%s\'. This will also delete all individual content styles. Are you sure to continue?\";s:25:\"sty_copy_other_stylesheet\";s:28:\"Copy Style from Local Source\";s:20:\"sty_create_ind_style\";s:23:\"Create Individual Style\";s:25:\"sty_create_new_stylesheet\";s:16:\"Create new Style\";s:10:\"sty_cursor\";s:6:\"Cursor\";s:17:\"sty_default_style\";s:13:\"Default Style\";s:15:\"sty_font_family\";s:11:\"Font Family\";s:13:\"sty_font_size\";s:9:\"Font Size\";s:16:\"sty_font_stretch\";s:12:\"Font Stretch\";s:14:\"sty_font_style\";s:10:\"Font Style\";s:16:\"sty_font_variant\";s:12:\"Font Variant\";s:15:\"sty_font_weight\";s:11:\"Font Weight\";s:21:\"sty_import_stylesheet\";s:12:\"Import Style\";s:20:\"sty_individual_style\";s:16:\"Individual Style\";s:21:\"sty_individual_styles\";s:17:\"Individual Styles\";s:8:\"sty_left\";s:4:\"Left\";s:18:\"sty_letter_spacing\";s:14:\"Letter Spacing\";s:15:\"sty_line_height\";s:11:\"Line Height\";s:10:\"sty_margin\";s:6:\"Margin\";s:22:\"sty_margin_and_padding\";s:18:\"Margin and Padding\";s:18:\"sty_move_lm_styles\";s:32:\"Change Style of Learning Modules\";s:14:\"sty_move_style\";s:12:\"Change Style\";s:23:\"sty_nr_learning_modules\";s:26:\"Number of Learning Modules\";s:11:\"sty_padding\";s:7:\"Padding\";s:9:\"sty_right\";s:5:\"Right\";s:22:\"sty_save_active_styles\";s:18:\"Save Active Styles\";s:24:\"sty_save_standard_styles\";s:20:\"Save Standard Styles\";s:9:\"sty_scope\";s:5:\"Scope\";s:13:\"sty_set_scope\";s:9:\"Set Scope\";s:10:\"sty_source\";s:6:\"Source\";s:11:\"sty_special\";s:7:\"Special\";s:18:\"sty_standard_style\";s:14:\"Standard Style\";s:8:\"sty_text\";s:4:\"Text\";s:14:\"sty_text_align\";s:14:\"Text Alignment\";s:19:\"sty_text_decoration\";s:15:\"Text Decoration\";s:15:\"sty_text_indent\";s:16:\"Text Indentation\";s:18:\"sty_text_transform\";s:14:\"Text Transform\";s:7:\"sty_top\";s:3:\"Top\";s:18:\"sty_vertical_align\";s:18:\"Vertical Alignment\";s:15:\"sty_white_space\";s:11:\"White Space\";s:16:\"sty_word_spacing\";s:12:\"Word Spacing\";}');
INSERT INTO `lng_modules` VALUES ('survey','en','a:399:{s:20:\"SurveyMetricQuestion\";s:15:\"Metric question\";s:21:\"SurveyNominalQuestion\";s:16:\"Nominal question\";s:21:\"SurveyOrdinalQuestion\";s:16:\"Ordinal question\";s:18:\"SurveyTextQuestion\";s:5:\"Essay\";s:12:\"add_category\";s:10:\"Add answer\";s:11:\"add_heading\";s:11:\"Add heading\";s:31:\"add_limits_for_standard_numbers\";s:89:\"Please enter a lower and upper limit for the standard numbers you want to add as answers.\";s:10:\"add_phrase\";s:10:\"Add phrase\";s:23:\"add_phrase_introduction\";s:23:\"Please select a phrase:\";s:20:\"add_standard_numbers\";s:20:\"Add standard numbers\";s:24:\"already_completed_survey\";s:81:\"You have already finished the survey! You are not able to enter the survey again.\";s:13:\"anonymization\";s:13:\"Anonymization\";s:32:\"anonymize_anonymous_introduction\";s:222:\"This survey anonymizes all user data. To grant you access to the survey, you must use a 5-character survey code which you can receive from the creator/maintainer of this survey<br />Please enter it in the text field below.\";s:26:\"anonymize_key_introduction\";s:331:\"This survey anonymizes all user data. To grant you access to the survey, a 5-character code was created by the system and will be sent to your ILIAS mail inbox when you start the survey (after answering the first question). Your survey access code is<br /><span class=\"bold\">%s</span><br />Please enter it in the text field below. \";s:22:\"anonymize_personalized\";s:16:\"No anonymization\";s:25:\"anonymize_registered_user\";s:24:\"Anonymized survey access\";s:29:\"anonymize_resume_introduction\";s:124:\"Please enter your survey access code to resume the survey. It was sent to your ILIAS mail inbox when you started the survey.\";s:16:\"anonymize_survey\";s:21:\"Anonymize survey data\";s:19:\"anonymize_with_code\";s:54:\"Anonymization with personal access using a survey code\";s:22:\"anonymize_without_code\";s:44:\"Anonymization with free access to the survey\";s:34:\"anonymous_with_personalized_survey\";s:59:\"You must be a registered user to run a personalized survey!\";s:6:\"answer\";s:6:\"Answer\";s:5:\"apply\";s:5:\"Apply\";s:15:\"arithmetic_mean\";s:15:\"Arithmetic mean\";s:25:\"ask_insert_questionblocks\";s:78:\"Are you sure you want to insert the following question block(s) to the survey?\";s:20:\"ask_insert_questions\";s:72:\"Are you sure you want to insert the following question(s) to the survey?\";s:4:\"back\";s:7:\"<< Back\";s:6:\"before\";s:6:\"before\";s:20:\"browse_for_questions\";s:20:\"Browse for questions\";s:13:\"cancel_survey\";s:18:\"Suspend the survey\";s:26:\"cannot_create_survey_codes\";s:72:\"You do not possess sufficient permissions to create survey access codes!\";s:18:\"cannot_edit_survey\";s:61:\"You do not possess sufficient permissions to edit the survey!\";s:26:\"cannot_export_questionpool\";s:77:\"You do not possess sufficient permissions to export the survey question pool!\";s:20:\"cannot_export_survey\";s:63:\"You do not possess sufficient permissions to export the survey!\";s:22:\"cannot_maintain_survey\";s:65:\"You do not possess sufficient permissions to maintain the survey!\";s:21:\"cannot_manage_phrases\";s:64:\"You do not possess sufficient permissions to manage the phrases!\";s:25:\"cannot_participate_survey\";s:71:\"You do not possess sufficient permissions to participate in the survey!\";s:24:\"cannot_read_questionpool\";s:73:\"You do not possess sufficient permissions to read the question pool data!\";s:18:\"cannot_read_survey\";s:66:\"You do not possess sufficient permissions to read the survey data!\";s:22:\"cannot_save_metaobject\";s:64:\"You do not possess sufficient permissions to save the meta data!\";s:36:\"cannot_switch_to_online_no_questions\";s:96:\"The status cannot be changed to &quot;online&quot; because there are no questions in the survey!\";s:10:\"categories\";s:7:\"Answers\";s:8:\"category\";s:6:\"Answer\";s:23:\"category_delete_confirm\";s:54:\"Are you sure you want to delete the following answers?\";s:27:\"category_delete_select_none\";s:46:\"Please check at least one answer to delete it!\";s:20:\"category_nr_selected\";s:41:\"Number of users that selected this answer\";s:5:\"chart\";s:5:\"Chart\";s:29:\"check_category_to_save_phrase\";s:52:\"You must select a least one answer to save a phrase!\";s:5:\"codes\";s:12:\"Access codes\";s:8:\"combobox\";s:8:\"Combobox\";s:13:\"concatenation\";s:13:\"Concatenation\";s:28:\"confirm_delete_all_user_data\";s:60:\"Are you sure you want to delete all user data of the survey?\";s:31:\"confirm_delete_single_user_data\";s:70:\"Are you sure you want to delete the survey data of the selected users?\";s:22:\"confirm_remove_heading\";s:44:\"Are you sure you want to remove the heading?\";s:22:\"confirm_sync_questions\";s:145:\"The question you changed is a copy which has been created for use with the active survey. Do you want to change the original of the question too?\";s:14:\"constraint_add\";s:16:\"Add precondition\";s:11:\"constraints\";s:13:\"Preconditions\";s:38:\"constraints_first_question_description\";s:90:\"The first entity could not have any preconditions because there are no previous questions.\";s:24:\"constraints_introduction\";s:375:\"For every entity (a single question or a question block with multiple questions) one or more preconditions could be defined. These preconditions will be derived from the answers of the survey participants of questions which occur earlier in the survey. Since the first entity has no previous questions or questionblocks there is no possibility to define preconditions for it.\";s:28:\"constraints_list_of_entities\";s:43:\"Available survey entities for preconditions\";s:33:\"constraints_no_nonessay_available\";s:151:\"There are no previous questions or only essay questions available to calculate preconditions (essay questions are not valid to calculate preconditions)\";s:51:\"constraints_no_questions_or_questionblocks_selected\";s:53:\"Please select at least one question or questionblock!\";s:8:\"contains\";s:8:\"Contains\";s:8:\"continue\";s:11:\"Continue >>\";s:11:\"create_date\";s:7:\"Created\";s:10:\"create_new\";s:10:\"Create new\";s:39:\"create_questionpool_before_add_question\";s:67:\"You must create at least one question pool to store your questions!\";s:8:\"dc_agree\";s:5:\"agree\";s:9:\"dc_always\";s:6:\"always\";s:18:\"dc_definitelyfalse\";s:16:\"definitely false\";s:17:\"dc_definitelytrue\";s:15:\"definitely true\";s:10:\"dc_desired\";s:7:\"desired\";s:11:\"dc_disagree\";s:8:\"disagree\";s:7:\"dc_fair\";s:4:\"fair\";s:8:\"dc_false\";s:5:\"false\";s:7:\"dc_good\";s:4:\"good\";s:12:\"dc_manytimes\";s:10:\"many times\";s:15:\"dc_morenegative\";s:13:\"more negative\";s:15:\"dc_morepositive\";s:13:\"more positive\";s:16:\"dc_mostcertainly\";s:14:\"most certainly\";s:19:\"dc_mostcertainlynot\";s:18:\"most certainly not\";s:7:\"dc_must\";s:4:\"must\";s:10:\"dc_mustnot\";s:8:\"must not\";s:10:\"dc_neutral\";s:7:\"neutral\";s:8:\"dc_never\";s:5:\"never\";s:5:\"dc_no\";s:2:\"no\";s:16:\"dc_notacceptable\";s:14:\"not acceptable\";s:7:\"dc_poor\";s:4:\"poor\";s:9:\"dc_rarely\";s:6:\"rarely\";s:9:\"dc_should\";s:6:\"should\";s:12:\"dc_shouldnot\";s:10:\"should not\";s:12:\"dc_sometimes\";s:9:\"sometimes\";s:16:\"dc_stronglyagree\";s:14:\"strongly agree\";s:18:\"dc_stronglydesired\";s:16:\"strongly desired\";s:19:\"dc_stronglydisagree\";s:17:\"strongly disagree\";s:20:\"dc_stronglyundesired\";s:18:\"strongly undesired\";s:7:\"dc_true\";s:4:\"true\";s:12:\"dc_undecided\";s:9:\"undecided\";s:12:\"dc_undesired\";s:9:\"undesired\";s:10:\"dc_varying\";s:7:\"varying\";s:11:\"dc_verygood\";s:9:\"very good\";s:6:\"dc_yes\";s:3:\"yes\";s:20:\"define_questionblock\";s:21:\"Define question block\";s:16:\"delete_user_data\";s:44:\"Delete the survey data of the selected users\";s:20:\"description_maxchars\";s:86:\"If nothing entered the maximum number of characters for this text answer is unlimited.\";s:9:\"disinvite\";s:9:\"Disinvite\";s:21:\"display_all_available\";s:21:\"Display all available\";s:27:\"dp_standard_attitude_agree5\";s:77:\"Standard attitude (strongly agree-agree-undecided-disagree-strongly disagree)\";s:35:\"dp_standard_attitude_agree_disagree\";s:34:\"Standard attitude (agree-disagree)\";s:45:\"dp_standard_attitude_agree_undecided_disagree\";s:44:\"Standard attitude (agree-undecided-disagree)\";s:29:\"dp_standard_attitude_desired5\";s:81:\"Standard attitude (strongly desired-desired-neutral-undesired-strongly undesired)\";s:46:\"dp_standard_attitude_desired_neutral_undesired\";s:45:\"Standard attitude (desired-neutral-undesired)\";s:38:\"dp_standard_attitude_desired_undesired\";s:37:\"Standard attitude (desired-undesired)\";s:26:\"dp_standard_attitude_good5\";s:59:\"Standard attitude (very good-good-fair-poor-not acceptable)\";s:44:\"dp_standard_attitude_good_fair_notacceptable\";s:44:\"Standard attitude (good-fair-not acceptable)\";s:39:\"dp_standard_attitude_good_notacceptable\";s:39:\"Standard attitude (good-not acceptable)\";s:26:\"dp_standard_attitude_must5\";s:61:\"Standard attitude (must-should-undecided-should not-must not)\";s:36:\"dp_standard_attitude_shold_shouldnot\";s:37:\"Standard attitude (should-should not)\";s:47:\"dp_standard_attitude_should_undecided_shouldnot\";s:47:\"Standard attitude (should-undecided-should not)\";s:32:\"dp_standard_behaviour_certainly5\";s:91:\"Standard behavior (most certainly-more positive-undecided-more negative-most certainly not)\";s:28:\"dp_standard_behaviour_yes_no\";s:26:\"Standard behavior (yes-no)\";s:38:\"dp_standard_behaviour_yes_undecided_no\";s:36:\"Standard behavior (yes-undecided-no)\";s:27:\"dp_standard_beliefs_always5\";s:57:\"Standard beliefs (always-many times-varying-rarely-never)\";s:32:\"dp_standard_beliefs_always_never\";s:31:\"Standard beliefs (always-never)\";s:42:\"dp_standard_beliefs_always_sometimes_never\";s:41:\"Standard beliefs (always-sometimes-never)\";s:25:\"dp_standard_beliefs_true5\";s:72:\"Standard beliefs (definitely true-true-undecided-false-definitely false)\";s:30:\"dp_standard_beliefs_true_false\";s:29:\"Standard beliefs (true-false)\";s:40:\"dp_standard_beliefs_true_undecided_false\";s:39:\"Standard beliefs (true-undecided-false)\";s:19:\"dp_standard_numbers\";s:16:\"Standard numbers\";s:9:\"duplicate\";s:9:\"Duplicate\";s:13:\"duplicate_svy\";s:16:\"Duplicate survey\";s:17:\"edit_ask_continue\";s:47:\"Do you want to continue and edit this question?\";s:29:\"edit_constraints_introduction\";s:87:\"You have selected the following question(s)/question block(s) to edit the preconditions\";s:12:\"edit_heading\";s:12:\"Edit heading\";s:8:\"end_date\";s:8:\"End date\";s:16:\"end_date_reached\";s:53:\"You cannot start the survey. The end date is reached!\";s:18:\"enter_anonymous_id\";s:18:\"Survey access code\";s:18:\"enter_phrase_title\";s:27:\"Please enter a phrase title\";s:25:\"enter_questionblock_title\";s:35:\"Please enter a questionblock title!\";s:27:\"enter_valid_number_of_codes\";s:60:\"Please enter a valid number to generate survey access codes!\";s:11:\"enter_value\";s:13:\"Enter a value\";s:17:\"error_add_heading\";s:21:\"Please add a heading!\";s:24:\"error_importing_question\";s:77:\"There was an error importing the question(s) from the file you have selected!\";s:33:\"error_retrieving_anonymous_survey\";s:121:\"The system could not find your survey data for survey code &quot;%s&quot;. Please check the survey code you have entered!\";s:16:\"eval_legend_link\";s:72:\"Please refer to the legend for the meaning of the column header symbols.\";s:10:\"evaluation\";s:10:\"Evaluation\";s:17:\"evaluation_access\";s:17:\"Evaluation access\";s:21:\"evaluation_access_all\";s:31:\"Evaluation access for all users\";s:22:\"evaluation_access_info\";s:40:\"You have access to the survey evaluation\";s:30:\"evaluation_access_participants\";s:41:\"Evaluation access for survey participants\";s:20:\"existing_constraints\";s:22:\"Existing preconditions\";s:4:\"exit\";s:4:\"Exit\";s:12:\"exp_type_csv\";s:27:\"Comma separated value (CSV)\";s:14:\"exp_type_excel\";s:15:\"Microsoft Excel\";s:14:\"export_data_as\";s:14:\"Export data as\";s:28:\"fill_out_all_category_fields\";s:59:\"Please fill out all answer fields before you add a new one!\";s:41:\"fill_out_all_required_fields_add_category\";s:59:\"Please fill out all required fields before you add answers!\";s:44:\"fill_out_all_required_fields_delete_category\";s:62:\"Please fill out all required fields before you delete answers!\";s:42:\"fill_out_all_required_fields_move_category\";s:60:\"Please fill out all required fields before you move answers!\";s:40:\"fill_out_all_required_fields_save_phrase\";s:61:\"Please fill out all required fields before you save a phrase!\";s:6:\"filter\";s:6:\"Filter\";s:25:\"filter_all_question_types\";s:18:\"All question types\";s:24:\"filter_all_questionpools\";s:18:\"All question pools\";s:26:\"filter_show_question_types\";s:19:\"Show question types\";s:25:\"filter_show_questionpools\";s:19:\"Show question pools\";s:29:\"form_data_modified_press_save\";s:75:\"The form data has been modified. Press the save button to keep the changes.\";s:15:\"found_questions\";s:15:\"Found questions\";s:14:\"geometric_mean\";s:14:\"Geometric mean\";s:13:\"given_answers\";s:13:\"Given answers\";s:13:\"glossary_term\";s:13:\"Glossary term\";s:13:\"harmonic_mean\";s:13:\"Harmonic mean\";s:7:\"heading\";s:7:\"Heading\";s:10:\"horizontal\";s:10:\"horizontal\";s:25:\"import_error_closing_file\";s:30:\"Error closing the import file!\";s:25:\"import_error_opening_file\";s:30:\"Error opening the import file!\";s:36:\"import_error_survey_no_proper_values\";s:51:\"The survey properties do not contain proper values!\";s:33:\"import_error_survey_no_properties\";s:53:\"No survey properties found. Cannot import the survey!\";s:23:\"import_no_file_selected\";s:17:\"No file selected!\";s:15:\"import_question\";s:18:\"Import question(s)\";s:22:\"import_wrong_file_type\";s:16:\"Wrong file type!\";s:12:\"insert_after\";s:12:\"Insert after\";s:13:\"insert_before\";s:13:\"Insert before\";s:23:\"insert_missing_question\";s:65:\"Please select at least one question to insert it into the survey!\";s:28:\"insert_missing_questionblock\";s:71:\"Please select at least one question block to insert it into the survey!\";s:12:\"introduction\";s:12:\"Introduction\";s:27:\"introduction_manage_phrases\";s:90:\"Manage your own phrases which are available for all the ordinal questions you edit/create.\";s:10:\"invitation\";s:10:\"Invitation\";s:15:\"invitation_mode\";s:15:\"Invitation mode\";s:19:\"invite_participants\";s:19:\"Invite participants\";s:14:\"invited_groups\";s:14:\"Invited groups\";s:13:\"invited_users\";s:13:\"Invited users\";s:19:\"label_resume_survey\";s:30:\"Enter your 5 digit survey code\";s:11:\"last_update\";s:11:\"Last update\";s:6:\"legend\";s:6:\"Legend\";s:11:\"lower_limit\";s:11:\"Lower limit\";s:11:\"maintenance\";s:11:\"Maintenance\";s:14:\"manage_phrases\";s:14:\"Manage phrases\";s:8:\"material\";s:8:\"Material\";s:27:\"material_added_successfully\";s:37:\"You successfully set a material link!\";s:13:\"material_file\";s:13:\"Material file\";s:8:\"maxchars\";s:28:\"Maximum number of characters\";s:7:\"maximum\";s:13:\"Maximum value\";s:6:\"median\";s:6:\"Median\";s:14:\"median_between\";s:7:\"between\";s:8:\"menuback\";s:4:\"Back\";s:16:\"menubacktosurvey\";s:18:\"Back to the survey\";s:22:\"message_mail_survey_id\";s:239:\"You have started the anonymized survey &quot;%s&quot;. To resume this survey you need the following 5 digit survey code:<br><br><strong>%s</strong><br><br>Resuming a survey is only possible, if you interrupt the survey before finishing it.\";s:30:\"metric_question_floating_point\";s:110:\"The value you entered is a floating point value. Floating point values are not allowed for this question type!\";s:27:\"metric_question_not_a_value\";s:45:\"The value you entered is not a numeric value!\";s:29:\"metric_question_out_of_bounds\";s:67:\"The value you entered is not between the minimum and maximum value!\";s:7:\"minimum\";s:13:\"Minimum value\";s:28:\"missing_upper_or_lower_limit\";s:40:\"Please enter a lower and an upper limit!\";s:4:\"mode\";s:19:\"Most selected value\";s:21:\"mode_nr_of_selections\";s:16:\"Nr of selections\";s:9:\"mode_text\";s:26:\"Most selected value (Text)\";s:33:\"multiple_choice_multiple_response\";s:35:\"Multiple choice (multiple response)\";s:31:\"multiple_choice_single_response\";s:33:\"Multiple choice (single response)\";s:16:\"new_survey_codes\";s:25:\"new survey access code(s)\";s:18:\"next_question_rows\";s:26:\"Questions %d - %d of %d >>\";s:24:\"no_available_constraints\";s:35:\"There are no preconditions defined!\";s:33:\"no_category_selected_for_deleting\";s:63:\"Please select a least one answer if you want to delete answers!\";s:29:\"no_category_selected_for_move\";s:44:\"Please check at least one answer to move it!\";s:22:\"no_constraints_checked\";s:79:\"Please select a least one question or question block to edit the preconditions!\";s:29:\"no_question_selected_for_move\";s:46:\"Please check at least one question to move it!\";s:32:\"no_question_selected_for_removal\";s:66:\"Please check at least one question or question block to remove it!\";s:27:\"no_questionblocks_available\";s:38:\"There are no question blocks available\";s:22:\"no_questions_available\";s:33:\"There are no questions available!\";s:17:\"no_search_results\";s:28:\"There are no search results!\";s:27:\"no_target_selected_for_move\";s:34:\"You must select a target position!\";s:25:\"no_user_or_group_selected\";s:72:\"Please check an option what are you searching for (users and/or groups)!\";s:23:\"no_user_phrases_defined\";s:44:\"There are no user defined phrases available!\";s:31:\"nominal_question_mr_not_checked\";s:49:\"Please check at least one of the offered answers!\";s:28:\"nominal_question_not_checked\";s:40:\"Please check one of the offered answers!\";s:9:\"non_ratio\";s:8:\"Interval\";s:8:\"not_used\";s:8:\"not used\";s:10:\"obligatory\";s:10:\"obligatory\";s:3:\"off\";s:3:\"off\";s:7:\"offline\";s:7:\"offline\";s:2:\"on\";s:2:\"on\";s:6:\"online\";s:6:\"online\";s:2:\"or\";s:2:\"or\";s:28:\"ordinal_question_not_checked\";s:40:\"Please check one of the offered answers!\";s:11:\"orientation\";s:11:\"Orientation\";s:5:\"outro\";s:15:\"Final statement\";s:28:\"percentage_of_entered_values\";s:43:\"Percentage of users that entered this value\";s:29:\"percentage_of_offered_answers\";s:29:\"Percentage of offered answers\";s:24:\"percentage_of_selections\";s:45:\"Percentage of users that selected this answer\";s:12:\"phrase_saved\";s:34:\"The phrase was saved successfully!\";s:13:\"please_select\";s:19:\"-- please select --\";s:16:\"predefined_users\";s:19:\"Predefined user set\";s:7:\"preview\";s:7:\"Preview\";s:22:\"previous_question_rows\";s:26:\"<< Questions %d - %d of %d\";s:26:\"qpl_confirm_delete_phrases\";s:56:\"Are you sure you want to delete the following phrase(s)?\";s:28:\"qpl_confirm_delete_questions\";s:58:\"Are you sure you want to delete the following question(s)?\";s:20:\"qpl_copy_select_none\";s:46:\"Please check at least one question to copy it!\";s:39:\"qpl_define_questionblock_select_missing\";s:75:\"Please select a least two questions if you want to define a question block!\";s:29:\"qpl_delete_phrase_select_none\";s:45:\"Please check at least one phrase to delete it\";s:21:\"qpl_delete_rbac_error\";s:45:\"You have no rights to delete the question(s)!\";s:22:\"qpl_delete_select_none\";s:48:\"Please check at least one question to delete it!\";s:25:\"qpl_duplicate_select_none\";s:51:\"Please check at least one question to duplicate it!\";s:22:\"qpl_export_select_none\";s:47:\"Please check at least one question to export it\";s:31:\"qpl_past_questions_confirmation\";s:78:\"Are you sure you want to paste the following question(s) in the question pool?\";s:19:\"qpl_phrases_deleted\";s:18:\"Phrase(s) deleted.\";s:21:\"qpl_questions_deleted\";s:20:\"Question(s) deleted.\";s:20:\"qpl_questions_pasted\";s:19:\"Question(s) pasted.\";s:20:\"qpl_savephrase_empty\";s:28:\"Please enter a phrase title!\";s:21:\"qpl_savephrase_exists\";s:67:\"The phrase title already exists! Please enter another phrase title.\";s:22:\"qpl_unfold_select_none\";s:80:\"Please select at least one question block if you want to unfold question blocks!\";s:31:\"question_contains_no_categories\";s:46:\"There are no answers defined for this question\";s:24:\"question_has_constraints\";s:13:\"Preconditions\";s:13:\"question_icon\";s:13:\"Question icon\";s:19:\"question_obligatory\";s:27:\"The question is obligatory!\";s:25:\"question_saved_for_upload\";s:224:\"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!\";s:13:\"question_type\";s:13:\"Question type\";s:13:\"questionblock\";s:14:\"Question block\";s:29:\"questionblock_has_constraints\";s:13:\"Preconditions\";s:18:\"questionblock_icon\";s:18:\"Questionblock icon\";s:14:\"questionblocks\";s:15:\"Question blocks\";s:9:\"questions\";s:9:\"Questions\";s:18:\"questions_inserted\";s:21:\"Question(s) inserted!\";s:17:\"questions_removed\";s:45:\"Question(s) and/or question block(s) removed!\";s:12:\"questiontype\";s:13:\"Question type\";s:14:\"ratio_absolute\";s:14:\"Ratio-Absolute\";s:18:\"ratio_non_absolute\";s:18:\"Ratio-Non-Absolute\";s:19:\"ratio_scale_ge_zero\";s:65:\"The minimum value for a ratio scale must be greater or equal zero\";s:15:\"remove_question\";s:6:\"Remove\";s:16:\"remove_questions\";s:99:\"Are you sure you want to remove the following question(s) and/or question block(s) from the survey?\";s:12:\"reset_filter\";s:12:\"Reset filter\";s:13:\"resume_survey\";s:17:\"Resume the survey\";s:19:\"save_back_to_survey\";s:30:\"Save and go back to the survey\";s:21:\"save_obligatory_state\";s:22:\"Save obligatory states\";s:11:\"save_phrase\";s:14:\"Save as phrase\";s:34:\"save_phrase_categories_not_checked\";s:66:\"Please check at least two answers to save answers in a new phrase!\";s:24:\"save_phrase_introduction\";s:175:\"If you want to save the answers below as default phrase, please enter a phrase title. You can access a default phrase whenever you want to add a phrase to an ordinal question.\";s:16:\"search_field_all\";s:20:\"Search in all fields\";s:10:\"search_for\";s:10:\"Search for\";s:13:\"search_groups\";s:12:\"Found groups\";s:17:\"search_invitation\";s:36:\"Search for users or groups to invite\";s:16:\"search_questions\";s:16:\"Search questions\";s:12:\"search_roles\";s:11:\"Found roles\";s:11:\"search_term\";s:11:\"Search term\";s:15:\"search_type_all\";s:28:\"Search in all question types\";s:12:\"search_users\";s:11:\"Found users\";s:13:\"select_option\";s:31:\"--- Please select an option ---\";s:20:\"select_phrase_to_add\";s:49:\"Please select a phrase to add it to the question!\";s:21:\"select_prior_question\";s:23:\"Select a prior question\";s:19:\"select_questionpool\";s:59:\"Please select a question pool to store the created question\";s:25:\"select_questionpool_short\";s:24:\"Question pool for Survey\";s:15:\"select_relation\";s:17:\"Select a relation\";s:17:\"select_svy_option\";s:30:\"--- Please select a survey ---\";s:31:\"select_target_position_for_move\";s:88:\"Please select a target position to move the answers and press one of the insert buttons!\";s:40:\"select_target_position_for_move_question\";s:92:\"Please select a target position to move the question(s) and press one of the insert buttons!\";s:12:\"select_value\";s:14:\"Select a value\";s:9:\"selection\";s:9:\"Selection\";s:10:\"set_filter\";s:10:\"Set filter\";s:7:\"skipped\";s:7:\"skipped\";s:22:\"spl_general_properties\";s:18:\"General properties\";s:19:\"spl_online_property\";s:6:\"Online\";s:31:\"spl_online_property_description\";s:64:\"If the questionpool is not online, it cannot be used in surveys.\";s:26:\"spl_select_file_for_import\";s:34:\"You must select a file for import!\";s:10:\"start_date\";s:10:\"Start date\";s:22:\"start_date_not_reached\";s:60:\"You cannot start the survey until the start date is reached!\";s:12:\"start_survey\";s:12:\"Start survey\";s:22:\"subject_mail_survey_id\";s:26:\"Your survey code for \"%s\" \";s:7:\"subtype\";s:7:\"Subtype\";s:11:\"survey_code\";s:18:\"Survey access code\";s:24:\"survey_code_message_sent\";s:75:\"A survey code which allows you to resume the survey was sent to your INBOX!\";s:20:\"survey_code_no_codes\";s:49:\"You have not created any survey access codes yet.\";s:15:\"survey_code_url\";s:21:\"URL for direct access\";s:20:\"survey_code_url_name\";s:40:\"URL (use right mouse button to copy URL)\";s:16:\"survey_code_used\";s:13:\"Code was used\";s:17:\"survey_codes_lang\";s:22:\"Language of the survey\";s:39:\"survey_error_insert_incomplete_question\";s:82:\"You tried to add an incomplete question to the survey! The question was not added.\";s:13:\"survey_finish\";s:13:\"Finish survey\";s:15:\"survey_finished\";s:63:\"You have finished the survey. Thank you for your participation!\";s:27:\"survey_has_datasets_warning\";s:134:\"The survey already contains datasets. You cannot edit the survey questions until you remove these datasets in the maintenance section.\";s:17:\"survey_is_offline\";s:51:\"You cannot start the survey! The survey is offline.\";s:11:\"survey_next\";s:7:\"Next >>\";s:22:\"survey_offline_message\";s:42:\"Can\'t invite users. The survey is offline!\";s:21:\"survey_online_warning\";s:59:\"The survey is online. You cannot edit the survey questions!\";s:15:\"survey_previous\";s:11:\"<< Previous\";s:26:\"survey_question_obligatory\";s:58:\"This question is obligatory. You must answer the question!\";s:24:\"survey_question_optional\";s:10:\"(Optional)\";s:16:\"survey_questions\";s:9:\"Questions\";s:33:\"survey_selected_user_data_deleted\";s:64:\"The survey data of the selected user(s) was deleted successfully\";s:18:\"survey_skip_finish\";s:22:\"skip and finish survey\";s:16:\"survey_skip_next\";s:7:\"skip >>\";s:20:\"survey_skip_previous\";s:7:\"<< skip\";s:17:\"survey_skip_start\";s:25:\"skip and go to start page\";s:12:\"survey_start\";s:16:\"Go to start page\";s:25:\"svy_all_user_data_deleted\";s:46:\"All user data of this survey has been deleted!\";s:40:\"svy_check_evaluation_access_introduction\";s:136:\"Since this survey evaluation is only accessable by survey participants you need to enter your survey access code to open the evaluation.\";s:42:\"svy_check_evaluation_authentication_needed\";s:21:\"Authentication needed\";s:30:\"svy_check_evaluation_wrong_key\";s:127:\"You entered a wrong survey access code or you have not participated the survey. Your access to the survey evaluation is denied.\";s:22:\"svy_create_export_file\";s:18:\"Create export file\";s:24:\"svy_delete_all_user_data\";s:20:\"Delete all user data\";s:18:\"svy_eval_cumulated\";s:17:\"Cumulated results\";s:15:\"svy_eval_detail\";s:27:\"Cumulated results (details)\";s:13:\"svy_eval_user\";s:21:\"User specific results\";s:16:\"svy_export_files\";s:12:\"Export files\";s:8:\"svy_file\";s:4:\"File\";s:22:\"svy_general_properties\";s:18:\"General properties\";s:38:\"svy_maintenance_information_no_results\";s:108:\"There are no existing user datasets for the survey. You need at least one user dataset to maintain the data.\";s:18:\"svy_missing_author\";s:92:\"You have not entered the author\'s name in the survey properties! Please add an authors name.\";s:21:\"svy_missing_questions\";s:92:\"You do not have any questions in the survey! Please add at least one question to the survey.\";s:17:\"svy_missing_title\";s:89:\"You have not entered a survey title! Please go to the metadata section and enter a title.\";s:14:\"svy_page_error\";s:114:\"There was an error answering a survey question. Please refer to the question to get more information on the error!\";s:15:\"svy_page_errors\";s:118:\"There were errors answering the survey questions. Please refer to the questions to get more information on the errors!\";s:26:\"svy_select_file_for_import\";s:34:\"You must select a file for import!\";s:24:\"svy_select_questionpools\";s:61:\"Please select a question pool to store the imported questions\";s:18:\"svy_select_surveys\";s:38:\"Please select a survey for duplication\";s:30:\"svy_selected_user_data_deleted\";s:64:\"The survey data of the selected user(s) was deleted successfully\";s:23:\"svy_show_questiontitles\";s:30:\"Show question titles in survey\";s:8:\"svy_size\";s:4:\"Size\";s:26:\"svy_statistical_evaluation\";s:22:\"Statistical evaluation\";s:18:\"svy_status_missing\";s:51:\"There are required elements missing in this survey!\";s:27:\"svy_status_missing_elements\";s:35:\"The following elements are missing:\";s:13:\"svy_status_ok\";s:62:\"The status of the survey is OK. There are no missing elements.\";s:26:\"text_maximum_chars_allowed\";s:91:\"Please do not enter more than a maximum of %s characters. Any characters above will be cut.\";s:28:\"text_question_not_filled_out\";s:33:\"Please fill out the answer field!\";s:18:\"text_resume_survey\";s:355:\"You are trying to resume an anonymized survey. To continue the survey with your previously entered values please enter the 5 digit survey code which you received after starting the survey (it was sent with a message to your ILIAS mail folder). Instead of typing your survey code you also can copy it from your inbox and paste it into the text field below.\";s:19:\"title_resume_survey\";s:37:\"Resume the survey - Enter survey code\";s:6:\"unfold\";s:6:\"Unfold\";s:15:\"unlimited_users\";s:9:\"Unlimited\";s:17:\"uploaded_material\";s:17:\"Uploaded Material\";s:11:\"upper_limit\";s:11:\"Upper limit\";s:27:\"upper_limit_must_be_greater\";s:53:\"The upper limit must be greater than the lower limit!\";s:4:\"used\";s:4:\"used\";s:14:\"users_answered\";s:14:\"Users answered\";s:13:\"users_skipped\";s:13:\"Users skipped\";s:16:\"value_nr_entered\";s:39:\"Number of users that entered that value\";s:6:\"values\";s:6:\"Values\";s:8:\"vertical\";s:8:\"vertical\";s:29:\"view_constraints_introduction\";s:75:\"You are viewing the preconditions of the following question/question block:\";s:11:\"view_phrase\";s:11:\"View phrase\";s:23:\"warning_question_in_use\";s:345:\"Warning! The question you want to edit is in use by the surveys listed below. If you decide to continue and save/apply the question, all answers of the surveys listed below will be deleted. If you want to change the question and use it in another survey, please choose duplicate in the question browser to create a new instance of this question.\";s:29:\"warning_question_not_complete\";s:29:\"The question is not complete!\";s:36:\"wrong_categories_selected_for_insert\";s:95:\"ILIAS could not perform the desired action. Please check exactly one answer as target position!\";s:22:\"wrong_survey_code_used\";s:92:\"You cannot enter the survey, because you tried to start it with an unauthorized survey code.\";}');
INSERT INTO `lng_modules` VALUES ('trac','en','a:216:{s:13:\"found_objects\";s:13:\"Found objects\";s:22:\"found_too_much_objects\";s:94:\"Thereby more than %s objects totally were found. Therefore refine your search request, please.\";s:16:\"info_all_objects\";s:67:\"The following user tracking refers to all objects of the type \'%s\'.\";s:15:\"info_dwell_time\";s:88:\"Attention: The total dwell time of an object isn\'t addicted to the given period of time!\";s:18:\"info_found_objects\";s:114:\"The user tracking refers to the following objects of the type \'%s\' that were found according to your search terms.\";s:18:\"info_valid_request\";s:55:\"The maximum valid time between two requests of an user.\";s:10:\"last_login\";s:10:\"Last login\";s:26:\"meta_typical_learning_time\";s:21:\"Typical learning time\";s:14:\"newUT_settings\";s:26:\"Learning Module Statistics\";s:9:\"obj_types\";s:12:\"Object Types\";s:16:\"search_area_info\";s:25:\"Please choose one object.\";s:12:\"search_terms\";s:14:\"Search term(s)\";s:10:\"select_one\";s:24:\"Please select one object\";s:12:\"stats_access\";s:6:\"Access\";s:14:\"stats_accesses\";s:8:\"Accesses\";s:9:\"stats_all\";s:3:\"All\";s:13:\"stats_chapter\";s:7:\"Chapter\";s:33:\"stats_chapter_average_page_number\";s:35:\"Average Number of Pages per Chapter\";s:28:\"stats_chapter_depth_coverage\";s:29:\"Degree of Coverage with Depth\";s:27:\"stats_chapter_fewest_access\";s:13:\"Fewest Access\";s:21:\"stats_chapter_listing\";s:15:\"Chapter Listing\";s:44:\"stats_chapter_longest_total_dwell_time_depth\";s:22:\"Total Dwell Time Depth\";s:31:\"stats_chapter_most_access_depth\";s:22:\"Most Access with Depth\";s:24:\"stats_chapter_most_pages\";s:10:\"Most Pages\";s:20:\"stats_chapter_number\";s:18:\"Number of Chapters\";s:23:\"stats_chapter_statisics\";s:18:\"Chapter Statistics\";s:40:\"stats_chapter_stubbiest_total_dwell_time\";s:26:\"Stubbiest Total Dwell Time\";s:17:\"stats_chapter_top\";s:36:\"Top-Chapter (variance, access, etc.)\";s:29:\"stats_chapter_total_statistic\";s:23:\"Total-Chapter-Statistic\";s:12:\"stats_choice\";s:9:\"Selection\";s:13:\"stats_current\";s:9:\"Currently\";s:11:\"stats_depth\";s:5:\"Depth\";s:14:\"stats_duration\";s:8:\"Duration\";s:16:\"stats_equivalent\";s:16:\"is equivalent to\";s:10:\"stats_hits\";s:4:\"Hits\";s:10:\"stats_hour\";s:1:\"h\";s:14:\"stats_interval\";s:8:\"Interval\";s:25:\"stats_interval_dwell_time\";s:22:\"Interval of Dwell Time\";s:26:\"stats_interval_page_access\";s:27:\"Interval of Access to Pages\";s:10:\"stats_last\";s:4:\"Last\";s:12:\"stats_legend\";s:6:\"Legend\";s:21:\"stats_measurable_hits\";s:39:\"Measurable Hits (Hits within a Session)\";s:12:\"stats_minute\";s:1:\"m\";s:16:\"stats_navigation\";s:57:\"Navigation/Observation Model (requires JRE 1.5 or higher)\";s:19:\"stats_new_selection\";s:13:\"New Selection\";s:16:\"stats_occurrence\";s:10:\"Occurrence\";s:8:\"stats_of\";s:2:\"of\";s:10:\"stats_page\";s:4:\"Page\";s:25:\"stats_page_average_access\";s:26:\"Average of Access to pages\";s:29:\"stats_page_average_dwell_time\";s:30:\"Average of Dwell Time to Pages\";s:27:\"stats_page_deviation_access\";s:28:\"Deviation of Access to Pages\";s:31:\"stats_page_deviation_dwell_time\";s:32:\"Deviation of Dwell Time to Pages\";s:24:\"stats_page_fewest_access\";s:13:\"Fewest Access\";s:28:\"stats_page_highest_deviation\";s:17:\"Highest Deviation\";s:27:\"stats_page_highest_varcoeff\";s:29:\"Highest Variation Coefficient\";s:26:\"stats_page_least_deviation\";s:15:\"Least Deviation\";s:18:\"stats_page_listing\";s:12:\"Page Listing\";s:37:\"stats_page_longest_average_dwell_time\";s:18:\"Average Dwell Time\";s:35:\"stats_page_longest_total_dwell_time\";s:16:\"Total Dwell Time\";s:26:\"stats_page_lowest_varcoeff\";s:28:\"Lowest Variation Coefficient\";s:24:\"stats_page_median_access\";s:25:\"Median of Access to Pages\";s:28:\"stats_page_median_dwell_time\";s:29:\"Median of Dwell Time to Pages\";s:22:\"stats_page_mode_access\";s:23:\"Mode of Access to Pages\";s:22:\"stats_page_most_access\";s:13:\"Most Accesses\";s:17:\"stats_page_number\";s:15:\"Number of Pages\";s:24:\"stats_page_number_access\";s:25:\"Number of Access to Pages\";s:23:\"stats_page_range_access\";s:24:\"Range of Access to Pages\";s:27:\"stats_page_range_dwell_time\";s:28:\"Range of Dwell Time to Pages\";s:39:\"stats_page_stubbiest_average_dwell_time\";s:28:\"Stubbiest Average Dwell Time\";s:37:\"stats_page_stubbiest_total_dwell_time\";s:26:\"Stubbiest Total Dwell Time\";s:27:\"stats_page_total_dwell_time\";s:22:\"Total-Pages-Dwell time\";s:26:\"stats_page_total_statistic\";s:21:\"Total-Pages-Statistic\";s:26:\"stats_page_varcoeff_access\";s:40:\"Variation Coefficient of Access to Pages\";s:30:\"stats_page_varcoeff_dwell_time\";s:44:\"Variation Coefficient of Dwell time to Pages\";s:26:\"stats_page_variance_access\";s:27:\"Variance of Access to Pages\";s:30:\"stats_page_variance_dwell_time\";s:31:\"Variance of Dwell Time to Pages\";s:11:\"stats_pages\";s:5:\"Pages\";s:21:\"stats_pages_statisics\";s:15:\"Page Statistics\";s:9:\"stats_sec\";s:3:\"sec\";s:13:\"stats_sel_lng\";s:7:\"English\";s:13:\"stats_session\";s:7:\"Session\";s:28:\"stats_session_average_length\";s:22:\"Average Session Length\";s:33:\"stats_session_average_page_access\";s:35:\"Average Access to Pages per Session\";s:23:\"stats_session_evaluable\";s:18:\"Evaluable Sessions\";s:30:\"stats_session_evaluable_access\";s:24:\"Evaluable Session Access\";s:27:\"stats_session_evaluable_usr\";s:14:\"Evaluable User\";s:26:\"stats_session_involved_usr\";s:24:\"Number of involved Users\";s:21:\"stats_session_listing\";s:15:\"Session Listing\";s:21:\"stats_session_longest\";s:15:\"Longest Session\";s:40:\"stats_session_longest_total_duration_usr\";s:31:\"Longest Total Duration per User\";s:18:\"stats_session_most\";s:13:\"Most Sessions\";s:20:\"stats_session_number\";s:18:\"Number of Sessions\";s:28:\"stats_session_total_duration\";s:30:\"Total Duration of all Sessions\";s:29:\"stats_session_total_statistic\";s:23:\"Total-Session-Statistic\";s:14:\"stats_sessions\";s:8:\"Sessions\";s:24:\"stats_sessions_statisics\";s:18:\"Session Statistics\";s:11:\"stats_start\";s:5:\"Start\";s:15:\"stats_summation\";s:9:\"Summation\";s:18:\"stats_tracked_user\";s:14:\"Selected Users\";s:11:\"stats_until\";s:5:\"until\";s:10:\"stats_user\";s:7:\"User(s)\";s:19:\"stats_user_selected\";s:13:\"User selected\";s:10:\"stats_with\";s:4:\"with\";s:16:\"total_dwell_time\";s:16:\"Total Dwell Time\";s:14:\"trac_activated\";s:18:\"Tracking activated\";s:16:\"trac_active_both\";s:45:\"User Tracking and Learning progress activated\";s:19:\"trac_active_lp_only\";s:27:\"Learning Progress activated\";s:19:\"trac_active_ut_only\";s:23:\"User Tracking activated\";s:24:\"trac_added_no_shown_list\";s:36:\"The selected objects will be hidden.\";s:15:\"trac_anonymized\";s:10:\"Anonymized\";s:20:\"trac_anonymized_info\";s:46:\"If enabled, all statistics will be anonymized.\";s:13:\"trac_assigned\";s:8:\"Assigned\";s:16:\"trac_assignments\";s:11:\"Assignments\";s:10:\"trac_below\";s:6:\"Below:\";s:22:\"trac_collection_assign\";s:6:\"Assign\";s:24:\"trac_collection_deassign\";s:8:\"Deassign\";s:12:\"trac_comment\";s:7:\"Comment\";s:13:\"trac_comments\";s:8:\"Comments\";s:14:\"trac_completed\";s:9:\"Completed\";s:20:\"trac_crs_assignments\";s:26:\"Assignment of course items\";s:14:\"trac_crs_items\";s:23:\"Assignable course items\";s:16:\"trac_crs_members\";s:15:\"Course members:\";s:16:\"trac_crs_objects\";s:35:\"Learning progress of course members\";s:24:\"trac_crs_releavant_items\";s:12:\"Course items\";s:23:\"trac_crs_relevant_items\";s:16:\"Course Materials\";s:20:\"trac_edit_collection\";s:120:\"Please assign materials. If the status of all assigned items is \'Completed\' the overall status is completed by the user.\";s:18:\"trac_edit_progress\";s:22:\"Edit learning progress\";s:14:\"trac_edit_time\";s:15:\"Processing time\";s:16:\"trac_edit_visits\";s:78:\"Please define the number of visits that is neccessary to complete this object.\";s:16:\"trac_edited_scos\";s:17:\"Processed content\";s:24:\"trac_editing_time_passed\";s:19:\"Editing time Passed\";s:11:\"trac_failed\";s:6:\"Failed\";s:16:\"trac_filter_area\";s:4:\"Area\";s:18:\"trac_filter_hidden\";s:6:\"Hidden\";s:25:\"trac_filter_limit_reached\";s:78:\"The number of hits is limited to %s. Please use the filter to reduce the hits.\";s:21:\"trac_filter_no_access\";s:16:\"No objects found\";s:16:\"trac_filter_none\";s:4:\"None\";s:22:\"trac_filter_repository\";s:17:\"In the repository\";s:24:\"trac_fold_relevant_items\";s:14:\"Folder Content\";s:23:\"trac_grp_relevant_items\";s:15:\"Group Materials\";s:16:\"trac_head_timing\";s:10:\"Edit Until\";s:9:\"trac_hide\";s:4:\"Hide\";s:16:\"trac_in_progress\";s:11:\"In progress\";s:18:\"trac_inactive_both\";s:47:\"User Tracking and Learning progress deactivated\";s:16:\"trac_info_edited\";s:74:\"Set the status to \'Completed\' if you think you have processed all content.\";s:16:\"trac_last_access\";s:11:\"Last access\";s:22:\"trac_learning_progress\";s:17:\"Learning Progress\";s:33:\"trac_learning_progress_tbl_header\";s:21:\"Learning progress of:\";s:18:\"trac_lm_statistics\";s:17:\"Access Statistics\";s:21:\"trac_lp_determination\";s:38:\"Learning Progress Status Determination\";s:30:\"trac_lp_determination_info_crs\";s:69:\"Select the items that determine the overall learning progress status.\";s:30:\"trac_lp_determination_info_sco\";s:98:\"Select the items that determine the overall learning progress status of the SCORM learning module.\";s:14:\"trac_lp_filter\";s:6:\"Filter\";s:9:\"trac_mark\";s:4:\"Mark\";s:10:\"trac_marks\";s:5:\"Marks\";s:9:\"trac_mode\";s:4:\"Mode\";s:20:\"trac_mode_collection\";s:21:\"Collection of objects\";s:21:\"trac_mode_deactivated\";s:11:\"Deactivated\";s:27:\"trac_mode_exercise_returned\";s:15:\"Exercise Solved\";s:16:\"trac_mode_manual\";s:6:\"Manual\";s:20:\"trac_mode_objectives\";s:19:\"Learning objectives\";s:15:\"trac_mode_scorm\";s:10:\"SCORM/AICC\";s:20:\"trac_mode_scorm_aicc\";s:10:\"SCORM/AICC\";s:23:\"trac_mode_test_finished\";s:13:\"Test finished\";s:21:\"trac_mode_test_passed\";s:11:\"Test passed\";s:13:\"trac_mode_tlt\";s:21:\"Typical learning time\";s:16:\"trac_mode_visits\";s:16:\"Number of visits\";s:24:\"trac_modifications_saved\";s:14:\"Saved settings\";s:10:\"trac_modus\";s:4:\"Mode\";s:17:\"trac_no_attempted\";s:13:\"Not attempted\";s:15:\"trac_no_content\";s:54:\"No informations about the learning progress available.\";s:24:\"trac_no_sahs_items_found\";s:17:\"No objects found.\";s:17:\"trac_not_accessed\";s:12:\"Not accessed\";s:17:\"trac_not_assigned\";s:12:\"Not assigned\";s:18:\"trac_not_attempted\";s:13:\"Not attempted\";s:18:\"trac_not_completed\";s:13:\"Not Completed\";s:21:\"trac_not_participated\";s:16:\"Not Participated\";s:19:\"trac_not_registered\";s:14:\"Not Registered\";s:15:\"trac_num_visits\";s:16:\"Number of visits\";s:12:\"trac_objects\";s:26:\"Learning Progress of Users\";s:16:\"trac_occurrences\";s:5:\"Path:\";s:17:\"trac_participated\";s:12:\"Participated\";s:20:\"trac_processing_time\";s:23:\"Assumed processing time\";s:13:\"trac_progress\";s:26:\"Personal Learning Progress\";s:10:\"trac_query\";s:20:\"Title / Description:\";s:23:\"trac_reached_objectives\";s:27:\"Reached Learning Objectives\";s:19:\"trac_reached_points\";s:14:\"Achieved score\";s:19:\"trac_reached_visits\";s:15:\"Required visits\";s:12:\"trac_refresh\";s:7:\"Refresh\";s:15:\"trac_registered\";s:10:\"Registered\";s:20:\"trac_required_visits\";s:25:\"Number of required visits\";s:24:\"trac_sahs_relevant_items\";s:13:\"Content Items\";s:15:\"trac_select_one\";s:21:\"You made no selection\";s:13:\"trac_settings\";s:8:\"Settings\";s:19:\"trac_settings_saved\";s:15:\"Saved settings.\";s:9:\"trac_show\";s:22:\"Show learning progress\";s:16:\"trac_show_hidden\";s:4:\"Show\";s:15:\"trac_spent_time\";s:10:\"Spent time\";s:11:\"trac_status\";s:6:\"Status\";s:16:\"trac_time_passed\";s:21:\"Editing Time Exceeded\";s:17:\"trac_total_online\";s:17:\"Total time online\";s:21:\"trac_update_edit_user\";s:14:\"Saved settings\";s:19:\"trac_updated_status\";s:31:\"Saved learning progress status.\";s:14:\"trac_user_data\";s:10:\"User Data \";s:13:\"trac_usr_list\";s:5:\"Users\";s:18:\"trac_valid_request\";s:26:\"Max. time between requests\";s:13:\"trac_view_crs\";s:14:\"Back to course\";s:14:\"trac_view_list\";s:12:\"Back to list\";s:11:\"trac_visits\";s:16:\"Number of visits\";s:16:\"trac_visits_info\";s:37:\"Every page visit counts as one visit.\";s:28:\"tracking_time_span_not_valid\";s:39:\"Please enter a valid number of seconds.\";s:9:\"view_mode\";s:9:\"View mode\";s:18:\"vm_access_of_users\";s:15:\"Access of users\";s:17:\"vm_days_of_period\";s:14:\"Days of period\";s:15:\"vm_times_of_day\";s:13:\"Times of days\";s:26:\"trac_anonymized_info_short\";s:12:\"(Anonymized)\";}');
INSERT INTO `lng_modules` VALUES ('exercise','en','a:10:{s:11:\"exc_comment\";s:7:\"Comment\";s:23:\"exc_comment_for_learner\";s:19:\"Comment for Learner\";s:10:\"exc_failed\";s:6:\"Failed\";s:23:\"exc_feedback_from_tutor\";s:19:\"Feedback from Tutor\";s:11:\"exc_grading\";s:7:\"Grading\";s:8:\"exc_mark\";s:4:\"Mark\";s:13:\"exc_notgraded\";s:10:\"Not Graded\";s:10:\"exc_passed\";s:6:\"Passed\";s:13:\"exc_send_mail\";s:9:\"Send Mail\";s:19:\"exc_your_submission\";s:15:\"Your Submission\";}');

--
-- Table structure for table `lo_access`
--

CREATE TABLE `lo_access` (
  `timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `usr_id` int(11) NOT NULL default '0',
  `lm_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `lm_title` varchar(200) NOT NULL default ''
) TYPE=MyISAM;

--
-- Dumping data for table `lo_access`
--


--
-- Table structure for table `mail`
--

CREATE TABLE `mail` (
  `mail_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `folder_id` int(11) NOT NULL default '0',
  `sender_id` int(11) default NULL,
  `attachments` varchar(255) default NULL,
  `send_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `rcp_to` varchar(255) default NULL,
  `rcp_cc` varchar(255) default NULL,
  `rcp_bcc` varchar(255) default NULL,
  `m_status` varchar(16) default NULL,
  `m_type` varchar(255) default NULL,
  `m_email` tinyint(1) default NULL,
  `m_subject` varchar(255) default NULL,
  `m_message` text,
  `import_name` text,
  PRIMARY KEY  (`mail_id`),
  KEY `jmp_uid` (`user_id`),
  KEY `folder_id` (`folder_id`),
  KEY `m_status` (`m_status`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail`
--


--
-- Table structure for table `mail_attachment`
--

CREATE TABLE `mail_attachment` (
  `mail_id` int(11) NOT NULL default '0',
  `path` text NOT NULL,
  PRIMARY KEY  (`mail_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_attachment`
--


--
-- Table structure for table `mail_obj_data`
--

CREATE TABLE `mail_obj_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` char(70) NOT NULL default '',
  `type` char(16) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`),
  KEY `jmp_uid` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_obj_data`
--

INSERT INTO `mail_obj_data` VALUES (2,6,'a_root','root');
INSERT INTO `mail_obj_data` VALUES (3,6,'b_inbox','inbox');
INSERT INTO `mail_obj_data` VALUES (4,6,'c_trash','trash');
INSERT INTO `mail_obj_data` VALUES (5,6,'d_drafts','drafts');
INSERT INTO `mail_obj_data` VALUES (6,6,'e_sent','sent');
INSERT INTO `mail_obj_data` VALUES (7,6,'z_local','local');

--
-- Table structure for table `mail_options`
--

CREATE TABLE `mail_options` (
  `user_id` int(11) NOT NULL default '0',
  `linebreak` tinyint(4) NOT NULL default '0',
  `signature` text NOT NULL,
  `incoming_type` tinyint(3) default NULL,
  KEY `user_id` (`user_id`,`linebreak`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_options`
--

INSERT INTO `mail_options` VALUES (6,60,'',NULL);

--
-- Table structure for table `mail_saved`
--

CREATE TABLE `mail_saved` (
  `user_id` int(11) NOT NULL default '0',
  `attachments` varchar(255) default NULL,
  `rcp_to` varchar(255) default NULL,
  `rcp_cc` varchar(255) default NULL,
  `rcp_bcc` varchar(255) default NULL,
  `m_type` varchar(16) default NULL,
  `m_email` tinyint(1) default NULL,
  `m_subject` varchar(255) default NULL,
  `m_message` text
) TYPE=MyISAM;

--
-- Dumping data for table `mail_saved`
--


--
-- Table structure for table `mail_tree`
--

CREATE TABLE `mail_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_tree` (`tree`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_tree`
--

INSERT INTO `mail_tree` VALUES (6,2,0,1,12,1);
INSERT INTO `mail_tree` VALUES (6,3,2,2,3,2);
INSERT INTO `mail_tree` VALUES (6,4,2,4,5,2);
INSERT INTO `mail_tree` VALUES (6,5,2,6,7,2);
INSERT INTO `mail_tree` VALUES (6,6,2,8,9,2);
INSERT INTO `mail_tree` VALUES (6,7,2,10,11,2);

--
-- Table structure for table `map_area`
--

CREATE TABLE `map_area` (
  `item_id` int(11) NOT NULL default '0',
  `nr` int(11) NOT NULL default '0',
  `shape` varchar(20) default NULL,
  `coords` varchar(200) default NULL,
  `link_type` char(3) default NULL,
  `title` varchar(200) default NULL,
  `href` varchar(200) default NULL,
  `target` varchar(50) default NULL,
  `type` varchar(20) default NULL,
  `target_frame` varchar(50) default NULL,
  PRIMARY KEY  (`item_id`,`nr`)
) TYPE=MyISAM;

--
-- Dumping data for table `map_area`
--


--
-- Table structure for table `media_item`
--

CREATE TABLE `media_item` (
  `id` int(11) NOT NULL auto_increment,
  `width` varchar(10) default NULL,
  `height` varchar(10) default NULL,
  `halign` enum('Left','Center','Right','LeftFloat','RightFloat') default NULL,
  `caption` text,
  `nr` int(11) NOT NULL default '0',
  `purpose` enum('Standard','Fullscreen','Additional') default NULL,
  `mob_id` int(11) NOT NULL default '0',
  `location` varchar(200) default NULL,
  `location_type` enum('LocalFile','Reference') NOT NULL default 'LocalFile',
  `format` varchar(200) default NULL,
  `param` text,
  `tried_thumb` enum('y','n') default 'n',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `media_item`
--


--
-- Table structure for table `mep_tree`
--

CREATE TABLE `mep_tree` (
  `mep_id` int(11) NOT NULL default '0',
  `child` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  `lft` int(11) NOT NULL default '0',
  `rgt` int(11) NOT NULL default '0',
  `depth` smallint(6) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `mep_tree`
--


--
-- Table structure for table `meta_data`
--

CREATE TABLE `meta_data` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `title` varchar(200) NOT NULL default '',
  `language` varchar(200) NOT NULL default '',
  `description` blob NOT NULL,
  PRIMARY KEY  (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_data`
--


--
-- Table structure for table `meta_keyword`
--

CREATE TABLE `meta_keyword` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `language` char(2) NOT NULL default '',
  `keyword` varchar(200) NOT NULL default ''
) TYPE=MyISAM;

--
-- Dumping data for table `meta_keyword`
--


--
-- Table structure for table `meta_techn_format`
--

CREATE TABLE `meta_techn_format` (
  `tech_id` int(11) NOT NULL default '0',
  `format` varchar(150) default NULL,
  `nr` int(11) default NULL,
  KEY `tech_id` (`tech_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_techn_format`
--


--
-- Table structure for table `meta_techn_loc`
--

CREATE TABLE `meta_techn_loc` (
  `tech_id` int(11) NOT NULL default '0',
  `location` varchar(150) default NULL,
  `nr` int(11) default NULL,
  `type` enum('LocalFile','Reference') NOT NULL default 'LocalFile',
  KEY `tech_id` (`tech_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_techn_loc`
--


--
-- Table structure for table `meta_technical`
--

CREATE TABLE `meta_technical` (
  `tech_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `size` varchar(50) NOT NULL default '',
  `install_remarks` text NOT NULL,
  `install_remarks_lang` char(2) NOT NULL default '',
  `other_requirements` text NOT NULL,
  `other_requirements_lang` char(2) NOT NULL default '',
  `duration` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`tech_id`),
  KEY `obj_id` (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_technical`
--


--
-- Table structure for table `mob_parameter`
--

CREATE TABLE `mob_parameter` (
  `med_item_id` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `value` text,
  KEY `mob_id` (`med_item_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mob_parameter`
--


--
-- Table structure for table `mob_usage`
--

CREATE TABLE `mob_usage` (
  `id` int(11) NOT NULL default '0',
  `usage_type` varchar(10) NOT NULL default '',
  `usage_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`usage_type`,`usage_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mob_usage`
--


--
-- Table structure for table `module`
--

CREATE TABLE `module` (
  `name` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`name`)
) TYPE=MyISAM COMMENT='ILIAS Modules';

--
-- Dumping data for table `module`
--

INSERT INTO `module` VALUES ('ILIASLearningModule','content');
INSERT INTO `module` VALUES ('SAHSLearningModule','content');
INSERT INTO `module` VALUES ('Glossary','content');
INSERT INTO `module` VALUES ('Assessment','assessment');
INSERT INTO `module` VALUES ('Survey','survey');
INSERT INTO `module` VALUES ('Course','course');

--
-- Table structure for table `module_class`
--

CREATE TABLE `module_class` (
  `class` varchar(100) NOT NULL default '',
  `module` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`class`)
) TYPE=MyISAM COMMENT='Class information of ILIAS Modules';

--
-- Dumping data for table `module_class`
--

INSERT INTO `module_class` VALUES ('ilLMEditorGUI','ILIASLearningModule','classes');
INSERT INTO `module_class` VALUES ('ilLMPresentationGUI','ILIASLearningModule','classes');
INSERT INTO `module_class` VALUES ('ilSAHSPresentationGUI','SAHSLearningModule','classes');
INSERT INTO `module_class` VALUES ('ilGlossaryEditorGUI','Glossary','classes');
INSERT INTO `module_class` VALUES ('ilGlossaryPresentationGUI','Glossary','classes');
INSERT INTO `module_class` VALUES ('ilObjQuestionPoolGUI','Assessment','classes');
INSERT INTO `module_class` VALUES ('ilObjTestGUI','Assessment','classes');
INSERT INTO `module_class` VALUES ('ilObjSurveyQuestionPoolGUI','Survey','classes');
INSERT INTO `module_class` VALUES ('ilObjSurveyGUI','Survey','classes');

--
-- Table structure for table `note`
--

CREATE TABLE `note` (
  `id` int(11) NOT NULL auto_increment,
  `rep_obj_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` varchar(10) default NULL,
  `type` int(11) NOT NULL default '0',
  `author` int(11) NOT NULL default '0',
  `text` mediumtext,
  `label` int(11) NOT NULL default '0',
  `creation_date` datetime default NULL,
  `update_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `subject` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `i_author` (`author`),
  KEY `i_obj` (`rep_obj_id`,`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `note`
--


--
-- Table structure for table `note_data`
--

CREATE TABLE `note_data` (
  `note_id` int(11) NOT NULL default '0',
  `lo_id` int(11) NOT NULL default '0',
  `text` text,
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `important` enum('y','n') NOT NULL default 'n',
  `good` enum('y','n') NOT NULL default 'n',
  `question` enum('y','n') NOT NULL default 'n',
  `bad` enum('y','n') NOT NULL default 'n',
  PRIMARY KEY  (`note_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `note_data`
--


--
-- Table structure for table `object_data`
--

CREATE TABLE `object_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `type` char(4) NOT NULL default 'none',
  `title` char(70) NOT NULL default '',
  `description` char(128) default NULL,
  `owner` int(11) NOT NULL default '0',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `import_id` char(50) NOT NULL default '',
  PRIMARY KEY  (`obj_id`),
  KEY `type` (`type`),
  FULLTEXT KEY `title_desc` (`title`,`description`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_data`
--

INSERT INTO `object_data` VALUES (2,'role','Administrator','Role for systemadministrators. This role grants access to everything!',-1,'2002-01-16 15:31:45','2003-08-15 13:18:57','');
INSERT INTO `object_data` VALUES (3,'rolt','Author','Role template for authors with write & create permissions.',-1,'2002-01-16 15:32:50','2005-07-20 16:13:42','');
INSERT INTO `object_data` VALUES (4,'role','User','Standard role for registered users. Grants read access to most objects.',-1,'2002-01-16 15:34:00','2005-07-20 16:01:03','');
INSERT INTO `object_data` VALUES (5,'role','Guest','Role grants only a few visible & read permissions.',-1,'2002-01-16 15:34:46','2005-07-20 16:01:35','');
INSERT INTO `object_data` VALUES (6,'usr','root user','ilias@yourserver.com',-1,'2002-01-16 16:09:22','2003-09-30 19:50:01','');
INSERT INTO `object_data` VALUES (7,'usrf','User accounts','Manage user accounts here.',-1,'2002-06-27 09:24:06','2004-01-20 12:23:47','');
INSERT INTO `object_data` VALUES (8,'rolf','Roles','Manage your roles here.',-1,'2002-06-27 09:24:06','2004-01-20 12:23:40','');
INSERT INTO `object_data` VALUES (1,'root','ILIAS','This is the root node of the system!!!',-1,'2002-06-24 15:15:03','2004-01-20 12:24:12','');
INSERT INTO `object_data` VALUES (9,'adm','System Settings','Folder contains the systems settings',-1,'2002-07-15 12:37:33','2002-07-15 12:37:33','');
INSERT INTO `object_data` VALUES (10,'objf','Objectdefinitions','Manage ILIAS object types and object permissions. (only for experts!)',-1,'2002-07-15 12:36:56','2004-01-20 12:23:53','');
INSERT INTO `object_data` VALUES (11,'lngf','Languages','Manage your system languages here.',-1,'2002-07-15 15:52:51','2004-01-20 12:24:06','');
INSERT INTO `object_data` VALUES (25,'typ','usr','User object',-1,'2002-07-15 15:53:37','2003-08-15 12:30:56','');
INSERT INTO `object_data` VALUES (34,'typ','lm','Learning module Object',-1,'2002-07-15 15:54:04','2003-08-15 12:33:04','');
INSERT INTO `object_data` VALUES (37,'typ','frm','Forum object',-1,'2002-07-15 15:54:22','2003-08-15 12:36:40','');
INSERT INTO `object_data` VALUES (15,'typ','grp','Group object',-1,'2002-07-15 15:54:37','2002-07-15 15:54:37','');
INSERT INTO `object_data` VALUES (16,'typ','cat','Category object',-1,'2002-07-15 15:54:54','2002-07-15 15:54:54','');
INSERT INTO `object_data` VALUES (17,'typ','crs','Course object',-1,'2002-07-15 15:55:08','2002-07-15 15:55:08','');
INSERT INTO `object_data` VALUES (19,'typ','mail','Mailmodule object',-1,'2002-07-15 15:55:49','2002-07-15 15:55:49','');
INSERT INTO `object_data` VALUES (21,'typ','adm','Administration Panel object',-1,'2002-07-15 15:56:38','2002-07-15 15:56:38','');
INSERT INTO `object_data` VALUES (22,'typ','usrf','User Folder object',-1,'2002-07-15 15:56:52','2002-07-15 15:56:52','');
INSERT INTO `object_data` VALUES (23,'typ','rolf','Role Folder object',-1,'2002-07-15 15:57:06','2002-07-15 15:57:06','');
INSERT INTO `object_data` VALUES (24,'typ','objf','Object-Type Folder object',-1,'2002-07-15 15:57:17','2002-07-15 15:57:17','');
INSERT INTO `object_data` VALUES (26,'typ','typ','Object Type Definition object',-1,'2002-07-15 15:58:16','2002-07-15 15:58:16','');
INSERT INTO `object_data` VALUES (27,'typ','rolt','Role template object',-1,'2002-07-15 15:58:16','2002-07-15 15:58:16','');
INSERT INTO `object_data` VALUES (28,'typ','lngf','Language Folder object',-1,'2002-08-28 14:22:01','2002-08-28 14:22:01','');
INSERT INTO `object_data` VALUES (29,'typ','lng','Language object',-1,'2002-08-30 10:18:29','2002-08-30 10:18:29','');
INSERT INTO `object_data` VALUES (30,'typ','role','Role Object',-1,'2002-08-30 10:21:37','2002-08-30 10:21:37','');
INSERT INTO `object_data` VALUES (31,'typ','dbk','Digilib Book',-1,'2003-08-15 10:07:29','2003-08-15 12:30:19','');
INSERT INTO `object_data` VALUES (33,'typ','root','Root Folder Object',-1,'2002-12-21 00:04:00','2003-08-15 12:04:20','');
INSERT INTO `object_data` VALUES (70,'lng','en','installed',-1,'0000-00-00 00:00:00','2006-10-26 20:08:51','');
INSERT INTO `object_data` VALUES (14,'role','Anonymous','Default role for anonymous users (with no account)',-1,'2003-08-15 12:06:19','2005-07-20 15:15:06','');
INSERT INTO `object_data` VALUES (18,'typ','mob','Multimedia object',-1,'0000-00-00 00:00:00','2003-08-15 12:03:20','');
INSERT INTO `object_data` VALUES (35,'typ','notf','Note Folder Object',-1,'2002-12-21 00:04:00','2002-12-21 00:04:00','');
INSERT INTO `object_data` VALUES (36,'typ','note','Note Object',-1,'2002-12-21 00:04:00','2002-12-21 00:04:00','');
INSERT INTO `object_data` VALUES (12,'mail','Mail Settings','Configure global mail settings here.',-1,'2003-08-15 10:07:28','2004-01-20 12:24:00','');
INSERT INTO `object_data` VALUES (20,'typ','sahs','SCORM/AICC Learning Module',-1,'2003-08-15 10:07:28','2003-08-15 12:23:10','');
INSERT INTO `object_data` VALUES (80,'rolt','il_grp_admin','Administrator role template of groups',-1,'2003-08-15 10:07:28','2005-07-20 17:04:15','');
INSERT INTO `object_data` VALUES (81,'rolt','il_grp_member','Member role template of groups',-1,'2003-08-15 10:07:28','2005-07-20 17:07:55','');
INSERT INTO `object_data` VALUES (82,'rolt','il_grp_status_closed','Group role template',-1,'2003-08-15 10:07:29','2003-08-15 13:21:38','');
INSERT INTO `object_data` VALUES (83,'rolt','il_grp_status_open','Group role template',-1,'2003-08-15 10:07:29','2003-08-15 13:21:25','');
INSERT INTO `object_data` VALUES (32,'typ','glo','Glossary',-1,'2003-08-15 10:07:30','2003-08-15 12:29:54','');
INSERT INTO `object_data` VALUES (13,'usr','Anonymous','Anonymous user account. DO NOT DELETE!',-1,'2003-08-15 10:07:30','2003-08-15 10:07:30','');
INSERT INTO `object_data` VALUES (71,'lng','de','not_installed',6,'2003-08-15 10:25:19','2003-09-30 19:50:06','');
INSERT INTO `object_data` VALUES (72,'lng','es','not_installed',6,'2003-08-15 10:25:19','2003-08-15 10:25:19','');
INSERT INTO `object_data` VALUES (73,'lng','it','not_installed',6,'2003-08-15 10:25:19','2003-08-15 10:25:19','');
INSERT INTO `object_data` VALUES (84,'typ','exc','Exercise object',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (85,'typ','auth','Authentication settings',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (86,'auth','Authentication settings','Select and configure authentication mode for all user accounts',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (87,'typ','fold','Folder object',-1,'2003-11-30 21:22:50','2003-11-30 21:22:50','');
INSERT INTO `object_data` VALUES (88,'typ','file','File object',-1,'2003-11-30 21:22:50','2003-11-30 21:22:50','');
INSERT INTO `object_data` VALUES (89,'lng','fr','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (90,'lng','nl','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (91,'lng','pl','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (92,'lng','ua','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (93,'lng','zh','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (94,'typ','tst','Test object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (95,'typ','qpl','Question pool object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (96,'typ','chat','Chat object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (97,'typ','chac','Chat server config object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (98,'chac','Chat server settings','Configure chat server settings here',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (99,'typ','recf','RecoveryFolder object',-1,'2004-03-09 18:13:16','2004-03-09 18:13:16','');
INSERT INTO `object_data` VALUES (100,'recf','__Restored Objects','Contains objects restored by recovery tool',-1,'2004-03-09 18:13:16','2004-03-09 18:13:16','');
INSERT INTO `object_data` VALUES (101,'typ','mep','Media pool object',-1,'2004-04-19 00:09:14','2004-04-19 00:09:14','');
INSERT INTO `object_data` VALUES (102,'typ','htlm','HTML LM object',-1,'2004-04-19 00:09:15','2004-04-19 00:09:15','');
INSERT INTO `object_data` VALUES (103,'typ','svy','Survey object',-1,'2004-05-15 01:18:59','2004-05-15 01:18:59','');
INSERT INTO `object_data` VALUES (104,'typ','spl','Question pool object (Survey)',-1,'2004-05-15 01:18:59','2004-05-15 01:18:59','');
INSERT INTO `object_data` VALUES (105,'typ','tax','Taxonomy object',-1,'2004-06-21 01:27:18','2004-06-21 01:27:18','');
INSERT INTO `object_data` VALUES (106,'typ','taxf','Taxonomy folder object',-1,'2004-06-21 01:27:18','2004-06-21 01:27:18','');
INSERT INTO `object_data` VALUES (107,'taxf','Taxonomy folder','Configure taxonomy settings here',-1,'2004-06-21 01:27:18','2004-06-21 01:27:18','');
INSERT INTO `object_data` VALUES (108,'typ','trac','UserTracking object',-1,'2004-07-11 01:03:12','2004-07-11 01:03:12','');
INSERT INTO `object_data` VALUES (109,'trac','__User Tracking','System user tracking',-1,'2004-07-11 01:03:12','2004-07-11 01:03:12','');
INSERT INTO `object_data` VALUES (110,'rolt','il_crs_admin','Administrator template for course admins',-1,'2004-09-02 09:49:43','2005-07-20 16:47:58','');
INSERT INTO `object_data` VALUES (111,'rolt','il_crs_tutor','Tutor template for course tutors',-1,'2004-09-02 09:49:43','2005-07-20 16:55:04','');
INSERT INTO `object_data` VALUES (112,'rolt','il_crs_member','Member template for course members',-1,'2004-09-02 09:49:43','2005-07-20 16:59:41','');
INSERT INTO `object_data` VALUES (113,'typ','pays','Payment settings',-1,'2004-09-02 09:49:45','2004-09-02 09:49:45','');
INSERT INTO `object_data` VALUES (114,'pays','Payment settings','Payment settings',-1,'2004-09-02 09:49:45','2004-09-02 09:49:45','');
INSERT INTO `object_data` VALUES (115,'typ','assf','AssessmentFolder object',-1,'2005-01-07 17:21:15','2005-01-07 17:21:15','');
INSERT INTO `object_data` VALUES (116,'assf','__Test&Assessment','Test&Assessment Administration',-1,'2005-01-07 17:21:15','2005-01-07 17:21:15','');
INSERT INTO `object_data` VALUES (117,'typ','stys','Style Settings',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (118,'stys','System Style Settings','Manage system skin and style settings here',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (119,'typ','icrs','iLinc course object',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (120,'typ','icla','iLinc class room object',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (121,'typ','crsg','Course grouping object',-1,'2005-03-02 08:59:02','2005-03-02 08:59:02','');
INSERT INTO `object_data` VALUES (122,'typ','webr','Link resource object',-1,'2005-03-13 22:41:38','2005-03-13 22:41:38','');
INSERT INTO `object_data` VALUES (123,'typ','seas','Search settings',-1,'2005-06-20 09:50:00','2005-06-20 09:50:00','');
INSERT INTO `object_data` VALUES (124,'seas','Search settings','Search settings',-1,'2005-06-20 09:50:00','2005-06-20 09:50:00','');
INSERT INTO `object_data` VALUES (125,'rolt','Local Administrator','Role template for local administrators.',6,'2005-07-20 15:33:13','2005-07-20 16:00:19','');
INSERT INTO `object_data` VALUES (126,'rolt','Co-Author','Role template for authors with limited permissions.',6,'2005-07-20 16:36:46','2005-07-20 16:42:50','');
INSERT INTO `object_data` VALUES (127,'typ','extt','external tools settings',-1,'2005-07-20 18:10:04','2005-07-20 18:10:04','');
INSERT INTO `object_data` VALUES (128,'extt','External tools settings','Configuring external tools',-1,'2005-07-20 18:10:04','2005-07-20 18:10:04','');
INSERT INTO `object_data` VALUES (129,'rolt','il_icrs_admin','Administrator template for LearnLink Seminars',-1,'2005-07-20 18:10:05','2005-07-20 18:10:05','');
INSERT INTO `object_data` VALUES (130,'rolt','il_icrs_member','Member template for LearnLink Seminars',-1,'2005-07-20 18:10:05','2005-07-20 18:10:05','');
INSERT INTO `object_data` VALUES (131,'rolt','il_crs_non_member','Non-member template for course object',-1,'2005-11-07 12:41:21','2005-11-07 12:41:21','');
INSERT INTO `object_data` VALUES (132,'chat','Public chat','Public chat',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (133,'rolf','132','(ref_id 24)',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (134,'role','il_chat_moderator_24','Moderator of chat obj_no.132',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (135,'typ','adve','Advanced editing object',-1,'2006-07-11 18:43:23','2006-07-11 18:43:23','');
INSERT INTO `object_data` VALUES (136,'adve','__AdvancedEditing','Advanced Editing',-1,'2006-07-11 18:43:23','2006-07-11 18:43:23','');

--
-- Table structure for table `object_description`
--

CREATE TABLE `object_description` (
  `obj_id` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_description`
--


--
-- Table structure for table `object_reference`
--

CREATE TABLE `object_reference` (
  `ref_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `deleted` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ref_id`),
  KEY `obj_id` (`obj_id`),
  KEY `obj_del` (`deleted`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_reference`
--

INSERT INTO `object_reference` VALUES (1,1,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (7,7,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (8,8,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (9,9,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (10,10,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (11,11,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (12,12,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (19,114,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (14,98,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (15,100,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (16,107,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (17,109,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (18,86,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (20,116,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (21,118,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (22,124,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (23,128,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (24,132,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (25,133,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (26,136,'0000-00-00 00:00:00');

--
-- Table structure for table `object_translation`
--

CREATE TABLE `object_translation` (
  `obj_id` int(11) NOT NULL default '0',
  `title` varchar(70) NOT NULL default '',
  `description` text,
  `lang_code` char(2) NOT NULL default '',
  `lang_default` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`lang_code`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_translation`
--

INSERT INTO `object_translation` VALUES (9,'Open Source eLearning','','en',1);

--
-- Table structure for table `page_object`
--

CREATE TABLE `page_object` (
  `page_id` int(11) NOT NULL default '0',
  `parent_id` int(11) default NULL,
  `content` mediumtext,
  `parent_type` varchar(4) NOT NULL default 'lm',
  PRIMARY KEY  (`page_id`,`parent_type`),
  FULLTEXT KEY `content` (`content`)
) TYPE=MyISAM;

--
-- Dumping data for table `page_object`
--


--
-- Table structure for table `payment_bill_vendor`
--

CREATE TABLE `payment_bill_vendor` (
  `pobject_id` int(11) NOT NULL default '0',
  `gender` tinyint(2) default NULL,
  `firstname` char(64) default NULL,
  `lastname` char(64) default NULL,
  `title` char(64) default NULL,
  `institution` char(64) default NULL,
  `department` char(64) default NULL,
  `street` char(64) default NULL,
  `zipcode` char(16) default NULL,
  `city` char(64) default NULL,
  `country` char(64) default NULL,
  `phone` char(32) default NULL,
  `fax` char(32) default NULL,
  `email` char(64) default NULL,
  `account_number` char(32) default NULL,
  `bankcode` char(32) default NULL,
  `iban` char(64) default NULL,
  `bic` char(64) default NULL,
  `bankname` char(64) default NULL,
  PRIMARY KEY  (`pobject_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_bill_vendor`
--


--
-- Table structure for table `payment_currencies`
--

CREATE TABLE `payment_currencies` (
  `currency_id` int(3) NOT NULL default '0',
  `unit` char(32) NOT NULL default '',
  `subunit` char(32) NOT NULL default '',
  PRIMARY KEY  (`currency_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_currencies`
--

INSERT INTO `payment_currencies` VALUES (1,'euro','cent');

--
-- Table structure for table `payment_objects`
--

CREATE TABLE `payment_objects` (
  `pobject_id` int(11) NOT NULL auto_increment,
  `ref_id` int(11) NOT NULL default '0',
  `status` int(2) NOT NULL default '0',
  `pay_method` int(2) NOT NULL default '0',
  `vendor_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pobject_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_objects`
--


--
-- Table structure for table `payment_prices`
--

CREATE TABLE `payment_prices` (
  `price_id` int(11) NOT NULL auto_increment,
  `pobject_id` int(11) NOT NULL default '0',
  `duration` int(4) NOT NULL default '0',
  `currency` int(4) NOT NULL default '0',
  `unit_value` char(6) default '0',
  `sub_unit_value` char(3) default '00',
  PRIMARY KEY  (`price_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_prices`
--


--
-- Table structure for table `payment_settings`
--

CREATE TABLE `payment_settings` (
  `settings_id` bigint(20) NOT NULL auto_increment,
  `currency_unit` varchar(255) NOT NULL default '',
  `currency_subunit` varchar(255) NOT NULL default '',
  `address` text NOT NULL,
  `bank_data` text NOT NULL,
  `add_info` text NOT NULL,
  `vat_rate` varchar(255) NOT NULL default '',
  `pdf_path` varchar(255) NOT NULL default '',
  `paypal` text NOT NULL,
  PRIMARY KEY  (`settings_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_settings`
--


--
-- Table structure for table `payment_shopping_cart`
--

CREATE TABLE `payment_shopping_cart` (
  `psc_id` int(11) NOT NULL auto_increment,
  `customer_id` int(11) NOT NULL default '0',
  `pobject_id` int(11) NOT NULL default '0',
  `price_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`psc_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_shopping_cart`
--


--
-- Table structure for table `payment_statistic`
--

CREATE TABLE `payment_statistic` (
  `booking_id` int(11) NOT NULL auto_increment,
  `transaction` char(64) default NULL,
  `pobject_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `b_vendor_id` int(11) default NULL,
  `b_pay_method` int(2) default NULL,
  `order_date` int(9) default NULL,
  `duration` char(16) default NULL,
  `price` char(16) NOT NULL default '',
  `payed` int(2) NOT NULL default '0',
  `access` int(2) NOT NULL default '0',
  `voucher` char(64) default NULL,
  `transaction_extern` char(64) default NULL,
  PRIMARY KEY  (`booking_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_statistic`
--


--
-- Table structure for table `payment_trustees`
--

CREATE TABLE `payment_trustees` (
  `vendor_id` int(11) NOT NULL default '0',
  `trustee_id` int(11) NOT NULL default '0',
  `perm_stat` int(1) default NULL,
  `perm_obj` int(1) NOT NULL default '0',
  PRIMARY KEY  (`vendor_id`,`trustee_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_trustees`
--


--
-- Table structure for table `payment_vendors`
--

CREATE TABLE `payment_vendors` (
  `vendor_id` int(11) NOT NULL default '0',
  `cost_center` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`vendor_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_vendors`
--


--
-- Table structure for table `personal_clipboard`
--

CREATE TABLE `personal_clipboard` (
  `user_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `type` char(4) NOT NULL default '',
  `title` char(70) NOT NULL default '',
  PRIMARY KEY  (`user_id`,`item_id`,`type`)
) TYPE=MyISAM;

--
-- Dumping data for table `personal_clipboard`
--


--
-- Table structure for table `qpl_answer_cloze`
--

CREATE TABLE `qpl_answer_cloze` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `shuffle` enum('0','1') NOT NULL default '1',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `correctness` enum('0','1') NOT NULL default '0',
  `gap_id` int(10) unsigned NOT NULL default '0',
  `cloze_type` enum('0','1','2') default NULL,
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_cloze`
--


--
-- Table structure for table `qpl_answer_imagemap`
--

CREATE TABLE `qpl_answer_imagemap` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `correctness` enum('0','1') NOT NULL default '0',
  `coords` text,
  `area` varchar(20) default NULL,
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_imagemap`
--


--
-- Table structure for table `qpl_answer_matching`
--

CREATE TABLE `qpl_answer_matching` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `matchingtext` text,
  `matching_order` int(10) unsigned default NULL,
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_matching`
--


--
-- Table structure for table `qpl_answer_multiplechoice`
--

CREATE TABLE `qpl_answer_multiplechoice` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `imagefile` text,
  `points` double NOT NULL default '0',
  `points_unchecked` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_multiplechoice`
--


--
-- Table structure for table `qpl_answer_ordering`
--

CREATE TABLE `qpl_answer_ordering` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `solution_order` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_ordering`
--


--
-- Table structure for table `qpl_answer_singlechoice`
--

CREATE TABLE `qpl_answer_singlechoice` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `imagefile` text,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_singlechoice`
--


--
-- Table structure for table `qpl_answer_textsubset`
--

CREATE TABLE `qpl_answer_textsubset` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_textsubset`
--


--
-- Table structure for table `qpl_numeric_range`
--

CREATE TABLE `qpl_numeric_range` (
  `range_id` int(11) NOT NULL auto_increment,
  `lowerlimit` double NOT NULL default '0',
  `upperlimit` double NOT NULL default '0',
  `points` double NOT NULL default '0',
  `aorder` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `lastchange` timestamp(14) NOT NULL,
  PRIMARY KEY  (`range_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_numeric_range`
--


--
-- Table structure for table `qpl_question_cloze`
--

CREATE TABLE `qpl_question_cloze` (
  `question_fi` int(11) NOT NULL default '0',
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  `identical_scoring` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_cloze`
--


--
-- Table structure for table `qpl_question_essay`
--

CREATE TABLE `qpl_question_essay` (
  `question_fi` int(11) NOT NULL default '0',
  `maxNumOfChars` int(11) NOT NULL default '0',
  `keywords` text,
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_essay`
--


--
-- Table structure for table `qpl_question_imagemap`
--

CREATE TABLE `qpl_question_imagemap` (
  `question_fi` int(11) NOT NULL default '0',
  `image_file` varchar(100) default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_imagemap`
--


--
-- Table structure for table `qpl_question_javaapplet`
--

CREATE TABLE `qpl_question_javaapplet` (
  `question_fi` int(11) NOT NULL default '0',
  `image_file` varchar(100) default NULL,
  `params` text,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_javaapplet`
--


--
-- Table structure for table `qpl_question_matching`
--

CREATE TABLE `qpl_question_matching` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1') NOT NULL default '1',
  `matching_type` enum('0','1') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_matching`
--


--
-- Table structure for table `qpl_question_multiplechoice`
--

CREATE TABLE `qpl_question_multiplechoice` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_multiplechoice`
--


--
-- Table structure for table `qpl_question_numeric`
--

CREATE TABLE `qpl_question_numeric` (
  `question_fi` int(11) NOT NULL default '0',
  `maxNumOfChars` int(11) NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_numeric`
--


--
-- Table structure for table `qpl_question_ordering`
--

CREATE TABLE `qpl_question_ordering` (
  `question_fi` int(11) NOT NULL default '0',
  `ordering_type` enum('0','1') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_ordering`
--


--
-- Table structure for table `qpl_question_singlechoice`
--

CREATE TABLE `qpl_question_singlechoice` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_singlechoice`
--


--
-- Table structure for table `qpl_question_textsubset`
--

CREATE TABLE `qpl_question_textsubset` (
  `question_fi` int(11) NOT NULL default '0',
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  `correctanswers` int(11) default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_textsubset`
--


--
-- Table structure for table `qpl_question_type`
--

CREATE TABLE `qpl_question_type` (
  `question_type_id` int(3) unsigned NOT NULL auto_increment,
  `type_tag` char(35) NOT NULL default '',
  PRIMARY KEY  (`question_type_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_type`
--

INSERT INTO `qpl_question_type` VALUES (1,'assSingleChoice');
INSERT INTO `qpl_question_type` VALUES (2,'assMultipleChoice');
INSERT INTO `qpl_question_type` VALUES (3,'assClozeTest');
INSERT INTO `qpl_question_type` VALUES (4,'assMatchingQuestion');
INSERT INTO `qpl_question_type` VALUES (5,'assOrderingQuestion');
INSERT INTO `qpl_question_type` VALUES (6,'assImagemapQuestion');
INSERT INTO `qpl_question_type` VALUES (7,'assJavaApplet');
INSERT INTO `qpl_question_type` VALUES (8,'assTextQuestion');
INSERT INTO `qpl_question_type` VALUES (9,'assNumeric');
INSERT INTO `qpl_question_type` VALUES (10,'assTextSubset');

--
-- Table structure for table `qpl_questionpool`
--

CREATE TABLE `qpl_questionpool` (
  `id_questionpool` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `online` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`id_questionpool`),
  KEY `obj_fi` (`obj_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_questionpool`
--


--
-- Table structure for table `qpl_questions`
--

CREATE TABLE `qpl_questions` (
  `question_id` int(11) NOT NULL auto_increment,
  `question_type_fi` int(10) unsigned NOT NULL default '0',
  `obj_fi` int(10) unsigned NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `comment` text,
  `author` varchar(50) NOT NULL default '',
  `owner` int(11) NOT NULL default '0',
  `question_text` text NOT NULL,
  `working_time` time NOT NULL default '00:00:00',
  `points` double default NULL,
  `complete` enum('0','1') NOT NULL default '1',
  `created` varchar(14) NOT NULL default '',
  `original_id` int(11) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`question_id`),
  KEY `question_type_fi` (`question_type_fi`),
  FULLTEXT KEY `title_desc` (`title`,`comment`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_questions`
--


--
-- Table structure for table `qpl_suggested_solutions`
--

CREATE TABLE `qpl_suggested_solutions` (
  `suggested_solution_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `internal_link` varchar(50) default '',
  `import_id` varchar(50) default '',
  `subquestion_index` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`suggested_solution_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_suggested_solutions`
--


--
-- Table structure for table `rbac_fa`
--

CREATE TABLE `rbac_fa` (
  `rol_id` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  `assign` enum('y','n') default NULL,
  `protected` enum('y','n') default 'n',
  PRIMARY KEY  (`rol_id`,`parent`),
  KEY `jmp_parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_fa`
--

INSERT INTO `rbac_fa` VALUES (2,8,'y','y');
INSERT INTO `rbac_fa` VALUES (3,8,'n','n');
INSERT INTO `rbac_fa` VALUES (4,8,'y','n');
INSERT INTO `rbac_fa` VALUES (5,8,'y','n');
INSERT INTO `rbac_fa` VALUES (83,8,'n','n');
INSERT INTO `rbac_fa` VALUES (82,8,'n','n');
INSERT INTO `rbac_fa` VALUES (80,8,'n','y');
INSERT INTO `rbac_fa` VALUES (81,8,'n','n');
INSERT INTO `rbac_fa` VALUES (14,8,'y','n');
INSERT INTO `rbac_fa` VALUES (110,8,'n','y');
INSERT INTO `rbac_fa` VALUES (111,8,'n','n');
INSERT INTO `rbac_fa` VALUES (112,8,'n','n');
INSERT INTO `rbac_fa` VALUES (125,8,'n','y');
INSERT INTO `rbac_fa` VALUES (126,8,'n','n');
INSERT INTO `rbac_fa` VALUES (129,8,'n','y');
INSERT INTO `rbac_fa` VALUES (130,8,'n','n');
INSERT INTO `rbac_fa` VALUES (131,8,'n','n');
INSERT INTO `rbac_fa` VALUES (134,25,'y','n');

--
-- Table structure for table `rbac_operations`
--

CREATE TABLE `rbac_operations` (
  `ops_id` int(11) NOT NULL auto_increment,
  `operation` char(32) NOT NULL default '',
  `description` char(255) default NULL,
  `class` enum('create','general','object','rbac','admin','notused') NOT NULL default 'notused',
  `op_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`ops_id`),
  UNIQUE KEY `operation` (`operation`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_operations`
--

INSERT INTO `rbac_operations` VALUES (1,'edit_permission','edit permissions','rbac',NULL);
INSERT INTO `rbac_operations` VALUES (2,'visible','view object','general',100);
INSERT INTO `rbac_operations` VALUES (3,'read','access object','general',110);
INSERT INTO `rbac_operations` VALUES (4,'write','modify object','general',120);
INSERT INTO `rbac_operations` VALUES (6,'delete','remove object','general',130);
INSERT INTO `rbac_operations` VALUES (7,'join','join/subscribe','object',NULL);
INSERT INTO `rbac_operations` VALUES (8,'leave','leave/unsubscribe','object',NULL);
INSERT INTO `rbac_operations` VALUES (9,'edit_post','edit forum articles','object',NULL);
INSERT INTO `rbac_operations` VALUES (10,'delete_post','delete forum articles','object',NULL);
INSERT INTO `rbac_operations` VALUES (11,'smtp_mail','send external mail','object',NULL);
INSERT INTO `rbac_operations` VALUES (12,'system_message','allow to send system messages','object',NULL);
INSERT INTO `rbac_operations` VALUES (13,'create_user','create new user account','create',NULL);
INSERT INTO `rbac_operations` VALUES (14,'create_role','create new role definition','create',NULL);
INSERT INTO `rbac_operations` VALUES (15,'create_rolt','create new role definition template','create',NULL);
INSERT INTO `rbac_operations` VALUES (16,'create_cat','create new category','create',NULL);
INSERT INTO `rbac_operations` VALUES (17,'create_grp','create new group','create',NULL);
INSERT INTO `rbac_operations` VALUES (18,'create_frm','create new forum','create',NULL);
INSERT INTO `rbac_operations` VALUES (19,'create_crs','create new course','create',NULL);
INSERT INTO `rbac_operations` VALUES (20,'create_lm','create new learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (21,'create_sahs','create new SCORM/AICC learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (22,'create_glo','create new glossary','create',NULL);
INSERT INTO `rbac_operations` VALUES (23,'create_dbk','create new digibook','create',NULL);
INSERT INTO `rbac_operations` VALUES (24,'create_exc','create new exercise','create',NULL);
INSERT INTO `rbac_operations` VALUES (25,'create_file','upload new file','create',NULL);
INSERT INTO `rbac_operations` VALUES (26,'create_fold','create new folder','create',NULL);
INSERT INTO `rbac_operations` VALUES (40,'edit_userassignment','change userassignment of roles','object',NULL);
INSERT INTO `rbac_operations` VALUES (41,'edit_roleassignment','change roleassignments of user accounts','object',NULL);
INSERT INTO `rbac_operations` VALUES (27,'create_tst','create new test','create',NULL);
INSERT INTO `rbac_operations` VALUES (28,'create_qpl','create new question pool','create',NULL);
INSERT INTO `rbac_operations` VALUES (29,'create_chat','create chat object','create',NULL);
INSERT INTO `rbac_operations` VALUES (30,'mail_visible','users can use mail system','object',NULL);
INSERT INTO `rbac_operations` VALUES (31,'create_mep','create new media pool','create',NULL);
INSERT INTO `rbac_operations` VALUES (32,'create_htlm','create new html learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (42,'create_svy','create new survey','create',NULL);
INSERT INTO `rbac_operations` VALUES (43,'create_spl','create new question pool (Survey)','create',NULL);
INSERT INTO `rbac_operations` VALUES (44,'create_tax','create taxonomy object','create',NULL);
INSERT INTO `rbac_operations` VALUES (45,'invite','invite','object',NULL);
INSERT INTO `rbac_operations` VALUES (46,'participate','participate','object',NULL);
INSERT INTO `rbac_operations` VALUES (47,'cat_administrate_users','Administrate local user','object',NULL);
INSERT INTO `rbac_operations` VALUES (48,'read_users','read local users','object',NULL);
INSERT INTO `rbac_operations` VALUES (49,'push_desktop_items','Allow pushing desktop items','object',NULL);
INSERT INTO `rbac_operations` VALUES (50,'create_webr','create web resource','create',NULL);
INSERT INTO `rbac_operations` VALUES (51,'search','Allow using search','object',NULL);
INSERT INTO `rbac_operations` VALUES (52,'moderate','Moderate objects','object',NULL);
INSERT INTO `rbac_operations` VALUES (53,'create_icrs','create LearnLink Seminar','create',NULL);
INSERT INTO `rbac_operations` VALUES (54,'create_icla','create LearnLink Seminar room','create',NULL);
INSERT INTO `rbac_operations` VALUES (55,'edit_learning_progress','edit learning progress','object',NULL);

--
-- Table structure for table `rbac_pa`
--

CREATE TABLE `rbac_pa` (
  `rol_id` int(11) NOT NULL default '0',
  `ops_id` text NOT NULL,
  `ref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`rol_id`,`ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_pa`
--

INSERT INTO `rbac_pa` VALUES (5,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (14,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (4,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (2,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (3,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (4,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (5,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (14,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (80,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (81,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (82,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (83,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (110,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (111,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (112,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (134,'a:3:{i:0;i:52;i:1;i:3;i:2;i:2;}',24);
INSERT INTO `rbac_pa` VALUES (5,'a:1:{i:0;i:30;}',12);
INSERT INTO `rbac_pa` VALUES (4,'a:1:{i:0;i:30;}',12);

--
-- Table structure for table `rbac_ta`
--

CREATE TABLE `rbac_ta` (
  `typ_id` int(11) NOT NULL default '0',
  `ops_id` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`typ_id`,`ops_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_ta`
--

INSERT INTO `rbac_ta` VALUES (15,1);
INSERT INTO `rbac_ta` VALUES (15,2);
INSERT INTO `rbac_ta` VALUES (15,3);
INSERT INTO `rbac_ta` VALUES (15,4);
INSERT INTO `rbac_ta` VALUES (15,6);
INSERT INTO `rbac_ta` VALUES (15,7);
INSERT INTO `rbac_ta` VALUES (15,8);
INSERT INTO `rbac_ta` VALUES (15,17);
INSERT INTO `rbac_ta` VALUES (15,18);
INSERT INTO `rbac_ta` VALUES (15,20);
INSERT INTO `rbac_ta` VALUES (15,21);
INSERT INTO `rbac_ta` VALUES (15,22);
INSERT INTO `rbac_ta` VALUES (15,23);
INSERT INTO `rbac_ta` VALUES (15,24);
INSERT INTO `rbac_ta` VALUES (15,25);
INSERT INTO `rbac_ta` VALUES (15,26);
INSERT INTO `rbac_ta` VALUES (15,27);
INSERT INTO `rbac_ta` VALUES (15,28);
INSERT INTO `rbac_ta` VALUES (15,29);
INSERT INTO `rbac_ta` VALUES (15,31);
INSERT INTO `rbac_ta` VALUES (15,32);
INSERT INTO `rbac_ta` VALUES (15,42);
INSERT INTO `rbac_ta` VALUES (15,43);
INSERT INTO `rbac_ta` VALUES (15,50);
INSERT INTO `rbac_ta` VALUES (15,53);
INSERT INTO `rbac_ta` VALUES (15,55);
INSERT INTO `rbac_ta` VALUES (16,1);
INSERT INTO `rbac_ta` VALUES (16,2);
INSERT INTO `rbac_ta` VALUES (16,3);
INSERT INTO `rbac_ta` VALUES (16,4);
INSERT INTO `rbac_ta` VALUES (16,6);
INSERT INTO `rbac_ta` VALUES (16,16);
INSERT INTO `rbac_ta` VALUES (16,17);
INSERT INTO `rbac_ta` VALUES (16,18);
INSERT INTO `rbac_ta` VALUES (16,19);
INSERT INTO `rbac_ta` VALUES (16,20);
INSERT INTO `rbac_ta` VALUES (16,21);
INSERT INTO `rbac_ta` VALUES (16,22);
INSERT INTO `rbac_ta` VALUES (16,23);
INSERT INTO `rbac_ta` VALUES (16,24);
INSERT INTO `rbac_ta` VALUES (16,25);
INSERT INTO `rbac_ta` VALUES (16,27);
INSERT INTO `rbac_ta` VALUES (16,28);
INSERT INTO `rbac_ta` VALUES (16,29);
INSERT INTO `rbac_ta` VALUES (16,31);
INSERT INTO `rbac_ta` VALUES (16,32);
INSERT INTO `rbac_ta` VALUES (16,42);
INSERT INTO `rbac_ta` VALUES (16,43);
INSERT INTO `rbac_ta` VALUES (16,47);
INSERT INTO `rbac_ta` VALUES (16,48);
INSERT INTO `rbac_ta` VALUES (16,50);
INSERT INTO `rbac_ta` VALUES (16,53);
INSERT INTO `rbac_ta` VALUES (17,1);
INSERT INTO `rbac_ta` VALUES (17,2);
INSERT INTO `rbac_ta` VALUES (17,3);
INSERT INTO `rbac_ta` VALUES (17,4);
INSERT INTO `rbac_ta` VALUES (17,6);
INSERT INTO `rbac_ta` VALUES (17,7);
INSERT INTO `rbac_ta` VALUES (17,8);
INSERT INTO `rbac_ta` VALUES (17,17);
INSERT INTO `rbac_ta` VALUES (17,18);
INSERT INTO `rbac_ta` VALUES (17,20);
INSERT INTO `rbac_ta` VALUES (17,21);
INSERT INTO `rbac_ta` VALUES (17,22);
INSERT INTO `rbac_ta` VALUES (17,23);
INSERT INTO `rbac_ta` VALUES (17,24);
INSERT INTO `rbac_ta` VALUES (17,25);
INSERT INTO `rbac_ta` VALUES (17,26);
INSERT INTO `rbac_ta` VALUES (17,27);
INSERT INTO `rbac_ta` VALUES (17,28);
INSERT INTO `rbac_ta` VALUES (17,29);
INSERT INTO `rbac_ta` VALUES (17,31);
INSERT INTO `rbac_ta` VALUES (17,32);
INSERT INTO `rbac_ta` VALUES (17,42);
INSERT INTO `rbac_ta` VALUES (17,43);
INSERT INTO `rbac_ta` VALUES (17,50);
INSERT INTO `rbac_ta` VALUES (17,53);
INSERT INTO `rbac_ta` VALUES (17,55);
INSERT INTO `rbac_ta` VALUES (19,1);
INSERT INTO `rbac_ta` VALUES (19,2);
INSERT INTO `rbac_ta` VALUES (19,3);
INSERT INTO `rbac_ta` VALUES (19,4);
INSERT INTO `rbac_ta` VALUES (19,11);
INSERT INTO `rbac_ta` VALUES (19,12);
INSERT INTO `rbac_ta` VALUES (19,30);
INSERT INTO `rbac_ta` VALUES (20,1);
INSERT INTO `rbac_ta` VALUES (20,2);
INSERT INTO `rbac_ta` VALUES (20,3);
INSERT INTO `rbac_ta` VALUES (20,4);
INSERT INTO `rbac_ta` VALUES (20,6);
INSERT INTO `rbac_ta` VALUES (20,7);
INSERT INTO `rbac_ta` VALUES (20,8);
INSERT INTO `rbac_ta` VALUES (20,55);
INSERT INTO `rbac_ta` VALUES (21,1);
INSERT INTO `rbac_ta` VALUES (21,2);
INSERT INTO `rbac_ta` VALUES (21,3);
INSERT INTO `rbac_ta` VALUES (21,4);
INSERT INTO `rbac_ta` VALUES (21,44);
INSERT INTO `rbac_ta` VALUES (22,1);
INSERT INTO `rbac_ta` VALUES (22,2);
INSERT INTO `rbac_ta` VALUES (22,3);
INSERT INTO `rbac_ta` VALUES (22,4);
INSERT INTO `rbac_ta` VALUES (22,6);
INSERT INTO `rbac_ta` VALUES (22,13);
INSERT INTO `rbac_ta` VALUES (22,41);
INSERT INTO `rbac_ta` VALUES (22,48);
INSERT INTO `rbac_ta` VALUES (22,49);
INSERT INTO `rbac_ta` VALUES (23,1);
INSERT INTO `rbac_ta` VALUES (23,2);
INSERT INTO `rbac_ta` VALUES (23,3);
INSERT INTO `rbac_ta` VALUES (23,4);
INSERT INTO `rbac_ta` VALUES (23,6);
INSERT INTO `rbac_ta` VALUES (23,14);
INSERT INTO `rbac_ta` VALUES (23,15);
INSERT INTO `rbac_ta` VALUES (23,40);
INSERT INTO `rbac_ta` VALUES (24,1);
INSERT INTO `rbac_ta` VALUES (24,2);
INSERT INTO `rbac_ta` VALUES (24,3);
INSERT INTO `rbac_ta` VALUES (24,4);
INSERT INTO `rbac_ta` VALUES (28,1);
INSERT INTO `rbac_ta` VALUES (28,2);
INSERT INTO `rbac_ta` VALUES (28,3);
INSERT INTO `rbac_ta` VALUES (31,1);
INSERT INTO `rbac_ta` VALUES (31,2);
INSERT INTO `rbac_ta` VALUES (31,3);
INSERT INTO `rbac_ta` VALUES (31,4);
INSERT INTO `rbac_ta` VALUES (31,6);
INSERT INTO `rbac_ta` VALUES (31,55);
INSERT INTO `rbac_ta` VALUES (32,1);
INSERT INTO `rbac_ta` VALUES (32,2);
INSERT INTO `rbac_ta` VALUES (32,3);
INSERT INTO `rbac_ta` VALUES (32,4);
INSERT INTO `rbac_ta` VALUES (32,6);
INSERT INTO `rbac_ta` VALUES (32,7);
INSERT INTO `rbac_ta` VALUES (32,8);
INSERT INTO `rbac_ta` VALUES (33,1);
INSERT INTO `rbac_ta` VALUES (33,2);
INSERT INTO `rbac_ta` VALUES (33,3);
INSERT INTO `rbac_ta` VALUES (33,4);
INSERT INTO `rbac_ta` VALUES (33,16);
INSERT INTO `rbac_ta` VALUES (34,1);
INSERT INTO `rbac_ta` VALUES (34,2);
INSERT INTO `rbac_ta` VALUES (34,3);
INSERT INTO `rbac_ta` VALUES (34,4);
INSERT INTO `rbac_ta` VALUES (34,6);
INSERT INTO `rbac_ta` VALUES (34,7);
INSERT INTO `rbac_ta` VALUES (34,8);
INSERT INTO `rbac_ta` VALUES (34,55);
INSERT INTO `rbac_ta` VALUES (37,1);
INSERT INTO `rbac_ta` VALUES (37,2);
INSERT INTO `rbac_ta` VALUES (37,3);
INSERT INTO `rbac_ta` VALUES (37,4);
INSERT INTO `rbac_ta` VALUES (37,6);
INSERT INTO `rbac_ta` VALUES (37,9);
INSERT INTO `rbac_ta` VALUES (37,10);
INSERT INTO `rbac_ta` VALUES (84,1);
INSERT INTO `rbac_ta` VALUES (84,2);
INSERT INTO `rbac_ta` VALUES (84,3);
INSERT INTO `rbac_ta` VALUES (84,4);
INSERT INTO `rbac_ta` VALUES (84,6);
INSERT INTO `rbac_ta` VALUES (84,55);
INSERT INTO `rbac_ta` VALUES (85,1);
INSERT INTO `rbac_ta` VALUES (85,2);
INSERT INTO `rbac_ta` VALUES (85,3);
INSERT INTO `rbac_ta` VALUES (85,4);
INSERT INTO `rbac_ta` VALUES (87,1);
INSERT INTO `rbac_ta` VALUES (87,2);
INSERT INTO `rbac_ta` VALUES (87,3);
INSERT INTO `rbac_ta` VALUES (87,4);
INSERT INTO `rbac_ta` VALUES (87,6);
INSERT INTO `rbac_ta` VALUES (87,17);
INSERT INTO `rbac_ta` VALUES (87,18);
INSERT INTO `rbac_ta` VALUES (87,20);
INSERT INTO `rbac_ta` VALUES (87,21);
INSERT INTO `rbac_ta` VALUES (87,22);
INSERT INTO `rbac_ta` VALUES (87,23);
INSERT INTO `rbac_ta` VALUES (87,24);
INSERT INTO `rbac_ta` VALUES (87,25);
INSERT INTO `rbac_ta` VALUES (87,26);
INSERT INTO `rbac_ta` VALUES (87,27);
INSERT INTO `rbac_ta` VALUES (87,28);
INSERT INTO `rbac_ta` VALUES (87,29);
INSERT INTO `rbac_ta` VALUES (87,31);
INSERT INTO `rbac_ta` VALUES (87,32);
INSERT INTO `rbac_ta` VALUES (87,42);
INSERT INTO `rbac_ta` VALUES (87,43);
INSERT INTO `rbac_ta` VALUES (87,50);
INSERT INTO `rbac_ta` VALUES (87,53);
INSERT INTO `rbac_ta` VALUES (87,55);
INSERT INTO `rbac_ta` VALUES (88,1);
INSERT INTO `rbac_ta` VALUES (88,2);
INSERT INTO `rbac_ta` VALUES (88,3);
INSERT INTO `rbac_ta` VALUES (88,4);
INSERT INTO `rbac_ta` VALUES (88,6);
INSERT INTO `rbac_ta` VALUES (94,1);
INSERT INTO `rbac_ta` VALUES (94,2);
INSERT INTO `rbac_ta` VALUES (94,3);
INSERT INTO `rbac_ta` VALUES (94,4);
INSERT INTO `rbac_ta` VALUES (94,6);
INSERT INTO `rbac_ta` VALUES (94,55);
INSERT INTO `rbac_ta` VALUES (95,1);
INSERT INTO `rbac_ta` VALUES (95,2);
INSERT INTO `rbac_ta` VALUES (95,3);
INSERT INTO `rbac_ta` VALUES (95,4);
INSERT INTO `rbac_ta` VALUES (95,6);
INSERT INTO `rbac_ta` VALUES (96,1);
INSERT INTO `rbac_ta` VALUES (96,2);
INSERT INTO `rbac_ta` VALUES (96,3);
INSERT INTO `rbac_ta` VALUES (96,4);
INSERT INTO `rbac_ta` VALUES (96,6);
INSERT INTO `rbac_ta` VALUES (96,52);
INSERT INTO `rbac_ta` VALUES (97,1);
INSERT INTO `rbac_ta` VALUES (97,2);
INSERT INTO `rbac_ta` VALUES (97,3);
INSERT INTO `rbac_ta` VALUES (97,4);
INSERT INTO `rbac_ta` VALUES (101,1);
INSERT INTO `rbac_ta` VALUES (101,2);
INSERT INTO `rbac_ta` VALUES (101,3);
INSERT INTO `rbac_ta` VALUES (101,4);
INSERT INTO `rbac_ta` VALUES (101,6);
INSERT INTO `rbac_ta` VALUES (102,1);
INSERT INTO `rbac_ta` VALUES (102,2);
INSERT INTO `rbac_ta` VALUES (102,3);
INSERT INTO `rbac_ta` VALUES (102,4);
INSERT INTO `rbac_ta` VALUES (102,6);
INSERT INTO `rbac_ta` VALUES (102,55);
INSERT INTO `rbac_ta` VALUES (103,1);
INSERT INTO `rbac_ta` VALUES (103,2);
INSERT INTO `rbac_ta` VALUES (103,3);
INSERT INTO `rbac_ta` VALUES (103,4);
INSERT INTO `rbac_ta` VALUES (103,6);
INSERT INTO `rbac_ta` VALUES (103,45);
INSERT INTO `rbac_ta` VALUES (103,46);
INSERT INTO `rbac_ta` VALUES (104,1);
INSERT INTO `rbac_ta` VALUES (104,2);
INSERT INTO `rbac_ta` VALUES (104,3);
INSERT INTO `rbac_ta` VALUES (104,4);
INSERT INTO `rbac_ta` VALUES (104,6);
INSERT INTO `rbac_ta` VALUES (105,1);
INSERT INTO `rbac_ta` VALUES (105,2);
INSERT INTO `rbac_ta` VALUES (105,3);
INSERT INTO `rbac_ta` VALUES (105,4);
INSERT INTO `rbac_ta` VALUES (105,6);
INSERT INTO `rbac_ta` VALUES (106,1);
INSERT INTO `rbac_ta` VALUES (106,2);
INSERT INTO `rbac_ta` VALUES (106,3);
INSERT INTO `rbac_ta` VALUES (106,4);
INSERT INTO `rbac_ta` VALUES (108,1);
INSERT INTO `rbac_ta` VALUES (108,2);
INSERT INTO `rbac_ta` VALUES (108,3);
INSERT INTO `rbac_ta` VALUES (108,6);
INSERT INTO `rbac_ta` VALUES (113,1);
INSERT INTO `rbac_ta` VALUES (113,2);
INSERT INTO `rbac_ta` VALUES (113,3);
INSERT INTO `rbac_ta` VALUES (113,4);
INSERT INTO `rbac_ta` VALUES (115,1);
INSERT INTO `rbac_ta` VALUES (115,2);
INSERT INTO `rbac_ta` VALUES (115,3);
INSERT INTO `rbac_ta` VALUES (115,4);
INSERT INTO `rbac_ta` VALUES (117,1);
INSERT INTO `rbac_ta` VALUES (117,2);
INSERT INTO `rbac_ta` VALUES (117,3);
INSERT INTO `rbac_ta` VALUES (117,4);
INSERT INTO `rbac_ta` VALUES (119,1);
INSERT INTO `rbac_ta` VALUES (119,2);
INSERT INTO `rbac_ta` VALUES (119,3);
INSERT INTO `rbac_ta` VALUES (119,4);
INSERT INTO `rbac_ta` VALUES (119,6);
INSERT INTO `rbac_ta` VALUES (119,7);
INSERT INTO `rbac_ta` VALUES (119,8);
INSERT INTO `rbac_ta` VALUES (119,54);
INSERT INTO `rbac_ta` VALUES (122,1);
INSERT INTO `rbac_ta` VALUES (122,2);
INSERT INTO `rbac_ta` VALUES (122,3);
INSERT INTO `rbac_ta` VALUES (122,4);
INSERT INTO `rbac_ta` VALUES (122,6);
INSERT INTO `rbac_ta` VALUES (122,7);
INSERT INTO `rbac_ta` VALUES (122,8);
INSERT INTO `rbac_ta` VALUES (123,1);
INSERT INTO `rbac_ta` VALUES (123,2);
INSERT INTO `rbac_ta` VALUES (123,3);
INSERT INTO `rbac_ta` VALUES (123,4);
INSERT INTO `rbac_ta` VALUES (123,51);
INSERT INTO `rbac_ta` VALUES (127,1);
INSERT INTO `rbac_ta` VALUES (127,2);
INSERT INTO `rbac_ta` VALUES (127,3);
INSERT INTO `rbac_ta` VALUES (127,4);
INSERT INTO `rbac_ta` VALUES (135,1);
INSERT INTO `rbac_ta` VALUES (135,2);
INSERT INTO `rbac_ta` VALUES (135,3);
INSERT INTO `rbac_ta` VALUES (135,4);

--
-- Table structure for table `rbac_templates`
--

CREATE TABLE `rbac_templates` (
  `rol_id` int(11) NOT NULL default '0',
  `type` char(5) NOT NULL default '',
  `ops_id` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  KEY `rol_id` (`rol_id`),
  KEY `type` (`type`),
  KEY `ops_id` (`ops_id`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_templates`
--

INSERT INTO `rbac_templates` VALUES (3,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (5,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (5,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (5,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (5,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (5,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (5,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (5,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (5,'root',3,8);
INSERT INTO `rbac_templates` VALUES (5,'root',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',23,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (4,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (4,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (4,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (4,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (4,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (4,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (4,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (4,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (4,'mail',30,8);
INSERT INTO `rbac_templates` VALUES (4,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (4,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (4,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (4,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (5,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (5,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (5,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (4,'root',3,8);
INSERT INTO `rbac_templates` VALUES (4,'root',2,8);
INSERT INTO `rbac_templates` VALUES (4,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (4,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (4,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (5,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (4,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (83,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (4,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (5,'file',2,8);
INSERT INTO `rbac_templates` VALUES (4,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (4,'file',3,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',8,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',7,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (5,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (4,'file',2,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (4,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (81,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (4,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (4,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (4,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (4,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (81,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (4,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (81,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (81,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (81,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (81,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (81,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (81,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (81,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (81,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (81,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (5,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (14,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (14,'root',3,8);
INSERT INTO `rbac_templates` VALUES (14,'root',2,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (83,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (14,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (4,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (3,'file',6,8);
INSERT INTO `rbac_templates` VALUES (3,'file',4,8);
INSERT INTO `rbac_templates` VALUES (3,'file',3,8);
INSERT INTO `rbac_templates` VALUES (3,'file',2,8);
INSERT INTO `rbac_templates` VALUES (3,'file',1,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (81,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (81,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (81,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (81,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (81,'file',3,8);
INSERT INTO `rbac_templates` VALUES (81,'file',2,8);
INSERT INTO `rbac_templates` VALUES (81,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (81,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (81,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (81,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (81,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (81,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (80,'file',6,8);
INSERT INTO `rbac_templates` VALUES (80,'file',4,8);
INSERT INTO `rbac_templates` VALUES (80,'file',3,8);
INSERT INTO `rbac_templates` VALUES (80,'file',2,8);
INSERT INTO `rbac_templates` VALUES (80,'file',1,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (4,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (5,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (4,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (5,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (4,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (5,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',23,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',23,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (110,'file',6,8);
INSERT INTO `rbac_templates` VALUES (110,'file',4,8);
INSERT INTO `rbac_templates` VALUES (110,'file',3,8);
INSERT INTO `rbac_templates` VALUES (110,'file',2,8);
INSERT INTO `rbac_templates` VALUES (110,'file',1,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',32,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',31,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',28,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',27,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',22,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',21,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',20,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (111,'file',4,8);
INSERT INTO `rbac_templates` VALUES (111,'file',3,8);
INSERT INTO `rbac_templates` VALUES (111,'file',2,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (112,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (112,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (112,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (112,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (112,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (112,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (112,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (112,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (112,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (112,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (112,'file',3,8);
INSERT INTO `rbac_templates` VALUES (112,'file',2,8);
INSERT INTO `rbac_templates` VALUES (112,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (112,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (112,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (112,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (112,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (112,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (125,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (125,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (125,'file',6,8);
INSERT INTO `rbac_templates` VALUES (125,'file',2,8);
INSERT INTO `rbac_templates` VALUES (125,'file',1,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',48,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',47,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',23,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',6,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',4,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',1,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',32,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',31,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',28,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',27,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',22,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',21,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',20,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (126,'file',2,8);
INSERT INTO `rbac_templates` VALUES (126,'file',3,8);
INSERT INTO `rbac_templates` VALUES (126,'file',4,8);
INSERT INTO `rbac_templates` VALUES (126,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (126,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (111,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (111,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (112,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (112,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (112,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',1,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',2,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',3,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',4,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',6,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',7,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',8,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',54,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',1,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',2,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',3,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',4,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',6,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',14,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',2,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',3,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',7,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',8,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',55,8);

--
-- Table structure for table `rbac_ua`
--

CREATE TABLE `rbac_ua` (
  `usr_id` int(11) NOT NULL default '0',
  `rol_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`rol_id`),
  KEY `usr_id` (`usr_id`),
  KEY `rol_id` (`rol_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_ua`
--

INSERT INTO `rbac_ua` VALUES (6,2);
INSERT INTO `rbac_ua` VALUES (13,14);

--
-- Table structure for table `reg_email_role_assignments`
--

CREATE TABLE `reg_email_role_assignments` (
  `assignment_id` int(11) NOT NULL auto_increment,
  `domain` varchar(128) NOT NULL default '',
  `role` int(11) NOT NULL default '0',
  PRIMARY KEY  (`assignment_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `reg_email_role_assignments`
--

INSERT INTO `reg_email_role_assignments` VALUES (1,'',0);

--
-- Table structure for table `role_data`
--

CREATE TABLE `role_data` (
  `role_id` int(11) NOT NULL default '0',
  `allow_register` tinyint(1) unsigned NOT NULL default '0',
  `assign_users` char(2) default '0',
  `auth_mode` enum('default','local','ldap','radius','shibboleth','script','cas','soap') NOT NULL default 'default',
  PRIMARY KEY  (`role_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `role_data`
--

INSERT INTO `role_data` VALUES (2,0,'0','default');
INSERT INTO `role_data` VALUES (3,0,'0','default');
INSERT INTO `role_data` VALUES (4,0,'0','default');
INSERT INTO `role_data` VALUES (5,1,'0','default');
INSERT INTO `role_data` VALUES (14,0,'0','default');
INSERT INTO `role_data` VALUES (134,0,'0','default');

--
-- Table structure for table `role_desktop_items`
--

CREATE TABLE `role_desktop_items` (
  `role_item_id` int(11) NOT NULL auto_increment,
  `role_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `item_type` char(16) NOT NULL default '',
  KEY `role_item_id` (`role_item_id`,`role_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `role_desktop_items`
--


--
-- Table structure for table `sahs_lm`
--

CREATE TABLE `sahs_lm` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `api_adapter` varchar(80) default 'API',
  `api_func_prefix` varchar(20) default 'LMS',
  `credit` enum('credit','no_credit') NOT NULL default 'credit',
  `default_lesson_mode` enum('normal','browse') NOT NULL default 'normal',
  `auto_review` enum('y','n') NOT NULL default 'n',
  `type` enum('scorm','aicc','hacp') default 'scorm',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sahs_lm`
--


--
-- Table structure for table `sc_item`
--

CREATE TABLE `sc_item` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `identifierref` varchar(200) default NULL,
  `isvisible` enum('','true','false') default '',
  `parameters` text,
  `prereq_type` varchar(200) default NULL,
  `prerequisites` text,
  `maxtimeallowed` varchar(30) default NULL,
  `timelimitaction` varchar(30) default NULL,
  `datafromlms` text,
  `masteryscore` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_item`
--


--
-- Table structure for table `sc_manifest`
--

CREATE TABLE `sc_manifest` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `version` varchar(200) default NULL,
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_manifest`
--


--
-- Table structure for table `sc_organization`
--

CREATE TABLE `sc_organization` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `structure` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_organization`
--


--
-- Table structure for table `sc_organizations`
--

CREATE TABLE `sc_organizations` (
  `obj_id` int(11) NOT NULL default '0',
  `default_organization` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_organizations`
--


--
-- Table structure for table `sc_resource`
--

CREATE TABLE `sc_resource` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `resourcetype` varchar(30) default NULL,
  `scormtype` enum('sco','asset') default NULL,
  `href` varchar(250) default NULL,
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`),
  KEY `import_id` (`import_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource`
--


--
-- Table structure for table `sc_resource_dependency`
--

CREATE TABLE `sc_resource_dependency` (
  `id` int(11) NOT NULL auto_increment,
  `res_id` int(11) default NULL,
  `identifierref` varchar(200) default NULL,
  `nr` int(11) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource_dependency`
--


--
-- Table structure for table `sc_resource_file`
--

CREATE TABLE `sc_resource_file` (
  `id` int(11) NOT NULL auto_increment,
  `res_id` int(11) default NULL,
  `href` text,
  `nr` int(11) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource_file`
--


--
-- Table structure for table `sc_resources`
--

CREATE TABLE `sc_resources` (
  `obj_id` int(11) NOT NULL default '0',
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resources`
--


--
-- Table structure for table `scorm_object`
--

CREATE TABLE `scorm_object` (
  `obj_id` int(11) NOT NULL auto_increment,
  `title` varchar(200) default NULL,
  `type` char(3) default NULL,
  `slm_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_object`
--


--
-- Table structure for table `scorm_tracking`
--

CREATE TABLE `scorm_tracking` (
  `user_id` int(11) NOT NULL default '0',
  `sco_id` int(11) NOT NULL default '0',
  `lvalue` varchar(64) NOT NULL default '',
  `rvalue` text,
  `obj_id` int(11) default NULL,
  PRIMARY KEY  (`user_id`,`sco_id`,`lvalue`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_tracking`
--


--
-- Table structure for table `scorm_tree`
--

CREATE TABLE `scorm_tree` (
  `slm_id` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_tree`
--


--
-- Table structure for table `search_data`
--

CREATE TABLE `search_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `target` text NOT NULL,
  `type` varchar(4) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `search_data`
--


--
-- Table structure for table `search_tree`
--

CREATE TABLE `search_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `search_tree`
--


--
-- Table structure for table `service`
--

CREATE TABLE `service` (
  `name` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`name`)
) TYPE=MyISAM COMMENT='ILIAS Modules';

--
-- Dumping data for table `service`
--

INSERT INTO `service` VALUES ('Help','Services/Help');
INSERT INTO `service` VALUES ('PersonalDesktop','.');
INSERT INTO `service` VALUES ('Administration','.');
INSERT INTO `service` VALUES ('Initialisation','Services/Init');

--
-- Table structure for table `service_class`
--

CREATE TABLE `service_class` (
  `class` varchar(100) NOT NULL default '',
  `service` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`class`)
) TYPE=MyISAM COMMENT='Class information of ILIAS Modules';

--
-- Dumping data for table `service_class`
--

INSERT INTO `service_class` VALUES ('ilHelpGUI','Help','classes');
INSERT INTO `service_class` VALUES ('ilPersonalDesktopGUI','PersonalDesktop','classes');
INSERT INTO `service_class` VALUES ('ilAdministrationGUI','Administration','classes');
INSERT INTO `service_class` VALUES ('ilStartUpGUI','Initialisation','classes');

--
-- Table structure for table `settings`
--

CREATE TABLE `settings` (
  `module` varchar(50) NOT NULL default 'common',
  `keyword` varchar(50) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`module`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `settings`
--

INSERT INTO `settings` VALUES ('common','convert_path','');
INSERT INTO `settings` VALUES ('common','db_version','821');
INSERT INTO `settings` VALUES ('common','ilias_version','3.2.3 2004-11-22');
INSERT INTO `settings` VALUES ('common','inst_info','');
INSERT INTO `settings` VALUES ('common','inst_name','');
INSERT INTO `settings` VALUES ('common','java_path','');
INSERT INTO `settings` VALUES ('common','language','en');
INSERT INTO `settings` VALUES ('common','ldap_basedn','');
INSERT INTO `settings` VALUES ('common','ldap_port','');
INSERT INTO `settings` VALUES ('common','ldap_server','');
INSERT INTO `settings` VALUES ('common','system_user_id','6');
INSERT INTO `settings` VALUES ('common','anonymous_role_id','14');
INSERT INTO `settings` VALUES ('common','error_recipient','');
INSERT INTO `settings` VALUES ('common','pub_section','');
INSERT INTO `settings` VALUES ('common','feedback_recipient','');
INSERT INTO `settings` VALUES ('common','unzip_path','');
INSERT INTO `settings` VALUES ('common','anonymous_user_id','13');
INSERT INTO `settings` VALUES ('common','zip_path','');
INSERT INTO `settings` VALUES ('common','enable_registration','1');
INSERT INTO `settings` VALUES ('common','system_role_id','2');
INSERT INTO `settings` VALUES ('common','recovery_folder_id','15');
INSERT INTO `settings` VALUES ('common','bench_max_records','10000');
INSERT INTO `settings` VALUES ('common','enable_bench','0');
INSERT INTO `settings` VALUES ('common','sys_user_tracking_id','17');
INSERT INTO `settings` VALUES ('common','enable_tracking','0');
INSERT INTO `settings` VALUES ('common','save_user_related_data','0');
INSERT INTO `settings` VALUES ('common','auth_mode','1');
INSERT INTO `settings` VALUES ('common','auto_registration','1');
INSERT INTO `settings` VALUES ('common','approve_recipient','');
INSERT INTO `settings` VALUES ('common','require_login','1');
INSERT INTO `settings` VALUES ('common','require_passwd','1');
INSERT INTO `settings` VALUES ('common','require_passwd2','1');
INSERT INTO `settings` VALUES ('common','require_firstname','1');
INSERT INTO `settings` VALUES ('common','require_gender','1');
INSERT INTO `settings` VALUES ('common','require_lastname','1');
INSERT INTO `settings` VALUES ('common','require_institution','');
INSERT INTO `settings` VALUES ('common','require_department','');
INSERT INTO `settings` VALUES ('common','require_street','');
INSERT INTO `settings` VALUES ('common','require_city','');
INSERT INTO `settings` VALUES ('common','require_zipcode','');
INSERT INTO `settings` VALUES ('common','require_country','');
INSERT INTO `settings` VALUES ('common','require_phone_office','');
INSERT INTO `settings` VALUES ('common','require_phone_home','');
INSERT INTO `settings` VALUES ('common','require_phone_mobile','');
INSERT INTO `settings` VALUES ('common','require_fax','');
INSERT INTO `settings` VALUES ('common','require_email','1');
INSERT INTO `settings` VALUES ('common','require_hobby','');
INSERT INTO `settings` VALUES ('common','require_default_role','1');
INSERT INTO `settings` VALUES ('common','require_referral_comment','');
INSERT INTO `settings` VALUES ('common','enable_js_edit','1');
INSERT INTO `settings` VALUES ('common','sys_assessment_folder_id','20');
INSERT INTO `settings` VALUES ('common','default_repository_view','flat');
INSERT INTO `settings` VALUES ('common','enable_calendar','1');
INSERT INTO `settings` VALUES ('common','custom_icon_big_width','32');
INSERT INTO `settings` VALUES ('common','custom_icon_big_height','32');
INSERT INTO `settings` VALUES ('common','custom_icon_small_width','22');
INSERT INTO `settings` VALUES ('common','custom_icon_small_height','22');
INSERT INTO `settings` VALUES ('common','icon_position_in_lists','header');
INSERT INTO `settings` VALUES ('common','new_registration_type','2');
INSERT INTO `settings` VALUES ('common','enable_trash','1');
INSERT INTO `settings` VALUES ('common','sys_advanced_editing_id','26');
INSERT INTO `settings` VALUES ('common','ilinc_akclassvalues_required','1');
INSERT INTO `settings` VALUES ('common','shib_hos_type','external_wayf');
INSERT INTO `settings` VALUES ('common','shib_federation_name','Shibboleth');
INSERT INTO `settings` VALUES ('common','shib_idp_list','');

--
-- Table structure for table `settings_deactivated_styles`
--

CREATE TABLE `settings_deactivated_styles` (
  `skin` varchar(100) NOT NULL default '',
  `style` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`skin`,`style`)
) TYPE=MyISAM;

--
-- Dumping data for table `settings_deactivated_styles`
--


--
-- Table structure for table `style_data`
--

CREATE TABLE `style_data` (
  `id` int(11) NOT NULL default '0',
  `uptodate` tinyint(2) default '0',
  `standard` tinyint(2) default '0',
  `category` int(11) default NULL,
  `active` tinyint(2) default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_data`
--


--
-- Table structure for table `style_folder_styles`
--

CREATE TABLE `style_folder_styles` (
  `folder_id` int(11) NOT NULL default '0',
  `style_id` int(11) NOT NULL default '0',
  KEY `f_id` (`folder_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_folder_styles`
--


--
-- Table structure for table `style_parameter`
--

CREATE TABLE `style_parameter` (
  `id` int(11) NOT NULL auto_increment,
  `style_id` int(11) NOT NULL default '0',
  `tag` varchar(100) default NULL,
  `class` varchar(100) default NULL,
  `parameter` varchar(100) default NULL,
  `value` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_parameter`
--


--
-- Table structure for table `survey_anonymous`
--

CREATE TABLE `survey_anonymous` (
  `anonymous_id` int(11) NOT NULL auto_increment,
  `survey_key` varchar(32) NOT NULL default '',
  `survey_fi` int(11) NOT NULL default '0',
  `user_key` varchar(40) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`anonymous_id`),
  KEY `survey_key` (`survey_key`,`survey_fi`),
  KEY `survey_fi` (`survey_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_anonymous`
--


--
-- Table structure for table `survey_answer`
--

CREATE TABLE `survey_answer` (
  `answer_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `anonymous_id` varchar(32) NOT NULL default '',
  `value` double default NULL,
  `textanswer` text,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`),
  KEY `user_fi` (`user_fi`),
  KEY `anonymous_id` (`anonymous_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_answer`
--


--
-- Table structure for table `survey_category`
--

CREATE TABLE `survey_category` (
  `category_id` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `defaultvalue` enum('0','1') NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`category_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_category`
--

INSERT INTO `survey_category` VALUES (1,'dc_desired','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (2,'dc_undesired','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (3,'dc_agree','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (4,'dc_disagree','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (5,'dc_good','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (6,'dc_notacceptable','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (7,'dc_should','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (8,'dc_shouldnot','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (9,'dc_true','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (10,'dc_false','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (11,'dc_always','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (12,'dc_never','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (13,'dc_yes','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (14,'dc_no','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (15,'dc_neutral','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (16,'dc_undecided','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (17,'dc_fair','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (18,'dc_sometimes','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (19,'dc_stronglydesired','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (20,'dc_stronglyundesired','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (21,'dc_stronglyagree','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (22,'dc_stronglydisagree','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (23,'dc_verygood','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (24,'dc_poor','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (25,'dc_must','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (26,'dc_mustnot','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (27,'dc_definitelytrue','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (28,'dc_definitelyfalse','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (29,'dc_manytimes','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (30,'dc_varying','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (31,'dc_rarely','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (32,'dc_mostcertainly','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (33,'dc_morepositive','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (34,'dc_morenegative','1',0,20040522134301);
INSERT INTO `survey_category` VALUES (35,'dc_mostcertainlynot','1',0,20040522134301);

--
-- Table structure for table `survey_constraint`
--

CREATE TABLE `survey_constraint` (
  `constraint_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `relation_fi` int(11) NOT NULL default '0',
  `value` double NOT NULL default '0',
  PRIMARY KEY  (`constraint_id`),
  KEY `question_fi` (`question_fi`),
  KEY `relation_fi` (`relation_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_constraint`
--


--
-- Table structure for table `survey_finished`
--

CREATE TABLE `survey_finished` (
  `finished_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `anonymous_id` varchar(32) default NULL,
  `state` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`finished_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `user_fi` (`user_fi`),
  KEY `anonymous_id` (`anonymous_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_finished`
--


--
-- Table structure for table `survey_invited_group`
--

CREATE TABLE `survey_invited_group` (
  `invited_group_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `group_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`invited_group_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `group_fi` (`group_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_invited_group`
--


--
-- Table structure for table `survey_invited_user`
--

CREATE TABLE `survey_invited_user` (
  `invited_user_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`invited_user_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `user_fi` (`user_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_invited_user`
--


--
-- Table structure for table `survey_material`
--

CREATE TABLE `survey_material` (
  `material_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `internal_link` varchar(50) default NULL,
  `import_id` varchar(50) default NULL,
  `material_title` varchar(255) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`material_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_material`
--


--
-- Table structure for table `survey_phrase`
--

CREATE TABLE `survey_phrase` (
  `phrase_id` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `defaultvalue` enum('0','1','2') NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`phrase_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_phrase`
--

INSERT INTO `survey_phrase` VALUES (1,'dp_standard_attitude_desired_undesired','1',0,20040522135431);
INSERT INTO `survey_phrase` VALUES (2,'dp_standard_attitude_agree_disagree','1',0,20040522135458);
INSERT INTO `survey_phrase` VALUES (3,'dp_standard_attitude_good_notacceptable','1',0,20040522135518);
INSERT INTO `survey_phrase` VALUES (4,'dp_standard_attitude_shold_shouldnot','1',0,20040522135546);
INSERT INTO `survey_phrase` VALUES (5,'dp_standard_beliefs_true_false','1',0,20040522135613);
INSERT INTO `survey_phrase` VALUES (6,'dp_standard_beliefs_always_never','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (7,'dp_standard_behaviour_yes_no','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (8,'dp_standard_attitude_desired_neutral_undesired','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (9,'dp_standard_attitude_agree_undecided_disagree','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (10,'dp_standard_attitude_good_fair_notacceptable','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (11,'dp_standard_attitude_should_undecided_shouldnot','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (12,'dp_standard_beliefs_true_undecided_false','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (13,'dp_standard_beliefs_always_sometimes_never','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (14,'dp_standard_behaviour_yes_undecided_no','1',0,20040522140547);
INSERT INTO `survey_phrase` VALUES (15,'dp_standard_attitude_desired5','1',0,20040522150702);
INSERT INTO `survey_phrase` VALUES (16,'dp_standard_attitude_agree5','1',0,20040522150717);
INSERT INTO `survey_phrase` VALUES (17,'dp_standard_attitude_good5','1',0,20040522150729);
INSERT INTO `survey_phrase` VALUES (18,'dp_standard_attitude_must5','1',0,20040522150744);
INSERT INTO `survey_phrase` VALUES (19,'dp_standard_beliefs_true5','1',0,20040522150754);
INSERT INTO `survey_phrase` VALUES (20,'dp_standard_beliefs_always5','1',0,20040522150812);
INSERT INTO `survey_phrase` VALUES (21,'dp_standard_behaviour_certainly5','1',0,20040522150828);
INSERT INTO `survey_phrase` VALUES (22,'dp_standard_numbers','1',0,20040621012719);

--
-- Table structure for table `survey_phrase_category`
--

CREATE TABLE `survey_phrase_category` (
  `phrase_category_id` int(11) NOT NULL auto_increment,
  `phrase_fi` int(11) NOT NULL default '0',
  `category_fi` int(11) NOT NULL default '0',
  `sequence` int(11) NOT NULL default '0',
  PRIMARY KEY  (`phrase_category_id`),
  KEY `phrase_fi` (`phrase_fi`),
  KEY `category_fi` (`category_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_phrase_category`
--

INSERT INTO `survey_phrase_category` VALUES (1,1,1,1);
INSERT INTO `survey_phrase_category` VALUES (2,1,2,2);
INSERT INTO `survey_phrase_category` VALUES (3,2,3,1);
INSERT INTO `survey_phrase_category` VALUES (4,2,4,2);
INSERT INTO `survey_phrase_category` VALUES (5,3,5,1);
INSERT INTO `survey_phrase_category` VALUES (6,3,6,2);
INSERT INTO `survey_phrase_category` VALUES (7,4,7,1);
INSERT INTO `survey_phrase_category` VALUES (8,4,8,2);
INSERT INTO `survey_phrase_category` VALUES (9,5,9,1);
INSERT INTO `survey_phrase_category` VALUES (10,5,10,2);
INSERT INTO `survey_phrase_category` VALUES (11,6,11,1);
INSERT INTO `survey_phrase_category` VALUES (12,6,12,2);
INSERT INTO `survey_phrase_category` VALUES (13,7,13,1);
INSERT INTO `survey_phrase_category` VALUES (14,7,14,2);
INSERT INTO `survey_phrase_category` VALUES (15,8,1,1);
INSERT INTO `survey_phrase_category` VALUES (16,8,15,2);
INSERT INTO `survey_phrase_category` VALUES (17,8,2,3);
INSERT INTO `survey_phrase_category` VALUES (18,9,3,1);
INSERT INTO `survey_phrase_category` VALUES (19,9,16,2);
INSERT INTO `survey_phrase_category` VALUES (20,9,4,3);
INSERT INTO `survey_phrase_category` VALUES (21,10,5,1);
INSERT INTO `survey_phrase_category` VALUES (22,10,17,2);
INSERT INTO `survey_phrase_category` VALUES (23,10,6,3);
INSERT INTO `survey_phrase_category` VALUES (24,11,7,1);
INSERT INTO `survey_phrase_category` VALUES (25,11,16,2);
INSERT INTO `survey_phrase_category` VALUES (26,11,8,3);
INSERT INTO `survey_phrase_category` VALUES (27,12,9,1);
INSERT INTO `survey_phrase_category` VALUES (28,12,16,2);
INSERT INTO `survey_phrase_category` VALUES (29,12,10,3);
INSERT INTO `survey_phrase_category` VALUES (30,13,11,1);
INSERT INTO `survey_phrase_category` VALUES (31,13,18,2);
INSERT INTO `survey_phrase_category` VALUES (32,13,12,3);
INSERT INTO `survey_phrase_category` VALUES (33,14,13,1);
INSERT INTO `survey_phrase_category` VALUES (34,14,16,2);
INSERT INTO `survey_phrase_category` VALUES (35,14,14,3);
INSERT INTO `survey_phrase_category` VALUES (36,15,19,1);
INSERT INTO `survey_phrase_category` VALUES (37,15,1,2);
INSERT INTO `survey_phrase_category` VALUES (38,15,15,3);
INSERT INTO `survey_phrase_category` VALUES (39,15,2,4);
INSERT INTO `survey_phrase_category` VALUES (40,15,20,5);
INSERT INTO `survey_phrase_category` VALUES (41,16,21,1);
INSERT INTO `survey_phrase_category` VALUES (42,16,3,2);
INSERT INTO `survey_phrase_category` VALUES (43,16,16,3);
INSERT INTO `survey_phrase_category` VALUES (44,16,4,4);
INSERT INTO `survey_phrase_category` VALUES (45,16,22,5);
INSERT INTO `survey_phrase_category` VALUES (46,17,23,1);
INSERT INTO `survey_phrase_category` VALUES (47,17,5,2);
INSERT INTO `survey_phrase_category` VALUES (48,17,17,3);
INSERT INTO `survey_phrase_category` VALUES (49,17,24,4);
INSERT INTO `survey_phrase_category` VALUES (50,17,6,5);
INSERT INTO `survey_phrase_category` VALUES (51,18,25,1);
INSERT INTO `survey_phrase_category` VALUES (52,18,7,2);
INSERT INTO `survey_phrase_category` VALUES (53,18,16,3);
INSERT INTO `survey_phrase_category` VALUES (54,18,8,4);
INSERT INTO `survey_phrase_category` VALUES (55,18,26,5);
INSERT INTO `survey_phrase_category` VALUES (56,19,27,1);
INSERT INTO `survey_phrase_category` VALUES (57,19,9,2);
INSERT INTO `survey_phrase_category` VALUES (58,19,16,3);
INSERT INTO `survey_phrase_category` VALUES (59,19,10,4);
INSERT INTO `survey_phrase_category` VALUES (60,19,28,5);
INSERT INTO `survey_phrase_category` VALUES (61,20,11,1);
INSERT INTO `survey_phrase_category` VALUES (62,20,29,2);
INSERT INTO `survey_phrase_category` VALUES (63,20,30,3);
INSERT INTO `survey_phrase_category` VALUES (64,20,31,4);
INSERT INTO `survey_phrase_category` VALUES (65,20,12,5);
INSERT INTO `survey_phrase_category` VALUES (66,21,32,1);
INSERT INTO `survey_phrase_category` VALUES (67,21,33,2);
INSERT INTO `survey_phrase_category` VALUES (68,21,16,3);
INSERT INTO `survey_phrase_category` VALUES (69,21,34,4);
INSERT INTO `survey_phrase_category` VALUES (70,21,35,5);

--
-- Table structure for table `survey_question`
--

CREATE TABLE `survey_question` (
  `question_id` int(11) NOT NULL auto_increment,
  `questiontype_fi` int(11) NOT NULL default '0',
  `obj_fi` int(11) unsigned NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `author` varchar(100) NOT NULL default '',
  `questiontext` text NOT NULL,
  `obligatory` enum('0','1') NOT NULL default '1',
  `complete` enum('0','1') NOT NULL default '0',
  `created` varchar(14) NOT NULL default '',
  `original_id` int(11) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`question_id`),
  KEY `obj_fi` (`obj_fi`),
  KEY `owner_fi` (`owner_fi`),
  FULLTEXT KEY `title_desc` (`title`,`description`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question`
--


--
-- Table structure for table `survey_question_constraint`
--

CREATE TABLE `survey_question_constraint` (
  `question_constraint_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `constraint_fi` int(11) NOT NULL default '0',
  PRIMARY KEY  (`question_constraint_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`),
  KEY `constraint_fi` (`constraint_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_constraint`
--


--
-- Table structure for table `survey_question_material`
--

CREATE TABLE `survey_question_material` (
  `material_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `materials` text,
  `materials_file` varchar(200) NOT NULL default '',
  UNIQUE KEY `material_id` (`material_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_material`
--


--
-- Table structure for table `survey_question_metric`
--

CREATE TABLE `survey_question_metric` (
  `question_fi` int(11) NOT NULL default '0',
  `subtype` enum('3','4','5') NOT NULL default '3',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_metric`
--


--
-- Table structure for table `survey_question_nominal`
--

CREATE TABLE `survey_question_nominal` (
  `question_fi` int(11) NOT NULL default '0',
  `subtype` enum('1','2') NOT NULL default '1',
  `orientation` enum('0','1','2') NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_nominal`
--


--
-- Table structure for table `survey_question_obligatory`
--

CREATE TABLE `survey_question_obligatory` (
  `question_obligatory_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `obligatory` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`question_obligatory_id`),
  KEY `survey_fi` (`survey_fi`,`question_fi`)
) TYPE=MyISAM COMMENT='Contains the obligatory state of questions in a survey';

--
-- Dumping data for table `survey_question_obligatory`
--


--
-- Table structure for table `survey_question_ordinal`
--

CREATE TABLE `survey_question_ordinal` (
  `question_fi` int(11) NOT NULL default '0',
  `orientation` enum('0','1','2') NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_ordinal`
--


--
-- Table structure for table `survey_question_text`
--

CREATE TABLE `survey_question_text` (
  `question_fi` int(11) NOT NULL default '0',
  `maxchars` int(11) default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_text`
--


--
-- Table structure for table `survey_questionblock`
--

CREATE TABLE `survey_questionblock` (
  `questionblock_id` int(11) NOT NULL auto_increment,
  `title` text,
  `owner_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`questionblock_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionblock`
--


--
-- Table structure for table `survey_questionblock_question`
--

CREATE TABLE `survey_questionblock_question` (
  `questionblock_question_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `questionblock_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  PRIMARY KEY  (`questionblock_question_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `questionblock_fi` (`questionblock_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionblock_question`
--


--
-- Table structure for table `survey_questionpool`
--

CREATE TABLE `survey_questionpool` (
  `id_questionpool` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `online` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`id_questionpool`),
  KEY `obj_fi` (`obj_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionpool`
--


--
-- Table structure for table `survey_questiontype`
--

CREATE TABLE `survey_questiontype` (
  `questiontype_id` int(11) NOT NULL auto_increment,
  `type_tag` varchar(30) NOT NULL default '',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`questiontype_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questiontype`
--

INSERT INTO `survey_questiontype` VALUES (1,'SurveyNominalQuestion',20060711184319);
INSERT INTO `survey_questiontype` VALUES (2,'SurveyOrdinalQuestion',20060711184319);
INSERT INTO `survey_questiontype` VALUES (3,'SurveyMetricQuestion',20060711184319);
INSERT INTO `survey_questiontype` VALUES (4,'SurveyTextQuestion',20060711184319);

--
-- Table structure for table `survey_relation`
--

CREATE TABLE `survey_relation` (
  `relation_id` int(11) NOT NULL auto_increment,
  `longname` varchar(20) NOT NULL default '',
  `shortname` char(2) NOT NULL default '',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`relation_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_relation`
--

INSERT INTO `survey_relation` VALUES (1,'less','<',20040518195753);
INSERT INTO `survey_relation` VALUES (2,'less_or_equal','<=',20040518195808);
INSERT INTO `survey_relation` VALUES (3,'equal','=',20040518195816);
INSERT INTO `survey_relation` VALUES (4,'not_equal','<>',20040518195839);
INSERT INTO `survey_relation` VALUES (5,'more_or_equal','>=',20040518195852);
INSERT INTO `survey_relation` VALUES (6,'more','>',20040518195903);

--
-- Table structure for table `survey_survey`
--

CREATE TABLE `survey_survey` (
  `survey_id` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `author` varchar(50) NOT NULL default '',
  `introduction` text,
  `outro` text,
  `status` enum('0','1') NOT NULL default '1',
  `startdate` date default NULL,
  `enddate` date default NULL,
  `evaluation_access` enum('0','1','2') NOT NULL default '0',
  `invitation` enum('0','1') NOT NULL default '0',
  `invitation_mode` enum('0','1') NOT NULL default '1',
  `complete` enum('0','1') NOT NULL default '0',
  `created` varchar(14) NOT NULL default '',
  `anonymize` enum('0','1','2') NOT NULL default '0',
  `show_question_titles` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`survey_id`),
  KEY `obj_fi` (`obj_fi`),
  FULLTEXT KEY `introduction` (`introduction`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_survey`
--


--
-- Table structure for table `survey_survey_question`
--

CREATE TABLE `survey_survey_question` (
  `survey_question_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(11) NOT NULL default '0',
  `heading` varchar(255) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`survey_question_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_survey_question`
--


--
-- Table structure for table `survey_variable`
--

CREATE TABLE `survey_variable` (
  `variable_id` int(11) NOT NULL auto_increment,
  `category_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `value1` double default NULL,
  `value2` double default NULL,
  `sequence` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`variable_id`),
  KEY `category_fi` (`category_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_variable`
--


--
-- Table structure for table `tree`
--

CREATE TABLE `tree` (
  `tree` int(10) NOT NULL default '0',
  `child` int(10) unsigned NOT NULL default '0',
  `parent` int(10) unsigned default NULL,
  `lft` int(10) unsigned NOT NULL default '0',
  `rgt` int(10) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_tree` (`tree`)
) TYPE=MyISAM;

--
-- Dumping data for table `tree`
--

INSERT INTO `tree` VALUES (1,1,0,1,140,1);
INSERT INTO `tree` VALUES (1,7,9,5,6,3);
INSERT INTO `tree` VALUES (1,8,9,7,8,3);
INSERT INTO `tree` VALUES (1,9,1,2,139,2);
INSERT INTO `tree` VALUES (1,10,9,9,10,3);
INSERT INTO `tree` VALUES (1,11,9,11,12,3);
INSERT INTO `tree` VALUES (1,12,9,3,4,3);
INSERT INTO `tree` VALUES (1,14,9,13,18,3);
INSERT INTO `tree` VALUES (1,15,9,19,20,3);
INSERT INTO `tree` VALUES (1,16,9,21,22,3);
INSERT INTO `tree` VALUES (1,17,9,23,24,3);
INSERT INTO `tree` VALUES (1,18,9,25,26,3);
INSERT INTO `tree` VALUES (1,19,9,27,28,3);
INSERT INTO `tree` VALUES (1,20,9,29,30,3);
INSERT INTO `tree` VALUES (1,21,9,31,32,3);
INSERT INTO `tree` VALUES (1,22,9,33,34,3);
INSERT INTO `tree` VALUES (1,23,9,35,36,3);
INSERT INTO `tree` VALUES (1,24,14,14,17,4);
INSERT INTO `tree` VALUES (1,25,24,15,16,5);
INSERT INTO `tree` VALUES (1,26,9,37,38,3);

--
-- Table structure for table `tst_active`
--

CREATE TABLE `tst_active` (
  `active_id` int(10) unsigned NOT NULL auto_increment,
  `user_fi` int(10) unsigned NOT NULL default '0',
  `anonymous_id` varchar(5) default NULL,
  `test_fi` int(10) unsigned NOT NULL default '0',
  `sequence` text NOT NULL,
  `postponed` text,
  `lastindex` tinyint(4) NOT NULL default '1',
  `tries` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  `submitted` tinyint(3) unsigned default '0',
  `submittimestamp` datetime default NULL,
  PRIMARY KEY  (`active_id`),
  KEY `user_fi` (`user_fi`),
  KEY `test_fi` (`test_fi`),
  KEY `anonymous_id` (`anonymous_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_active`
--


--
-- Table structure for table `tst_active_qst_sol_settings`
--

CREATE TABLE `tst_active_qst_sol_settings` (
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `solved` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`active_fi`,`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_active_qst_sol_settings`
--


--
-- Table structure for table `tst_eval_settings`
--

CREATE TABLE `tst_eval_settings` (
  `eval_settings_id` int(11) NOT NULL auto_increment,
  `user_fi` int(11) NOT NULL default '0',
  `qworkedthrough` enum('0','1') NOT NULL default '1',
  `pworkedthrough` enum('0','1') NOT NULL default '1',
  `timeofwork` enum('0','1') NOT NULL default '1',
  `atimeofwork` enum('0','1') NOT NULL default '1',
  `firstvisit` enum('0','1') NOT NULL default '1',
  `lastvisit` enum('0','1') NOT NULL default '1',
  `resultspoints` enum('0','1') NOT NULL default '1',
  `resultsmarks` enum('0','1') NOT NULL default '1',
  `distancemedian` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`eval_settings_id`),
  KEY `user_fi` (`user_fi`)
) TYPE=MyISAM COMMENT='User settings for statistical evaluation tool';

--
-- Dumping data for table `tst_eval_settings`
--


--
-- Table structure for table `tst_eval_users`
--

CREATE TABLE `tst_eval_users` (
  `test_fi` int(11) NOT NULL default '0',
  `evaluator_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  KEY `test_fi` (`test_fi`,`evaluator_fi`,`user_fi`)
) TYPE=MyISAM COMMENT='Contains the users someone has chosen for a statistical eval';

--
-- Dumping data for table `tst_eval_users`
--


--
-- Table structure for table `tst_invited_user`
--

CREATE TABLE `tst_invited_user` (
  `test_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  `clientip` varchar(15) default NULL,
  PRIMARY KEY  (`test_fi`,`user_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_invited_user`
--


--
-- Table structure for table `tst_mark`
--

CREATE TABLE `tst_mark` (
  `mark_id` int(10) unsigned NOT NULL auto_increment,
  `test_fi` int(10) unsigned NOT NULL default '0',
  `short_name` varchar(15) NOT NULL default '',
  `official_name` varchar(50) NOT NULL default '',
  `minimum_level` double NOT NULL default '0',
  `passed` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`mark_id`),
  KEY `test_fi` (`test_fi`)
) TYPE=MyISAM COMMENT='Mark steps of mark schemas';

--
-- Dumping data for table `tst_mark`
--


--
-- Table structure for table `tst_solutions`
--

CREATE TABLE `tst_solutions` (
  `solution_id` int(10) unsigned NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `value1` text,
  `value2` varchar(50) default NULL,
  `points` double default NULL,
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`solution_id`),
  KEY `question_fi` (`question_fi`),
  KEY `active_fi` (`active_fi`)
) TYPE=MyISAM COMMENT='Test and Assessment solutions';

--
-- Dumping data for table `tst_solutions`
--


--
-- Table structure for table `tst_test_question`
--

CREATE TABLE `tst_test_question` (
  `test_question_id` int(11) NOT NULL auto_increment,
  `test_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(10) unsigned NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`test_question_id`),
  KEY `test_fi` (`test_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM COMMENT='Relation table for questions in tests';

--
-- Dumping data for table `tst_test_question`
--


--
-- Table structure for table `tst_test_random`
--

CREATE TABLE `tst_test_random` (
  `test_random_id` int(11) NOT NULL auto_increment,
  `test_fi` int(11) NOT NULL default '0',
  `questionpool_fi` int(11) NOT NULL default '0',
  `num_of_q` int(10) unsigned NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`test_random_id`),
  KEY `test_fi` (`test_fi`),
  KEY `questionpool_fi` (`questionpool_fi`)
) TYPE=MyISAM COMMENT='Questionpools taken for a random test';

--
-- Dumping data for table `tst_test_random`
--


--
-- Table structure for table `tst_test_random_question`
--

CREATE TABLE `tst_test_random_question` (
  `test_random_question_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(10) unsigned NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`test_random_question_id`),
  KEY `question_fi` (`question_fi`),
  KEY `active_fi` (`active_fi`)
) TYPE=MyISAM COMMENT='Relation table for random questions in tests';

--
-- Dumping data for table `tst_test_random_question`
--


--
-- Table structure for table `tst_test_result`
--

CREATE TABLE `tst_test_result` (
  `test_result_id` int(10) unsigned NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `points` double NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`test_result_id`),
  UNIQUE KEY `active_fi` (`active_fi`,`question_fi`,`pass`)
) TYPE=MyISAM COMMENT='Test and Assessment user results for test questions';

--
-- Dumping data for table `tst_test_result`
--


--
-- Table structure for table `tst_test_type`
--

CREATE TABLE `tst_test_type` (
  `test_type_id` int(10) unsigned NOT NULL auto_increment,
  `type_tag` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`test_type_id`)
) TYPE=MyISAM COMMENT='ILIAS 3 Assessment Test types';

--
-- Dumping data for table `tst_test_type`
--

INSERT INTO `tst_test_type` VALUES (1,'tt_assessment');
INSERT INTO `tst_test_type` VALUES (2,'tt_self_assessment');
INSERT INTO `tst_test_type` VALUES (4,'tt_online_exam');
INSERT INTO `tst_test_type` VALUES (5,'tt_varying_randomtest');

--
-- Table structure for table `tst_tests`
--

CREATE TABLE `tst_tests` (
  `test_id` int(10) unsigned NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `author` varchar(50) NOT NULL default '',
  `test_type_fi` int(10) unsigned NOT NULL default '0',
  `introduction` text,
  `sequence_settings` tinyint(3) unsigned NOT NULL default '0',
  `score_reporting` tinyint(3) unsigned NOT NULL default '0',
  `instant_verification` enum('0','1') NOT NULL default '0',
  `nr_of_tries` tinyint(3) unsigned NOT NULL default '0',
  `hide_previous_results` enum('0','1') NOT NULL default '0',
  `hide_title_points` enum('0','1') NOT NULL default '0',
  `processing_time` time default NULL,
  `enable_processing_time` enum('0','1') NOT NULL default '0',
  `reporting_date` varchar(14) default NULL,
  `starting_time` varchar(14) default NULL,
  `ending_time` varchar(14) default NULL,
  `shuffle_questions` enum('0','1') NOT NULL default '0',
  `ects_output` enum('0','1') NOT NULL default '0',
  `ects_fx` float default NULL,
  `complete` enum('0','1') NOT NULL default '1',
  `created` varchar(14) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  `ects_a` double NOT NULL default '90',
  `ects_b` double NOT NULL default '65',
  `ects_c` double NOT NULL default '35',
  `ects_d` double NOT NULL default '10',
  `ects_e` double NOT NULL default '0',
  `random_test` enum('0','1') NOT NULL default '0',
  `random_question_count` int(11) default NULL,
  `count_system` enum('0','1') NOT NULL default '0',
  `mc_scoring` enum('0','1') NOT NULL default '0',
  `score_cutting` enum('0','1') NOT NULL default '0',
  `pass_scoring` enum('0','1') NOT NULL default '0',
  `password` varchar(20) default NULL,
  `allowedUsers` int(11) default NULL,
  `allowedUsersTimeGap` int(11) default NULL,
  `show_solution_details` enum('0','1') NOT NULL default '1',
  `show_solution_printview` enum('0','1') NOT NULL default '0',
  `show_summary` enum('0','1') NOT NULL default '0',
  `show_question_titles` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`test_id`),
  KEY `obj_fi` (`obj_fi`),
  KEY `test_type_fi` (`test_type_fi`),
  FULLTEXT KEY `introduction` (`introduction`)
) TYPE=MyISAM COMMENT='Tests in ILIAS Assessment';

--
-- Dumping data for table `tst_tests`
--


--
-- Table structure for table `tst_times`
--

CREATE TABLE `tst_times` (
  `times_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `started` datetime NOT NULL default '0000-00-00 00:00:00',
  `finished` datetime NOT NULL default '0000-00-00 00:00:00',
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`times_id`),
  KEY `active_fi` (`active_fi`)
) TYPE=MyISAM COMMENT='Editing times of an assessment test';

--
-- Dumping data for table `tst_times`
--


--
-- Table structure for table `user_defined_field_definition`
--

CREATE TABLE `user_defined_field_definition` (
  `field_id` int(3) NOT NULL auto_increment,
  `field_name` tinytext NOT NULL,
  `field_type` tinyint(1) NOT NULL default '0',
  `field_values` text NOT NULL,
  `visible` tinyint(1) NOT NULL default '0',
  `changeable` tinyint(1) NOT NULL default '0',
  `required` tinyint(1) NOT NULL default '0',
  `searchable` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`field_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `user_defined_field_definition`
--


--
-- Table structure for table `usr_data`
--

CREATE TABLE `usr_data` (
  `usr_id` int(10) unsigned NOT NULL default '0',
  `login` varchar(80) NOT NULL default '',
  `passwd` varchar(32) NOT NULL default '',
  `firstname` varchar(32) NOT NULL default '',
  `lastname` varchar(32) NOT NULL default '',
  `title` varchar(32) NOT NULL default '',
  `gender` enum('m','f') NOT NULL default 'm',
  `email` varchar(80) NOT NULL default '',
  `institution` varchar(80) default NULL,
  `street` varchar(40) default NULL,
  `city` varchar(40) default NULL,
  `zipcode` varchar(10) default NULL,
  `country` varchar(40) default NULL,
  `phone_office` varchar(40) NOT NULL default '',
  `last_login` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `hobby` text NOT NULL,
  `department` varchar(80) NOT NULL default '',
  `phone_home` varchar(40) NOT NULL default '',
  `phone_mobile` varchar(40) NOT NULL default '',
  `fax` varchar(40) NOT NULL default '',
  `i2passwd` varchar(32) NOT NULL default '',
  `time_limit_owner` int(10) default '0',
  `time_limit_unlimited` int(2) default '0',
  `time_limit_from` int(10) default '0',
  `time_limit_until` int(10) default '0',
  `time_limit_message` int(2) default '0',
  `referral_comment` varchar(250) default '',
  `matriculation` varchar(40) default NULL,
  `active` int(4) unsigned NOT NULL default '0',
  `approve_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `agree_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `ilinc_id` int(10) unsigned default NULL,
  `ilinc_login` varchar(40) default NULL,
  `ilinc_passwd` varchar(40) default NULL,
  `client_ip` varchar(15) default NULL,
  `auth_mode` enum('default','local','ldap','radius','shibboleth','script','cas','soap') NOT NULL default 'default',
  `profile_incomplete` int(2) default '0',
  `ext_account` varchar(50) default NULL,
  PRIMARY KEY  (`usr_id`),
  KEY `login` (`login`,`passwd`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_data`
--

INSERT INTO `usr_data` VALUES (6,'root','dfa8327f5bfa4c672a04f9b38e348a70','root','user','','m','ilias@yourserver.com','','','','','','','2005-07-20 15:11:40','2003-09-30 19:50:01','0000-00-00 00:00:00','','','','','','',7,1,0,0,0,'',NULL,1,'0000-00-00 00:00:00','0000-00-00 00:00:00',NULL,NULL,NULL,NULL,'default',0,NULL);
INSERT INTO `usr_data` VALUES (13,'anonymous','294de3557d9d00b3d2d8a1e6aab028cf','anonymous','anonymous','','m','nomail',NULL,NULL,NULL,NULL,NULL,'','2003-08-15 11:03:36','2003-08-15 10:07:30','2003-08-15 10:07:30','','','','','','',7,1,0,0,0,'',NULL,1,'0000-00-00 00:00:00','0000-00-00 00:00:00',NULL,NULL,NULL,NULL,'local',0,NULL);

--
-- Table structure for table `usr_defined_data`
--

CREATE TABLE `usr_defined_data` (
  `usr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_defined_data`
--

INSERT INTO `usr_defined_data` VALUES (6);
INSERT INTO `usr_defined_data` VALUES (13);

--
-- Table structure for table `usr_new_account_mail`
--

CREATE TABLE `usr_new_account_mail` (
  `lang` varchar(5) NOT NULL default '',
  `subject` varchar(200) default '',
  `body` mediumtext,
  `sal_f` varchar(200) NOT NULL default '',
  `sal_m` varchar(200) NOT NULL default '',
  `sal_g` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`lang`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_new_account_mail`
--


--
-- Table structure for table `usr_pref`
--

CREATE TABLE `usr_pref` (
  `usr_id` int(10) unsigned NOT NULL default '0',
  `keyword` char(40) NOT NULL default '',
  `value` char(40) default NULL,
  PRIMARY KEY  (`usr_id`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_pref`
--

INSERT INTO `usr_pref` VALUES (6,'style','delos');
INSERT INTO `usr_pref` VALUES (6,'skin','default');
INSERT INTO `usr_pref` VALUES (6,'public_zip','n');
INSERT INTO `usr_pref` VALUES (6,'public_upload','n');
INSERT INTO `usr_pref` VALUES (6,'public_street','n');
INSERT INTO `usr_pref` VALUES (6,'public_profile','n');
INSERT INTO `usr_pref` VALUES (6,'public_phone','n');
INSERT INTO `usr_pref` VALUES (6,'public_institution','n');
INSERT INTO `usr_pref` VALUES (6,'public_hobby','n');
INSERT INTO `usr_pref` VALUES (6,'public_email','n');
INSERT INTO `usr_pref` VALUES (6,'public_country','n');
INSERT INTO `usr_pref` VALUES (6,'public_city','n');
INSERT INTO `usr_pref` VALUES (6,'language','en');
INSERT INTO `usr_pref` VALUES (6,'show_users_online','y');
INSERT INTO `usr_pref` VALUES (13,'show_users_online','y');

--
-- Table structure for table `usr_pwassist`
--

CREATE TABLE `usr_pwassist` (
  `pwassist_id` varchar(32) NOT NULL default '',
  `expires` int(11) NOT NULL default '0',
  `ctime` int(11) NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pwassist_id`),
  UNIQUE KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_pwassist`
--


--
-- Table structure for table `usr_search`
--

CREATE TABLE `usr_search` (
  `usr_id` int(11) NOT NULL default '0',
  `search_result` text,
  `search_type` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`search_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_search`
--


--
-- Table structure for table `usr_session`
--

CREATE TABLE `usr_session` (
  `session_id` varchar(32) NOT NULL default '',
  `expires` int(11) NOT NULL default '0',
  `data` text NOT NULL,
  `ctime` int(11) NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`session_id`),
  KEY `expires` (`expires`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_session`
--


--
-- Table structure for table `ut_access`
--

CREATE TABLE `ut_access` (
  `id` int(10) NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `action_type` char(10) default NULL,
  `php_script` char(100) NOT NULL default '',
  `client_ip` char(15) default NULL,
  `acc_obj_type` char(10) NOT NULL default '',
  `acc_obj_id` int(10) NOT NULL default '0',
  `acc_sub_type` char(10) NOT NULL default '',
  `acc_sub_id` int(10) NOT NULL default '0',
  `language` char(15) default NULL,
  `browser` char(60) NOT NULL default '',
  `session_id` char(40) default NULL,
  `acc_time` datetime default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_access`
--


--
-- Table structure for table `ut_learning_progress`
--

CREATE TABLE `ut_learning_progress` (
  `lp_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `obj_type` char(4) NOT NULL default '',
  `obj_id` int(11) NOT NULL default '0',
  `spent_time` int(10) NOT NULL default '0',
  `access_time` int(10) NOT NULL default '0',
  `visits` int(4) NOT NULL default '0',
  PRIMARY KEY  (`lp_id`),
  KEY `user_obj` (`user_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_learning_progress`
--


--
-- Table structure for table `ut_lp_collections`
--

CREATE TABLE `ut_lp_collections` (
  `obj_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  KEY `obj_id` (`obj_id`,`item_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_collections`
--


--
-- Table structure for table `ut_lp_event_collections`
--

CREATE TABLE `ut_lp_event_collections` (
  `obj_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  KEY `obj_id` (`obj_id`,`item_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_event_collections`
--


--
-- Table structure for table `ut_lp_filter`
--

CREATE TABLE `ut_lp_filter` (
  `usr_id` int(11) NOT NULL default '0',
  `filter_type` varchar(4) NOT NULL default '',
  `root_node` int(11) NOT NULL default '0',
  `hidden` text NOT NULL,
  `query_string` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_filter`
--


--
-- Table structure for table `ut_lp_marks`
--

CREATE TABLE `ut_lp_marks` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `completed` int(1) NOT NULL default '0',
  `mark` varchar(32) NOT NULL default '',
  `comment` text NOT NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`),
  KEY `obj_usr` (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_marks`
--


--
-- Table structure for table `ut_lp_settings`
--

CREATE TABLE `ut_lp_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(4) NOT NULL default '',
  `mode` tinyint(1) NOT NULL default '0',
  `visits` int(4) default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_settings`
--


--
-- Table structure for table `ut_online`
--

CREATE TABLE `ut_online` (
  `usr_id` int(11) NOT NULL default '0',
  `online_time` int(11) NOT NULL default '0',
  `access_time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_online`
--


--
-- Table structure for table `webr_items`
--

CREATE TABLE `webr_items` (
  `link_id` int(11) NOT NULL auto_increment,
  `webr_id` int(11) NOT NULL default '0',
  `title` varchar(127) default NULL,
  `description` text NOT NULL,
  `target` text,
  `active` tinyint(1) default NULL,
  `disable_check` tinyint(1) default NULL,
  `create_date` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `last_check` int(11) default NULL,
  `valid` tinyint(1) NOT NULL default '0',
  KEY `link_id` (`link_id`,`webr_id`),
  FULLTEXT KEY `title` (`title`)
) TYPE=MyISAM;

--
-- Dumping data for table `webr_items`
--


--
-- Table structure for table `webr_params`
--

CREATE TABLE `webr_params` (
  `param_id` int(11) NOT NULL auto_increment,
  `webr_id` int(11) NOT NULL default '0',
  `link_id` int(11) NOT NULL default '0',
  `name` char(128) NOT NULL default '',
  `value` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`param_id`),
  KEY `link_id` (`link_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `webr_params`
--


--
-- Table structure for table `xhtml_page`
--

CREATE TABLE `xhtml_page` (
  `id` int(11) NOT NULL auto_increment,
  `content` mediumtext,
  `save_content` mediumtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xhtml_page`
--


--
-- Table structure for table `xml_attribute_idx`
--

CREATE TABLE `xml_attribute_idx` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `attribute_id` smallint(5) unsigned NOT NULL default '0',
  `value_id` smallint(5) unsigned NOT NULL default '0',
  KEY `node_id` (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_idx`
--


--
-- Table structure for table `xml_attribute_name`
--

CREATE TABLE `xml_attribute_name` (
  `attribute_id` smallint(5) unsigned NOT NULL auto_increment,
  `attribute` char(32) NOT NULL default '',
  PRIMARY KEY  (`attribute_id`),
  UNIQUE KEY `attribute` (`attribute`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_name`
--


--
-- Table structure for table `xml_attribute_namespace`
--

CREATE TABLE `xml_attribute_namespace` (
  `attribute_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `namespace` char(64) NOT NULL default '',
  PRIMARY KEY  (`attribute_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_namespace`
--


--
-- Table structure for table `xml_attribute_value`
--

CREATE TABLE `xml_attribute_value` (
  `value_id` smallint(5) unsigned NOT NULL auto_increment,
  `value` char(32) NOT NULL default '0',
  PRIMARY KEY  (`value_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_value`
--


--
-- Table structure for table `xml_cdata`
--

CREATE TABLE `xml_cdata` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `cdata` text NOT NULL,
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_cdata`
--


--
-- Table structure for table `xml_comment`
--

CREATE TABLE `xml_comment` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `comment` text NOT NULL,
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_comment`
--


--
-- Table structure for table `xml_element_idx`
--

CREATE TABLE `xml_element_idx` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `element_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_idx`
--


--
-- Table structure for table `xml_element_name`
--

CREATE TABLE `xml_element_name` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `element` char(32) NOT NULL default '',
  PRIMARY KEY  (`element_id`),
  UNIQUE KEY `element` (`element`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_name`
--


--
-- Table structure for table `xml_element_namespace`
--

CREATE TABLE `xml_element_namespace` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `namespace` char(64) NOT NULL default '',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_namespace`
--


--
-- Table structure for table `xml_entity_reference`
--

CREATE TABLE `xml_entity_reference` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `entity_reference` char(128) NOT NULL default '',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_entity_reference`
--


--
-- Table structure for table `xml_node_type`
--

CREATE TABLE `xml_node_type` (
  `node_type_id` int(11) NOT NULL auto_increment,
  `description` varchar(50) default NULL,
  `lft_delimiter` varchar(10) default NULL,
  `rgt_delimiter` varchar(10) default NULL,
  PRIMARY KEY  (`node_type_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_node_type`
--

INSERT INTO `xml_node_type` VALUES (1,'ELEMENT_NODE','<','>');
INSERT INTO `xml_node_type` VALUES (2,'ATTRIBUTE_NODE(not used)','\"','\"');
INSERT INTO `xml_node_type` VALUES (3,'TEXT_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (5,'ENTITY_REF_NODE','&',';');
INSERT INTO `xml_node_type` VALUES (4,'CDATA_SECTION_NODE','<![CDATA[',']]>');
INSERT INTO `xml_node_type` VALUES (8,'COMMENT_NODE','<!--','-->');
INSERT INTO `xml_node_type` VALUES (9,'DOCUMENT_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (10,'DOCUMENT_TYPE_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (6,'ENTITY_NODE','&',';');

--
-- Table structure for table `xml_object`
--

CREATE TABLE `xml_object` (
  `ID` int(11) NOT NULL auto_increment,
  `version` varchar(5) NOT NULL default '',
  `encoding` varchar(40) default NULL,
  `charset` varchar(40) default NULL,
  `TIMESTAMP` timestamp(14) NOT NULL,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Master Table for XML objects';

--
-- Dumping data for table `xml_object`
--


--
-- Table structure for table `xml_pi_data`
--

CREATE TABLE `xml_pi_data` (
  `leaf_id` int(10) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `leaf_text` text NOT NULL,
  PRIMARY KEY  (`leaf_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_pi_data`
--


--
-- Table structure for table `xml_pi_target`
--

CREATE TABLE `xml_pi_target` (
  `leaf_id` int(10) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `leaf_text` text NOT NULL,
  PRIMARY KEY  (`leaf_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_pi_target`
--


--
-- Table structure for table `xml_text`
--

CREATE TABLE `xml_text` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `textnode` text NOT NULL,
  PRIMARY KEY  (`node_id`),
  FULLTEXT KEY `textnode` (`textnode`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_text`
--


--
-- Table structure for table `xml_tree`
--

CREATE TABLE `xml_tree` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `xml_id` mediumint(8) unsigned NOT NULL default '0',
  `parent_node_id` int(10) unsigned NOT NULL default '0',
  `lft` smallint(5) unsigned NOT NULL default '0',
  `rgt` smallint(5) unsigned NOT NULL default '0',
  `node_type_id` tinyint(3) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  `prev_sibling_node_id` int(10) unsigned NOT NULL default '0',
  `next_sibling_node_id` int(10) unsigned NOT NULL default '0',
  `first_child_node_id` int(10) unsigned NOT NULL default '0',
  `struct` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`node_id`),
  KEY `xml_id` (`xml_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_tree`
--


--
-- Table structure for table `xmlnestedset`
--

CREATE TABLE `xmlnestedset` (
  `ns_book_fk` int(11) NOT NULL default '0',
  `ns_type` char(50) NOT NULL default '',
  `ns_tag_fk` int(11) default NULL,
  `ns_l` int(11) default NULL,
  `ns_r` int(11) default NULL,
  KEY `ns_tag_fk` (`ns_tag_fk`),
  KEY `ns_book_fk` (`ns_book_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlnestedset`
--


--
-- Table structure for table `xmlparam`
--

CREATE TABLE `xmlparam` (
  `tag_fk` int(11) NOT NULL default '0',
  `param_name` char(50) NOT NULL default '',
  `param_value` char(255) NOT NULL default '',
  KEY `tag_fk` (`tag_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlparam`
--


--
-- Table structure for table `xmltags`
--

CREATE TABLE `xmltags` (
  `tag_pk` int(11) NOT NULL auto_increment,
  `tag_depth` int(11) NOT NULL default '0',
  `tag_name` char(50) NOT NULL default '',
  PRIMARY KEY  (`tag_pk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmltags`
--


--
-- Table structure for table `xmlvalue`
--

CREATE TABLE `xmlvalue` (
  `tag_value_pk` int(11) NOT NULL auto_increment,
  `tag_fk` int(11) NOT NULL default '0',
  `tag_value` text NOT NULL,
  PRIMARY KEY  (`tag_value_pk`),
  KEY `tag_fk` (`tag_fk`),
  FULLTEXT KEY `tag_value` (`tag_value`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlvalue`
--


